<%@ Control Language="vb" AutoEventWireup="false" Codebehind="emoluments.ascx.vb" Inherits="CRAVBackOffice.emoluments" TargetSchema="http://schemas.microsoft.com/intellisense/ie5" %>
<table id="tblMain" cellSpacing="0" cellPadding="0" width="700" align="center" border="0">
	<tr>
		<td class="vertical_spacer4" colSpan="3"></td>
	</tr>
	<TR>
		<td class="txtRF"></td>
		<TD width="100" class="txt"><%=GetLabel("Emolument.EmolumentDate")%></TD>
		<TD width="580">
			<table cellSpacing="0" cellPadding="0" border="0">
				<tr>
					<td><asp:textbox id="txtYearEmolument" MaxLength="4" runat="server" CssClass="txbYear"></asp:textbox>&nbsp;/&nbsp;</td>
					<td><asp:textbox id="txtMonthEmolument" MaxLength="2" runat="server" CssClass="txbMonth"></asp:textbox>&nbsp;/&nbsp;</td>
					<td><asp:textbox id="txtDayEmolument" MaxLength="2" runat="server" CssClass="txbDay"></asp:textbox></td>
					<td class="text04"><code class="txt">&nbsp;(aaaa/mm/dd)</code></td>
				</tr>
			</table>
		</TD>
	</TR>
	<TR>
		<TD class="vertical_spacer1" colSpan="3"></TD>
	</TR>
	<TR>
		<TD class="txtRF">*</TD>
		<TD class="txt"><%=GetLabel("Emolument.ReceiptNumber")%></TD>
		<TD><asp:textbox id="txbReceiptNumber" runat="server" CssClass="txbMSmall"></asp:textbox><asp:regularexpressionvalidator id="reReceiptNumber" ValidationExpression="\d+" ControlToValidate="txbReceiptNumber"
				Runat="server"> !</asp:regularexpressionvalidator></TD>
	</TR>
	<tr>
		<td class="vertical_spacer3" colSpan="3"></td>
	</tr>
	<tr>
		<td colSpan="3">
			<table cellSpacing="0" cellPadding="4" width="100%" border="0">
				<tr>
					<td class="txtCenter" width="150"><%=getlabel("Emolument.Category")%></td>
					<td class="txtCenter" width="50"><%=getlabel("Emolument.IVA")%></td>
					<td class="txtCenter" width="75"><%=getlabel("Emolument.Cost") + " (&euro;)"%></td>
					<td class="txtCenter" width="150"><%=getlabel("Emolument.Exemption")%></td>
					<td class="txtCenter" width="150"><%=getlabel("Emolument.Note")%></td>
					<td></td>
				</tr>
				<tr vAlign="baseline">
					<td><asp:dropdownlist id="ddlCategories" CssClass="ddl100" Runat="server"></asp:dropdownlist></td>
					<td><asp:dropdownlist id="ddlIVA" CssClass="ddl100" Runat="server"></asp:dropdownlist></td>
					<td><asp:textbox id="txbCost" CssClass="txb100" Runat="server"></asp:textbox></td>
					<td><asp:textbox id="txbExemption" CssClass="txb100" Runat="server"></asp:textbox></td>
					<td><asp:textbox id="txbNote" CssClass="txb100" Runat="server"></asp:textbox></td>
					<td align="right"><asp:linkbutton id="lnkbInsert" CssClass="Button_1" Runat="server" CausesValidation="true" Height="20px"></asp:linkbutton></td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="line" colSpan="3"></td>
	</tr>
	<tr>
		<td class="vertical_spacer2" colSpan="3"></td>
	</tr>
	<tr>
		<td colSpan="3"><asp:datagrid id="dgEmoluments" Runat="server" Width="100%" BorderWidth="0" DataKeyField="EmolumentID"
				AutoGenerateColumns="False" GridLines="None" PageSize="10" AllowPaging="True" CellSpacing="1" cellpadding="4">
				<Columns>
					<asp:buttoncolumn buttontype="LinkButton" commandname="Delete" HeaderStyle-Width="20">
						<HeaderStyle CssClass="bgDgHeader"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
					</asp:buttoncolumn>
					<asp:BoundColumn DataField="EmolumentDate" ReadOnly="True">
						<HeaderStyle CssClass="bgDgHeader"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textLeft"></ItemStyle>
					</asp:BoundColumn>
					<asp:BoundColumn DataField="ReceiptNumber" ReadOnly="True">
						<HeaderStyle CssClass="bgDgHeader"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textLeft"></ItemStyle>
					</asp:BoundColumn>
					<asp:BoundColumn DataField="Category" ReadOnly="True">
						<HeaderStyle CssClass="bgDgHeader"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textLeft"></ItemStyle>
					</asp:BoundColumn>
					<asp:BoundColumn DataField="CertificateNumber" ReadOnly="True">
						<HeaderStyle CssClass="bgDgHeader"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textLeft"></ItemStyle>
					</asp:BoundColumn>
					<asp:BoundColumn DataField="Exemption" ReadOnly="True">
						<HeaderStyle CssClass="bgDgHeader"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textLeft"></ItemStyle>
					</asp:BoundColumn>
					<asp:TemplateColumn>
						<HeaderStyle CssClass="bgDgHeader"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textLeft"></ItemStyle>
						<ItemTemplate>
							<%# string.format("{0:0.00}", DataBinder.Eval(Container,"DataItem.Cost")) %>
						</ItemTemplate>
					</asp:TemplateColumn>
					<asp:TemplateColumn>
						<HeaderStyle CssClass="bgDgHeader"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textLeft"></ItemStyle>
						<ItemTemplate>
							<%# DataBinder.Eval(Container,"DataItem.IVA").ToString + "%" %>
						</ItemTemplate>
					</asp:TemplateColumn>
					<asp:BoundColumn DataField="Note" ReadOnly="True">
						<HeaderStyle CssClass="bgDgHeader"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textLeft"></ItemStyle>
					</asp:BoundColumn>
				</Columns>
				<PagerStyle Mode="NumericPages" NextPageText="Prxima >> " PrevPageText=" << Anterior" HorizontalAlign="Center"
					PageButtonCount="10" Font-Bold="True" CssClass="bgDgFooter"></PagerStyle>
			</asp:datagrid></td>
	</tr>
	<tr>
		<td colSpan="3"><asp:panel id="pnlTotal" Runat="server" Visible="False">
      <TABLE cellSpacing=0 cellPadding=0 width="100%" border=0>
        <TR>
          <TD class=line colSpan=2></TD></TR>
        <TR height=20>
          <TD class=txtRight width=600><%=getlabel("BO.emoluments.lblTotal") + " (&euro;):"%></TD>
          <TD align=center width=100>
<asp:Label id=lblTotalValue CssClass="lbl05_Center" Runat="server" Font-Bold="True"></asp:Label></TD></TR>
        <TR>
          <TD class=line colSpan=2></TD></TR></TABLE>
			</asp:panel></td>
	</tr>
	<tr>
		<td class="vertical_spacer1" colSpan="3"></td>
	</tr>
	<tr>
		<td colSpan="3">
			<table cellSpacing="1" cellPadding="4" width="100%" border="0">
				<tr>
					<td class="txtCenter" width="120"><%=getlabel("Emolument.Category")%></td>
					<td class="txtCenter" width="80"><%=getlabel("BO.emoluments.lblYear")%></td>
					<td class="txtCenter" width="120"><%=getlabel("BO.emoluments.lblMonth")%></td>
					<td class="txtCenter"></td>
				</tr>
				<tr vAlign="baseline">
					<td><asp:dropdownlist id="ddlSearchByCategory" CssClass="ddl100" Runat="server" AutoPostBack="True"></asp:dropdownlist></td>
					<td><asp:dropdownlist id="ddlSearchByYear" CssClass="ddl100" Runat="server" AutoPostBack="True"></asp:dropdownlist></td>
					<td><asp:dropdownlist id="ddlSearchByMonth" CssClass="ddl100" Runat="server" AutoPostBack="True"></asp:dropdownlist></td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="vertical_spacer1" colSpan="3"></td>
	</tr>
	<tr>
		<td class="line" colSpan="3"></td>
	</tr>
	<tr>
		<td class="vertical_spacer2" colSpan="3"></td>
	</tr>
	<tr>
		<td align="right" colspan="3">
			<asp:linkbutton id="lnkbExportExcel" CssClass="Button_1" Runat="server" CausesValidation="False"
				Height="20px"></asp:linkbutton><asp:linkbutton id="lnkbReport" CssClass="Button_1" Runat="server" CausesValidation="False" Height="20px"></asp:linkbutton></td>
	</tr>
	<tr>
		<td class="vertical_spacer2" colSpan="3"></td>
	</tr>
</table>
