Imports CRAVDataBaseAccess
Imports CRAVDataBaseAccess.utils
'Imports CRAVDataBaseAccess.General
Imports DigitArq.Data.Entities.MGUP
Imports DigitArq.Utility


Public Class insertProcess
    Inherits CRAVDataBaseAccess.BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents resumo As System.Web.UI.WebControls.ValidationSummary
    Protected WithEvents txtDocumentDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents lnkbSubmit As System.Web.UI.WebControls.LinkButton
    Protected WithEvents txbClassification As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbSubject As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbFolderID As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtYearInitialDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtMonthInitialDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtDayInitialDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtYearFinalDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtMonthFinalDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtDayFinalDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblProcessID As System.Web.UI.WebControls.Label
    Protected WithEvents hlnkNew As System.Web.UI.WebControls.HyperLink
    Protected WithEvents rfvClassification As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents rfvSubject As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents rfvFolderID As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents ddlEmployee As System.Web.UI.WebControls.DropDownList
    Protected WithEvents rblCert As System.Web.UI.WebControls.RadioButtonList
    Protected WithEvents rblProcessType As System.Web.UI.WebControls.RadioButtonList
    Protected WithEvents txbUserID As System.Web.UI.WebControls.TextBox
    Protected WithEvents hlnkSearchUsers As System.Web.UI.WebControls.HyperLink

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private objICRAV As New CRAVDataBaseAccess.SQLDataBase
    Private objIGPU As New DigitArq.Data.Entities.MGUP.SQLDataBase

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here

        If Not Me.Page.IsPostBack Then
            Dim FunctionCode As String = Request.QueryString("page")
            Dim pid As String = Me.Request.QueryString("pid")

            If objIGPU.accessFunction(HttpContext.Current.User.Identity.Name, FunctionCode) Then
                Me.hlnkSearchUsers.Text = GetLabel("lnkbDots")
                Me.hlnkNew.Text = GetLabel("lnkbNew")
                Me.lnkbSubmit.Text = GetLabel("lnkbSubmit")
                Me.hlnkNew.NavigateUrl = "../defaultIn.aspx?page=insertProcess"
                Me.hlnkSearchUsers.NavigateUrl = "javascript:NewWindow('/CRAVbackOffice/NewWindow.aspx?page=selectUser&control=" & Me.txbUserID.ClientID & "','mywin','700','700','yes','center');"

                Me.rblProcessType.Items(0).Text = GetLabel("Process.ProcessType.0")
                Me.rblProcessType.Items(1).Text = GetLabel("Process.ProcessType.1")

                Dim ds As DataSet = objIGPU.loadFullEmployees()
                Me.ddlEmployee.DataSource = ds
                Me.ddlEmployee.DataValueField = "UserName"
                Me.ddlEmployee.DataTextField = "FullName"
                Me.ddlEmployee.DataBind()

                Dim li As New ListItem(GetLabel("BO.itemSelect"), "")
                Me.ddlEmployee.Items.Insert(0, li)

                Me.txtYearInitialDate.Text = Now.Year.ToString
                Me.txtMonthInitialDate.Text = Now.Month.ToString.PadLeft(2, "0")
                Me.txtDayInitialDate.Text = Now.Day.ToString.PadLeft(2, "0")
                Me.txbClassification.Text = GetConfig("ReproductionRequest.Classification")
                Me.txbSubject.Text = GetConfig("ReproductionRequest.Subject")

                If Not pid Is Nothing Then
                    loadProcessToForm(CInt(pid))
                    Me.hlnkNew.Visible = False
                    Me.lnkbSubmit.Text = GetLabel("lnkbChange")
                End If
            Else
                Response.Redirect("defaultIn.aspx?page=crav-0&lbl=accessDenied")
            End If
        End If
    End Sub

    Private Sub loadProcessToForm(ByVal intProcessID As Integer)
        Dim objProcess As Process = objICRAV.loadProcess(intProcessID)

        Me.lblProcessID.Text = objProcess.OtherProcessID
        Me.txbClassification.Text = objProcess.Classification
        Me.txbSubject.Text = objProcess.Subject
        Me.txbFolderID.Text = objProcess.FolderID
        Me.ddlEmployee.SelectedValue = objProcess.Employee.UserName
        Me.txtYearInitialDate.Text = DBToDate_YYYY(objProcess.InitialDate)
        Me.txtMonthInitialDate.Text = DBToDate_MM(objProcess.InitialDate)
        Me.txtDayInitialDate.Text = DBToDate_DD(objProcess.InitialDate)
        Me.txtYearFinalDate.Text = DBToDate_YYYY(objProcess.FinalDate)
        Me.txtMonthFinalDate.Text = DBToDate_MM(objProcess.FinalDate)
        Me.txtDayFinalDate.Text = DBToDate_DD(objProcess.FinalDate)
        Me.txbUserID.Text = IntToStr(objProcess.UserInfo.UserID)
        Me.rblProcessType.SelectedValue = objProcess.ProcessType
    End Sub

    Private Sub lnkbSubmit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbSubmit.Click

        If Me.Page.IsValid Then
            Dim objProcess As New CRAVDataBaseAccess.Process

            objProcess.ProcessType = Me.rblProcessType.SelectedValue
            objProcess.Classification = Me.txbClassification.Text
            objProcess.Subject = Me.txbSubject.Text
            objProcess.FolderID = Me.txbFolderID.Text
            objProcess.Employee.UserName = Me.ddlEmployee.SelectedValue
            objProcess.UserInfo.UserID = StrToInt(Me.txbUserID.Text)

            objProcess.InitialDate = strConvDate(Me.txtYearInitialDate.Text, Me.txtMonthInitialDate.Text, Me.txtDayInitialDate.Text)
            objProcess.FinalDate = strConvDate(Me.txtYearFinalDate.Text, Me.txtMonthFinalDate.Text, Me.txtDayFinalDate.Text)

            If Me.Request.QueryString("pid") Is Nothing Then
                Dim PRet(2) As Integer
                PRet = objICRAV.storeProcess(objProcess)
                objProcess.ProcessID = PRet(0)
                objProcess.OtherProcessID = PRet(1)
                Me.lblProcessID.Text = objProcess.OtherProcessID
                If Not PRet Is Nothing Then
                    Me.Page.RegisterStartupScript("popup1", "<script language=javascript>window.alert('" & GetLabel("popup.insertProcess.success") & "');</script>")
                Else
                    Me.Page.RegisterStartupScript("popup2", "<script language=javascript>window.alert('" & GetLabel("eReturn.ErrorDB") & "');</script>")
                End If
            Else
                objProcess.ProcessID = CInt(Me.Request.QueryString("pid"))
                Dim ret As Boolean = objICRAV.updateProcess(objProcess)
                If ret Then
                    Me.Page.RegisterStartupScript("popup3", "<script language=javascript>window.alert('" & GetLabel("popup.updateProcess.success") & "');</script>")
                Else
                    Me.Page.RegisterStartupScript("popup4", "<script language=javascript>window.alert('" & GetLabel("eReturn.ErrorDB") & "');</script>")
                End If
            End If
        End If
    End Sub

    Private Sub rblProcessType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rblProcessType.SelectedIndexChanged
        Dim ProcessType As Process.eProcessType = Me.rblProcessType.SelectedValue
        Select Case ProcessType
            Case Process.eProcessType.CRAV
                Me.txbClassification.Text = GetConfig("ReproductionRequest.Classification")
                Me.txbSubject.Text = GetConfig("ReproductionRequest.Subject")
            Case Process.eProcessType.Other
                Me.txbClassification.Text = ""
                Me.txbSubject.Text = ""
        End Select
    End Sub

End Class
