Imports CRAVDataBaseAccess

Public Class uc_reproductionStep1
    Inherits BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents txtRef As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtTitleF As System.Web.UI.WebControls.TextBox
    Protected WithEvents pnlReg As System.Web.UI.WebControls.Panel
    Protected WithEvents repTitles As System.Web.UI.WebControls.Repeater
    Protected WithEvents pnlTitles As System.Web.UI.WebControls.Panel
    Protected WithEvents rdblType As System.Web.UI.WebControls.RadioButtonList
    Protected WithEvents imgBttnGo As System.Web.UI.WebControls.ImageButton
    Protected WithEvents summary As System.Web.UI.WebControls.ValidationSummary
    Protected WithEvents reRef As System.Web.UI.WebControls.RegularExpressionValidator
    Protected WithEvents hlnkCancel As System.Web.UI.WebControls.HyperLink
    Protected WithEvents bttnNext As System.Web.UI.WebControls.ImageButton
    Protected WithEvents rdblOptions As System.Web.UI.WebControls.RadioButtonList
    Protected WithEvents pnlOptions As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlReference As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlRequest As System.Web.UI.WebControls.Panel
    Protected WithEvents hlnkBack As System.Web.UI.WebControls.HyperLink
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblOptions As System.Web.UI.WebControls.Label
    Protected WithEvents lblReference As System.Web.UI.WebControls.Label
    Protected WithEvents lblReqType As System.Web.UI.WebControls.Label
    Protected WithEvents lnkbNext As System.Web.UI.WebControls.LinkButton
    Protected WithEvents txbUserID As System.Web.UI.WebControls.TextBox
    Protected WithEvents hlnkSearchUsers As System.Web.UI.WebControls.HyperLink
    Protected WithEvents txbProcess As System.Web.UI.WebControls.TextBox
    Protected WithEvents hlnkSearchProcesses As System.Web.UI.WebControls.HyperLink
    Protected WithEvents hlnkWebSearch As System.Web.UI.WebControls.HyperLink
    Protected WithEvents rfvUserID As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents txbProcessID As System.Web.UI.WebControls.TextBox
    Protected WithEvents rfvProcessID As System.Web.UI.WebControls.RequiredFieldValidator

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private objI As New SQLDataBase
    Private objPath As New Path

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        If Not Me.Page.IsPostBack Then
            Me.hlnkBack.Text = GetLabel("lnkbBack")
            Me.hlnkCancel.Text = GetLabel("lnkbCancel")
            Me.lnkbNext.Text = GetLabel("lnkbNext")
            Me.hlnkSearchUsers.Text = GetLabel("hlnkSearchUsers")
            Me.hlnkSearchProcesses.Text = GetLabel("hlnkSearchProcesses")
            Me.hlnkWebSearch.Text = GetLabel("hlnkWebSearch")

            Me.hlnkBack.NavigateUrl = "javascript:history.back();"
            Me.hlnkCancel.NavigateUrl = GetConfig("InitialPageUrl")
            Me.hlnkSearchUsers.NavigateUrl = "javascript:NewWindow('/CRAVbackOffice/NewWindow.aspx?page=selectUser&control=" & Me.txbUserID.ClientID & "','mywin','700','700','yes','center');"
            Me.hlnkSearchProcesses.NavigateUrl = "javascript:NewWindow('/CRAVbackOffice/NewWindow.aspx?page=selectProcess&control=" & Me.txbProcessID.ClientID & "','mywin','700','700','yes','center');"
            Me.hlnkWebSearch.NavigateUrl = "http://" & Me.Context.Request.ServerVariables("HTTP_HOST") & "/" & ConfigurationSettings.AppSettings("WebSearchAddress")


            Me.txtRef.Text = GetConfig("CountryCode") + "/" + GetConfig("RepositoryCode") + "/"
            Me.lblError.Visible = True
            Me.Session.Remove("requestType")

            Me.rdblOptions.Items(0).Text = GetLabel("FO.repReq1.rdblOptions0")
            Me.rdblOptions.Items(1).Text = GetLabel("FO.repReq1.rdblOptions1")

            Me.rdblType.Items(0).Text = GetLabel("FO.repReq1.rdblType0")
            Me.rdblType.Items(1).Text = GetLabel("FO.repReq1.rdblType1")
            Me.rdblType.Items(2).Text = GetLabel("FO.repReq1.rdblType2")
        End If

    End Sub


    Private Sub lnkbNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbNext.Click
        If Me.Page.IsValid Then
            Dim objUser As New User
            ReproductionRequest = New ReproductionRequest
            ReproductionRequest.UserInfo.UserID = Me.txbUserID.Text
            ReproductionRequest.UserInfo.FullName = objI.getFullNameUser(Me.txbUserID.Text)
            ReproductionRequest.Process.ProcessID = objI.getProcessID(Me.txbProcessID.Text)
            ReproductionRequest.Process.UserInfo.UserID = Me.txbUserID.Text
            ReproductionRequest.EmployeeInfo.UserName = HttpContext.Current.User.Identity.Name
            Select Case Me.rdblOptions.SelectedValue
                Case "reference"
                    Dim strReference As String = Me.txtRef.Text.Trim
                    Dim strOtherLevel As String = objI.getOtherLevel(strReference)

                    Select Case strOtherLevel
                        Case "UI"
                            ReproductionRequest.DigitarqInfo = objI.loadDigitarqInfo(strReference)

                            objPath.From = Path.eFrom.Reference
                            objPath.OtherLevel = Path.eOtherLevel.UI
                            objPath.RequestType = objPath.getRequestType(strReference)
                            Path = objPath

                            Me.Response.Redirect("defaultIn.aspx?page=repReq2")
                        Case "DC", "D"
                            ReproductionRequest.DigitarqInfo = objI.loadDigitarqInfo(strReference)

                            objPath.From = Path.eFrom.Reference
                            objPath.OtherLevel = Path.eOtherLevel.DorDC
                            objPath.RequestType = objPath.getRequestType(strReference)
                            Path = objPath

                            Me.Response.Redirect("defaultIn.aspx?page=repReq3")
                        Case Else
                            Me.lblError.Visible = True
                            Me.lblError.Text = String.Format(GetLabel("BO.repReq1.lblAlert1"), "<br>")
                    End Select

                Case "form"
                    Dim strType As String = Me.rdblType.SelectedValue
                    objPath.From = Path.eFrom.Form
                    objPath.RequestType = Me.rdblType.SelectedValue
                    Path = objPath
                    Me.Response.Redirect("defaultIn.aspx?page=repReq2")
            End Select
        End If
    End Sub


    Private Sub rdblOptions_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdblOptions.SelectedIndexChanged
        Select Case Me.rdblOptions.SelectedValue
            Case "reference"
                Me.pnlOptions.Visible = True
                Me.pnlReference.Visible = True
                Me.pnlRequest.Visible = False
                Me.hlnkBack.Visible = True
            Case "form"
                Me.pnlOptions.Visible = True
                Me.pnlRequest.Visible = True
                Me.pnlReference.Visible = False
                Me.hlnkBack.Visible = True
        End Select
    End Sub

End Class
