Imports CRAVDataBaseAccess
Imports DigitArq.Data.Entities.MGUP

Public Class requests
    Inherits CRAVDataBaseAccess.BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents ddlListReqType As System.Web.UI.WebControls.DropDownList
    Protected WithEvents dgRequests As System.Web.UI.WebControls.DataGrid
    Protected WithEvents idr As System.Web.UI.WebControls.Label
    Protected WithEvents dlRequests As System.Web.UI.WebControls.DataList
    Protected WithEvents dlEmployees As System.Web.UI.WebControls.DataList
    Protected WithEvents lnkbExpand As System.Web.UI.WebControls.LinkButton
    Protected WithEvents rblNextEvents As System.Web.UI.WebControls.RadioButtonList
    Protected WithEvents cblNextEvents As System.Web.UI.WebControls.CheckBoxList
    Protected WithEvents lnkbSubmitOr As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkbSubmitAnd As System.Web.UI.WebControls.LinkButton
    Protected WithEvents cblUserGroups As System.Web.UI.WebControls.CheckBoxList
    Protected WithEvents lnkbSubmit As System.Web.UI.WebControls.LinkButton

    Protected WithEvents pnlEvents As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlDetails As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlEventDetails As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlAnd As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlOr As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlXor As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlUserGroups As System.Web.UI.WebControls.Panel
    Protected WithEvents lblMessage As System.Web.UI.WebControls.Label
    Protected WithEvents pnlMessage As System.Web.UI.WebControls.Panel
    Protected WithEvents rblUsers As System.Web.UI.WebControls.RadioButtonList
    Protected WithEvents lnkbRefresh As System.Web.UI.WebControls.LinkButton

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        'Call Me.AssignEvents()
        InitializeComponent()
    End Sub

#End Region

    Private objIGPU As New DigitArq.Data.Entities.MGUP.SQLDataBase
    Private objICRAV As New CRAVDataBaseAccess.SQLDataBase

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        Dim eventName As String = Me.Request.QueryString("event")
        Dim operation As String = Me.Request.QueryString("op")

        If Not Me.Page.IsPostBack Then
            Me.lnkbExpand.Text = "<img src=""Images/BArrowASC.gif"" border=""0"">"
            Me.lnkbRefresh.ToolTip = GetLabel("lnkbCollapse")
            Me.lnkbRefresh.Text = "<img src=""Images/refresh.png"" border=""0"">"
            Me.lnkbRefresh.ToolTip = GetLabel("lnkbRefresh")
            Me.lnkbSubmit.Text = GetLabel("lnkbSubmit")
            Me.lnkbSubmitOr.Text = GetLabel("lnkbSubmit")
            Me.lnkbSubmitAnd.Text = GetLabel("lnkbSubmit")
            If Not Me.Request.QueryString("reqtype") Is Nothing Then
                objICRAV.loadRequestTypes(Me.ddlListReqType, Me.Request.QueryString("reqtype"))
            Else
                objICRAV.loadRequestTypes(Me.ddlListReqType)
            End If
            BindData()
        End If

            If Not eventName Is Nothing Then
                Me.pnlDetails.Visible = True
                Me.pnlEventDetails.Controls.Add(Me.LoadControl("../WorkflowControls/" & eventName & ".ascx"))
            End If

            If Not operation Is Nothing And operation <> "" And Me.pnlXor.Visible = False Then
                Dim op As Event_.eSubmitStatus = CInt(Me.Request.QueryString("op"))

                Select Case op
                    Case Event_.eSubmitStatus.Submit
                        Me.pnlEventDetails.Visible = False
                        changeStatus(EventNow.EventID, Event_.eStatus.Attended)
                        If Not EventNow.SelectNextTasks Then
                            lnkbSubmit_Click(sender, e)
                        Else
                            listNextEvents(EventNow)
                            listProfiles(False)
                        End If

                    Case Event_.eSubmitStatus.SaveExit
                        Me.pnlEventDetails.Controls.Clear()
                        Me.pnlDetails.Visible = False
                        changeStatus(EventNow.EventID, Event_.eStatus.PendentTaken)
                        BindData()

                    Case Event_.eSubmitStatus.ExitWithoutSave
                        Me.pnlEventDetails.Controls.Clear()
                        Me.pnlDetails.Visible = False
                        changeStatus(EventNow.EventID, Event_.eStatus.Pendent)
                        BindData()

                    'Case Event_.eSubmitStatus.SendUser
                    '    Me.pnlEventDetails.Controls.Clear()
                    '    Me.pnlDetails.Visible = False
                    '    changeStatus(EventNow.EventID, Event_.eStatus.Attended)
                    '    sendToUser()
                    '    BindData()
                End Select
            End If
    End Sub

    Private Sub ddlListReqType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ddlListReqType.SelectedIndexChanged
        BindData()
    End Sub

    Private Sub dgRequests_ItemCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles dgRequests.ItemCommand
        If e.CommandName = "ExpandEvent" Then

            Dim eid As Int64 = Me.dgRequests.DataKeys(e.Item.ItemIndex)
            EventNow = objICRAV.loadEvent(eid)
            EventNow.XMLToEvent(EventNow.EventName, EventNow.SourceEventCode)

            Me.pnlDetails.Visible = True
            Dim isSaved As Boolean = saved(EventNow)
            If takenTask(EventNow) Then
                Dim strUrl As String = TruncateUrl(Me.Request.Url.ToString)
                strUrl = strUrl & "&event=" & EventNow.EventName & "&eid=" & eid & "&seid=" & EventNow.DerivedFrom & "&saved=" & isSaved & "&cpi=" & Me.dgRequests.CurrentPageIndex & "&reqtype=" & Me.ddlListReqType.SelectedValue
                Me.Response.Redirect(strUrl)
            Else
                Me.pnlDetails.Visible = False
                Me.pnlMessage.Visible = True
                Me.lblMessage.Text = GetLabel("BO.requests.RequestsTaken")
            End If
        End If
    End Sub

    Private Function takenTask(ByVal objEvent As Event_) As Boolean
        If objEvent.EmployeeInfo.UserName <> HttpContext.Current.User.Identity.Name _
            And objEvent.Status = Event_.eStatus.Taken Then : Return False
        Else
            objEvent.EmployeeInfo.UserName = HttpContext.Current.User.Identity.Name
            objEvent.Status = Event_.eStatus.Taken
            objEvent.Seen = True
            objICRAV.updateEvent(objEvent)
            objICRAV.changeStatusTakenToPendent(objEvent.EventID, HttpContext.Current.User.Identity.Name)
            Return True
        End If
    End Function

    Private Function saved(ByVal objEvent As Event_) As Boolean
        If objEvent.Status = Event_.eStatus.PendentTaken Then : Return True
            'If objEvent.EmployeeInfo.UserName Is System.DBNull.Value Then : Return False
        Else : Return False
        End If
    End Function

    Private Sub changeStatus(ByVal eventID As Int64, ByVal status As Event_.eStatus)
        objICRAV.changeStatus(eventID, status)
    End Sub

    Private Sub lnkbExpand_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbExpand.Click
        If Me.pnlEvents.Visible = True Then
            Me.pnlEvents.Visible = False
            Me.lnkbExpand.Text = "<img src=""Images/BArrowDESC.gif"" border=""0"">" 'GetLabel("lnkbExpand")
            Me.lnkbExpand.ToolTip = GetLabel("lnkbExpand")
        Else
            Me.pnlEvents.Visible = True
            Me.lnkbExpand.Text = "<img src=""Images/BArrowASC.gif"" border=""0"">" 'GetLabel("lnkbCollapse")
            Me.lnkbExpand.ToolTip = GetLabel("lnkbCollapse")
        End If
    End Sub


    '======= NEXT EVENTS ====================================================================

    Public Sub listNextEvents(ByVal objEvent As Event_)
        If objEvent.SplitCode = "xor" Then
            Me.pnlXor.Visible = True
            Me.rblNextEvents.DataSource = objEvent.PossibleNextEvents
            Me.rblNextEvents.DataValueField = "Key"
            Me.rblNextEvents.DataTextField = "Value"
            Me.rblNextEvents.DataBind()

        ElseIf objEvent.SplitCode = "or" Then
            Me.pnlOr.Visible = True
            Me.cblNextEvents.DataSource = objEvent.PossibleNextEvents
            Me.cblNextEvents.DataValueField = "Key"
            Me.cblNextEvents.DataTextField = "Value"
            Me.cblNextEvents.DataBind()
        End If
    End Sub

    Private Sub listProfiles(Optional ByVal enabled As Boolean = True)
        Me.cblUserGroups.DataSource = objIGPU.loadProfiles(GetConfig("CRAVApplicationCode"))
        Me.cblUserGroups.DataValueField = "ProfileID"
        Me.cblUserGroups.DataTextField = "Profile"
        Me.cblUserGroups.DataBind()

        Me.cblUserGroups.Enabled = enabled

        Me.pnlUserGroups.Visible = True
    End Sub

    '========    XOR   ======== 
    Private Sub rblNextEvents_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rblNextEvents.SelectedIndexChanged
        getUserGroups(Me.rblNextEvents.SelectedValue)

        For i As Integer = 0 To Me.cblUserGroups.Items.Count - 1
            Me.cblUserGroups.Items(i).Selected = False
        Next
        Me.rblUsers.Items.Clear()
        Me.lnkbSubmit.Enabled = False
        SetFocus(Me.rblNextEvents.ClientID)
    End Sub

    '========    OR   ======== 
    Private Sub cblNextEvents_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cblNextEvents.SelectedIndexChanged
        '//
        SetFocus(Me.cblNextEvents.ClientID)
    End Sub


    Private Sub getUserGroups(ByVal task As String)
        Dim alUserGroups As ArrayList = EventNow.getUserGroups(task)
        EventNow.UserGroups = alUserGroups
        enableUserGroups(alUserGroups)
    End Sub

    Private Sub enableUserGroups(ByVal al As ArrayList)
        Me.cblUserGroups.Enabled = True
        Dim numOfItems As Integer = Me.cblUserGroups.Items.Count
        For i As Integer = 0 To numOfItems - 1
            If Not al.Contains(Me.cblUserGroups.Items(i).Text) Then
                Me.Page.RegisterStartupScript(i, "<script>disableListItems('" & Me.cblUserGroups.ClientID & "', '" & i & "', '" & numOfItems & "');</script>")
            End If
        Next
    End Sub

    Private Sub cblUserGroups_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cblUserGroups.SelectedIndexChanged
        Dim counter As Integer = 0
        Me.rblUsers.Items.Clear()

        For i As Integer = 0 To Me.cblUserGroups.Items.Count - 1
            If Me.cblUserGroups.Items(i).Selected Then
                counter += 1
            End If
        Next
        If counter = 1 Then
            Me.rblUsers.DataSource = Me.objIGPU.loadEmployees(CInt(Me.cblUserGroups.SelectedValue), GetConfig("CRAVApplicationCode"))
            Me.rblUsers.DataValueField = "UserName"
            Me.rblUsers.DataTextField = "FullName"
            Me.rblUsers.DataBind()
        End If
        If counter = 0 Then
            Me.lnkbSubmit.Enabled = False
        Else
            Me.lnkbSubmit.Enabled = True
        End If
        enableUserGroups(EventNow.UserGroups)
    End Sub


    '============= SUBMIT TO NEXT ================================================================
    Private Sub lnkbSubmit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbSubmit.Click
        If EventNow.SelectNextTasks Then
            Dim htNextEvents As New Hashtable
            'EventNow.NextEvents.Add(Me.rblNextEvents.SelectedValue(), Me.rblNextEvents.SelectedItem.Text)
            EventNow.NextUserGroups = getUserGroupsSelected()
            EventNow.NextEmployeeInfo.UserName = Me.rblUsers.SelectedValue
            htNextEvents.Add(Me.rblNextEvents.SelectedValue(), Me.rblNextEvents.SelectedItem.Text)
            storeNextEvents(htNextEvents)
        Else
            For Each task As String In EventNow.PossibleNextEvents.Keys
                If task = "output" Then
                    Exit For
                End If
                EventNow.NextUserGroups = EventNow.getUserGroups(task)
                storeNextEvents(EventNow.PossibleNextEvents)
            Next
        End If
        Me.pnlDetails.Visible = False
        Dim url As String = TruncateUrl(Me.Request.Url.ToString)
        Response.Redirect(url)
        EventNow = Nothing
    End Sub

    Private Function getUserGroupsSelected() As ArrayList
        Dim alUserGroupsSelected As New ArrayList
        For Each item As ListItem In Me.cblUserGroups.Items
            If item.Text = "Administrador" And Not item.Selected Then
                alUserGroupsSelected.Add(item.Text)
            End If
            If item.Selected Then
                alUserGroupsSelected.Add(item.Text)
            End If
        Next
        If alUserGroupsSelected.Contains("Utilizador") And alUserGroupsSelected.Contains("Administrador") Then
            alUserGroupsSelected.Remove("Administrador")
        End If
        Return alUserGroupsSelected
    End Function

    Private Sub storeNextEvents(ByVal htNextEvents As Hashtable)
        EventNow.getNextEvents(htNextEvents, Event_.eEventType.reproductionRequest)
        For Each NextEvent As Event_ In EventNow.NextEvents
            objICRAV.storeNextEvent(NextEvent, EventNow.NextUserGroups)
        Next
    End Sub

    'Private Sub sendToUser()
    '    Dim al As New ArrayList
    '    al.Add("Utilizador")
    '    EventNow.NextUserGroups = al

    '    Dim hash As New Hashtable
    '    hash.Add(EventNow.getStrEventCode(EventNow.EventCode) + "Notification", "Utilizador")

    '    storeNextEvents(hash)
    '    EventNow = Nothing
    'End Sub

    '============= DATAGRID =====================================================================
    Public Sub BindData()
        If IsNothing(Session("sortExpression")) Then
            Me.DataGridSetup(CInt(Session("currentPageIndex")))
        Else
            ' sort before setup datagrid
            Me.SortedDatagridSetup(False, CInt(Session("currentPageIndex")), Session("sortExpression"))
        End If
    End Sub

    Private Sub SortedDatagridSetup(ByVal toggleSort As Boolean, ByVal currentPageIndex As Int32, ByVal sortExpression As String)
        ' get sort header sufixes
        Dim headerDescSufix As String = " <img src=""Images/BArrowDESC.gif"" border=""0"">" 'Me.GetConfig("ColumnHeaderSortDesc")
        Dim headerAscSufix As String = " <img src=""Images/BArrowASC.gif"" border=""0"">" 'Me.GetConfig("ColumnHeaderSortAsc")
        ' parse sortExpression
        Dim sortColumnName As String = CStr(Split(sortExpression, ",")(0))
        Dim sortColumnIndex As Int16 = CInt(Split(sortExpression, ",")(1))
        ' store in viewstate the sort state
        'Me.ViewState.Add("sortExpression", sortExpression)
        Me.Session.Add("sortExpression", sortExpression)
        ' datagrid setup
        If toggleSort Then
            ' switch the sort: 2-way click sorting ( ..  -> ASC -> DESC -> ASC -> .. )
            If Me.dgRequests.Columns(sortColumnIndex).HeaderText.EndsWith(headerAscSufix) Then
                DataGridSetup(currentPageIndex, sortColumnName & " DESC", sortColumnIndex, headerDescSufix)
            Else
                DataGridSetup(currentPageIndex, sortColumnName & " ASC", sortColumnIndex, headerAscSufix)
            End If
        Else
            ' mantain the current sort state
            If Me.dgRequests.Columns(sortColumnIndex).HeaderText.EndsWith(headerAscSufix) Then
                DataGridSetup(currentPageIndex, sortColumnName & " ASC", sortColumnIndex, headerAscSufix)
            Else
                DataGridSetup(currentPageIndex, sortColumnName & " DESC", sortColumnIndex, headerDescSufix)
            End If
        End If
    End Sub


    Private Function DataGridSetup(ByVal currentPageIndex As Int32, Optional ByVal sortExpression As String = Nothing, Optional ByVal sortColumnIndex As String = Nothing, Optional ByVal sortColumnHeader As String = Nothing)

        Me.dgRequests.Columns(0).HeaderText = GetLabel("dgRequests.EventID")
        Me.dgRequests.Columns(2).HeaderText = GetLabel("dgRequests.EventDesignation")
        Me.dgRequests.Columns(3).HeaderText = GetLabel("dgRequests.Status")
        Me.dgRequests.Columns(4).HeaderText = GetLabel("dgRequests.Process.ProcessID")
        Me.dgRequests.Columns(5).HeaderText = GetLabel("dgRequests.Process.InitialDate")
        Me.dgRequests.Columns(6).HeaderText = GetLabel("dgRequests.UserInfo.FullName")

        If Not IsNothing(sortExpression) Then
            Me.dgRequests.Columns(sortColumnIndex).HeaderText() &= sortColumnHeader
        End If
        ' setup datagrid parameters
        Me.dgRequests.PageSize = Me.GetConfig("NumPageRowsDG")
        Me.dgRequests.PagerStyle.PageButtonCount = Me.GetConfig("NumIndexPagesDG")
        ' setup datagrid datasource
        Me.dgRequests.DataSource = Me.CreateDataSource(sortExpression)
        'Me.dgRequests.DataBind()

        ' show/hide datagrid whether it exists datasource rows
        Dim DataSourceRows As Int32 = CType(Me.dgRequests.DataSource, DataView).Table.Rows.Count

        If DataSourceRows > 0 Then
            Me.pnlMessage.Visible = False
            'Me.dgRequests.Visible = True
            Me.pnlEvents.Visible = True
            Dim numPages = (DataSourceRows \ Me.dgRequests.PageSize)
            If (DataSourceRows Mod Me.dgRequests.PageSize) <> 0 Then
                numPages = numPages + 1
            End If
            If numPages <= currentPageIndex Then
                Me.dgRequests.CurrentPageIndex = numPages - 1
            Else
                Me.dgRequests.CurrentPageIndex = currentPageIndex
            End If
            Me.dgRequests.DataBind()
        Else
            Me.pnlEvents.Visible = False
            Me.pnlMessage.Visible = True
            Me.lblMessage.Text = GetLabel("BO.requests.EmptyTaskList")
        End If
    End Function

    Private Function CreateDataSource(Optional ByVal sortExpression As String = Nothing) As ICollection
        Dim intProfile As Integer = objIGPU.getProfile(HttpContext.Current.User.Identity.Name, ConfigurationSettings.AppSettings("CRAVApplicationCode")).ProfileID
        Dim ReqType As String
        'If Not Me.Request.QueryString("reqtype") Is Nothing Then
        '    ReqType = Me.Request.QueryString("reqtype")
        'Else
        '    ReqType = Me.ddlListReqType.SelectedValue
        'End If
        Dim dsRequests As DataSet = objICRAV.loadRequestsPendentsByProfile(Me.ddlListReqType.SelectedValue, intProfile)

        Dim dv As DataView = dsRequests.DefaultViewManager.CreateDataView(dsRequests.Tables(0))
        If Not IsNothing(sortExpression) Then dv.Sort = sortExpression
        Return dv
    End Function

    Private Sub dgRequests_ItemDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles dgRequests.ItemDataBound
        Dim eventID As Int64
        Dim seen As Boolean
        If e.Item.ItemType.ToString = "Item" Or e.Item.ItemType.ToString = "AlternatingItem" Then

            eventID = Me.dgRequests.DataKeys(e.Item.ItemIndex)
            seen = e.Item.Cells(8).Text
            If eventID = Me.Request.QueryString("eid") Then
                e.Item.BackColor = Color.FromName("#cccccc")
            ElseIf seen = False Then
                e.Item.BackColor = Color.FromArgb(255, 200, 255, 200)
            Else
                e.Item.Attributes.Add("OnMouseOver", "this.style.backgroundColor = '#cccccc';")
                e.Item.Attributes.Add("OnMouseOut", "this.style.backgroundColor = '';")

                Dim status As Event_.eStatus = e.Item.Cells(1).Text
                If status = Event_.eStatus.Taken And Not Me.Request.QueryString("eid") Is Nothing Then
                    changeStatus(eventID, Event_.eStatus.Pendent)
                    'Me.Page.RegisterStartupScript(e.Item.Cells(1).Text, "<script>window.alert('" & String.Format(GetLabel("BO.requests.popRequestMustBeReleased"), e.Item.Cells(0).Text) & "');</script>")
                End If
            End If
        End If
    End Sub

    Private Sub DataGrid_SortCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridSortCommandEventArgs) Handles dgRequests.SortCommand
        SortedDatagridSetup(True, Me.dgRequests.CurrentPageIndex, e.SortExpression)
    End Sub

    Private Sub dgRequests_PageIndexChanged(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridPageChangedEventArgs) Handles dgRequests.PageIndexChanged
        Me.dgRequests.CurrentPageIndex = e.NewPageIndex
        If IsNothing(Session("sortExpression")) Then
            Me.DataGridSetup(e.NewPageIndex)
        Else
            Me.SortedDatagridSetup(False, e.NewPageIndex, Session("sortExpression"))
        End If
        Session("currentPageIndex") = e.NewPageIndex
    End Sub

    '============= UTILS =====================================================================
    Private Sub SetFocus(ByVal ctrl As String)
        Dim s As String = "<script language='JavaScript'>" & _
            " if (document.getElementById) {x=document.getElementById('" & ctrl & "');" & _
            "x.focus(); } " & _
            "</script>"
        Page.RegisterStartupScript("Focus", s)
    End Sub

    '============= PROPERTIES ================================================================
    Public Property EventNow() As Event_
        Get
            Return Session("EventNow")
        End Get
        Set(ByVal Value As Event_)
            Try
                Session("EventNow") = Value
            Catch ex As Exception
                Response.Write("<script language=javascript>window.alert('A sua sesso expirou...');</script>")
                Response.Redirect(GetConfig("InitialPageUrl"))
            End Try
        End Set
    End Property

    Private Sub lnkbRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbRefresh.Click
        Response.Redirect(Me.Request.Url.ToString)
    End Sub


End Class
