<%@ Import Namespace ="CRAVDataBaseAccess.General" %>
<%@ Import Namespace ="CRAVDataBaseAccess.mShowItems" %>
<%@ Register TagPrefix="uc1" TagName="ascendantCorrespondence" Src="../ControlsBackOffice/ascendantCorrespondence.ascx" %>
<%@ Control Language="vb" AutoEventWireup="false" Codebehind="correspondenceIn.ascx.vb" Inherits="CRAVBackOffice.correspondenceIn1" TargetSchema="http://schemas.microsoft.com/intellisense/ie5" %>
<table width="100%" cellpadding="0" cellspacing="0" border="0">
	<tr>
		<%= CorrespondencePath %>
	</tr>
	<tr>
		<td class="vertical_spacer2"></td>
	</tr>
	<tr>
		<td class="txtALeftBold07">Registo de entrada:</td>
	</tr>
	<tr>
		<td>
			<asp:repeater id="repTitles" Runat="server">
				<HeaderTemplate>
					<%# strHeaderTable() %>
				</HeaderTemplate>
				<ItemTemplate>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.CorrespondenceID"), DataBinder.Eval(Container,"DataItem.ManualEntryExitID") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Type"), getlabel("event." & DataBinder.Eval(Container,"DataItem.EventCode")) ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.TypeEntry"), DataBinder.Eval(Container,"DataItem.TypeEntryExit")  ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.EntryDate"), DataBinder.Eval(Container,"DataItem.EventDate") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.DocumentDate"), DataBinder.Eval(Container,"DataItem.DocumentDate") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Prov"), DataBinder.Eval(Container,"DataItem.ProvDest") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Reference"), DataBinder.Eval(Container,"DataItem.Reference") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Note"), DataBinder.Eval(Container,"DataItem.Note") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Event.Classification"), DataBinder.Eval(Container,"DataItem.Classification") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Event.ProcessID"), DataBinder.Eval(Container,"DataItem.Process.ProcessID") ) %>
				</ItemTemplate>
				<FooterTemplate>
					<%# strFooterTable() %>
				</FooterTemplate>
			</asp:repeater>
		</td>
	</tr>
	<tr>
		<td class="vertical_spacer1"></td>
	</tr>
	<tr>
		<td>
			<table width="100%" cellpadding="0" cellspacing="0" border="0">
				<tr>
					<td width="20"></td>
					<td><uc1:ascendantCorrespondence id="AscendantCorrespondence" runat="server"></uc1:ascendantCorrespondence></td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="vertical_spacer1"></td>
	</tr>
	<tr>
		<td>
			<asp:DataGrid ID="dgAttacheds" cellpadding="4" CellSpacing="1" AllowPaging="False" GridLines="None"
				AutoGenerateColumns="False" DataKeyField="AttachedID" BorderWidth="0" BackColor="#ffffff"
				Width="100%" Runat="server">
				<HeaderStyle CssClass="headerStyle"></HeaderStyle>
				<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
				<Columns>
					<asp:buttoncolumn buttontype="LinkButton" commandname="Delete" text="<img src='../Images/delete.gif' alt='Remover Item' border='0'>"></asp:buttoncolumn>
					<asp:BoundColumn DataField="FileName" HeaderText="Nome" ReadOnly="True"></asp:BoundColumn>
					<asp:BoundColumn DataField="ContentLength" HeaderText="Tamanho" HeaderStyle-Width="150"></asp:BoundColumn>
					<asp:TemplateColumn>
						<ItemTemplate>
							<asp:ImageButton Runat="server" ID="imbOpenAttached" CausesValidation="False" CommandName="OpenAttached" ImageUrl="../Images/detalhe1.gif" />
						</ItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:DataGrid>
		</td>
	</tr>
</table>
