<%@ Control Language="vb" AutoEventWireup="false" Codebehind="listServices.ascx.vb" Inherits="CRAVBackOffice.listServices" TargetSchema="http://schemas.microsoft.com/intellisense/ie5" %>
<table width="100%" cellpadding="0" cellspacing="0" border="0">
	<tr>
		<td>
			<asp:datagrid id="dgBudgets" Runat="server" Width="100%" BorderWidth="0" DataKeyField="ServiceID"
				AutoGenerateColumns="False" GridLines="None" AllowPaging="False" CellSpacing="1" cellpadding="4">
				<Columns>
					<asp:BoundColumn DataField="Category" ReadOnly="True">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
					</asp:BoundColumn>
					<asp:BoundColumn DataField="Service" ReadOnly="True">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
					</asp:BoundColumn>
					<asp:TemplateColumn>
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
						<ItemTemplate>
							<%# String.Format("{0:0.00}", DataBinder.Eval(Container.DataItem,"UnitPrice")) %>
						</ItemTemplate>
					</asp:TemplateColumn>
					<asp:BoundColumn DataField="Quantity" ReadOnly="True">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
					</asp:BoundColumn>
					<asp:TemplateColumn HeaderStyle-Width="100px">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
						<ItemTemplate>
							<%# String.Format("{0:0.00}", DataBinder.Eval(Container.DataItem,"UnitPrice")*DataBinder.Eval(Container.DataItem,"Quantity")) %>
						</ItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:datagrid>
		</td>
	</tr>
	<TR>
		<TD class="line" colSpan="2"></TD>
	</TR>
	<tr>
		<td>
			<TABLE cellSpacing="1" cellPadding="4" width="100%" border="0">
				<TR height="20">
					<TD align="right"><%=getlabel("BO.buildListServices.lblTotal")%></TD>
					<TD align="center" width="100">
						<asp:Label id="lblTotalValue" Runat="server" CssClass="lbl05_Center" Font-Bold="True"></asp:Label></TD>
				</TR>
			</TABLE>
		</td>
	</tr>
	<TR>
		<TD class="line" colSpan="2"></TD>
	</TR>
</table>
