<%@ Control Language="vb" AutoEventWireup="false" Codebehind="processEvents.ascx.vb" Inherits="CRAVBackOffice.processEvents" TargetSchema="http://schemas.microsoft.com/intellisense/ie5" %>
<%@ Import Namespace ="DigitArq.Utility" %>
<%@ Import Namespace ="CRAVDataBaseAccess.mShowItems" %>
<table cellSpacing="0" cellPadding="0" width="600" align="center" border="0">
	<tr>
		<td>
			<asp:Repeater id="repProcess" Runat="server">
				<HeaderTemplate>
					<%# strHeaderTable() %>
				</HeaderTemplate>
				<ItemTemplate>
					<%# strDraw3ColumnRowTitles("", getlabel("Process.ProcessID"), DataBinder.Eval(Container,"DataItem.OtherProcessID")  ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Process.ProcessType"), GetLabel("Process.ProcessType." & DataBinder.Eval(Container,"DataItem.ProcessType")) ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Process.Classification"), dbtostr(DataBinder.Eval(Container,"DataItem.Classification")) ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Process.Subject"), dbtostr(DataBinder.Eval(Container,"DataItem.Subject")) ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Process.FolderID"), dbtostr(DataBinder.Eval(Container,"DataItem.FolderID")) ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Process.Employee"), dbtostr(DataBinder.Eval(Container,"DataItem.Employee.FullName")) ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Process.InitialDate"), dbtostr(DataBinder.Eval(Container,"DataItem.InitialDate")) ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Process.FinalDate"), dbtostr(DataBinder.Eval(Container,"DataItem.FinalDate")) ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Process.User"), dbtostr(DataBinder.Eval(Container,"DataItem.UserInfo.FullName")) ) %>
				</ItemTemplate>
				<FooterTemplate>
					<%# strFooterTable() %>
				</FooterTemplate>
			</asp:Repeater>
		</td>
	</tr>
	<tr>
		<td class="vertical_spacer2"></td>
	</tr>
	<tr>
		<td vAlign="top">
			<div id="contentstart">
				<asp:datagrid id="dgCorrespondence" Runat="server" cellpadding="5" CellSpacing="1" AllowPaging="False"
					AllowSorting="True" GridLines="None" AutoGenerateColumns="False" DataKeyField="EventID" BorderWidth="0"
					Width="100%">
					<ITEMSTYLE CssClass='itemStyle_textLeft'></ITEMSTYLE>
					<ALTERNATINGITEMSTYLE CssClass='itemStyle_textLeft'></ALTERNATINGITEMSTYLE>
					<Columns>
						<asp:BoundColumn DataField="SourceEventID" ReadOnly="True">
							<HEADERSTYLE CssClass='hStyleOrder'></HEADERSTYLE>
						</asp:BoundColumn>
						<asp:BoundColumn DataField="EventCode" Visible="False" ReadOnly="True">
							<HEADERSTYLE CssClass='hStyleOrder'></HEADERSTYLE>
						</asp:BoundColumn>
						<asp:TemplateColumn ItemStyle-VerticalAlign="Top">
							<HEADERSTYLE CssClass='hStyleOrder'></HEADERSTYLE>
							<ItemTemplate>
								<%# getLabel("event." + DataBinder.Eval(Container,"DataItem.EventCode").tostring) %>
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:BoundColumn DataField="EventDate" ReadOnly="True">
							<HEADERSTYLE CssClass='hStyleOrder'></HEADERSTYLE>
						</asp:BoundColumn>
						<asp:BoundColumn DataField="EmployeeID" ReadOnly="True">
							<HEADERSTYLE CssClass='hStyleOrder'></HEADERSTYLE>
						</asp:BoundColumn>
						<asp:BoundColumn DataField="FullNameUser" ReadOnly="True">
							<HEADERSTYLE CssClass='hStyleOrder'></HEADERSTYLE>
						</asp:BoundColumn>
						<asp:TemplateColumn ItemStyle-Width="15px">
							<HEADERSTYLE CssClass='headerStyle'></HEADERSTYLE>
							<ItemTemplate>
								<a href='requestDetails.aspx?event=<%# getEventName(DataBinder.Eval(Container,"DataItem.EventCode")) %>&eid=<%# DataBinder.Eval(Container,"DataItem.EventID") %>&lastID=<%# DataBinder.Eval(Container,"DataItem.EventID") %>&lnkBack=Visible'>
									<img src="../Images/detalhe1.gif" border="0"> </a>
							</ItemTemplate>
						</asp:TemplateColumn>
					</Columns>
				</asp:datagrid>
			</div>
		</td>
	</tr>
	<tr>
		<td><asp:panel id="pnlWithoutResults" Runat="server" Visible="false">
      <TABLE cellSpacing=0 cellPadding=0 width="100%" border=0>
        <TR>
          <TD class=vertival_spacer2></TD></TR>
        <TR>
          <TD class=Alert align=center><%= getlabel("BO.processEvents.alert1") %></TD></TR></TABLE>
			</asp:panel>
		</td>
	</tr>
</table>
