Imports System.Globalization
Imports CRAVDataBaseAccess
Imports DigitArq.Data.Entities.MGUP

Public Class buildListServices
    Inherits CRAVDataBaseAccess.BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents tblBudgets As System.Web.UI.WebControls.Table
    Protected WithEvents lnkbDelete As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkbSubmit As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lblRowID As System.Web.UI.WebControls.Label
    Protected WithEvents lblUnitPrice As System.Web.UI.WebControls.Label
    Protected WithEvents txbQuantity As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblCost As System.Web.UI.WebControls.Label
    Protected WithEvents lblTotal As System.Web.UI.WebControls.Label
    Protected WithEvents lblTotalValue As System.Web.UI.WebControls.Label
    Protected WithEvents pnlTotal As System.Web.UI.WebControls.Panel
    Protected WithEvents reQuantity As System.Web.UI.WebControls.RegularExpressionValidator
    Protected WithEvents RequiredFieldValidator1 As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents lnkbInsert As System.Web.UI.WebControls.LinkButton
    Protected WithEvents ddlCategories As System.Web.UI.WebControls.DropDownList
    Protected WithEvents ddlServices As System.Web.UI.WebControls.DropDownList
    Protected WithEvents rfvQuantity As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents dgTasks As System.Web.UI.WebControls.DataGrid
    Protected WithEvents rfvServices As System.Web.UI.WebControls.RequiredFieldValidator

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private myTask As Task
    Private myListServices As DataTable
    Private objLS As DataTable
    Private objDT As DataTable
    Private objDR As System.Data.DataRow
    Private objICRAV As New CRAVDataBaseAccess.SQLDataBase
    Private objIGPU As New DigitArq.Data.Entities.MGUP.SQLDataBase

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        If Not Me.Page.IsPostBack Then
            objICRAV.loadCategories(Me.ddlCategories)
            loadDdlServices(Me.ddlCategories.SelectedValue)
            'Me.lblUnitPrice.Text = String.Format("{0:0.00}", objDT.Rows.Find(Me.ddlServices.SelectedValue).Item("UnitPrice"))

            If Services Is Nothing Then
                CreatTask()
            Else
                LoadTask(Services)
                DataGridSetup(objLS)
                Me.pnlTotal.Visible = True
                Me.lblTotalValue.Text = String.Format("{0:0.00}", GetItemTotal())
            End If

            Me.lnkbInsert.Text = GetLabel("lnkbInsert")
        End If
    End Sub

    Private Sub DataGridSetup(ByVal dt As DataTable)
        Me.dgTasks.Columns(1).HeaderText = GetLabel("BO.buildListServices.lblCategory")
        Me.dgTasks.Columns(2).HeaderText = GetLabel("BO.buildListServices.lblService")
        Me.dgTasks.Columns(3).HeaderText = GetLabel("BO.buildListServices.lblUnitPrice")
        Me.dgTasks.Columns(4).HeaderText = GetLabel("BO.buildListServices.lblQuantity")
        Me.dgTasks.Columns(5).HeaderText = GetLabel("BO.buildListServices.lblCost")

        Me.dgTasks.DataSource = dt
        Me.dgTasks.DataBind()
    End Sub

    Private Sub loadDdlServices(Optional ByVal strCategory As String = "")
        objDT = New DataTable
        objDT = objICRAV.loadServices(Me.ddlCategories.SelectedValue)
        If strCategory <> "" Then
            Me.ddlServices.DataValueField = "ServiceID"
            Me.ddlServices.DataTextField = "Service"
            Me.ddlServices.DataSource = objDT
            Me.ddlServices.DataBind()
            Dim item As New ListItem(GetLabel("BO.itemSelect"), "0")
            Me.ddlServices.Items.Insert(0, item)
        End If
    End Sub

    Function CreatTask()
        objLS = New DataTable

        objLS.Constraints.Add("primaryKey", objLS.Columns.Add("ServiceID", GetType(Int64)), True)
        objLS.Columns.Add("Service", GetType(String))
        objLS.Columns.Add("Category", GetType(String))
        objLS.Columns.Add("Quantity", GetType(Integer))
        objLS.Columns.Add("UnitPrice", GetType(Decimal))
        objLS.Columns.Add("Attached", GetType(Byte()))
        objLS.Columns.Add("AttachedName", GetType(String))
        objLS.Columns.Add("AttachedType", GetType(String))
        objLS.Columns.Add("AttachedLength", GetType(Int64))

        ListServices = objLS
    End Function

    Private Sub LoadTask(ByVal services As DataTable)
        objLS = New DataTable

        objLS.Constraints.Add("primaryKey", objLS.Columns.Add("ServiceID", GetType(Int64)), True)
        objLS.Columns.Add("Service", GetType(String))
        objLS.Columns.Add("Category", GetType(String))
        objLS.Columns.Add("Quantity", GetType(Integer))
        objLS.Columns.Add("UnitPrice", GetType(Decimal))
        objLS.Columns.Add("Attached", GetType(Byte()))
        objLS.Columns.Add("AttachedName", GetType(String))
        objLS.Columns.Add("AttachedType", GetType(String))
        objLS.Columns.Add("AttachedLength", GetType(Int64))

        For Each dataRow As System.Data.DataRow In services.Rows
            objDR = objLS.NewRow
            objDR("ServiceID") = dataRow("ServiceID")
            objDR("Quantity") = dataRow("Quantity")
            objDR("Service") = dataRow("Service")
            objDR("UnitPrice") = dataRow("UnitPrice")
            objDR("Category") = dataRow("Category")
            objDR("Attached") = dataRow("Attached")
            objDR("AttachedName") = dataRow("AttachedName")
            objDR("AttachedType") = dataRow("AttachedType")
            objDR("AttachedLength") = dataRow("AttachedLength")

            objLS.Rows.Add(objDR)
        Next

        ListServices = objLS
    End Sub

    Private Sub lnkbInsert_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbInsert.Click

        If Me.Page.IsValid Then
            objLS = ListServices

            Dim Service As String = Me.ddlServices.SelectedItem.Text
            Dim blnMatch As Boolean = False

            For Each objDR In objLS.Rows
                If objDR("Service") = Service Then
                    objDR("Quantity") += Me.txbQuantity.Text
                    blnMatch = True
                    Exit For
                End If
            Next
            If Not blnMatch Then
                Dim bytes(0) As Byte

                objDR = objLS.NewRow
                objDR("ServiceID") = Me.ddlServices.SelectedValue
                objDR("Quantity") = Me.txbQuantity.Text
                objDR("Service") = Me.ddlServices.SelectedItem.Text
                objDR("UnitPrice") = Math.Round(CType(Me.lblUnitPrice.Text, Decimal), 2)
                objDR("Category") = Me.ddlCategories.SelectedItem.Text
                objDR("Attached") = bytes
                objDR("AttachedName") = ""
                objDR("AttachedType") = ""
                objDR("AttachedLength") = 0

                objLS.Rows.Add(objDR)
            End If

            ListServices = objLS

            DataGridSetup(objLS)

            Me.pnlTotal.Visible = True
            Me.lblTotalValue.Text = String.Format("{0:0.00}", GetItemTotal())
        End If
    End Sub

    Private Function GetItemTotal() As Decimal
        Dim intCounter As Integer
        Dim decTotal As Decimal

        For intCounter = 0 To objLS.Rows.Count - 1
            objDR = objLS.Rows(intCounter)
            decTotal += (objDR("UnitPrice") * objDR("Quantity"))
        Next

        Return Math.Round(decTotal, 2)
    End Function

    Private Sub ddlCategories_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ddlCategories.SelectedIndexChanged
        loadDdlServices(Me.ddlCategories.SelectedValue)
    End Sub

    Private Sub ddlServices_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ddlServices.SelectedIndexChanged
        If Not Me.ddlServices.SelectedValue.Equals("0") Then
            loadDdlServices()
            Me.lblUnitPrice.Text = String.Format("{0:0.00}", objDT.Rows.Find(Me.ddlServices.SelectedValue).Item("UnitPrice"))
        Else
            Me.lblUnitPrice.Text = ""
        End If
    End Sub

    Private Sub dgTasks_DeleteCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles dgTasks.DeleteCommand
        objLS = Session("ListServices")
        objLS.Rows(e.Item.ItemIndex).Delete()
        Dim num As Integer = objLS.Rows.Count
        ListServices = objLS

        DataGridSetup(objLS)

        Me.lblTotalValue.Text = String.Format("{0:0.00}", GetItemTotal())
    End Sub

    '============= PROPERTIES =========================================
    Property Task() As Task
        Get
            Return myTask
        End Get
        Set(ByVal Value As Task)
            myTask = Value
        End Set
    End Property

    Property Services() As DataTable
        Get
            Return myListServices
        End Get
        Set(ByVal Value As DataTable)
            myListServices = Value
        End Set
    End Property

End Class
