Imports System.Resources
Imports System.Globalization
Imports System.Threading

Module loadText

    Public Function loadtext(ByVal cc As ControlCollection, ByVal strlanguage As String, ByVal prefix As String) As String

        Dim objrm As New ResourceManager("crav.res", system.reflection.assembly.getexecutingassembly)
        thread.currentthread.currentuiculture = New CultureInfo(strlanguage)

        Dim ctrl As Control
        For Each ctrl In cc
            Try
                If ctrl.GetType Is GetType(Label) Then
                    Dim tempCtrl As Label = CType(ctrl, Label)
                    tempCtrl.Text = objrm.GetString(prefix & ctrl.ID)
                ElseIf ctrl.GetType Is GetType(RadioButtonList) Then
                    Dim tempCtrl As RadioButtonList = CType(ctrl, RadioButtonList)
                    Dim numItems As Integer = tempCtrl.Items.Count
                    For i As Integer = 0 To numItems - 1
                        Dim str As String = prefix & ctrl.ID & CStr(i)
                        tempCtrl.Items(i).Text = objrm.GetString(prefix & ctrl.ID & CStr(i))
                    Next
                ElseIf ctrl.GetType Is GetType(HyperLink) Then
                    Dim tempCtrl As HyperLink = CType(ctrl, HyperLink)
                    tempCtrl.Text = objrm.GetString(prefix & ctrl.ID)
                ElseIf ctrl.GetType Is GetType(RequiredFieldValidator) Then
                    Dim tempCtrl As RequiredFieldValidator = CType(ctrl, RequiredFieldValidator)
                    tempCtrl.ErrorMessage = objrm.GetString(prefix & ctrl.ID)
                End If
            Catch ex As Exception
            End Try
        Next
    End Function

End Module
