Public Class Correspondence
    Inherits Event_


#Region "Internal Properties (private)"

    Private myCorrespondenceID As Int64
    Private myManualEntryExitID As Integer
    Private myParentID As Integer

    Private myTypeEntryExitCode As String
    Private myTypeEntryExit As String

    Private myDocumentDate As String
    Private myProvDest As String
    Private myReference As String
    Private mySubject As String
    Private myAttacheds As New AttachedCollection
    Private myNote As String

#End Region


#Region "Gets and Sets of Public Properties"


    Public Property CorrespondenceID() As Int64
        Get
            Return myCorrespondenceID
        End Get
        Set(ByVal Value As Int64)
            myCorrespondenceID = Value
        End Set
    End Property

    Public Property ManualEntryExitID() As Integer
        Get
            Return myManualEntryExitID
        End Get
        Set(ByVal Value As Integer)
            myManualEntryExitID = Value
        End Set
    End Property

    Public Property ParentID() As String
        Get
            Return myParentID
        End Get
        Set(ByVal Value As String)
            myParentID = Value
        End Set
    End Property

    Public Property TypeEntryExitCode() As String
        Get
            Return myTypeEntryExitCode
        End Get
        Set(ByVal Value As String)
            myTypeEntryExitCode = Value
        End Set
    End Property

    Public Property TypeEntryExit() As String
        Get
            Return myTypeEntryExit
        End Get
        Set(ByVal Value As String)
            myTypeEntryExit = Value
        End Set
    End Property

    Public Property DocumentDate() As String
        Get
            Return myDocumentDate
        End Get
        Set(ByVal Value As String)
            myDocumentDate = Value
        End Set
    End Property

    Public Property ProvDest() As String
        Get
            Return myProvDest
        End Get
        Set(ByVal Value As String)
            myProvDest = Value
        End Set
    End Property

    Public Property Reference() As String
        Get
            Return myReference
        End Get
        Set(ByVal Value As String)
            myReference = Value
        End Set
    End Property

    Public Property Subject() As String
        Get
            Return mySubject
        End Get
        Set(ByVal Value As String)
            mySubject = Value
        End Set
    End Property

    Public Property Attacheds() As AttachedCollection
        Get
            Return myAttacheds
        End Get
        Set(ByVal Value As AttachedCollection)
            myAttacheds = Value
        End Set
    End Property

    Public Property Note() As String
        Get
            Return myNote
        End Get
        Set(ByVal Value As String)
            myNote = Value
        End Set
    End Property

#End Region

End Class

Public Class CorrespondenceCollection
    Inherits CollectionBase

    Default Public Property Item(ByVal index As Integer) As Correspondence
        Get
            Return CType(List(index), Correspondence)
        End Get
        Set(ByVal Value As Correspondence)
            List(index) = Value
        End Set
    End Property

    Public Function Add(ByVal value As Correspondence) As Integer
        Return List.Add(value)
    End Function

    Public Function IndexOf(ByVal value As Correspondence) As Integer
        Return List.IndexOf(value)
    End Function

    Public Sub Insert(ByVal index As Integer, ByVal value As Correspondence)
        List.Insert(index, value)
    End Sub

    Public Sub Remove(ByVal value As Correspondence)
        List.Remove(value)
    End Sub

    Public Function Contains(ByVal value As Correspondence) As Boolean
        Return List.Contains(value)
    End Function

End Class


