Public Class Emolument

#Region "Internal Properties (private)"

    Private myEmolumentID As Integer
    Private myEmolumentDate As String
    Private myReceiptNumber As String
    Private myIVA As Integer
    Private myCost As String
    Private myCertificateNumber As Int64
    Private myExemption As String
    Private myNote As String
    Private myCategoryID As Integer

#End Region


#Region "Gets and Sets of Public Properties"

    Public Property EmolumentID() As Integer
        Get
            Return myEmolumentID
        End Get
        Set(ByVal Value As Integer)
            myEmolumentID = Value
        End Set
    End Property

    Public Property EmolumentDate() As String
        Get
            Return myEmolumentDate
        End Get
        Set(ByVal Value As String)
            myEmolumentDate = Value
        End Set
    End Property

    Public Property ReceiptNumber() As String
        Get
            Return myReceiptNumber
        End Get
        Set(ByVal Value As String)
            myReceiptNumber = Value
        End Set
    End Property

    Public Property IVA() As Integer
        Get
            Return myIVA
        End Get
        Set(ByVal Value As Integer)
            myIVA = Value
        End Set
    End Property

    Public Property Cost() As String
        Get
            Return myCost
        End Get
        Set(ByVal Value As String)
            myCost = Value
        End Set
    End Property

    Public Property CertificateNumber() As Int64
        Get
            Return myCertificateNumber
        End Get
        Set(ByVal Value As Int64)
            myCertificateNumber = Value
        End Set
    End Property

    Public Property Exemption() As String
        Get
            Return myExemption
        End Get
        Set(ByVal Value As String)
            myExemption = Value
        End Set
    End Property

    Public Property Note() As String
        Get
            Return myNote
        End Get
        Set(ByVal Value As String)
            myNote = Value
        End Set
    End Property

    Public Property CategoryID() As String
        Get
            Return myCategoryID
        End Get
        Set(ByVal Value As String)
            myCategoryID = Value
        End Set
    End Property

#End Region

End Class

Public Class EmolumentCollection
    Inherits CollectionBase

    Default Public Property Item(ByVal index As Integer) As Emolument
        Get
            Return CType(List(index), Emolument)
        End Get
        Set(ByVal Value As Emolument)
            List(index) = Value
        End Set
    End Property

    Public Function Add(ByVal value As Emolument) As Integer
        Return List.Add(value)
    End Function

    Public Function IndexOf(ByVal value As Emolument) As Integer
        Return List.IndexOf(value)
    End Function

    Public Sub Insert(ByVal index As Integer, ByVal value As Emolument)
        List.Insert(index, value)
    End Sub

    Public Sub Remove(ByVal value As Emolument)
        List.Remove(value)
    End Sub

    Public Function Contains(ByVal value As Emolument) As Boolean
        Return List.Contains(value)
    End Function

End Class