Public Class Message

#Region "Internal Properties (private)"

    Private myMessageID As Integer
    Private myMessageTitle As String
    Private myMessage As String

#End Region


#Region "Gets and Sets of Public Properties"

    Public Property MessageID() As Integer
        Get
            Return myMessageID
        End Get
        Set(ByVal Value As Integer)
            myMessageID = Value
        End Set
    End Property

    Public Property MessageTitle() As String
        Get
            Return myMessageTitle
        End Get
        Set(ByVal Value As String)
            myMessageTitle = Value
        End Set
    End Property

    Public Property Message() As String
        Get
            Return myMessage
        End Get
        Set(ByVal Value As String)
            myMessage = Value
        End Set
    End Property

#End Region

End Class

Public Class MessageCollection
    Inherits CollectionBase

    Default Public Property Item(ByVal index As Integer) As Message
        Get
            Return CType(List(index), Message)
        End Get
        Set(ByVal Value As Message)
            List(index) = Value
        End Set
    End Property

    Public Function Add(ByVal value As Message) As Integer
        Return List.Add(value)
    End Function

    Public Function IndexOf(ByVal value As Message) As Integer
        Return List.IndexOf(value)
    End Function

    Public Sub Insert(ByVal index As Integer, ByVal value As Message)
        List.Insert(index, value)
    End Sub

    Public Sub Remove(ByVal value As Message)
        List.Remove(value)
    End Sub

    Public Function Contains(ByVal value As Message) As Boolean
        Return List.Contains(value)
    End Function

End Class