Public Class Note

#Region "Internal Properties (private)"

    Private myNoteID As Integer
    Private myNoteTitle As String
    Private myNoteDate As String
    Private myNote As String
    Private myUserID As Integer

#End Region


#Region "Gets and Sets of Public Properties"

    Public Property NoteID() As Integer
        Get
            Return myNoteID
        End Get
        Set(ByVal Value As Integer)
            myNoteID = Value
        End Set
    End Property

    Public Property NoteTitle() As String
        Get
            Return myNoteTitle
        End Get
        Set(ByVal Value As String)
            myNoteTitle = Value
        End Set
    End Property

    Public Property NoteDate() As String
        Get
            Return myNoteDate
        End Get
        Set(ByVal Value As String)
            myNoteDate = Value
        End Set
    End Property

    Public Property Note() As String
        Get
            Return myNote
        End Get
        Set(ByVal Value As String)
            myNote = Value
        End Set
    End Property

    Public Property UserID() As Integer
        Get
            Return myUserID
        End Get
        Set(ByVal Value As Integer)
            myUserID = Value
        End Set
    End Property

#End Region

End Class

Public Class NoteCollection
    Inherits CollectionBase

    Default Public Property Item(ByVal index As Integer) As Note
        Get
            Return CType(List(index), Note)
        End Get
        Set(ByVal Value As Note)
            List(index) = Value
        End Set
    End Property

    Public Function Add(ByVal value As Note) As Integer
        Return List.Add(value)
    End Function

    Public Function IndexOf(ByVal value As Note) As Integer
        Return List.IndexOf(value)
    End Function

    Public Sub Insert(ByVal index As Integer, ByVal value As Note)
        List.Insert(index, value)
    End Sub

    Public Sub Remove(ByVal value As Note)
        List.Remove(value)
    End Sub

    Public Function Contains(ByVal value As Note) As Boolean
        Return List.Contains(value)
    End Function

End Class