Public Class ServiceItem

    Private myServiceID As Integer
    Private myService As String
    Private myUnitPrice As Double
    Private myAttacheds As New AttachedCollection


#Region "Constructors"

    Public Sub New()
    End Sub

    Public Sub New(ByVal intServiceID As Integer)
        myServiceID = intServiceID
    End Sub

#End Region


#Region "Properties"

    Property ServiceID() As Integer
        Get
            Return myServiceID
        End Get
        Set(ByVal Value As Integer)
            myServiceID = Value
        End Set
    End Property

    Property Service() As String
        Get
            Return myService
        End Get
        Set(ByVal Value As String)
            myService = Value
        End Set
    End Property

    Property UnitPrice() As Double
        Get
            Return myUnitPrice
        End Get
        Set(ByVal Value As Double)
            myUnitPrice = Value
        End Set
    End Property

    Public Property Attacheds() As AttachedCollection
        Get
            Return myAttacheds
        End Get
        Set(ByVal Value As AttachedCollection)
            myAttacheds = Value
        End Set
    End Property

#End Region

End Class


Public Class ServiceItemCollection
    Inherits CollectionBase

    Default Public Property Item(ByVal index As Integer) As ServiceItem
        Get
            Return CType(List(index), ServiceItem)
        End Get
        Set(ByVal Value As ServiceItem)
            List(index) = Value
        End Set
    End Property

    Public Function Add(ByVal value As ServiceItem) As Integer
        Return List.Add(value)
    End Function

    Public Function IndexOf(ByVal value As ServiceItem) As Integer
        Return List.IndexOf(value)
    End Function

    Public Sub Insert(ByVal index As Integer, ByVal value As ServiceItem)
        List.Insert(index, value)
    End Sub

    Public Sub Remove(ByVal value As ServiceItem)
        List.Remove(value)
    End Sub

    Public Function Contains(ByVal value As ServiceItem) As Boolean
        Return List.Contains(value)
    End Function

End Class
