
Public Class User

#Region "private properties"

    Private myUserID As Integer
    Private myType As Integer
    Private myFullName As String
    Private myUserName As String
    Private myPassword As String
    Private myHomePhone As String
    Private myMobilePhone As String
    Private myFax As String
    Private myEmail As String
    Private myAddress As String
    Private myLocality As String
    Private myPostalCode As String
    Private myCountryCode As Integer
    Private myCountry As String
    Private myContributorNumber As String
    Private myUserExists As Boolean

    Private mySex As String
    Private myBirthDate As String
    Private myNationality As String
    Private myIdentityCard As String
    Private myInstitution As String
    Private myWorkAreaID As Integer
    Private myWorkArea As String
    Private myAcademicsHabID As Integer
    Private myAcademicsHab As String
    Private myProfessionID As Integer
    Private myProfession As String

    Private myContactName As String
    Private myActivityAreaID As Integer
    Private myActivityArea As String

#End Region
    

    Public Enum eUserType
        Individual
        Institutional
    End Enum

    Public Enum eBy
        UserName
        UserID
    End Enum

    Public Enum eCapacities
        Full
        Medium
        Minimum
    End Enum

#Region "Constructors"

    Public Sub New()
        'myUserID = ""
        'myFirstName = ""
        'myLastName = ""
        'myUserName = ""
        'myPassword = ""
        'myInstitution = ""
        'myHomePhone = ""
        'myMobilePhone = ""
        'myFax = ""
        'myEmail = ""
        'myAddress = ""
        'myLocality = ""
        'myPostalCode = ""
        'myCountry = ""
        'myNationality = ""
        'myIdentityCard = ""
        'myContributorNumber = ""
        'myProfession = ""
        'myWorkArea = ""
        'myConnStringCRAV = ConfigurationSettings.AppSettings("ConnStringCRAV")
    End Sub

    'Public Sub New(ByVal userID As Integer, ByVal password As String, ByVal Capacity As eCapacities)
    '    myUserID = userID
    '    Me.Password = password
    '    myCapacity = Capacity
    '    myBy = By.UserID
    '    'myConnStringCRAV = ConfigurationSettings.AppSettings("ConnStringCRAV")
    '    'Download()
    'End Sub

    'Public Sub New(ByVal userName As String, ByVal password As String, ByVal Capacity As eCapacities)
    '    myUserName = userName
    '    Me.Password = password
    '    myCapacity = Capacity
    '    myBy = By.UserName
    '    myConnStringCRAV = ConfigurationSettings.AppSettings("ConnStringCRAV")
    '    Download()
    'End Sub

#End Region


#Region "Properties"

    Property UserID() As Integer
        Get
            Return myUserID
        End Get
        Set(ByVal Value As Integer)
            myUserID = Value
        End Set
    End Property

    Property Type() As eUserType
        Get
            Return myType
        End Get
        Set(ByVal Value As eUserType)
            myType = Value
        End Set
    End Property

    Property FullName() As String
        Get
            Return myFullName
        End Get
        Set(ByVal Value As String)
            myFullName = Value
        End Set
    End Property

    Property UserName() As String
        Get
            Return myUserName
        End Get
        Set(ByVal Value As String)
            myUserName = Value
        End Set
    End Property

    Property Password() As String
        Get
            Return myPassword
        End Get
        Set(ByVal Value As String)
            myPassword = Encrypt.GenerateHash(Value)
        End Set
    End Property

    Property HomePhone() As String
        Get
            Return myHomePhone
        End Get
        Set(ByVal Value As String)
            myHomePhone = Value
        End Set
    End Property

    Property MobilePhone() As String
        Get
            Return myMobilePhone
        End Get
        Set(ByVal Value As String)
            myMobilePhone = Value
        End Set
    End Property

    Property Fax() As String
        Get
            Return myFax
        End Get
        Set(ByVal Value As String)
            myFax = Value
        End Set
    End Property

    Property Email() As String
        Get
            Return myEmail
        End Get
        Set(ByVal Value As String)
            myEmail = Value
        End Set
    End Property

    Property Address() As String
        Get
            Return myAddress
        End Get
        Set(ByVal Value As String)
            myAddress = Value
        End Set
    End Property

    Property Locality() As String
        Get
            Return myLocality
        End Get
        Set(ByVal Value As String)
            myLocality = Value
        End Set
    End Property

    Property PostalCode() As String
        Get
            Return myPostalCode
        End Get
        Set(ByVal Value As String)
            myPostalCode = Value
        End Set
    End Property

    Property CountryCode() As Integer
        Get
            Return myCountryCode
        End Get
        Set(ByVal Value As Integer)
            myCountryCode = Value
        End Set
    End Property

    Property Country() As String
        Get
            Return myCountry
        End Get
        Set(ByVal Value As String)
            myCountry = Value
        End Set
    End Property

    Property ContributorNumber() As String
        Get
            Return myContributorNumber
        End Get
        Set(ByVal Value As String)
            myContributorNumber = Value
        End Set
    End Property

    Property UserExists() As Boolean
        Get
            Return myUserExists
        End Get
        Set(ByVal Value As Boolean)
            myUserExists = Value
        End Set
    End Property

    Property Sex() As String
        Get
            Return mySex
        End Get
        Set(ByVal Value As String)
            mySex = Value
        End Set
    End Property

    Property BirthDate() As String
        Get
            Return myBirthDate
        End Get
        Set(ByVal Value As String)
            myBirthDate = Value
        End Set
    End Property

    Property Nationality() As String
        Get
            Return myNationality
        End Get
        Set(ByVal Value As String)
            myNationality = Value
        End Set
    End Property

    Property IdentityCard() As String
        Get
            Return myIdentityCard
        End Get
        Set(ByVal Value As String)
            myIdentityCard = Value
        End Set
    End Property

    Property Institution() As String
        Get
            Return myInstitution
        End Get
        Set(ByVal Value As String)
            myInstitution = Value
        End Set
    End Property

    Property WorkAreaID() As Integer
        Get
            Return myWorkAreaID
        End Get
        Set(ByVal Value As Integer)
            myWorkAreaID = Value
        End Set
    End Property

    Property WorkArea() As String
        Get
            Return myWorkArea
        End Get
        Set(ByVal Value As String)
            myWorkArea = Value
        End Set
    End Property

    Property AcademicsHabID() As Integer
        Get
            Return myAcademicsHabID
        End Get
        Set(ByVal Value As Integer)
            myAcademicsHabID = Value
        End Set
    End Property

    Property AcademicsHab() As String
        Get
            Return myAcademicsHab
        End Get
        Set(ByVal Value As String)
            myAcademicsHab = Value
        End Set
    End Property

    Property ProfessionID() As Integer
        Get
            Return myProfessionID
        End Get
        Set(ByVal Value As Integer)
            myProfessionID = Value
        End Set
    End Property

    Property Profession() As String
        Get
            Return myProfession
        End Get
        Set(ByVal Value As String)
            myProfession = Value
        End Set
    End Property

    Property ContactName() As String
        Get
            Return myContactName
        End Get
        Set(ByVal Value As String)
            myContactName = Value
        End Set
    End Property

    Property ActivityAreaID() As Integer
        Get
            Return myActivityAreaID
        End Get
        Set(ByVal Value As Integer)
            myActivityAreaID = Value
        End Set
    End Property

    Property ActivityArea() As String
        Get
            Return myActivityArea
        End Get
        Set(ByVal Value As String)
            myActivityArea = Value
        End Set
    End Property

#End Region



    'Private Sub Download()
    '    Select Case myBy
    '        Case eBy.UserID
    '            Select Case myCapacity
    '                Case eCapacities.Minimum : DounloadMinimumByUserID()
    '                Case eCapacities.Medium : DounloadMediumByUserID()
    '                Case eCapacities.Full : DounloadFullByUserID()
    '            End Select
    '        Case eBy.UserName
    '            Select Case myCapacity
    '                Case eCapacities.Minimum : DounloadMinimumByUsername()
    '                Case eCapacities.Medium : DounloadMediumByUserName()
    '                Case eCapacities.Full : DounloadFullByUserName()
    '            End Select
    '    End Select
    'End Sub

    'Private Sub DounloadMinimumByUserID()
    '    Dim cn As New SqlConnection
    '    cn.ConnectionString = myConnStringCRAV
    '    Dim strQuery As String = "SELECT userName FROM users WHERE userID =" & myUserID
    '    Dim cm As New SqlCommand
    '    Try
    '        cn.Open()
    '        cm.Connection = cn
    '        cm.CommandText = strQuery
    '        UserName = cm.ExecuteScalar()
    '    Catch ex As Exception

    '    Finally
    '        cn.Close()
    '    End Try
    'End Sub

    'Private Sub DounloadMediumByUserID()
    '    Dim cn As New SqlConnection
    '    cn.ConnectionString = myConnStringCRAV
    '    Dim strQuery As String
    '    strQuery = "SELECT Username, FirstName + ' ' + LastName as CompleteName "
    '    strQuery += "FROM users "
    '    strQuery += "WHERE UserID = " & myUserID & " AND Password ='" & myPassword & "'"
    '    Dim cm As New SqlCommand
    '    Dim dr As SqlDataReader
    '    Try
    '        cn.Open()
    '        cm.Connection = cn
    '        cm.CommandText = strQuery
    '        dr = cm.ExecuteReader
    '        If Not dr.HasRows Then
    '            UserExists = False
    '            Return
    '        Else
    '            UserExists = True
    '        End If
    '        While dr.Read
    '            UserName = dr.Item("Username")
    '            CompleteName = dr.Item("CompleteName")
    '        End While
    '    Catch ex As Exception

    '    Finally
    '        dr.Close()
    '        cn.Close()
    '    End Try
    'End Sub

    'Private Sub DounloadFullByUserID()

    'End Sub

    'Private Sub DounloadMinimumByUsername()
    '    Dim cn As New SqlConnection
    '    cn.ConnectionString = myConnStringCRAV
    '    Dim strQuery As String = "SELECT userID FROM users WHERE userName =" & myUserName
    '    Dim cm As New SqlCommand
    '    Try
    '        cn.Open()
    '        cm.Connection = cn
    '        cm.CommandText = strQuery
    '        Dim ret As Integer = cm.ExecuteScalar()
    '        UserID = ret
    '    Catch ex As Exception

    '    Finally
    '        cn.Close()
    '    End Try
    'End Sub

    'Private Sub DounloadMediumByUserName()
    '    Dim cn As New SqlConnection
    '    cn.ConnectionString = myConnStringCRAV
    '    Dim strQuery As String
    '    strQuery = "SELECT UserID, FirstName + ' ' + LastName as CompleteName "
    '    strQuery += "FROM users "
    '    strQuery += "WHERE UserName = '" & myUserName & "' AND Password ='" & myPassword & "'"
    '    Dim cm As New SqlCommand
    '    Dim dr As SqlDataReader
    '    Try
    '        cn.Open()
    '        cm.Connection = cn
    '        cm.CommandText = strQuery
    '        dr = cm.ExecuteReader
    '        If Not dr.HasRows Then
    '            UserExists = False
    '            Return
    '        Else
    '            UserExists = True
    '        End If
    '        While dr.Read
    '            UserID = dr.Item("UserID")
    '            CompleteName = dr.Item("CompleteName")
    '        End While
    '    Catch ex As Exception

    '    Finally
    '        dr.Close()
    '        cn.Close()
    '    End Try
    'End Sub

    'Private Sub DounloadFullByUserName()

    'End Sub

    'Public Function sqlInsertNewUser()
    '    Dim cn As New SqlConnection
    '    cn.ConnectionString = myConnStringCRAV
    '    Dim strQuery As String
    '    strQuery = "INSERT INTO users VALUES "
    '    strQuery += "("
    '    strQuery += "'" + myFirstName + "', "
    '    strQuery += "'" + myLastName + "', "
    '    strQuery += "'" + myUserName + "', "
    '    strQuery += "'" + myPassword + "', "
    '    strQuery += "'" + myInstitution + "', "
    '    strQuery += "'" + myHomePhone + "', "
    '    strQuery += "'" + myMobilePhone + "', "
    '    strQuery += "'" + myFax + "', "
    '    strQuery += "'" + myEmail + "', "
    '    strQuery += "'" + myAddress + "', "
    '    strQuery += "'" + myLocality + "', "
    '    strQuery += "'" + myPostalCode + "', "
    '    strQuery += CStr(myCountryCode) + ", "
    '    strQuery += "'" + myNationality + "', "
    '    strQuery += "'" + myIdentityCard + "', "
    '    strQuery += "'" + myContributorNumber + "', "
    '    strQuery += CStr(myProfessionID) + ", "
    '    strQuery += CStr(myWorkAreaID)
    '    strQuery += ")"
    '    Dim cm As New SqlCommand
    '    Try
    '        cn.Open()
    '        cm.Connection = cn
    '        cm.CommandText = strQuery
    '        cm.ExecuteNonQuery()
    '    Catch ex As Exception

    '    Finally
    '        cn.Close()
    '    End Try

    'End Function

    'Private Function sqlGetProfessionID() As Integer
    '    Dim cn As New SqlConnection
    '    cn.ConnectionString = myConnStringCRAV
    '    Dim strQuery As String = "SELECT ProfessionID FROM Professions WHERE Profession = '" & myProfession & "'"
    '    Dim cm As New SqlCommand
    '    Try
    '        cn.Open()
    '        cm.Connection = cn
    '        cm.CommandText = strQuery
    '        Return cm.ExecuteScalar()
    '    Catch ex As Exception

    '    Finally
    '        cn.Close()
    '    End Try
    'End Function

    'Private Function sqlGetWorkAreaID() As Integer
    '    Dim cn As New SqlConnection
    '    cn.ConnectionString = myConnStringCRAV
    '    Dim strQuery As String = "SELECT WorkAreaID FROM WorkAreas WHERE WorkArea = '" & myWorkArea & "'"
    '    Dim cm As New SqlCommand
    '    Try
    '        cn.Open()
    '        cm.Connection = cn
    '        cm.CommandText = strQuery
    '        Return cm.ExecuteScalar()
    '    Catch ex As Exception

    '    Finally
    '        cn.Close()
    '    End Try
    'End Function

    'Private Function sqlGetCountryID() As Integer
    '    Dim cn As New SqlConnection
    '    cn.ConnectionString = myConnStringCRAV
    '    Dim strQuery As String = "SELECT CountryCode FROM Countries WHERE CountryName = '" & myCountry & "'"
    '    Dim cm As New SqlCommand
    '    Try
    '        cn.Open()
    '        cm.Connection = cn
    '        cm.CommandText = strQuery
    '        Return cm.ExecuteScalar()
    '    Catch ex As Exception

    '    Finally
    '        cn.Close()
    '    End Try
    'End Function

End Class
