Imports System.Data.SqlClient

Public Class DigitarqInfo


#Region "Properties"

    Private myConnStringCRAV As String
    Private myConnStringDigitarq As String
    Private myConnStringGOD As String
    Private myRef As String

    Private myID As Int64
    Private myOtherLevel As String
    Private myReference As String
    Private myUnitTitleF As String
    Private myUnitTitleSF As String
    Private myUnitTitleSC As String
    Private myUnitTitleSSC As String
    Private myUnitTitleSSSC As String
    Private myUnitTitleSR As String
    Private myUnitTitleSSR As String
    Private myUnitTitleUI As String
    Private myUnitTitleDC As String
    Private myUnitTitleD As String
    Private myPhysLoc As String
    Private myAltFormAvail As String
    Private myUnitDateInitial As String
    Private myUnitDateInitialCertainty As Boolean
    Private myUnitDateFinal As String
    Private myUnitDateFinalCertainty As Boolean
    Private myNoExistsRef As Boolean
    Private myDigitalObjectExists As Boolean
    Private myDOCollection As New DOCollection

#End Region

#Region "Inicializations"

    Public Sub New()
    End Sub

#End Region

#Region "Gets and Sets of Public Properties"

    Public Property ID() As String
        Get
            Return myID
        End Get
        Set(ByVal Value As String)
            myID = Value
        End Set
    End Property

    Public Property OtherLevel() As String
        Get
            Return myOtherLevel
        End Get
        Set(ByVal Value As String)
            myOtherLevel = Value
        End Set
    End Property

    Public Property Reference() As String
        Get
            Return myReference
        End Get
        Set(ByVal Value As String)
            myReference = Value
        End Set
    End Property

    Public Property UnitTitleF() As String
        Get
            Return myUnitTitleF
        End Get
        Set(ByVal Value As String)
            myUnitTitleF = Value
        End Set
    End Property

    Public Property UnitTitleSF() As String
        Get
            Return myUnitTitleSF
        End Get
        Set(ByVal Value As String)
            myUnitTitleSF = Value
        End Set
    End Property

    Public Property UnitTitleSC() As String
        Get
            Return myUnitTitleSC
        End Get
        Set(ByVal Value As String)
            myUnitTitleSC = Value
        End Set
    End Property

    Public Property UnitTitleSSC() As String
        Get
            Return myUnitTitleSSC
        End Get
        Set(ByVal Value As String)
            myUnitTitleSSC = Value
        End Set
    End Property

    Public Property UnitTitleSSSC() As String
        Get
            Return myUnitTitleSSSC
        End Get
        Set(ByVal Value As String)
            myUnitTitleSSSC = Value
        End Set
    End Property

    Public Property UnitTitleSR() As String
        Get
            Return myUnitTitleSR
        End Get
        Set(ByVal Value As String)
            myUnitTitleSR = Value
        End Set
    End Property

    Public Property UnitTitleSSR() As String
        Get
            Return myUnitTitleSSR
        End Get
        Set(ByVal Value As String)
            myUnitTitleSSR = Value
        End Set
    End Property

    Public Property UnitTitleUI() As String
        Get
            Return myUnitTitleUI
        End Get
        Set(ByVal Value As String)
            myUnitTitleUI = Value
        End Set
    End Property

    Public Property UnitTitleDC() As String
        Get
            Return myUnitTitleDC
        End Get
        Set(ByVal Value As String)
            myUnitTitleDC = Value
        End Set
    End Property

    Public Property UnitTitleD() As String
        Get
            Return myUnitTitleD
        End Get
        Set(ByVal Value As String)
            myUnitTitleD = Value
        End Set
    End Property

    Public Property PhysLoc() As String
        Get
            Return myPhysLoc
        End Get
        Set(ByVal Value As String)
            myPhysLoc = Value
        End Set
    End Property

    Public Property UnitDateInitial() As String
        Get
            Return myUnitDateInitial
        End Get
        Set(ByVal Value As String)
            myUnitDateInitial = Value
        End Set
    End Property

    Public Property UnitDateInitialCertainty() As Boolean
        Get
            Return myUnitDateInitialCertainty
        End Get
        Set(ByVal Value As Boolean)
            myUnitDateInitialCertainty = Value
        End Set
    End Property

    Public Property UnitDateFinal() As String
        Get
            Return myUnitDateFinal
        End Get
        Set(ByVal Value As String)
            myUnitDateFinal = Value
        End Set
    End Property

    Public Property DaoGrp() As DOCollection
        Get
            Return myDOCollection
        End Get
        Set(ByVal Value As DOCollection)
            myDOCollection = Value
        End Set
    End Property

    Public Property UnitDateFinalCertainty() As Boolean
        Get
            Return myUnitDateFinalCertainty
        End Get
        Set(ByVal Value As Boolean)
            myUnitDateFinalCertainty = Value
        End Set
    End Property

    Public Property AltFormAvail() As String
        Get
            Return myAltFormAvail
        End Get
        Set(ByVal Value As String)
            myAltFormAvail = Value
        End Set
    End Property

    Public Property NoExistsRef() As Boolean
        Get
            Return myNoExistsRef
        End Get
        Set(ByVal Value As Boolean)
            myNoExistsRef = Value
        End Set
    End Property

    Public Property DigitalObjectExists() As Boolean
        Get
            Return myDigitalObjectExists
        End Get
        Set(ByVal Value As Boolean)
            myDigitalObjectExists = Value
        End Set
    End Property

#End Region

End Class

#Region "Class DigitalObject"

Public Class DigitalObject

    Private myComponentID As Int64
    Private myDigitalObjectID As Int64
    Private myDigitalObjectName As String
    Private myFileID As Int64
    Private myFileName As String
    Private myType As Int16
    Private myArchiveID As String
    Private myTopographicalQuota As String
    Private myNumImages As Integer


    Public Sub New()
    End Sub

    Public Sub New(ByVal ComponentID As Int64, ByVal DigitalObjectID As Int64, ByVal FileID As Int64, ByVal Type As Int16)
        myComponentID = ComponentID
        myDigitalObjectID = DigitalObjectID
        myFileID = FileID
        myType = Type
    End Sub

    Property ComponentID() As Int64
        Get
            Return myComponentID
        End Get
        Set(ByVal Value As Int64)
            myComponentID = Value
        End Set
    End Property

    Property DigitalObjectID() As Int64
        Get
            Return myDigitalObjectID
        End Get
        Set(ByVal Value As Int64)
            myDigitalObjectID = Value
        End Set
    End Property

    Property DigitalObjectName() As String
        Get
            Return myDigitalObjectName
        End Get
        Set(ByVal Value As String)
            myDigitalObjectName = Value
        End Set
    End Property

    Property FileID() As Int64
        Get
            Return myFileID
        End Get
        Set(ByVal Value As Int64)
            myFileID = Value
        End Set
    End Property

    Property FileName() As String
        Get
            Return myFileName
        End Get
        Set(ByVal Value As String)
            myFileName = Value
        End Set
    End Property

    Property Type() As Int16
        Get
            Return myType
        End Get
        Set(ByVal Value As Int16)
            myType = Value
        End Set
    End Property

    Property ArchiveID() As String
        Get
            Return myArchiveID
        End Get
        Set(ByVal Value As String)
            myArchiveID = Value
        End Set
    End Property

    Property TopographicalQuota() As String
        Get
            Return myTopographicalQuota
        End Get
        Set(ByVal Value As String)
            myTopographicalQuota = Value
        End Set
    End Property

    Property NumImages() As Integer
        Get
            Return myNumImages
        End Get
        Set(ByVal Value As Integer)
            myNumImages = Value
        End Set
    End Property

    Public Function Clone() As Object
        Return New DigitalObject(myComponentID, myDigitalObjectID, myFileID, myType)
    End Function

End Class

#End Region


#Region "Class DOCollection"

Public Class DOCollection
    Inherits CollectionBase

    Default Public Property Item(ByVal index As Integer) As DigitalObject
        Get
            Return CType(List(index), DigitalObject)
        End Get
        Set(ByVal Value As DigitalObject)
            List(index) = Value
        End Set
    End Property


    Public Function Add(ByVal value As DigitalObject) As Integer
        Return List.Add(value)
    End Function 'Add

    Public Function IndexOf(ByVal value As DigitalObject) As Integer
        Return List.IndexOf(value)
    End Function 'IndexOf

    Public Sub Insert(ByVal index As Integer, ByVal value As DigitalObject)
        List.Insert(index, value)
    End Sub 'Insert

    Public Sub Remove(ByVal value As DigitalObject)
        List.Remove(value)
    End Sub 'Remove

    Public Function Contains(ByVal value As DigitalObject) As Boolean
        Return List.Contains(value)
    End Function 'Contains

End Class

#End Region
