Public Class Path
    Inherits BaseClassP

    Public Enum eOtherLevel
        DorDC
        UI
    End Enum

    Public Enum eFrom
        Search
        Reference
        Form
    End Enum

    Public Enum eRequestType
        Parochial
        Notarial
        Other
    End Enum

    Private bolRepReqStep1 As Boolean
    Private bolRepReqStep2 As Boolean
    Private bolRepReqStep3 As Boolean

    Private myOtherLevel As eOtherLevel
    Private myFrom As eFrom
    Private myRequestType As eRequestType

#Region "Constructors"

    'Public Sub New(ByVal from As String)
    '    myFrom = intComesOf(from)
    'End Sub

    Public Sub New()
    End Sub

#End Region

#Region "Properties"

    Property RepReqStep1() As Boolean
        Get
            Return bolRepReqStep1
        End Get
        Set(ByVal Value As Boolean)
            bolRepReqStep1 = Value
        End Set
    End Property

    Property RepReqStep2() As Boolean
        Get
            Return bolRepReqStep2
        End Get
        Set(ByVal Value As Boolean)
            bolRepReqStep2 = Value
        End Set
    End Property

    Property RepReqStep3() As Boolean
        Get
            Return bolRepReqStep3
        End Get
        Set(ByVal Value As Boolean)
            bolRepReqStep3 = Value
        End Set
    End Property

    Property OtherLevel() As eOtherLevel
        Get
            Return myOtherLevel
        End Get
        Set(ByVal Value As eOtherLevel)
            myOtherLevel = Value
        End Set
    End Property

    Property From() As eFrom
        Get
            Return myFrom
        End Get
        Set(ByVal Value As eFrom)
            myFrom = Value
        End Set
    End Property

    Property RequestType() As eRequestType
        Get
            Return myRequestType
        End Get
        Set(ByVal Value As eRequestType)
            myRequestType = Value
        End Set
    End Property

#End Region

#Region "Functions"

    'Private Function intComesOf(ByVal from As String) As eFrom
    '    If from = "pesquisa" Then
    '        myFrom = eFrom.Search
    '    ElseIf from = "refIP" Then
    '        myFrom = eFrom.Reference
    '    Else
    '        myFrom = eFrom.Form
    '    End If
    '    Return myFrom
    'End Function

    'Public Function intRequestType(ByVal strReq As String) As eRequestType
    '    If strReq = "prc" Then
    '        myRequestType = eRequestType.Parochial
    '    ElseIf strReq = "not" Then
    '        myRequestType = eRequestType.Notarial
    '    Else
    '        myRequestType = eRequestType.Other
    '    End If
    '    Return myRequestType
    'End Function

    Public Function getRequestType(ByVal strReq As String) As eRequestType
        If strReq.ToUpper.StartsWith(GetConfig("CountryCode") + "/" + GetConfig("RepositoryCode") + "/" + "PRQ") Then
            myRequestType = eRequestType.Parochial
        ElseIf strReq.ToUpper.StartsWith(GetConfig("CountryCode") + "/" + GetConfig("RepositoryCode") + "/" + "NOT") Then
            myRequestType = eRequestType.Notarial
        Else
            myRequestType = eRequestType.Other
        End If
        Return myRequestType
    End Function

#End Region

End Class


