
Imports System
Imports System.Collections
Imports System.Collections.Specialized
Imports System.Data.SqlClient

'********************************************************************************
' Module: mDataBase
' Purpose: This module treats all input data in order to creates the query
'           according to the user (input) needs.
'           It starts by read and stores all text from the textboxes, then
'           the build the query string and finally returns the query results.
'*********************************************************************************

Module mDataBase


    '***************************************************************************
    ' Function: strConvDateInitial
    ' Purpose: Once the date fields in the db ( DigitArq database) are string type 
    '          is necessary to convert the date to the string db format.
    '***************************************************************************
    'Public Function strConvDateInitial(ByVal year As String, ByVal month As String, ByVal day As String) As String
    '    year = year.PadLeft(4, "0")
    '    'If month = "" Then
    '    'month = "01"
    '    'Else
    '    month = month.PadLeft(2, "0")
    '    'End If
    '    'If day = "" Then
    '    'day = "01"
    '    'Else
    '    day = day.PadLeft(2, "0")
    '    'End If
    '    Return year & "-" & month & "-" & day

    'End Function


    '*****************************************************************************
    ' Function: strConvDateFinal
    ' Purpose: Once the date fields in the db ( DigitArq database) are string type 
    '          is necessary to convert the date to the string db format.
    '******************************************************************************

    'Public Function strConvDateFinal(ByVal year As String, ByVal month As String, ByVal day As String) As String

    '    If year = "" Then
    '        year = "9999"
    '        If day = "" Then
    '            day = "00"
    '        Else
    '            day = day
    '        End If
    '        If month = "" Then
    '            month = "00"
    '        Else
    '            month = month
    '        End If
    '    Else
    '        year = year.PadLeft(4, "0")
    '        If day = "" Then
    '            day = "31"
    '        Else
    '            day = day
    '        End If
    '        If month = "" Then
    '            month = "12"
    '        Else
    '            month = month
    '        End If
    '    End If
    '    Return year & "-" & month & "-" & day

    'End Function


    '*************************************************************************************
    ' Function: StrDateRange
    ' Purpose: Returns query Str(ing) for the date range. This part of search condition 
    '           restricts the query results for a date range.
    '*************************************************************************************
    'Public Function strDateRange(ByVal UnitDateInitialValue As String, ByVal UnitDateFinalValue As String) As String

    '    Dim strSet1 As String
    '    Dim strSet2 As String

    '    strSet1 = "(UnitDateFinal<='" & UnitDateFinalValue & "' and UnitDateFinal >= '" & UnitDateInitialValue & _
    '              "' and (UnitDateInitial='0000-00-00' or UnitDateInitial='') )"
    '    strSet2 = "(UnitDateInitial>='" & UnitDateInitialValue & "' and UnitDateFinal<='" & UnitDateFinalValue & "' and UnitDateInitial<='" & UnitDateFinalValue & "' )"

    '    Return strSet1 & " or " & strSet2 & " "

    'End Function


    'Public Function sclUnitDateInitial(ByVal sclCurQry As StringCollection, ByVal hash As Hashtable, ByVal strKeyCur As String) As StringCollection

    '    Dim a() As String = hash(strKeyCur).Split("-")
    '    Dim dateFinal, dateInitial As String


    '    If (a(0) = "0000" And (a(1) <> "00" Or a(2) <> "00")) Then
    '        If (a(2) = "00") Then
    '            sclCurQry.Add("(UnitDateInitial like '____-" & a(1) & "-__' )")
    '        ElseIf (a(1) = "00") Then
    '            sclCurQry.Add("(UnitDateInitial like '____-__-" & a(2) & "' )")
    '        Else
    '            sclCurQry.Add("(UnitDateInitial like '____-" & a(1) & "-" & a(2) & "' )")
    '        End If
    '    ElseIf hash.ContainsKey("UnitDateFinal") Then
    '        sclCurQry.Add("(" & strDateRange(hash("UnitDateInitial"), hash("UnitDateFinal")) & ")")
    '    ElseIf (a(0) <> "0000" And (a(1) = "00" Or a(2) = "00")) Then
    '        sclCurQry.Add("( UnitDateInitial >= '" & hash(strKeyCur) & "' )")
    '        sclCurQry.Add("( UnitDateFinal >= '" & hash(strKeyCur) & "' or UnitDateFinal='' or UnitDateFinal='0000-00-00')")
    '    Else
    '        sclCurQry.Add("(UnitDateInitial = '" & hash("UnitDateInitial") & "')")
    '    End If

    '    Return sclCurQry
    'End Function


    'Public Function sclUnitDateFinal(ByVal sclCurQry As StringCollection, ByVal hash As Hashtable, ByVal strKeyCur As String) As StringCollection

    '    Dim a() As String = hash(strKeyCur).Split("-")

    '    If Not hash.ContainsKey("UnitDateInitial") Then

    '        If (a(0) = "9999" And (a(1) <> "00" Or a(2) <> "00")) Then
    '            If (a(2) = "00") Then
    '                sclCurQry.Add("(UnitDateFinal like '____-" & a(1) & "-__' )")
    '            ElseIf (a(1) = "00") Then
    '                sclCurQry.Add("(UnitDateFinal like '____-__-" & a(2) & "' )")
    '            Else
    '                sclCurQry.Add("(UnitDateFinal like '____-" & a(1) & "-" & a(2) & "' )")
    '            End If
    '        Else
    '            sclCurQry.Add("( UnitDateFinal <= '" & hash(strKeyCur) & "' and UnitDateInitial <= '" & hash(strKeyCur) & "')")
    '        End If
    '    End If

    '    Return sclCurQry
    'End Function


    '******************************************************************************
    ' Function: blnIsValid
    ' Purpose: Returns true if isn't a empty ("") string if not returns false
    '******************************************************************************
    'Public Function blnIsValid(ByVal Text As String) As Boolean
    '    Return Text <> ""
    'End Function


    '*************************************************************************************
    ' Function: objQryRecs
    ' Purpose: It returns all the Rec(ord)s ID's derived from the 
    '          sql Q(ue)ry(- gotten for the entrance of text,
    '          given for the user in textboxes, that it is related with the columns of the 
    '          components table)
    '*************************************************************************************
    'Public Function objQryRecs(ByVal query As String, ByVal imagesOnly As Boolean)

    '    Dim strCmdText As String ' Com(an)d Text, sqlQuery

    '    Dim SQLConnection As SqlConnection = New SqlConnection
    '    SQLConnection.ConnectionString = ConfigurationSettings.AppSettings("ConnStringDigitArq")

    '    Dim SQLCommand As New SqlCommand
    '    SQLCommand.Connection = SQLConnection

    '    Dim DataReader As SqlDataReader

    '    If imagesOnly Then
    '        strCmdText = "select ID from components, daogrp " & query
    '    Else
    '        strCmdText = "select ID from components " & query
    '    End If

    '    SQLConnection.Open()
    '    SQLCommand.CommandText = String.Format(strCmdText)
    '    DataReader = SQLCommand.ExecuteReader()
    '    ' Dim IDList As New RecordsIDCollection
    '    Dim IDList As New RecordsIDCollection


    '    While DataReader.Read()

    '        IDList.Add(DataReader.Item("ID"))
    '    End While
    '    SQLConnection.Close()
    '    DataReader.Close()
    '    Return IDList

    'End Function


    '*************************************************************************************
    ' Function: objQryRecsOrderBy
    ' Purpose: It returns all the IDs registers derived from the 
    '          sql query (- given for the text, introduced for the user in textboxes,
    '          that it is related with the columns of the table of the components) 
    '          in a given order (strOrderBy).
    '*************************************************************************************
    'Public Function objQryRecsOrderBy(ByVal strComponentQry As String, ByVal strOrderBy As String) As RecordsIDCollection

    '    Dim strCmdQry As String

    '    Dim SQLConnection As SqlConnection = New SqlConnection
    '    SQLConnection.ConnectionString = ConfigurationSettings.AppSettings("ConnStringDigitArq")

    '    Dim SQLCommand As New SqlCommand
    '    SQLCommand.Connection = SQLConnection

    '    Dim DataReader As SqlDataReader

    '    Select Case strOrderBy
    '        Case "t_a"
    '            strCmdQry &= "select ID from components  " & strComponentQry & " ORDER BY UnitTitle ASC"
    '        Case "t_d"
    '            strCmdQry &= "select ID from components   " & strComponentQry & " ORDER BY UnitTitle DESC"
    '        Case "d_a"
    '            strCmdQry &= "select ID from components  " & strComponentQry & " ORDER BY UnitDateInitial ASC"

    '        Case "d_d"
    '            strCmdQry &= "select ID from components   " & strComponentQry & " ORDER BY UnitDateInitial DESC"
    '        Case "l_a"
    '            strCmdQry = strOrderByOtherLevelASCQry(strComponentQry)
    '        Case "l_d"
    '            strCmdQry = strOrderByOtherLevelDESCQry(strComponentQry)
    '    End Select


    '    SQLConnection.Open()
    '    SQLCommand.CommandText = String.Format(strCmdQry)
    '    DataReader = SQLCommand.ExecuteReader()

    '    Dim IDList As New RecordsIDCollection

    '    While DataReader.Read()
    '        IDList.Add(DBToInt(DataReader.Item("ID")))
    '    End While
    '    SQLConnection.Close()
    '    DataReader.Close()

    '    Return IDList

    'End Function


    '*************************************************************************************
    ' Function: sdrOrderByOtherLevelASCQry
    ' Purpose: It returns a String commandText query for order the results from OtherLevel='F'
    '     OtherLevel='D'. I call it ascendant way.
    '*************************************************************************************
    'Private Function strOrderByOtherLevelASCQry(ByVal strSubQry As String) As String
    '    Dim strOtherLevelAscOrder() As String = {"F", "SF", "SC", "SSC", "SSSC", "SR", "SSR", "UI", "DC", "D"}
    '    Dim strVariables() As String = {"x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10"}
    '    Dim i As Integer
    '    Dim strOtherLevelASCQry As String

    '    For i = 1 To 10
    '        strOtherLevelASCQry &= "( select " & i & " as Coln1," & strVariables(i - 1) & ".ID," & strVariables(i - 1) & _
    '        ".OtherLevel from (select ID,OtherLevel from components as C " & strSubQry & ") as " & strVariables(i - 1) & " where OtherLevel='" & _
    '         strOtherLevelAscOrder(i - 1) & "')union"
    '    Next

    '    strOtherLevelASCQry = strOtherLevelASCQry.TrimEnd(CStr(")union").ToCharArray)
    '    strOtherLevelASCQry = "select xfnl.ID from (" & strOtherLevelASCQry & "))as xfnl order By Coln1"
    '    Return strOtherLevelASCQry

    'End Function


    '*************************************************************************************
    ' Function: sdrOrderByOtherLevelDESCQry
    ' Purpose: It returns a String commandText query for order the results from OtherLevel='D'
    '     OtherLevel='F'. I call it decreasing way.

    '*************************************************************************************
    'Private Function strOrderByOtherLevelDESCQry(ByVal strSubQry As String) As String
    '    Dim strOtherLevelDescOrder() As String = {"D", "DC", "UI", "SSR", "SR", "SSSC", "SSC", "SC", "SF", "F"}
    '    Dim strVariables() As String = {"x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10"}
    '    Dim i As Integer
    '    Dim strOtherLevelDESCQry As String

    '    For i = 1 To 10
    '        strOtherLevelDESCQry &= "( select " & i & " as Coln1," & strVariables(i - 1) & ".ID," & strVariables(i - 1) & _
    '        ".OtherLevel from (select ID,OtherLevel from components as C " & strSubQry & ") as " & strVariables(i - 1) & " where OtherLevel='" & _
    '        strOtherLevelDescOrder(i - 1) & "')union"
    '    Next

    '    strOtherLevelDESCQry = strOtherLevelDESCQry.TrimEnd(CStr(")union").ToCharArray)
    '    strOtherLevelDESCQry = "select xfnl.ID from (" & strOtherLevelDESCQry & "))as xfnl order By Coln1"
    '    Return strOtherLevelDESCQry

    'End Function


    '*************************************************************************************
    ' Function: strRemoveText
    ' Purpose: It returns a String with all the removed inconvenient characters.
    '*************************************************************************************
    Public Function strRemoveText(ByVal Text As String) As String

        Text = Text.Replace("<", "")
        Text = Text.Replace(">", "")
        Text = Text.Replace("&", "")
        Text = Text.Replace("%", "")
        Text = Text.Replace("(", "")
        Text = Text.Replace(")", "")
        Text = Text.Replace("[", "")
        Text = Text.Replace("]", "")
        Text = Text.Replace(";", "")
        Text = Text.Replace("'", "")
        'Text = Text.Replace(Chr(34), "")
        Text = Text.Replace("#", "")
        Return Text.ToUpper

    End Function


    '*************************************************************************************
    ' Function: strReadInputText
    ' Purpose: It returns a String with all the removed inconvenient characters and all "\"
    '          characters replaced by "/". It is only necessary for the completeUnitId.
    '*************************************************************************************

    Public Function strReadReference(ByVal strInputText As String, ByVal strPrefixRef As String) As String

        If strInputText.StartsWith(strPrefixRef) Then
            strInputText = strInputText.Replace(strPrefixRef, "")
        End If
        strInputText = strInputText.Replace("\", "/")
        strInputText = strRemoveText(strInputText)

        Return strInputText
    End Function


    '*************************************************************************************
    ' Function: strGetTextFromTxt
    ' Purpose: It gets text from a txtbox control.
    '*************************************************************************************
    Public Function strGetTextFromTxt(ByVal txtControl As System.Web.UI.Control) As String
        Dim text As String
        If TypeOf txtControl Is TextBox Then
            Dim textbox As TextBox = CType(txtControl, TextBox)
            text = textbox.Text
        End If
        Return text
    End Function


    '*************************************************************************************
    ' Function: strRemoveWords
    ' Purpose: It removes all usual short words like 'para', etc. 
    '          This words are unwanted for the or condition in a query.
    '*************************************************************************************
    Public Function strRemoveWords(ByVal strInpText As String) As String()

        Dim sclAllQryWords As New StringCollection

        Dim strTemp() As String
        Dim i, j As Integer
        j = 0
        strInpText.Trim()

        If strInpText.Equals("") Then
            Return New String() {""}
        End If

        strTemp = Split(strInpText)
        For i = 0 To strTemp.Length - 1
            If strTemp(i).Length > 1 Then
                Select Case strTemp(i).ToLower
                    Case ""
                        Exit Select
                    Case "de"
                        Exit Select
                    Case "do"
                        Exit Select
                    Case "da"
                        Exit Select
                    Case "dos"
                        Exit Select
                    Case "das"
                        Exit Select
                    Case "os"
                        Exit Select
                    Case "as"
                        Exit Select
                    Case "ou"
                        Exit Select
                    Case "que"
                        Exit Select
                    Case "pela"
                        Exit Select
                    Case "pelo"
                        Exit Select
                    Case "com"
                        Exit Select
                    Case "sem"
                        Exit Select
                    Case "um"
                        Exit Select
                    Case "uns"
                        Exit Select
                    Case "uma"
                        Exit Select
                    Case "umas"
                        Exit Select
                    Case "seu"
                        Exit Select
                    Case "sua"
                        Exit Select
                    Case "mais"
                        Exit Select
                    Case "mas"
                        Exit Select
                    Case "menos"
                        Exit Select
                    Case "pelas"
                        Exit Select
                    Case "pelos"
                        Exit Select
                    Case "em"
                        Exit Select
                    Case "por"
                        Exit Select
                    Case "in"
                        Exit Select
                    Case "no"
                        Exit Select
                    Case "nos"
                        Exit Select
                    Case "na"
                        Exit Select
                    Case "nas"
                        Exit Select
                    Case "outros"
                        Exit Select
                    Case "como"
                        Exit Select
                    Case "s"
                        Exit Select
                    Case "n"
                        Exit Select
                    Case "1"
                        Exit Select
                    Case "2"
                        Exit Select
                    Case "3"
                        Exit Select
                    Case "4"
                        Exit Select
                    Case "5"
                        Exit Select
                    Case "6"
                        Exit Select
                    Case "7"
                        Exit Select
                    Case "8"
                        Exit Select
                    Case "9"
                        Exit Select
                    Case "10"
                        Exit Select
                    Case "1"
                        Exit Select
                    Case "2"
                        Exit Select
                    Case "3"
                        Exit Select
                    Case "4"
                        Exit Select
                    Case "5"
                        Exit Select
                    Case "6"
                        Exit Select
                    Case "7"
                        Exit Select
                    Case "8"
                        Exit Select
                    Case "9"
                        Exit Select
                    Case "10"
                        Exit Select
                    Case "ms"
                        Exit Select
                    Case "i"
                        Exit Select
                    Case "ii"
                        Exit Select
                    Case "iii"
                        Exit Select
                    Case "iv"
                        Exit Select
                    Case "v"
                        Exit Select
                    Case "vi"
                        Exit Select
                    Case "vii"
                        Exit Select
                    Case "viii"
                        Exit Select
                    Case "xix"
                        Exit Select
                    Case "x"
                        Exit Select
                    Case "xi"
                        Exit Select
                    Case "xii"
                        Exit Select
                    Case "xiii"
                        Exit Select
                    Case "xiv"
                        Exit Select
                    Case "xv"
                        Exit Select
                    Case strTemp(i).StartsWith("xv")
                        Exit Select
                    Case strTemp(i).StartsWith("xx")
                        Exit Select
                    Case "se"
                        Exit Select
                    Case Else
                        sclAllQryWords.Add(strTemp(i))
                End Select
            End If
        Next
        Dim strAllQryWords(sclAllQryWords.Count - 1) As String
        sclAllQryWords.CopyTo(strAllQryWords, 0)
        Return strAllQryWords
    End Function


End Module
