Imports CRAVDataBaseAccess

Public Class uc_reproductionStep1
    Inherits BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents txtRef As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtTitleF As System.Web.UI.WebControls.TextBox
    Protected WithEvents pnlReg As System.Web.UI.WebControls.Panel
    Protected WithEvents repTitles As System.Web.UI.WebControls.Repeater
    Protected WithEvents pnlTitles As System.Web.UI.WebControls.Panel
    Protected WithEvents rdblType As System.Web.UI.WebControls.RadioButtonList
    Protected WithEvents imgBttnGo As System.Web.UI.WebControls.ImageButton
    Protected WithEvents summary As System.Web.UI.WebControls.ValidationSummary
    Protected WithEvents reRef As System.Web.UI.WebControls.RegularExpressionValidator
    Protected WithEvents hlnkCancel As System.Web.UI.WebControls.HyperLink
    Protected WithEvents bttnNext As System.Web.UI.WebControls.Button
    Protected WithEvents rdblOptions As System.Web.UI.WebControls.RadioButtonList
    Protected WithEvents pnlOptions As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlReference As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlRequest As System.Web.UI.WebControls.Panel
    Protected WithEvents hlnkBack As System.Web.UI.WebControls.HyperLink
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lblOptions As System.Web.UI.WebControls.Label
    Protected WithEvents lblReference As System.Web.UI.WebControls.Label
    Protected WithEvents lblReqType As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Public ListSteps As String

    Private objI As New SQLDataBase
    Private objPath As New Path

    'Private PrefRef As String = GetConfig("PrefRef") & "/"
    'Private lenPref As Integer = PrefRef.Length


    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        If Not Me.Page.IsPostBack Then
            Me.hlnkBack.Text = GetLabel("lnkbBack")
            Me.hlnkBack.ToolTip = GetLabel("lnkbBack")
            Me.hlnkCancel.Text = GetLabel("lnkbCancel")
            Me.hlnkCancel.ToolTip = GetLabel("lnkbCancel")
            Me.bttnNext.Text = GetLabel("lnkbNext")
            Me.bttnNext.ToolTip = GetLabel("lnkbNext")

            Me.hlnkBack.NavigateUrl = "javascript:history.back();"
            Me.hlnkCancel.NavigateUrl = GetConfig("InitialPageUrl")

            Me.txtRef.Text = GetConfig("CountryCode") + "/" + GetConfig("RepositoryCode") + "/"
            Me.lblError.Visible = True
            Me.Session.Remove("requestType")

            Me.rdblOptions.Items(0).Text = GetLabel("FO.repReq1.rdblOptions0")
            Me.rdblOptions.Items(1).Text = GetLabel("FO.repReq1.rdblOptions1")
            Me.rdblOptions.Items(2).Text = GetLabel("FO.repReq1.rdblOptions2")

            Me.rdblType.Items(0).Text = GetLabel("FO.repReq1.rdblType0")
            Me.rdblType.Items(1).Text = GetLabel("FO.repReq1.rdblType1")
            Me.rdblType.Items(2).Text = GetLabel("FO.repReq1.rdblType2")
        End If
        
    End Sub

    Private Sub bttnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnNext.Click
        If Me.pnlReference.Visible Then
            Dim strReference As String = Me.txtRef.Text.Trim
            Dim strOtherLevel As String = objI.getOtherLevel(strReference)

            Select Case strOtherLevel
                Case "DC", "D"
                    ReproductionRequest = New ReproductionRequest
                    ReproductionRequest.DigitarqInfo = objI.loadDigitarqInfo(strReference)

                    objPath.From = Path.eFrom.Reference
                    objPath.OtherLevel = Path.eOtherLevel.DorDC
                    objPath.RequestType = objPath.getRequestType(strReference)
                    Path = objPath

                    Me.Response.Redirect("defaultIn.aspx?page=repReq&step=3")
                Case "UI"
                    ReproductionRequest = New ReproductionRequest
                    ReproductionRequest.DigitarqInfo = objI.loadDigitarqInfo(strReference)

                    objPath.From = Path.eFrom.Reference
                    objPath.OtherLevel = Path.eOtherLevel.UI
                    objPath.RequestType = objPath.getRequestType(strReference)
                    Path = objPath

                    Me.Response.Redirect("defaultIn.aspx?page=repReq&step=2")
                Case Else
                    Me.lblError.Visible = True
                    Me.lblError.Text = String.Format(GetLabel("BO.repReq1.lblAlert1"), "<br>")
            End Select
        End If
    End Sub

    Private Sub rdblOptions_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdblOptions.SelectedIndexChanged
        Select Case Me.rdblOptions.SelectedValue
            Case "reference"
                Me.pnlOptions.Visible = True
                Me.pnlReference.Visible = True
                Me.pnlRequest.Visible = False
                Me.hlnkBack.Visible = True
            Case "form"
                Me.pnlOptions.Visible = True
                Me.pnlRequest.Visible = True
                Me.pnlReference.Visible = False
                Me.hlnkBack.Visible = True
            Case "search"
                Me.Response.Redirect("default.aspx?page=basicSearch&searchMode=bs")
        End Select
    End Sub

    Private Sub rdblType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdblType.SelectedIndexChanged
        If Me.rdblOptions.SelectedValue = "form" Then
            Dim strType As String = Me.rdblType.SelectedValue
            objPath.From = Path.eFrom.Form
            objPath.RequestType = Me.rdblType.SelectedValue
            Path = objPath
            ReproductionRequest = New ReproductionRequest
            Me.Response.Redirect("defaultIn.aspx?page=repReq&step=2")
        End If
    End Sub

End Class
