
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System
Imports System.Collections

Namespace MDA

    Public Class ArchivistNotes
        Inherits CollectionBase


        Default Public Property Item(ByVal index As Integer) As ArchivistNotesItem
            Get
                Return CType(List(index), ArchivistNotesItem)
            End Get
            Set(ByVal Value As ArchivistNotesItem)
                List(index) = Value
            End Set
        End Property


        Public Function Add(ByVal Value As ArchivistNotesItem) As Integer
            Return List.Add(Value)
        End Function 'Add


        Public Function IndexOf(ByVal value As ArchivistNotesItem) As Integer
            Return List.IndexOf(value)
        End Function 'IndexOf


        Public Sub Insert(ByVal index As Integer, ByVal value As ArchivistNotesItem)
            List.Insert(index, value)
        End Sub 'Insert


        Public Sub Remove(ByVal value As ArchivistNotesItem)
            List.Remove(value)
        End Sub 'Remove


        Public Function Contains(ByVal value As ArchivistNotesItem) As Boolean
            Return List.Contains(value)
        End Function 'Contains


    End Class





    Public Class ArchivistNotesItem
        Private myNoteID As Integer
        Private myNoteTitle As String
        Private myNote As String
        Private myNoteDate As String
        'Private myComponentID As Int64
        Private myUsername As String


        Public Sub New()

        End Sub

        Public Sub New(ByVal NoteTitle As String, ByVal Note As String, ByVal NoteDate As String, ByVal Username As String)
            myNoteTitle = NoteTitle
            myNote = Note
            myNoteDate = NoteDate
            myUsername = Username
        End Sub


        Property NoteID() As Integer
            Get
                Return myNoteID
            End Get
            Set(ByVal Value As Integer)
                myNoteID = Value
            End Set
        End Property

        Property NoteTitle() As String
            Get
                Return myNoteTitle
            End Get
            Set(ByVal Value As String)
                myNoteTitle = Value
            End Set
        End Property

        Property Note() As String
            Get
                Return myNote
            End Get
            Set(ByVal Value As String)
                myNote = Value
            End Set
        End Property

        Property NoteDate() As String
            Get
                Return myNoteDate
            End Get
            Set(ByVal Value As String)
                myNoteDate = Value
            End Set
        End Property

        'Property ComponentID() As Int64
        '    Get
        '        Return myComponentID
        '    End Get
        '    Set(ByVal Value As Int64)
        '        myComponentID = Value
        '    End Set
        'End Property

        Property Username() As String
            Get
                Return myUsername
            End Get
            Set(ByVal Value As String)
                myUsername = Value
            End Set
        End Property


        Public Function Clone() As Object
            Return New ArchivistNotesItem(myNoteTitle, myNote, myNoteDate, myUsername)
        End Function

        Public Overloads Overrides Function Equals(ByVal obj As Object) As Boolean
            If Not TypeOf obj Is ArchivistNotesItem Then
                Return False
            Else
                Return NoteID = CType(obj, ArchivistNotesItem).NoteID
            End If
        End Function
    End Class
End Namespace
