
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region



Imports Digitarq.UserControls.CustomUserControls
Imports Digitarq.Utility
Imports Digitarq.Data.Entities.MDA
Imports Digitarq.Data.Entities
Imports Digitarq.Definitions
Imports Digitarq.Core.Logging
Imports Digitarq.UserControls.ImageButton
Imports Digitarq.UserControls
Imports Digitarq.UserControls.ErrorHandling


Public Class AutoCodingStartNumberForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New(ByVal StartPattern As String)
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        Number.Text = StartPattern
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Panel2 As System.Windows.Forms.Panel
    Friend WithEvents Number As ValidTextBox
    Friend WithEvents lblDescription As System.Windows.Forms.Label
    Friend WithEvents btnOkAutoCoding As System.Windows.Forms.Button
    Friend WithEvents btnCancelAutoCoding As System.Windows.Forms.Button
    Friend WithEvents imglButtons As System.Windows.Forms.ImageList
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(AutoCodingStartNumberForm))
        Me.Panel2 = New System.Windows.Forms.Panel
        Me.btnOkAutoCoding = New System.Windows.Forms.Button
        Me.imglButtons = New System.Windows.Forms.ImageList(Me.components)
        Me.btnCancelAutoCoding = New System.Windows.Forms.Button
        Me.Number = New ValidTextBox
        Me.lblDescription = New System.Windows.Forms.Label
        Me.Panel2.SuspendLayout()
        Me.SuspendLayout()
        '
        'Panel2
        '
        Me.Panel2.Controls.Add(Me.btnOkAutoCoding)
        Me.Panel2.Controls.Add(Me.btnCancelAutoCoding)
        Me.Panel2.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.Panel2.Location = New System.Drawing.Point(0, 55)
        Me.Panel2.Name = "Panel2"
        Me.Panel2.Size = New System.Drawing.Size(250, 40)
        Me.Panel2.TabIndex = 5
        '
        'btnOkAutoCoding
        '
        Me.btnOkAutoCoding.BackColor = System.Drawing.Color.White
        Me.btnOkAutoCoding.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.btnOkAutoCoding.Enabled = False
        Me.btnOkAutoCoding.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnOkAutoCoding.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnOkAutoCoding.ImageIndex = 1
        Me.btnOkAutoCoding.ImageList = Me.imglButtons
        Me.btnOkAutoCoding.Location = New System.Drawing.Point(88, 8)
        Me.btnOkAutoCoding.Name = "btnOkAutoCoding"
        Me.btnOkAutoCoding.Size = New System.Drawing.Size(70, 25)
        Me.btnOkAutoCoding.TabIndex = 3
        Me.btnOkAutoCoding.Text = CType(configurationAppSettings.GetValue("btnOkAutoCoding.Text", GetType(System.String)), String)
        Me.btnOkAutoCoding.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'imglButtons
        '
        Me.imglButtons.ImageSize = New System.Drawing.Size(18, 18)
        Me.imglButtons.ImageStream = CType(resources.GetObject("imglButtons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.imglButtons.TransparentColor = System.Drawing.Color.Transparent
        '
        'btnCancelAutoCoding
        '
        Me.btnCancelAutoCoding.BackColor = System.Drawing.Color.White
        Me.btnCancelAutoCoding.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnCancelAutoCoding.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnCancelAutoCoding.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnCancelAutoCoding.ImageIndex = 0
        Me.btnCancelAutoCoding.ImageList = Me.imglButtons
        Me.btnCancelAutoCoding.Location = New System.Drawing.Point(160, 8)
        Me.btnCancelAutoCoding.Name = "btnCancelAutoCoding"
        Me.btnCancelAutoCoding.Size = New System.Drawing.Size(80, 25)
        Me.btnCancelAutoCoding.TabIndex = 2
        Me.btnCancelAutoCoding.Text = CType(configurationAppSettings.GetValue("btnCancelAutoCoding.Text", GetType(System.String)), String)
        Me.btnCancelAutoCoding.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Number
        '
        Me.Number.AllowErrorMessage = True
        Me.Number.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.Number.FieldType = ValidTextBox.FieldTypes.IntegerField
        Me.Number.Location = New System.Drawing.Point(160, 20)
        Me.Number.MaxLength = 500000
        Me.Number.Name = "Number"
        Me.Number.RightToLeft = System.Windows.Forms.RightToLeft.Yes
        Me.Number.Size = New System.Drawing.Size(80, 20)
        Me.Number.TabIndex = 24
        Me.Number.Text = "001"
        '
        'lblDescription
        '
        Me.lblDescription.Location = New System.Drawing.Point(8, 20)
        Me.lblDescription.Name = "lblDescription"
        Me.lblDescription.Size = New System.Drawing.Size(152, 20)
        Me.lblDescription.TabIndex = 23
        Me.lblDescription.Text = CType(configurationAppSettings.GetValue("AutoCodingFormlblDescription.Text", GetType(System.String)), String)
        Me.lblDescription.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'AutoCodingStartNumberForm
        '
        Me.AcceptButton = Me.btnOkAutoCoding
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.CancelButton = Me.btnCancelAutoCoding
        Me.ClientSize = New System.Drawing.Size(250, 95)
        Me.Controls.Add(Me.lblDescription)
        Me.Controls.Add(Me.Number)
        Me.Controls.Add(Me.Panel2)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "AutoCodingStartNumberForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.Text = CType(configurationAppSettings.GetValue("AutoCodingStartNumberForm.Text", GetType(System.String)), String)
        Me.Panel2.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region


    Public Property Value() As Integer
        Get
            Return StrToInt(Number.Text)
        End Get
        Set(ByVal Value As Integer)
            Number.Text = IntToStr(Value)
        End Set
    End Property

    Public ReadOnly Property ValueAsString() As String
        Get
            Return Number.Text
        End Get
    End Property

    Private Sub Number_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Number.TextChanged
        Me.btnOkAutoCoding.Enabled = Number.Text.Length > 0 AndAlso Number.isValid
    End Sub

End Class

