
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Xml
Imports System.IO
Imports System.Text.RegularExpressions
Imports System.Configuration
Imports System.Collections.Specialized
Imports System.Data.SqlClient ' SQL Server Data Provider
Imports System.Xml.Xsl
Imports System.Xml.XPath
Imports SHDocVw
Imports DigitArq.UserControls.Authentication
Imports System.Threading
Imports System.Windows.Forms.TabPage.TabPageControlCollection
Imports DigitArq.Data.Entities.MDA
Imports DigitArq.Data.Entities.MGUP


Imports DigitArq.Utility
Imports DigitArq.core.Logging
Imports DigitArq.Definitions
Imports DigitArq.UserControls

Imports DigitArq.UserControls.CustomUserControls

Public Class MainForm
    Inherits System.Windows.Forms.Form


    Dim mySQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")


    Private myProgressDialog As ProgressDialog.ProgressDialog
    Private myFloatingForm As FloatingForm = New FloatingForm
    Private myProgramState As ProgramState = New ProgramState
    'Private mySelectedLazyNode As LazyNode = Nothing

    Private myProcessInfoName As String = ""
    Private myApplicationType As ApplicationType = GetApplicationType()

    'Private myFieldPresentationMode As ViewMode
    Private myLazyNodeDataChanged As Boolean

    Private myNodeTakenCacheNodeID As Int64 = -1
    Private myNodeTakenCacheTakenBy As String = ""

    Private WithEvents mySearchForm As SearchForm = Nothing



#Region " Windows Form Designer generated code "

    Private Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        'Initialize()
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents StatusBar As System.Windows.Forms.StatusBar
    Friend WithEvents MainMenu As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItemFile As System.Windows.Forms.MenuItem
    Friend WithEvents RightPanel As System.Windows.Forms.Panel

    Friend WithEvents ButtonIcons As System.Windows.Forms.ImageList
    Friend WithEvents MenuItemExit As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemCollapseAll As System.Windows.Forms.MenuItem
    Friend WithEvents OtherFindAidIcons As System.Windows.Forms.ImageList
    Friend WithEvents MenuItemExpandAll As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem6 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemCopy As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemPaste As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemCut As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemTools As System.Windows.Forms.MenuItem
    Friend WithEvents PrintReportMenu As System.Windows.Forms.ContextMenu
    Friend WithEvents IncorporationResumeMenuItem As System.Windows.Forms.MenuItem
    Friend WithEvents FondsListingMenuItem As System.Windows.Forms.MenuItem
    Friend WithEvents IncorporationTransportationUnitsMenuItem As System.Windows.Forms.MenuItem
    Friend WithEvents GenreFormIcons As System.Windows.Forms.ImageList
    Friend WithEvents LegalStatusMenuItem As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemValidate As System.Windows.Forms.MenuItem
    Friend WithEvents OtherLevelIcons As System.Windows.Forms.ImageList
    Friend WithEvents MenuItemFondsManager As System.Windows.Forms.MenuItem
    Friend WithEvents UpDownArrowButtons As System.Windows.Forms.ImageList
    Friend WithEvents MenuItemAdministration As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemControlAccess As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem9 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemRemove As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemUserManagement As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemSortBy As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemSortByUnitID As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemSortByUnitDateInitial As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemSortByOtherLevel As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemStatistics As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemView As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemAllFields As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemMandatoryFields As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemMostFrequentFields As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemTree As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemReplace As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemFindReplace As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemFind As System.Windows.Forms.MenuItem
    Friend WithEvents ViewModeIcons As System.Windows.Forms.ImageList
    Friend WithEvents MenuItem10 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemAutoCoding As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem13 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemEdit As System.Windows.Forms.MenuItem
    Friend WithEvents ContainerTypeIcons As System.Windows.Forms.ImageList
    Friend WithEvents MenuItemLogin As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemVisibility As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemValidation As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemMakeValid As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemMakeVisible As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemMakeInvisible As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemMakeInvalid As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemInference As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemSortByProcessInfoDate As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemAuthority As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemInventoryReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemIUInventoryReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemCatalogReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemIUListReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemSeriesListReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemClassificationPlanReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemAllControlAccessReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemControlAccessReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemReports As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemImport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemImportEAD As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemExport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemExportEAD As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemExportCALM As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemClearLog As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemNodeCounterPro As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemImportFonds As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem4 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemAskBeforeSave As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemInstalationUnitsBySeriesReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemWebSearch As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemLog As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemLogViewer As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemGlobalStats As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemMonthlyStats As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemWebStats As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemImportTabSeparatedText As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemNormaliseCoding As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem7 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemSortByUnitTitle As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemAuthorsListReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemWebSeparator As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemPhyslocReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemFileSeparator1 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemFileSeparator2 As System.Windows.Forms.MenuItem
    Friend WithEvents AltFormAvailIcons As System.Windows.Forms.ImageList
    Private configurationAppSettings As New System.Configuration.AppSettingsReader
    Friend WithEvents MenuItemNewFonds As System.Windows.Forms.MenuItem
    Friend WithEvents imglButtons As System.Windows.Forms.ImageList
    Friend WithEvents MenuItem3 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemTextSize As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemTextSizeSmall As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemTextSizeMedium As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemTextSizeLarge As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemUpdateCompleteUnitIDs As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemAutoUpdateCompleteUnitID As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem5 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemMigrationNotes As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemFileSep2 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemIncorporationReports As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemIncorporationResumeReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemIncorporationListingReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemIncorporationTransportUnitsReport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemIncorporationDeliveryCertificate As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemAskBeforeRemove As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemExportDIF As System.Windows.Forms.MenuItem
    Friend WithEvents EadEditor As DigitArq.UserControls.EADEditor.EADEditor
    Friend WithEvents TreeView As LazyTree
    Friend WithEvents NavigationBar As NavigationBar.NavigationBar
    Friend WithEvents Splitter As System.Windows.Forms.Splitter
    Friend WithEvents MenuItem11 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemAbout As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemSupport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemAboutThisVersion As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemHelpdesk As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(MainForm))
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Me.OtherLevelIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.StatusBar = New System.Windows.Forms.StatusBar
        Me.PrintReportMenu = New System.Windows.Forms.ContextMenu
        Me.IncorporationResumeMenuItem = New System.Windows.Forms.MenuItem
        Me.FondsListingMenuItem = New System.Windows.Forms.MenuItem
        Me.IncorporationTransportationUnitsMenuItem = New System.Windows.Forms.MenuItem
        Me.LegalStatusMenuItem = New System.Windows.Forms.MenuItem
        Me.ButtonIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.RightPanel = New System.Windows.Forms.Panel
        Me.EadEditor = New DigitArq.UserControls.EADEditor.EADEditor
        Me.Splitter = New System.Windows.Forms.Splitter
        Me.TreeView = New DigitArq.Applications.MDA.LazyTree
        Me.NavigationBar = New NavigationBar.NavigationBar
        Me.MainMenu = New System.Windows.Forms.MainMenu
        Me.MenuItemFile = New System.Windows.Forms.MenuItem
        Me.MenuItemNewFonds = New System.Windows.Forms.MenuItem
        Me.MenuItemFondsManager = New System.Windows.Forms.MenuItem
        Me.MenuItemFileSep2 = New System.Windows.Forms.MenuItem
        Me.MenuItemImport = New System.Windows.Forms.MenuItem
        Me.MenuItemImportEAD = New System.Windows.Forms.MenuItem
        Me.MenuItemImportFonds = New System.Windows.Forms.MenuItem
        Me.MenuItemImportTabSeparatedText = New System.Windows.Forms.MenuItem
        Me.MenuItemExport = New System.Windows.Forms.MenuItem
        Me.MenuItemExportEAD = New System.Windows.Forms.MenuItem
        Me.MenuItemExportCALM = New System.Windows.Forms.MenuItem
        Me.MenuItemExportDIF = New System.Windows.Forms.MenuItem
        Me.MenuItemFileSeparator1 = New System.Windows.Forms.MenuItem
        Me.MenuItemLogin = New System.Windows.Forms.MenuItem
        Me.MenuItemFileSeparator2 = New System.Windows.Forms.MenuItem
        Me.MenuItemExit = New System.Windows.Forms.MenuItem
        Me.MenuItemEdit = New System.Windows.Forms.MenuItem
        Me.MenuItemCut = New System.Windows.Forms.MenuItem
        Me.MenuItemCopy = New System.Windows.Forms.MenuItem
        Me.MenuItemPaste = New System.Windows.Forms.MenuItem
        Me.MenuItem9 = New System.Windows.Forms.MenuItem
        Me.MenuItemRemove = New System.Windows.Forms.MenuItem
        Me.MenuItem6 = New System.Windows.Forms.MenuItem
        Me.MenuItemFind = New System.Windows.Forms.MenuItem
        Me.MenuItemReplace = New System.Windows.Forms.MenuItem
        Me.MenuItemFindReplace = New System.Windows.Forms.MenuItem
        Me.MenuItemWebSearch = New System.Windows.Forms.MenuItem
        Me.MenuItemView = New System.Windows.Forms.MenuItem
        Me.MenuItemAllFields = New System.Windows.Forms.MenuItem
        Me.MenuItemMostFrequentFields = New System.Windows.Forms.MenuItem
        Me.MenuItemMandatoryFields = New System.Windows.Forms.MenuItem
        Me.MenuItem3 = New System.Windows.Forms.MenuItem
        Me.MenuItemTextSize = New System.Windows.Forms.MenuItem
        Me.MenuItemTextSizeSmall = New System.Windows.Forms.MenuItem
        Me.MenuItemTextSizeMedium = New System.Windows.Forms.MenuItem
        Me.MenuItemTextSizeLarge = New System.Windows.Forms.MenuItem
        Me.MenuItemTree = New System.Windows.Forms.MenuItem
        Me.MenuItemExpandAll = New System.Windows.Forms.MenuItem
        Me.MenuItemCollapseAll = New System.Windows.Forms.MenuItem
        Me.MenuItem10 = New System.Windows.Forms.MenuItem
        Me.MenuItemSortBy = New System.Windows.Forms.MenuItem
        Me.MenuItemSortByUnitDateInitial = New System.Windows.Forms.MenuItem
        Me.MenuItemSortByUnitID = New System.Windows.Forms.MenuItem
        Me.MenuItemSortByUnitTitle = New System.Windows.Forms.MenuItem
        Me.MenuItemSortByOtherLevel = New System.Windows.Forms.MenuItem
        Me.MenuItemSortByProcessInfoDate = New System.Windows.Forms.MenuItem
        Me.MenuItem4 = New System.Windows.Forms.MenuItem
        Me.MenuItemAskBeforeRemove = New System.Windows.Forms.MenuItem
        Me.MenuItemAskBeforeSave = New System.Windows.Forms.MenuItem
        Me.MenuItemAutoUpdateCompleteUnitID = New System.Windows.Forms.MenuItem
        Me.MenuItem5 = New System.Windows.Forms.MenuItem
        Me.MenuItemMigrationNotes = New System.Windows.Forms.MenuItem
        Me.MenuItemTools = New System.Windows.Forms.MenuItem
        Me.MenuItemValidate = New System.Windows.Forms.MenuItem
        Me.MenuItemInference = New System.Windows.Forms.MenuItem
        Me.MenuItem2 = New System.Windows.Forms.MenuItem
        Me.MenuItem7 = New System.Windows.Forms.MenuItem
        Me.MenuItemUpdateCompleteUnitIDs = New System.Windows.Forms.MenuItem
        Me.MenuItemNormaliseCoding = New System.Windows.Forms.MenuItem
        Me.MenuItemAutoCoding = New System.Windows.Forms.MenuItem
        Me.MenuItemStatistics = New System.Windows.Forms.MenuItem
        Me.MenuItemNodeCounterPro = New System.Windows.Forms.MenuItem
        Me.MenuItemAdministration = New System.Windows.Forms.MenuItem
        Me.MenuItemControlAccess = New System.Windows.Forms.MenuItem
        Me.MenuItemUserManagement = New System.Windows.Forms.MenuItem
        Me.MenuItemAuthority = New System.Windows.Forms.MenuItem
        Me.MenuItem13 = New System.Windows.Forms.MenuItem
        Me.MenuItemValidation = New System.Windows.Forms.MenuItem
        Me.MenuItemMakeValid = New System.Windows.Forms.MenuItem
        Me.MenuItemMakeInvalid = New System.Windows.Forms.MenuItem
        Me.MenuItemVisibility = New System.Windows.Forms.MenuItem
        Me.MenuItemMakeVisible = New System.Windows.Forms.MenuItem
        Me.MenuItemMakeInvisible = New System.Windows.Forms.MenuItem
        Me.MenuItemWebSeparator = New System.Windows.Forms.MenuItem
        Me.MenuItemLog = New System.Windows.Forms.MenuItem
        Me.MenuItemLogViewer = New System.Windows.Forms.MenuItem
        Me.MenuItemClearLog = New System.Windows.Forms.MenuItem
        Me.MenuItemWebStats = New System.Windows.Forms.MenuItem
        Me.MenuItemGlobalStats = New System.Windows.Forms.MenuItem
        Me.MenuItemMonthlyStats = New System.Windows.Forms.MenuItem
        Me.MenuItemReports = New System.Windows.Forms.MenuItem
        Me.MenuItemInventoryReport = New System.Windows.Forms.MenuItem
        Me.MenuItemIUInventoryReport = New System.Windows.Forms.MenuItem
        Me.MenuItemCatalogReport = New System.Windows.Forms.MenuItem
        Me.MenuItemInstalationUnitsBySeriesReport = New System.Windows.Forms.MenuItem
        Me.MenuItemIUListReport = New System.Windows.Forms.MenuItem
        Me.MenuItemSeriesListReport = New System.Windows.Forms.MenuItem
        Me.MenuItemClassificationPlanReport = New System.Windows.Forms.MenuItem
        Me.MenuItemControlAccessReport = New System.Windows.Forms.MenuItem
        Me.MenuItemAllControlAccessReport = New System.Windows.Forms.MenuItem
        Me.MenuItemPhyslocReport = New System.Windows.Forms.MenuItem
        Me.MenuItemAuthorsListReport = New System.Windows.Forms.MenuItem
        Me.MenuItemIncorporationReports = New System.Windows.Forms.MenuItem
        Me.MenuItemIncorporationResumeReport = New System.Windows.Forms.MenuItem
        Me.MenuItemIncorporationListingReport = New System.Windows.Forms.MenuItem
        Me.MenuItemIncorporationTransportUnitsReport = New System.Windows.Forms.MenuItem
        Me.MenuItemIncorporationDeliveryCertificate = New System.Windows.Forms.MenuItem
        Me.MenuItemAbout = New System.Windows.Forms.MenuItem
        Me.MenuItemHelpdesk = New System.Windows.Forms.MenuItem
        Me.MenuItemSupport = New System.Windows.Forms.MenuItem
        Me.MenuItemAboutThisVersion = New System.Windows.Forms.MenuItem
        Me.MenuItem11 = New System.Windows.Forms.MenuItem
        Me.OtherFindAidIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.GenreFormIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.ViewModeIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.UpDownArrowButtons = New System.Windows.Forms.ImageList(Me.components)
        Me.ContainerTypeIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.AltFormAvailIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.imglButtons = New System.Windows.Forms.ImageList(Me.components)
        Me.RightPanel.SuspendLayout()
        Me.SuspendLayout()
        '
        'OtherLevelIcons
        '
        Me.OtherLevelIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit
        Me.OtherLevelIcons.ImageSize = New System.Drawing.Size(16, 16)
        Me.OtherLevelIcons.ImageStream = CType(resources.GetObject("OtherLevelIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.OtherLevelIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'StatusBar
        '
        Me.StatusBar.Location = New System.Drawing.Point(0, 379)
        Me.StatusBar.Name = "StatusBar"
        Me.StatusBar.Size = New System.Drawing.Size(944, 22)
        Me.StatusBar.TabIndex = 0
        '
        'PrintReportMenu
        '
        Me.PrintReportMenu.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.IncorporationResumeMenuItem, Me.FondsListingMenuItem, Me.IncorporationTransportationUnitsMenuItem, Me.LegalStatusMenuItem})
        '
        'IncorporationResumeMenuItem
        '
        Me.IncorporationResumeMenuItem.Index = 0
        Me.IncorporationResumeMenuItem.RadioCheck = True
        Me.IncorporationResumeMenuItem.Text = "Resumo..."
        '
        'FondsListingMenuItem
        '
        Me.FondsListingMenuItem.Checked = True
        Me.FondsListingMenuItem.Index = 1
        Me.FondsListingMenuItem.RadioCheck = True
        Me.FondsListingMenuItem.Text = "Listagem..."
        '
        'IncorporationTransportationUnitsMenuItem
        '
        Me.IncorporationTransportationUnitsMenuItem.Index = 2
        Me.IncorporationTransportationUnitsMenuItem.RadioCheck = True
        Me.IncorporationTransportationUnitsMenuItem.Text = "Unidades de Transporte..."
        '
        'LegalStatusMenuItem
        '
        Me.LegalStatusMenuItem.Index = 3
        Me.LegalStatusMenuItem.RadioCheck = True
        Me.LegalStatusMenuItem.Text = "Auto de Entrega"
        '
        'ButtonIcons
        '
        Me.ButtonIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit
        Me.ButtonIcons.ImageSize = New System.Drawing.Size(32, 32)
        Me.ButtonIcons.ImageStream = CType(resources.GetObject("ButtonIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ButtonIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'RightPanel
        '
        Me.RightPanel.Controls.Add(Me.EadEditor)
        Me.RightPanel.Controls.Add(Me.Splitter)
        Me.RightPanel.Controls.Add(Me.TreeView)
        Me.RightPanel.Controls.Add(Me.NavigationBar)
        Me.RightPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.RightPanel.Location = New System.Drawing.Point(0, 0)
        Me.RightPanel.Name = "RightPanel"
        Me.RightPanel.Size = New System.Drawing.Size(944, 379)
        Me.RightPanel.TabIndex = 8
        '
        'EadEditor
        '
        Me.EadEditor.Dock = System.Windows.Forms.DockStyle.Fill
        Me.EadEditor.LazyNode = Nothing
        Me.EadEditor.Location = New System.Drawing.Point(219, 40)
        Me.EadEditor.Name = "EadEditor"
        Me.EadEditor.Size = New System.Drawing.Size(725, 339)
        Me.EadEditor.TabIndex = 9
        Me.EadEditor.ViewMode = DigitArq.Definitions.MDA.ViewMode.All
        '
        'Splitter
        '
        Me.Splitter.Location = New System.Drawing.Point(216, 40)
        Me.Splitter.MinSize = 100
        Me.Splitter.Name = "Splitter"
        Me.Splitter.Size = New System.Drawing.Size(3, 339)
        Me.Splitter.TabIndex = 8
        Me.Splitter.TabStop = False
        '
        'TreeView
        '
        Me.TreeView.AllowDrop = True
        Me.TreeView.AskBeforeRemove = True
        Me.TreeView.AutoUpdateCompleteUnitID = True
        Me.TreeView.Dock = System.Windows.Forms.DockStyle.Left
        Me.TreeView.ImageList = Me.OtherLevelIcons
        Me.TreeView.Location = New System.Drawing.Point(0, 40)
        Me.TreeView.Name = "TreeView"
        Me.TreeView.ProcessInfoName = Nothing
        Me.TreeView.RootLazyNode = Nothing
        Me.TreeView.SelectedLazyNode = Nothing
        Me.TreeView.Size = New System.Drawing.Size(216, 339)
        Me.TreeView.TabIndex = 2
        '
        'NavigationBar
        '
        Me.NavigationBar.Dock = System.Windows.Forms.DockStyle.Top
        Me.NavigationBar.Location = New System.Drawing.Point(0, 0)
        Me.NavigationBar.Name = "NavigationBar"
        Me.NavigationBar.Reference = ""
        Me.NavigationBar.Search = "Cannot Load Configuration File!"
        Me.NavigationBar.SearchTextBoxForeColor = System.Drawing.SystemColors.GrayText
        Me.NavigationBar.Size = New System.Drawing.Size(944, 40)
        Me.NavigationBar.TabIndex = 0
        '
        'MainMenu
        '
        Me.MainMenu.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemFile, Me.MenuItemEdit, Me.MenuItemView, Me.MenuItemTools, Me.MenuItemAdministration, Me.MenuItemReports, Me.MenuItemIncorporationReports, Me.MenuItemAbout, Me.MenuItem11})
        '
        'MenuItemFile
        '
        Me.MenuItemFile.Index = 0
        Me.MenuItemFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemNewFonds, Me.MenuItemFondsManager, Me.MenuItemFileSep2, Me.MenuItemImport, Me.MenuItemExport, Me.MenuItemFileSeparator1, Me.MenuItemLogin, Me.MenuItemFileSeparator2, Me.MenuItemExit})
        Me.MenuItemFile.Text = "&Fundos"
        '
        'MenuItemNewFonds
        '
        Me.MenuItemNewFonds.Index = 0
        Me.MenuItemNewFonds.Text = CType(configurationAppSettings.GetValue("MenuItemNewFonds.Text", GetType(System.String)), String)
        '
        'MenuItemFondsManager
        '
        Me.MenuItemFondsManager.Index = 1
        Me.MenuItemFondsManager.Text = CType(configurationAppSettings.GetValue("mnuItemFondsManager.Text", GetType(System.String)), String)
        '
        'MenuItemFileSep2
        '
        Me.MenuItemFileSep2.Index = 2
        Me.MenuItemFileSep2.Text = "-"
        '
        'MenuItemImport
        '
        Me.MenuItemImport.Index = 3
        Me.MenuItemImport.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemImportEAD, Me.MenuItemImportFonds, Me.MenuItemImportTabSeparatedText})
        Me.MenuItemImport.Text = CType(configurationAppSettings.GetValue("MenuItemImport.Text", GetType(System.String)), String)
        Me.MenuItemImport.Visible = False
        '
        'MenuItemImportEAD
        '
        Me.MenuItemImportEAD.Index = 0
        Me.MenuItemImportEAD.Text = CType(configurationAppSettings.GetValue("MenuItemImportEAD.Text", GetType(System.String)), String)
        '
        'MenuItemImportFonds
        '
        Me.MenuItemImportFonds.Index = 1
        Me.MenuItemImportFonds.Text = CType(configurationAppSettings.GetValue("MenuItemImportFonds.Text", GetType(System.String)), String)
        '
        'MenuItemImportTabSeparatedText
        '
        Me.MenuItemImportTabSeparatedText.Index = 2
        Me.MenuItemImportTabSeparatedText.Text = CType(configurationAppSettings.GetValue("MenuItemImportTabSeparatedText.Text", GetType(System.String)), String)
        '
        'MenuItemExport
        '
        Me.MenuItemExport.Index = 4
        Me.MenuItemExport.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemExportEAD, Me.MenuItemExportCALM, Me.MenuItemExportDIF})
        Me.MenuItemExport.Text = CType(configurationAppSettings.GetValue("MenuItemExport.Text", GetType(System.String)), String)
        Me.MenuItemExport.Visible = False
        '
        'MenuItemExportEAD
        '
        Me.MenuItemExportEAD.Index = 0
        Me.MenuItemExportEAD.Text = CType(configurationAppSettings.GetValue("MenuItemExportEAD.Text", GetType(System.String)), String)
        '
        'MenuItemExportCALM
        '
        Me.MenuItemExportCALM.Index = 1
        Me.MenuItemExportCALM.Text = CType(configurationAppSettings.GetValue("MenuItemExportCALM.Text", GetType(System.String)), String)
        '
        'MenuItemExportDIF
        '
        Me.MenuItemExportDIF.Index = 2
        Me.MenuItemExportDIF.Text = CType(configurationAppSettings.GetValue("MenuItemExportDIF.Text", GetType(System.String)), String)
        '
        'MenuItemFileSeparator1
        '
        Me.MenuItemFileSeparator1.Index = 5
        Me.MenuItemFileSeparator1.Text = "-"
        '
        'MenuItemLogin
        '
        Me.MenuItemLogin.Index = 6
        Me.MenuItemLogin.Text = CType(configurationAppSettings.GetValue("MenuItemLogin.Text", GetType(System.String)), String)
        '
        'MenuItemFileSeparator2
        '
        Me.MenuItemFileSeparator2.Index = 7
        Me.MenuItemFileSeparator2.Text = "-"
        Me.MenuItemFileSeparator2.Visible = False
        '
        'MenuItemExit
        '
        Me.MenuItemExit.Index = 8
        Me.MenuItemExit.Text = "Sai&r"
        '
        'MenuItemEdit
        '
        Me.MenuItemEdit.Index = 1
        Me.MenuItemEdit.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemCut, Me.MenuItemCopy, Me.MenuItemPaste, Me.MenuItem9, Me.MenuItemRemove, Me.MenuItem6, Me.MenuItemFind, Me.MenuItemReplace, Me.MenuItemFindReplace})
        Me.MenuItemEdit.Text = CType(configurationAppSettings.GetValue("MenuItemEdit.Text", GetType(System.String)), String)
        Me.MenuItemEdit.Visible = False
        '
        'MenuItemCut
        '
        Me.MenuItemCut.Index = 0
        Me.MenuItemCut.Text = "Cor&tar"
        '
        'MenuItemCopy
        '
        Me.MenuItemCopy.Index = 1
        Me.MenuItemCopy.Text = "&Copiar"
        '
        'MenuItemPaste
        '
        Me.MenuItemPaste.Enabled = False
        Me.MenuItemPaste.Index = 2
        Me.MenuItemPaste.Text = "C&olar"
        '
        'MenuItem9
        '
        Me.MenuItem9.Index = 3
        Me.MenuItem9.Text = "-"
        '
        'MenuItemRemove
        '
        Me.MenuItemRemove.Index = 4
        Me.MenuItemRemove.Text = CType(configurationAppSettings.GetValue("MenuItemRemove.Text", GetType(System.String)), String)
        '
        'MenuItem6
        '
        Me.MenuItem6.Index = 5
        Me.MenuItem6.Text = "-"
        '
        'MenuItemFind
        '
        Me.MenuItemFind.Index = 6
        Me.MenuItemFind.Text = CType(configurationAppSettings.GetValue("MenuItemFind.Text", GetType(System.String)), String)
        '
        'MenuItemReplace
        '
        Me.MenuItemReplace.Index = 7
        Me.MenuItemReplace.Text = CType(configurationAppSettings.GetValue("MenuItemReplace.Text", GetType(System.String)), String)
        '
        'MenuItemFindReplace
        '
        Me.MenuItemFindReplace.Index = 8
        Me.MenuItemFindReplace.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemWebSearch})
        Me.MenuItemFindReplace.Text = CType(configurationAppSettings.GetValue("MenuItemFindReplace.Text", GetType(System.String)), String)
        Me.MenuItemFindReplace.Visible = False
        '
        'MenuItemWebSearch
        '
        Me.MenuItemWebSearch.Index = 0
        Me.MenuItemWebSearch.Text = CType(configurationAppSettings.GetValue("MenuItemWebSearch.Text", GetType(System.String)), String)
        '
        'MenuItemView
        '
        Me.MenuItemView.Index = 2
        Me.MenuItemView.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemAllFields, Me.MenuItemMostFrequentFields, Me.MenuItemMandatoryFields, Me.MenuItem3, Me.MenuItemTextSize, Me.MenuItemTree, Me.MenuItem10, Me.MenuItemSortBy, Me.MenuItem4, Me.MenuItemAskBeforeRemove, Me.MenuItemAskBeforeSave, Me.MenuItemAutoUpdateCompleteUnitID, Me.MenuItem5, Me.MenuItemMigrationNotes})
        Me.MenuItemView.Text = CType(configurationAppSettings.GetValue("MenuItemView.Text", GetType(System.String)), String)
        Me.MenuItemView.Visible = False
        '
        'MenuItemAllFields
        '
        Me.MenuItemAllFields.Checked = True
        Me.MenuItemAllFields.Index = 0
        Me.MenuItemAllFields.RadioCheck = True
        Me.MenuItemAllFields.Text = CType(configurationAppSettings.GetValue("MenuItemAllFields.Text", GetType(System.String)), String)
        '
        'MenuItemMostFrequentFields
        '
        Me.MenuItemMostFrequentFields.Index = 1
        Me.MenuItemMostFrequentFields.RadioCheck = True
        Me.MenuItemMostFrequentFields.Text = CType(configurationAppSettings.GetValue("MenuItemMostFrequentFields.Text", GetType(System.String)), String)
        '
        'MenuItemMandatoryFields
        '
        Me.MenuItemMandatoryFields.Index = 2
        Me.MenuItemMandatoryFields.RadioCheck = True
        Me.MenuItemMandatoryFields.Text = CType(configurationAppSettings.GetValue("MenuItemMandatoryFields.Text", GetType(System.String)), String)
        '
        'MenuItem3
        '
        Me.MenuItem3.Index = 3
        Me.MenuItem3.Text = "-"
        '
        'MenuItemTextSize
        '
        Me.MenuItemTextSize.Index = 4
        Me.MenuItemTextSize.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemTextSizeSmall, Me.MenuItemTextSizeMedium, Me.MenuItemTextSizeLarge})
        Me.MenuItemTextSize.Text = CType(configurationAppSettings.GetValue("MenuItemTextSize.Text", GetType(System.String)), String)
        '
        'MenuItemTextSizeSmall
        '
        Me.MenuItemTextSizeSmall.Checked = CType(configurationAppSettings.GetValue("MenuItemTextSizeSmall.Checked", GetType(System.Boolean)), Boolean)
        Me.MenuItemTextSizeSmall.Index = 0
        Me.MenuItemTextSizeSmall.Text = CType(configurationAppSettings.GetValue("MenuItemTextSizeSmall.Text", GetType(System.String)), String)
        '
        'MenuItemTextSizeMedium
        '
        Me.MenuItemTextSizeMedium.Checked = CType(configurationAppSettings.GetValue("MenuItemTextSizeMedium.Checked", GetType(System.Boolean)), Boolean)
        Me.MenuItemTextSizeMedium.Index = 1
        Me.MenuItemTextSizeMedium.Text = CType(configurationAppSettings.GetValue("MenuItemTextSizeMedium.Text", GetType(System.String)), String)
        '
        'MenuItemTextSizeLarge
        '
        Me.MenuItemTextSizeLarge.Checked = CType(configurationAppSettings.GetValue("MenuItemTextSizeLarge.Checked", GetType(System.Boolean)), Boolean)
        Me.MenuItemTextSizeLarge.Index = 2
        Me.MenuItemTextSizeLarge.RadioCheck = CType(configurationAppSettings.GetValue("MenuItemTextSizeLarge.RadioCheck", GetType(System.Boolean)), Boolean)
        Me.MenuItemTextSizeLarge.Text = CType(configurationAppSettings.GetValue("MenuItemTextSizeLarge.Text", GetType(System.String)), String)
        '
        'MenuItemTree
        '
        Me.MenuItemTree.Index = 5
        Me.MenuItemTree.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemExpandAll, Me.MenuItemCollapseAll})
        Me.MenuItemTree.Text = CType(configurationAppSettings.GetValue("MenuItemTree.Text", GetType(System.String)), String)
        '
        'MenuItemExpandAll
        '
        Me.MenuItemExpandAll.Index = 0
        Me.MenuItemExpandAll.Text = "&Expandir"
        '
        'MenuItemCollapseAll
        '
        Me.MenuItemCollapseAll.Index = 1
        Me.MenuItemCollapseAll.Text = "&Colapsar"
        '
        'MenuItem10
        '
        Me.MenuItem10.Index = 6
        Me.MenuItem10.Text = "-"
        '
        'MenuItemSortBy
        '
        Me.MenuItemSortBy.Index = 7
        Me.MenuItemSortBy.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemSortByUnitDateInitial, Me.MenuItemSortByUnitID, Me.MenuItemSortByUnitTitle, Me.MenuItemSortByOtherLevel, Me.MenuItemSortByProcessInfoDate})
        Me.MenuItemSortBy.Text = CType(configurationAppSettings.GetValue("MenuItemSortBy.Text", GetType(System.String)), String)
        '
        'MenuItemSortByUnitDateInitial
        '
        Me.MenuItemSortByUnitDateInitial.Checked = True
        Me.MenuItemSortByUnitDateInitial.Index = 0
        Me.MenuItemSortByUnitDateInitial.RadioCheck = True
        Me.MenuItemSortByUnitDateInitial.Text = CType(configurationAppSettings.GetValue("MenuItemSortByUnitDateInitial.Text", GetType(System.String)), String)
        '
        'MenuItemSortByUnitID
        '
        Me.MenuItemSortByUnitID.Index = 1
        Me.MenuItemSortByUnitID.RadioCheck = True
        Me.MenuItemSortByUnitID.Text = CType(configurationAppSettings.GetValue("MenuItemSortByUnitID.Text", GetType(System.String)), String)
        '
        'MenuItemSortByUnitTitle
        '
        Me.MenuItemSortByUnitTitle.Index = 2
        Me.MenuItemSortByUnitTitle.RadioCheck = True
        Me.MenuItemSortByUnitTitle.Text = CType(configurationAppSettings.GetValue("MenuItemSortByUnitTitle.Text", GetType(System.String)), String)
        '
        'MenuItemSortByOtherLevel
        '
        Me.MenuItemSortByOtherLevel.Index = 3
        Me.MenuItemSortByOtherLevel.RadioCheck = True
        Me.MenuItemSortByOtherLevel.Text = CType(configurationAppSettings.GetValue("MenuItemSortByOtherLevel.Text", GetType(System.String)), String)
        '
        'MenuItemSortByProcessInfoDate
        '
        Me.MenuItemSortByProcessInfoDate.Index = 4
        Me.MenuItemSortByProcessInfoDate.RadioCheck = True
        Me.MenuItemSortByProcessInfoDate.Text = CType(configurationAppSettings.GetValue("MenuItemSortByProcessInfoDate.Text", GetType(System.String)), String)
        '
        'MenuItem4
        '
        Me.MenuItem4.Index = 8
        Me.MenuItem4.Text = "-"
        '
        'MenuItemAskBeforeRemove
        '
        Me.MenuItemAskBeforeRemove.Checked = True
        Me.MenuItemAskBeforeRemove.Index = 9
        Me.MenuItemAskBeforeRemove.Text = CType(configurationAppSettings.GetValue("MenuItemAskBeforeRemove.Text", GetType(System.String)), String)
        '
        'MenuItemAskBeforeSave
        '
        Me.MenuItemAskBeforeSave.Checked = True
        Me.MenuItemAskBeforeSave.Index = 10
        Me.MenuItemAskBeforeSave.Text = CType(configurationAppSettings.GetValue("MenuItemAskBeforeSave.Text", GetType(System.String)), String)
        '
        'MenuItemAutoUpdateCompleteUnitID
        '
        Me.MenuItemAutoUpdateCompleteUnitID.Index = 11
        Me.MenuItemAutoUpdateCompleteUnitID.Text = CType(configurationAppSettings.GetValue("MenuItemUpdateCompleteUnitID.Text", GetType(System.String)), String)
        '
        'MenuItem5
        '
        Me.MenuItem5.Index = 12
        Me.MenuItem5.Text = "-"
        '
        'MenuItemMigrationNotes
        '
        Me.MenuItemMigrationNotes.Index = 13
        Me.MenuItemMigrationNotes.Text = CType(configurationAppSettings.GetValue("MenuItemMigrationNotes.Text", GetType(System.String)), String)
        '
        'MenuItemTools
        '
        Me.MenuItemTools.Index = 3
        Me.MenuItemTools.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemValidate, Me.MenuItemInference, Me.MenuItem2, Me.MenuItem7, Me.MenuItemStatistics})
        Me.MenuItemTools.Text = "Ferra&mentas"
        Me.MenuItemTools.Visible = False
        '
        'MenuItemValidate
        '
        Me.MenuItemValidate.Index = 0
        Me.MenuItemValidate.Text = CType(configurationAppSettings.GetValue("MenuItemValidate.Text", GetType(System.String)), String)
        '
        'MenuItemInference
        '
        Me.MenuItemInference.Index = 1
        Me.MenuItemInference.Text = CType(configurationAppSettings.GetValue("MenuItemInference.Text", GetType(System.String)), String)
        '
        'MenuItem2
        '
        Me.MenuItem2.Index = 2
        Me.MenuItem2.Text = "-"
        '
        'MenuItem7
        '
        Me.MenuItem7.Index = 3
        Me.MenuItem7.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemUpdateCompleteUnitIDs, Me.MenuItemNormaliseCoding, Me.MenuItemAutoCoding})
        Me.MenuItem7.Text = "Re&ferncias..."
        '
        'MenuItemUpdateCompleteUnitIDs
        '
        Me.MenuItemUpdateCompleteUnitIDs.Index = 0
        Me.MenuItemUpdateCompleteUnitIDs.Text = CType(configurationAppSettings.GetValue("MenuItemUpdateCompleteUnitIDs.Text", GetType(System.String)), String)
        '
        'MenuItemNormaliseCoding
        '
        Me.MenuItemNormaliseCoding.Index = 1
        Me.MenuItemNormaliseCoding.Text = CType(configurationAppSettings.GetValue("MenuItemNormaliseCoding.Text", GetType(System.String)), String)
        '
        'MenuItemAutoCoding
        '
        Me.MenuItemAutoCoding.Index = 2
        Me.MenuItemAutoCoding.Text = CType(configurationAppSettings.GetValue("MenuItemAutoCoding.Text", GetType(System.String)), String)
        '
        'MenuItemStatistics
        '
        Me.MenuItemStatistics.Index = 4
        Me.MenuItemStatistics.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemNodeCounterPro})
        Me.MenuItemStatistics.Text = CType(configurationAppSettings.GetValue("MenuItemStatistics.Text", GetType(System.String)), String)
        '
        'MenuItemNodeCounterPro
        '
        Me.MenuItemNodeCounterPro.Index = 0
        Me.MenuItemNodeCounterPro.Text = CType(configurationAppSettings.GetValue("MenuItemNodeCounterPro.Text", GetType(System.String)), String)
        '
        'MenuItemAdministration
        '
        Me.MenuItemAdministration.Index = 4
        Me.MenuItemAdministration.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemControlAccess, Me.MenuItemUserManagement, Me.MenuItemAuthority, Me.MenuItem13, Me.MenuItemValidation, Me.MenuItemVisibility, Me.MenuItemWebSeparator, Me.MenuItemLog, Me.MenuItemWebStats})
        Me.MenuItemAdministration.Text = CType(configurationAppSettings.GetValue("MenuItemAdministration.Text", GetType(System.String)), String)
        Me.MenuItemAdministration.Visible = False
        '
        'MenuItemControlAccess
        '
        Me.MenuItemControlAccess.Index = 0
        Me.MenuItemControlAccess.Text = CType(configurationAppSettings.GetValue("MenuItemControlAccess.Text", GetType(System.String)), String)
        '
        'MenuItemUserManagement
        '
        Me.MenuItemUserManagement.Index = 1
        Me.MenuItemUserManagement.Text = CType(configurationAppSettings.GetValue("MenuItemUserManagement.Text", GetType(System.String)), String)
        Me.MenuItemUserManagement.Visible = False
        '
        'MenuItemAuthority
        '
        Me.MenuItemAuthority.Enabled = False
        Me.MenuItemAuthority.Index = 2
        Me.MenuItemAuthority.Text = CType(configurationAppSettings.GetValue("MenuItemAuthority.Text", GetType(System.String)), String)
        '
        'MenuItem13
        '
        Me.MenuItem13.Index = 3
        Me.MenuItem13.Text = "-"
        '
        'MenuItemValidation
        '
        Me.MenuItemValidation.Index = 4
        Me.MenuItemValidation.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemMakeValid, Me.MenuItemMakeInvalid})
        Me.MenuItemValidation.Text = CType(configurationAppSettings.GetValue("MenuItemValidation.Text", GetType(System.String)), String)
        '
        'MenuItemMakeValid
        '
        Me.MenuItemMakeValid.Index = 0
        Me.MenuItemMakeValid.Text = CType(configurationAppSettings.GetValue("MenuItemMakeValid.Text", GetType(System.String)), String)
        '
        'MenuItemMakeInvalid
        '
        Me.MenuItemMakeInvalid.Index = 1
        Me.MenuItemMakeInvalid.Text = CType(configurationAppSettings.GetValue("MenuItemMakeInvalid.Text", GetType(System.String)), String)
        '
        'MenuItemVisibility
        '
        Me.MenuItemVisibility.Index = 5
        Me.MenuItemVisibility.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemMakeVisible, Me.MenuItemMakeInvisible})
        Me.MenuItemVisibility.Text = CType(configurationAppSettings.GetValue("MenuItemVisibility.Text", GetType(System.String)), String)
        '
        'MenuItemMakeVisible
        '
        Me.MenuItemMakeVisible.Index = 0
        Me.MenuItemMakeVisible.Text = CType(configurationAppSettings.GetValue("MenuItemMakeVisible.Text", GetType(System.String)), String)
        '
        'MenuItemMakeInvisible
        '
        Me.MenuItemMakeInvisible.Index = 1
        Me.MenuItemMakeInvisible.Text = CType(configurationAppSettings.GetValue("MenuItemMakeInvisible.Text", GetType(System.String)), String)
        '
        'MenuItemWebSeparator
        '
        Me.MenuItemWebSeparator.Index = 6
        Me.MenuItemWebSeparator.Text = "-"
        Me.MenuItemWebSeparator.Visible = False
        '
        'MenuItemLog
        '
        Me.MenuItemLog.Index = 7
        Me.MenuItemLog.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemLogViewer, Me.MenuItemClearLog})
        Me.MenuItemLog.Text = CType(configurationAppSettings.GetValue("MenuItemLog.Text", GetType(System.String)), String)
        Me.MenuItemLog.Visible = False
        '
        'MenuItemLogViewer
        '
        Me.MenuItemLogViewer.Index = 0
        Me.MenuItemLogViewer.Text = CType(configurationAppSettings.GetValue("MenuItemLogViewer.Text", GetType(System.String)), String)
        '
        'MenuItemClearLog
        '
        Me.MenuItemClearLog.Index = 1
        Me.MenuItemClearLog.Text = CType(configurationAppSettings.GetValue("MenuItemClearLog.Text", GetType(System.String)), String)
        '
        'MenuItemWebStats
        '
        Me.MenuItemWebStats.Index = 8
        Me.MenuItemWebStats.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemGlobalStats, Me.MenuItemMonthlyStats})
        Me.MenuItemWebStats.Text = CType(configurationAppSettings.GetValue("MenuItemWebStats.Text", GetType(System.String)), String)
        Me.MenuItemWebStats.Visible = False
        '
        'MenuItemGlobalStats
        '
        Me.MenuItemGlobalStats.Index = 0
        Me.MenuItemGlobalStats.Text = CType(configurationAppSettings.GetValue("MenuItemGlobalStats.Text", GetType(System.String)), String)
        '
        'MenuItemMonthlyStats
        '
        Me.MenuItemMonthlyStats.Index = 1
        Me.MenuItemMonthlyStats.Text = CType(configurationAppSettings.GetValue("MenuItemMonthlyStats.Text", GetType(System.String)), String)
        '
        'MenuItemReports
        '
        Me.MenuItemReports.Index = 5
        Me.MenuItemReports.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemInventoryReport, Me.MenuItemIUInventoryReport, Me.MenuItemCatalogReport, Me.MenuItemInstalationUnitsBySeriesReport, Me.MenuItemIUListReport, Me.MenuItemSeriesListReport, Me.MenuItemClassificationPlanReport, Me.MenuItemControlAccessReport, Me.MenuItemAllControlAccessReport, Me.MenuItemPhyslocReport, Me.MenuItemAuthorsListReport})
        Me.MenuItemReports.Text = CType(configurationAppSettings.GetValue("MenuItemReports.Text", GetType(System.String)), String)
        Me.MenuItemReports.Visible = False
        '
        'MenuItemInventoryReport
        '
        Me.MenuItemInventoryReport.Index = 0
        Me.MenuItemInventoryReport.Text = CType(configurationAppSettings.GetValue("MenuItemInventoryReport.Text", GetType(System.String)), String)
        '
        'MenuItemIUInventoryReport
        '
        Me.MenuItemIUInventoryReport.Index = 1
        Me.MenuItemIUInventoryReport.Text = CType(configurationAppSettings.GetValue("MenuItemIUInventoryReport.Text", GetType(System.String)), String)
        '
        'MenuItemCatalogReport
        '
        Me.MenuItemCatalogReport.Index = 2
        Me.MenuItemCatalogReport.Text = CType(configurationAppSettings.GetValue("MenuItemCatalogReport.Text", GetType(System.String)), String)
        '
        'MenuItemInstalationUnitsBySeriesReport
        '
        Me.MenuItemInstalationUnitsBySeriesReport.Index = 3
        Me.MenuItemInstalationUnitsBySeriesReport.Text = CType(configurationAppSettings.GetValue("MainForm.MenuItemInstalationUnitsBySeriesReport.Text", GetType(System.String)), String)
        '
        'MenuItemIUListReport
        '
        Me.MenuItemIUListReport.Index = 4
        Me.MenuItemIUListReport.Text = CType(configurationAppSettings.GetValue("MenuItemIUListReport.Text", GetType(System.String)), String)
        '
        'MenuItemSeriesListReport
        '
        Me.MenuItemSeriesListReport.Index = 5
        Me.MenuItemSeriesListReport.Text = CType(configurationAppSettings.GetValue("MenuItemSeriesListReport.Text", GetType(System.String)), String)
        '
        'MenuItemClassificationPlanReport
        '
        Me.MenuItemClassificationPlanReport.Index = 6
        Me.MenuItemClassificationPlanReport.Text = CType(configurationAppSettings.GetValue("MenuItemClassificationPlanReport.Text", GetType(System.String)), String)
        '
        'MenuItemControlAccessReport
        '
        Me.MenuItemControlAccessReport.Index = 7
        Me.MenuItemControlAccessReport.Text = CType(configurationAppSettings.GetValue("MainFormMenuItemControlAccessReport.Text", GetType(System.String)), String)
        '
        'MenuItemAllControlAccessReport
        '
        Me.MenuItemAllControlAccessReport.Index = 8
        Me.MenuItemAllControlAccessReport.Text = CType(configurationAppSettings.GetValue("MenuItemAllControlAccessReport.Text", GetType(System.String)), String)
        '
        'MenuItemPhyslocReport
        '
        Me.MenuItemPhyslocReport.Index = 9
        Me.MenuItemPhyslocReport.Text = "Relatrio de localizao..."
        '
        'MenuItemAuthorsListReport
        '
        Me.MenuItemAuthorsListReport.Index = 10
        Me.MenuItemAuthorsListReport.Text = CType(configurationAppSettings.GetValue("MenuItemAuthorsListReport.Text", GetType(System.String)), String)
        '
        'MenuItemIncorporationReports
        '
        Me.MenuItemIncorporationReports.Index = 6
        Me.MenuItemIncorporationReports.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemIncorporationResumeReport, Me.MenuItemIncorporationListingReport, Me.MenuItemIncorporationTransportUnitsReport, Me.MenuItemIncorporationDeliveryCertificate})
        Me.MenuItemIncorporationReports.Text = "&Relatrios"
        Me.MenuItemIncorporationReports.Visible = False
        '
        'MenuItemIncorporationResumeReport
        '
        Me.MenuItemIncorporationResumeReport.Index = 0
        Me.MenuItemIncorporationResumeReport.Text = "&Resumo..."
        '
        'MenuItemIncorporationListingReport
        '
        Me.MenuItemIncorporationListingReport.Index = 1
        Me.MenuItemIncorporationListingReport.Text = "&Listagem..."
        '
        'MenuItemIncorporationTransportUnitsReport
        '
        Me.MenuItemIncorporationTransportUnitsReport.Index = 2
        Me.MenuItemIncorporationTransportUnitsReport.Text = "&Unidades de transporte..."
        '
        'MenuItemIncorporationDeliveryCertificate
        '
        Me.MenuItemIncorporationDeliveryCertificate.Index = 3
        Me.MenuItemIncorporationDeliveryCertificate.Text = "&Auto de entrega..."
        '
        'MenuItemAbout
        '
        Me.MenuItemAbout.Index = 7
        Me.MenuItemAbout.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemHelpdesk, Me.MenuItemSupport, Me.MenuItemAboutThisVersion})
        Me.MenuItemAbout.Text = CType(configurationAppSettings.GetValue("MenuItemHelp.Text", GetType(System.String)), String)
        '
        'MenuItemHelpdesk
        '
        Me.MenuItemHelpdesk.Index = 0
        Me.MenuItemHelpdesk.Text = CType(configurationAppSettings.GetValue("MenuItemHelpdesk.Text", GetType(System.String)), String)
        '
        'MenuItemSupport
        '
        Me.MenuItemSupport.Index = 1
        Me.MenuItemSupport.Text = CType(configurationAppSettings.GetValue("MenuItemSupport.Text", GetType(System.String)), String)
        '
        'MenuItemAboutThisVersion
        '
        Me.MenuItemAboutThisVersion.Index = 2
        Me.MenuItemAboutThisVersion.Text = CType(configurationAppSettings.GetValue("MenuItemAboutThisVersion.Text", GetType(System.String)), String)
        '
        'MenuItem11
        '
        Me.MenuItem11.Index = 8
        Me.MenuItem11.Text = ""
        '
        'OtherFindAidIcons
        '
        Me.OtherFindAidIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth24Bit
        Me.OtherFindAidIcons.ImageSize = New System.Drawing.Size(16, 16)
        Me.OtherFindAidIcons.ImageStream = CType(resources.GetObject("OtherFindAidIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.OtherFindAidIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'GenreFormIcons
        '
        Me.GenreFormIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth24Bit
        Me.GenreFormIcons.ImageSize = New System.Drawing.Size(16, 16)
        Me.GenreFormIcons.ImageStream = CType(resources.GetObject("GenreFormIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.GenreFormIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'ViewModeIcons
        '
        Me.ViewModeIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth24Bit
        Me.ViewModeIcons.ImageSize = New System.Drawing.Size(24, 31)
        Me.ViewModeIcons.ImageStream = CType(resources.GetObject("ViewModeIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ViewModeIcons.TransparentColor = System.Drawing.Color.White
        '
        'UpDownArrowButtons
        '
        Me.UpDownArrowButtons.ImageSize = New System.Drawing.Size(20, 20)
        Me.UpDownArrowButtons.ImageStream = CType(resources.GetObject("UpDownArrowButtons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.UpDownArrowButtons.TransparentColor = System.Drawing.Color.Transparent
        '
        'ContainerTypeIcons
        '
        Me.ContainerTypeIcons.ImageSize = New System.Drawing.Size(16, 16)
        Me.ContainerTypeIcons.ImageStream = CType(resources.GetObject("ContainerTypeIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ContainerTypeIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'AltFormAvailIcons
        '
        Me.AltFormAvailIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth24Bit
        Me.AltFormAvailIcons.ImageSize = New System.Drawing.Size(16, 16)
        Me.AltFormAvailIcons.ImageStream = CType(resources.GetObject("AltFormAvailIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.AltFormAvailIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'imglButtons
        '
        Me.imglButtons.ImageSize = New System.Drawing.Size(18, 18)
        Me.imglButtons.ImageStream = CType(resources.GetObject("imglButtons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.imglButtons.TransparentColor = System.Drawing.Color.Transparent
        '
        'MainForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(944, 401)
        Me.Controls.Add(Me.RightPanel)
        Me.Controls.Add(Me.StatusBar)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Menu = Me.MainMenu
        Me.MinimumSize = New System.Drawing.Size(700, 0)
        Me.Name = "MainForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.RightPanel.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Form Events"

    Public Sub New(ByVal ProcessInfoName As String)
        Me.New()

        Me.ProcessInfoName = ProcessInfoName

        ' adjust UI based on user profile
        SetupUserProfile()

        ' adjust UI based on available settings
        MenuItemWebSearch.Visible = Constant("AdvancedWebSearchURL").Length > 0
        MenuItemWebStats.Visible = Constant("MonthlyStatsURL").Length > 0 And Constant("GlobalStatsURL").Length > 0
        MenuItemLog.Visible = Constant("LogViewerURL").Length > 0
        MenuItemWebSeparator.Visible = MenuItemWebStats.Visible OrElse MenuItemLog.Visible

        SetFormTitle("[" & myProcessInfoName & "]")
    End Sub

    Private Sub MainForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.WindowState = FormWindowState.Maximized
        Me.myLazyNodeDataChanged = False
        LoadApplicationSettings()

        If myProgramState.OpenChangeLongOnLoad Then
            ShowChangeLogOnLoad()
        End If

        OpenFondsOnLoad()

    End Sub

    Private Sub MainForm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        UploadSelectedLazyNode()
        SaveApplicationSettings()
        Logger.Append(myProcessInfoName, Logger.LogActions.CloseApplication, LogMessage("Log.ClosedApplication"))
    End Sub



#End Region


#Region "Methods that display external forms"

    Private Sub OpenFondsOnLoad()
        Dim FondsToOpen As LazyNode
        Dim ID As Integer = myProgramState.LastOpenedFonds
        Dim LastUsedNode As LazyNode

        If ID <> 0 Then ' Load Last Opened Fonds
            Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
            Try
                Dim RootNode As LazyNode = New SQLLazyNode(SQLServerSettings.Item("ServerAddress"), _
                                                           SQLServerSettings.Item("Database"), _
                                                           SQLServerSettings.Item("Username"), _
                                                           SQLServerSettings.Item("Password"), _
                                                           ID)

                If myProgramState.LastUsedNode <> 0 Then
                    LastUsedNode = New SQLLazyNode(SQLServerSettings.Item("ServerAddress"), _
                                                               SQLServerSettings.Item("Database"), _
                                                               SQLServerSettings.Item("Username"), _
                                                               SQLServerSettings.Item("Password"), _
                                                               myProgramState.LastUsedNode)
                    If LastUsedNode Is Nothing Then LastUsedNode = RootNode
                Else
                    LastUsedNode = RootNode
                End If
                FondsToOpen = RootNode
            Catch ex As SqlException
                MessageBoxes.MsgBoxSqlException(ex)
            Catch ex As Exception
                MessageBoxes.MsgBoxException(ex)
            End Try



            If Not FondsToOpen Is Nothing AndAlso FondsToOpen.ID <> 0 Then
                OpenFonds(FondsToOpen.ID, LastUsedNode)
            Else
                OpenFondsManager()
            End If

        Else ' Open Fonds Manager
            OpenFondsManager()
        End If
    End Sub

    Private Sub OpenFondsManager()
        Cursor.Current = Cursors.WaitCursor
        Dim frmFondsManager As New FondsManagerForm(myProcessInfoName, False, myProgramState)

        If frmFondsManager.ShowDialog() = DialogResult.OK AndAlso Not frmFondsManager.SelectedFonds Is Nothing Then
            ' get fonds ID and open it
            Dim FondsToOpen As LazyNode = frmFondsManager.SelectedFonds
            Dim SelectedNode As LazyNode = frmFondsManager.SelectedLazyNode

            OpenFonds(FondsToOpen.ID, SelectedNode)

        End If
        frmFondsManager.Dispose()
    End Sub

    Private Sub OpenControlAccess()
        Cursor.Current = Cursors.WaitCursor
        Dim frmControlAccess As ControlAccessForm

        If TreeView.RootTreeNode Is Nothing Then
            frmControlAccess = New ControlAccessForm
        Else
            frmControlAccess = New ControlAccessForm(CType(TreeView.RootLazyNode, SQLLazyNode).ID)
        End If
        frmControlAccess.ShowDialog()
    End Sub

    Private Sub OpenLogin()
        Dim frmLogin As New Authentication.LoginForm

        If frmLogin.ShowDialog() = DialogResult.OK Then
            ProcessInfoName = frmLogin.Username

            Logger.Append(myProcessInfoName, Logger.LogActions.Login, String.Format(LogMessage("Log.Login"), myProcessInfoName, Date.Now.ToString))
            SetupUserProfile()
        End If
        SetFormTitle("[" & myProcessInfoName & "]")
    End Sub

    Private Sub OpenAuthority()
        If Not (TreeView.SelectedLazyNode.OtherLevel = EAD.OTHERLEVEL_FONDS Or _
                TreeView.SelectedLazyNode.OtherLevel = EAD.OTHERLEVEL_SUBFONDS) Then
            Exit Sub
        End If
        Dim frmAuthority As New AuthoritiesForm(TreeView.SelectedLazyNode)
        frmAuthority.ShowDialog()
    End Sub

#End Region


#Region "Lazy TreeView Events"


    Private Sub TreeView_AfterSelect(ByVal sender As System.Object, _
                                     ByVal e As System.Windows.Forms.TreeViewEventArgs) _
                                     Handles TreeView.AfterSelect

        ' Nothing is selected. Exit please
        If e Is Nothing Then Exit Sub

        Dim TreeSelectedLazyNode As LazyNode = CType(e.Node.Tag, LazyNode)

        ' If the selected node is not the node currently being edited
        If Not EadEditor.LazyNode Is Nothing AndAlso EadEditor.LazyNode.ID <> TreeSelectedLazyNode.ID Then
            DisableControls()
            TreeView.SelectedLazyNode.Download()
            EditLazyNode(TreeView.SelectedLazyNode)
            EnableDisableMenuItems()
        End If
    End Sub

    Private Sub TreeView_BeforeSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles TreeView.BeforeSelect
        If e Is Nothing Then Exit Sub
        Dim TreeSelectedLazyNode As LazyNode = CType(e.Node.Tag, LazyNode)

        ' If the selected node is not the node currently being edited
        If Not EadEditor.LazyNode Is Nothing AndAlso EadEditor.LazyNode.ID <> TreeSelectedLazyNode.ID Then
            UploadSelectedLazyNode()
        End If
    End Sub

#End Region

#Region "Handlers for EAD Editor buttons "

    Private Sub NewNodeButton_Clicked(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EadEditor.NewButtonClicked
        If Not TreeView.SelectedNode Is Nothing Then
            TreeView.AppendNewChild(TreeView.SelectedNode.Parent, TreeView.SelectedLazyNode.OtherLevel)
        End If
    End Sub

    Private Sub ReplicateNodeButton_Clicked(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EadEditor.ReplicateButtonClicked
        If TreeView.SelectedNode Is Nothing Then Exit Sub

        Dim Button As MsgBoxResult = MsgBoxResult.Yes

        If TreeView.SelectedLazyNode.HasChildren Then
            Button = MsgBox(InfoMessage("ReplicateButton.ReplicateChildren"), MsgBoxStyle.Question + MsgBoxStyle.YesNoCancel)
        End If

        EadEditor.EnableReplicateButton(False)
        If Button = MsgBoxResult.Yes Then
            TreeView.CopyNode(TreeView.SelectedNode)
            TreeView.PasteNodes(TreeView.SelectedNode.Parent, True, True)
        ElseIf (Button = MsgBoxResult.No) Then
            TreeView.CopyNode(TreeView.SelectedNode)
            TreeView.PasteNodes(TreeView.SelectedNode.Parent, True, False)
        End If
        EadEditor.EnableReplicateButton(True)

    End Sub



    Private Sub PrintNodeButton_Clicked(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EadEditor.PrintButtonClicked
        Dim ReportDataSet As RecordDataSet = LazyNodeToRecordData(EadEditor.LazyNode)
        Dim Report As New RecordReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()
    End Sub



    Private Function LazyNodeToRecordData(ByVal Item As LazyNode) As RecordDataSet
        Dim RecordData As New RecordDataSet


        'Identity Area
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("CompleteUnitID"), Item.CompleteUnitId)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("OtherLevel"), VisualFieldLabel(Item.OtherLevel))
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("UnitTitle"), Item.UnitTitle)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("UnitDates"), Item.UnitDateInitial & "/" & Item.UnitDateFinal)

        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("UnitDateBulk"), Item.UnitDateBulk)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("UnitDateNotes"), Item.UnitDateNotes)

        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ExtentMl"), Item.ExtentMl)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ExtentPage"), Item.ExtentPage)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ExtentLeaf"), Item.ExtentLeaf)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ExtentBook"), Item.ExtentBook)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ExtentBox"), Item.ExtentBox)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ExtentMaco"), Item.ExtentMaco)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ExtentMacete"), Item.ExtentMacete)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ExtentFolder"), Item.ExtentFolder)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ExtentCover"), Item.ExtentCover)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ExtentCapilha"), Item.ExtentCapilha)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ExtentRoll"), Item.ExtentRoll)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ExtentAlbum"), Item.ExtentAlbum)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ExtentEnvelope"), Item.ExtentEnvelope)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ExtentOther"), Item.ExtentOther)

        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("Dimensions"), Item.Dimensions)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("Repository"), Item.Repository)

        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("GenreForm"), Item.GenreForm)

        If Not Item.ControlAccess Is Nothing Then
            ' handle multiple control access
            Dim ControlAccessString As String = ""
            For Each ControlAccessItem As ControlAccessItem In Item.ControlAccess
                ControlAccessString &= "- " & ControlAccessItem.Type & "/" & ControlAccessItem.Item & vbNewLine
            Next
            RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ControlAccess"), ControlAccessString)
        End If

        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("Abstract"), Item.Abstract)



        ' context area
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("OriginationAuthor"), Item.OriginationAuthor)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("OriginationAuthorAddress"), Item.OriginationAuthorAddress)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("OriginationNotary"), Item.OriginationNotary)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("OriginationScrivener"), Item.OriginationScrivener)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("OriginationDestination"), Item.OriginationDestination)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("OriginationDestinationAddress"), Item.OriginationDestinationAddress)

        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("BiogHist"), Item.BiogHist)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("CustodHist"), Item.CustodHist)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("AcqInfo"), Item.AcqInfo)

        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("GeogName"), Item.GeogName)

        ' Content Structure Area
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ScopeContent"), Item.ScopeContent)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("Appraisal"), Item.Appraisal)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("Accruals"), Item.Accruals)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("Arrangement"), Item.Arrangement)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("FilePlan"), Item.FilePlan)


        ' Use Access Area
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("LegalStatus"), Item.LegalStatus)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("AccessRestrict"), Item.AccessRestrict)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("PhysFacet"), Item.PhysFacet)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("UseRestrict"), Item.UseRestrict)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("LangMaterial"), Item.LangMaterial)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("PhysTech"), Item.PhysTech)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("MaterialSpec"), Item.MaterialSpec)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("OtherFindAid"), Item.OtherFindAid)

        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("PhysLoc"), Item.PhysLoc)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("OriginalNumbering"), Item.OriginalNumbering)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("PreviousLoc"), Item.PreviousLoc)


        ' Allied Material Area
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("OriginalsLoc"), Item.OriginalsLoc)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("AltFormAvail"), Item.AltFormAvail)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("RelatedMaterial"), Item.RelatedMaterial)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("SeparatedMaterial"), Item.SeparatedMaterial)

        If Not Item.Bibliography Is Nothing Then
            ' handle multiple bibrefs
            Dim BibliographyString As String = ""
            For Each BibRefItem As BibRefItem In Item.Bibliography
                BibliographyString &= "- " & BibRefItem.BibRef() & vbNewLine
            Next

            RecordData.Properties.AddPropertiesRow(VisualFieldLabel("Bibliography"), BibliographyString)
        End If


        ' Notes area
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("Note"), Item.Note)

        If Not Item.ArchivistNotes Is Nothing Then
            ' handle multiple archivist notes
            Dim ArchNotesString As String = ""
            For Each ArchNoteItem As ArchivistNotesItem In Item.ArchivistNotes
                ArchNotesString &= "- " & ArchNoteItem.NoteTitle & vbNewLine
            Next
            RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ArchivistNotes"), ArchNotesString)

        End If


        ' Description Control Area
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ProcessInfo"), Item.ProcessInfo)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ArchivistName"), Item.ProcessInfoName)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("ProcessInfoDate"), Item.ProcessInfoDate)
        RecordData.Properties.AddPropertiesRow(VisualFieldLabel("OtherDescriptiveData"), Item.OtherDescriptiveData)


        ' Add logos to report data
        Dim logoPath As String = CType(configurationAppSettings.GetValue("LogoPath", GetType(System.String)), String)
        Dim smallLogoPath As String = CType(configurationAppSettings.GetValue("SmallLogoPath", GetType(System.String)), String)

        Dim drow As DataRow = RecordData.Logo.NewRow
        drow(0) = Reports.GetLogo(logoPath)
        drow(1) = Reports.GetLogo(smallLogoPath)

        RecordData.Logo.Rows.Add(drow)

        Return RecordData
    End Function

#End Region


#Region "Some auxiliary methods"
    Public Property ProcessInfoName() As String
        Get
            Return myProcessInfoName
        End Get
        Set(ByVal Value As String)
            myProcessInfoName = Value
            TreeView.ProcessInfoName = Value
        End Set
    End Property

    ' Adjust interface based on user profile. 3 profiles supported -> administrator, revisor, others
    Private Sub SetupUserProfile()
        Dim ProcessInfoName As String = myProcessInfoName

        Dim UserProfile As String = (New SQLDataBase).getProfile(ProcessInfoName, ConfigurationSettings.AppSettings("Application.Code")).Profile

        If UserProfile = ConfigurationSettings.AppSettings("Profile.Administrator") Then
            MenuItemAdministration.Visible = True
            MenuItemImport.Enabled = True
            MenuItemRemove.Enabled = True
        ElseIf UserProfile = ConfigurationSettings.AppSettings("Profile.Revisor") Then
            MenuItemAdministration.Visible = True
            MenuItemImport.Enabled = True
            MenuItemRemove.Enabled = True
        Else
            MenuItemAdministration.Visible = False
            MenuItemImport.Enabled = False
            MenuItemRemove.Enabled = False
        End If
    End Sub

    '    Private Sub OpenInternetExplorer(ByVal URL As String)
    '        Dim ie As New SHDocVw.InternetExplorerClass
    '        Dim wb As IWebBrowserApp = CType(ie, IWebBrowserApp)
    '        wb.Visible = True
    '        wb.Navigate(URL, Nothing, Nothing, Nothing, Nothing)
    '    End Sub


    Private Sub SetFormTitle(ByVal Title As String)
        Me.Text = GetStandardFormTitle() & " " & Title
    End Sub

    Private Function GetStandardFormTitle() As String
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Return String.Format(CStr(configurationAppSettings.GetValue("MainForm.Text", GetType(System.String))), CStr(configurationAppSettings.GetValue("Application.Version", GetType(System.String))))
    End Function



    'Private Sub SaveSelectedNode()
    '    Dim LazyNode As LazyNode = EadEditor.LazyNode

    '    CleanNodeTakenCache()
    '    TreeView.UpdateTreeNode(TreeView.SelectedNode)
    '    myLazyNodeDataChanged = False
    '    EadEditor.EnableSaveButton(False)

    '    LazyNode.TakenBy = ""
    '    LazyNode.Upload()

    '    Logger.Append(myProcessInfoName, Logger.LogActions.EditNode, String.Format(LogMessage("Log.EditNode"), LazyNode.OtherLevel, LazyNode.UnitId))

    '    'Dim MustUpdateCompleteUnitId As Boolean = LazyNode.MustUpdateCompleteUnitId
    '    Dim MustUpdateCompleteUnitId As Boolean = MenuItemAutoUpdateCompleteUnitID.Checked
    '    If MustUpdateCompleteUnitId AndAlso LazyNode.HasChildren Then
    '        Dim ProgressDialogMaxValue As Integer = LazyNode.DescendantsCount
    '        UpdateCompleteUnitID(TreeView.SelectedLazyNode, ProgressDialogMaxValue)
    '    End If


    'End Sub


    Private Sub UploadSelectedLazyNode()
        Dim LazyNode As LazyNode = EadEditor.LazyNode

        ' nothing to save, so exit sub
        If LazyNode Is Nothing OrElse Not myLazyNodeDataChanged Then Exit Sub

        If MenuItemAskBeforeSave.Checked AndAlso _
           MsgBox(InfoMessage("MainForm.AskBeforeSave"), MsgBoxStyle.YesNo Or MsgBoxStyle.Question Or MsgBoxStyle.DefaultButton1) _
                = MsgBoxResult.No Then
            ' don't save
            LazyNode.Download()
            TreeView.SelectedNode.Tag = LazyNode
            TreeView.UpdateTreeNode(TreeView.SelectedNode)
        Else
            ' do save

            EadEditor.EnableSaveButton(False)
            LazyNode.TakenBy = ""
            LazyNode.Valid = False
            'updated by lmferros
            LazyNode.ProcessInfoName = myProcessInfoName
            LazyNode.ProcessInfoDate = DateToStr(Now)
            '--
            LazyNode.Upload()

            Logger.Append(myProcessInfoName, Logger.LogActions.EditNode, String.Format(LogMessage("Log.EditNode"), LazyNode.OtherLevel, LazyNode.UnitId))

            'Dim MustUpdateCompleteUnitId As Boolean = LazyNode.MustUpdateCompleteUnitId
            Dim MustUpdateCompleteUnitId As Boolean = MenuItemAutoUpdateCompleteUnitID.Checked
            If MustUpdateCompleteUnitId AndAlso LazyNode.HasChildren Then
                Dim ProgressDialogMaxValue As Integer = LazyNode.DescendantsCount
                UpdateCompleteUnitID(TreeView.SelectedLazyNode, ProgressDialogMaxValue)
            End If

        End If

        CleanNodeTakenCache()
        TreeView.UpdateTreeNode(TreeView.SelectedNode)
        myLazyNodeDataChanged = False
    End Sub



    'Private Sub UploadSelectedLazyNode()
    '    'Dim LazyNode As LazyNode = TreeView.SelectedLazyNode
    '    Dim LazyNode As LazyNode = EadEditor.LazyNode

    '    If Not LazyNode Is Nothing AndAlso myLazyNodeDataChanged Then

    '        If Me.MenuItemAskBeforeSave.Checked AndAlso MsgBox(InfoMessage("MainForm.AskBeforeSave"), _
    '           MsgBoxStyle.YesNo Or MsgBoxStyle.Question Or MsgBoxStyle.DefaultButton1) = MsgBoxResult.No Then

    '            LazyNode.Download()
    '            myLazyNodeDataChanged = False
    '        Else
    '            LazyNode.UpdateProcessInfo(myProcessInfoName)
    '            LazyNode.Valid = False
    '            LazyNode.Visible = False

    '            SaveSelectedNode()
    '        End If
    '    End If
    'End Sub







    Private Sub UpdateCompleteUnitID(ByVal RootNode As LazyNode, ByVal ProgressDialogMaxValue As Integer)
        If Not MenuItemAutoUpdateCompleteUnitID.Checked Then Exit Sub

        Me.Enabled = False
        Dim iterator As New iterator(RootNode, False, ProgressDialogMaxValue)
        iterator.Start(iterator.Action.UpdateCompleteUnitId)
        Me.Enabled = True
        Me.Focus()
    End Sub



    Private Sub EnableDisableMenuItems()
        If TreeView.SelectedLazyNode Is Nothing Then Exit Sub

        Me.MenuItemMakeInvalid.Visible = TreeView.SelectedLazyNode.Valid
        Me.MenuItemMakeValid.Visible = Not Me.MenuItemMakeInvalid.Visible
        Me.MenuItemMakeInvisible.Visible = TreeView.SelectedLazyNode.Visible
        Me.MenuItemMakeVisible.Visible = Not MenuItemMakeInvisible.Visible
        Me.MenuItemVisibility.Visible = True
        Me.MenuItemAuthority.Enabled = TreeView.SelectedLazyNode.OtherLevel = EAD.OTHERLEVEL_FONDS Or TreeView.SelectedLazyNode.OtherLevel = EAD.OTHERLEVEL_SUBFONDS
    End Sub

    Private Sub AutoCoding(ByVal StartNumber As String, ByVal SelectedNodes As ArrayList)
        Dim Node As TreeNode
        Dim LazyNode As LazyNode
        Dim NewCode As String

        Dim Code As Integer = StrToInt(StartNumber)
        Cursor.Current = Cursors.WaitCursor
        For Each Node In SelectedNodes
            LazyNode = LazyTree.GetLazyNode(Node)
            NewCode = FormatNumericCode(Code, LazyNode.OtherLevel)
            LazyNode.UnitId = FormatReference(NewCode, StartNumber)
            Node.Text = LazyNode.UnitId
            LazyNode.Upload()
            UpdateCompleteUnitID(LazyNode, LazyNode.DescendantsCount)
            Code += 1
        Next
        Cursor.Current = Cursors.Default
    End Sub

    Private Function FormatReference(ByVal UnitIdAsInteger As Integer, ByVal ExampleIdAsPattern As String) As String
        Dim newID As Integer = UnitIdAsInteger

        If ExampleIdAsPattern Is Nothing Then Return String.Format("{0}", newID)
        Select Case ExampleIdAsPattern.Length
            Case 0 : Return newID
            Case 1 : Return String.Format("{0:0}", newID)
            Case 2 : Return String.Format("{0:00}", newID)
            Case 3 : Return String.Format("{0:000}", newID)
            Case 4 : Return String.Format("{0:0000}", newID)
            Case 5 : Return String.Format("{0:00000}", newID)
            Case 6 : Return String.Format("{0:000000}", newID)
            Case 7 : Return String.Format("{0:0000000}", newID)
            Case 8 : Return String.Format("{0:00000000}", newID)
            Case 9 : Return String.Format("{0:000000000}", newID)
            Case Else : Return String.Format("{0:0000000000}", newID)
        End Select

    End Function

    Private Sub NormaliseCoding(ByVal SelectedNodes As ArrayList)
        Dim Node As TreeNode
        Dim LazyNode As LazyNode
        Dim NewCode As String

        Dim Code As Integer
        Cursor.Current = Cursors.WaitCursor
        For Each Node In SelectedNodes
            Code = StrToInt(LazyTree.GetLazyNode(Node).UnitId)
            If Code <> 0 Then
                LazyNode = LazyTree.GetLazyNode(Node)
                NewCode = FormatNumericCode(Code, LazyNode.OtherLevel)
                LazyNode.UnitId = NewCode
                Node.Text = NewCode
                LazyNode.Upload()

                UpdateCompleteUnitID(LazyNode, LazyNode.DescendantsCount)
            End If
        Next
        Cursor.Current = Cursors.Default
    End Sub

    Private Function FormatNumericCode(ByVal Code As Integer, ByVal OtherLevel As String) As String
        If OtherLevel = EAD.OTHERLEVEL_SERIES OrElse _
               OtherLevel = EAD.OTHERLEVEL_SUBSERIES OrElse _
               OtherLevel = EAD.OTHERLEVEL_SUBSUBSERIES Then
            Return String.Format("{0:000}", Code)
        ElseIf OtherLevel = OTHERLEVEL_INSTALATIONUNIT Then
            Return String.Format("{0:0000}", Code)
        ElseIf OtherLevel = OTHERLEVEL_COMPOSEDDOCUMENT OrElse _
               OtherLevel = OTHERLEVEL_DOCUMENT Then
            Return String.Format("{0:00000}", Code)
        Else
            Dim ret As String = Chr(Code)
            Return ret.ToUpper
        End If
    End Function



    Private Function GetSelectedSortStyle() As LazyNode.SortingStyles
        If MenuItemSortByUnitID.Checked Then
            Return LazyNode.SortingStyles.ByUnitID

        ElseIf MenuItemSortByUnitDateInitial.Checked Then
            Return LazyNode.SortingStyles.ByUnitDateInitial

        ElseIf MenuItemSortByProcessInfoDate.Checked Then
            Return LazyNode.SortingStyles.ByProcessInfoDate

        ElseIf MenuItemSortByUnitTitle.Checked Then
            Return LazyNode.SortingStyles.ByUnitTitle

        ElseIf MenuItemSortByOtherLevel.Checked Then
            Return LazyNode.SortingStyles.ByOtherLevel
        Else
            Return LazyNode.SortingStyles.None
        End If
    End Function




    Private Sub DisableControls()
        Select Case myApplicationType
            Case ApplicationType.Client
                Me.MenuItemIncorporationReports.Visible = False

            Case ApplicationType.Standalone
                Me.MenuItemIncorporationReports.Visible = False

            Case ApplicationType.MiniDigitArq
                Me.MenuItem5.Visible = False
                Me.MenuItemMigrationNotes.Visible = False
                Me.MenuItemAdministration.Visible = False
                Me.MenuItemReports.Visible = False
                Me.MenuItemIncorporationReports.Visible = True
        End Select
    End Sub



    Private Sub EnableMenus(ByVal State As Boolean)
        Me.MenuItemEdit.Visible = State
        Me.MenuItemView.Visible = State
        Me.MenuItemTools.Visible = State
        Me.MenuItemReports.Visible = State
        Me.MenuItemImport.Visible = State
        Me.MenuItemExport.Visible = State
        Me.MenuItemFileSeparator1.Visible = State
        Me.MenuItemFileSeparator2.Visible = State
    End Sub



#End Region


#Region "Menu Events"

#Region "MenuItem File"

    Private Sub MenuItemNewFonds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemNewFonds.Click
        Dim ApplicationType As ApplicationType = GetApplicationType()
        Select Case ApplicationType
            Case ApplicationType.Client
                CreateNewFonds()
            Case ApplicationType.Standalone
                CreateNewFonds()
            Case ApplicationType.MiniDigitArq
                CreateNewFondsByTemplate()
        End Select
    End Sub

    Private Sub CreateNewFonds()
        UploadSelectedLazyNode()
        Dim frmNewFonds As New NewFondsForm

        If frmNewFonds.ShowDialog() = DialogResult.OK Then
            Try
                Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

                Dim NewFondsReference As String = frmNewFonds.GetCompleteUnitID()
                Dim FondsExist As Boolean = SQLLazyNode.GetFondsList(SQLServerSettings.Item("ServerAddress"), _
                                                            SQLServerSettings.Item("Database"), _
                                                            SQLServerSettings.Item("Username"), _
                                                            SQLServerSettings.Item("Password"), _
                                                            NewFondsReference).Count > 0



                If (Not FondsExist) OrElse _
                   (FondsExist AndAlso _
                        MsgBox(ErrorMessage("NewFonds.FondsAlreadyExists"), MsgBoxStyle.YesNo + MsgBoxStyle.Question, _
                        ErrorMessage("NewFonds.FondsAlreadyExistsTitle")) = MsgBoxResult.Yes) Then

                    Dim Node As LazyNode = SQLLazyNode.CreateNewFonds( _
                                                                SQLServerSettings.Item("ServerAddress"), _
                                                                SQLServerSettings.Item("Database"), _
                                                                SQLServerSettings.Item("Username"), _
                                                                SQLServerSettings.Item("Password"), _
                                                                frmNewFonds.GetUnitId(), _
                                                                frmNewFonds.GetUnitTitle(), _
                                                                myProcessInfoName, _
                                                                frmNewFonds.GetCountryCode, _
                                                                frmNewFonds.GetRepositoryCode, _
                                                                frmNewFonds.GetRepository())


                    TreeView.RootLazyNode = Node
                    TreeView.RootLazyNode.SortBy = GetSelectedSortStyle()
                    Logger.Append(myProcessInfoName, Logger.LogActions.OpenFonds, String.Format(LogMessage("Log.OpenFonds"), Node.UnitId & ":" & Node.UnitTitle))
                    EnableMenus(True)
                    TreeView.SelectedNode = TreeView.RootTreeNode
                    TreeView_AfterSelect(Me, Nothing)
                End If

            Catch ex As SqlException
                MessageBoxes.MsgBoxSqlException(ex)
            Catch ex As Exception
                MessageBoxes.MsgBoxException(ex)

            End Try
        End If
    End Sub

    Private Sub CreateNewFondsByTemplate()
        UploadSelectedLazyNode()
        Dim Filename As String = FONDSTEMPLATE_FILENAME
        If Not File.Exists(Filename) Then Exit Sub

        Cursor.Current = Cursors.WaitCursor

        Dim SourceFonds As LazyNode = New EADLazyNode(Filename)


        Try
            Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

            Dim Node As LazyNode = SQLLazyNode.CreateNewFonds( _
                                                        SQLServerSettings.Item("ServerAddress"), _
                                                        SQLServerSettings.Item("Database"), _
                                                        SQLServerSettings.Item("Username"), _
                                                        SQLServerSettings.Item("Password"), _
                                                        SourceFonds.UnitId(), _
                                                        SourceFonds.UnitTitle(), _
                                                        myProcessInfoName _
                                                    )

            TreeView.RootLazyNode = Node

            Dim DestinationFonds As LazyNode = TreeView.RootLazyNode
            Dim Importer As New Importer(DestinationFonds, SourceFonds)
            Importer.Import()
            TreeView.CollapseAll()
            TreeView.RefreshRootNode()

            TreeView.RootLazyNode.SortBy = GetSelectedSortStyle()

            Logger.Append(myProcessInfoName, Logger.LogActions.OpenFonds, String.Format(LogMessage("Log.OpenFonds"), Node.UnitId & ":" & Node.UnitTitle))
            EnableMenus(True)
            TreeView.SelectedNode = TreeView.RootTreeNode
            TreeView_AfterSelect(Me, Nothing)

            ' Calls iterator to calculate complete unit ids
            Dim iterator As New iterator(TreeView.SelectedLazyNode)
            iterator.Start(iterator.Action.UpdateCompleteUnitId)

            Cursor.Current = Cursors.Default

        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
        Catch ex As Exception
            MessageBoxes.MsgBoxException(ex)

        End Try
    End Sub

    Private Sub MenuItemFondsManager_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemFondsManager.Click
        UploadSelectedLazyNode()
        OpenFondsManager()
    End Sub

    Private Sub MenuItemLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemLogin.Click
        UploadSelectedLazyNode()
        OpenLogin()
    End Sub

    Private Sub MenuItemExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemExit.Click
        UploadSelectedLazyNode()
        Close()
    End Sub

#Region "Import / Export"

    Private Sub MenuItemImportEAD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemImportEAD.Click
        If TreeView.RootLazyNode Is Nothing Then Exit Sub

        Dim OpenFileDialog As New OpenFileDialog
        OpenFileDialog.Multiselect = False
        'OpenFileDialog.InitialDirectory() = Environment.GetFolderPath(Environment.SpecialFolder.Personal)
        OpenFileDialog.Filter = "Ficheiros EAD (*.ead)|*.ead"
        OpenFileDialog.Title = InfoMessage("OpenFileDialog.Title.ExternalEAD")


        Try
            If OpenFileDialog.ShowDialog() = DialogResult.OK Then
                Cursor.Current = Cursors.WaitCursor
                Dim Filename As String = OpenFileDialog.FileName
                Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
                Dim SourceFonds As LazyNode = New EADLazyNode(Filename)
                Dim DestinationFonds As LazyNode = TreeView.RootLazyNode
                Dim Importer As New Importer(DestinationFonds, SourceFonds)
                Importer.Import()
                TreeView.CollapseAll()
                TreeView.RefreshRootNode()
                Cursor.Current = Cursors.Default
            End If
        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
        Catch ex As Exception
            If ex.Message = "" Then
                MsgBox(ErrorMessage("OpenFileDialog.TooManyFilesSelected"), MsgBoxStyle.Exclamation)
            Else
                MessageBoxes.MsgBoxException(ex)
            End If
        End Try

    End Sub

    Private Sub MenuItemImportTabSeparatedText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemImportTabSeparatedText.Click
        If TreeView.SelectedLazyNode Is Nothing Then
            MsgBox(InfoMessage("Import.ElementNotSelected"), MsgBoxStyle.Information Or MsgBoxStyle.OKOnly)
            Exit Sub
        End If

        Dim OpenFileDialog As New OpenFileDialog
        OpenFileDialog.Multiselect = False
        'OpenFileDialog.InitialDirectory() = Environment.GetFolderPath(Environment.SpecialFolder.Personal)
        OpenFileDialog.Filter = "Texto (separado p/ tabulaes) (*.txt)|*.txt"
        OpenFileDialog.Title = InfoMessage("OpenFileDialog.Title.TabSeparatedFile")
        Try
            If OpenFileDialog.ShowDialog() = DialogResult.OK Then
                Cursor.Current = Cursors.WaitCursor
                Dim Filename As String = OpenFileDialog.FileName
                Dim DestinationFonds As LazyNode = TreeView.SelectedLazyNode
                Dim Importer As New Importer(DestinationFonds, Filename, myProcessInfoName)
                Importer.Import()
                TreeView.CollapseAll()
                TreeView.RefreshRootNode()
                Cursor.Current = Cursors.Default
                If Importer.ErrorCount > 0 Then
                    MsgBox(String.Format(InfoMessage("Import.TabSeparatedFile.ErrorsOccoured"), Importer.ErrorCount, Path.GetFileName(Filename)))
                Else
                    MsgBox(InfoMessage("Import.TabSeparatedFile.Success"))
                End If
            End If
        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
        Catch ex As Exception
            If ex.Message = "" Then
                MsgBox(ErrorMessage("OpenFileDialog.TooManyFilesSelected"), MsgBoxStyle.Exclamation)
            Else
                MessageBoxes.MsgBoxException(ex)
            End If
        End Try
    End Sub



    Private Sub MenuItemImportFonds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemImportFonds.Click
        Cursor.Current = Cursors.WaitCursor
        If TreeView.RootLazyNode Is Nothing Then Exit Sub


        ' Changed on version 3.0.0
        'Dim frmFondsManager As New FondsManagerForm("admin", True, myProgramState)
        Dim frmFondsManager As New FondsManagerForm(myProcessInfoName, True, myProgramState)
        Dim SourceFonds As LazyNode
        Dim DestinationFonds As LazyNode = TreeView.RootLazyNode

        If frmFondsManager.ShowDialog() <> DialogResult.OK Then Exit Sub
        SourceFonds = frmFondsManager.SelectedFonds()
        Dim Importer As New Importer(DestinationFonds, SourceFonds)
        Importer.Import()
        TreeView.CollapseAll()
        TreeView.RefreshRootNode()
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub MenuItemExportEAD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemExportEAD.Click
        Dim SaveFileDialog As New SaveFileDialog
        SaveFileDialog.Filter = "Ficheiros EAD (*.ead)|*.ead"
        SaveFileDialog.Title = InfoMessage("SaveFileDialog.Title.EAD")


        Try
            Dim OnlyExportVisibles As Boolean = MsgBox(InfoMessage("SaveFileDialog.EAD.Question"), MsgBoxStyle.YesNo Or MsgBoxStyle.Question, InfoMessage("SaveFileDialog.Title.EAD")) = MsgBoxResult.Yes
            SaveFileDialog.FileName = TreeView.RootLazyNode.CompleteUnitId.Replace("/", "-")
            If SaveFileDialog.ShowDialog() = DialogResult.OK Then
                Dim Filename As String = SaveFileDialog.FileName
                Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
                Dim ID As Integer = TreeView.RootLazyNode.ID
                Dim Exporter As New Exporter(SQLServerSettings.Item("ServerAddress"), _
                                             SQLServerSettings.Item("Database"), _
                                             SQLServerSettings.Item("Username"), _
                                             SQLServerSettings.Item("Password"), _
                                             Filename, _
                                             ID, _
                                             OnlyExportVisibles)
                Me.Enabled = False
                Exporter.Export()
            End If
        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
        Catch ex As Exception
            MessageBoxes.MsgBoxException(ex)
        Finally
            Me.Enabled = True
        End Try
    End Sub

    Private Sub MenuItemExportCALM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemExportCALM.Click
        Dim SaveFileDialog As New SaveFileDialog
        'OpenFileDialog.Multiselect = True
        'OpenFileDialog.InitialDirectory() = Environment.GetFolderPath(Environment.SpecialFolder.Personal)
        SaveFileDialog.Filter = "CALM Natural Format (*.txt)|*.txt"
        SaveFileDialog.Title = InfoMessage("Exportar CALM...")


        Try
            SaveFileDialog.FileName = TreeView.RootLazyNode.CompleteUnitId.Replace("/", "-")
            If SaveFileDialog.ShowDialog() = DialogResult.OK Then
                Dim Filename As String = SaveFileDialog.FileName
                Dim EADFilename As String = Path.GetFileNameWithoutExtension(Filename) & ".ead"
                Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
                Dim ID As Integer = TreeView.RootLazyNode.ID
                Dim Exporter As New Exporter(SQLServerSettings.Item("ServerAddress"), _
                                             SQLServerSettings.Item("Database"), _
                                             SQLServerSettings.Item("Username"), _
                                             SQLServerSettings.Item("Password"), EADFilename, _
                                             ID)
                Me.Enabled = False
                Exporter.Export()

                If Not Exporter.OperationCancelled Then
                    Dim xslt As XslTransform = New XslTransform
                    xslt.Load(EAD2CNF_XSLT_FILENAME)

                    Dim resolver As XmlUrlResolver = New XmlUrlResolver
                    resolver.Credentials = System.Net.CredentialCache.DefaultCredentials
                    xslt.Transform(EADFilename, Filename, resolver)
                    xslt = Nothing
                    File.Delete(EADFilename)
                End If

            End If
        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
        Catch ex As Exception
            MessageBoxes.MsgBoxException(ex)
        Finally
            Me.Enabled = True
        End Try

    End Sub


    Private Sub MenuItemExportDIF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemExportDIF.Click
        Dim SaveFileDialog As New SaveFileDialog
        SaveFileDialog.Filter = "DigitArq Interoperability Format (*.dif)|*.dif"
        SaveFileDialog.Title = InfoMessage("Exportar DIF...")


        Try
            Dim Result As DialogResult = MsgBox(InfoMessage("ImportExport.DIFWarning"), MsgBoxStyle.Question + MsgBoxStyle.YesNo)
            If Result = DialogResult.No Then Exit Sub

            SaveFileDialog.FileName = TreeView.SelectedLazyNode.CompleteUnitId.Replace("/", "-")
            If SaveFileDialog.ShowDialog() = DialogResult.OK Then
                Dim Filename As String = SaveFileDialog.FileName
                Dim EADFilename As String = Path.GetFileNameWithoutExtension(Filename) & ".dif"
                Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
                Dim ID As Integer = TreeView.RootLazyNode.ID
                Dim Exporter As New Exporter(SQLServerSettings.Item("ServerAddress"), _
                                             SQLServerSettings.Item("Database"), _
                                             SQLServerSettings.Item("Username"), _
                                             SQLServerSettings.Item("Password"), _
                                             EADFilename, _
                                             TreeView.SelectedLazyNode.CompleteUnitId)
                Me.Enabled = False
                Exporter.ExportPartialDIF()

            End If
        Catch ex As SqlException
            MessageBoxes.MsgBoxSqlException(ex)
        Catch ex As Exception
            MessageBoxes.MsgBoxException(ex)
        Finally
            Me.Enabled = True
        End Try
    End Sub

#End Region

#End Region

#Region "MenuItem Edit"

    Private Sub MenuItemCut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemCut.Click
        UploadSelectedLazyNode()
        TreeView.CutNodes(TreeView.SelectedNodes())
        MenuItemPaste.Enabled = True
    End Sub

    Private Sub MenuItemCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemCopy.Click
        UploadSelectedLazyNode()
        TreeView.CopyNodes(TreeView.SelectedNodes())
        MenuItemPaste.Enabled = True
    End Sub

    Private Sub MenuItemPaste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemPaste.Click
        UploadSelectedLazyNode()
        TreeView.PasteNodes(TreeView.SelectedNode, True, True)
        If TreeView.EditOperation = LazyTree.EditOperations.Cut Then
            MenuItemPaste.Enabled = False
        End If
    End Sub

    Private Sub MenuItemRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemRemove.Click
        UploadSelectedLazyNode()
        If TreeView.SelectedNodes.Count > 0 Then
            TreeView.RemoveNodes(TreeView.SelectedNodes.Clone)
        End If
    End Sub

    Private Sub MenuItemFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemFind.Click
        UploadSelectedLazyNode()
        If TreeView.RootLazyNode Is Nothing Then Exit Sub

        If mySearchForm Is Nothing Then
            mySearchForm = New SearchForm(CInt(TreeView.RootLazyNode.ID))
        End If


        Me.Enabled = False
        mySearchForm.Show()

        'If (mySearchForm.FormResult = DialogResult.OK) Then
        '    Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

        '    Dim ID As Integer = mySearchForm.SelectedNodeID
        '    Dim SelectedLazyNode As LazyNode = New SQLLazyNode( _
        '                                        SQLServerSettings.Item("ServerAddress"), _
        '                                        SQLServerSettings.Item("Database"), _
        '                                        SQLServerSettings.Item("Username"), _
        '                                        SQLServerSettings.Item("Password"), _
        '                                        ID)

        '    EditLazyNode(SelectedLazyNode)
        '    'EadEditor.LazyNode = SelectedLazyNode
        '    'TreeView.SelectedLazyNode = SelectedLazyNode
        '    'TreeView_AfterSelect(Me, Nothing)
        'End If



    End Sub

    'Private Sub DisplayLazyNode(ByVal LazyNode As LazyNode)
    '    If LazyNode Is Nothing Then Exit Sub
    '    Dim ApplicationType As ApplicationType = GetApplicationType()
    '    DisableControls()
    '    EadEditor.LazyNode = LazyNode
    '    EadEditor.Reload()
    '    EnableDisableMenuItems()
    'End Sub






    'Private Sub MenuItemFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemFind.Click
    '    UploadSelectedLazyNode()
    '    If TreeView.RootLazyNode Is Nothing Then Exit Sub

    '    Dim StartNode As LazyNode
    '    If TreeView.RootLazyNode Is TreeView.SelectedLazyNode Then
    '        StartNode = TreeView.RootLazyNode
    '    Else
    '        Dim Result As DialogResult = MsgBox(InfoMessage("SearchReplace.StartFromRootNode"), MsgBoxStyle.Question + MsgBoxStyle.YesNoCancel + MsgBoxStyle.DefaultButton2)
    '        If Result = MsgBoxResult.Yes Then
    '            StartNode = TreeView.RootLazyNode
    '        ElseIf Result = DialogResult.No Then
    '            StartNode = TreeView.SelectedLazyNode
    '        Else
    '            Exit Sub
    '        End If
    '    End If

    '    Dim frmSearch As New SearchReplaceForm(StartNode, TreeView, Me.OtherLevelIcons, False)
    '    frmSearch.TopMost = True
    '    frmSearch.Show()
    'End Sub

    Private Sub MenuItemReplace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemReplace.Click
        UploadSelectedLazyNode()
        If TreeView.RootLazyNode Is Nothing Then Exit Sub

        Dim StartNode As LazyNode
        If TreeView.RootLazyNode Is TreeView.SelectedLazyNode Then
            StartNode = TreeView.RootLazyNode
        Else
            Dim Result As DialogResult = MsgBox(InfoMessage("SearchReplace.StartFromRootNode"), MsgBoxStyle.Question + MsgBoxStyle.YesNoCancel + MsgBoxStyle.DefaultButton2)
            If Result = MsgBoxResult.Yes Then
                StartNode = TreeView.RootLazyNode
            ElseIf Result = DialogResult.No Then
                StartNode = TreeView.SelectedLazyNode
            Else
                Exit Sub
            End If
        End If

        Dim frmReplace As New SearchReplaceForm(StartNode, TreeView, Me.OtherLevelIcons)
        frmReplace.TopMost = True
        frmReplace.Show()
        TreeView.CollapseAll()
        TreeView.SelectedNode = TreeView.RootTreeNode
    End Sub

#End Region

#Region "MenuItem View"

    Private Sub MenuItemAllFields_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemAllFields.Click
        UploadSelectedLazyNode()
        MenuItemMostFrequentFields.Checked = False
        MenuItemAllFields.Checked = True
        MenuItemMandatoryFields.Checked = False
        EadEditor.ViewMode = ViewMode.All
        EadEditor.Reload()

        'Me.myFieldPresentationMode = ViewMode.All
        'TreeView_AfterSelect(Nothing, Nothing)
    End Sub

    Private Sub MenuItemMostFrequentFields_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemMostFrequentFields.Click
        UploadSelectedLazyNode()
        MenuItemMostFrequentFields.Checked = True
        MenuItemAllFields.Checked = False
        MenuItemMandatoryFields.Checked = False

        EadEditor.ViewMode = ViewMode.Frequent
        EadEditor.Reload()


        'Me.myFieldPresentationMode = ViewMode.Frequent
        'TreeView_AfterSelect(Nothing, Nothing)
    End Sub

    Private Sub MenuItemMandatoryFields_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemMandatoryFields.Click
        UploadSelectedLazyNode()
        MenuItemMostFrequentFields.Checked = False
        MenuItemAllFields.Checked = False
        MenuItemMandatoryFields.Checked = True

        EadEditor.ViewMode = ViewMode.Mandatory
        EadEditor.Reload()

    End Sub

    Private Sub MenuItemTextSizeSmall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemTextSizeSmall.Click
        DigitarqFonts.StandardFont = DigitarqFonts.RegularFont
        EadEditor.Reload()
        MenuItemTextSizeSmall.Checked = True
        MenuItemTextSizeMedium.Checked = False
        MenuItemTextSizeLarge.Checked = False
    End Sub

    Private Sub MenuItemTextSizeMedium_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemTextSizeMedium.Click
        DigitarqFonts.StandardFont = DigitarqFonts.MediumFont
        EadEditor.Reload()
        MenuItemTextSizeSmall.Checked = False
        MenuItemTextSizeMedium.Checked = True
        MenuItemTextSizeLarge.Checked = False
    End Sub

    Private Sub MenuItemTextSizeLarge_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemTextSizeLarge.Click
        DigitarqFonts.StandardFont = DigitarqFonts.LargeFont
        EadEditor.Reload()

        MenuItemTextSizeSmall.Checked = False
        MenuItemTextSizeMedium.Checked = False
        MenuItemTextSizeLarge.Checked = True


    End Sub

    Private Sub MenuItemAutoUpdateCompleteUnitID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemAutoUpdateCompleteUnitID.Click
        MenuItemAutoUpdateCompleteUnitID.Checked = Not MenuItemAutoUpdateCompleteUnitID.Checked
        TreeView.AutoUpdateCompleteUnitID = MenuItemAutoUpdateCompleteUnitID.Checked
    End Sub

    Private Sub MenuItemExpandAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemExpandAll.Click
        UploadSelectedLazyNode()
        TreeView.ExpandAll()
    End Sub

    Private Sub MenuItemCollapseAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemCollapseAll.Click
        UploadSelectedLazyNode()
        TreeView.CollapseAll()
    End Sub

    Private Sub MenuItemSortByUnitDateInitial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemSortByUnitDateInitial.Click
        UploadSelectedLazyNode()
        MenuItemSortByUnitID.Checked = False
        MenuItemSortByUnitDateInitial.Checked = True
        MenuItemSortByOtherLevel.Checked = False
        MenuItemSortByProcessInfoDate.Checked = False
        MenuItemSortByUnitTitle.Checked = False

        myProgramState.SortBy = LazyNode.SortingStyles.ByUnitDateInitial

        If Not TreeView.RootLazyNode Is Nothing Then
            TreeView.RootLazyNode.SortBy = LazyNode.SortingStyles.ByUnitDateInitial
            'TreeView.CollapseAll()
            TreeView.RefreshRootNode()
            TreeView.SelectedNode = TreeView.RootTreeNode
        End If
    End Sub

    Private Sub MenuItemSortByUnitID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemSortByUnitID.Click
        UploadSelectedLazyNode()
        MenuItemSortByUnitID.Checked = True
        MenuItemSortByUnitDateInitial.Checked = False
        MenuItemSortByOtherLevel.Checked = False
        MenuItemSortByProcessInfoDate.Checked = False
        MenuItemSortByUnitTitle.Checked = False

        myProgramState.SortBy = LazyNode.SortingStyles.ByUnitID


        If Not TreeView.RootLazyNode Is Nothing Then
            TreeView.RootLazyNode.SortBy = LazyNode.SortingStyles.ByUnitID
            'TreeView.CollapseAll()
            TreeView.RefreshRootNode()
            TreeView.SelectedNode = TreeView.RootTreeNode

        End If
    End Sub

    Private Sub MenuItemSortByUnitTitle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemSortByUnitTitle.Click
        UploadSelectedLazyNode()
        MenuItemSortByUnitID.Checked = False
        MenuItemSortByUnitDateInitial.Checked = False
        MenuItemSortByOtherLevel.Checked = False
        MenuItemSortByProcessInfoDate.Checked = False
        MenuItemSortByUnitTitle.Checked = True

        myProgramState.SortBy = LazyNode.SortingStyles.ByUnitTitle

        If Not TreeView.RootLazyNode Is Nothing Then
            TreeView.RootLazyNode.SortBy = LazyNode.SortingStyles.ByUnitTitle
            'TreeView.CollapseAll()
            TreeView.RefreshRootNode()
            TreeView.SelectedNode = TreeView.RootTreeNode

        End If

    End Sub

    Private Sub MenuItemSortByOtherLevel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemSortByOtherLevel.Click
        UploadSelectedLazyNode()
        MenuItemSortByUnitID.Checked = False
        MenuItemSortByUnitDateInitial.Checked = False
        MenuItemSortByOtherLevel.Checked = True
        MenuItemSortByProcessInfoDate.Checked = False
        MenuItemSortByUnitTitle.Checked = False

        myProgramState.SortBy = LazyNode.SortingStyles.ByOtherLevel

        If Not TreeView.RootLazyNode Is Nothing Then
            TreeView.RootLazyNode.SortBy = LazyNode.SortingStyles.ByOtherLevel
            'TreeView.CollapseAll()
            TreeView.RefreshRootNode()
            TreeView.SelectedNode = TreeView.RootTreeNode
        End If
    End Sub

    Private Sub MenuItemSortByProcessInfoDate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemSortByProcessInfoDate.Click
        UploadSelectedLazyNode()
        MenuItemSortByUnitID.Checked = False
        MenuItemSortByUnitDateInitial.Checked = False
        MenuItemSortByOtherLevel.Checked = False
        MenuItemSortByProcessInfoDate.Checked = True
        MenuItemSortByUnitTitle.Checked = False

        myProgramState.SortBy = LazyNode.SortingStyles.ByProcessInfoDate

        If Not TreeView.RootLazyNode Is Nothing Then
            TreeView.RootLazyNode.SortBy = LazyNode.SortingStyles.ByProcessInfoDate
            'TreeView.CollapseAll()
            TreeView.RefreshRootNode()
            TreeView.SelectedNode = TreeView.RootTreeNode

        End If
    End Sub

    Private Sub MenuItemAskBeforeSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemAskBeforeSave.Click
        MenuItemAskBeforeSave.Checked = Not MenuItemAskBeforeSave.Checked
    End Sub

    Private Sub MenuItemAskBeforeRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemAskBeforeRemove.Click
        MenuItemAskBeforeRemove.Checked = Not MenuItemAskBeforeRemove.Checked
        Me.TreeView.AskBeforeRemove = MenuItemAskBeforeRemove.Checked
    End Sub


    Private Sub MenuItemMigrationNotes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemMigrationNotes.Click

        MenuItemMigrationNotes.Checked = Not MenuItemMigrationNotes.Checked

        If MenuItemMigrationNotes.Checked Then
            myFloatingForm = New FloatingForm
            myFloatingForm.Title = VisualFieldLabel("OtherDescriptiveData")
            myFloatingForm.Field = LazyNode.LazyNodeFields.OtherDescriptiveData
            myFloatingForm.LazyNode = TreeView.SelectedLazyNode
            myFloatingForm.Show()
        Else
            myFloatingForm.Dispose()
        End If

    End Sub

    Private Sub MenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Throw New Exception("Ups!")
    End Sub

#End Region

#Region "MenuItem Tools"

    Private Sub MenuItemValidate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemValidate.Click
        If TreeView.SelectedNode Is Nothing Then Exit Sub

        UploadSelectedLazyNode()

        Dim result As MsgBoxResult
        If Not TreeView.RootLazyNode Is TreeView.SelectedLazyNode Then
            result = MsgBox(InfoMessage("Validation.StartFromRoot"), MsgBoxStyle.Question + MsgBoxStyle.YesNoCancel + MsgBoxStyle.DefaultButton2)
        Else
            result = MsgBoxResult.Yes
        End If

        If result = MsgBoxResult.Cancel Then
            Exit Sub
        ElseIf result = MsgBoxResult.No Then
            Dim Validator As New Validator(TreeView.SelectedLazyNode, TreeView, OtherLevelIcons)
            Me.Enabled = False
            Validator.Validate(True)
            Me.Enabled = True
        Else
            Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
            Dim ElementCounter As Integer = SQLLazyNode.CountByOtherLevel(SQLServerSettings.Item("ServerAddress"), _
                                             SQLServerSettings.Item("Database"), _
                                             SQLServerSettings.Item("Username"), _
                                             SQLServerSettings.Item("Password"), _
                                             TreeView.RootLazyNode.ID, Nothing)
            Dim Validator As New Validator(TreeView.RootLazyNode, TreeView, ElementCounter, OtherLevelIcons)
            Me.Enabled = False
            Validator.Validate(True)
            Me.Enabled = True
        End If
    End Sub

    Private Sub MenuItemInference_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemInference.Click
        If MsgBox(InfoMessage("Inference.MakeSure"), MsgBoxStyle.Question Or MsgBoxStyle.YesNo Or MsgBoxStyle.DefaultButton1) = MsgBoxResult.No Then Exit Sub
        UploadSelectedLazyNode()
        Dim Validator As New Validator(TreeView.RootLazyNode, TreeView, OtherLevelIcons)
        Me.Enabled = False
        Dim isValid As Boolean = Validator.InferenceValidation(False)
        Me.Enabled = True

        If Not isValid Then
            Exit Sub
        End If

        Dim Inference As New Inference(TreeView.RootLazyNode)
        Me.Enabled = False
        Inference.Infer()
        Me.Enabled = True
        TreeView.CollapseAll()
        TreeView.SelectedNode = TreeView.RootTreeNode
        TreeView_AfterSelect(sender, Nothing)
    End Sub

    ' Calls iterator to calculate complete unit ids
    Private Sub MenuItemUpdateCompleteUnitIDs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemUpdateCompleteUnitIDs.Click
        UploadSelectedLazyNode()
        Me.Enabled = False
        Dim iterator As New iterator(TreeView.SelectedLazyNode)
        iterator.Start(iterator.Action.UpdateCompleteUnitId)
        Me.Enabled = True
    End Sub

    Private Sub MenuItemNormaliseCoding_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemNormaliseCoding.Click
        UploadSelectedLazyNode()

        If TreeView.SelectedNodes.Count > 0 Then
            For Each TreeNode As TreeNode In TreeView.SelectedNodes
                If LazyTree.GetLazyNode(TreeNode).OtherLevelIndex < EAD.GetOtherLevelIndex(OTHERLEVEL_SERIES) Then
                    MsgBox(InfoMessage("NormaliseCoding.WrongLevelType"), MsgBoxStyle.Information)
                    Exit Sub
                End If
            Next
        Else
            Exit Sub
        End If

        If MsgBox(InfoMessage("NormaliseCoding.Confirm"), MsgBoxStyle.Question Or MsgBoxStyle.YesNo Or MsgBoxStyle.DefaultButton2) = MsgBoxResult.No Then Exit Sub

        NormaliseCoding(TreeView.SelectedNodes)
    End Sub

    Private Sub MenuItemAutoCoding_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemAutoCoding.Click
        UploadSelectedLazyNode()
        If TreeView.SelectedNodes.Count > 0 Then
            Dim TreeNode As TreeNode
            For Each TreeNode In TreeView.SelectedNodes
                If LazyTree.GetLazyNode(TreeNode).OtherLevelIndex < EAD.GetOtherLevelIndex(OTHERLEVEL_SERIES) Then
                    MsgBox(InfoMessage("AutoCoding.WrongLevelType"), MsgBoxStyle.Information)
                    Exit Sub
                End If
            Next

            Dim StartPattern As String = "001"
            If TreeView.SelectedNodes.Count > 0 Then
                Dim FirstSelectedNode As LazyNode = LazyTree.GetLazyNode(TreeView.SelectedNodes.Item(0))
                StartPattern = FormatNumericCode(1, FirstSelectedNode.OtherLevel)
            End If

            Dim frmAutoCondingStartNumber As New AutoCodingStartNumberForm(StartPattern)
            If frmAutoCondingStartNumber.ShowDialog = DialogResult.OK Then
                AutoCoding(frmAutoCondingStartNumber.ValueAsString, TreeView.SelectedNodes)
            End If
        End If
    End Sub

    Private Sub MenuItemNodeCounterPro_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemNodeCounterPro.Click
        UploadSelectedLazyNode()


        Dim CountResults As New Hashtable
        Dim startTime As Date

        Dim Result As DialogResult
        If Not TreeView.RootLazyNode Is TreeView.SelectedLazyNode Then
            Result = MsgBox(InfoMessage("CountNodes.StartFromRoot"), MsgBoxStyle.Question + MsgBoxStyle.YesNoCancel + MsgBoxStyle.DefaultButton2)
        Else
            Result = MsgBoxResult.Yes
        End If



        Dim StartNode As LazyNode = Nothing
        If Result = MsgBoxResult.Cancel Then
            Exit Sub
        ElseIf Result = DialogResult.Yes Then
            StartNode = TreeView.RootLazyNode

            startTime = Date.Now

            Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")
            Try

                For Each OtherLevel As String In EAD.OtherLevels
                    Dim Count As Integer = SQLLazyNode.CountByOtherLevel( _
                                                              SQLServerSettings.Item("ServerAddress"), _
                                                              SQLServerSettings.Item("Database"), _
                                                              SQLServerSettings.Item("Username"), _
                                                              SQLServerSettings.Item("Password"), StartNode.ID, _
                                                              OtherLevel)
                    CountResults.Add(OtherLevel, Count)
                Next

            Catch ex As SqlException
                MessageBoxes.MsgBoxSqlException(ex)
            Catch ex As Exception
                MessageBoxes.MsgBoxException(ex)
            End Try

        Else ' not root node. Iterate over descendants
            StartNode = TreeView.SelectedLazyNode
            startTime = Date.Now
            Dim iterator As New iterator(StartNode)
            CountResults = iterator.Start(iterator.Action.CountNodesByOtherLevel)
        End If

        Dim msg As String = ""
        Dim total As Integer = 0
        ' added by lmferros

        For i As Integer = 0 To EAD.OtherLevels.Length - 1
            If CountResults.ContainsKey(EAD.OtherLevels(i)) Then
                msg &= VisualFieldLabel(EAD.OtherLevels(i)) & ": " & CountResults(EAD.OtherLevels(i)) & Chr(13)
                total += CountResults(EAD.OtherLevels(i))
            End If
        Next

        Dim finishTime As Date = Date.Now
        Dim timeSpan As timeSpan = finishTime.Subtract(startTime)
        Dim timeStr As String = timeSpan.Minutes.ToString.PadLeft(2, "0") & "m" & timeSpan.Seconds.ToString.PadLeft(2, "0") & "s"
        msg &= Chr(13) & "Total: " & total & " [" & timeStr & "]"
        MsgBox(msg)

    End Sub

    Private Sub MenuItemNodeCount_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        UploadSelectedLazyNode()
        If Not TreeView.RootLazyNode Is Nothing Then
            Dim NodeCounter As New NodeCounter(TreeView.RootLazyNode)
            NodeCounter.CountNodes()
        End If
    End Sub

#End Region

#Region "MenuItem Administration"

    Private Sub MenuItemControlAccess_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemControlAccess.Click
        UploadSelectedLazyNode()
        OpenControlAccess()
    End Sub

    Private Sub MenuItemMakeValid_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemMakeValid.Click
        If TreeView.SelectedLazyNode Is Nothing Then Exit Sub
        UploadSelectedLazyNode()
        TreeView.MakeValid(Me, Nothing)
        EnableDisableMenuItems()
    End Sub

    Private Sub MenuItemMakeInvalid_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemMakeInvalid.Click
        If TreeView.SelectedLazyNode Is Nothing Then Exit Sub
        UploadSelectedLazyNode()
        TreeView.MakeInvalid(Me, Nothing)
        EnableDisableMenuItems()
    End Sub

    Private Sub MenuItemMakeVisible_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemMakeVisible.Click
        If TreeView.SelectedLazyNode Is Nothing Then Exit Sub
        TreeView.MakeVisible(Me, Nothing)
        EnableDisableMenuItems()
    End Sub

    Private Sub MenuItemMakeInvisible_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemMakeInvisible.Click
        If TreeView.SelectedLazyNode Is Nothing Then Exit Sub
        UploadSelectedLazyNode()
        TreeView.MakeInvisible(Me, Nothing)
        EnableDisableMenuItems()
    End Sub

    Private Sub MenuItemAuthority_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemAuthority.Click
        UploadSelectedLazyNode()
        OpenAuthority()
    End Sub

    Private Sub MenuItemBranchNodeCount_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        UploadSelectedLazyNode()
        If Not TreeView.SelectedLazyNode Is Nothing Then
            Dim NodeCounter As New NodeCounter(TreeView.SelectedLazyNode)
            NodeCounter.CountNodes()
        Else
            MsgBox(InfoMessage("BranchNodeCount.ElementNotSelected"), MsgBoxStyle.Information Or MsgBoxStyle.OKOnly)
        End If

    End Sub

    Private Sub MenuItemClearLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemClearLog.Click
        Dim aMonth As New TimeSpan(31, 0, 0, 0)
        Dim DeleteUntil As Date = Date.Now.Subtract(aMonth)
        If MsgBox(String.Format(InfoMessage("Log.ClearLog"), DateToStr(DeleteUntil)), MsgBoxStyle.Critical Or MsgBoxStyle.YesNo Or MsgBoxStyle.DefaultButton2) = MsgBoxResult.Yes Then
            Logger.Clear(DateToStr(DeleteUntil))
        End If
    End Sub

    'Private Sub MenuItemWebSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemWebSearch.Click
    '    OpenInternetExplorer(Constant("AdvancedWebSearchURL"))

    'End Sub

    'Private Sub MenuItemLogViewer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemLogViewer.Click
    '    OpenInternetExplorer(Constant("LogViewerURL"))
    'End Sub

    'Private Sub MenuItemGlobalStats_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemGlobalStats.Click
    '    OpenInternetExplorer(Constant("GlobalStatsURL"))

    'End Sub

    'Private Sub MenuItemMonthlyStats_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemMonthlyStats.Click
    '    OpenInternetExplorer(Constant("MonthlyStatsURL"))
    'End Sub

#End Region

#Region "MenuItem Reports"

    Private Sub MenuItemInventoryReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemInventoryReport.Click
        Dim SelectedLazyNodes As New LazyNodeCollection
        SelectedLazyNodes.Add(TreeView.RootLazyNode)
        Dim ReportDataSet As InventoryDataSet = ReportDataSetBuilder.GenerateInventoryReportData(SelectedLazyNodes)

        Dim Report As New InventoryReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()
    End Sub

    Private Sub MenuItemIUInventoryReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemIUInventoryReport.Click
        Dim SelectedLazyNodes As New LazyNodeCollection
        SelectedLazyNodes.Add(TreeView.RootLazyNode)
        Dim ReportDataSet As CatalogDataSet = ReportDataSetBuilder.GenerateIUInventoryReportData(SelectedLazyNodes)

        Dim Report As New IUInventoryReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()
    End Sub

    Private Sub MenuItemCatalogReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemCatalogReport.Click
        Dim SelectedLazyNodes As New LazyNodeCollection
        SelectedLazyNodes.Add(TreeView.RootLazyNode)
        Dim ReportDataSet As CatalogDataSet = ReportDataSetBuilder.GenerateCatalogReportData(SelectedLazyNodes)

        Dim Report As New CatalogReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()

    End Sub

    Private Sub MenuItemIUListReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemIUListReport.Click
        Dim SelectedLazyNodes As New LazyNodeCollection
        SelectedLazyNodes.Add(TreeView.RootLazyNode)
        Dim ReportDataSet As ListDataSet = ReportDataSetBuilder.GenerateInstalationUnitsListData(SelectedLazyNodes)

        Dim Report As New IUListReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()
    End Sub

    Private Sub MenuItemSeriesListReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemSeriesListReport.Click
        Dim SelectedLazyNodes As New LazyNodeCollection
        SelectedLazyNodes.Add(TreeView.RootLazyNode)
        Dim ReportDataSet As ListDataSet = ReportDataSetBuilder.GenerateSeriesListData(SelectedLazyNodes)

        Dim Report As New SeriesListReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()
    End Sub

    Private Sub MenuItemClassificationPlanReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemClassificationPlanReport.Click
        Dim SelectedLazyNodes As New LazyNodeCollection
        SelectedLazyNodes.Add(TreeView.RootLazyNode)
        Dim ReportDataSet As InventoryDataSet = ReportDataSetBuilder.GenerateClassificationPlanData(SelectedLazyNodes)

        Dim Report As New ClassificationPlanReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()
    End Sub

    Private Sub MenuItemControlAccessReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemControlAccessReport.Click
        Cursor.Current = Cursors.WaitCursor
        Dim SelectedLazyNodes As New LazyNodeCollection
        SelectedLazyNodes.Add(TreeView.RootLazyNode)
        Dim ReportDataSet As ControlAccessDataSet = ReportDataSetBuilder.GenerateControlAccessData(SelectedLazyNodes)

        Dim Report As New ControlAccessReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        Cursor.Current = Cursors.Default
        frmReportPreview.Show()
    End Sub

    Private Sub MenuItemAllControlAccessReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemAllControlAccessReport.Click
        Cursor.Current = Cursors.WaitCursor
        Dim ReportDataSet As ControlAccessDataSet = ReportDataSetBuilder.GenerateAllControlAccessData()

        Dim Report As New AllControlAccessReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        Cursor.Current = Cursors.Default
        frmReportPreview.Show()
    End Sub


    Private Sub MenuItemFondsGuide_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim SelectedLazyNodes As New LazyNodeCollection
        SelectedLazyNodes.Add(TreeView.RootLazyNode)
        Dim ReportDataSet As FondsGuideDataSet = ReportDataSetBuilder.GenerateFondsGuideReportData(SelectedLazyNodes)

        Dim Report As New FondsGuideReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()

    End Sub


    Private Sub MenuItemInstalationUnitsBySeriesReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemInstalationUnitsBySeriesReport.Click
        Dim SelectedLazyNodes As New LazyNodeCollection
        SelectedLazyNodes.Add(TreeView.RootLazyNode)
        Dim ReportDataSet As ListDataSet = ReportDataSetBuilder.GenerateInstalationUnitsBySeriesListData(SelectedLazyNodes)

        Dim Report As New IUBySeriesReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        frmReportPreview.Show()
    End Sub


    Private Sub MenuItemAuthorsListReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemAuthorsListReport.Click
        Dim SelectedLazyNodes As New LazyNodeCollection
        SelectedLazyNodes.Add(TreeView.RootLazyNode)
        Cursor = Cursors.WaitCursor
        Dim ReportDataSet As ListDataSet = ReportDataSetBuilder.GenerateAuthorsListData(SelectedLazyNodes)

        Dim Report As New AuthorsListReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        Cursor = Cursors.Default
        frmReportPreview.Show()
    End Sub

    Private Sub MenuItemPhyslocReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemPhyslocReport.Click
        Cursor.Current = Cursors.WaitCursor
        Dim SelectedLazyNodes As New LazyNodeCollection
        SelectedLazyNodes.Add(TreeView.RootLazyNode)

        Dim ReportDataSet As PhysLocDataSet = ReportDataSetBuilder.GeneratePhysLocData(SelectedLazyNodes)

        Dim Report As New PhysLocReport
        Report.SetDataSource(ReportDataSet)
        Dim frmReportPreview As New ReportPreviewForm(Report)
        Cursor.Current = Cursors.Default
        frmReportPreview.Show()

    End Sub

#End Region

#Region "MenuItem Incorporation Reports"

    Private Sub MenuItemIncorporationResumeReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemIncorporationResumeReport.Click
        Dim frmPrintReport As New PrintReportForm(TreeView.RootLazyNode, PrintReportForm.ReportTypes.IncorporationResume, myProgramState)
        frmPrintReport.ShowDialog()
    End Sub

    Private Sub MenuItemIncorporationListingReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemIncorporationListingReport.Click
        Dim frmPrintReport As New PrintReportForm(TreeView.RootLazyNode, PrintReportForm.ReportTypes.FondsListing, myProgramState)
        frmPrintReport.ShowDialog()
    End Sub

    Private Sub MenuItemIncorporationTransportUnitsReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemIncorporationTransportUnitsReport.Click
        Dim frmPrintReport As New PrintReportForm(TreeView.RootLazyNode, PrintReportForm.ReportTypes.IncorporationTrasportationUnits, myProgramState)
        frmPrintReport.ShowDialog()
    End Sub

    Private Sub MenuItemIncorporationDeliveryCertificate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemIncorporationDeliveryCertificate.Click
        Dim frmPrintReport As New PrintReportForm(TreeView.RootLazyNode, PrintReportForm.ReportTypes.IncorporationLegalStatus, myProgramState)
        frmPrintReport.ShowDialog()
    End Sub

#End Region

#Region "MenuItem Help"



    Private Sub ShowChangeLogOnLoad()
        Dim frmHTMLViewer As New HTMLViewerForm
        frmHTMLViewer.ReopenMessageVisible = True
        frmHTMLViewer.Text = MenuItemAboutThisVersion.Text
        frmHTMLViewer.Navigate(System.Windows.Forms.Application.StartupPath + "\..\Resources\about\index.html")
        frmHTMLViewer.ShowDialog()
        myProgramState.OpenChangeLongOnLoad = Not frmHTMLViewer.ReopenChecked()
        myProgramState.Save()
    End Sub

    Private Sub MenuItemAboutThisVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemAboutThisVersion.Click
        Dim frmHTMLViewer As New HTMLViewerForm
        frmHTMLViewer.ReopenMessageVisible = False
        frmHTMLViewer.Text = MenuItemAboutThisVersion.Text
        frmHTMLViewer.Navigate(System.Windows.Forms.Application.StartupPath + "\..\Resources\about\index.html")
        frmHTMLViewer.ShowDialog()
    End Sub


    Private Sub MenuItemSupport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemSupport.Click
        Dim frmHTMLViewer As New HTMLViewerForm
        frmHTMLViewer.ReopenMessageVisible = False
        frmHTMLViewer.Text = MenuItemSupport.Text
        frmHTMLViewer.Navigate(System.Windows.Forms.Application.StartupPath + "\..\Resources\support\index.html")
        frmHTMLViewer.ShowDialog()
    End Sub


    Private Sub MenuItemHelpdesk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemHelpdesk.Click
        Dim frmHTMLViewer As New HTMLViewerForm
        frmHTMLViewer.ReopenMessageVisible = False
        frmHTMLViewer.Text = MenuItemSupport.Text
        frmHTMLViewer.Navigate("http://helpdesk.keep.pt")
        frmHTMLViewer.ShowDialog()

    End Sub
#End Region

#End Region


#Region "Saving/Loading Program Settings/State"

    ' setups UI and components according to previously saved program settings
    Private Sub LoadApplicationSettings()
        Me.MenuItemAskBeforeSave.Checked = myProgramState.AskBeforeSave
        Me.MenuItemAskBeforeRemove.Checked = myProgramState.AskBeforeRemove
        Me.MenuItemAutoUpdateCompleteUnitID.Checked = myProgramState.AutoUpdateCompleteUnitID


        If myProgramState.TextSize = 3 Then
            MenuItemTextSizeLarge_Click(Me, Nothing)
        ElseIf myProgramState.TextSize = 2 Then
            MenuItemTextSizeMedium_Click(Me, Nothing)
        Else
            MenuItemTextSizeSmall_Click(Me, Nothing)
        End If


        Select Case myProgramState.SortBy
            Case 0 : MenuItemSortByUnitDateInitial_Click(Me, Nothing)
            Case 1 : MenuItemSortByUnitID_Click(Me, Nothing)
            Case 2 : MenuItemSortByUnitTitle_Click(Me, Nothing)
            Case 3 : MenuItemSortByOtherLevel_Click(Me, Nothing)
            Case 4 : MenuItemSortByProcessInfoDate_Click(Me, Nothing)
            Case Else : MenuItemSortByUnitDateInitial_Click(Me, Nothing)
        End Select

        Me.TreeView.AskBeforeRemove = MenuItemAskBeforeRemove.Checked

        'Me.myFieldPresentationMode = myProgramState.ViewMode
        EadEditor.ViewMode = myProgramState.ViewMode

        Select Case myProgramState.ViewMode
            Case ViewMode.Frequent : MenuItemMostFrequentFields_Click(Me, Nothing)
            Case ViewMode.Mandatory : MenuItemMandatoryFields_Click(Me, Nothing)
            Case Else : MenuItemAllFields_Click(Me, Nothing)
        End Select

    End Sub

    Private Sub SaveApplicationSettings()
        ' save text size
        If Me.MenuItemTextSizeLarge.Checked Then
            myProgramState.TextSize = 3
        ElseIf Me.MenuItemTextSizeMedium.Checked Then
            myProgramState.TextSize = 2
        ElseIf Me.MenuItemTextSizeSmall.Checked Then
            myProgramState.TextSize = 1
        End If


        ' save last opened fonds
        If Not TreeView.RootLazyNode Is Nothing Then
            myProgramState.LastOpenedFonds = TreeView.RootLazyNode.ID
            If Not TreeView.SelectedLazyNode Is Nothing Then
                myProgramState.LastUsedNode = TreeView.SelectedLazyNode.ID
            Else
                myProgramState.LastUsedNode = TreeView.RootLazyNode.ID
            End If
        End If

        ' save other stuff
        myProgramState.LastLoginUsername = myProcessInfoName
        myProgramState.AskBeforeSave = Me.MenuItemAskBeforeSave.Checked
        myProgramState.AskBeforeRemove = Me.MenuItemAskBeforeRemove.Checked
        myProgramState.AutoUpdateCompleteUnitID = Me.MenuItemAutoUpdateCompleteUnitID.Checked

        'myProgramState.ViewMode = Me.myFieldPresentationMode
        myProgramState.ViewMode = EadEditor.ViewMode

        ' save settings
        myProgramState.Save()
    End Sub

#End Region


#Region "Record taken/untaken functions"

    Private Sub SetLazyNodeDataChanged()
        Dim TakenBy As String = GetNodeTaken(TreeView.SelectedLazyNode.ID)

        If TakenBy.Equals("") Then ' node is not taken by anyone 
            SetNodeTaken(EadEditor.LazyNode.ID, myProcessInfoName)
            myLazyNodeDataChanged = True
            EadEditor.EnableSaveButton(True)
        ElseIf (TakenBy = myProcessInfoName) Then ' node is  taken by me 
            myLazyNodeDataChanged = True
            EadEditor.EnableSaveButton(True)
        Else ' node is taken by someone else
            MsgBox(String.Format(ErrorMessage("RegisterTaken"), """" & TakenBy & """"), MsgBoxStyle.Exclamation, InfoMessage("TakenWarning.Title"))
            EadEditor.EnableSaveButton(False)
        End If
    End Sub


    Private Function GetNodeTaken(ByVal ComponentID As Int64) As String
        Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

        If myNodeTakenCacheNodeID = ComponentID Then
            Return myNodeTakenCacheTakenBy
        Else
            ' update cache
            Dim TakenBy As String = SQLLazyNode.GetTaken(SQLServerSettings.Item("ServerAddress"), _
                                        SQLServerSettings.Item("Database"), _
                                        SQLServerSettings.Item("Username"), _
                                        SQLServerSettings.Item("Password"), _
                                        ComponentID)

            UpdateNodeTakenCache(ComponentID, TakenBy)
            Return TakenBy
        End If
    End Function


    Private Sub CleanNodeTakenCache()
        myNodeTakenCacheNodeID = -1
        myNodeTakenCacheTakenBy = ""
    End Sub

    Private Sub UpdateNodeTakenCache(ByVal ComponentID As Int64, ByVal TakenBy As String)
        myNodeTakenCacheNodeID = ComponentID
        myNodeTakenCacheTakenBy = TakenBy
    End Sub



    ' Prevent other users from using this node
    Private Sub SetNodeTaken(ByVal ComponentID As Int64, ByVal TakenBy As String)

        Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

        SQLLazyNode.SetTaken(SQLServerSettings.Item("ServerAddress"), _
                                    SQLServerSettings.Item("Database"), _
                                    SQLServerSettings.Item("Username"), _
                                    SQLServerSettings.Item("Password"), _
                                    ComponentID, TakenBy)
        UpdateNodeTakenCache(ComponentID, TakenBy)
    End Sub


#End Region

#Region "NavigationBar events"

    Private Sub NavigationBar_EditButtonClicked(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NavigationBar.EditButtonClicked
        Me.UploadSelectedLazyNode()

        Dim LazyNode As LazyNode = SQLLazyNode.Retrieve( _
                                         CStr(mySQLServerSettings.Item("ServerAddress")), _
                                         CStr(mySQLServerSettings.Item("Database")), _
                                         CStr(mySQLServerSettings.Item("Username")), _
                                         CStr(mySQLServerSettings.Item("Password")), _
                                         NavigationBar.Reference)

        If LazyNode Is Nothing Then
            NavigationBar.IsValidReference(False)
        Else
            NavigationBar.IsValidReference(True)

            Dim LastSelectedNode As LazyNode = EadEditor.LazyNode

            If LastSelectedNode.ParentFondsID <> LazyNode.ParentFondsID Then
                ' reference belongs to another fonds. Open it
                OpenFonds(LazyNode.ParentFondsID, LazyNode)
            Else
                ' Node is in this fonds
                EditLazyNode(LazyNode)
            End If
        End If

    End Sub

    Private Sub OpenFonds(ByVal FondsIdToOpen As Integer, Optional ByVal SelectLazyNode As LazyNode = Nothing)
        Dim RootLazyNode As LazyNode = New SQLLazyNode( _
                                     CStr(mySQLServerSettings.Item("ServerAddress")), _
                                     CStr(mySQLServerSettings.Item("Database")), _
                                     CStr(mySQLServerSettings.Item("Username")), _
                                     CStr(mySQLServerSettings.Item("Password")), _
                                     FondsIdToOpen)

        If RootLazyNode Is Nothing Then Exit Sub

        TreeView.RootLazyNode = RootLazyNode
        TreeView.RootLazyNode.SortBy = GetSelectedSortStyle()
        TreeView.SelectedNode = TreeView.RootTreeNode

        EditLazyNode(SelectLazyNode)

        'If SelectLazyNode Is Nothing OrElse TreeView.RootLazyNode.ID = SelectLazyNode.ID Then
        '    TreeView.RootTreeNode.Expand()
        'End If

        'If Not SelectLazyNode Is Nothing Then
        '    TreeView.SelectedLazyNode = SelectLazyNode
        'End If

        mySearchForm = Nothing

        Logger.Append(myProcessInfoName, Logger.LogActions.OpenFonds, String.Format(LogMessage("Log.OpenFonds"), RootLazyNode.CompleteUnitId & ":" & RootLazyNode.UnitTitle))
        EnableMenus(True)
    End Sub



    Private Sub NavigationBar_SearchButtonClicked(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NavigationBar.SearchButtonClicked
        UploadSelectedLazyNode()

        ' no fonds opened. exit
        If TreeView.RootLazyNode Is Nothing Then Exit Sub

        mySearchForm = New SearchForm(TreeView.RootLazyNode.ID, NavigationBar.Search)

        Me.Enabled = False
        mySearchForm.Show()

    End Sub




    Private Sub GotoRecordEvent(ByVal GotoNodeID As Integer) Handles mySearchForm.GotoRecord
        Me.Enabled = True
        Me.Focus()
        Dim SelectedLazyNode As LazyNode = New SQLLazyNode( _
                                                 mySQLServerSettings.Item("ServerAddress"), _
                                                 mySQLServerSettings.Item("Database"), _
                                                 mySQLServerSettings.Item("Username"), _
                                                 mySQLServerSettings.Item("Password"), _
                                                 GotoNodeID)
        EditLazyNode(SelectedLazyNode)
    End Sub


    Private Sub SearchForm_Close(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mySearchForm.FormClose
        Me.Enabled = True
        Me.Focus()
    End Sub


    Private Sub EditLazyNode(ByVal LazyNode As LazyNode)
        If LazyNode Is Nothing Then Exit Sub
        CleanNodeTakenCache()

        EadEditor.LazyNode = LazyNode
        myFloatingForm.LazyNode = LazyNode
        EadEditor.Reload()

        ' update UI
        NavigationBar.Reference = LazyNode.CompleteUnitId
        StatusBar.Text = VisualFieldLabel(LazyNode.OtherLevel) & " - " & LazyNode.CompleteUnitId & " - " & LazyNode.UnitTitle


        ' Find node on tree
        TreeView.SelectedLazyNode = LazyNode
    End Sub


    Private Sub EADEditor_LazyNodeDataChanged(ByVal sender As System.Object, ByVal Data As LazyNode) Handles EadEditor.DataChanged
        SetLazyNodeDataChanged()
    End Sub



    Private Sub EADEditor_Saved(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EadEditor.SaveButtonClicked
        'SaveSelectedNode()
        UploadSelectedLazyNode()
    End Sub


#End Region



End Class

