
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports DigitArq.Utility
Imports System.Configuration
Imports DigitArq.UserControls.CustomUserControls



Public Class NewFondsForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        txtReference.FieldType = ValidTextBox.FieldTypes.FondsReferenceField
        txtReference.AllowErrorMessage = False

        txtTitle.FieldType = ValidTextBox.FieldTypes.NotEmptyField
        txtTitle.AllowErrorMessage = False
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents txtReference As ValidTextBox
    Friend WithEvents txtTitle As ValidTextBox
    Friend WithEvents ToolTip As System.Windows.Forms.ToolTip
    Friend WithEvents btnOk As System.Windows.Forms.Button
    Friend WithEvents btnCancel As System.Windows.Forms.Button
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents txtCountryCode As ValidTextBox
    Friend WithEvents txtRepositoryCode As ValidTextBox
    Friend WithEvents imglButtons As System.Windows.Forms.ImageList
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents txtRepository As ValidTextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(NewFondsForm))
        Me.Label1 = New System.Windows.Forms.Label
        Me.txtTitle = New ValidTextBox
        Me.txtReference = New ValidTextBox
        Me.Label2 = New System.Windows.Forms.Label
        Me.btnOk = New System.Windows.Forms.Button
        Me.imglButtons = New System.Windows.Forms.ImageList(Me.components)
        Me.btnCancel = New System.Windows.Forms.Button
        Me.ToolTip = New System.Windows.Forms.ToolTip(Me.components)
        Me.txtCountryCode = New ValidTextBox
        Me.txtRepositoryCode = New ValidTextBox
        Me.txtRepository = New ValidTextBox
        Me.Label3 = New System.Windows.Forms.Label
        Me.Label4 = New System.Windows.Forms.Label
        Me.Label5 = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.ForeColor = System.Drawing.Color.FromArgb(CType(192, Byte), CType(0, Byte), CType(0, Byte))
        Me.Label1.Location = New System.Drawing.Point(16, 64)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(96, 16)
        Me.Label1.TabIndex = 1
        Me.Label1.Text = CType(configurationAppSettings.GetValue("NewFondsReference.Text", GetType(System.String)), String)
        '
        'txtTitle
        '
        Me.txtTitle.AllowErrorMessage = False
        Me.txtTitle.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtTitle.FieldType = ValidTextBox.FieldTypes.NotEmptyField
        Me.txtTitle.Location = New System.Drawing.Point(112, 88)
        Me.txtTitle.Name = "txtTitle"
        Me.txtTitle.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.txtTitle.Size = New System.Drawing.Size(288, 20)
        Me.txtTitle.TabIndex = 2
        Me.txtTitle.Text = ""
        Me.ToolTip.SetToolTip(Me.txtTitle, "Ttulo do Fundo (e.g. Tribunal de Relao do Porto)")
        '
        'txtReference
        '
        Me.txtReference.AllowErrorMessage = False
        Me.txtReference.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtReference.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper
        Me.txtReference.FieldType = ValidTextBox.FieldTypes.NotEmptyField
        Me.txtReference.Location = New System.Drawing.Point(112, 64)
        Me.txtReference.Name = "txtReference"
        Me.txtReference.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.txtReference.Size = New System.Drawing.Size(88, 20)
        Me.txtReference.TabIndex = 0
        Me.txtReference.Text = ""
        Me.ToolTip.SetToolTip(Me.txtReference, "Referncia do Fundo. (e.g. JUD/TRPRT)")
        '
        'Label2
        '
        Me.Label2.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label2.ForeColor = System.Drawing.Color.FromArgb(CType(192, Byte), CType(0, Byte), CType(0, Byte))
        Me.Label2.Location = New System.Drawing.Point(16, 88)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(64, 16)
        Me.Label2.TabIndex = 3
        Me.Label2.Text = "Ttulo:"
        '
        'btnOk
        '
        Me.btnOk.BackColor = System.Drawing.Color.White
        Me.btnOk.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnOk.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnOk.ImageIndex = 0
        Me.btnOk.ImageList = Me.imglButtons
        Me.btnOk.Location = New System.Drawing.Point(232, 120)
        Me.btnOk.Name = "btnOk"
        Me.btnOk.Size = New System.Drawing.Size(80, 25)
        Me.btnOk.TabIndex = 4
        Me.btnOk.Text = "&Gravar"
        Me.btnOk.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'imglButtons
        '
        Me.imglButtons.ImageSize = New System.Drawing.Size(18, 18)
        Me.imglButtons.ImageStream = CType(resources.GetObject("imglButtons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.imglButtons.TransparentColor = System.Drawing.Color.Transparent
        '
        'btnCancel
        '
        Me.btnCancel.BackColor = System.Drawing.Color.White
        Me.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnCancel.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnCancel.ImageIndex = 1
        Me.btnCancel.ImageList = Me.imglButtons
        Me.btnCancel.Location = New System.Drawing.Point(320, 120)
        Me.btnCancel.Name = "btnCancel"
        Me.btnCancel.Size = New System.Drawing.Size(80, 25)
        Me.btnCancel.TabIndex = 5
        Me.btnCancel.Text = "&Cancelar"
        Me.btnCancel.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'txtCountryCode
        '
        Me.txtCountryCode.AllowErrorMessage = False
        Me.txtCountryCode.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtCountryCode.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper
        Me.txtCountryCode.FieldType = ValidTextBox.FieldTypes.NotEmptyField
        Me.txtCountryCode.Location = New System.Drawing.Point(112, 16)
        Me.txtCountryCode.Name = "txtCountryCode"
        Me.txtCountryCode.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.txtCountryCode.Size = New System.Drawing.Size(48, 20)
        Me.txtCountryCode.TabIndex = 6
        Me.txtCountryCode.Text = ""
        Me.ToolTip.SetToolTip(Me.txtCountryCode, "Referncia do Fundo. (e.g. JUD/TRPRT)")
        '
        'txtRepositoryCode
        '
        Me.txtRepositoryCode.AllowErrorMessage = False
        Me.txtRepositoryCode.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtRepositoryCode.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper
        Me.txtRepositoryCode.FieldType = ValidTextBox.FieldTypes.NotEmptyField
        Me.txtRepositoryCode.Location = New System.Drawing.Point(296, 16)
        Me.txtRepositoryCode.Name = "txtRepositoryCode"
        Me.txtRepositoryCode.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.txtRepositoryCode.Size = New System.Drawing.Size(104, 20)
        Me.txtRepositoryCode.TabIndex = 8
        Me.txtRepositoryCode.Text = ""
        Me.ToolTip.SetToolTip(Me.txtRepositoryCode, "Referncia do Fundo. (e.g. JUD/TRPRT)")
        '
        'txtRepository
        '
        Me.txtRepository.AllowErrorMessage = False
        Me.txtRepository.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtRepository.FieldType = ValidTextBox.FieldTypes.NotEmptyField
        Me.txtRepository.Location = New System.Drawing.Point(112, 40)
        Me.txtRepository.Name = "txtRepository"
        Me.txtRepository.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.txtRepository.Size = New System.Drawing.Size(288, 20)
        Me.txtRepository.TabIndex = 10
        Me.txtRepository.Text = ""
        Me.ToolTip.SetToolTip(Me.txtRepository, "Referncia do Fundo. (e.g. JUD/TRPRT)")
        '
        'Label3
        '
        Me.Label3.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label3.ForeColor = System.Drawing.Color.FromArgb(CType(192, Byte), CType(0, Byte), CType(0, Byte))
        Me.Label3.Location = New System.Drawing.Point(16, 18)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(88, 16)
        Me.Label3.TabIndex = 7
        Me.Label3.Text = "Cdigo do pas:"
        '
        'Label4
        '
        Me.Label4.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label4.ForeColor = System.Drawing.Color.FromArgb(CType(192, Byte), CType(0, Byte), CType(0, Byte))
        Me.Label4.Location = New System.Drawing.Point(184, 18)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(112, 16)
        Me.Label4.TabIndex = 9
        Me.Label4.Text = "Cdigo da instituio:"
        '
        'Label5
        '
        Me.Label5.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label5.ForeColor = System.Drawing.Color.FromArgb(CType(192, Byte), CType(0, Byte), CType(0, Byte))
        Me.Label5.Location = New System.Drawing.Point(16, 40)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(64, 16)
        Me.Label5.TabIndex = 11
        Me.Label5.Text = "Instituio:"
        '
        'NewFondsForm
        '
        Me.AcceptButton = Me.btnOk
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.CancelButton = Me.btnCancel
        Me.ClientSize = New System.Drawing.Size(410, 152)
        Me.Controls.Add(Me.txtRepository)
        Me.Controls.Add(Me.Label5)
        Me.Controls.Add(Me.txtRepositoryCode)
        Me.Controls.Add(Me.Label4)
        Me.Controls.Add(Me.txtCountryCode)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.btnCancel)
        Me.Controls.Add(Me.btnOk)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.txtTitle)
        Me.Controls.Add(Me.txtReference)
        Me.Controls.Add(Me.Label1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "NewFondsForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = CType(configurationAppSettings.GetValue("NewFondsForm.Text", GetType(System.String)), String)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public Function GetUnitId() As String
        Return txtReference.Text
    End Function

    Public Function GetUnitTitle() As String
        Return txtTitle.Text
    End Function

    Public Function GetCountryCode() As String
        Return txtCountryCode.Text
    End Function

    Public Function GetRepositoryCode() As String
        Return txtRepositoryCode.Text
    End Function

    Public Function GetCompleteUnitID() As String
        Return String.Format("{0}/{1}/{2}", GetCountryCode(), GetRepositoryCode, GetUnitId)
    End Function

    Public Function GetRepository() As String
        Return txtRepository.Text
    End Function


    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click
        If Not txtReference.isValid() Then
            Dim AcceptProblem As Boolean = txtReference.ShowErrorMessage(ErrorMessage("NotFondsReference"))
            txtReference.Focus()
            If (AcceptProblem) Then DialogResult = DialogResult.OK
        ElseIf Not txtTitle.isValid() Then
            txtTitle.ShowErrorMessage(ErrorMessage("EmptyField"))
            txtTitle.Focus()
        Else
            DialogResult = DialogResult.OK
            'Close()
        End If
    End Sub

    Private Sub NewFondsForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.txtCountryCode.Text = VisualFieldLabel("CountryCode.DefaultValue")
        Me.txtRepositoryCode.Text = VisualFieldLabel("RepositoryCode.DefaultValue")
        Me.txtRepository.Text = VisualFieldLabel("Repository.DefaultValue")
    End Sub

End Class

