
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Data.SqlClient ' SQL Server Data Provider
Imports System.Configuration
Imports System.IO



Imports DigitArq.Data.Entities.MDA
Imports DigitArq.UserControls
Imports DigitArq.Utility
Imports DigitArq.Definitions
Imports DigitArq.UserControls.CustomUserControls


Public Class ValidationResultsForm
    Inherits System.Windows.Forms.Form


#Region " Windows Form Designer generated code "


    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
    End Sub


    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Panel2 As System.Windows.Forms.Panel
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents btnClose As System.Windows.Forms.Button
    Friend WithEvents chOtherLevel As System.Windows.Forms.ColumnHeader
    Friend WithEvents chUnitId As System.Windows.Forms.ColumnHeader
    Friend WithEvents chUnitTitle As System.Windows.Forms.ColumnHeader
    Friend WithEvents chID As System.Windows.Forms.ColumnHeader
    Friend WithEvents ListView As System.Windows.Forms.ListView
    Friend WithEvents btnGoto As System.Windows.Forms.Button
    Friend WithEvents chErrorDescription As System.Windows.Forms.ColumnHeader
    Friend WithEvents lblErrorCount As System.Windows.Forms.Label
    Friend WithEvents imglButtons As System.Windows.Forms.ImageList
    Friend WithEvents btnSaveToTextFile As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(ValidationResultsForm))
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Me.Panel2 = New System.Windows.Forms.Panel
        Me.btnSaveToTextFile = New System.Windows.Forms.Button
        Me.lblErrorCount = New System.Windows.Forms.Label
        Me.btnGoto = New System.Windows.Forms.Button
        Me.btnClose = New System.Windows.Forms.Button
        Me.imglButtons = New System.Windows.Forms.ImageList(Me.components)
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.ListView = New System.Windows.Forms.ListView
        Me.chOtherLevel = New System.Windows.Forms.ColumnHeader
        Me.chUnitId = New System.Windows.Forms.ColumnHeader
        Me.chUnitTitle = New System.Windows.Forms.ColumnHeader
        Me.chErrorDescription = New System.Windows.Forms.ColumnHeader
        Me.chID = New System.Windows.Forms.ColumnHeader
        Me.Panel2.SuspendLayout()
        Me.Panel1.SuspendLayout()
        Me.SuspendLayout()
        '
        'Panel2
        '
        Me.Panel2.Controls.Add(Me.btnSaveToTextFile)
        Me.Panel2.Controls.Add(Me.lblErrorCount)
        Me.Panel2.Controls.Add(Me.btnGoto)
        Me.Panel2.Controls.Add(Me.btnClose)
        Me.Panel2.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.Panel2.Location = New System.Drawing.Point(0, 278)
        Me.Panel2.Name = "Panel2"
        Me.Panel2.Size = New System.Drawing.Size(656, 40)
        Me.Panel2.TabIndex = 4
        '
        'btnSaveToTextFile
        '
        Me.btnSaveToTextFile.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.btnSaveToTextFile.BackColor = System.Drawing.Color.White
        Me.btnSaveToTextFile.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.btnSaveToTextFile.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnSaveToTextFile.Image = CType(resources.GetObject("btnSaveToTextFile.Image"), System.Drawing.Image)
        Me.btnSaveToTextFile.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnSaveToTextFile.Location = New System.Drawing.Point(208, 8)
        Me.btnSaveToTextFile.Name = "btnSaveToTextFile"
        Me.btnSaveToTextFile.Size = New System.Drawing.Size(80, 25)
        Me.btnSaveToTextFile.TabIndex = 5
        Me.btnSaveToTextFile.Text = CType(configurationAppSettings.GetValue("btnSaveToTextFile.Text", GetType(System.String)), String)
        Me.btnSaveToTextFile.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblErrorCount
        '
        Me.lblErrorCount.Location = New System.Drawing.Point(16, 8)
        Me.lblErrorCount.Name = "lblErrorCount"
        Me.lblErrorCount.Size = New System.Drawing.Size(192, 25)
        Me.lblErrorCount.TabIndex = 4
        Me.lblErrorCount.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'btnGoto
        '
        Me.btnGoto.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnGoto.BackColor = System.Drawing.Color.White
        Me.btnGoto.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.btnGoto.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnGoto.Image = CType(resources.GetObject("btnGoto.Image"), System.Drawing.Image)
        Me.btnGoto.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnGoto.Location = New System.Drawing.Point(486, 8)
        Me.btnGoto.Name = "btnGoto"
        Me.btnGoto.Size = New System.Drawing.Size(80, 25)
        Me.btnGoto.TabIndex = 3
        Me.btnGoto.Text = CType(configurationAppSettings.GetValue("FindResults.btnGoto.Text", GetType(System.String)), String)
        Me.btnGoto.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnClose
        '
        Me.btnClose.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnClose.BackColor = System.Drawing.Color.White
        Me.btnClose.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnClose.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnClose.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnClose.ImageIndex = 0
        Me.btnClose.ImageList = Me.imglButtons
        Me.btnClose.Location = New System.Drawing.Point(574, 8)
        Me.btnClose.Name = "btnClose"
        Me.btnClose.Size = New System.Drawing.Size(75, 25)
        Me.btnClose.TabIndex = 2
        Me.btnClose.Text = "&Fechar"
        Me.btnClose.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'imglButtons
        '
        Me.imglButtons.ImageSize = New System.Drawing.Size(18, 18)
        Me.imglButtons.ImageStream = CType(resources.GetObject("imglButtons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.imglButtons.TransparentColor = System.Drawing.Color.Transparent
        '
        'Panel1
        '
        Me.Panel1.Controls.Add(Me.ListView)
        Me.Panel1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.Panel1.Location = New System.Drawing.Point(0, 0)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(656, 278)
        Me.Panel1.TabIndex = 5
        '
        'ListView
        '
        Me.ListView.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.ListView.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chOtherLevel, Me.chUnitId, Me.chUnitTitle, Me.chErrorDescription, Me.chID})
        Me.ListView.Dock = System.Windows.Forms.DockStyle.Fill
        Me.ListView.FullRowSelect = True
        Me.ListView.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
        Me.ListView.Location = New System.Drawing.Point(0, 0)
        Me.ListView.MultiSelect = False
        Me.ListView.Name = "ListView"
        Me.ListView.Size = New System.Drawing.Size(656, 278)
        Me.ListView.TabIndex = 26
        Me.ListView.View = System.Windows.Forms.View.Details
        '
        'chOtherLevel
        '
        Me.chOtherLevel.Text = ""
        Me.chOtherLevel.Width = 20
        '
        'chUnitId
        '
        Me.chUnitId.Text = "Referncia"
        Me.chUnitId.Width = 69
        '
        'chUnitTitle
        '
        Me.chUnitTitle.Text = "Ttulo"
        Me.chUnitTitle.Width = 234
        '
        'chErrorDescription
        '
        Me.chErrorDescription.Text = "Descrio do Erro"
        Me.chErrorDescription.Width = 320
        '
        'chID
        '
        Me.chID.Text = "ID"
        Me.chID.Width = 0
        '
        'ValidationResultsForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.CancelButton = Me.btnClose
        Me.ClientSize = New System.Drawing.Size(656, 318)
        Me.Controls.Add(Me.Panel1)
        Me.Controls.Add(Me.Panel2)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.MaximumSize = New System.Drawing.Size(1600, 1024)
        Me.MinimumSize = New System.Drawing.Size(300, 200)
        Me.Name = "ValidationResultsForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Resultados"
        Me.Panel2.ResumeLayout(False)
        Me.Panel1.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private myValidationResults As ValidationErrorCollection
    Private myLazyTree As LazyTree
    Private myOtherLevelIcons As ImageList



    Public Sub New(ByVal ValidationResults As ValidationErrorCollection, ByVal LazyTree As LazyTree, ByVal OtherLevelIcons As ImageList)
        Me.New()
        myLazyTree = LazyTree
        myValidationResults = ValidationResults
        myOtherLevelIcons = OtherLevelIcons
        ListView.SmallImageList = myOtherLevelIcons
    End Sub



    Private Sub FindResultsForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LoadResultsList()
    End Sub



    Private Sub LoadResultsList()
        ListView.Items.Clear()
        Dim ValidationError As ValidationError
        For Each ValidationError In myValidationResults
            Dim Row As New ListViewItem("", ValidationError.LazyNode.OtherLevelIndex)
            Row.UseItemStyleForSubItems = False
            Dim Icon As New ListViewItem.ListViewSubItem(Row, "")
            Dim UnitId As New ListViewItem.ListViewSubItem(Row, ValidationError.LazyNode.UnitId)
            Dim UnitTitle As New ListViewItem.ListViewSubItem(Row, ValidationError.LazyNode.UnitTitle)
            Dim ErrorDescription As New ListViewItem.ListViewSubItem(Row, ValidationError.ErrorDescription)
            Dim ID As New ListViewItem.ListViewSubItem(Row, IntToStr(ValidationError.LazyNode.ID))

            Row.SubItems.Add(UnitId)
            Row.SubItems.Add(UnitTitle)
            Row.SubItems.Add(ErrorDescription)
            Row.SubItems.Add(ID)
            ListView.Items.Add(Row)
        Next
        lblErrorCount.Text = String.Format(InfoMessage("ValidationResults.ErrorCount"), ListView.Items.Count)

    End Sub


    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Close()
    End Sub

    Private Sub btnGoto_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGoto.Click
        If ListView.SelectedIndices.Count <> 1 Then Exit Sub
        If myLazyTree Is Nothing Then Exit Sub
        myLazyTree.SelectedLazyNode = myValidationResults.Item(ListView.SelectedIndices.Item(0)).LazyNode
    End Sub

    Private Sub ListView_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListView.DoubleClick
        btnGoto_Click(sender, e)
    End Sub

    Private Sub btnSaveToTextFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveToTextFile.Click

        Dim SaveFileDialog As New SaveFileDialog
        SaveFileDialog.Filter = "Relatrio de validao (*.csv)|*.csv"
        SaveFileDialog.Title = InfoMessage("SaveFileDialog.Title.EAD")


        Try
            SaveFileDialog.FileName = myLazyTree.RootLazyNode.UnitId.Replace("/", "-")
            If SaveFileDialog.ShowDialog() = DialogResult.OK Then

                Dim oFile As System.IO.File
                Dim oWrite As System.IO.StreamWriter
                oWrite = oFile.CreateText(SaveFileDialog.FileName)

                Dim ErrorLine As String = String.Format("{0}; {1}; {2}; {3}; {4}", "ID", "Nivel descricao", "Classificacao", "Titulo", "Descricao do erro")
                oWrite.WriteLine(ErrorLine)

                For Each ValidationResult As ValidationError In myValidationResults
                    ErrorLine = String.Format("{0}; {1}; {2}; {3}; {4}", _
                                                    ValidationResult.LazyNode.ID, _
                                                    ValidationResult.LazyNode.OtherLevel, _
                                                    ValidationResult.LazyNode.CompleteUnitId, _
                                                    ValidationResult.LazyNode.UnitTitle, _
                                                    ValidationResult.ErrorDescription)
                    oWrite.WriteLine(ErrorLine)
                Next
                oWrite.Flush()
                oWrite.Close()
            End If
        Catch ex As Exception
            MessageBoxes.MsgBoxException(ex)
        Finally
            Me.Enabled = True
        End Try



    End Sub
End Class


