
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports DigitArq.Data.Entities.MGOD
Imports DigitArq.Utility
Imports DigitArq.Core.Logging
Imports DigitArq.Definitions.MGOD

Public Class DigitalizationProfilesForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New() 'ByVal scanner As scanner)
        MyBase.New()
        'Me.scanner = scanner

        'This call is required by the Windows Form Designer.
        InitializeComponent()
        'Add any initialization after the InitializeComponent() call
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents GroupBox4 As System.Windows.Forms.GroupBox
    Friend WithEvents lbxDigitalizationProfiles As System.Windows.Forms.ListBox
    Friend WithEvents gbxDigitalizationProfiles As System.Windows.Forms.GroupBox
    Friend WithEvents btnNew As System.Windows.Forms.Button
    Friend WithEvents btnSave As System.Windows.Forms.Button
    Friend WithEvents btnDelete As System.Windows.Forms.Button
    Friend WithEvents txtCompression As MGOD.ColorTextBox
    Friend WithEvents txtFormat As MGOD.ColorTextBox
    Friend WithEvents txtBitDepth As MGOD.ColorTextBox
    Friend WithEvents txtResolution As MGOD.ColorTextBox
    Friend WithEvents txtDescription As MGOD.ColorTextBox
    Friend WithEvents txtSharpness As System.Windows.Forms.NumericUpDown
    Friend WithEvents txtBlur As System.Windows.Forms.NumericUpDown
    Friend WithEvents txtBrightness As System.Windows.Forms.NumericUpDown
    Friend WithEvents txtProfileName As MGOD.ColorTextBox
    Friend WithEvents txtContrast As System.Windows.Forms.NumericUpDown
    Friend WithEvents btnClose As System.Windows.Forms.Button
    Friend WithEvents gbxDigitalizationProfile As System.Windows.Forms.GroupBox
    Friend WithEvents lblCompression As System.Windows.Forms.Label
    Friend WithEvents lblFormat As System.Windows.Forms.Label
    Friend WithEvents lblBitDepth As System.Windows.Forms.Label
    Friend WithEvents lblResolution As System.Windows.Forms.Label
    Friend WithEvents lblDescription As System.Windows.Forms.Label
    Friend WithEvents lblProfileName As System.Windows.Forms.Label
    Friend WithEvents lBlSharpen As System.Windows.Forms.Label
    Friend WithEvents lblBlur As System.Windows.Forms.Label
    Friend WithEvents lblBrightness As System.Windows.Forms.Label
    Friend WithEvents lblContrast As System.Windows.Forms.Label
    Friend WithEvents ButtonsImageList As System.Windows.Forms.ImageList
    Friend WithEvents lblOrientation As System.Windows.Forms.Label
    Friend WithEvents rdbPortrait As System.Windows.Forms.RadioButton
    Friend WithEvents rdbLandscape As System.Windows.Forms.RadioButton

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(DigitalizationProfilesForm))
        Me.btnNew = New System.Windows.Forms.Button
        Me.ButtonsImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.lbxDigitalizationProfiles = New System.Windows.Forms.ListBox
        Me.gbxDigitalizationProfiles = New System.Windows.Forms.GroupBox
        Me.btnDelete = New System.Windows.Forms.Button
        Me.gbxDigitalizationProfile = New System.Windows.Forms.GroupBox
        Me.rdbLandscape = New System.Windows.Forms.RadioButton
        Me.rdbPortrait = New System.Windows.Forms.RadioButton
        Me.lblOrientation = New System.Windows.Forms.Label
        Me.lblCompression = New System.Windows.Forms.Label
        Me.txtCompression = New MGOD.ColorTextBox
        Me.lblFormat = New System.Windows.Forms.Label
        Me.txtFormat = New MGOD.ColorTextBox
        Me.lblBitDepth = New System.Windows.Forms.Label
        Me.txtBitDepth = New MGOD.ColorTextBox
        Me.lblResolution = New System.Windows.Forms.Label
        Me.txtResolution = New MGOD.ColorTextBox
        Me.txtDescription = New MGOD.ColorTextBox
        Me.GroupBox4 = New System.Windows.Forms.GroupBox
        Me.btnSave = New System.Windows.Forms.Button
        Me.btnClose = New System.Windows.Forms.Button
        Me.lblDescription = New System.Windows.Forms.Label
        Me.txtSharpness = New System.Windows.Forms.NumericUpDown
        Me.txtBlur = New System.Windows.Forms.NumericUpDown
        Me.txtBrightness = New System.Windows.Forms.NumericUpDown
        Me.txtProfileName = New MGOD.ColorTextBox
        Me.lblProfileName = New System.Windows.Forms.Label
        Me.lBlSharpen = New System.Windows.Forms.Label
        Me.lblBlur = New System.Windows.Forms.Label
        Me.lblBrightness = New System.Windows.Forms.Label
        Me.txtContrast = New System.Windows.Forms.NumericUpDown
        Me.lblContrast = New System.Windows.Forms.Label
        Me.gbxDigitalizationProfiles.SuspendLayout()
        Me.gbxDigitalizationProfile.SuspendLayout()
        CType(Me.txtSharpness, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.txtBlur, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.txtBrightness, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.txtContrast, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'btnNew
        '
        Me.btnNew.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnNew.BackColor = System.Drawing.Color.White
        Me.btnNew.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnNew.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnNew.ImageIndex = 0
        Me.btnNew.ImageList = Me.ButtonsImageList
        Me.btnNew.Location = New System.Drawing.Point(16, 24)
        Me.btnNew.Name = "btnNew"
        Me.btnNew.Size = New System.Drawing.Size(152, 25)
        Me.btnNew.TabIndex = 14
        Me.btnNew.Text = "Novo perfil"
        '
        'ButtonsImageList
        '
        Me.ButtonsImageList.ImageSize = New System.Drawing.Size(18, 18)
        Me.ButtonsImageList.ImageStream = CType(resources.GetObject("ButtonsImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ButtonsImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'lbxDigitalizationProfiles
        '
        Me.lbxDigitalizationProfiles.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lbxDigitalizationProfiles.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lbxDigitalizationProfiles.Location = New System.Drawing.Point(16, 56)
        Me.lbxDigitalizationProfiles.Name = "lbxDigitalizationProfiles"
        Me.lbxDigitalizationProfiles.Size = New System.Drawing.Size(152, 275)
        Me.lbxDigitalizationProfiles.TabIndex = 15
        '
        'gbxDigitalizationProfiles
        '
        Me.gbxDigitalizationProfiles.BackColor = System.Drawing.Color.WhiteSmoke
        Me.gbxDigitalizationProfiles.Controls.Add(Me.btnDelete)
        Me.gbxDigitalizationProfiles.Controls.Add(Me.lbxDigitalizationProfiles)
        Me.gbxDigitalizationProfiles.Controls.Add(Me.btnNew)
        Me.gbxDigitalizationProfiles.Location = New System.Drawing.Point(9, 14)
        Me.gbxDigitalizationProfiles.Name = "gbxDigitalizationProfiles"
        Me.gbxDigitalizationProfiles.Size = New System.Drawing.Size(185, 378)
        Me.gbxDigitalizationProfiles.TabIndex = 20
        Me.gbxDigitalizationProfiles.TabStop = False
        Me.gbxDigitalizationProfiles.Text = "Perfis de digitalizao"
        '
        'btnDelete
        '
        Me.btnDelete.BackColor = System.Drawing.Color.White
        Me.btnDelete.Enabled = False
        Me.btnDelete.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnDelete.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnDelete.ImageIndex = 1
        Me.btnDelete.ImageList = Me.ButtonsImageList
        Me.btnDelete.Location = New System.Drawing.Point(16, 338)
        Me.btnDelete.Name = "btnDelete"
        Me.btnDelete.Size = New System.Drawing.Size(152, 25)
        Me.btnDelete.TabIndex = 16
        Me.btnDelete.Text = "Eliminar perfil"
        '
        'gbxDigitalizationProfile
        '
        Me.gbxDigitalizationProfile.BackColor = System.Drawing.Color.WhiteSmoke
        Me.gbxDigitalizationProfile.Controls.Add(Me.rdbLandscape)
        Me.gbxDigitalizationProfile.Controls.Add(Me.rdbPortrait)
        Me.gbxDigitalizationProfile.Controls.Add(Me.lblOrientation)
        Me.gbxDigitalizationProfile.Controls.Add(Me.lblCompression)
        Me.gbxDigitalizationProfile.Controls.Add(Me.txtCompression)
        Me.gbxDigitalizationProfile.Controls.Add(Me.lblFormat)
        Me.gbxDigitalizationProfile.Controls.Add(Me.txtFormat)
        Me.gbxDigitalizationProfile.Controls.Add(Me.lblBitDepth)
        Me.gbxDigitalizationProfile.Controls.Add(Me.txtBitDepth)
        Me.gbxDigitalizationProfile.Controls.Add(Me.lblResolution)
        Me.gbxDigitalizationProfile.Controls.Add(Me.txtResolution)
        Me.gbxDigitalizationProfile.Controls.Add(Me.txtDescription)
        Me.gbxDigitalizationProfile.Controls.Add(Me.GroupBox4)
        Me.gbxDigitalizationProfile.Controls.Add(Me.btnSave)
        Me.gbxDigitalizationProfile.Controls.Add(Me.btnClose)
        Me.gbxDigitalizationProfile.Controls.Add(Me.lblDescription)
        Me.gbxDigitalizationProfile.Controls.Add(Me.txtSharpness)
        Me.gbxDigitalizationProfile.Controls.Add(Me.txtBlur)
        Me.gbxDigitalizationProfile.Controls.Add(Me.txtBrightness)
        Me.gbxDigitalizationProfile.Controls.Add(Me.txtProfileName)
        Me.gbxDigitalizationProfile.Controls.Add(Me.lblProfileName)
        Me.gbxDigitalizationProfile.Controls.Add(Me.lBlSharpen)
        Me.gbxDigitalizationProfile.Controls.Add(Me.lblBlur)
        Me.gbxDigitalizationProfile.Controls.Add(Me.lblBrightness)
        Me.gbxDigitalizationProfile.Controls.Add(Me.txtContrast)
        Me.gbxDigitalizationProfile.Controls.Add(Me.lblContrast)
        Me.gbxDigitalizationProfile.Location = New System.Drawing.Point(201, 14)
        Me.gbxDigitalizationProfile.Name = "gbxDigitalizationProfile"
        Me.gbxDigitalizationProfile.Size = New System.Drawing.Size(389, 378)
        Me.gbxDigitalizationProfile.TabIndex = 21
        Me.gbxDigitalizationProfile.TabStop = False
        Me.gbxDigitalizationProfile.Text = "Perfil de digitalizao"
        '
        'rdbLandscape
        '
        Me.rdbLandscape.Location = New System.Drawing.Point(152, 272)
        Me.rdbLandscape.Name = "rdbLandscape"
        Me.rdbLandscape.TabIndex = 68
        Me.rdbLandscape.Text = "Horizontal"
        '
        'rdbPortrait
        '
        Me.rdbPortrait.Checked = True
        Me.rdbPortrait.Location = New System.Drawing.Point(152, 248)
        Me.rdbPortrait.Name = "rdbPortrait"
        Me.rdbPortrait.TabIndex = 67
        Me.rdbPortrait.TabStop = True
        Me.rdbPortrait.Text = "Vertical"
        '
        'lblOrientation
        '
        Me.lblOrientation.BackColor = System.Drawing.Color.Transparent
        Me.lblOrientation.Location = New System.Drawing.Point(73, 260)
        Me.lblOrientation.Name = "lblOrientation"
        Me.lblOrientation.Size = New System.Drawing.Size(72, 20)
        Me.lblOrientation.TabIndex = 66
        Me.lblOrientation.Text = "Orientao"
        Me.lblOrientation.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblCompression
        '
        Me.lblCompression.BackColor = System.Drawing.Color.Transparent
        Me.lblCompression.Location = New System.Drawing.Point(233, 163)
        Me.lblCompression.Name = "lblCompression"
        Me.lblCompression.Size = New System.Drawing.Size(70, 20)
        Me.lblCompression.TabIndex = 65
        Me.lblCompression.Text = "Compresso"
        Me.lblCompression.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtCompression
        '
        Me.txtCompression.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtCompression.Location = New System.Drawing.Point(310, 163)
        Me.txtCompression.MaxLength = 100
        Me.txtCompression.Name = "txtCompression"
        Me.txtCompression.Size = New System.Drawing.Size(60, 20)
        Me.txtCompression.TabIndex = 6
        Me.txtCompression.Text = ""
        '
        'lblFormat
        '
        Me.lblFormat.BackColor = System.Drawing.Color.Transparent
        Me.lblFormat.Location = New System.Drawing.Point(233, 136)
        Me.lblFormat.Name = "lblFormat"
        Me.lblFormat.Size = New System.Drawing.Size(70, 20)
        Me.lblFormat.TabIndex = 63
        Me.lblFormat.Text = "Formato"
        Me.lblFormat.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtFormat
        '
        Me.txtFormat.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtFormat.Location = New System.Drawing.Point(310, 136)
        Me.txtFormat.MaxLength = 100
        Me.txtFormat.Name = "txtFormat"
        Me.txtFormat.Size = New System.Drawing.Size(60, 20)
        Me.txtFormat.TabIndex = 4
        Me.txtFormat.Text = ""
        '
        'lblBitDepth
        '
        Me.lblBitDepth.BackColor = System.Drawing.Color.Transparent
        Me.lblBitDepth.Location = New System.Drawing.Point(73, 163)
        Me.lblBitDepth.Name = "lblBitDepth"
        Me.lblBitDepth.Size = New System.Drawing.Size(72, 24)
        Me.lblBitDepth.TabIndex = 61
        Me.lblBitDepth.Text = "Profundidade bits"
        Me.lblBitDepth.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtBitDepth
        '
        Me.txtBitDepth.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtBitDepth.Location = New System.Drawing.Point(152, 163)
        Me.txtBitDepth.MaxLength = 100
        Me.txtBitDepth.Name = "txtBitDepth"
        Me.txtBitDepth.Size = New System.Drawing.Size(60, 20)
        Me.txtBitDepth.TabIndex = 5
        Me.txtBitDepth.Text = ""
        '
        'lblResolution
        '
        Me.lblResolution.BackColor = System.Drawing.Color.Transparent
        Me.lblResolution.Location = New System.Drawing.Point(73, 136)
        Me.lblResolution.Name = "lblResolution"
        Me.lblResolution.Size = New System.Drawing.Size(72, 20)
        Me.lblResolution.TabIndex = 59
        Me.lblResolution.Text = "Resoluo"
        Me.lblResolution.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtResolution
        '
        Me.txtResolution.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtResolution.Location = New System.Drawing.Point(152, 136)
        Me.txtResolution.MaxLength = 100
        Me.txtResolution.Name = "txtResolution"
        Me.txtResolution.Size = New System.Drawing.Size(60, 20)
        Me.txtResolution.TabIndex = 3
        Me.txtResolution.Text = ""
        '
        'txtDescription
        '
        Me.txtDescription.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtDescription.Location = New System.Drawing.Point(74, 51)
        Me.txtDescription.MaxLength = 1000
        Me.txtDescription.Multiline = True
        Me.txtDescription.Name = "txtDescription"
        Me.txtDescription.Size = New System.Drawing.Size(296, 66)
        Me.txtDescription.TabIndex = 2
        Me.txtDescription.Text = ""
        '
        'GroupBox4
        '
        Me.GroupBox4.Location = New System.Drawing.Point(13, 328)
        Me.GroupBox4.Name = "GroupBox4"
        Me.GroupBox4.Size = New System.Drawing.Size(360, 3)
        Me.GroupBox4.TabIndex = 56
        Me.GroupBox4.TabStop = False
        '
        'btnSave
        '
        Me.btnSave.BackColor = System.Drawing.Color.White
        Me.btnSave.Enabled = False
        Me.btnSave.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnSave.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnSave.ImageIndex = 2
        Me.btnSave.ImageList = Me.ButtonsImageList
        Me.btnSave.Location = New System.Drawing.Point(204, 338)
        Me.btnSave.Name = "btnSave"
        Me.btnSave.Size = New System.Drawing.Size(80, 25)
        Me.btnSave.TabIndex = 12
        Me.btnSave.Text = "Guardar"
        Me.btnSave.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnClose
        '
        Me.btnClose.BackColor = System.Drawing.Color.White
        Me.btnClose.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnClose.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnClose.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnClose.ImageIndex = 5
        Me.btnClose.ImageList = Me.ButtonsImageList
        Me.btnClose.Location = New System.Drawing.Point(291, 338)
        Me.btnClose.Name = "btnClose"
        Me.btnClose.Size = New System.Drawing.Size(80, 25)
        Me.btnClose.TabIndex = 13
        Me.btnClose.Text = "Fechar"
        Me.btnClose.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'lblDescription
        '
        Me.lblDescription.BackColor = System.Drawing.Color.Transparent
        Me.lblDescription.Location = New System.Drawing.Point(8, 51)
        Me.lblDescription.Name = "lblDescription"
        Me.lblDescription.Size = New System.Drawing.Size(72, 20)
        Me.lblDescription.TabIndex = 53
        Me.lblDescription.Text = "Descrio"
        Me.lblDescription.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtSharpness
        '
        Me.txtSharpness.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtSharpness.Increment = New Decimal(New Integer() {10, 0, 0, 0})
        Me.txtSharpness.Location = New System.Drawing.Point(152, 217)
        Me.txtSharpness.Name = "txtSharpness"
        Me.txtSharpness.Size = New System.Drawing.Size(60, 20)
        Me.txtSharpness.TabIndex = 9
        '
        'txtBlur
        '
        Me.txtBlur.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtBlur.Increment = New Decimal(New Integer() {10, 0, 0, 0})
        Me.txtBlur.Location = New System.Drawing.Point(310, 217)
        Me.txtBlur.Maximum = New Decimal(New Integer() {0, 0, 0, 0})
        Me.txtBlur.Minimum = New Decimal(New Integer() {100, 0, 0, -2147483648})
        Me.txtBlur.Name = "txtBlur"
        Me.txtBlur.Size = New System.Drawing.Size(60, 20)
        Me.txtBlur.TabIndex = 10
        '
        'txtBrightness
        '
        Me.txtBrightness.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtBrightness.Increment = New Decimal(New Integer() {50, 0, 0, 0})
        Me.txtBrightness.Location = New System.Drawing.Point(152, 190)
        Me.txtBrightness.Maximum = New Decimal(New Integer() {1000, 0, 0, 0})
        Me.txtBrightness.Minimum = New Decimal(New Integer() {1000, 0, 0, -2147483648})
        Me.txtBrightness.Name = "txtBrightness"
        Me.txtBrightness.Size = New System.Drawing.Size(60, 20)
        Me.txtBrightness.TabIndex = 7
        '
        'txtProfileName
        '
        Me.txtProfileName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtProfileName.Location = New System.Drawing.Point(74, 24)
        Me.txtProfileName.MaxLength = 100
        Me.txtProfileName.Name = "txtProfileName"
        Me.txtProfileName.Size = New System.Drawing.Size(296, 20)
        Me.txtProfileName.TabIndex = 1
        Me.txtProfileName.Text = ""
        '
        'lblProfileName
        '
        Me.lblProfileName.BackColor = System.Drawing.Color.Transparent
        Me.lblProfileName.ForeColor = System.Drawing.Color.Red
        Me.lblProfileName.Location = New System.Drawing.Point(8, 24)
        Me.lblProfileName.Name = "lblProfileName"
        Me.lblProfileName.Size = New System.Drawing.Size(72, 20)
        Me.lblProfileName.TabIndex = 51
        Me.lblProfileName.Text = "Designao"
        Me.lblProfileName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lBlSharpen
        '
        Me.lBlSharpen.BackColor = System.Drawing.Color.Transparent
        Me.lBlSharpen.Location = New System.Drawing.Point(73, 217)
        Me.lBlSharpen.Name = "lBlSharpen"
        Me.lBlSharpen.Size = New System.Drawing.Size(72, 20)
        Me.lBlSharpen.TabIndex = 42
        Me.lBlSharpen.Text = "Focagem"
        Me.lBlSharpen.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblBlur
        '
        Me.lblBlur.BackColor = System.Drawing.Color.Transparent
        Me.lblBlur.Location = New System.Drawing.Point(233, 217)
        Me.lblBlur.Name = "lblBlur"
        Me.lblBlur.Size = New System.Drawing.Size(70, 20)
        Me.lblBlur.TabIndex = 41
        Me.lblBlur.Text = "Desfocagem"
        Me.lblBlur.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblBrightness
        '
        Me.lblBrightness.BackColor = System.Drawing.Color.Transparent
        Me.lblBrightness.Location = New System.Drawing.Point(73, 190)
        Me.lblBrightness.Name = "lblBrightness"
        Me.lblBrightness.Size = New System.Drawing.Size(72, 20)
        Me.lblBrightness.TabIndex = 50
        Me.lblBrightness.Text = "Brilho"
        Me.lblBrightness.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtContrast
        '
        Me.txtContrast.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtContrast.Increment = New Decimal(New Integer() {50, 0, 0, 0})
        Me.txtContrast.Location = New System.Drawing.Point(310, 190)
        Me.txtContrast.Maximum = New Decimal(New Integer() {1000, 0, 0, 0})
        Me.txtContrast.Minimum = New Decimal(New Integer() {1000, 0, 0, -2147483648})
        Me.txtContrast.Name = "txtContrast"
        Me.txtContrast.Size = New System.Drawing.Size(60, 20)
        Me.txtContrast.TabIndex = 8
        '
        'lblContrast
        '
        Me.lblContrast.BackColor = System.Drawing.Color.Transparent
        Me.lblContrast.Location = New System.Drawing.Point(233, 190)
        Me.lblContrast.Name = "lblContrast"
        Me.lblContrast.Size = New System.Drawing.Size(70, 20)
        Me.lblContrast.TabIndex = 48
        Me.lblContrast.Text = "Contraste"
        Me.lblContrast.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'DigitalizationProfilesForm
        '
        Me.AcceptButton = Me.btnSave
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.White
        Me.CancelButton = Me.btnClose
        Me.ClientSize = New System.Drawing.Size(602, 399)
        Me.Controls.Add(Me.gbxDigitalizationProfiles)
        Me.Controls.Add(Me.gbxDigitalizationProfile)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.KeyPreview = True
        Me.MaximizeBox = False
        Me.Name = "DigitalizationProfilesForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.Text = "Perfis de digitalizao"
        Me.gbxDigitalizationProfiles.ResumeLayout(False)
        Me.gbxDigitalizationProfile.ResumeLayout(False)
        CType(Me.txtSharpness, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.txtBlur, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.txtBrightness, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.txtContrast, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Private properties"

    Const NEW_MODEL_NAME As String = "Novo"
    Private myID As Integer
    Private SqlCommands As New SqlCommands(USER_LOGON)
    Private configReader As System.Configuration.AppSettingsReader = _
                New System.Configuration.AppSettingsReader

#End Region

#Region "Properties"

    Private ReadOnly Property DigitalizationProfile() As DigitalizationProfile
        Get
            Dim Profile As New DigitalizationProfile
            Profile.ID = Me.ID
            Profile.Name = Me.ProfileName
            Profile.Description = Me.Description
            Profile.Orientation = Me.Orientation
            Profile.Brightness = Me.Brightness
            Profile.Contrast = Me.Contrast
            Profile.Sharpness = Me.Sharpness
            Profile.Blur = Me.Blur
            Profile.Resolution = Me.Resolution
            Profile.BitDepth = Me.BitDepth
            Profile.Format = Me.Format
            Profile.Compression = Me.Compression

            Return Profile
        End Get
    End Property


    Property ID() As Integer
        Get
            Return myID
        End Get
        Set(ByVal Value As Integer)
            myID = Value
        End Set
    End Property

    Property ProfileName() As String
        Get
            Return Me.txtProfileName.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtProfileName.Text = Value
        End Set
    End Property

    Property Description() As String
        Get
            Return Me.txtDescription.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtDescription.Text = Value
        End Set
    End Property

    Property Resolution() As String
        Get
            Return Me.txtResolution.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtResolution.Text = Value
        End Set
    End Property

    Property BitDepth() As String
        Get
            Return Me.txtBitDepth.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtBitDepth.Text = Value
        End Set
    End Property

    Property Format() As String
        Get
            Return Me.txtFormat.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtFormat.Text = Value
        End Set
    End Property

    Property Compression() As String
        Get
            Return Me.txtCompression.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtCompression.Text = Value
        End Set
    End Property

    Property Brightness() As String
        Get
            Return Me.txtBrightness.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtBrightness.Text = Value
        End Set
    End Property

    Property Contrast() As String
        Get
            Return Me.txtContrast.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtContrast.Text = Value
        End Set
    End Property

    Property Sharpness() As String
        Get
            Return Me.txtSharpness.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtSharpness.Text = Value
        End Set
    End Property

    Property Blur() As String
        Get
            Return Me.txtBlur.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtBlur.Text = Value
        End Set
    End Property

    Property Orientation() As String
        Get
            If Me.rdbPortrait.Checked Then
                Return Me.rdbPortrait.Text
            Else
                Return Me.rdbLandscape.Text
            End If
        End Get
        Set(ByVal Value As String)
            If Value = Me.rdbLandscape.Text Then
                Me.rdbLandscape.Checked = True
            Else
                Me.rdbPortrait.Checked = True
            End If
        End Set
    End Property

#End Region

#Region "Form event handlers"

    Private Sub DigitalizationProfilesForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If USER_LOGON.Equals("admin") Then
            Me.btnDelete.Enabled = True
        End If
        LoadData()
    End Sub

    Private Sub DigitalizationProfilesForm_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        If Me.btnSave.Enabled Then
            If MsgBox(InfoMessage("MainForm.AskBeforeSave"), MsgBoxStyle.Question Or MsgBoxStyle.YesNo Or MsgBoxStyle.DefaultButton1) = MsgBoxResult.Yes Then
                Save()
            End If
        End If
        Me.Close()
    End Sub

#End Region

#Region "Listbox event handlers"

    Private Sub lbxDigitalizationProfiles_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbxDigitalizationProfiles.SelectedIndexChanged
        If Me.btnSave.Enabled Then
            If MsgBox(InfoMessage("MainForm.AskBeforeSave"), MsgBoxStyle.YesNo Or MsgBoxStyle.Question Or MsgBoxStyle.DefaultButton1) = MsgBoxResult.Yes Then
                Save()
            End If
        End If
        Me.ID = Me.lbxDigitalizationProfiles.SelectedValue
        LoadDigitalizationProfile(Me.ID)
    End Sub

#End Region

#Region "Buttons event handlers"

    Private Sub bttnNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNew.Click
        Clear()
        Me.ProfileName = NEW_MODEL_NAME
        Me.txtProfileName.Focus()
        Me.txtProfileName.SelectAll()
        SqlCommands.InsertDigitalizationProfile(Me.DigitalizationProfile)
        Logger.Append(USER_LOGON, Logger.AppendNode, String.Format(LogMessage("Log.InsertDigitalizationProfile"), Me.ProfileName))
        Me.btnSave.Enabled = False
        LoadData()
    End Sub

    Private Sub bttnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        Save()
    End Sub

    Private Sub Save()
        Dim index As Integer = Me.lbxDigitalizationProfiles.SelectedIndex
        If SqlCommands.UpdateDigitalizationProfile(Me.DigitalizationProfile) Then
            Logger.Append(USER_LOGON, Logger.EditNode, String.Format(LogMessage("Log.UpdateDigitalizationProfile"), Me.ProfileName))
            Me.btnSave.Enabled = False
            LoadData()
        End If
        Me.lbxDigitalizationProfiles.SelectedIndex = index
    End Sub

    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        If MsgBox(String.Format(InfoMessage("DigitalizationProfiles.Delete"), Me.ProfileName), MessageBoxButtons.YesNo Or MessageBoxIcon.Warning Or MessageBoxDefaultButton.Button2) = MsgBoxResult.Yes Then
            If SqlCommands.DeleteDigitalizationProfile(Me.ID) Then
                Logger.Append(USER_LOGON, Logger.RemoveNode, String.Format(LogMessage("Log.DeleteDigitalizationProfile"), Me.ProfileName))
                LoadData()
            Else
                MsgBox(ErrorMessage("Delete.RelatedProjectRecord"), MsgBoxStyle.Exclamation)
            End If
        End If
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

#End Region

#Region "Textboxs event handlers"

    Private Sub txtProfileName_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtProfileName.TextChanged
        Me.btnSave.Enabled = Me.ProfileName.Length > 0
    End Sub

    Private Sub txtDescription_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtDescription.TextChanged
        Me.btnSave.Enabled = Me.ProfileName.Length > 0
    End Sub

    Private Sub txtResolution_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtResolution.TextChanged
        Me.btnSave.Enabled = Me.ProfileName.Length > 0
    End Sub

    Private Sub txtBitDepth_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtBitDepth.TextChanged
        Me.btnSave.Enabled = Me.ProfileName.Length > 0
    End Sub

    Private Sub txtFormat_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtFormat.TextChanged
        Me.btnSave.Enabled = Me.ProfileName.Length > 0
    End Sub

    Private Sub txtCompression_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtCompression.TextChanged
        Me.btnSave.Enabled = Me.ProfileName.Length > 0
    End Sub

    Private Sub txtBrightness_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtBrightness.ValueChanged
        Me.btnSave.Enabled = Me.ProfileName.Length > 0
    End Sub

    Private Sub txtContrast_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtContrast.ValueChanged
        Me.btnSave.Enabled = Me.ProfileName.Length > 0
    End Sub

    Private Sub txtSharpness_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtSharpness.ValueChanged
        Me.btnSave.Enabled = Me.ProfileName.Length > 0
    End Sub

    Private Sub txtBlur_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtBlur.ValueChanged
        Me.btnSave.Enabled = Me.ProfileName.Length > 0
    End Sub

    Private Sub rdbPortrait_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdbPortrait.CheckedChanged
        Me.rdbLandscape.Checked = Not Me.rdbPortrait.Checked
        Me.btnSave.Enabled = Me.ProfileName.Length > 0
    End Sub

    Private Sub rdbLandscape_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdbLandscape.CheckedChanged
        Me.rdbPortrait.Checked = Not Me.rdbLandscape.Checked
        Me.btnSave.Enabled = Me.ProfileName.Length > 0
    End Sub

#End Region

#Region "Load Data"

    Private Sub LoadData()
        Dim ArrayList As New ArrayList
        Dim DigitalizationProfiles As DigitalizationProfileCollection = SqlCommands.SelectDigitalizationProfiles

        ArrayList.AddRange(DigitalizationProfiles)


        With Me.lbxDigitalizationProfiles
            .DisplayMember = "Name"
            .ValueMember = "ID"
            .DataSource = ArrayList
        End With

        If Me.lbxDigitalizationProfiles.Items.Count > 0 Then
            Me.btnDelete.Enabled = True
        Else
            Me.btnDelete.Enabled = False
            Clear()
        End If
    End Sub

    Private Sub LoadDigitalizationProfile(ByVal ID As Integer)
        Dim Profile As DigitalizationProfile = SqlCommands.SelectDigitalizationProfile(ID)

        Me.ProfileName = Profile.Name
        Me.Description = Profile.Description
        Me.Orientation = Profile.Orientation
        Me.Brightness = Profile.Brightness
        Me.Contrast = Profile.Contrast
        Me.Sharpness = Profile.Sharpness
        Me.Blur = Profile.Blur
        Me.Resolution = Profile.Resolution
        Me.BitDepth = Profile.BitDepth
        Me.Format = Profile.Format
        Me.Compression = Profile.Compression

        Me.btnSave.Enabled = False
    End Sub

#End Region

#Region "Auxiliary functions"

    'Private Function GetProfile() As DigitalizationProfile
    '    Dim Profile As New DigitalizationProfile

    '    Profile.ID = Me.ID
    '    Profile.Name = Me.ProfileName
    '    Profile.Description = Me.Description
    '    Profile.Rotation = Me.Rotation
    '    Profile.Brightness = Me.Brightness
    '    Profile.Contrast = Me.Contrast
    '    Profile.Sharpness = Me.Sharpness
    '    Profile.Blur = Me.Blur
    '    Profile.Resolution = Me.Resolution
    '    Profile.BitDepth = Me.BitDepth
    '    Profile.Format = Me.Format
    '    Profile.Compression = Me.Compression

    '    Return Profile
    'End Function

    Private Sub Clear()
        Me.ProfileName = ""
        Me.Description = ""
        Me.Resolution = ""
        Me.BitDepth = ""
        Me.Format = ""
        Me.Compression = ""
        Me.Brightness = ""
        Me.Contrast = ""
        Me.Sharpness = ""
        Me.Blur = ""
    End Sub

#End Region

End Class
