
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports DigitArq.Data.Entities.MGOD
Imports DigitArq.Data.Entities.MGUP
Imports DigitArq.Definitions.MGOD

Public Class FindProjectForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents lblAlert As System.Windows.Forms.Label
    Friend WithEvents btnFind As System.Windows.Forms.Button
    Friend WithEvents CbbDates As System.Windows.Forms.ComboBox
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents cbbEmployees As System.Windows.Forms.ComboBox
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents txtDate2 As MGOD.DateTextBox
    Friend WithEvents lblTM2 As System.Windows.Forms.Label
    Friend WithEvents txtDate1 As MGOD.DateTextBox
    Friend WithEvents ButtonsImageList As System.Windows.Forms.ImageList
    Friend WithEvents btnClose As System.Windows.Forms.Button
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents txtProjectName As MGOD.ColorTextBox
    Friend WithEvents txtDOName As MGOD.ColorTextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(FindProjectForm))
        Me.GroupBox1 = New System.Windows.Forms.GroupBox
        Me.btnClose = New System.Windows.Forms.Button
        Me.ButtonsImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.lblAlert = New System.Windows.Forms.Label
        Me.btnFind = New System.Windows.Forms.Button
        Me.txtProjectName = New MGOD.ColorTextBox
        Me.CbbDates = New System.Windows.Forms.ComboBox
        Me.PictureBox1 = New System.Windows.Forms.PictureBox
        Me.Label3 = New System.Windows.Forms.Label
        Me.cbbEmployees = New System.Windows.Forms.ComboBox
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label1 = New System.Windows.Forms.Label
        Me.txtDate2 = New MGOD.DateTextBox
        Me.lblTM2 = New System.Windows.Forms.Label
        Me.txtDate1 = New MGOD.DateTextBox
        Me.txtDOName = New MGOD.ColorTextBox
        Me.Label4 = New System.Windows.Forms.Label
        Me.GroupBox1.SuspendLayout()
        Me.SuspendLayout()
        '
        'GroupBox1
        '
        Me.GroupBox1.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.GroupBox1.Controls.Add(Me.btnClose)
        Me.GroupBox1.Controls.Add(Me.lblAlert)
        Me.GroupBox1.Controls.Add(Me.btnFind)
        Me.GroupBox1.Location = New System.Drawing.Point(-40, 128)
        Me.GroupBox1.Name = "GroupBox1"
        Me.GroupBox1.Size = New System.Drawing.Size(664, 120)
        Me.GroupBox1.TabIndex = 147
        Me.GroupBox1.TabStop = False
        '
        'btnClose
        '
        Me.btnClose.BackColor = System.Drawing.Color.White
        Me.btnClose.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnClose.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnClose.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnClose.ImageIndex = 5
        Me.btnClose.ImageList = Me.ButtonsImageList
        Me.btnClose.Location = New System.Drawing.Point(392, 15)
        Me.btnClose.Name = "btnClose"
        Me.btnClose.Size = New System.Drawing.Size(80, 25)
        Me.btnClose.TabIndex = 26
        Me.btnClose.Text = "Fechar"
        Me.btnClose.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'ButtonsImageList
        '
        Me.ButtonsImageList.ImageSize = New System.Drawing.Size(18, 18)
        Me.ButtonsImageList.ImageStream = CType(resources.GetObject("ButtonsImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ButtonsImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'lblAlert
        '
        Me.lblAlert.ForeColor = System.Drawing.Color.Red
        Me.lblAlert.Location = New System.Drawing.Point(136, 15)
        Me.lblAlert.Name = "lblAlert"
        Me.lblAlert.Size = New System.Drawing.Size(152, 24)
        Me.lblAlert.TabIndex = 24
        Me.lblAlert.Text = "Nenhum registo encontrado."
        Me.lblAlert.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'btnFind
        '
        Me.btnFind.BackColor = System.Drawing.Color.White
        Me.btnFind.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnFind.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnFind.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnFind.ImageIndex = 7
        Me.btnFind.ImageList = Me.ButtonsImageList
        Me.btnFind.Location = New System.Drawing.Point(297, 15)
        Me.btnFind.Name = "btnFind"
        Me.btnFind.Size = New System.Drawing.Size(88, 25)
        Me.btnFind.TabIndex = 23
        Me.btnFind.Text = "Pesquisar"
        Me.btnFind.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'txtProjectName
        '
        Me.txtProjectName.BackColor = System.Drawing.Color.White
        Me.txtProjectName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtProjectName.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtProjectName.Location = New System.Drawing.Point(184, 68)
        Me.txtProjectName.Name = "txtProjectName"
        Me.txtProjectName.Size = New System.Drawing.Size(248, 20)
        Me.txtProjectName.TabIndex = 146
        Me.txtProjectName.Text = ""
        '
        'CbbDates
        '
        Me.CbbDates.Location = New System.Drawing.Point(352, 14)
        Me.CbbDates.Name = "CbbDates"
        Me.CbbDates.Size = New System.Drawing.Size(80, 21)
        Me.CbbDates.TabIndex = 149
        '
        'PictureBox1
        '
        Me.PictureBox1.Image = CType(resources.GetObject("PictureBox1.Image"), System.Drawing.Image)
        Me.PictureBox1.Location = New System.Drawing.Point(16, 16)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(72, 72)
        Me.PictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage
        Me.PictureBox1.TabIndex = 148
        Me.PictureBox1.TabStop = False
        '
        'Label3
        '
        Me.Label3.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label3.Location = New System.Drawing.Point(91, 68)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(101, 20)
        Me.Label3.TabIndex = 145
        Me.Label3.Text = "Perfil incorporao"
        Me.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'cbbEmployees
        '
        Me.cbbEmployees.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cbbEmployees.Location = New System.Drawing.Point(184, 41)
        Me.cbbEmployees.Name = "cbbEmployees"
        Me.cbbEmployees.Size = New System.Drawing.Size(248, 21)
        Me.cbbEmployees.TabIndex = 144
        '
        'Label2
        '
        Me.Label2.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label2.Location = New System.Drawing.Point(91, 41)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(101, 20)
        Me.Label2.TabIndex = 143
        Me.Label2.Text = "Funcionrio"
        Me.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.Location = New System.Drawing.Point(254, 14)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(12, 20)
        Me.Label1.TabIndex = 142
        Me.Label1.Text = "a"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtDate2
        '
        Me.txtDate2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtDate2.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtDate2.Location = New System.Drawing.Point(272, 14)
        Me.txtDate2.Mask = "####-##-##"
        Me.txtDate2.MaxLength = 10
        Me.txtDate2.Name = "txtDate2"
        Me.txtDate2.Size = New System.Drawing.Size(64, 20)
        Me.txtDate2.TabIndex = 141
        Me.txtDate2.Text = ""
        '
        'lblTM2
        '
        Me.lblTM2.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTM2.Location = New System.Drawing.Point(91, 14)
        Me.lblTM2.Name = "lblTM2"
        Me.lblTM2.Size = New System.Drawing.Size(101, 20)
        Me.lblTM2.TabIndex = 140
        Me.lblTM2.Text = "Data de criao"
        Me.lblTM2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtDate1
        '
        Me.txtDate1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtDate1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtDate1.Location = New System.Drawing.Point(184, 14)
        Me.txtDate1.Mask = "####-##-##"
        Me.txtDate1.MaxLength = 10
        Me.txtDate1.Name = "txtDate1"
        Me.txtDate1.Size = New System.Drawing.Size(64, 20)
        Me.txtDate1.TabIndex = 139
        Me.txtDate1.Text = ""
        '
        'txtDOName
        '
        Me.txtDOName.BackColor = System.Drawing.Color.White
        Me.txtDOName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtDOName.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtDOName.Location = New System.Drawing.Point(184, 95)
        Me.txtDOName.Name = "txtDOName"
        Me.txtDOName.Size = New System.Drawing.Size(248, 20)
        Me.txtDOName.TabIndex = 151
        Me.txtDOName.Text = ""
        '
        'Label4
        '
        Me.Label4.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label4.Location = New System.Drawing.Point(91, 95)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(101, 20)
        Me.Label4.TabIndex = 150
        Me.Label4.Text = "Objecto digital"
        Me.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'FindProjectForm
        '
        Me.AcceptButton = Me.btnFind
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.WhiteSmoke
        Me.CancelButton = Me.btnClose
        Me.ClientSize = New System.Drawing.Size(448, 175)
        Me.Controls.Add(Me.txtDOName)
        Me.Controls.Add(Me.Label4)
        Me.Controls.Add(Me.txtProjectName)
        Me.Controls.Add(Me.txtDate2)
        Me.Controls.Add(Me.txtDate1)
        Me.Controls.Add(Me.CbbDates)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.cbbEmployees)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.lblTM2)
        Me.Controls.Add(Me.GroupBox1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.Name = "FindProjectForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Pesquisar perfis incorporao digital"
        Me.GroupBox1.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private database1 As New SQLDataBase
    Private database2 As New SqlCommands(USER_LOGON)
    
    Private Sub FindProjectForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        FillEmployees()
        FillCbbdates()
        Me.lblAlert.Visible = False
    End Sub

    Private Sub FillCbbdates()
        Dim li As New ComboBox.ObjectCollection(Me.CbbDates)

        Me.CbbDates.Items.Add("A partir de ?")
        Me.CbbDates.Items.Add("At ?")
        Me.CbbDates.Items.Add("Entre ? e ?")
        Me.CbbDates.Items.Add("Exacta")
        Me.CbbDates.SelectedIndex = 0
    End Sub

    Private Sub FillEmployees()
        Dim myArray As New ArrayList
        Dim EmployeeCollection As EmployeeCollection = database1.SelectAllEmployees

        Me.cbbEmployees.Items.Clear()

        myArray.AddRange(EmployeeCollection)
        myArray.Insert(0, New Employee(""))
        With Me.cbbEmployees
            .DisplayMember = "Username"
            .ValueMember = "Username"
            .DataSource = myArray
        End With
    End Sub

    Private Sub btnFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFind.Click
        Dim StrCommand As String
        Dim ProjectCollection As ProjectCollection
        Dim prequery As String = "SELECT P.Name, P.ProjectID, P.Description, P.CreationDateTime, " & _
                        "P.LastUpdateDateTime, P.Username, Count(DO.DigitalObjectID) AS DOCount FROM Projects P " & _
                        "LEFT JOIN DigitalObjects DO ON DO.ProjectID=P.ProjectID "

        Dim posquery As String = "GROUP BY P.Name, P.ProjectID, P.Description, P.CreationDateTime, P.LastUpdateDateTime, P.Username " & _
                        "ORDER BY P.ProjectID DESC"

        Select Case Me.CbbDates.SelectedIndex
            Case 0
                StrCommand = String.Format("WHERE P.CreationDateTime >= '{0}' " & _
                                "AND P.UserName LIKE '%{1}%' " & _
                                "AND P.Name LIKE '%{2}%' " & _
                                "AND DO.Name LIKE '%{3}%' ", _
                                Me.txtDate1.Text, Me.cbbEmployees.SelectedValue, Me.txtProjectName.Text, Me.txtDOName.Text)
            Case 1
                StrCommand = String.Format("WHERE P.CreationDateTime <= '{0}' " & _
                                "AND P.UserName LIKE '%{1}%' " & _
                                "AND P.Name LIKE '%{2}%' " & _
                                "AND DO.Name LIKE '%{3}%' ", _
                                Me.txtDate2.Text, Me.cbbEmployees.SelectedValue, Me.txtProjectName.Text, Me.txtDOName.Text)
            Case 2
                StrCommand = String.Format("WHERE P.CreationDateTime >= '{0}' AND P.CreationDateTime <= '{1}'" & _
                                "AND P.UserName LIKE '%{1}%' " & _
                                "AND P.Name LIKE '%{3}%' " & _
                                "AND DO.Name LIKE '%{4}%' ", _
                                Me.txtDate1.Text, Me.txtDate2.Text, Me.cbbEmployees.SelectedValue, Me.txtProjectName.Text, Me.txtDOName.Text)
            Case 3
                StrCommand = String.Format("WHERE P.CreationDateTime LIKE '%{0}%' " & _
                                "AND P.UserName LIKE '%{1}%' " & _
                                "AND P.Name LIKE '%{2}%' " & _
                                "AND DO.Name LIKE '%{3}%' ", _
                                Me.txtDate1.Text, Me.cbbEmployees.SelectedValue, Me.txtProjectName.Text, Me.txtDOName.Text)
        End Select
        StrCommand = prequery + StrCommand + posquery

        ProjectCollection = database2.SelectProjects(StrCommand)
        If ProjectCollection.Count > 0 Then
            Dim ProjectForm As ProjectsForm = Me.Owner
            ProjectForm.LoadData(ProjectCollection)
            Me.lblAlert.Visible = False
            Me.Close()
        Else
            Me.lblAlert.Visible = True
        End If
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Private Sub CbbDates_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CbbDates.SelectedIndexChanged
        Select Case Me.CbbDates.SelectedIndex
            Case 0
                Me.txtDate1.Enabled = True
                Me.txtDate2.Enabled = False
            Case 1
                Me.txtDate1.Enabled = False
                Me.txtDate2.Enabled = True
            Case 2
                Me.txtDate1.Enabled = True
                Me.txtDate2.Enabled = True
            Case 3
                Me.txtDate1.Enabled = True
                Me.txtDate2.Enabled = False
        End Select
    End Sub

End Class
