
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.IO
Imports System.Data.SqlClient
Imports CrystalDecisions.CrystalReports.Engine
Imports CrystalDecisions.Shared
Imports System.Threading
Imports System.Text.Encoding
Imports DigitArq.UserControls.ProgressDialog
Imports DigitArq.UserControls.ImageButton
Imports DigitArq.Data.Entities.MGOD
Imports DigitArq.Core.Logging
Imports DigitArq.Definitions.MGOD
Imports DigitArq.Utility


Public Class NewProjectForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()
        myCreateNewProject = True
        'This call is required by the Windows Form Designer.
        InitializeComponent()
        'Me.ConfigProjectTabPage.Enabled = False
        'Add any initialization after the InitializeComponent() call

    End Sub

    Public Sub New(ByVal ProjectToUpdate As Project)
        MyBase.New()
        myProject = ProjectToUpdate
        myCreateNewProject = False
        'This call is required by the Windows Form Designer.
        InitializeComponent()
        'Me.ConfigProjectTabPage.Enabled = True
        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents BackPanel As System.Windows.Forms.Panel
    Friend WithEvents TabControl As System.Windows.Forms.TabControl
    Friend WithEvents NewProjectTabPage As System.Windows.Forms.TabPage
    Friend WithEvents SaveButton As System.Windows.Forms.Button
    Friend WithEvents NewProjectPanel As System.Windows.Forms.Panel
    Friend WithEvents lblLastUpdateDateTime As System.Windows.Forms.Label
    Friend WithEvents lblEmployee As System.Windows.Forms.Label
    Friend WithEvents lblCreationDateTime As System.Windows.Forms.Label
    Friend WithEvents txtDescription As MGOD.ColorTextBox
    Friend WithEvents txtName As MGOD.ColorTextBox
    Friend WithEvents ConfigProjectTabPage As System.Windows.Forms.TabPage
    Friend WithEvents SaveConfigButton As System.Windows.Forms.Button
    Friend WithEvents CancelConfigButton As System.Windows.Forms.Button
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents SeparatorGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents DigitalizationProfileComboBox As System.Windows.Forms.ComboBox
    Friend WithEvents DigitalizationProfileLabel As System.Windows.Forms.Label
    Friend WithEvents TechnologicalPlatformComboBox As System.Windows.Forms.ComboBox
    Friend WithEvents TechnologicalPlatformLabel As System.Windows.Forms.Label
    Friend WithEvents LastUpdateDateTimeLabel As System.Windows.Forms.Label
    Friend WithEvents DescriptionLabel As System.Windows.Forms.Label
    Friend WithEvents Employeelabel As System.Windows.Forms.Label
    Friend WithEvents CreationDateTimeLabel As System.Windows.Forms.Label
    Friend WithEvents NameLabel As System.Windows.Forms.Label
    Friend WithEvents CancelEditButton As System.Windows.Forms.Button
    Friend WithEvents ButtonsImageList As System.Windows.Forms.ImageList
    Friend WithEvents ProjectsImageList As System.Windows.Forms.ImageList
    Friend WithEvents ToolTip As System.Windows.Forms.ToolTip
    Friend WithEvents NewProjectFooterGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents ConfigProjectFooterGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents ConfigProjectPanel As System.Windows.Forms.Panel
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents AddTechnologicalPlatformButton As ImageButton
    Friend WithEvents AddDigitalizationProfileButton As ImageButton
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(NewProjectForm))
        Me.ButtonsImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.ProjectsImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.ToolTip = New System.Windows.Forms.ToolTip(Me.components)
        Me.SaveButton = New System.Windows.Forms.Button
        Me.CancelEditButton = New System.Windows.Forms.Button
        Me.txtName = New MGOD.ColorTextBox
        Me.SaveConfigButton = New System.Windows.Forms.Button
        Me.CancelConfigButton = New System.Windows.Forms.Button
        Me.BackPanel = New System.Windows.Forms.Panel
        Me.TabControl = New System.Windows.Forms.TabControl
        Me.NewProjectTabPage = New System.Windows.Forms.TabPage
        Me.NewProjectPanel = New System.Windows.Forms.Panel
        Me.lblLastUpdateDateTime = New System.Windows.Forms.Label
        Me.LastUpdateDateTimeLabel = New System.Windows.Forms.Label
        Me.lblEmployee = New System.Windows.Forms.Label
        Me.lblCreationDateTime = New System.Windows.Forms.Label
        Me.txtDescription = New MGOD.ColorTextBox
        Me.DescriptionLabel = New System.Windows.Forms.Label
        Me.Employeelabel = New System.Windows.Forms.Label
        Me.CreationDateTimeLabel = New System.Windows.Forms.Label
        Me.NameLabel = New System.Windows.Forms.Label
        Me.NewProjectFooterGroupBox = New System.Windows.Forms.GroupBox
        Me.ConfigProjectTabPage = New System.Windows.Forms.TabPage
        Me.ConfigProjectPanel = New System.Windows.Forms.Panel
        Me.AddDigitalizationProfileButton = New ImageButton
        Me.AddTechnologicalPlatformButton = New ImageButton
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label1 = New System.Windows.Forms.Label
        Me.SeparatorGroupBox = New System.Windows.Forms.GroupBox
        Me.DigitalizationProfileComboBox = New System.Windows.Forms.ComboBox
        Me.DigitalizationProfileLabel = New System.Windows.Forms.Label
        Me.TechnologicalPlatformComboBox = New System.Windows.Forms.ComboBox
        Me.TechnologicalPlatformLabel = New System.Windows.Forms.Label
        Me.ConfigProjectFooterGroupBox = New System.Windows.Forms.GroupBox
        Me.BackPanel.SuspendLayout()
        Me.TabControl.SuspendLayout()
        Me.NewProjectTabPage.SuspendLayout()
        Me.NewProjectPanel.SuspendLayout()
        Me.NewProjectFooterGroupBox.SuspendLayout()
        Me.ConfigProjectTabPage.SuspendLayout()
        Me.ConfigProjectPanel.SuspendLayout()
        Me.ConfigProjectFooterGroupBox.SuspendLayout()
        Me.SuspendLayout()
        '
        'ButtonsImageList
        '
        Me.ButtonsImageList.ImageSize = New System.Drawing.Size(18, 18)
        Me.ButtonsImageList.ImageStream = CType(resources.GetObject("ButtonsImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ButtonsImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'ProjectsImageList
        '
        Me.ProjectsImageList.ImageSize = New System.Drawing.Size(16, 16)
        Me.ProjectsImageList.ImageStream = CType(resources.GetObject("ProjectsImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ProjectsImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'SaveButton
        '
        Me.SaveButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.SaveButton.BackColor = System.Drawing.Color.White
        Me.SaveButton.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.SaveButton.Enabled = False
        Me.SaveButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.SaveButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SaveButton.ForeColor = System.Drawing.Color.Black
        Me.SaveButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.SaveButton.ImageIndex = 2
        Me.SaveButton.ImageList = Me.ButtonsImageList
        Me.SaveButton.Location = New System.Drawing.Point(322, 13)
        Me.SaveButton.Name = "SaveButton"
        Me.SaveButton.Size = New System.Drawing.Size(76, 25)
        Me.SaveButton.TabIndex = 81
        Me.SaveButton.Text = "Guardar"
        Me.SaveButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.ToolTip.SetToolTip(Me.SaveButton, "Guardar")
        '
        'CancelEditButton
        '
        Me.CancelEditButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.CancelEditButton.BackColor = System.Drawing.Color.White
        Me.CancelEditButton.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.CancelEditButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.CancelEditButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.CancelEditButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.CancelEditButton.ImageIndex = 5
        Me.CancelEditButton.ImageList = Me.ButtonsImageList
        Me.CancelEditButton.Location = New System.Drawing.Point(405, 13)
        Me.CancelEditButton.Name = "CancelEditButton"
        Me.CancelEditButton.Size = New System.Drawing.Size(76, 25)
        Me.CancelEditButton.TabIndex = 82
        Me.CancelEditButton.Text = "Cancelar"
        Me.CancelEditButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.ToolTip.SetToolTip(Me.CancelEditButton, "Cancelar")
        '
        'txtName
        '
        Me.txtName.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtName.BackColor = System.Drawing.Color.White
        Me.txtName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtName.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtName.ForeColor = System.Drawing.Color.Black
        Me.txtName.Location = New System.Drawing.Point(104, 28)
        Me.txtName.MaxLength = 50
        Me.txtName.Name = "txtName"
        Me.txtName.Size = New System.Drawing.Size(376, 20)
        Me.txtName.TabIndex = 122
        Me.txtName.Text = ""
        Me.ToolTip.SetToolTip(Me.txtName, "E.g. DGARQ2008P-SGU")
        '
        'SaveConfigButton
        '
        Me.SaveConfigButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.SaveConfigButton.BackColor = System.Drawing.Color.White
        Me.SaveConfigButton.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.SaveConfigButton.Enabled = False
        Me.SaveConfigButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.SaveConfigButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SaveConfigButton.ForeColor = System.Drawing.Color.Black
        Me.SaveConfigButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.SaveConfigButton.ImageIndex = 2
        Me.SaveConfigButton.ImageList = Me.ButtonsImageList
        Me.SaveConfigButton.Location = New System.Drawing.Point(322, 13)
        Me.SaveConfigButton.Name = "SaveConfigButton"
        Me.SaveConfigButton.Size = New System.Drawing.Size(76, 25)
        Me.SaveConfigButton.TabIndex = 81
        Me.SaveConfigButton.Text = "Guardar"
        Me.SaveConfigButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.ToolTip.SetToolTip(Me.SaveConfigButton, "Guardar")
        '
        'CancelConfigButton
        '
        Me.CancelConfigButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.CancelConfigButton.BackColor = System.Drawing.Color.White
        Me.CancelConfigButton.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.CancelConfigButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.CancelConfigButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.CancelConfigButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.CancelConfigButton.ImageIndex = 5
        Me.CancelConfigButton.ImageList = Me.ButtonsImageList
        Me.CancelConfigButton.Location = New System.Drawing.Point(405, 13)
        Me.CancelConfigButton.Name = "CancelConfigButton"
        Me.CancelConfigButton.Size = New System.Drawing.Size(76, 25)
        Me.CancelConfigButton.TabIndex = 82
        Me.CancelConfigButton.Text = "Cancelar"
        Me.CancelConfigButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.ToolTip.SetToolTip(Me.CancelConfigButton, "Cancelar")
        '
        'BackPanel
        '
        Me.BackPanel.Controls.Add(Me.TabControl)
        Me.BackPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.BackPanel.Location = New System.Drawing.Point(0, 0)
        Me.BackPanel.Name = "BackPanel"
        Me.BackPanel.Size = New System.Drawing.Size(498, 291)
        Me.BackPanel.TabIndex = 80
        '
        'TabControl
        '
        Me.TabControl.Controls.Add(Me.NewProjectTabPage)
        Me.TabControl.Controls.Add(Me.ConfigProjectTabPage)
        Me.TabControl.Dock = System.Windows.Forms.DockStyle.Fill
        Me.TabControl.Location = New System.Drawing.Point(0, 0)
        Me.TabControl.Name = "TabControl"
        Me.TabControl.SelectedIndex = 0
        Me.TabControl.Size = New System.Drawing.Size(498, 291)
        Me.TabControl.TabIndex = 0
        '
        'NewProjectTabPage
        '
        Me.NewProjectTabPage.BackColor = System.Drawing.Color.WhiteSmoke
        Me.NewProjectTabPage.Controls.Add(Me.NewProjectPanel)
        Me.NewProjectTabPage.Controls.Add(Me.NewProjectFooterGroupBox)
        Me.NewProjectTabPage.Location = New System.Drawing.Point(4, 22)
        Me.NewProjectTabPage.Name = "NewProjectTabPage"
        Me.NewProjectTabPage.Size = New System.Drawing.Size(490, 265)
        Me.NewProjectTabPage.TabIndex = 0
        Me.NewProjectTabPage.Text = "Perfil de incorporao digital"
        '
        'NewProjectPanel
        '
        Me.NewProjectPanel.Controls.Add(Me.lblLastUpdateDateTime)
        Me.NewProjectPanel.Controls.Add(Me.LastUpdateDateTimeLabel)
        Me.NewProjectPanel.Controls.Add(Me.lblEmployee)
        Me.NewProjectPanel.Controls.Add(Me.lblCreationDateTime)
        Me.NewProjectPanel.Controls.Add(Me.txtDescription)
        Me.NewProjectPanel.Controls.Add(Me.txtName)
        Me.NewProjectPanel.Controls.Add(Me.DescriptionLabel)
        Me.NewProjectPanel.Controls.Add(Me.Employeelabel)
        Me.NewProjectPanel.Controls.Add(Me.CreationDateTimeLabel)
        Me.NewProjectPanel.Controls.Add(Me.NameLabel)
        Me.NewProjectPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.NewProjectPanel.Location = New System.Drawing.Point(0, 0)
        Me.NewProjectPanel.Name = "NewProjectPanel"
        Me.NewProjectPanel.Size = New System.Drawing.Size(490, 221)
        Me.NewProjectPanel.TabIndex = 119
        '
        'lblLastUpdateDateTime
        '
        Me.lblLastUpdateDateTime.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblLastUpdateDateTime.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblLastUpdateDateTime.Location = New System.Drawing.Point(298, 92)
        Me.lblLastUpdateDateTime.Name = "lblLastUpdateDateTime"
        Me.lblLastUpdateDateTime.Size = New System.Drawing.Size(70, 20)
        Me.lblLastUpdateDateTime.TabIndex = 127
        Me.lblLastUpdateDateTime.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'LastUpdateDateTimeLabel
        '
        Me.LastUpdateDateTimeLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.LastUpdateDateTimeLabel.Location = New System.Drawing.Point(208, 92)
        Me.LastUpdateDateTimeLabel.Name = "LastUpdateDateTimeLabel"
        Me.LastUpdateDateTimeLabel.Size = New System.Drawing.Size(88, 20)
        Me.LastUpdateDateTimeLabel.TabIndex = 126
        Me.LastUpdateDateTimeLabel.Text = "ltima alterao"
        Me.LastUpdateDateTimeLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblEmployee
        '
        Me.lblEmployee.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblEmployee.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblEmployee.Location = New System.Drawing.Point(104, 60)
        Me.lblEmployee.Name = "lblEmployee"
        Me.lblEmployee.Size = New System.Drawing.Size(264, 20)
        Me.lblEmployee.TabIndex = 125
        Me.lblEmployee.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblCreationDateTime
        '
        Me.lblCreationDateTime.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblCreationDateTime.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblCreationDateTime.Location = New System.Drawing.Point(104, 92)
        Me.lblCreationDateTime.Name = "lblCreationDateTime"
        Me.lblCreationDateTime.Size = New System.Drawing.Size(70, 20)
        Me.lblCreationDateTime.TabIndex = 124
        Me.lblCreationDateTime.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtDescription
        '
        Me.txtDescription.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtDescription.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtDescription.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtDescription.Location = New System.Drawing.Point(104, 124)
        Me.txtDescription.Multiline = True
        Me.txtDescription.Name = "txtDescription"
        Me.txtDescription.Size = New System.Drawing.Size(376, 80)
        Me.txtDescription.TabIndex = 123
        Me.txtDescription.Text = ""
        '
        'DescriptionLabel
        '
        Me.DescriptionLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.DescriptionLabel.Location = New System.Drawing.Point(16, 124)
        Me.DescriptionLabel.Name = "DescriptionLabel"
        Me.DescriptionLabel.Size = New System.Drawing.Size(83, 20)
        Me.DescriptionLabel.TabIndex = 121
        Me.DescriptionLabel.Text = "Descrio"
        Me.DescriptionLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Employeelabel
        '
        Me.Employeelabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Employeelabel.Location = New System.Drawing.Point(16, 60)
        Me.Employeelabel.Name = "Employeelabel"
        Me.Employeelabel.Size = New System.Drawing.Size(83, 20)
        Me.Employeelabel.TabIndex = 120
        Me.Employeelabel.Text = "Responsvel"
        Me.Employeelabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'CreationDateTimeLabel
        '
        Me.CreationDateTimeLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.CreationDateTimeLabel.Location = New System.Drawing.Point(16, 92)
        Me.CreationDateTimeLabel.Name = "CreationDateTimeLabel"
        Me.CreationDateTimeLabel.Size = New System.Drawing.Size(83, 20)
        Me.CreationDateTimeLabel.TabIndex = 119
        Me.CreationDateTimeLabel.Text = "Data criao"
        Me.CreationDateTimeLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'NameLabel
        '
        Me.NameLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.NameLabel.ForeColor = System.Drawing.Color.Red
        Me.NameLabel.Location = New System.Drawing.Point(16, 28)
        Me.NameLabel.Name = "NameLabel"
        Me.NameLabel.Size = New System.Drawing.Size(83, 20)
        Me.NameLabel.TabIndex = 118
        Me.NameLabel.Text = "Designao"
        Me.NameLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'NewProjectFooterGroupBox
        '
        Me.NewProjectFooterGroupBox.BackColor = System.Drawing.Color.WhiteSmoke
        Me.NewProjectFooterGroupBox.Controls.Add(Me.SaveButton)
        Me.NewProjectFooterGroupBox.Controls.Add(Me.CancelEditButton)
        Me.NewProjectFooterGroupBox.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.NewProjectFooterGroupBox.Location = New System.Drawing.Point(0, 221)
        Me.NewProjectFooterGroupBox.Name = "NewProjectFooterGroupBox"
        Me.NewProjectFooterGroupBox.Size = New System.Drawing.Size(490, 44)
        Me.NewProjectFooterGroupBox.TabIndex = 118
        Me.NewProjectFooterGroupBox.TabStop = False
        '
        'ConfigProjectTabPage
        '
        Me.ConfigProjectTabPage.Controls.Add(Me.ConfigProjectPanel)
        Me.ConfigProjectTabPage.Controls.Add(Me.ConfigProjectFooterGroupBox)
        Me.ConfigProjectTabPage.Location = New System.Drawing.Point(4, 22)
        Me.ConfigProjectTabPage.Name = "ConfigProjectTabPage"
        Me.ConfigProjectTabPage.Size = New System.Drawing.Size(490, 265)
        Me.ConfigProjectTabPage.TabIndex = 2
        Me.ConfigProjectTabPage.Text = "Pr-definies"
        '
        'ConfigProjectPanel
        '
        Me.ConfigProjectPanel.AutoScroll = True
        Me.ConfigProjectPanel.BackColor = System.Drawing.Color.WhiteSmoke
        Me.ConfigProjectPanel.Controls.Add(Me.AddDigitalizationProfileButton)
        Me.ConfigProjectPanel.Controls.Add(Me.AddTechnologicalPlatformButton)
        Me.ConfigProjectPanel.Controls.Add(Me.Label2)
        Me.ConfigProjectPanel.Controls.Add(Me.Label1)
        Me.ConfigProjectPanel.Controls.Add(Me.SeparatorGroupBox)
        Me.ConfigProjectPanel.Controls.Add(Me.DigitalizationProfileComboBox)
        Me.ConfigProjectPanel.Controls.Add(Me.DigitalizationProfileLabel)
        Me.ConfigProjectPanel.Controls.Add(Me.TechnologicalPlatformComboBox)
        Me.ConfigProjectPanel.Controls.Add(Me.TechnologicalPlatformLabel)
        Me.ConfigProjectPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.ConfigProjectPanel.Location = New System.Drawing.Point(0, 0)
        Me.ConfigProjectPanel.Name = "ConfigProjectPanel"
        Me.ConfigProjectPanel.Size = New System.Drawing.Size(490, 221)
        Me.ConfigProjectPanel.TabIndex = 120
        '
        'AddDigitalizationProfileButton
        '
        Me.AddDigitalizationProfileButton.BorderColor = System.Drawing.Color.WhiteSmoke
        Me.AddDigitalizationProfileButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.AddDigitalizationProfileButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.AddDigitalizationProfileButton.ButtonImage = CType(resources.GetObject("AddDigitalizationProfileButton.ButtonImage"), System.Drawing.Image)
        Me.AddDigitalizationProfileButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.AddDigitalizationProfileButton.ButtonShowShadow = True
        Me.AddDigitalizationProfileButton.ButtonText = ""
        Me.AddDigitalizationProfileButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.AddDigitalizationProfileButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.AddDigitalizationProfileButton.HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
        Me.AddDigitalizationProfileButton.Location = New System.Drawing.Point(426, 88)
        Me.AddDigitalizationProfileButton.Name = "AddDigitalizationProfileButton"
        Me.AddDigitalizationProfileButton.Size = New System.Drawing.Size(18, 18)
        Me.AddDigitalizationProfileButton.TabIndex = 9
        Me.AddDigitalizationProfileButton.ToolTip = ""
        '
        'AddTechnologicalPlatformButton
        '
        Me.AddTechnologicalPlatformButton.BorderColor = System.Drawing.Color.WhiteSmoke
        Me.AddTechnologicalPlatformButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.AddTechnologicalPlatformButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.AddTechnologicalPlatformButton.ButtonImage = CType(resources.GetObject("AddTechnologicalPlatformButton.ButtonImage"), System.Drawing.Image)
        Me.AddTechnologicalPlatformButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.AddTechnologicalPlatformButton.ButtonShowShadow = True
        Me.AddTechnologicalPlatformButton.ButtonText = ""
        Me.AddTechnologicalPlatformButton.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.AddTechnologicalPlatformButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.AddTechnologicalPlatformButton.HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
        Me.AddTechnologicalPlatformButton.Location = New System.Drawing.Point(426, 64)
        Me.AddTechnologicalPlatformButton.Name = "AddTechnologicalPlatformButton"
        Me.AddTechnologicalPlatformButton.Size = New System.Drawing.Size(18, 18)
        Me.AddTechnologicalPlatformButton.TabIndex = 8
        Me.AddTechnologicalPlatformButton.ToolTip = ""
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(20, 12)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(424, 40)
        Me.Label2.TabIndex = 7
        Me.Label2.Text = "Os parmetros definidos neste painel iro ser utilizados para preencher automatic" & _
        "amente a metainformao tcnica associada aos objectos digitais deste perfil de " & _
        "incorporao digital."
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.Location = New System.Drawing.Point(16, 124)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(168, 21)
        Me.Label1.TabIndex = 6
        Me.Label1.Text = "Vocabulrios controlados:"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'SeparatorGroupBox
        '
        Me.SeparatorGroupBox.Location = New System.Drawing.Point(16, 148)
        Me.SeparatorGroupBox.Name = "SeparatorGroupBox"
        Me.SeparatorGroupBox.Size = New System.Drawing.Size(424, 4)
        Me.SeparatorGroupBox.TabIndex = 5
        Me.SeparatorGroupBox.TabStop = False
        '
        'DigitalizationProfileComboBox
        '
        Me.DigitalizationProfileComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.DigitalizationProfileComboBox.Location = New System.Drawing.Point(155, 88)
        Me.DigitalizationProfileComboBox.Name = "DigitalizationProfileComboBox"
        Me.DigitalizationProfileComboBox.Size = New System.Drawing.Size(269, 21)
        Me.DigitalizationProfileComboBox.TabIndex = 4
        '
        'DigitalizationProfileLabel
        '
        Me.DigitalizationProfileLabel.Location = New System.Drawing.Point(20, 88)
        Me.DigitalizationProfileLabel.Name = "DigitalizationProfileLabel"
        Me.DigitalizationProfileLabel.Size = New System.Drawing.Size(130, 21)
        Me.DigitalizationProfileLabel.TabIndex = 2
        Me.DigitalizationProfileLabel.Text = "Perfil de digitalizao:"
        Me.DigitalizationProfileLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'TechnologicalPlatformComboBox
        '
        Me.TechnologicalPlatformComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.TechnologicalPlatformComboBox.Location = New System.Drawing.Point(155, 64)
        Me.TechnologicalPlatformComboBox.Name = "TechnologicalPlatformComboBox"
        Me.TechnologicalPlatformComboBox.Size = New System.Drawing.Size(269, 21)
        Me.TechnologicalPlatformComboBox.TabIndex = 1
        '
        'TechnologicalPlatformLabel
        '
        Me.TechnologicalPlatformLabel.Location = New System.Drawing.Point(20, 64)
        Me.TechnologicalPlatformLabel.Name = "TechnologicalPlatformLabel"
        Me.TechnologicalPlatformLabel.Size = New System.Drawing.Size(130, 21)
        Me.TechnologicalPlatformLabel.TabIndex = 0
        Me.TechnologicalPlatformLabel.Text = "Plataforma tecnolgica:"
        Me.TechnologicalPlatformLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'ConfigProjectFooterGroupBox
        '
        Me.ConfigProjectFooterGroupBox.BackColor = System.Drawing.Color.WhiteSmoke
        Me.ConfigProjectFooterGroupBox.Controls.Add(Me.SaveConfigButton)
        Me.ConfigProjectFooterGroupBox.Controls.Add(Me.CancelConfigButton)
        Me.ConfigProjectFooterGroupBox.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.ConfigProjectFooterGroupBox.Location = New System.Drawing.Point(0, 221)
        Me.ConfigProjectFooterGroupBox.Name = "ConfigProjectFooterGroupBox"
        Me.ConfigProjectFooterGroupBox.Size = New System.Drawing.Size(490, 44)
        Me.ConfigProjectFooterGroupBox.TabIndex = 119
        Me.ConfigProjectFooterGroupBox.TabStop = False
        '
        'NewProjectForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.White
        Me.ClientSize = New System.Drawing.Size(498, 291)
        Me.Controls.Add(Me.BackPanel)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.KeyPreview = True
        Me.MaximizeBox = False
        Me.Name = "NewProjectForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Novo perfil de incorporao digital"
        Me.BackPanel.ResumeLayout(False)
        Me.TabControl.ResumeLayout(False)
        Me.NewProjectTabPage.ResumeLayout(False)
        Me.NewProjectPanel.ResumeLayout(False)
        Me.NewProjectFooterGroupBox.ResumeLayout(False)
        Me.ConfigProjectTabPage.ResumeLayout(False)
        Me.ConfigProjectPanel.ResumeLayout(False)
        Me.ConfigProjectFooterGroupBox.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Private properties"

    Private myProject As Project
    Private myProjectID As Int64
    Private myComboboxConfigArrayList As New ArrayList
    Const DEFAULT_PROJECT_NAME As String = "NOVO"
    Private SqlCommands As New SqlCommands(USER_LOGON)
    Private myCreateNewProject As Boolean = True
    Public Shared configReader As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
    Private myProgressDialog As ProgressDialog
    Private SelectedIndex As Integer = 0
    Private myData As DataSet
    Private myDOFileCollection As DOFileCollection

#End Region


#Region "Form event handlers"

    Private Sub NewProject_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LoadData()
        SaveButtonEnabled = False
    End Sub

    Private Sub NewProjectForm_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        If Me.SaveButtonEnabled = True Then
            If MsgBox(InfoMessage("MainForm.AskBeforeSave"), MsgBoxStyle.YesNo Or MsgBoxStyle.Question Or MsgBoxStyle.DefaultButton1) = MsgBoxResult.Yes Then
                Save()
            End If
        End If
        Me.Close()
    End Sub

    Private Sub TabControl_TabIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TabControl.TabIndexChanged
        If Me.TabControl.SelectedTab Is Me.ConfigProjectTabPage Then
            LoadConfigurations()
        End If
    End Sub

#End Region

#Region "Properties"

    Private ReadOnly Property Project() As Project
        Get
            Return New Project(ProjectID, ProjectName, Description, _
            CreationDateTime, LastUpdateDateTime, Employee, _
            DigitalizationProfileID, TechnologicalPlatformID)
        End Get
    End Property


    Public Property ProjectID() As Int64
        Get
            Return myProjectID
        End Get
        Set(ByVal Value As Int64)
            myProjectID = Value
        End Set
    End Property

    Public Property ProjectName() As String
        Get
            Return Me.txtName.Text
        End Get
        Set(ByVal Value As String)
            Me.txtName.Text = Value
        End Set
    End Property

    Private Property Employee() As String
        Get
            Return Me.lblEmployee.Text
        End Get
        Set(ByVal Value As String)
            Me.lblEmployee.Text = Value
        End Set
    End Property

    Private Property CreationDateTime() As String
        Get
            Return Me.lblCreationDateTime.Text
        End Get
        Set(ByVal Value As String)
            Me.lblCreationDateTime.Text = Value
        End Set
    End Property

    Private Property LastUpdateDateTime() As String
        Get
            Return Me.lblLastUpdateDateTime.Text
        End Get
        Set(ByVal Value As String)
            Me.lblLastUpdateDateTime.Text = Value
        End Set
    End Property

    Private Property Description() As String
        Get
            Return Me.txtDescription.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtDescription.Text = Value
        End Set
    End Property

    Private Property DigitalizationProfileID() As Integer
        Get
            Return Me.DigitalizationProfileComboBox.SelectedValue
        End Get
        Set(ByVal Value As Integer)
            Me.DigitalizationProfileComboBox.SelectedValue = Value
        End Set
    End Property

    Private Property TechnologicalPlatformID() As Integer
        Get
            Return Me.TechnologicalPlatformComboBox.SelectedValue
        End Get
        Set(ByVal Value As Integer)
            Me.TechnologicalPlatformComboBox.SelectedValue = Value
        End Set
    End Property

    Private Property SaveButtonEnabled() As Boolean
        Get
            Return Me.SaveButton.Enabled()
        End Get
        Set(ByVal Value As Boolean)
            Me.SaveButton.Enabled = Value
            Me.SaveConfigButton.Enabled = Value
        End Set
    End Property

#End Region

#Region "Load data"

    Private Sub LoadData()
        If Not myCreateNewProject Then
            Me.ProjectID = myProject.ProjectID
            Me.ProjectName = myProject.Name
            Me.Employee = myProject.Username
            Me.CreationDateTime = myProject.CreationDateTime
            Me.LastUpdateDateTime = myProject.LastUpdateDateTime
            Me.Description = myProject.Description
            LoadConfigurations(True)
        Else
            Me.CreationDateTime = DateToDB(Now)
            Me.LastUpdateDateTime = DateToDB(Now)
            Me.Employee = USER_LOGON
            LoadConfigurations(False)
        End If
    End Sub

#End Region

#Region "Buttons event handlers"

    Private Sub CancelEditButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CancelEditButton.Click
        Me.Close()
    End Sub

    Private Sub CancelConfigButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CancelConfigButton.Click
        Me.Close()
    End Sub

    Private Sub SaveButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveButton.Click
        Save()
        Me.Close()
    End Sub

    Private Sub SaveConfigButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveConfigButton.Click
        Save()
        Me.Close()
    End Sub

#End Region

#Region "Textbox event handlers"

    Private Sub txtName_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtName.TextChanged
        SaveButtonEnabled = Me.ProjectName.Length > 0
    End Sub

    Private Sub txtDescription_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtDescription.TextChanged
        SaveButtonEnabled = Me.ProjectName.Length > 0
    End Sub

#End Region

#Region "Project config"

    Private Sub LoadConfigurations(Optional ByVal SelectValue As Boolean = True)
        LoadDigitalizationProfiles(SelectValue)
        LoadTechnologicalPlatforms(SelectValue)
        LoadControlledVocabularies(SelectValue)
    End Sub

    Private Sub LoadDigitalizationProfiles(Optional ByVal SelectValue As Boolean = True)
        Dim ArrayList As New ArrayList
        Dim DigitalizationProfiles As DigitalizationProfileCollection = SqlCommands.SelectDigitalizationProfiles
        Dim DigitalizationProfile As Integer
        If SelectValue Then
            DigitalizationProfile = SqlCommands.SelectDigitalizationProfileID(ProjectID)
        End If

        ArrayList.AddRange(DigitalizationProfiles)
        ArrayList.Insert(0, New DigitalizationProfile("", 0))

        With Me.DigitalizationProfileComboBox
            .DisplayMember = "CompleteName"
            .ValueMember = "ID"
            .DataSource = ArrayList
        End With
        If Not DigitalizationProfile.Equals(0) Then
            Me.DigitalizationProfileID = DigitalizationProfile
        End If
    End Sub

    Private Sub LoadTechnologicalPlatforms(Optional ByVal SelectValue As Boolean = True)
        Dim ArrayList As New ArrayList
        Dim TechnologicalPlatforms As TechnologicalPlatformCollection = SqlCommands.SelectTechnologicalPlatforms
        Dim TechnologicalPlatform As Integer
        If SelectValue Then
            TechnologicalPlatform = SqlCommands.SelectTechnologicalPlatformID(ProjectID)
        End If

        ArrayList.AddRange(TechnologicalPlatforms)
        ArrayList.Insert(0, New TechnologicalPlatform("", 0))

        With Me.TechnologicalPlatformComboBox
            .DisplayMember = "CompleteName"
            .ValueMember = "ID"
            .DataSource = ArrayList
        End With
        If Not TechnologicalPlatform.Equals(0) Then
            Me.TechnologicalPlatformID = TechnologicalPlatform
        End If
    End Sub

    Private Sub LoadControlledVocabularies(Optional ByVal SelectValue As Boolean = True)
        Dim myProgramState As New ProgramState
        Dim ControlledVocabularyCollection As ControlledVocabularyCollection = SqlCommands.SelectControlledVocabularies
        Dim Y As Integer = GetTop()

        myComboboxConfigArrayList.Clear()

        For Each ControlledVocabulary As ControlledVocabulary In ControlledVocabularyCollection
            Dim ArrayList As New ArrayList
            Dim Label As New Label
            With Label
                .Text = ControlledVocabulary.Name
                .Height = 21
                .Width = 130
                .Location = New Point(20, Y)
            End With
            Dim ComboBox As New ComboBox
            Dim VocabularyValueCollection As VocabularyValueCollection = SqlCommands.SelectControlledVocabularyValues(ControlledVocabulary.ID)
            Dim VocabularyValue As String
            If SelectValue Then
                VocabularyValue = SqlCommands.SelectVocabularyValue(ProjectID, ControlledVocabulary.ID)
            End If

            ComboBox.Items.Add("")
            For Each Value As VocabularyValue In VocabularyValueCollection
                ComboBox.Items.Add(Value)
            Next
            With ComboBox
                .Text = VocabularyValue
                .DropDownStyle = ComboBoxStyle.DropDownList
                .Height = 21
                .Width = 190
                .Location = New Point(155, Y)
            End With

            AddHandler ComboBox.SelectedIndexChanged, AddressOf ComboBox_SelectedIndexChanged

            Me.ConfigProjectPanel.Controls.Add(Label)
            Me.ConfigProjectPanel.Controls.Add(ComboBox)
            Me.myComboboxConfigArrayList.Add(ComboBox)

            Y += Label.Height + 2
        Next
    End Sub

    Private Function GetTop() As Integer
        If Me.BackPanel.Controls.Count > 0 Then
            Dim LastControl As Control = Me.ConfigProjectPanel.Controls.Item(Me.ConfigProjectPanel.Controls.IndexOf(Me.SeparatorGroupBox))
            Return LastControl.Top + LastControl.Height + 2
        Else
            Return 0
        End If
    End Function

    Private Sub TechnologicalPlatformComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TechnologicalPlatformComboBox.SelectedIndexChanged
        Me.SaveButtonEnabled = Me.ProjectName.Length > 0
    End Sub

    Private Sub DigitalizationProfileComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DigitalizationProfileComboBox.SelectedIndexChanged
        Me.SaveButtonEnabled = Me.ProjectName.Length > 0
    End Sub

    Private Sub ComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Me.SaveButtonEnabled = Me.ProjectName.Length > 0
    End Sub

    Private Sub AddTechnologicalPlatformButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddTechnologicalPlatformButton.Click
        Dim form As New TechnologicalPlataformForm
        form.ShowDialog(Me)
        LoadTechnologicalPlatforms(False)
    End Sub

    Private Sub AddDigitalizationProfileButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddDigitalizationProfileButton.Click
        Dim form As New DigitalizationProfilesForm
        form.ShowDialog(Me)
        LoadDigitalizationProfiles(False)
    End Sub

#End Region

#Region "Save"

    Private Sub Save()
        If myCreateNewProject Then
            InsertProject()
            UpdateProject()
        Else
            UpdateProject()
        End If
        Me.SaveButtonEnabled = False
    End Sub

#End Region

    '#Region "DELETE Project"

    '    Private Sub DeleteProjects()
    '        If MessageBox.Show(String.Format(InfoMessage("Projects.RemoveProject.Confirm"), Me.ProjectName), InfoMessage("Projects.Delete.ConfirmTitle"), MessageBoxButtons.YesNo, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2) = DialogResult.Yes Then

    '            myProgressDialog = New ProgressDialog.ProgressDialog(False)
    '            myProgressDialog.ShowTimeToEnd = True
    '            myProgressDialog.Text = InfoMessage("Delete.ProgressTitle")
    '            myProgressDialog.ShowDialog()
    '            Dim Thread As Thread = New Thread(New ThreadStart(AddressOf DeleteProject))
    '            Thread.Start()

    '            While Thread.IsAlive
    '                System.Windows.Forms.Application.DoEvents()
    '            End While

    '            myProgressDialog.Hide()
    '            myProgressDialog.Close()
    '            myProgressDialog.Dispose()
    '        End If
    '        'LoadData()
    '    End Sub

    '    Private Sub DeleteProject()
    '        myProgressDialog.Message = String.Format(InfoMessage("Delete.Project"), Me.ProjectName)
    '        Dim DigitalObjectCollection As MGOD.DigitalObjectCollection = SqlCommands.SelectDigitalObjects(ProjectID)
    '        For Each DigitalObject As MGOD.DigitalObject In DigitalObjectCollection
    '            DeleteDigitalObject(DigitalObject)
    '        Next
    '        SqlCommands.DeleteProject(Me.ProjectID)
    '        Log.Append(USER_LOGON, Log.RemoveNode, String.Format(LogMessage("Log.DeleteProject"), Me.ProjectName))
    '        myProgressDialog.Increment()
    '    End Sub

    '    Private Sub DeleteDigitalObject(ByVal DigitalObject As DigitalObject)
    '        myProgressDialog.Message = String.Format(InfoMessage("Delete.DigitalObject"), DigitalObject.Name)
    '        Dim DOFileCollection As DOFileCollection = SqlCommands.SelectFiles(DigitalObject.DigitalObjectID)
    '        For Each DOFile As MGOD.DOFile In DOFileCollection
    '            DeleteDOFile(DOFile)
    '        Next
    '        SqlCommands.DeleteDigitalObject(DigitalObject.DigitalObjectID)
    '        Log.Append(USER_LOGON, Log.RemoveNode, String.Format(LogMessage("Log.DeleteDigitalObject"), DigitalObject.Name))
    '        myProgressDialog.Increment()
    '    End Sub

    '    Private Function DeleteDOFile(ByVal DOFile As DOFile) As Boolean
    '        myProgressDialog.Message = String.Format(InfoMessage("Delete.File"), DOFile.Name)
    '        DeleteOriginal(DOFile)
    '        DeleteDissemination(DOFile)
    '        DeleteThumbnail(DOFile)
    '        SqlCommands.DeleteFile(DOFile.ID)
    '        Log.Append(USER_LOGON, Log.RemoveNode, String.Format(LogMessage("Log.DeleteFile"), DOFile.Name))
    '        myProgressDialog.Increment()
    '    End Function

    '    Private Function DeleteOriginal(ByVal DOfile As DOFile) As Boolean
    '        If DOfile.OriginalURL.StartsWith(FILE_STORAGE) Then
    '            Try
    '                Dim FileName As String = DOfile.OriginalURL.Substring(FILE_STORAGE.Length)
    '                If File.Exists(FileName) Then
    '                    File.Delete(FileName)
    '                End If
    '            Catch ex As Exception
    '                SqlCommands.MsgBoxException(ex)
    '            End Try
    '        ElseIf DOfile.OriginalURL.StartsWith(OBJECTVAULT_STORAGE) Then
    '            Try
    '                Dim ID As String = DOfile.OriginalURL.Substring(OBJECTVAULT_STORAGE.Length)
    '                Dim Vault As New ObjectVaultClient.ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
    '                Return Vault.Delete(ID)
    '            Catch ex As Exception
    '                SqlCommands.MsgBoxException(ex)
    '            End Try
    '        ElseIf DOfile.OriginalURL.StartsWith(SQLSERVER_STORAGE) Then
    '            Dim ID As String = DOfile.OriginalURL.Substring(SQLSERVER_STORAGE.Length)
    '            Return SqlCommands.DeleteBLOB(ID)
    '        End If
    '    End Function

    '    Private Function DeleteDissemination(ByVal DOfile As DOFile) As Boolean
    '        If DOfile.DisseminationURL.StartsWith(FILE_STORAGE) Then
    '            Dim FileName As String = DOfile.DisseminationURL.Substring(FILE_STORAGE.Length)
    '            If File.Exists(FileName) Then
    '                File.Delete(FileName)
    '            End If
    '        ElseIf DOfile.DisseminationURL.StartsWith(OBJECTVAULT_STORAGE) Then
    '            Try
    '                Dim ID As String = DOfile.DisseminationURL.Substring(OBJECTVAULT_STORAGE.Length)
    '                Dim Vault As New ObjectVaultClient.ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
    '                Vault.Delete(ID)
    '            Catch ex As Exception
    '                SqlCommands.MsgBoxException(ex)
    '            End Try
    '        ElseIf DOfile.DisseminationURL.StartsWith(SQLSERVER_STORAGE) Then
    '            Dim ID As String = DOfile.DisseminationURL.Substring(SQLSERVER_STORAGE.Length)
    '            SqlCommands.DeleteBLOB(ID)
    '        End If
    '    End Function

    '    Private Function DeleteThumbnail(ByVal DOfile As DOFile) As Boolean
    '        If DOfile.ThumbnailURL.StartsWith(FILE_STORAGE) Then
    '            Dim FileName As String = DOfile.ThumbnailURL.Substring(FILE_STORAGE.Length)
    '            If File.Exists(FileName) Then
    '                File.Delete(FileName)
    '            End If
    '        ElseIf DOfile.ThumbnailURL.StartsWith(OBJECTVAULT_STORAGE) Then
    '            Try
    '                Dim ID As String = DOfile.ThumbnailURL.Substring(OBJECTVAULT_STORAGE.Length)
    '                Dim Vault As New ObjectVaultClient.ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
    '                Return Vault.Delete(ID)
    '            Catch ex As Exception
    '                SqlCommands.MsgBoxException(ex)
    '            End Try
    '        ElseIf DOfile.ThumbnailURL.StartsWith(SQLSERVER_STORAGE) Then
    '            Dim ID As String = DOfile.ThumbnailURL.Substring(SQLSERVER_STORAGE.Length)
    '            Return SqlCommands.DeleteBLOB(ID)
    '        End If
    '    End Function

    '#End Region

#Region "INSERT Project"

    Public Sub InsertProject()
        Me.ProjectID = SqlCommands.InsertProject(Me.Project)
        If ProjectID Then
            Logger.Append(USER_LOGON, Logger.AppendNode, String.Format(LogMessage("Log.InsertProject"), Me.ProjectName))
        End If
    End Sub

#End Region

#Region "UPDATE Project"

    Private Sub UpdateProject()
        Me.LastUpdateDateTime = DateToDB(Now)
        If (Me.ProjectName.Length = 0) Then
            MsgBox(InfoMessage("Projects.InvalidName"), MsgBoxStyle.Information)
            Me.txtName.Focus()
            Exit Sub
        End If
        If SqlCommands.UpdateProject(Me.Project) Then
            Logger.Append(USER_LOGON, Logger.EditNode, String.Format(LogMessage("Log.UpdateProject"), Me.ProjectName))
            Dim ArrayList As New ArrayList
            For Each ComboBox As ComboBox In Me.myComboboxConfigArrayList
                If Not ComboBox.Text.Equals("") Then
                    ArrayList.Add(ComboBox.Text)
                End If
            Next
            SqlCommands.UpdateVocabulariesConfig(ProjectID, ArrayList)
        End If
    End Sub

#End Region

#Region "Gene disseminations"

    'Private Sub GeneDisseminations()
    '    For Each DOFile As DOFile In myDOFileCollection
    '        SaveDisseminationData(DOFile)
    '        SaveThumbnailData(DOFile)
    '    Next
    'End Sub

    'Private Function GetBinaryOriginalFile(ByVal URL As String) As Byte()
    '    Dim FileProcessing As New FileProcessing
    '    Dim Stream As New MemoryStream
    '    If URL.StartsWith(SQLSERVER_STORAGE) Then
    '        Dim ID As Int64 = URL.Substring(SQLSERVER_STORAGE.Length)
    '        Return SqlCommands.SelectBLOB(ID)

    '    ElseIf URL.StartsWith(FILE_STORAGE) Then
    '        Dim FilePath As String = URL.Substring(FILE_STORAGE.Length)
    '        Return FileProcessing.ReadBinaryFile(FilePath)

    '    ElseIf URL.StartsWith(OBJECTVAULT_STORAGE) Then
    '        Try
    '            Dim ID As String = URL.Substring(OBJECTVAULT_STORAGE.Length)
    '            Dim vault As New ObjectVaultClient.ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
    '            Return vault.Retrieve(ID)
    '        Catch ex As Exception
    '            SqlCommands.MsgBoxException(ex)
    '        End Try
    '    End If
    'End Function

    'Private Function SaveDisseminationData(ByVal DOFile As DOFile) As DOFile
    '    Dim FileProcessing As New FileProcessing
    '    Dim ProgramState As New ProgramState

    '    myProgressDialog.Message = String.Format(InfoMessage("Files.InsertDissemination"), DOFile.Name)
    '    Select Case ProgramState.DisseminationStorage
    '        Case ProgramState.StorageForm.Database
    '            Select Case DOFile.Format
    '                Case "TIFF", "TIF", "JPEG", "JPG"
    '                    Dim BinaryOriginalFile As Byte() = GetBinaryOriginalFile(DOFile.OriginalURL)
    '                    Dim BLOB As Byte() = FileProcessing.GenerateDisseminationImage(BinaryOriginalFile, ProgramState.DisseminationQuality, ProgramState.DisseminationDim, GetDimensionValue(ProgramState.DisseminationDim))
    '                    Dim ID As Int64 = SqlCommands.InsertBLOB(DOFile.ID, BLOB)
    '                    DOFile.DisseminationURL = SQLSERVER_STORAGE & CStr(ID)
    '                    DOFile.HasDissemination = True
    '                    SqlCommands.UpdateDOFile(DOFile)
    '                    Return DOFile

    '                Case "PDF", "DOC"
    '                    DOFile.DisseminationURL = DOFile.OriginalURL
    '                    SqlCommands.UpdateDOFile(DOFile)
    '                    Return DOFile

    '            End Select

    '        Case ProgramState.StorageForm.FileSystem

    '        Case ProgramState.StorageForm.ObjectVault
    '            Select Case DOFile.Format
    '                Case "TIFF", "TIF", "JPEG", "JPG"
    '                    Try
    '                        Dim BinaryOriginalFile As Byte() = GetBinaryOriginalFile(DOFile.OriginalURL)
    '                        Dim BLOB As Byte() = FileProcessing.GenerateDisseminationImage(BinaryOriginalFile, ProgramState.DisseminationQuality, ProgramState.DisseminationDim, GetDimensionValue(ProgramState.DisseminationDim))

    '                        Dim Vault As New ObjectVaultClient.ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
    '                        Dim CustomMetadata As New Hashtable
    '                        CustomMetadata.Add("Date", Now.ToShortDateString)
    '                        Dim DataStream As Stream = FileProcessing.WriteBinaryToStream(blob)
    '                        Dim Result As Byte() = Vault.Store(DataStream, DOFile.Name, CustomMetadata)
    '                        Dim ObjectID As String = ASCII.GetString(Result)

    '                        DOFile.DisseminationURL = OBJECTVAULT_STORAGE & ObjectID
    '                        DOFile.HasDissemination = True
    '                        SqlCommands.UpdateDOFile(DOFile)
    '                        Return DOFile
    '                    Catch ex As Exception
    '                        SqlCommands.MsgBoxException(ex)
    '                    End Try

    '                Case "PDF", "DOC"
    '                    DOFile.DisseminationURL = DOFile.OriginalURL
    '                    SqlCommands.UpdateDOFile(DOFile)
    '                    Return DOFile
    '            End Select
    '    End Select
    'End Function

    'Private Function SaveThumbnailData(ByVal DOFile As DOFile) As DOFile
    '    Dim FileProcessing As New FileProcessing
    '    Dim ProgramState As New ProgramState

    '    myProgressDialog.Message = String.Format(InfoMessage("Files.InsertThumbnail"), DOFile.Name)
    '    Select Case ProgramState.DisseminationStorage
    '        Case ProgramState.StorageForm.Database
    '            Select Case DOFile.Format
    '                Case "TIFF", "TIF", "JPEG", "JPG"
    '                    Dim BinaryOriginalFile As Byte() = GetBinaryOriginalFile(DOFile.OriginalURL)
    '                    Dim BLOB As Byte() = FileProcessing.GenerateThumbnailImage(BinaryOriginalFile, THUMBNAIL_WIDTH)
    '                    Dim ID As Int64 = SqlCommands.InsertBLOB(DOFile.ID, BLOB)
    '                    DOFile.ThumbnailURL = SQLSERVER_STORAGE & CStr(ID)
    '                    SqlCommands.UpdateDOFile(DOFile)
    '                    Return DOFile

    '                Case "PDF", "DOC"
    '                    DOFile.ThumbnailURL = DOFile.OriginalURL
    '                    SqlCommands.UpdateDOFile(DOFile)
    '                    Return DOFile

    '            End Select

    '        Case ProgramState.StorageForm.FileSystem

    '        Case ProgramState.StorageForm.ObjectVault
    '            Select Case DOFile.Format
    '                Case "TIFF", "TIF", "JPEG", "JPG"
    '                    Try
    '                        Dim BinaryOriginalFile As Byte() = GetBinaryOriginalFile(DOFile.OriginalURL)
    '                        Dim BLOB As Byte() = FileProcessing.GenerateThumbnailImage(BinaryOriginalFile, Constants.ThumbImageWidth)

    '                        Dim Vault As New ObjectVaultClient.ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
    '                        Dim CustomMetadata As New Hashtable
    '                        CustomMetadata.Add("Date", Now.ToShortDateString)
    '                        Dim DataStream As Stream = FileProcessing.WriteBinaryToStream(blob)
    '                        Dim Result As Byte() = Vault.Store(DataStream, DOFile.Name, CustomMetadata)
    '                        Dim ObjectID As String = ASCII.GetString(Result)

    '                        DOFile.ThumbnailURL = OBJECTVAULT_STORAGE & ObjectID
    '                        SqlCommands.UpdateDOFile(DOFile)
    '                        Return DOFile
    '                    Catch ex As Exception
    '                        SqlCommands.MsgBoxException(ex)
    '                    End Try

    '                Case "PDF", "DOC"
    '                    DOFile.ThumbnailURL = DOFile.OriginalURL
    '                    SqlCommands.UpdateDOFile(DOFile)
    '                    Return DOFile
    '            End Select
    '    End Select
    'End Function

    'Private Function GetDimensionValue(ByVal Dimension As ProgramState.DisseminationDimension) As Integer
    '    Dim myProgramState As New ProgramState
    '    Select Case Dimension
    '        Case ProgramState.DisseminationDimension.Width
    '            Return myProgramState.DisseminationWidth
    '        Case ProgramState.DisseminationDimension.Height
    '            Return myProgramState.DisseminationHeight
    '        Case ProgramState.DisseminationDimension.Resolution
    '            Return myProgramState.DisseminationResolution
    '    End Select
    'End Function

#End Region

End Class
