
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports DigitArq.Data.Entities.MGOD
Imports DigitArq.Core.Logging
Imports DigitArq.Definitions.MGOD
Imports DigitArq.Utility

Public Class ReformattingMethodsForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnChoose As System.Windows.Forms.Button
    Friend WithEvents gbxNorms As System.Windows.Forms.GroupBox
    Friend WithEvents btnNew As System.Windows.Forms.Button
    Friend WithEvents btnSave As System.Windows.Forms.Button
    Friend WithEvents txtDescription As MGOD.ColorTextBox
    Friend WithEvents lvwMethods As System.Windows.Forms.ListView
    Friend WithEvents imglButtons As System.Windows.Forms.ImageList
    Friend WithEvents btnDelete As System.Windows.Forms.Button
    Friend WithEvents chReformattingMethod As System.Windows.Forms.ColumnHeader
    Friend WithEvents chdescription As System.Windows.Forms.ColumnHeader
    Friend WithEvents txtMethod As MGOD.ColorTextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(ReformattingMethodsForm))
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Me.btnChoose = New System.Windows.Forms.Button
        Me.imglButtons = New System.Windows.Forms.ImageList(Me.components)
        Me.gbxNorms = New System.Windows.Forms.GroupBox
        Me.lvwMethods = New System.Windows.Forms.ListView
        Me.chReformattingMethod = New System.Windows.Forms.ColumnHeader
        Me.chdescription = New System.Windows.Forms.ColumnHeader
        Me.btnDelete = New System.Windows.Forms.Button
        Me.btnNew = New System.Windows.Forms.Button
        Me.btnSave = New System.Windows.Forms.Button
        Me.txtDescription = New MGOD.ColorTextBox
        Me.txtMethod = New MGOD.ColorTextBox
        Me.gbxNorms.SuspendLayout()
        Me.SuspendLayout()
        '
        'btnChoose
        '
        Me.btnChoose.BackColor = System.Drawing.Color.White
        Me.btnChoose.Enabled = False
        Me.btnChoose.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnChoose.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnChoose.ImageIndex = 0
        Me.btnChoose.ImageList = Me.imglButtons
        Me.btnChoose.Location = New System.Drawing.Point(638, 95)
        Me.btnChoose.Name = "btnChoose"
        Me.btnChoose.Size = New System.Drawing.Size(88, 25)
        Me.btnChoose.TabIndex = 120
        Me.btnChoose.Text = "Seleccionar"
        Me.btnChoose.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'imglButtons
        '
        Me.imglButtons.ImageSize = New System.Drawing.Size(18, 18)
        Me.imglButtons.ImageStream = CType(resources.GetObject("imglButtons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.imglButtons.TransparentColor = System.Drawing.Color.Transparent
        '
        'gbxNorms
        '
        Me.gbxNorms.Controls.Add(Me.lvwMethods)
        Me.gbxNorms.Location = New System.Drawing.Point(15, 15)
        Me.gbxNorms.Name = "gbxNorms"
        Me.gbxNorms.Size = New System.Drawing.Size(616, 240)
        Me.gbxNorms.TabIndex = 119
        Me.gbxNorms.TabStop = False
        Me.gbxNorms.Text = "Mtodos"
        '
        'lvwMethods
        '
        Me.lvwMethods.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lvwMethods.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lvwMethods.CheckBoxes = True
        Me.lvwMethods.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chReformattingMethod, Me.chdescription})
        Me.lvwMethods.FullRowSelect = True
        Me.lvwMethods.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
        Me.lvwMethods.Location = New System.Drawing.Point(8, 16)
        Me.lvwMethods.MultiSelect = False
        Me.lvwMethods.Name = "lvwMethods"
        Me.lvwMethods.Size = New System.Drawing.Size(600, 216)
        Me.lvwMethods.TabIndex = 1
        Me.lvwMethods.View = System.Windows.Forms.View.Details
        '
        'chReformattingMethod
        '
        Me.chReformattingMethod.Text = "Mtodo"
        Me.chReformattingMethod.Width = 250
        '
        'chdescription
        '
        Me.chdescription.Text = "Descrio"
        Me.chdescription.Width = 350
        '
        'btnDelete
        '
        Me.btnDelete.BackColor = System.Drawing.Color.White
        Me.btnDelete.Enabled = False
        Me.btnDelete.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnDelete.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnDelete.ImageIndex = 1
        Me.btnDelete.ImageList = Me.imglButtons
        Me.btnDelete.Location = New System.Drawing.Point(638, 63)
        Me.btnDelete.Name = "btnDelete"
        Me.btnDelete.Size = New System.Drawing.Size(88, 25)
        Me.btnDelete.TabIndex = 118
        Me.btnDelete.Text = CType(configurationAppSettings.GetValue("btnDelete.Text", GetType(System.String)), String)
        Me.btnDelete.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnNew
        '
        Me.btnNew.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.btnNew.BackColor = System.Drawing.SystemColors.Window
        Me.btnNew.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnNew.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnNew.ImageIndex = 0
        Me.btnNew.ImageList = Me.imglButtons
        Me.btnNew.Location = New System.Drawing.Point(638, 31)
        Me.btnNew.Name = "btnNew"
        Me.btnNew.Size = New System.Drawing.Size(88, 25)
        Me.btnNew.TabIndex = 117
        Me.btnNew.Text = CType(configurationAppSettings.GetValue("btnNew.Text", GetType(System.String)), String)
        Me.btnNew.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnSave
        '
        Me.btnSave.BackColor = System.Drawing.Color.White
        Me.btnSave.Enabled = False
        Me.btnSave.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnSave.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnSave.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnSave.ImageIndex = 2
        Me.btnSave.ImageList = Me.imglButtons
        Me.btnSave.Location = New System.Drawing.Point(638, 263)
        Me.btnSave.Name = "btnSave"
        Me.btnSave.Size = New System.Drawing.Size(88, 25)
        Me.btnSave.TabIndex = 116
        Me.btnSave.Text = CType(configurationAppSettings.GetValue("btnSave.Text", GetType(System.String)), String)
        Me.btnSave.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'txtDescription
        '
        Me.txtDescription.BackColor = System.Drawing.Color.White
        Me.txtDescription.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtDescription.Location = New System.Drawing.Point(24, 287)
        Me.txtDescription.Multiline = True
        Me.txtDescription.Name = "txtDescription"
        Me.txtDescription.Size = New System.Drawing.Size(600, 32)
        Me.txtDescription.TabIndex = 114
        Me.txtDescription.Text = ""
        '
        'txtMethod
        '
        Me.txtMethod.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtMethod.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtMethod.Location = New System.Drawing.Point(24, 263)
        Me.txtMethod.Name = "txtMethod"
        Me.txtMethod.Size = New System.Drawing.Size(600, 20)
        Me.txtMethod.TabIndex = 113
        Me.txtMethod.Text = ""
        '
        'ReformattingMethodsForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.WhiteSmoke
        Me.ClientSize = New System.Drawing.Size(736, 334)
        Me.Controls.Add(Me.btnChoose)
        Me.Controls.Add(Me.gbxNorms)
        Me.Controls.Add(Me.btnDelete)
        Me.Controls.Add(Me.btnNew)
        Me.Controls.Add(Me.btnSave)
        Me.Controls.Add(Me.txtDescription)
        Me.Controls.Add(Me.txtMethod)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.Name = "ReformattingMethodsForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Mtodos de reformatao"
        Me.gbxNorms.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private database As New SqlCommands(USER_LOGON)
    Private myReformattingMethods As DataSet
    Private myMethodID As Integer
    Const NEW_METHOD_NAME = "Novo"

#Region "Properties"

    Private ReadOnly Property ReformattingMethod() As ReformattingMethod
        Get
            Dim Method As New ReformattingMethod
            Method.ReformattingMethodID = Me.MethodID
            Method.ReformattingMethod = Me.Method
            Method.Description = Me.Description

            Return Method
        End Get
    End Property

    Private Property MethodID() As Integer
        Get
            Return myMethodID
        End Get
        Set(ByVal Value As Integer)
            myMethodID = Value
        End Set
    End Property

    Private Property Method() As String
        Get
            Return Me.txtMethod.Text
        End Get
        Set(ByVal Value As String)
            Me.txtMethod.Text = Value
        End Set
    End Property

    Private Property Description() As String
        Get
            Return Me.txtDescription.Text
        End Get
        Set(ByVal Value As String)
            Me.txtDescription.Text = Value
        End Set
    End Property

#End Region

    Private Sub ReformattingMethodsForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LoadListView()
    End Sub

    Private Sub LoadListView()
        Dim ReformattingMethodsCollection As ReformattingMethodCollection = database.SelectReformattingMethods
        Me.lvwMethods.Items.Clear()

        For Each ReformattingMethod As ReformattingMethod In ReformattingMethodsCollection
            Dim lvi As ListViewItem = New ListViewItem(ReformattingMethod.ReformattingMethod)
            lvi.SubItems.Add(ReformattingMethod.Description)
            lvi.Tag = ReformattingMethod.ReformattingMethodID

            Me.lvwMethods.Items.Add(lvi)
        Next
    End Sub

    Private Sub btnNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNew.Click
        Me.Method = NEW_METHOD_NAME
        Me.Description = ""
        Me.MethodID = database.InsertReformattingMethod(Me.ReformattingMethod)
        If Me.MethodID Then
            Logger.Append(USER_LOGON, Logger.AppendNode, LogMessage("Log.InsertReformattingMethod"))
            LoadListView()
            Me.btnSave.Enabled = True
        End If
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        If database.UpdateReformattingMethod(Me.ReformattingMethod) Then
            Logger.Append(USER_LOGON, Logger.AppendNode, String.Format(LogMessage("Log.UpdateReformattingMethod"), Me.ReformattingMethod))
            LoadListView()
            Me.btnSave.Enabled = False
        End If
    End Sub

    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        Try
            database.DeleteReformattingMethod(Me.MethodID)
            Logger.Append(USER_LOGON, Logger.AppendNode, String.Format(LogMessage("Log.DeleteReformattingMethod"), Me.ReformattingMethod))
            LoadListView()
        Catch ex As Exception
        End Try
    End Sub

    Private Sub btnChoose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChoose.Click
        Dim MainForm As MainForm = Me.Owner
        For Each lvi As ListViewItem In lvwMethods.CheckedItems
            MainForm.txtReformattingMethod.Text = lvi.SubItems(0).Text
            MainForm.txtReformattingMethod.Tag = lvi.Tag
        Next
        Me.Close()
    End Sub

    Private Sub lvwMethods_ItemCheck(ByVal sender As Object, ByVal e As System.Windows.Forms.ItemCheckEventArgs) Handles lvwMethods.ItemCheck
        For Each lvi As ListViewItem In lvwMethods.CheckedItems
            If lvi.Index <> e.Index Then
                lvi.Checked = False
            End If
        Next
        If e.NewValue = CheckState.Checked Then
            Me.btnChoose.Enabled = True
        Else
            Me.btnChoose.Enabled = False
        End If
    End Sub

    Private Sub lvwMethods_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvwMethods.SelectedIndexChanged
        If Me.lvwMethods.SelectedItems.Count > 0 Then
            Me.MethodID = Me.lvwMethods.SelectedItems(0).Tag
            Me.Method = Me.lvwMethods.SelectedItems(0).Text
            Me.Description = Me.lvwMethods.SelectedItems(0).SubItems(1).Text
            Me.btnDelete.Enabled = True
            Me.btnSave.Enabled = False
        End If
    End Sub

    Private Sub txtMethod_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtMethod.TextChanged
        Me.btnSave.Enabled = Me.Method.Length > 0
    End Sub

    Private Sub txtDescription_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtDescription.TextChanged
        Me.btnSave.Enabled = Me.Method.Length > 0
    End Sub

    Private Sub lvwMethods_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles lvwMethods.LostFocus
        Me.btnDelete.Enabled = False
    End Sub

    Private Sub lvwMethods_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles lvwMethods.GotFocus
        Me.btnDelete.Enabled = True
    End Sub

End Class
