
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports DigitArq.Data.Entities.MGOD
Imports DigitArq.Core.Logging
Imports DigitArq.Definitions.MGOD
Imports DigitArq.Utility

Public Class ReformattingNormsForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents txtNorm As MGOD.ColorTextBox
    Friend WithEvents txtDescription As MGOD.ColorTextBox
    Friend WithEvents btnSave As System.Windows.Forms.Button
    Friend WithEvents btnNew As MGOD.ColorButton
    Friend WithEvents gbxNorms As System.Windows.Forms.GroupBox
    Friend WithEvents lvwNorms As System.Windows.Forms.ListView
    Friend WithEvents btnChoose As System.Windows.Forms.Button
    Friend WithEvents imglButtons As System.Windows.Forms.ImageList
    Friend WithEvents chNorm As System.Windows.Forms.ColumnHeader
    Friend WithEvents chDescription As System.Windows.Forms.ColumnHeader
    Friend WithEvents btnDelete As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(ReformattingNormsForm))
        Me.txtNorm = New MGOD.ColorTextBox
        Me.txtDescription = New MGOD.ColorTextBox
        Me.imglButtons = New System.Windows.Forms.ImageList(Me.components)
        Me.btnSave = New System.Windows.Forms.Button
        Me.btnNew = New MGOD.ColorButton
        Me.btnDelete = New System.Windows.Forms.Button
        Me.gbxNorms = New System.Windows.Forms.GroupBox
        Me.lvwNorms = New System.Windows.Forms.ListView
        Me.chNorm = New System.Windows.Forms.ColumnHeader
        Me.chDescription = New System.Windows.Forms.ColumnHeader
        Me.btnChoose = New System.Windows.Forms.Button
        Me.gbxNorms.SuspendLayout()
        Me.SuspendLayout()
        '
        'txtNorm
        '
        Me.txtNorm.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtNorm.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtNorm.Location = New System.Drawing.Point(24, 263)
        Me.txtNorm.Name = "txtNorm"
        Me.txtNorm.Size = New System.Drawing.Size(600, 20)
        Me.txtNorm.TabIndex = 18
        Me.txtNorm.Text = ""
        '
        'txtDescription
        '
        Me.txtDescription.BackColor = System.Drawing.Color.White
        Me.txtDescription.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtDescription.Location = New System.Drawing.Point(24, 287)
        Me.txtDescription.Multiline = True
        Me.txtDescription.Name = "txtDescription"
        Me.txtDescription.Size = New System.Drawing.Size(600, 32)
        Me.txtDescription.TabIndex = 104
        Me.txtDescription.Text = ""
        '
        'imglButtons
        '
        Me.imglButtons.ImageSize = New System.Drawing.Size(18, 18)
        Me.imglButtons.ImageStream = CType(resources.GetObject("imglButtons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.imglButtons.TransparentColor = System.Drawing.Color.Transparent
        '
        'btnSave
        '
        Me.btnSave.BackColor = System.Drawing.Color.White
        Me.btnSave.Enabled = False
        Me.btnSave.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnSave.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnSave.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnSave.ImageIndex = 2
        Me.btnSave.ImageList = Me.imglButtons
        Me.btnSave.Location = New System.Drawing.Point(638, 263)
        Me.btnSave.Name = "btnSave"
        Me.btnSave.Size = New System.Drawing.Size(88, 25)
        Me.btnSave.TabIndex = 108
        Me.btnSave.Text = "Guardar"
        Me.btnSave.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnNew
        '
        Me.btnNew.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.btnNew.BackColor = System.Drawing.SystemColors.Window
        Me.btnNew.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnNew.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnNew.ImageIndex = 0
        Me.btnNew.ImageList = Me.imglButtons
        Me.btnNew.Location = New System.Drawing.Point(638, 31)
        Me.btnNew.Name = "btnNew"
        Me.btnNew.Size = New System.Drawing.Size(88, 25)
        Me.btnNew.TabIndex = 109
        Me.btnNew.Text = "Novo"
        Me.btnNew.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnDelete
        '
        Me.btnDelete.BackColor = System.Drawing.Color.White
        Me.btnDelete.Enabled = False
        Me.btnDelete.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnDelete.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnDelete.ImageIndex = 1
        Me.btnDelete.ImageList = Me.imglButtons
        Me.btnDelete.Location = New System.Drawing.Point(638, 63)
        Me.btnDelete.Name = "btnDelete"
        Me.btnDelete.Size = New System.Drawing.Size(88, 25)
        Me.btnDelete.TabIndex = 110
        Me.btnDelete.Text = "Eliminar"
        Me.btnDelete.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'gbxNorms
        '
        Me.gbxNorms.Controls.Add(Me.lvwNorms)
        Me.gbxNorms.Location = New System.Drawing.Point(15, 15)
        Me.gbxNorms.Name = "gbxNorms"
        Me.gbxNorms.Size = New System.Drawing.Size(616, 240)
        Me.gbxNorms.TabIndex = 111
        Me.gbxNorms.TabStop = False
        Me.gbxNorms.Text = "Normas"
        '
        'lvwNorms
        '
        Me.lvwNorms.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lvwNorms.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lvwNorms.CheckBoxes = True
        Me.lvwNorms.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chNorm, Me.chDescription})
        Me.lvwNorms.FullRowSelect = True
        Me.lvwNorms.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
        Me.lvwNorms.Location = New System.Drawing.Point(8, 16)
        Me.lvwNorms.Name = "lvwNorms"
        Me.lvwNorms.Size = New System.Drawing.Size(600, 216)
        Me.lvwNorms.TabIndex = 1
        Me.lvwNorms.View = System.Windows.Forms.View.Details
        '
        'chNorm
        '
        Me.chNorm.Text = "Norma"
        Me.chNorm.Width = 250
        '
        'chDescription
        '
        Me.chDescription.Text = "Descrio"
        Me.chDescription.Width = 350
        '
        'btnChoose
        '
        Me.btnChoose.BackColor = System.Drawing.Color.White
        Me.btnChoose.Enabled = False
        Me.btnChoose.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnChoose.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnChoose.ImageIndex = 0
        Me.btnChoose.ImageList = Me.imglButtons
        Me.btnChoose.Location = New System.Drawing.Point(638, 95)
        Me.btnChoose.Name = "btnChoose"
        Me.btnChoose.Size = New System.Drawing.Size(88, 25)
        Me.btnChoose.TabIndex = 112
        Me.btnChoose.Text = "Seleccionar"
        Me.btnChoose.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'ReformattingNormsForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.WhiteSmoke
        Me.ClientSize = New System.Drawing.Size(736, 334)
        Me.Controls.Add(Me.btnChoose)
        Me.Controls.Add(Me.gbxNorms)
        Me.Controls.Add(Me.btnDelete)
        Me.Controls.Add(Me.btnNew)
        Me.Controls.Add(Me.btnSave)
        Me.Controls.Add(Me.txtDescription)
        Me.Controls.Add(Me.txtNorm)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.Name = "ReformattingNormsForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Normas de reformatao"
        Me.gbxNorms.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private database As New SqlCommands(USER_LOGON)
    Private myNormID As Integer
    Const NEW_NORM_NAME As String = "Nova norma"


#Region "Properties"

    Private ReadOnly Property ReformattingNorm() As ReformattingNorm
        Get
            Dim Norm As New ReformattingNorm
            Norm.ReformattingNormID = Me.NormID
            Norm.ReformattingNorm = Me.Norm
            Norm.Description = Me.Description

            Return Norm
        End Get
    End Property

    Private Property NormID() As Integer
        Get
            Return myNormID
        End Get
        Set(ByVal Value As Integer)
            myNormID = Value
        End Set
    End Property

    Private Property Norm() As String
        Get
            Return Me.txtNorm.Text
        End Get
        Set(ByVal Value As String)
            Me.txtNorm.Text = Value
        End Set
    End Property

    Private Property Description() As String
        Get
            Return Me.txtDescription.Text
        End Get
        Set(ByVal Value As String)
            Me.txtDescription.Text = Value
        End Set
    End Property

#End Region


    Private Sub ReformattingNormsForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LoadListView()
    End Sub

    Private Sub LoadListView()
        Dim ReformattingNormCollection As ReformattingNormCollection = database.SelectReformattingNorms
        Me.lvwNorms.Items.Clear()

        For Each ReformattingNorm As ReformattingNorm In ReformattingNormCollection
            Dim lvi As ListViewItem = New ListViewItem(ReformattingNorm.ReformattingNorm)
            lvi.SubItems.Add(ReformattingNorm.Description)
            lvi.Tag = ReformattingNorm.ReformattingNormID

            Me.lvwNorms.Items.Add(lvi)
        Next
    End Sub

    Private Sub lvwNorms_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvwNorms.SelectedIndexChanged
        If Me.lvwNorms.SelectedItems.Count > 0 Then
            Me.NormID = Me.lvwNorms.SelectedItems(0).Tag
            Me.Norm = Me.lvwNorms.SelectedItems(0).Text
            Me.Description = Me.lvwNorms.SelectedItems(0).SubItems(1).Text
            Me.btnSave.Enabled = False
        End If
    End Sub

    Private Sub btnNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNew.Click
        Me.Norm = NEW_NORM_NAME
        Me.Description = ""
        Me.NormID = database.InsertReformattingNorm(Me.ReformattingNorm)
        If Me.NormID Then
            Logger.Append(USER_LOGON, Logger.AppendNode, LogMessage("Log.InsertReformattingNorm"))
        End If
        LoadListView()
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        If database.UpdateReformattingNorm(Me.ReformattingNorm) Then
            LoadListView()
            Logger.Append(USER_LOGON, Logger.AppendNode, String.Format(LogMessage("Log.UpdateReformattingNorm"), Me.ReformattingNorm))
        End If
        Me.btnSave.Enabled = False
    End Sub

    Private Sub bttnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        Try
            database.DeleteReformattingNorm(Me.NormID)
            LoadListView()
            Logger.Append(USER_LOGON, Logger.AppendNode, String.Format(LogMessage("Log.DeleteReformattingNorm"), Me.ReformattingNorm))
        Catch ex As Exception
        End Try
    End Sub

    Private Sub btnChoose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChoose.Click
        Dim MainForm As MainForm = Me.Owner
        Dim myReformattingNormsChoosen As New DataTable
        myReformattingNormsChoosen.Columns.Add("ReformattingNormID")
        myReformattingNormsChoosen.Columns.Add("ReformattingNorm")

        For Each lvi As ListViewItem In lvwNorms.CheckedItems
            Dim dr As DataRow = myReformattingNormsChoosen.NewRow()
            dr.Item("ReformattingNormID") = lvi.Tag
            dr.Item("ReformattingNorm") = lvi.SubItems(0).Text
            myReformattingNormsChoosen.Rows.Add(dr)
        Next
        MainForm.lbxReformattingNormsChoosen.DataSource = myReformattingNormsChoosen
        MainForm.lbxReformattingNormsChoosen.ValueMember = "ReformattingNormID"
        MainForm.lbxReformattingNormsChoosen.DisplayMember = "ReformattingNorm"
        Me.Close()
    End Sub

    Private Sub txtNorm_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtNorm.TextChanged
        If Me.Norm.Length > 0 Then
            Me.btnSave.Enabled = True
        End If
    End Sub

    Private Sub txtDescription_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtDescription.TextChanged
        Me.btnSave.Enabled = True
    End Sub

    Private Sub lvwNorms_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles lvwNorms.LostFocus
        Me.btnDelete.Enabled = False
    End Sub

    Private Sub lvwNorms_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles lvwNorms.GotFocus
        Me.btnDelete.Enabled = True
    End Sub

    Private Sub lvwNorms_ItemCheck(ByVal sender As Object, ByVal e As System.Windows.Forms.ItemCheckEventArgs) Handles lvwNorms.ItemCheck
        For Each lvi As ListViewItem In lvwNorms.CheckedItems
            If lvi.Checked = True Then
                Me.btnChoose.Enabled = True
            End If
        Next
    End Sub

End Class
