
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports DigitArq.Data.Entities.MGOD
Imports DigitArq.Definitions.MGOD
Imports DigitArq.Utility

Public Class RevisionIntervalForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents GroupBox4 As System.Windows.Forms.GroupBox
    Friend WithEvents txtRevisionInterval As MGOD.ColorTextBox
    Friend WithEvents lblYears As System.Windows.Forms.Label
    Friend WithEvents btnClose As System.Windows.Forms.Button
    Friend WithEvents btnSave As System.Windows.Forms.Button
    Friend WithEvents lblRevisionInterval As System.Windows.Forms.Label
    Friend WithEvents ButtonsImageList As System.Windows.Forms.ImageList
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(RevisionIntervalForm))
        Me.lblRevisionInterval = New System.Windows.Forms.Label
        Me.btnClose = New System.Windows.Forms.Button
        Me.ButtonsImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.btnSave = New System.Windows.Forms.Button
        Me.GroupBox4 = New System.Windows.Forms.GroupBox
        Me.lblYears = New System.Windows.Forms.Label
        Me.txtRevisionInterval = New MGOD.ColorTextBox
        Me.SuspendLayout()
        '
        'lblRevisionInterval
        '
        Me.lblRevisionInterval.BackColor = System.Drawing.Color.Transparent
        Me.lblRevisionInterval.Location = New System.Drawing.Point(13, 24)
        Me.lblRevisionInterval.Name = "lblRevisionInterval"
        Me.lblRevisionInterval.Size = New System.Drawing.Size(144, 20)
        Me.lblRevisionInterval.TabIndex = 0
        Me.lblRevisionInterval.Text = "Intervalo de reviso actual:"
        Me.lblRevisionInterval.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'btnClose
        '
        Me.btnClose.BackColor = System.Drawing.Color.Transparent
        Me.btnClose.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnClose.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnClose.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnClose.ImageIndex = 5
        Me.btnClose.ImageList = Me.ButtonsImageList
        Me.btnClose.Location = New System.Drawing.Point(181, 83)
        Me.btnClose.Name = "btnClose"
        Me.btnClose.Size = New System.Drawing.Size(72, 25)
        Me.btnClose.TabIndex = 8
        Me.btnClose.Text = CType(configurationAppSettings.GetValue("btnClose.Text", GetType(System.String)), String)
        Me.btnClose.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'ButtonsImageList
        '
        Me.ButtonsImageList.ImageSize = New System.Drawing.Size(18, 18)
        Me.ButtonsImageList.ImageStream = CType(resources.GetObject("ButtonsImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ButtonsImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'btnSave
        '
        Me.btnSave.BackColor = System.Drawing.Color.White
        Me.btnSave.Enabled = False
        Me.btnSave.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnSave.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnSave.ImageIndex = 2
        Me.btnSave.ImageList = Me.ButtonsImageList
        Me.btnSave.Location = New System.Drawing.Point(102, 83)
        Me.btnSave.Name = "btnSave"
        Me.btnSave.Size = New System.Drawing.Size(72, 25)
        Me.btnSave.TabIndex = 7
        Me.btnSave.Text = CType(configurationAppSettings.GetValue("btnSave.Text", GetType(System.String)), String)
        Me.btnSave.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'GroupBox4
        '
        Me.GroupBox4.Location = New System.Drawing.Point(7, 69)
        Me.GroupBox4.Name = "GroupBox4"
        Me.GroupBox4.Size = New System.Drawing.Size(246, 3)
        Me.GroupBox4.TabIndex = 57
        Me.GroupBox4.TabStop = False
        '
        'lblYears
        '
        Me.lblYears.BackColor = System.Drawing.Color.Transparent
        Me.lblYears.Location = New System.Drawing.Point(213, 24)
        Me.lblYears.Name = "lblYears"
        Me.lblYears.Size = New System.Drawing.Size(40, 20)
        Me.lblYears.TabIndex = 58
        Me.lblYears.Text = "(anos)"
        Me.lblYears.TextAlign = System.Drawing.ContentAlignment.BottomLeft
        '
        'txtRevisionInterval
        '
        Me.txtRevisionInterval.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtRevisionInterval.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtRevisionInterval.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtRevisionInterval.Location = New System.Drawing.Point(160, 24)
        Me.txtRevisionInterval.Name = "txtRevisionInterval"
        Me.txtRevisionInterval.Size = New System.Drawing.Size(47, 20)
        Me.txtRevisionInterval.TabIndex = 59
        Me.txtRevisionInterval.Text = ""
        '
        'RevisionIntervalForm
        '
        Me.AcceptButton = Me.btnSave
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.White
        Me.CancelButton = Me.btnClose
        Me.ClientSize = New System.Drawing.Size(266, 117)
        Me.Controls.Add(Me.txtRevisionInterval)
        Me.Controls.Add(Me.lblYears)
        Me.Controls.Add(Me.GroupBox4)
        Me.Controls.Add(Me.btnClose)
        Me.Controls.Add(Me.btnSave)
        Me.Controls.Add(Me.lblRevisionInterval)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.KeyPreview = True
        Me.MaximizeBox = False
        Me.Name = "RevisionIntervalForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Intervalo de reviso"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private myData As New DataSet
    Private Database As New SqlCommands(USER_LOGON)
    Private configReader As System.Configuration.AppSettingsReader = _
                 New System.Configuration.AppSettingsReader


    Private Sub RevisionIntervalForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.RevisionInterval = database.SelectRevisionInterval
        Me.btnSave.Enabled = False
    End Sub

    Property RevisionInterval() As String
        Get
            Return Me.txtRevisionInterval.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtRevisionInterval.Text = Value
        End Set
    End Property

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        If Not IsInteger(Me.RevisionInterval) Then
            MsgBox(InfoMessage("RevisionInterval.InvalidValue"), MsgBoxStyle.Exclamation)
            txtRevisionInterval.Focus()
            Exit Sub
        End If
        Dim res As Boolean = database.InsertRevisionInterval(Me.RevisionInterval)
        Me.btnSave.Enabled = False
        Me.Close()
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Private Sub txtRevisionInterval_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtRevisionInterval.TextChanged
        Me.btnSave.Enabled = True
    End Sub

    Private Function IsInteger(ByVal Value As String) As Boolean
        Dim Int As Integer
        Try
            Int = CType(Value, Integer)
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

End Class
