
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports DigitArq.Data.Entities.MGUP

Public Class ApplicationsMenu2
    Inherits BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents Panel1 As System.Web.UI.WebControls.Panel
    Protected WithEvents Panel3 As System.Web.UI.WebControls.Panel
    Protected WithEvents lnkbSave As System.Web.UI.WebControls.LinkButton
    Protected WithEvents dgApplications As System.Web.UI.WebControls.DataGrid
    Protected WithEvents txbNewApplication As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbNewVersion As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbNewApplicationCode As System.Web.UI.WebControls.TextBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private objI As New SQLDataBase

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        If Not Me.Page.IsPostBack Then
            If objI.accessFunction(HttpContext.Current.User.Identity.Name, Me.Request.QueryString("select")) Then
                Me.lnkbSave.Text = GetLabel("profilesMenu2.lnkbSave")
                BindData()
            Else
                Response.Redirect("defaultIn.aspx?page=gpu-0&lbl=accessDenied")
            End If
        End If
    End Sub

    Private Sub BindData()
        Dim c0 As ButtonColumn = Me.dgApplications.Columns(0)
        c0.Text = String.Format("<img src='Images/delete.png' alt='{0}' border='0'", GetLabel("alt.Delete"))

        Dim c1 As EditCommandColumn = Me.dgApplications.Columns(1)
        c1.EditText = String.Format("<img src='Images/edit.png' alt='{0}' border='0'", GetLabel("alt.Edit"))
        c1.UpdateText = String.Format("<img src='Images/save.png' alt='{0}' border='0'>", GetLabel("alt.Update"))
        c1.CancelText = String.Format("<img src='Images/cancel.png' alt='{0}' border='0'", GetLabel("alt.Cancel"))

        Me.dgApplications.Columns(2).HeaderText = GetLabel("ApplicationsMenu2.dgApplications.column2HeaderText")
        Me.dgApplications.Columns(3).HeaderText = GetLabel("ApplicationsMenu2.dgApplications.column3HeaderText")
        Me.dgApplications.Columns(4).HeaderText = GetLabel("ApplicationsMenu2.dgApplications.column4HeaderText")

        Me.dgApplications.DataSource = objI.loadApplications()
        Me.dgApplications.DataBind()
    End Sub

    Private Sub lnkbSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbSave.Click
        Dim strNewProfile As String = Me.txbNewApplication.Text.Trim
        Dim objApplication As New Application
        objApplication.ApplicationCode = Me.txbNewApplicationCode.Text.Trim
        objApplication.ApplicationName = Me.txbNewApplication.Text.Trim
        objApplication.Version = Me.txbNewVersion.Text.Trim
        objI.storeApplication(objApplication)
        BindData()
        Me.txbNewApplicationCode.Text = ""
        Me.txbNewApplication.Text = ""
        Me.txbNewVersion.Text = ""
    End Sub

    Private Sub dgApplications_DeleteCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles dgApplications.DeleteCommand
        Dim strApplicationCode As String = Me.dgApplications.DataKeys(e.Item.ItemIndex)
        objI.deleteApplication(strApplicationCode)
        BindData()
    End Sub

    Private Sub dgApplications_UpdateCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles dgApplications.UpdateCommand
        Dim objApplication As New Application
        objApplication.ApplicationCode = Me.dgApplications.DataKeys(e.Item.ItemIndex)
        objApplication.ApplicationName = (CType(e.Item.Cells(3).Controls(0), TextBox).Text).ToString
        objApplication.Version = (CType(e.Item.Cells(4).Controls(0), TextBox).Text).ToString

        objI.updateApplication(objApplication)
        Me.dgApplications.EditItemIndex = -1
        BindData()
    End Sub

    Private Sub dgApplications_CancelCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles dgApplications.CancelCommand
        Me.dgApplications.EditItemIndex = -1
        BindData()
    End Sub

    Private Sub dgApplications_EditCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles dgApplications.EditCommand
        Me.dgApplications.EditItemIndex = e.Item.ItemIndex
        BindData()
    End Sub

    Private Sub dgApplications_ItemDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles dgApplications.ItemDataBound
        If e.Item.ItemType = ListItemType.EditItem Then
            DirectCast(e.Item.Cells(3).Controls(0), TextBox).Attributes.Add("Class", "txb")
            DirectCast(e.Item.Cells(4).Controls(0), TextBox).Attributes.Add("Class", "txb")
        End If

        If e.Item.ItemType = ListItemType.Item Or _
            e.Item.ItemType = ListItemType.AlternatingItem Or _
            e.Item.ItemType = ListItemType.EditItem Then
            With DirectCast(e.Item.Cells(0).Controls(0), LinkButton)
                .Attributes.Add("onClick", "return confirm('" & GetLabel("popup.delete") & "');")
            End With
        End If
    End Sub
End Class
