
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.IO
Imports DigitArq.Data.Entities.MGUP

Public Class statsIBDGerRelD
    Inherits BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected WithEvents rblChoice As System.Web.UI.WebControls.RadioButtonList
    Protected WithEvents lblTypeOp As System.Web.UI.WebControls.Label
    Protected WithEvents lblInfo As System.Web.UI.WebControls.Label
    Protected WithEvents lnkbExport As System.Web.UI.WebControls.LinkButton
    Protected WithEvents dgRel As System.Web.UI.WebControls.DataGrid

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Dim hshDatabase As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

    Private ServerAddress As String = hshDatabase("ServerAddress")
    Private GPUDatabase As String = hshDatabase("Database")
    Private SA_Username As String = hshDatabase("SA_Username")
    Private SA_Password As String = hshDatabase("SA_Password")
    Private Username As String = hshDatabase("Username")
    Private Password As String = hshDatabase("Password")

    Private myConnString As String = String.Format("Data Source={0}; Initial Catalog={1}; User ID={2}; password={3}", ServerAddress, GPUDatabase, Username, Password)

    Private objI As SQLDataBase = New SQLDataBase
    Private objM As Misc = New Misc

    Public count As Int32 = 0

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If Not Me.Page.IsPostBack Then
            lnkbExport.Text = GetLabel("statsButton.lblExport")
            loadChoices(rblChoice)
        End If
    End Sub

    Private Sub rblChoice_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rblChoice.SelectedIndexChanged
        Me.dgRel.CurrentPageIndex() = 0
        Dim ds As New DataSet
        Dim tF As Int32 = objI.stCalcTotFunds()
        Dim tFDescr As New Int32

        If rblChoice.SelectedValue = GetLabel("statsIBDGerRel.rblF") Then
            lblTypeOp.Text = GetLabel("statsIBDGerRel.lblTypeOp") & GetLabel("statsIBDGerRel.lblF")
            ds = objI.stGetDescr("F")
            tFDescr = ds.Tables(0).Rows.Count()
            lblInfo.Text = tFDescr & GetLabel("statsIBDGerRel.lblFde") & tF & " (" & String.Format(objM.formatStringPerc, tFDescr / tF) & ")"
        ElseIf rblChoice.SelectedValue = GetLabel("statsIBDGerRel.rblSC") Then
            lblTypeOp.Text = GetLabel("statsIBDGerRel.lblTypeOp") & GetLabel("statsIBDGerRel.lblSC")
            ds = objI.stGetDescr("SC")
            tFDescr = ds.Tables(0).Rows.Count()
            lblInfo.Text = tFDescr & GetLabel("statsIBDGerRel.lblFde") & tF & " (" & String.Format(objM.formatStringPerc, tFDescr / tF) & ")"
        ElseIf rblChoice.SelectedValue = GetLabel("statsIBDGerRel.rblSR") Then
            lblTypeOp.Text = GetLabel("statsIBDGerRel.lblTypeOp") & GetLabel("statsIBDGerRel.lblSR")
            ds = objI.stGetDescr("SR")
            tFDescr = ds.Tables(0).Rows.Count()
            lblInfo.Text = tFDescr & GetLabel("statsIBDGerRel.lblFde") & tF & " (" & String.Format(objM.formatStringPerc, tFDescr / tF) & ")"
        ElseIf rblChoice.SelectedValue = GetLabel("statsIBDGerRel.rblUI") Then
            lblTypeOp.Text = GetLabel("statsIBDGerRel.lblTypeOp") & GetLabel("statsIBDGerRel.lblUI")
            ds = objI.stGetDescr("UI")
            tFDescr = ds.Tables(0).Rows.Count()
            lblInfo.Text = tFDescr & GetLabel("statsIBDGerRel.lblFde") & tF & " (" & String.Format(objM.formatStringPerc, tFDescr / tF) & ")"
        ElseIf rblChoice.SelectedValue = GetLabel("statsIBDGerRel.rblD") Then
            lblTypeOp.Text = GetLabel("statsIBDGerRel.lblTypeOp") & GetLabel("statsIBDGerRel.lblDDC")
            ds = objI.stGetDescr("D")
            tFDescr = ds.Tables(0).Rows.Count()
            lblInfo.Text = tFDescr & GetLabel("statsIBDGerRel.lblFde") & tF & " (" & String.Format(objM.formatStringPerc, tFDescr / tF) & ")"
        End If

        Dim dt As DataTable = ds.Tables(0)
        Session("tblReturn") = dt
        dgRel.DataSource = dt
        dgRel.DataBind()

        lnkbExport.Visible = True
    End Sub

    Private Sub loadChoices(ByVal rbl As RadioButtonList)
        Dim al As ArrayList = New ArrayList
        al.Add(GetLabel("statsIBDGerRel.rblF"))
        al.Add(GetLabel("statsIBDGerRel.rblSC"))
        al.Add(GetLabel("statsIBDGerRel.rblSR"))
        al.Add(GetLabel("statsIBDGerRel.rblUI"))
        al.Add(GetLabel("statsIBDGerRel.rblD"))
        rbl.DataSource = al
        rbl.DataBind()
    End Sub

    Private Sub lnkbExport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbExport.Click

        Dim sw As New StringWriter
        sw.Write(GetLabel("stats.lblExecutionTime"))
        sw.WriteLine(Date.Now)
        sw.WriteLine()
        sw.WriteLine(lblTypeOp.Text)
        sw.WriteLine(objM.exportDG(Session("tblReturn")).ToString)

        Response.AddHeader("content-disposition", "attachment;filename=rel.csv")
        Response.ContentType = "application/vnd.csv"
        Response.ContentEncoding = System.Text.Encoding.Default
        ' Remove the charset from the Content-Type header.
        Response.Charset = ""
        ' Turn off the view state.
        Me.EnableViewState = False

        ' Write the HTML back to the browser.
        Response.Write(sw.ToString)
        ' End the response.
        Response.End()
    End Sub

    Private Sub dgRel_PageIndexChanged(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridPageChangedEventArgs) Handles dgRel.PageIndexChanged
        Me.dgRel.CurrentPageIndex = e.NewPageIndex
        dgRel.DataSource = Session("tblReturn")
        dgRel.DataBind()
    End Sub

End Class
