
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Data.SqlClient

Public Module database

    Private Function connectDB(ByVal connectionString As String) As SqlConnection
        Dim cn As New SqlConnection
        cn.ConnectionString = ConfigurationSettings.AppSettings(connectionString)
        cn.Open()
        Return cn
    End Function


    Public Sub sqlNonQuery(ByVal myExecuteQuery As String, Optional ByVal connString As String = "ConnStringCRAV")
        Dim cn As SqlConnection = connectDB(connString)
        Dim cm As New SqlCommand
        Try
            cm.Connection = cn
            cm.CommandText = myExecuteQuery
            cm.ExecuteNonQuery()
        Catch ex As Exception

        Finally
            cn.Close()
        End Try

    End Sub


    Public Function sqlScalarQuery(ByVal myExecuteQuery As String, Optional ByVal connString As String = "ConnStringCRAV") As Object
        Dim cn As SqlConnection = connectDB(connString)
        Dim cm As New SqlCommand
        Try
            cm.Connection = cn
            cm.CommandText = myExecuteQuery
            Dim ret As Object = cm.ExecuteScalar()
            Return ret
        Catch ex As Exception

        Finally
            cn.Close()
        End Try
    End Function

    Public Sub sqlLoadDdl(ByVal ddl As DropDownList, ByVal code As String, ByVal name As String, ByVal table As String, _
                          Optional ByVal connString As String = "ConnStringCRAV", Optional ByVal startItem As String = "Selecionar")
        Dim cn As SqlConnection = connectDB(connString)
        Dim cm As New SqlCommand
        Dim dr As SqlDataReader
        Try
            cm.Connection = cn
            cm.CommandText = "SELECT " & code & " AS code ," & name & " AS name FROM " & table & " ORDER BY name"
            dr = cm.ExecuteReader
            Dim lii As New ListItem
            lii.Value = "0"
            lii.Text = startItem
            ddl.Items.Add(lii)
            While dr.Read
                Dim li As New ListItem
                li.Value = dr.Item("code")
                li.Text = dr.Item("name")
                ddl.Items.Add(li)
            End While

        Catch ex As Exception
        Finally
            'cn.Close()
            'dr.Close()
        End Try
    End Sub

    Public Function sqlIdToRef(ByVal id As Int64, Optional ByVal connString As String = "ConnStringDigitarq") As Object
        Dim cn As SqlConnection = connectDB(connString)
        Dim cm As New SqlCommand
        Try
            cm.Connection = cn
            cm.CommandText = "SELECT CompleteUnitID from Components WHERE ID = " & id
            Dim ret As Object = cm.ExecuteScalar()
            Return ret
        Catch ex As Exception

        Finally
            cn.Close()
        End Try
    End Function

    Public Function sqlGetOtherLevel(ByVal ref As String, Optional ByVal connString As String = "ConnStringDigitarq") As String
        Dim cn As SqlConnection = connectDB(connString)
        Dim cm As New SqlCommand
        Try
            cm.Connection = cn
            cm.CommandText = "SELECT OtherLevel FROM Components WHERE CompleteUnitId = '" & ref & "'"
            Dim ret As String = cm.ExecuteScalar()
            Return ret
        Catch ex As Exception

        Finally
            cn.Close()
        End Try
    End Function

    Public Function sqlGetRequestType(ByVal requestID As Int64, Optional ByVal connString As String = "ConnStringCRAV") As Integer
        Dim cn As SqlConnection = connectDB(connString)
        Dim cm As New SqlCommand("sp_getRequestType", cn)
        cm.CommandType = CommandType.StoredProcedure
        Try
            cm.Parameters.Add("@RequestID", requestID)
            Dim ret As String = cm.ExecuteScalar
            Return ret
        Catch ex As Exception
        Finally
            cn.Close()
        End Try
    End Function

    Public Function sqlGetRequestSubType(ByVal requestID As Int64, Optional ByVal connString As String = "ConnStringCRAV") As Integer
        Dim cn As SqlConnection = connectDB(connString)
        Dim cm As New SqlCommand("sp_getRequestSubType", cn)
        cm.CommandType = CommandType.StoredProcedure
        Try
            cm.Parameters.Add("@RequestID", requestID)
            Dim ret As String = cm.ExecuteScalar
            Return ret
        Catch ex As Exception
        Finally
            cn.Close()
        End Try
    End Function

End Module

