
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Public Module utils

    Public Function strConvdate(ByVal strYear As String, ByVal strMonth As String, ByVal strDay As String) As String
        Dim str As String = strYear.Trim & strMonth.Trim & strDay.Trim
        If strYear.Trim & strMonth.Trim & strDay.Trim = "" Then
            Return ""
        Else
            strYear = strYear.PadLeft(4, "0")

            strMonth = strMonth.PadLeft(2, "0")

            strDay = strDay.PadLeft(2, "0")

            Try
                Dim strDate As Date = strYear & "-" & strMonth & "-" & strDay
                Return strDate.ToString
            Catch ex As Exception
                Return "Error"
            End Try

        End If
    End Function


    Public Sub loadDdlMonth(ByVal ddl As DropDownList)
        Dim firstLI As New ListItem
        firstLI.Value = ""
        firstLI.Text = ""
        ddl.Items.Add(firstLI)
        For i As Integer = 1 To 12
            Dim li As New ListItem
            li.Value = i.ToString.PadLeft(2, "0")
            li.Text = MonthName(i)
            ddl.Items.Add(li)
        Next
    End Sub

    Public Function GetMonthName(ByVal monthValue As String) As String
        Return MonthName(monthValue)
    End Function



    Public Sub loadDdlDay(ByVal ddl As DropDownList)
        ddl.Items.Add("")
        For i As Integer = 1 To 31
            ddl.Items.Add(i.ToString.PadLeft(2, "0"))
        Next
    End Sub


    Public Sub Clean(ByVal controlP As Control)
        Dim ctl As Control
        For Each ctl In controlP.Controls
            If TypeOf ctl Is TextBox Then
                DirectCast(ctl, TextBox).Text = String.Empty
            ElseIf ctl.Controls.Count > 0 Then
                Clean(ctl)
            End If
        Next
    End Sub


    Public Function getReference(ByVal strFunctionCode As String) As String
        Dim hshReference As Hashtable = ConfigurationSettings.GetConfig("references")
        Return hshReference(strFunctionCode)
    End Function

    Public Function getControlName(ByVal strFunctionCode As String) As String
        Dim configReader As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Return configReader.GetValue(strFunctionCode, GetType(String))
    End Function

End Module
