
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Imports DigitArq.Utility.SimpleTypeValidation
Imports DigitArq.Data.Entities.MGOD
Imports DigitArq.Definitions.MPOD
Imports DigitArq.Utility

Public Class ProjectsForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents TabControl As System.Windows.Forms.TabControl
    Friend WithEvents ProjectsTabPage As System.Windows.Forms.TabPage
    Friend WithEvents FooterPanel As System.Windows.Forms.Panel
    Friend WithEvents btnOpenProject As System.Windows.Forms.Button
    Friend WithEvents ProjectsPanel As System.Windows.Forms.Panel
    Friend WithEvents lvwProjects As System.Windows.Forms.ListView
    Friend WithEvents chProjectName As System.Windows.Forms.ColumnHeader
    Friend WithEvents chUsername As System.Windows.Forms.ColumnHeader
    Friend WithEvents chCreationDateTime As System.Windows.Forms.ColumnHeader
    Friend WithEvents chLastUpdateDateTime As System.Windows.Forms.ColumnHeader
    Friend WithEvents ButtonsImageList As System.Windows.Forms.ImageList
    Friend WithEvents btnClose As System.Windows.Forms.Button
    Friend WithEvents chQuantityOfDigitalObjects As System.Windows.Forms.ColumnHeader
    Friend WithEvents chQuantityOfFiles As System.Windows.Forms.ColumnHeader
    Friend WithEvents ckbNumberOfItems As System.Windows.Forms.CheckBox
    Friend WithEvents txbNumberOfItems As System.Windows.Forms.NumericUpDown
    Friend WithEvents ShowItemsTimer As System.Windows.Forms.Timer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(ProjectsForm))
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Me.ButtonsImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.TabControl = New System.Windows.Forms.TabControl
        Me.ProjectsTabPage = New System.Windows.Forms.TabPage
        Me.ProjectsPanel = New System.Windows.Forms.Panel
        Me.lvwProjects = New System.Windows.Forms.ListView
        Me.chProjectName = New System.Windows.Forms.ColumnHeader
        Me.chQuantityOfDigitalObjects = New System.Windows.Forms.ColumnHeader
        Me.chQuantityOfFiles = New System.Windows.Forms.ColumnHeader
        Me.chUsername = New System.Windows.Forms.ColumnHeader
        Me.chCreationDateTime = New System.Windows.Forms.ColumnHeader
        Me.chLastUpdateDateTime = New System.Windows.Forms.ColumnHeader
        Me.FooterPanel = New System.Windows.Forms.Panel
        Me.txbNumberOfItems = New System.Windows.Forms.NumericUpDown
        Me.ckbNumberOfItems = New System.Windows.Forms.CheckBox
        Me.btnClose = New System.Windows.Forms.Button
        Me.btnOpenProject = New System.Windows.Forms.Button
        Me.ShowItemsTimer = New System.Windows.Forms.Timer(Me.components)
        Me.TabControl.SuspendLayout()
        Me.ProjectsTabPage.SuspendLayout()
        Me.ProjectsPanel.SuspendLayout()
        Me.FooterPanel.SuspendLayout()
        CType(Me.txbNumberOfItems, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'ButtonsImageList
        '
        Me.ButtonsImageList.ImageSize = New System.Drawing.Size(18, 18)
        Me.ButtonsImageList.ImageStream = CType(resources.GetObject("ButtonsImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ButtonsImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'TabControl
        '
        Me.TabControl.Controls.Add(Me.ProjectsTabPage)
        Me.TabControl.Dock = System.Windows.Forms.DockStyle.Fill
        Me.TabControl.Location = New System.Drawing.Point(0, 0)
        Me.TabControl.Name = "TabControl"
        Me.TabControl.SelectedIndex = 0
        Me.TabControl.Size = New System.Drawing.Size(674, 311)
        Me.TabControl.TabIndex = 5
        '
        'ProjectsTabPage
        '
        Me.ProjectsTabPage.Controls.Add(Me.ProjectsPanel)
        Me.ProjectsTabPage.Controls.Add(Me.FooterPanel)
        Me.ProjectsTabPage.Location = New System.Drawing.Point(4, 22)
        Me.ProjectsTabPage.Name = "ProjectsTabPage"
        Me.ProjectsTabPage.Size = New System.Drawing.Size(666, 285)
        Me.ProjectsTabPage.TabIndex = 0
        Me.ProjectsTabPage.Text = "Perfis de incorporao digital"
        '
        'ProjectsPanel
        '
        Me.ProjectsPanel.Controls.Add(Me.lvwProjects)
        Me.ProjectsPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.ProjectsPanel.Location = New System.Drawing.Point(0, 0)
        Me.ProjectsPanel.Name = "ProjectsPanel"
        Me.ProjectsPanel.Size = New System.Drawing.Size(666, 241)
        Me.ProjectsPanel.TabIndex = 6
        '
        'lvwProjects
        '
        Me.lvwProjects.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lvwProjects.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chProjectName, Me.chQuantityOfDigitalObjects, Me.chQuantityOfFiles, Me.chUsername, Me.chCreationDateTime, Me.chLastUpdateDateTime})
        Me.lvwProjects.Dock = System.Windows.Forms.DockStyle.Fill
        Me.lvwProjects.FullRowSelect = True
        Me.lvwProjects.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
        Me.lvwProjects.Location = New System.Drawing.Point(0, 0)
        Me.lvwProjects.MultiSelect = False
        Me.lvwProjects.Name = "lvwProjects"
        Me.lvwProjects.Size = New System.Drawing.Size(666, 241)
        Me.lvwProjects.TabIndex = 1
        Me.lvwProjects.View = System.Windows.Forms.View.Details
        '
        'chProjectName
        '
        Me.chProjectName.Text = "Perfil incorporao"
        Me.chProjectName.Width = 130
        '
        'chQuantityOfDigitalObjects
        '
        Me.chQuantityOfDigitalObjects.Text = "Objectos digitais"
        Me.chQuantityOfDigitalObjects.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.chQuantityOfDigitalObjects.Width = 90
        '
        'chQuantityOfFiles
        '
        Me.chQuantityOfFiles.Text = "Documentos"
        Me.chQuantityOfFiles.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.chQuantityOfFiles.Width = 90
        '
        'chUsername
        '
        Me.chUsername.Text = "Utilizador"
        Me.chUsername.Width = 120
        '
        'chCreationDateTime
        '
        Me.chCreationDateTime.Text = "Data criao"
        Me.chCreationDateTime.Width = 105
        '
        'chLastUpdateDateTime
        '
        Me.chLastUpdateDateTime.Text = "ltima actualizao"
        Me.chLastUpdateDateTime.Width = 105
        '
        'FooterPanel
        '
        Me.FooterPanel.BackColor = System.Drawing.Color.WhiteSmoke
        Me.FooterPanel.Controls.Add(Me.txbNumberOfItems)
        Me.FooterPanel.Controls.Add(Me.ckbNumberOfItems)
        Me.FooterPanel.Controls.Add(Me.btnClose)
        Me.FooterPanel.Controls.Add(Me.btnOpenProject)
        Me.FooterPanel.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.FooterPanel.Location = New System.Drawing.Point(0, 241)
        Me.FooterPanel.Name = "FooterPanel"
        Me.FooterPanel.Size = New System.Drawing.Size(666, 44)
        Me.FooterPanel.TabIndex = 5
        '
        'txbNumberOfItems
        '
        Me.txbNumberOfItems.Location = New System.Drawing.Point(144, 14)
        Me.txbNumberOfItems.Name = "txbNumberOfItems"
        Me.txbNumberOfItems.Size = New System.Drawing.Size(44, 20)
        Me.txbNumberOfItems.TabIndex = 117
        Me.txbNumberOfItems.Value = New Decimal(New Integer() {10, 0, 0, 0})
        '
        'ckbNumberOfItems
        '
        Me.ckbNumberOfItems.Checked = True
        Me.ckbNumberOfItems.CheckState = System.Windows.Forms.CheckState.Checked
        Me.ckbNumberOfItems.Location = New System.Drawing.Point(8, 10)
        Me.ckbNumberOfItems.Name = "ckbNumberOfItems"
        Me.ckbNumberOfItems.Size = New System.Drawing.Size(148, 24)
        Me.ckbNumberOfItems.TabIndex = 115
        Me.ckbNumberOfItems.Text = "Listar apenas os ltimos"
        '
        'btnClose
        '
        Me.btnClose.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnClose.BackColor = System.Drawing.Color.White
        Me.btnClose.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnClose.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnClose.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnClose.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnClose.ImageIndex = 5
        Me.btnClose.ImageList = Me.ButtonsImageList
        Me.btnClose.Location = New System.Drawing.Point(583, 10)
        Me.btnClose.Name = "btnClose"
        Me.btnClose.Size = New System.Drawing.Size(76, 25)
        Me.btnClose.TabIndex = 83
        Me.btnClose.Text = CType(configurationAppSettings.GetValue("btnCancel.Text", GetType(System.String)), String)
        Me.btnClose.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnOpenProject
        '
        Me.btnOpenProject.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnOpenProject.BackColor = System.Drawing.Color.White
        Me.btnOpenProject.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnOpenProject.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnOpenProject.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnOpenProject.ImageIndex = 6
        Me.btnOpenProject.ImageList = Me.ButtonsImageList
        Me.btnOpenProject.Location = New System.Drawing.Point(500, 10)
        Me.btnOpenProject.Name = "btnOpenProject"
        Me.btnOpenProject.Size = New System.Drawing.Size(76, 25)
        Me.btnOpenProject.TabIndex = 9
        Me.btnOpenProject.Text = CType(configurationAppSettings.GetValue("btnOpenProject.Text", GetType(System.String)), String)
        Me.btnOpenProject.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'ShowItemsTimer
        '
        Me.ShowItemsTimer.Interval = 1000
        '
        'ProjectsForm
        '
        Me.AcceptButton = Me.btnOpenProject
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.White
        Me.CancelButton = Me.btnClose
        Me.ClientSize = New System.Drawing.Size(674, 311)
        Me.Controls.Add(Me.TabControl)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.KeyPreview = True
        Me.Name = "ProjectsForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Abrir perfil de incorporao digital"
        Me.TabControl.ResumeLayout(False)
        Me.ProjectsTabPage.ResumeLayout(False)
        Me.ProjectsPanel.ResumeLayout(False)
        Me.FooterPanel.ResumeLayout(False)
        CType(Me.txbNumberOfItems, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Database As New SqlCommands(USER_LOGON)
    Private myProjectID As Int64
    Private myProjectName As String


#Region "Project Form"

    Private Sub ChooseProject_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Text = GetFormTitle("[" & USER_LOGON & "]")
        LoadConfiguration()
        LoadData()
        If Me.lvwProjects.Items.Count > 0 Then
            Me.lvwProjects.Items(0).Selected = True
        End If
    End Sub

    Private Sub ProjectsForm_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        Dim myProgramState As New ProgramState
        myProgramState.NumberOfProjectsChecked = Me.ckbNumberOfItems.Checked
        myProgramState.LastNumberOfProjectsShowed = Me.txbNumberOfItems.Value
        myProgramState.Save()
    End Sub

    Private Sub LoadConfiguration()
        Try
            Dim myProgramState As New ProgramState
            Me.ckbNumberOfItems.Checked = myProgramState.NumberOfProjectsChecked
            Me.txbNumberOfItems.Value = myProgramState.LastNumberOfProjectsShowed
        Catch ex As Exception
        End Try
    End Sub

    Private Sub OpenProject()
        If Me.lvwProjects.SelectedItems.Count > 0 Then
            Me.ProjectID = Me.lvwProjects.SelectedItems(0).Tag
            Me.ProjectName = Me.lvwProjects.SelectedItems(0).Text
            Me.Close()
        End If
    End Sub

    Private Sub lvwProjects_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvwProjects.SelectedIndexChanged
        If Me.lvwProjects.SelectedItems.Count > 0 Then
            Me.ProjectID = Me.lvwProjects.SelectedItems(0).Tag
            Me.ProjectName = Me.lvwProjects.SelectedItems(0).Text
        End If
    End Sub

    Private Sub lvwProjects_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvwProjects.DoubleClick
        If Me.lvwProjects.SelectedItems.Count > 0 Then
            Me.Close()
        End If
    End Sub

    Private Sub btnOpenProject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpenProject.Click
        If Me.lvwProjects.SelectedItems.Count > 0 Then
            Me.Close()
        End If
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

#End Region

#Region "Load Data"

    Private Sub LoadData()
        Me.Cursor = Cursors.WaitCursor
        Dim TopValue As Integer
        Dim Order As String
        If Me.ckbNumberOfItems.Checked AndAlso IsInteger(Me.txbNumberOfItems.Text) Then
            TopValue = Me.txbNumberOfItems.Text
            Order = "DESC"
        Else
            TopValue = 0
            Order = "ASC"
        End If
        Dim ProjectCollection As ProjectCollection = Database.SelectProjects(TopValue, "ProjectID", Order)
        Me.lvwProjects.Items.Clear()
        For Each Project As Project In ProjectCollection
            Dim lvi As ListViewItem = New ListViewItem(Project.Name)
            lvi.SubItems.Add(Project.DigitalObjectsCount)
            lvi.SubItems.Add(Database.SelectCountProjectFiles(Project.ProjectID))
            lvi.SubItems.Add(Project.Username)
            lvi.SubItems.Add(Project.CreationDateTime)
            lvi.SubItems.Add(Project.LastUpdateDateTime)

            lvi.Tag = Project.ProjectID
            Me.lvwProjects.Items.Add(lvi)
        Next

        If Me.lvwProjects.Items.Count = 0 Then
            MsgBox(InfoMessage("ChooseProjects.EmptyProjectList"), MsgBoxStyle.Exclamation)
            Application.Exit()
        End If
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub txbNumberOfItems_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txbNumberOfItems.ValueChanged
        ShowItemsTimer.Enabled = True
        ShowItemsTimer.Start()
    End Sub

    Private Sub txbNumberOfItems_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txbNumberOfItems.TextChanged
        ShowItemsTimer.Enabled = True
        ShowItemsTimer.Start()
    End Sub

    Private Sub ShowitemsTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowItemsTimer.Tick
        LoadData()
        ShowItemsTimer.Enabled = False
        ShowItemsTimer.Stop()
    End Sub

#End Region

#Region "Properties"

    Public Property ProjectID() As Int64
        Get
            Return myProjectID
        End Get
        Set(ByVal Value As Int64)
            myProjectID = Value
        End Set
    End Property

    Public Property ProjectName() As String
        Get
            Return myProjectName
        End Get
        Set(ByVal Value As String)
            myProjectName = Value
        End Set
    End Property

#End Region

End Class
