Imports System.Configuration
Imports System.IO
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports System.Text
Imports System.Security
Imports System.Xml

Public Module XML


    Public Function CreateTag(ByVal Name As String, ByVal Value As String) As String
        Return String.Format("<{0}>{1}</{0}>", Name, Value)
    End Function

    Public Function CreateTag(ByVal Name As String, ByVal Value As String, ByVal Attributes As String) As String
        Return String.Format("<{0} {2}>{1}</{0}>", Name, Value, Attributes)
    End Function

    Public Function CreateTag(ByVal Name As String, ByVal Value As String, ByVal Attributes As String()) As String
        Return String.Format("<{0} {2}>{1}</{0}>", Name, Value, String.Join(" ", Attributes))
    End Function

    Public Function XMLEscape(ByVal Value As String) As String
        Dim st As New StringBuilder

        For i As Integer = 0 To Value.Length - 1
            Dim c As Char = Value.Chars(i)
            Dim charcode As Integer = Asc(c)

            If charcode = 13 OrElse charcode = 10 OrElse (Not Char.IsControl(c)) Then
                st.Append(c)
            End If
        Next
        Return SecurityElement.Escape(st.ToString)
    End Function

End Module
