
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.IO
Imports System.Threading
Imports System.Configuration
Imports System.Data.SqlClient ' SQL Server Data Provider
Imports DigitArq.Utility.Config

Public Class SplashScreenForm
    Inherits System.Windows.Forms.Form

    Declare Function HideCaret Lib "user32.dll" (ByVal hwnd As Long) As Long


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    Public Sub New(ByVal ApplicationCode As String)
        MyBase.New()

        myApplicationCode = ApplicationCode
        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents PictureBox As System.Windows.Forms.PictureBox
    Friend WithEvents txtOutput As System.Windows.Forms.TextBox
    Friend WithEvents LinkClose As System.Windows.Forms.LinkLabel
    Friend WithEvents lblVersion As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Me.PictureBox = New System.Windows.Forms.PictureBox
        Me.txtOutput = New System.Windows.Forms.TextBox
        Me.LinkClose = New System.Windows.Forms.LinkLabel
        Me.lblVersion = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'PictureBox
        '
        Me.PictureBox.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.PictureBox.Cursor = System.Windows.Forms.Cursors.Default
        Me.PictureBox.Location = New System.Drawing.Point(-2, -2)
        Me.PictureBox.Name = "PictureBox"
        Me.PictureBox.Size = New System.Drawing.Size(454, 312)
        Me.PictureBox.TabIndex = 30
        Me.PictureBox.TabStop = False
        '
        'txtOutput
        '
        Me.txtOutput.BackColor = System.Drawing.Color.White
        Me.txtOutput.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.txtOutput.Location = New System.Drawing.Point(32, 192)
        Me.txtOutput.Multiline = True
        Me.txtOutput.Name = "txtOutput"
        Me.txtOutput.ReadOnly = True
        Me.txtOutput.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtOutput.Size = New System.Drawing.Size(384, 56)
        Me.txtOutput.TabIndex = 32
        Me.txtOutput.TabStop = False
        Me.txtOutput.Text = ""
        '
        'LinkClose
        '
        Me.LinkClose.AutoSize = True
        Me.LinkClose.BackColor = System.Drawing.Color.White
        Me.LinkClose.Location = New System.Drawing.Point(385, 290)
        Me.LinkClose.Name = "LinkClose"
        Me.LinkClose.Size = New System.Drawing.Size(0, 16)
        Me.LinkClose.TabIndex = 33
        Me.LinkClose.TabStop = True
        Me.LinkClose.Text = CType(configurationAppSettings.GetValue("LinkClose.Text", GetType(System.String)), String)
        Me.LinkClose.Visible = False
        '
        'lblVersion
        '
        Me.lblVersion.BackColor = System.Drawing.Color.White
        Me.lblVersion.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblVersion.ForeColor = System.Drawing.Color.FromArgb(CType(78, Byte), CType(73, Byte), CType(72, Byte))
        Me.lblVersion.Location = New System.Drawing.Point(330, 112)
        Me.lblVersion.Name = "lblVersion"
        Me.lblVersion.Size = New System.Drawing.Size(70, 16)
        Me.lblVersion.TabIndex = 34
        '
        'SplashScreenForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(448, 306)
        Me.ControlBox = False
        Me.Controls.Add(Me.lblVersion)
        Me.Controls.Add(Me.LinkClose)
        Me.Controls.Add(Me.txtOutput)
        Me.Controls.Add(Me.PictureBox)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "SplashScreenForm"
        Me.ShowInTaskbar = False
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.ResumeLayout(False)

    End Sub

#End Region


#Region "Properties "

    Private FONDSTEMPLATE_FILENAME As String = Application.StartupPath & Path.DirectorySeparatorChar & "template.ead"
    Private myFailedTests As Integer
    Private myApplicationCode As String

    Public ReadOnly Property FailedTests() As Integer
        Get
            Return myFailedTests
        End Get
    End Property

    Public Enum ApplicationType
        Client
        Standalone
        MiniDigitArq
    End Enum

#End Region

#Region "Events"

    Private Sub SplashScreenForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.TopMost = True
        Dim ApplicationType As ApplicationType = GetApplicationType()
        Select Case ApplicationType
            Case ApplicationType.Client
                Me.PictureBox.Image = Image.FromFile(Application.StartupPath + "\..\Resources\splash.jpg")
            Case ApplicationType.Standalone
                Me.PictureBox.Image = Image.FromFile(Application.StartupPath + "\..\Resources\splash.jpg")
            Case ApplicationType.MiniDigitArq
                Me.PictureBox.Image = Image.FromFile(Application.StartupPath + "\..\Resources\MiniDigitArqSplash.jpg")
            Case Else
                Me.PictureBox.Image = Image.FromFile(Application.StartupPath + "\..\Resources\splash.jpg")
        End Select
        Me.lblVersion.Text = String.Format(ConfigurationSettings.AppSettings("lblVersion.Text"), ConfigurationSettings.AppSettings("Application.Version"))
    End Sub

    Private Sub AppendToOutput(ByVal Line As String)
        txtOutput.Select(0, 0)
        txtOutput.AppendText(Line)
        txtOutput.ScrollToCaret()
        'txtOutput.SelectionStart = txtOutput.Text.Length
    End Sub

    Private Sub LinkClose_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles LinkClose.LinkClicked
        Close()
        Dispose()
    End Sub

    Public Function GetApplicationType() As ApplicationType
        Dim Constants As Hashtable = ConfigurationSettings.GetConfig("constants")

        Return CType(Constants.Item("ApplicationType"), ApplicationType)
    End Function

#End Region

#Region "System Tests"

    Public Function CheckPrerequisites() As Boolean
        Dim t As New Thread(AddressOf TestPrerequisites)
        t.Start()
        While t.IsAlive
            Application.DoEvents()
        End While

        If myFailedTests = 0 Then
            Thread.Sleep(1500)
        Else
            LinkClose.Visible = True
            txtOutput.ScrollBars = ScrollBars.Vertical
            txtOutput.ScrollToCaret()
        End If
        Return Me.myFailedTests = 0
    End Function

    Private Sub TestPrerequisites()
        myFailedTests = 0
        AppendToOutput(InfoMessage("Prerequisites.InitializingTest") & ControlChars.NewLine & ControlChars.NewLine)

        If myFailedTests = 0 Then TestOperatingSystem()
        If myFailedTests = 0 Then TestDatabase()
        If myFailedTests = 0 Then TestAdminUsername()
        If myFailedTests = 0 Then TestVersionOfApplication()
        If GetApplicationType() = ApplicationType.MiniDigitArq Then
            If myFailedTests = 0 Then TestExistenceOfFondsTemplate()
        End If
        If myFailedTests = 0 Then
            AppendToOutput(ControlChars.NewLine & InfoMessage("Prerequisites.OpeningDigitArq"))
        Else
            AppendToOutput(ControlChars.NewLine & InfoMessage("Prerequisites.PrerequisitesFailed"))
        End If
    End Sub

    Private Sub TestAdminUsername()
        AppendToOutput(InfoMessage("Prerequisites.AdministratorMissing"))
        'If Users.AdministratorMissing Then
        '    Users.CreateAdmin()
        '    AppendToOutput(InfoMessage("Prerequisites.Recovered"))
        'Else
        AppendToOutput(InfoMessage("Prerequisites.Ok"))
        'End If
        AppendToOutput(ControlChars.NewLine)
    End Sub


    Private Sub TestDatabase()

        AppendToOutput(InfoMessage("Prerequisites.Database"))

        Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

        Dim myUsername As String = SQLServerSettings("Username")
        Dim myDatabase As String = SQLServerSettings("Database")
        Dim myServerAddress As String = SQLServerSettings("ServerAddress")
        Dim myPassword As String = SQLServerSettings("Password")


        Dim SQLConnection As SqlConnection = New SqlConnection

        Dim Transaction As SqlTransaction
        Try
            SQLConnection.ConnectionString = String.Format("Data Source={0}; Initial Catalog={1}; User ID={2}; Password={3}", myServerAddress, myDatabase, myUsername, myPassword)

            Dim SQLCommand As New SqlCommand
            SQLCommand.Connection = SQLConnection

            SQLConnection.Open()
            SQLCommand.CommandText = "SELECT count(name) FROM sysobjects WHERE " & _
            "name = 'Components';"

            If CInt(SQLCommand.ExecuteScalar()) <> 1 Then
                AppendToOutput(InfoMessage("Prerequisites.Failed"))
                myFailedTests += 1
            Else
                AppendToOutput(InfoMessage("Prerequisites.Ok"))
            End If

        Catch ex As Exception
            Debug.WriteLine(ex.Message & ControlChars.NewLine & ex.StackTrace)
            AppendToOutput(ControlChars.NewLine & ex.Message & ControlChars.NewLine)
            AppendToOutput(InfoMessage("Prerequisites.Failed"))
            myFailedTests += 1
        Finally
            SQLConnection.Close()
        End Try
        AppendToOutput(ControlChars.NewLine)
    End Sub


    Private Sub TestExistenceOfDatabaseSQL()
        AppendToOutput(InfoMessage("Prerequisites.DatabaseSQL"))
        If File.Exists(DATABASE_SQL_FILENAME) Then
            AppendToOutput(InfoMessage("Prerequisites.Ok"))
        Else
            AppendToOutput(InfoMessage("Prerequisites.Failed"))
            myFailedTests += 1
        End If
        AppendToOutput(ControlChars.NewLine)
    End Sub


    Private Sub TestExistenceOfCnfXslt()
        AppendToOutput(InfoMessage("Prerequisites.ExistenceOfCnfXslt"))
        If File.Exists(EAD2CNF_XSLT_FILENAME) Then
            AppendToOutput(InfoMessage("Prerequisites.Ok"))
        Else
            AppendToOutput(InfoMessage("Prerequisites.Failed"))
            myFailedTests += 1
        End If
        AppendToOutput(ControlChars.NewLine)
    End Sub


    Private Sub TestExistenceOfEacXslt()
        AppendToOutput(InfoMessage("Prerequisites.ExistenceOfEacXslt"))
        If File.Exists(EAC_XSLT_FILENAME) Then
            AppendToOutput(InfoMessage("Prerequisites.Ok"))
        Else
            AppendToOutput(InfoMessage("Prerequisites.Failed"))
            myFailedTests += 1
        End If
        AppendToOutput(ControlChars.NewLine)
    End Sub


    Private Sub TestOperatingSystem()
        AppendToOutput(String.Format(InfoMessage("Prerequisites.OperatingSystem"), Environment.OSVersion.ToString))
        If Environment.OSVersion.Platform = PlatformID.Win32NT Then
            AppendToOutput(InfoMessage("Prerequisites.Ok"))
        Else
            AppendToOutput(InfoMessage("Prerequisites.Failed"))
            'myFailedTests += 1
        End If
        AppendToOutput(ControlChars.NewLine)
    End Sub

    Private Sub TestVersionOfApplication()

        AppendToOutput(InfoMessage("Prerequisites.VersionOfApplication"))

        Dim SQLServerSettings As Hashtable = ConfigurationSettings.GetConfig("sqlServerSettings")

        Dim myUsername As String = SQLServerSettings("Username")
        Dim myDatabase As String = SQLServerSettings("Database")
        Dim myServerAddress As String = SQLServerSettings("ServerAddress")
        Dim myPassword As String = SQLServerSettings("Password")

        Dim SQLConnection As SqlConnection = New SqlConnection


        Dim Transaction As SqlTransaction
        Try
            SQLConnection.ConnectionString = String.Format("Data Source={0}; Initial Catalog={1}; User ID={2}; Password={3}", myServerAddress, myDatabase, myUsername, myPassword)

            Dim SQLCommand As New SqlCommand
            SQLCommand.Connection = SQLConnection

            SQLConnection.Open()
            SQLCommand.CommandText = "SELECT SUBSTRING(Version,1,1) FROM Applications WHERE ApplicationCode='" & myApplicationCode & "'"

            If SQLCommand.ExecuteScalar() <> ConfigurationSettings.AppSettings("Application.Version").Substring(0, 1) Then
                AppendToOutput(InfoMessage("Prerequisites.Failed"))
                myFailedTests += 1
            Else
                AppendToOutput(InfoMessage("Prerequisites.Ok"))
            End If
        Catch ex As Exception
            Debug.WriteLine(ex.Message & ControlChars.NewLine & ex.StackTrace)
            AppendToOutput(ex.Message & ControlChars.NewLine & ex.StackTrace)
            myFailedTests += 1
        Finally
            SQLConnection.Close()
        End Try
        AppendToOutput(ControlChars.NewLine)
    End Sub

    Private Sub TestExistenceOfFondsTemplate()
        AppendToOutput(InfoMessage("Prerequisites.ExistenceOfFondsTemplate"))
        If File.Exists(FONDSTEMPLATE_FILENAME) Then
            AppendToOutput(InfoMessage("Prerequisites.Ok"))
        Else
            AppendToOutput(InfoMessage("Prerequisites.Failed"))
            AppendToOutput(ControlChars.NewLine & InfoMessage("Prerequisites.RunConfigurationProgram"))
            myFailedTests += 1
        End If
        AppendToOutput(ControlChars.NewLine)
    End Sub

#End Region


End Class
