
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Data.SqlClient

Public Class DigitalObject

    Private myDigitalObjectID As Int64
    Private myProjectID As Int64
    Private myName As String
    Private myOriginalName As String
    Private myArchiveID As String
    Private myArchivingProfile As String
    Private myCaptureEntityCorporate As String
    Private myResponsabilityEntity As String
    Private myCreationDateTime As String
    Private myArchiveDateTime As String
    Private myDepositDateTime As String
    Private myRevisionDateTime As String
    Private myExternalDescriptiveInformation As String
    Private myPreservationOriginalInformation As String
    Private myQuantityOfTerminalObjects As Integer
    Private myTopographicalQuota As String
    Private myStructure As String
    Private myUserName As String
    Private myActive As Boolean

#Region "Constructors"

    Public Sub New()
    End Sub

#End Region

#Region "Properties"

    Property DigitalObjectID() As Int64
        Get
            Return myDigitalObjectID
        End Get
        Set(ByVal Value As Int64)
            myDigitalObjectID = Value
        End Set
    End Property

    Property ProjectID() As Int64
        Get
            Return myProjectID
        End Get
        Set(ByVal Value As Int64)
            myProjectID = Value
        End Set
    End Property

    Property Name() As String
        Get
            Return myName
        End Get
        Set(ByVal Value As String)
            myName = Value
        End Set
    End Property

    Property OriginalName() As String
        Get
            Return myOriginalName
        End Get
        Set(ByVal Value As String)
            myOriginalName = Value
        End Set
    End Property

    Property ArchiveID() As String
        Get
            Return myArchiveID
        End Get
        Set(ByVal Value As String)
            myArchiveID = Value
        End Set
    End Property

    Property ArchivingProfile() As String
        Get
            Return myArchivingProfile
        End Get
        Set(ByVal Value As String)
            myArchivingProfile = Value
        End Set
    End Property

    Property CaptureEntityCorporate() As String
        Get
            Return myCaptureEntityCorporate
        End Get
        Set(ByVal Value As String)
            myCaptureEntityCorporate = Value
        End Set
    End Property

    Property ResponsabilityEntity() As String
        Get
            Return myResponsabilityEntity
        End Get
        Set(ByVal Value As String)
            myResponsabilityEntity = Value
        End Set
    End Property

    Property CreationDateTime() As String
        Get
            Return myCreationDateTime
        End Get
        Set(ByVal Value As String)
            myCreationDateTime = Value
        End Set
    End Property

    Property ArchiveDateTime() As String
        Get
            Return myArchiveDateTime
        End Get
        Set(ByVal Value As String)
            myArchiveDateTime = Value
        End Set
    End Property

    Property DepositDateTime() As String
        Get
            Return myDepositDateTime
        End Get
        Set(ByVal Value As String)
            myDepositDateTime = Value
        End Set
    End Property

    Property RevisionDateTime() As String
        Get
            Return myRevisionDateTime
        End Get
        Set(ByVal Value As String)
            myRevisionDateTime = Value
        End Set
    End Property

    Property ExternalDescriptiveInformation() As String
        Get
            Return myExternalDescriptiveInformation
        End Get
        Set(ByVal Value As String)
            myExternalDescriptiveInformation = Value
        End Set
    End Property

    Property PreservationOriginalInformation() As String
        Get
            Return myPreservationOriginalInformation
        End Get
        Set(ByVal Value As String)
            myPreservationOriginalInformation = Value
        End Set
    End Property

    Property QuantityOfTerminalObjects() As Integer
        Get
            Return myQuantityOfTerminalObjects
        End Get
        Set(ByVal Value As Integer)
            myQuantityOfTerminalObjects = Value
        End Set
    End Property

    Property TopographicalQuota() As String
        Get
            Return myTopographicalQuota
        End Get
        Set(ByVal Value As String)
            myTopographicalQuota = Value
        End Set
    End Property

    Property DOStructure() As String
        Get
            Return myStructure
        End Get
        Set(ByVal Value As String)
            myStructure = Value
        End Set
    End Property

    Property UserName() As String
        Get
            Return myUserName
        End Get
        Set(ByVal Value As String)
            myUserName = Value
        End Set
    End Property

    Property Active() As Boolean
        Get
            Return myActive
        End Get
        Set(ByVal Value As Boolean)
            myActive = Value
        End Set
    End Property

#End Region

End Class

Public Class DigitalObjectCollection
    Inherits CollectionBase


    Default Public Property Item(ByVal index As Integer) As DigitalObject
        Get
            Return CType(List(index), DigitalObject)
        End Get
        Set(ByVal Value As DigitalObject)
            List(index) = Value
        End Set
    End Property

    Public Function Add(ByVal DigitalObject As DigitalObject) As Integer
        Return List.Add(DigitalObject)
    End Function

    Public Function IndexOf(ByVal value As DigitalObject) As Integer
        Return List.IndexOf(value)
    End Function

    Public Sub Insert(ByVal index As Integer, ByVal value As DigitalObject)
        List.Insert(index, value)
    End Sub

    Public Sub Remove(ByVal value As DigitalObject)
        List.Remove(value)
    End Sub

    Public Function Contains(ByVal value As DigitalObject) As Boolean
        Return List.Contains(value)
    End Function

End Class
