Imports System
Imports System.Collections
Imports System.Windows.Forms


Public Class PropertyItem

    Private myIndex As Integer
    Private myID As String
    Private myTag As Object
    Private myValueControl As Control


#Region "Constructors"

    Public Sub New()

    End Sub

#End Region


#Region "Properties"

    Property Index() As Integer
        Get
            Return myIndex
        End Get
        Set(ByVal Value As Integer)
            myIndex = Value
        End Set
    End Property

    Property ID() As Int64
        Get
            Return myID
        End Get
        Set(ByVal Value As Int64)
            myID = Value
        End Set
    End Property

    Property Tag() As Object
        Get
            Return myTag
        End Get
        Set(ByVal Value As Object)
            myTag = Value
        End Set
    End Property

    Property ValueControl() As Control
        Get
            Return myValueControl
        End Get
        Set(ByVal Value As Control)
            myValueControl = Value
        End Set
    End Property

#End Region

End Class

Public Class PropertyCollection
    Inherits CollectionBase

    Default Public Property Item(ByVal index As Integer) As PropertyItem
        Get
            Return CType(List(index), PropertyItem)
        End Get
        Set(ByVal Value As PropertyItem)
            List(index) = Value
        End Set
    End Property

    Public Function Add(ByVal value As PropertyItem) As Integer
        Return List.Add(value)
    End Function

    Public Function IndexOf(ByVal value As PropertyItem) As Integer
        Return List.IndexOf(value)
    End Function

    Public Sub Insert(ByVal index As Integer, ByVal value As PropertyItem)
        List.Insert(index, value)
    End Sub

    Public Sub Remove(ByVal value As PropertyItem)
        List.Remove(value)
    End Sub

    Public Sub Remove(ByVal index As Integer)
        List.Remove(list.Item(index))
    End Sub

    Public Function Contains(ByVal value As PropertyItem) As Boolean
        Return List.Contains(value)
    End Function

End Class

