<%@ Import Namespace ="DigitArq.Utility" %>
<%@ Control Language="vb" AutoEventWireup="false" Codebehind="correspondenceIn.ascx.vb" Inherits="CRAVBackOffice.uc_correspondenceIn" TargetSchema="http://schemas.microsoft.com/intellisense/ie5" %>
<table id="tblMain" cellSpacing="0" cellPadding="0" width="510" align="center" border="0">
	<tbody>
		<tr>
			<td class="vertical_spacer4" colSpan="4"></td>
		</tr>
		<TR>
			<td class="txtRF"></td>
			<TD class="txtLabel"><%=GetLabel("Correspondence.CorrespondenceID")%></TD>
			<TD width="300"><asp:Label Runat="server" ID="lblCorrespondenceID" CssClass="txtBRed"></asp:Label></TD>
			<td></td>
		</TR>
		<tr>
			<td class="vertical_spacer1" colSpan="4"></td>
		</tr>
		<TR>
			<td class="txtRF">*</td>
			<TD class="txtLabel"><%=GetLabel("BO.CorrespondenceIn.lblTypeEntry")%></TD>
			<TD><asp:dropdownlist id="ddlTypeEntry" CssClass="ddlLarge" runat="server"></asp:dropdownlist></TD>
			<td class=txtAlert><asp:RequiredFieldValidator id="rfvTypeExit" Runat="server" ControlToValidate="ddlTypeEntry" Display="Dynamic"
					InitialValue="0">!</asp:RequiredFieldValidator></td>
		</TR>
		<tr>
			<td class="vertical_spacer1" colSpan="4"></td>
		</tr>
		<TR>
			<td></td>
			<TD class="txtLabel"><%=GetLabel("BO.CorrespondenceIn.lblDocumentDate")%></TD>
			<TD>
				<table cellSpacing="0" cellPadding="0" border="0">
					<tr>
						<td><asp:textbox id="txtYearDocDate" CssClass="txbYear" runat="server" MaxLength="4"></asp:textbox>&nbsp;/&nbsp;</td>
						<td><asp:textbox id="txtMonthDocDate" CssClass="txbMonth" runat="server" MaxLength="2"></asp:textbox>&nbsp;/&nbsp;</td>
						<td><asp:textbox id="txtDayDocDate" CssClass="txbDay" runat="server" MaxLength="2"></asp:textbox></td>
						<td class="text04"><code>&nbsp;(aaaa/mm/dd)</code></td>
					</tr>
				</table>
			</TD>
			<td></td>
		</TR>
		<tr>
			<td class="vertical_spacer1" colSpan="4"></td>
		</tr>
		<TR>
			<td class="txtRF">*</td>
			<TD class="txtLabel"><%=GetLabel("BO.CorrespondenceIn.lblEntryDate")%></TD>
			<TD>
				<table cellSpacing="0" cellPadding="0" border="0">
					<tr>
						<td><asp:textbox id="txtYearEntryDate" CssClass="txbYear" runat="server" MaxLength="4" ReadOnly="True"></asp:textbox>&nbsp;/&nbsp;</td>
						<td><asp:textbox id="txtMonthEntryDate" CssClass="txbMonth" runat="server" MaxLength="2" ReadOnly="True"></asp:textbox>&nbsp;/&nbsp;</td>
						<td><asp:textbox id="txtDayEntryDate" CssClass="txbDay" runat="server" MaxLength="2" ReadOnly="True"></asp:textbox></td>
						<td class="text04"><code>&nbsp;(aaaa/mm/dd)</code></td>
					</tr>
				</table>
			</TD>
			<td></td>
		</TR>
		<tr>
			<td class="vertical_spacer1" colSpan="4"></td>
		</tr>
		<TR>
			<td class="txtRF">*</td>
			<TD class="txtLabel"><%=GetLabel("BO.CorrespondenceIn.lblProvenance")%></TD>
			<TD><asp:textbox id="txtProvenance" CssClass="txbLarge" runat="server"></asp:textbox></TD>
			<td class=txtAlert><asp:requiredfieldvalidator id="rfvTxtProvenance" runat="server" Display="Dynamic" controlToValidate="txtProvenance">!</asp:requiredfieldvalidator></td>
		</TR>
		<tr>
			<td class="vertical_spacer1" colSpan="4"></td>
		</tr>
		<TR>
			<TD></TD>
			<TD class="txtLabel"><%=GetLabel("BO.CorrespondenceIn.lblReference")%></TD>
			<TD><asp:textbox id="txtReference" CssClass="txbLarge" runat="server"></asp:textbox></TD>
			<td></td>
		</TR>
		<tr>
			<td class="vertical_spacer1" colSpan="4"></td>
		</tr>
		<TR>
			<td class="txtRF">*</td>
			<TD class="txtLabel"><%=GetLabel("BO.CorrespondenceIn.lblSubject")%></TD>
			<TD><asp:textbox id="txtSubject" CssClass="txbLarge" runat="server" TextMode="MultiLine" Rows="3"></asp:textbox></TD>
			<td class=txtAlert><asp:requiredfieldvalidator id="rfvTxtSubject" runat="server" Display="Dynamic" ControlToValidate="txtSubject">!</asp:requiredfieldvalidator></td>
		</TR>
		<tr>
			<td class="vertical_spacer1" colSpan="4"></td>
		</tr>
		<TR>
			<TD></TD>
			<TD class="txtLabel"><%=GetLabel("BO.CorrespondenceIn.lblAttacheds")%></TD>
			<TD><input type="file" id="attachedFile" runat="server" class="txbLarge"></TD>
			<td></td>
		</TR>
		<tr>
			<td class="vertical_spacer1" colSpan="4"></td>
		</tr>
		<TR>
			<TD></TD>
			<TD></TD>
			<TD><asp:linkbutton id="lnkbInsertAttached" CssClass="Button_1L" Runat="server" CausesValidation="False"
					Height="20px"></asp:linkbutton></TD>
			<td></td>
		</TR>
		<tr>
			<td class="vertical_spacer1" colSpan="4"></td>
		</tr>
		<TR>
			<TD></TD>
			<TD></TD>
			<TD><asp:Label id="lblAttacheds" CssClass="lbl03" runat="server"></asp:Label></TD>
			<td></td>
		</TR>
		<tr>
			<td class="vertical_spacer1" colSpan="4"></td>
		</tr>
		<TR>
			<td class="txtRF">*</td>
			<TD class="txtLabel"><%=GetLabel("BO.CorrespondenceIn.lblClassification")%></TD>
			<TD><asp:textbox id="txtClassification" CssClass="txbMSmall" runat="server"></asp:textbox></TD>
			<td class=txtAlert><asp:requiredfieldvalidator id="rfvTxtClassification" runat="server" Display="Dynamic" ControlToValidate="txtClassification">!</asp:requiredfieldvalidator></td>
		</TR>
		<tr>
			<td class="vertical_spacer1" colSpan="4"></td>
		</tr>
		<TR>
			<TD></TD>
			<TD class="txtLabel"><%=GetLabel("BO.CorrespondenceIn.lblProcessNumber")%></TD>
			<TD><asp:textbox id="txtProcessNumber" CssClass="txbMSmall" runat="server" ReadOnly="True"></asp:textbox><asp:linkbutton id="lnkbNewProcess" CssClass="Button_1" Runat="server" CausesValidation="False"
					Height="20px"></asp:linkbutton><asp:HyperLink id="hlnkSearchProcess" CssClass="Button_1" Runat="server" Height="20px"></asp:HyperLink></TD>
			<td></td>
		</TR>
		<tr>
			<td class="vertical_spacer1" colSpan="4"></td>
		</tr>
		<tr>
			<td colspan="4">
				<asp:Panel Runat="server" ID="pnlProcess" BackColor="#eeeeee" Visible="False">
					<TABLE cellSpacing="0" cellPadding="0" width="100%" align="center" border="0">
						<TR>
							<TD class="vertical_spacer1" colSpan="3"></TD>
						</TR>
						<TR>
							<TD class="txtRF"></TD>
							<TD class="txtLabel"><%=GetLabel("Process.ProcessType")%></TD>
							<TD width="300">
								<asp:radiobuttonlist id="rblProcessType" CssClass="normal" Runat="server" AutoPostBack="True" BorderWidth="0"
									RepeatDirection="Horizontal">
									<asp:ListItem Selected="True" Value="0"></asp:ListItem>
									<asp:ListItem Selected="False" Value="1"></asp:ListItem>
								</asp:radiobuttonlist></TD>
						</TR>
						<TR>
							<TD class="vertical_spacer1" colSpan="3"></TD>
						</TR>
						<TR>
							<TD class="txtRF">*</TD>
							<TD class="txtLabel"><%=GetLabel("Process.Classification")%></TD>
							<TD>
								<asp:textbox id="txbClassification" CssClass="txbMSmall" runat="server"></asp:textbox></TD>
							<TD class=txtAlert>
								<asp:requiredfieldvalidator id="Requiredfieldvalidator1" runat="server" Display="Dynamic" ControlToValidate="txbClassification">!</asp:requiredfieldvalidator></TD>
						</TR>
						<TR>
							<TD class="vertical_spacer1" colSpan="4"></TD>
						</TR>
						<TR>
							<TD class="txtRF">*</TD>
							<TD class="txtLabel"><%=GetLabel("Process.Subject")%></TD>
							<TD>
								<asp:textbox id="txbSubject" CssClass="txbLarge" runat="server"></asp:textbox></TD>
							<TD class=txtAlert>
								<asp:requiredfieldvalidator id="Requiredfieldvalidator2" runat="server" Display="Dynamic" ControlToValidate="txbSubject">!</asp:requiredfieldvalidator></TD>
						</TR>
						<TR>
							<TD class="vertical_spacer1" colSpan="4"></TD>
						</TR>
						<TR>
							<TD align="center"></TD>
							<TD class="txtLabel"><%=GetLabel("Process.FolderID")%></TD>
							<TD>
								<asp:textbox id="txbFolderID" CssClass="txbLarge" runat="server"></asp:textbox></TD>
							<TD></TD>
						</TR>
						<TR>
							<TD class="vertical_spacer1" colSpan="4"></TD>
						</TR>
						<TR>
							<TD></TD>
							<TD class="txtLabel"><%=GetLabel("Process.Employee")%></TD>
							<TD>
								<asp:dropdownlist id="ddlEmployee" CssClass="txbLarge" runat="server"></asp:dropdownlist></TD>
							<TD></TD>
						</TR>
						<TR>
							<TD class="vertical_spacer1" colSpan="4"></TD>
						</TR>
						<TR>
							<TD></TD>
							<TD class="txtLabel"><%=GetLabel("Process.InitialDate")%></TD>
							<TD>
								<TABLE cellSpacing="0" cellPadding="0" border="0">
									<TR>
										<TD>
											<asp:textbox id="txtYearInitialDate" CssClass="txbYear" runat="server" MaxLength="4" ReadOnly="True"></asp:textbox>&nbsp;/&nbsp;</TD>
										<TD>
											<asp:textbox id="txtMonthInitialDate" CssClass="txbMonth" runat="server" MaxLength="2" ReadOnly="True"></asp:textbox>&nbsp;/&nbsp;</TD>
										<TD>
											<asp:textbox id="txtDayInitialDate" CssClass="txbDay" runat="server" MaxLength="2" ReadOnly="True"></asp:textbox></TD>
										<TD class="text04"><CODE>&nbsp;(aaaa/mm/dd)</CODE></TD>
									</TR>
								</TABLE>
							</TD>
							<TD></TD>
						</TR>
						<TR>
							<TD class="vertical_spacer1" colSpan="4"></TD>
						</TR>
						<TR>
							<TD></TD>
							<TD class="txtLabel"><%=GetLabel("Process.FinalDate")%></TD>
							<TD>
								<TABLE cellSpacing="0" cellPadding="0" border="0">
									<TR>
										<TD>
											<asp:textbox id="txtYearFinalDate" CssClass="txbYear" runat="server" MaxLength="4"></asp:textbox>&nbsp;/&nbsp;</TD>
										<TD>
											<asp:textbox id="txtMonthFinalDate" CssClass="txbMonth" runat="server" MaxLength="2"></asp:textbox>&nbsp;/&nbsp;</TD>
										<TD>
											<asp:textbox id="txtDayFinalDate" CssClass="txbDay" runat="server" MaxLength="2"></asp:textbox></TD>
										<TD class="text04"><CODE>&nbsp;(aaaa/mm/dd)</CODE></TD>
									</TR>
								</TABLE>
							</TD>
							<TD></TD>
						</TR>
						<TR>
							<TD class="vertical_spacer1" colSpan="4"></TD>
						</TR>
					</TABLE>
				</asp:Panel>
			</td>
		</tr>
		<tr>
			<td class="vertical_spacer1" colSpan="4"></td>
		</tr>
		<TR>
			<TD></TD>
			<TD class="txtLabel"><%=GetLabel("BO.CorrespondenceIn.lblNotes")%></TD>
			<TD><asp:textbox id="txtNotes" CssClass="txbLarge" runat="server" TextMode="MultiLine" Rows="3"></asp:textbox></TD>
			<td></td>
		</TR>
		<tr>
			<td class="vertical_spacer2" colSpan="4"></td>
		</tr>
		<tr>
			<td align="right" colSpan="3"><asp:HyperLink id="hlnkNew" CssClass="Button_1" Runat="server" Height="20px"></asp:HyperLink><asp:linkbutton id="lnkbSubmit" CssClass="Button_1" Runat="server" CausesValidation="True" Height="20px"></asp:linkbutton></td>
			<td></td>
		</tr>
		<tr>
			<td class="vertical_spacer1" colSpan="4"></td>
		</tr>
		<TR>
			<td class="txtRF">*</td>
			<TD colspan="3" class="txt"><%=GetLabel("BO.lblRequiredFields")%></TD>
		</TR>
		<tr>
			<td colspan="4" class="vertical_spacer3"></td>
		</tr>
	</tbody>
</table>
