Imports CRAVDataBaseAccess
Imports DigitArq.Data.Entities.MGUP
Imports DigitArq.Utility

Public Class uc_correspondenceOut
    Inherits BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents resumo As System.Web.UI.WebControls.ValidationSummary
    Protected WithEvents txtDocumentDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents rfvDocumentDate As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents txtEntryDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents rfvTxtEntryDate As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents rfvTxtProvenance As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents txtSubject As System.Web.UI.WebControls.TextBox
    Protected WithEvents Textbox1 As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtProcessNumber As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtNotes As System.Web.UI.WebControls.TextBox
    Protected WithEvents lnkbSubmit As System.Web.UI.WebControls.LinkButton
    Protected WithEvents txtAddressee As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtYearYourDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtMonthYourDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtDayYourDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtClassification As System.Web.UI.WebControls.TextBox
    Protected WithEvents dgCorrespondenceIn As System.Web.UI.WebControls.DataGrid
    Protected WithEvents pnlCorrespondenceOut As System.Web.UI.WebControls.Panel
    Protected WithEvents lnkbRelation As System.Web.UI.WebControls.LinkButton
    Protected WithEvents txtYourReference As System.Web.UI.WebControls.TextBox
    Protected WithEvents ddlTypeExit As System.Web.UI.WebControls.DropDownList
    Protected WithEvents rfvTypeExit As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents txtYearExitDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtMonthExitDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtDayExitDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents rfvTxtAddressee As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents rfvTxtSubject As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents rfvTxtClassification As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents lblAttacheds As System.Web.UI.WebControls.Label
    Protected WithEvents attachedFile As System.Web.UI.HtmlControls.HtmlInputFile
    Protected WithEvents lnkbInsertAttached As System.Web.UI.WebControls.LinkButton
    Protected WithEvents txbClassification As System.Web.UI.WebControls.TextBox
    Protected WithEvents Requiredfieldvalidator1 As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents txbSubject As System.Web.UI.WebControls.TextBox
    Protected WithEvents Requiredfieldvalidator2 As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents txbFolderID As System.Web.UI.WebControls.TextBox
    Protected WithEvents Requiredfieldvalidator3 As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents txtYearInitialDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtMonthInitialDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtDayInitialDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtYearFinalDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtMonthFinalDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtDayFinalDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents pnlProcess As System.Web.UI.WebControls.Panel
    Protected WithEvents lnkbNewProcess As System.Web.UI.WebControls.LinkButton
    Protected WithEvents hlnkSearchProcess As System.Web.UI.WebControls.HyperLink
    Protected WithEvents hlnkNew As System.Web.UI.WebControls.HyperLink
    Protected WithEvents lblCorrespondenceID As System.Web.UI.WebControls.Label
    Protected WithEvents rblProcessType As System.Web.UI.WebControls.RadioButtonList
    Protected WithEvents ddlEmployee As System.Web.UI.WebControls.DropDownList

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private objICRAV As New CRAVDataBaseAccess.SQLDataBase
    Private objIGPU As New DigitArq.Data.Entities.MGUP.SQLDataBase

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here

        If Not Me.Page.IsPostBack Then
            Dim FunctionCode As String = Request.QueryString("page")
            Dim cid As String = Me.Request.QueryString("cid")

            If objIGPU.accessFunction(HttpContext.Current.User.Identity.Name, FunctionCode) Then
                Me.hlnkNew.Text = GetLabel("lnkbNew")
                Me.lnkbSubmit.Text = GetLabel("lnkbSubmit")
                Me.lnkbInsertAttached.Text = GetLabel("lnkbInsertAttached")
                Me.hlnkSearchProcess.Text = GetLabel("lnkbSearch")
                Me.lnkbNewProcess.Text = GetLabel("lnkbNew") + " <img src=""Images/BArrowDESC.gif"" border=""0"">"
                Me.hlnkSearchProcess.NavigateUrl = "javascript:NewWindow('/CRAVbackOffice/NewWindow.aspx?page=selectProcess&control=" & Me.txtProcessNumber.ClientID & "','mywin','700','700','yes','center');"
                Me.hlnkNew.NavigateUrl = "../defaultIn.aspx?page=correspondenceOut"

                Me.rblProcessType.Items(0).Text = GetLabel("Process.ProcessType.0")
                Me.rblProcessType.Items(1).Text = GetLabel("Process.ProcessType.1")

                objICRAV.loadTypesEntryExit(Me.ddlTypeExit)
                Me.txtYearExitDate.Text = Now.Year.ToString
                Me.txtMonthExitDate.Text = Now.Month.ToString.PadLeft(2, "0")
                Me.txtDayExitDate.Text = Now.Day.ToString.PadLeft(2, "0")
                Me.txtClassification.Text = GetConfig("ReproductionRequest.Classification")

                If Not cid Is Nothing Then
                    loadCorrespondenceToForm(CInt(cid))
                End If
            Else
                Response.Redirect("defaultIn.aspx?page=crav-0&lbl=accessDenied")
            End If
        End If
    End Sub


    Private Sub loadCorrespondenceToForm(ByVal cid As Int64)
        Dim objCorrespondence As Correspondence = objICRAV.loadFullCorrespondence(cid)

        Me.lblCorrespondenceID.Text = objCorrespondence.ManualEntryExitID
        Me.ddlTypeExit.SelectedValue = objCorrespondence.TypeEntryExitCode
        Me.txtYearExitDate.Text = DBToYYYY(objCorrespondence.EventDate)
        Me.txtMonthExitDate.Text = DBToMM(objCorrespondence.EventDate)
        Me.txtDayExitDate.Text = DBToDD(objCorrespondence.EventDate)
        Me.txtYearYourDate.Text = DBToYYYY(objCorrespondence.DocumentDate)
        Me.txtMonthYourDate.Text = DBToMM(objCorrespondence.DocumentDate)
        Me.txtDayYourDate.Text = DBToDD(objCorrespondence.DocumentDate)
        Me.txtAddressee.Text = objCorrespondence.ProvDest
        Me.txtYourReference.Text = objCorrespondence.Reference
        Me.txtSubject.Text = objCorrespondence.Subject
        Me.txtClassification.Text = objCorrespondence.Classification
        Me.txtProcessNumber.Text = objCorrespondence.Process.OtherProcessID
        Me.txtNotes.Text = objCorrespondence.Note

        Me.lnkbSubmit.Text = GetLabel("lnkbChange")
    End Sub


    Private Sub lnkbSubmit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbSubmit.Click

        If Me.Page.IsValid Then
            Dim objCorrespondence As New CRAVDataBaseAccess.Correspondence

            If Me.pnlProcess.Visible = True Then
                Dim objProcess As New Process

                objProcess.ProcessType = Me.rblProcessType.SelectedValue
                objProcess.Classification = Me.txbClassification.Text
                objProcess.Subject = Me.txbSubject.Text
                objProcess.FolderID = Me.txbFolderID.Text
                objProcess.Employee.UserName = Me.ddlEmployee.SelectedValue

                objProcess.InitialDate = strConvDate(Me.txtYearInitialDate.Text, Me.txtMonthInitialDate.Text, Me.txtDayInitialDate.Text)
                objProcess.FinalDate = strConvDate(Me.txtYearFinalDate.Text, Me.txtMonthFinalDate.Text, Me.txtDayFinalDate.Text)

                Dim PRet(2) As Integer
                PRet = objICRAV.storeProcess(objProcess)
                objCorrespondence.Process.ProcessID = PRet(0)
                objCorrespondence.Process.OtherProcessID = PRet(1)
            Else
                If Not Me.txtProcessNumber.Text.Equals("") Then
                    objCorrespondence.Process.ProcessID = objICRAV.getProcessID(StrToInt(Me.txtProcessNumber.Text))
                End If
            End If

            objCorrespondence.EventCode = Event_.eEventType.correspondenceOut
            objCorrespondence.Classification = Me.txtClassification.Text
            objCorrespondence.EmployeeInfo.UserName = HttpContext.Current.User.Identity.Name

            objCorrespondence.TypeEntryExitCode = Me.ddlTypeExit.SelectedValue
            objCorrespondence.TypeEntryExit = Me.ddlTypeExit.SelectedItem.Text
            objCorrespondence.EventDate = strConvDate(Me.txtYearExitDate.Text, Me.txtMonthExitDate.Text, Me.txtDayExitDate.Text)
            objCorrespondence.DocumentDate = strConvDate(Me.txtYearYourDate.Text, Me.txtMonthYourDate.Text, Me.txtDayYourDate.Text)
            objCorrespondence.ProvDest = Me.txtAddressee.Text
            objCorrespondence.Reference = Me.txtYourReference.Text
            objCorrespondence.Subject = Me.txtSubject.Text
            objCorrespondence.Attacheds = AttachedCollection
            objCorrespondence.Note = Me.txtNotes.Text

            If Me.Request.QueryString("cid") Is Nothing Then
                Dim Ret(2) As Int64
                Ret = objICRAV.storeCorrespondence(objCorrespondence)
                objCorrespondence.CorrespondenceID = Ret(0)
                objCorrespondence.ManualEntryExitID = Ret(1)
                Me.lblCorrespondenceID.Text = objCorrespondence.ManualEntryExitID
                If Not Ret Is Nothing Then
                    Me.Page.RegisterStartupScript("x", "<script>correspondenceRelated(" & objCorrespondence.CorrespondenceID & "," & Me.lblCorrespondenceID.Text & ");</script>")
                Else
                    Me.Page.RegisterStartupScript("xx", "<script language=javascript>window.alert('" & GetLabel("conReqStep2.error") & "');</script>")
                End If
            Else
                objCorrespondence.EventID = Me.Request.QueryString("cid")
                objICRAV.updateCorrespondence(objCorrespondence)
            End If
            Session.Remove("AttachedCollection")
        End If

    End Sub

    Private Sub lnkbInsertAttached_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbInsertAttached.Click

        Dim myFile As HttpPostedFile = Me.attachedFile.PostedFile

        Dim objAttached As New Attached
        Dim intAux As Integer = myFile.FileName.LastIndexOf("\")
        Dim strFileName As String = myFile.FileName.Substring(intAux + 1)
        objAttached.FileName = strFileName
        objAttached.ContentType = myFile.ContentType
        objAttached.ContentLength = myFile.ContentLength
        Dim myData(objAttached.ContentLength) As Byte
        myFile.InputStream.Read(myData, 0, objAttached.ContentLength)
        objAttached.Attached = myData

        If AttachedCollection Is Nothing Then
            AttachedCollection = New AttachedCollection
        End If
        AttachedCollection.Add(objAttached)

        Me.lblAttacheds.Text += objAttached.FileName + "<br>"
    End Sub


    Private Sub lnkbNewProcess_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbNewProcess.Click
        If Me.pnlProcess.Visible = True Then
            Me.pnlProcess.Visible = False
            Me.lnkbNewProcess.Text = Me.lnkbNewProcess.Text.Replace(" <img src=""Images/BArrowASC.gif"" border=""0"">", " <img src=""Images/BArrowDESC.gif"" border=""0"">")
        Else
            Me.pnlProcess.Visible = True
            Me.lnkbNewProcess.Text = Me.lnkbNewProcess.Text.Replace(" <img src=""Images/BArrowDESC.gif"" border=""0"">", " <img src=""Images/BArrowASC.gif"" border=""0"">")
            Me.txtProcessNumber.Text = ""

            Me.txtYearInitialDate.Text = Now.Year.ToString
            Me.txtMonthInitialDate.Text = Now.Month.ToString.PadLeft(2, "0")
            Me.txtDayInitialDate.Text = Now.Day.ToString.PadLeft(2, "0")
            Me.txbClassification.Text = Me.txtClassification.Text
            Me.txbSubject.Text = GetConfig("ReproductionRequest.Subject")

            Dim ds As DataSet = objIGPU.loadFullEmployees()
            Me.ddlEmployee.DataSource = ds
            Me.ddlEmployee.DataValueField = "UserName"
            Me.ddlEmployee.DataTextField = "FullName"
            Me.ddlEmployee.DataBind()

            Dim li As New ListItem("-- Selecionar --", "")
            Me.ddlEmployee.Items.Insert(0, li)
        End If
    End Sub

    Private Sub rblProcessType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rblProcessType.SelectedIndexChanged
        Dim ProcessType As Process.eProcessType = Me.rblProcessType.SelectedValue
        Select Case ProcessType
            Case Process.eProcessType.CRAV
                Me.txbClassification.Text = GetConfig("ReproductionRequest.Classification")
                Me.txbSubject.Text = GetConfig("ReproductionRequest.Subject")
            Case Process.eProcessType.Other
                Me.txbClassification.Text = ""
                Me.txbSubject.Text = ""
        End Select
    End Sub

    '============= PROPERTIES ================================================================
    Private Property AttachedCollection() As AttachedCollection
        Get
            Return Session("AttachedCollection")
        End Get
        Set(ByVal Value As AttachedCollection)
            Session("AttachedCollection") = Value
        End Set
    End Property

End Class
