Imports System.IO
Imports System.Globalization
Imports CRAVDataBaseAccess

Public Class emoluments
    Inherits BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents ddlCategories As System.Web.UI.WebControls.DropDownList
    Protected WithEvents txbCost As System.Web.UI.WebControls.TextBox
    Protected WithEvents rfvQuantity As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents lnkbInsert As System.Web.UI.WebControls.LinkButton
    Protected WithEvents dgEmoluments As System.Web.UI.WebControls.DataGrid
    Protected WithEvents lblTotalValue As System.Web.UI.WebControls.Label
    Protected WithEvents pnlTotal As System.Web.UI.WebControls.Panel
    Protected WithEvents rfvCost As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents txtYearEmolument As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtMonthEmolument As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtDayEmolument As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbReceiptNumber As System.Web.UI.WebControls.TextBox
    Protected WithEvents lnkbGetCertificateNumber As System.Web.UI.WebControls.LinkButton
    Protected WithEvents txbExemption As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbNote As System.Web.UI.WebControls.TextBox
    Protected WithEvents ckbCertificate As System.Web.UI.WebControls.CheckBox
    Protected WithEvents rfvReceiptNumber As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents lnkbExportExcel As System.Web.UI.WebControls.LinkButton
    Protected WithEvents reReceiptNumber As System.Web.UI.WebControls.RegularExpressionValidator
    Protected WithEvents ddlIVA As System.Web.UI.WebControls.DropDownList
    Protected WithEvents lnkbReport As System.Web.UI.WebControls.LinkButton
    Protected WithEvents ddlSearchByCategory As System.Web.UI.WebControls.DropDownList
    Protected WithEvents ddlSearchByYear As System.Web.UI.WebControls.DropDownList
    Protected WithEvents ddlSearchByMonth As System.Web.UI.WebControls.DropDownList
    Protected WithEvents teste As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private objICRAV As New CRAVDataBaseAccess.SQLDataBase


    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        If Not Me.Page.IsPostBack Then
            objICRAV.loadCategories(Me.ddlCategories)
            loadDdlIVA()
            loadDdlByCategory()
            loadDdlSearchByMonth()
            loadDdlSearchByYears()

            Me.txtYearEmolument.Text = Now.Year.ToString
            Me.txtMonthEmolument.Text = Now.Month.ToString.PadLeft(2, "0")
            Me.txtDayEmolument.Text = Now.Day.ToString.PadLeft(2, "0")

            Dim c1 As ButtonColumn = Me.dgEmoluments.Columns(0)
            c1.Text = String.Format("<img src='Images/delete.png' alt='{0}' border='0'>", GetLabel("alt.Delete"))
            Dim c2 As BoundColumn = Me.dgEmoluments.Columns(1)
            c2.HeaderText = GetLabel("Emolument.EmolumentDate")
            Dim c3 As BoundColumn = Me.dgEmoluments.Columns(2)
            c3.HeaderText = GetLabel("Emolument.ReceiptNumber")
            Dim c4 As BoundColumn = Me.dgEmoluments.Columns(3)
            c4.HeaderText = GetLabel("Emolument.Category")
            Dim c5 As BoundColumn = Me.dgEmoluments.Columns(4)
            c5.HeaderText = GetLabel("Emolument.CertificateNumber")
            Dim c6 As BoundColumn = Me.dgEmoluments.Columns(5)
            c6.HeaderText = GetLabel("Emolument.Exemption")
            Dim c7 As TemplateColumn = Me.dgEmoluments.Columns(6)
            c7.HeaderText = GetLabel("Emolument.Cost") + " (&euro;)"
            Dim c8 As TemplateColumn = Me.dgEmoluments.Columns(7)
            c8.HeaderText = GetLabel("Emolument.IVA")
            Dim c9 As BoundColumn = Me.dgEmoluments.Columns(8)
            c9.HeaderText = GetLabel("Emolument.Note")

            loadEmoluments()

            Me.lnkbInsert.Text = GetLabel("lnkbInsert")
            Me.lnkbReport.Text = GetLabel("lnkbReport")
            Me.lnkbExportExcel.Text = GetLabel("lnkbExport")
        End If
    End Sub

    Private Sub loadDdlIVA()
        Dim l1 As New ListItem(GetConfig("IVA1") + "%", GetConfig("IVA1"))
        Dim l2 As New ListItem(GetConfig("IVA2") + "%", GetConfig("IVA2"))
        Dim l3 As New ListItem(GetConfig("IVA3") + "%", GetConfig("IVA3"))
        Dim l4 As New ListItem(GetConfig("IVA4") + "%", GetConfig("IVA4"))
        Me.ddlIVA.Items.Add(l1)
        Me.ddlIVA.Items.Add(l2)
        Me.ddlIVA.Items.Add(l3)
        Me.ddlIVA.Items.Add(l4)
    End Sub

    Private Sub loadDdlByCategory()
        objICRAV.loadCategories(Me.ddlSearchByCategory)
        Dim l1 As New ListItem("", "")
        Me.ddlSearchByCategory.Items.Insert(0, l1)
    End Sub

    Private Sub loadDdlSearchByYears()
        Dim ds As DataSet = objICRAV.getEmolumentsYears
        Me.ddlSearchByYear.DataSource = ds
        Me.ddlSearchByYear.DataTextField = "Years"
        Me.ddlSearchByYear.DataValueField = "Years"
        Me.ddlSearchByYear.DataBind()
        If Not Me.ddlSearchByYear.Items.FindByValue(Now.Year.ToString) Is Nothing Then
            Me.ddlSearchByYear.SelectedValue = Now.Year
        End If
    End Sub

    Private Sub loadDdlSearchByMonth()
        loadDdlMonth(Me.ddlSearchByMonth)
        Me.ddlSearchByMonth.SelectedValue = Now.Month.ToString.PadLeft(2, "0")
    End Sub

    Private Sub lnkbInsert_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbInsert.Click

        Dim objEmolument As New Emolument

        objEmolument.EmolumentDate = strConvDate(Me.txtYearEmolument.Text, Me.txtMonthEmolument.Text, Me.txtDayEmolument.Text)
        objEmolument.ReceiptNumber = Me.txbReceiptNumber.Text
        objEmolument.IVA = Me.ddlIVA.SelectedValue
        objEmolument.Cost = Me.txbCost.Text.Replace(",", ".")
        objEmolument.Exemption = Me.txbExemption.Text
        objEmolument.Note = Me.txbNote.Text
        objEmolument.CategoryID = Me.ddlCategories.SelectedValue

        objICRAV.storeEmolument(objEmolument)
        loadEmoluments()

    End Sub

    Private Sub dgTasks_DeleteCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles dgEmoluments.DeleteCommand
        Dim EmolumentID As Int64 = Me.dgEmoluments.DataKeys(e.Item.ItemIndex)

        objICRAV.deleteEmolument(EmolumentID)
        If Me.dgEmoluments.Items.Count = 1 Then
            Me.dgEmoluments.CurrentPageIndex -= 1
        End If
        loadEmoluments()
        Dim ds As DataSet = objICRAV.loadEmoluments(Me.ddlSearchByCategory.SelectedValue, Me.ddlSearchByYear.SelectedValue, Me.ddlSearchByMonth.SelectedValue)
        Me.dgEmoluments.DataSource = ds
        Me.dgEmoluments.DataBind()
        Me.lblTotalValue.Text = String.Format("{0:0.00}", getTotalCostEmoluments(ds))
    End Sub

    Private Sub dgEmoluments_PageIndexChanged(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridPageChangedEventArgs) Handles dgEmoluments.PageIndexChanged
        Me.dgEmoluments.CurrentPageIndex = e.NewPageIndex
        Me.dgEmoluments.SelectedIndex = -1
        Dim ds As DataSet = objICRAV.loadEmoluments(Me.ddlSearchByCategory.SelectedValue, Me.ddlSearchByYear.SelectedValue, Me.ddlSearchByMonth.SelectedValue)
        Me.dgEmoluments.DataSource = ds
        Me.dgEmoluments.DataBind()
        Me.lblTotalValue.Text = String.Format("{0:0.00}", getTotalCostEmoluments(ds))
    End Sub

    Private Sub dgEmoluments_ItemDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles dgEmoluments.ItemDataBound
        If e.Item.ItemType = ListItemType.Item Or _
                e.Item.ItemType = ListItemType.AlternatingItem Then
            With DirectCast(e.Item.Cells(0).Controls(0), LinkButton)
                .Attributes.Add("onClick", "return confirm('" & GetLabel("return.confirm.delete") & "');")
            End With
        End If
    End Sub

    Private Sub lnkbExportExcel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbExportExcel.Click
        Dim ds As DataSet = objICRAV.loadEmoluments(Me.ddlSearchByCategory.SelectedValue, Me.ddlSearchByYear.SelectedValue, Me.ddlSearchByMonth.SelectedValue)
        exportExcel(ds, "emolumentos")
    End Sub

    Private Sub lnkbReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbReport.Click
        Dim ds As DataSet = objICRAV.loadEmolumentsGroupByReceiptNumber(Me.ddlSearchByCategory.SelectedValue, Me.ddlSearchByYear.SelectedValue, Me.ddlSearchByMonth.SelectedValue)
        exportExcel(ds, "emolumentos")
    End Sub

    Private Sub loadEmoluments()
        Dim ds As DataSet = objICRAV.loadEmoluments(Me.ddlSearchByCategory.SelectedValue, Me.ddlSearchByYear.SelectedValue, Me.ddlSearchByMonth.SelectedValue)
        Me.dgEmoluments.DataSource = ds
        Me.dgEmoluments.DataBind()
        Me.dgEmoluments.CurrentPageIndex = Me.dgEmoluments.PageCount - 1
        Me.dgEmoluments.SelectedIndex = -1
        Me.dgEmoluments.DataBind()
        If Me.dgEmoluments.Items.Count > 0 Then
            Me.pnlTotal.Visible = True
            Me.dgEmoluments.Visible = True
            Me.lnkbExportExcel.Visible = True
            Me.lblTotalValue.Text = String.Format("{0:0.00}", getTotalCostEmoluments(ds))
        Else
            Me.pnlTotal.Visible = False
            Me.dgEmoluments.Visible = False
            Me.lnkbExportExcel.Visible = False
        End If
    End Sub

    Private Function getTotalCostEmoluments(ByVal ds As DataSet) As Double
        Dim pageCostEmoluments As Double = 0
        'Dim dv As DataView = ds.DefaultViewManager.CreateDataView(ds.Tables(0))
        For i As Integer = 0 To ds.Tables(0).Rows.Count - 1
            Try
                pageCostEmoluments += CType(ds.Tables(0).Rows(i).Item("Cost").ToString(), Double)
            Catch ex As Exception
            End Try
        Next
        Return pageCostEmoluments
    End Function

    Private Sub exportExcel(ByVal ds As DataSet, ByVal saveAsFile As String)
        ' O limite de linhas do Excel   65536
        Dim sw As New StringWriter
        Dim dv As DataView = ds.DefaultViewManager.CreateDataView(ds.Tables(0))
        If dv.Count + 1 < 65536 Then
            Response.Clear()
            Response.ContentType = "application/vnd.csv"
            Response.AddHeader("content-disposition", "attachment;filename=" & saveAsFile & ".csv")
            Response.ContentEncoding = System.Text.Encoding.Default
            Response.Charset = ""

            For iCol As Integer = 0 To ds.Tables(0).Columns.Count - 1
                sw.Write(ds.Tables(0).Columns(iCol).ColumnName)
                sw.Write(";")
            Next
            sw.WriteLine()
            sw.WriteLine()

            For r As Integer = 0 To ds.Tables(0).Rows.Count - 1
                For iCol As Integer = 0 To ds.Tables(0).Columns.Count - 1
                    sw.Write(ds.Tables(0).Rows(r).Item(iCol).ToString)
                    sw.Write(";")
                Next
                sw.WriteLine()
            Next
            sw.WriteLine()
            sw.WriteLine()
            sw.Write("Total (euros): " & String.Format("{0:0.00}", Me.lblTotalValue.Text))
            sw.Write(";")

            Response.Write(sw.ToString())
            Response.End()
        Else
            HttpContext.Current.Response.Write("Muitas linhas para exportar para o Excel !!!")
        End If
    End Sub

    Private Sub ddlSearchByCategory_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ddlSearchByCategory.SelectedIndexChanged
        Dim ds As DataSet = objICRAV.loadEmoluments(Me.ddlSearchByCategory.SelectedValue, Me.ddlSearchByYear.SelectedValue, Me.ddlSearchByMonth.SelectedValue)
        Me.dgEmoluments.DataSource = ds
        Me.dgEmoluments.CurrentPageIndex = 0
        Me.dgEmoluments.DataBind()
        Me.lblTotalValue.Text = String.Format("{0:0.00}", getTotalCostEmoluments(ds))
    End Sub

    Private Sub ddlSearchByYear_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ddlSearchByYear.SelectedIndexChanged
        Dim ds As DataSet = objICRAV.loadEmoluments(Me.ddlSearchByCategory.SelectedValue, Me.ddlSearchByYear.SelectedValue, Me.ddlSearchByMonth.SelectedValue)
        Me.dgEmoluments.DataSource = ds
        Me.dgEmoluments.CurrentPageIndex = 0
        Me.dgEmoluments.DataBind()
        Me.lblTotalValue.Text = String.Format("{0:0.00}", getTotalCostEmoluments(ds))
    End Sub

    Private Sub ddlSearchByMonth_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ddlSearchByMonth.SelectedIndexChanged
        Dim ds As DataSet = objICRAV.loadEmoluments(Me.ddlSearchByCategory.SelectedValue, Me.ddlSearchByYear.SelectedValue, Me.ddlSearchByMonth.SelectedValue)
        Me.dgEmoluments.DataSource = ds
        Me.dgEmoluments.CurrentPageIndex = 0
        Me.dgEmoluments.DataBind()
        Me.lblTotalValue.Text = String.Format("{0:0.00}", getTotalCostEmoluments(ds))
    End Sub

End Class
