<%@ Control Language="vb" AutoEventWireup="false" Codebehind="updateCorrespondence.ascx.vb" Inherits="CRAVBackOffice.updateCorrespondence" TargetSchema="http://schemas.microsoft.com/intellisense/ie5" %>
<%@ Register TagPrefix="uc1" TagName="ascendantCorrespondence" Src="ascendantCorrespondence.ascx" %>
<%@ Import Namespace ="CRAVDataBaseAccess.mShowItems" %>
<%@ Import Namespace ="DigitArq.Utility" %>
<table cellSpacing="0" cellPadding="0" width="600" align="center" border="0">
	<tr>
		<td class="vertical_spacer3"></td>
	</tr>
	<tr>
		<td class="line"></td>
	</tr>
	<tr>
		<td>
			<table cellSpacing="1" cellPadding="2" width="100%" border="0">
				<tr>
					<td class="txtCenter" width="140"><%= getlabel("BO.searchCorrespondence.lblCorrespondenceType") %></td>
					<td class="txtCenter" width="140"><%= getlabel("BO.searchCorrespondence.lblFieldsSearch") %></td>
					<td></td>
					<td class="txtCenter" width="200"><%= getlabel("BO.searchCorrespondence.lblTerms") %></td>
					<td></td>
				</tr>
				<tr valign=baseline>
					<td><asp:dropdownlist id="ddlCorrespondenceType" Runat="server" CssClass="ddl07"></asp:dropdownlist></td>
					<td><asp:dropdownlist id="ddlFieldsSearch" Runat="server" CssClass="ddl07"></asp:dropdownlist></td>
					<td><asp:RequiredFieldValidator Runat="server" ID="rfvFieldsSearch" ControlToValidate="ddlFieldsSearch" InitialValue=""	Display="Static">!</asp:RequiredFieldValidator></td>
					<td><asp:textbox id="txtTerms" Runat="server" CssClass="txbALeft07"></asp:textbox></td>
					<td align="right"><asp:linkbutton id="lnkbSearch" Runat="server" CssClass="Button_1" CausesValidation="true" Height="20px"></asp:linkbutton></td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="line"></td>
	</tr>
	<tr>
		<td class="vertical_spacer1"></td>
	</tr>
	<tr>
		<td align="right"><asp:HyperLink id="hlnkPrint" Runat="server" Visible="False" ImageUrl="../Images/print.png" CssClass=imgPrint></asp:HyperLink><asp:linkbutton id="lnkbExport" Runat="server" CausesValidation="False"
				Visible="False" CssClass=imgExport></asp:linkbutton></td>
	</tr>
	<tr>
		<td class="vertical_spacer1"></td>
	</tr>
	<tr>
		<td><asp:panel id="pnlWithoutResults" Runat="server" Visible="false">
				<TABLE cellSpacing="0" cellPadding="0" width="100%" border="0">
					<TR>
						<TD class="vertival_spacer2"></TD>
					</TR>
					<TR>
						<TD class="Alert" align="center"><%= getlabel("BO.consultUsers.alert1") %></TD>
					</TR>
				</TABLE>
			</asp:panel>
		</td>
	</tr>
	<tr>
		<td vAlign="top">
			<div id="contentstart" style="OVERFLOW-Y: auto; OVERFLOW-X: auto; WIDTH: 600px; HEIGHT: 500px">
				<asp:datagrid id="dgCorrespondence" Runat="server" cellpadding="5" CellSpacing="1" AllowPaging="False"
					AllowSorting="True" GridLines="None" AutoGenerateColumns="False" DataKeyField="EventID" BorderWidth="0"
					Width="100%">
					<ITEMSTYLE CssClass='itemStyle_textLeft'></ITEMSTYLE>
					<ALTERNATINGITEMSTYLE CssClass='itemStyle_textLeft'></ALTERNATINGITEMSTYLE>
					<Columns>
						<asp:TemplateColumn ItemStyle-VerticalAlign="Top" HeaderStyle-Width=15px>
							<ITEMSTYLE CssClass='itemStyle_textCenter'></ITEMSTYLE>
							<HEADERSTYLE CssClass='hStyleOrder'></HEADERSTYLE>
							<HeaderTemplate>
								<asp:ImageButton Runat="server" ID="imbExpandAll" CommandName="ExpandAll" ImageUrl="../Images/plus.gif"
									AlternateText="Expandir tudo" />
							</HeaderTemplate>
							<ItemTemplate>
								<asp:ImageButton Runat="server" ID="imbExpand" CommandName="Expand" ImageUrl="../Images/plus.gif"
									AlternateText="Expandir" />
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:TemplateColumn ItemStyle-VerticalAlign="Top">
							<HeaderStyle CssClass="headerStyle"></HeaderStyle>
							<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
							<ItemTemplate>
								<a href="defaultIn.aspx?page=<%# getEventName(DataBinder.Eval(Container,"DataItem.EventCode")) %>&cid=<%# DataBinder.Eval(Container,"DataItem.EventID") %>"><img src='Images/edit.png' alt='Editar' border='0'></a>
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:TemplateColumn ItemStyle-VerticalAlign="Top" SortExpression="EventID,2">
							<ItemStyle Width="70px"></ItemStyle>
							<HEADERSTYLE CssClass='hStyleOrder'></HEADERSTYLE>
							<ItemTemplate>
								<%# DataBinder.Eval(Container,"DataItem.ManualEntryExitID") %>
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:TemplateColumn SortExpression="Subject,3">
							<HEADERSTYLE CssClass='hStyleOrder'></HEADERSTYLE>
							<ItemTemplate>
								<%# DataBinder.Eval(Container,"DataItem.Subject") + " > " + DataBinder.Eval(Container,"DataItem.ProvDest") %>
								<asp:repeater id="repCorrespondenceIn" Runat="server" Visible="False">
									<HeaderTemplate>
										<%# strHeaderTable() %>
									</HeaderTemplate>
									<ItemTemplate>
										<br>
										<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Type"), getlabel("event." & DataBinder.Eval(Container,"DataItem.EventCode")) ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.TypeEntry"), DataBinder.Eval(Container,"DataItem.TypeEntryExit")  ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.EntryDate"), DataBinder.Eval(Container,"DataItem.EventDate") ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.DocumentDate"), DataBinder.Eval(Container,"DataItem.DocumentDate") ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Prov"), DataBinder.Eval(Container,"DataItem.ProvDest") ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Reference"), DataBinder.Eval(Container,"DataItem.Reference") ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Note"), DataBinder.Eval(Container,"DataItem.Note") ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Event.Classification"), DataBinder.Eval(Container,"DataItem.Classification") ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Event.ProcessID"), DataBinder.Eval(Container,"DataItem.Process.OtherProcessID") ) %>
									</ItemTemplate>
									<FooterTemplate>
										<%# strFooterTable() %>
									</FooterTemplate>
								</asp:repeater>
								<asp:repeater id="repCorrespondenceOut" Runat="server" Visible="False">
									<HeaderTemplate>
										<%# strHeaderTable() %>
									</HeaderTemplate>
									<ItemTemplate>
										<br>
										<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Type"), getlabel("event." & DataBinder.Eval(Container,"DataItem.EventCode")) ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.TypeExit"), DataBinder.Eval(Container,"DataItem.TypeEntryExit")  ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.ExitDate"), DataBinder.Eval(Container,"DataItem.EventDate") ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.YourDate"), DataBinder.Eval(Container,"DataItem.DocumentDate") ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Dest"), DataBinder.Eval(Container,"DataItem.ProvDest") ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Reference"), DataBinder.Eval(Container,"DataItem.Reference") ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Note"), DataBinder.Eval(Container,"DataItem.Note") ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Event.Classification"), DataBinder.Eval(Container,"DataItem.Classification") ) %>
										<%# strDraw3ColumnRowTitles("", getlabel("Event.ProcessID"), DataBinder.Eval(Container,"DataItem.Process.OtherProcessID") ) %>
									</ItemTemplate>
									<FooterTemplate>
										<%# strFooterTable() %>
									</FooterTemplate>
								</asp:repeater>
								<table cellpadding="0" cellspacing="0" width="100%" border="0">
									<tr>
										<td width=20px></td>
										<td>
											<uc1:ascendantCorrespondence id="AscendantCorrespondence" runat="server" visible="false"></uc1:ascendantCorrespondence>
										</td>
									</tr>
								</table>
								<asp:DataGrid ID="dgAttacheds" cellpadding="4" CellSpacing="1" AllowPaging="False" GridLines="None"
									AutoGenerateColumns="False" DataKeyField="AttachedID" BorderWidth="0" BackColor="#ffffff"
									Width="100%" Runat="server">
									<Columns>
										<asp:buttoncolumn buttontype="LinkButton" commandname="Delete" text="<img src='Images/delete.png' alt='Remover Item' border='0'>">
											<HeaderStyle CssClass="bgSDgHeader"></HeaderStyle>
											<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
										</asp:buttoncolumn>
										<asp:BoundColumn DataField="FileName" HeaderText="Nome" ReadOnly="True">
											<HeaderStyle CssClass="bgSDgHeader"></HeaderStyle>
											<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
										</asp:BoundColumn>
										<asp:BoundColumn DataField="ContentLength" HeaderText="Tamanho" HeaderStyle-Width="150">
											<HeaderStyle CssClass="bgSDgHeader"></HeaderStyle>
											<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
										</asp:BoundColumn>
										<asp:TemplateColumn>
											<ItemTemplate>
												<asp:ImageButton Runat="server" ID="imbOpenAttached" CausesValidation="False" CommandName="OpenAttached"
													ImageUrl="../Images/detalhe1.gif" />
											</ItemTemplate>
											<HeaderStyle CssClass="bgSDgHeader"></HeaderStyle>
											<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
										</asp:TemplateColumn>
									</Columns>
								</asp:DataGrid>
							</ItemTemplate>
						</asp:TemplateColumn>
					</Columns>
				</asp:datagrid>
			</div>
		</td>
	</tr>
	<tr>
		<td class="vertical_spacer2"></td>
	</tr>
</table>
