<%@ Control Language="vb" AutoEventWireup="false" Codebehind="updateProcesses.ascx.vb" Inherits="CRAVBackOffice.updateProcesses" TargetSchema="http://schemas.microsoft.com/intellisense/ie5" %>
<%@ Import Namespace ="CRAVDataBaseAccess.mShowItems" %>
<%@ Import Namespace ="DigitArq.Utility" %>
<table cellSpacing="0" cellPadding="0" width="600" align="center" border="0">
	<tr>
		<td class="vertical_spacer3"></td>
	</tr>
	<tr>
		<td class="line"></td>
	</tr>
	<tr>
		<td>
			<table cellSpacing="1" cellPadding="2" width="100%" border="0">
				<tr>
					<td width="140" class="txtCenter"><%=GetLabel("BO.updateProcesses.lblProcessType")%></td>
					<td width="140" class="txtCenter"><%=GetLabel("BO.updateProcesses.lblFieldSearch")%></td>
					<td></td>
					<td width="200" class="txtCenter"><%=GetLabel("BO.updateProcesses.lblTerms")%></td>
					<td></td>
				</tr>
				<tr valign="baseline">
					<td><asp:dropdownlist id="ddlProcessType" Runat="server" CssClass="ddl10"></asp:dropdownlist></td>
					<td><asp:dropdownlist id="ddlFieldsSearch" Runat="server" CssClass="ddl10"></asp:dropdownlist></td>
					<td><asp:RequiredFieldValidator id="rfvFieldsSearch" Runat="server" InitialValue="" ControlToValidate="ddlFieldsSearch">!</asp:RequiredFieldValidator></td>
					<td><asp:textbox id="txtTerms" Runat="server" CssClass="txbALeft10"></asp:textbox></td>
					<td align="right"><asp:linkbutton id="lnkbSearch" Runat="server" CssClass="Button_1" CausesValidation="true" Height="20px"></asp:linkbutton></td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="line"></td>
	</tr>
	<tr>
		<td class="vertical_spacer1"></td>
	</tr>
	<tr>
		<td align="right"><asp:HyperLink id="hlnkPrint" Runat="server" Visible="False" ImageUrl="../Images/print.png" CssClass="imgPrint"></asp:HyperLink><asp:linkbutton id="lnkbExport" Runat="server" CausesValidation="False" Visible="False" CssClass="imgExport"></asp:linkbutton></td>
	</tr>
	<tr>
		<td class="vertical_spacer1"></td>
	</tr>
	<tr>
		<td>
			<asp:panel id="pnlWithoutResults" Runat="server" Visible="false">
      <TABLE cellSpacing=0 cellPadding=0 width="100%" border=0>
        <TR>
          <TD class=vertival_spacer2></TD></TR>
        <TR>
          <TD class=Alert align=center><%= getlabel("BO.consultUsers.alert1") %></TD></TR></TABLE>
			</asp:panel>
		</td>
	</tr>
	<tr>
		<td vAlign="top">
			<div id="contentstart" style="OVERFLOW-Y: auto; OVERFLOW-X: auto; WIDTH: 600px; HEIGHT: 500px">
				<asp:datagrid id="dgProcesses" Runat="server" cellpadding="5" CellSpacing="1" AllowPaging="False"
					AllowSorting="False" GridLines="None" AutoGenerateColumns="False" DataKeyField="ProcessID"
					BorderWidth="0" Width="100%">
					<ITEMSTYLE CssClass='itemStyle_textLeft'></ITEMSTYLE>
					<ALTERNATINGITEMSTYLE CssClass='itemStyle_textLeft'></ALTERNATINGITEMSTYLE>
					<Columns>
						<asp:buttoncolumn buttontype="LinkButton" commandname="Delete" text="<img src='Images/delete.png' alt='Eliminar registo' border='0'>" ItemStyle-VerticalAlign="Top">
							<HeaderStyle CssClass="bgDgHeader"></HeaderStyle>
							<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
						</asp:buttoncolumn>
						<asp:HyperLinkColumn ItemStyle-VerticalAlign="Top" DataNavigateUrlField="ProcessID" DataNavigateUrlFormatString="javascript:NewWindow('OtherWindows/windowDetails.aspx?event=processEvents&pid={0}','mywin','700','600','yes','center');" Text="<img src='Images/processes.png' alt='Registos do processo' border='0'>">
							<HeaderStyle CssClass="bgDgHeader"></HeaderStyle>
							<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
						</asp:HyperLinkColumn>
						<asp:TemplateColumn ItemStyle-VerticalAlign="Top">
							<HeaderStyle CssClass="bgDgHeader"></HeaderStyle>
							<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
							<ItemTemplate>
								<a href='defaultIn.aspx?page=insertProcess&pid=<%# DataBinder.Eval(Container,"DataItem.ProcessID") %>'>
									<img src='Images/edit.png' alt='Editar' border='0'></a>
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:TemplateColumn SortExpression="Subject,4" ItemStyle-Width="520">
							<HEADERSTYLE CssClass='hStyleOrder'></HEADERSTYLE>
							<ItemTemplate>
								<%# strHeaderTable() %>
								<%# strDraw3ColumnRowTitles("", getlabel("Process.ProcessID"), DBToInt(DataBinder.Eval(Container,"DataItem.OtherProcessID"))  ) %>
								<%# strDraw3ColumnRowTitles("", getlabel("Process.ProcessType"), GetLabel("Process.ProcessType." & DataBinder.Eval(Container,"DataItem.ProcessType")) ) %>
								<%# strDraw3ColumnRowTitles("", getlabel("Process.Classification"), dbtostr(DataBinder.Eval(Container,"DataItem.Classification")) ) %>
								<%# strDraw3ColumnRowTitles("", getlabel("Process.Subject"), dbtostr(DataBinder.Eval(Container,"DataItem.Subject")) ) %>
								<%# strDraw3ColumnRowTitles("", getlabel("Process.FolderID"), dbtostr(DataBinder.Eval(Container,"DataItem.FolderID")) ) %>
								<%# strDraw3ColumnRowTitles("", getlabel("Process.Employee"), dbtostr(DataBinder.Eval(Container,"DataItem.Employee")) ) %>
								<%# strDraw3ColumnRowTitles("", getlabel("Process.InitialDate"), dbtostr(DataBinder.Eval(Container,"DataItem.InitialDate")) ) %>
								<%# strDraw3ColumnRowTitles("", getlabel("Process.FinalDate"), dbtostr(DataBinder.Eval(Container,"DataItem.FinalDate")) ) %>
								<%# strDraw3ColumnRowTitles("", getlabel("Process.User"), dbtostr(DataBinder.Eval(Container,"DataItem.FullName")) ) %>
								<%# strFooterTable() %>
							</ItemTemplate>
						</asp:TemplateColumn>
					</Columns>
				</asp:datagrid>
			</div>
		</td>
	</tr>
	<tr>
		<td class="vertical_spacer2"></td>
	</tr>
</table>
