<%@ Import Namespace ="CRAVDataBaseAccess.mShowItems" %>
<%@ Register TagPrefix="uc1" TagName="ascendantCorrespondence" Src="../ControlsBackOffice/ascendantCorrespondence.ascx" %>
<%@ Control Language="vb" AutoEventWireup="false" Codebehind="correspondenceRelated.ascx.vb" Inherits="CRAVBackOffice.correspondenceRelated" TargetSchema="http://schemas.microsoft.com/intellisense/ie5" %>
<table cellSpacing="0" cellPadding="0" width="600" align="center" border="0">
	<tr>
		<td class="vertical_spacer2"></td>
	</tr>
	<tr>
		<td><asp:repeater id="repMeCorrespondenceIn" Visible="False" Runat="server">
				<HeaderTemplate>
					<%# strHeaderTable() %>
				</HeaderTemplate>
				<ItemTemplate>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.CorrespondenceID"), DataBinder.Eval(Container,"DataItem.ManualEntryExitID") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Type"), getlabel("event." & DataBinder.Eval(Container,"DataItem.EventCode")) ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.TypeEntry"), DataBinder.Eval(Container,"DataItem.TypeEntryExit")  ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.EntryDate"), DataBinder.Eval(Container,"DataItem.EventDate") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.DocumentDate"), DataBinder.Eval(Container,"DataItem.DocumentDate") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Prov"), DataBinder.Eval(Container,"DataItem.ProvDest") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Reference"), DataBinder.Eval(Container,"DataItem.Reference") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Note"), DataBinder.Eval(Container,"DataItem.Note") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Event.Classification"), DataBinder.Eval(Container,"DataItem.Classification") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Event.ProcessID"), DataBinder.Eval(Container,"DataItem.Process.ProcessID") ) %>
				</ItemTemplate>
				<FooterTemplate>
					<%# strFooterTable() %>
				</FooterTemplate>
			</asp:repeater><asp:repeater id="repMeCorrespondenceOut" Visible="False" Runat="server">
				<HeaderTemplate>
					<%# strHeaderTable() %>
				</HeaderTemplate>
				<ItemTemplate>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.EventID"), DataBinder.Eval(Container,"DataItem.ManualEntryExitID") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Type"), getlabel("event." & DataBinder.Eval(Container,"DataItem.EventCode")) ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.TypeExit"), DataBinder.Eval(Container,"DataItem.TypeEntryExit")  ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.ExitDate"), DataBinder.Eval(Container,"DataItem.EventDate") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.YourDate"), DataBinder.Eval(Container,"DataItem.DocumentDate") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Dest"), DataBinder.Eval(Container,"DataItem.ProvDest") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Reference"), DataBinder.Eval(Container,"DataItem.Reference") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Note"), DataBinder.Eval(Container,"DataItem.Note") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Event.Classification"), DataBinder.Eval(Container,"DataItem.Classification") ) %>
					<%# strDraw3ColumnRowTitles("", getlabel("Event.ProcessID"), DataBinder.Eval(Container,"DataItem.Process.ProcessID") ) %>
				</ItemTemplate>
				<FooterTemplate>
					<%# strFooterTable() %>
				</FooterTemplate>
			</asp:repeater>
		</td>
	</tr>
	<tr>
		<td class="vertical_spacer2"></td>
	</tr>
	<tr>
		<td><asp:datagrid id="dgCorrespondenceRelated" Runat="server" cellpadding="5" CellSpacing="1" AllowPaging="False"
				GridLines="None" AutoGenerateColumns="False" DataKeyField="CorrespondenceID" BorderWidth="0"
				Width="100%">
				<Columns>
					<asp:TemplateColumn ItemStyle-VerticalAlign="Top">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
						<HeaderTemplate>
							<asp:ImageButton Runat="server" ID="imbExpandAll" CommandName="ExpandAll" ImageUrl="../Images/plus.gif"
								AlternateText="Expandir tudo" />
						</HeaderTemplate>
						<ItemTemplate>
							<asp:ImageButton Runat="server" ID="imbExpand" CommandName="Expand" ImageUrl="../Images/plus.gif"
								AlternateText="Expandir" />
						</ItemTemplate>
					</asp:TemplateColumn>
					<asp:TemplateColumn ItemStyle-VerticalAlign="Top">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
						<ItemTemplate>
							<asp:ImageButton Runat="server" ID="imbRelationship" CommandName="Relationship" ImageUrl="../Images/relation.jpg"
								AlternateText="Relacionar" />
						</ItemTemplate>
					</asp:TemplateColumn>
					<asp:BoundColumn DataField="ManualEntryExitID" ReadOnly="True" HeaderText="Nmero">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textLeft" HorizontalAlign="Center" VerticalAlign="Top"></ItemStyle>
					</asp:BoundColumn>
					<asp:TemplateColumn ItemStyle-Width="500px">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textLeft"></ItemStyle>
						<ItemTemplate>
							<%# DataBinder.Eval(Container,"DataItem.Subject") %>
							<asp:repeater id="repCorrespondenceIn" Runat="server" Visible="False">
								<HeaderTemplate>
									<%# strHeaderTable() %>
								</HeaderTemplate>
								<ItemTemplate>
									<br>
									<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Type"), getlabel("event." & DataBinder.Eval(Container,"DataItem.EventCode")) ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.TypeEntry"), DataBinder.Eval(Container,"DataItem.TypeEntryExit")  ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.EntryDate"), DataBinder.Eval(Container,"DataItem.EventDate") ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.DocumentDate"), DataBinder.Eval(Container,"DataItem.DocumentDate") ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Prov"), DataBinder.Eval(Container,"DataItem.ProvDest") ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Reference"), DataBinder.Eval(Container,"DataItem.Reference") ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Note"), DataBinder.Eval(Container,"DataItem.Note") ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Event.Classification"), DataBinder.Eval(Container,"DataItem.Classification") ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Event.ProcessID"), DataBinder.Eval(Container,"DataItem.Process.ProcessID") ) %>
								</ItemTemplate>
								<FooterTemplate>
									<%# strFooterTable() %>
								</FooterTemplate>
							</asp:repeater>
							<asp:repeater id="repCorrespondenceOut" Runat="server" Visible="False">
								<HeaderTemplate>
									<%# strHeaderTable() %>
								</HeaderTemplate>
								<ItemTemplate>
									<br>
									<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Type"), getlabel("event." & DataBinder.Eval(Container,"DataItem.EventCode")) ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.TypeExit"), DataBinder.Eval(Container,"DataItem.TypeEntryExit")  ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.ExitDate"), DataBinder.Eval(Container,"DataItem.EventDate") ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.YourDate"), DataBinder.Eval(Container,"DataItem.DocumentDate") ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Dest"), DataBinder.Eval(Container,"DataItem.ProvDest") ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Reference"), DataBinder.Eval(Container,"DataItem.Reference") ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Correspondence.Note"), DataBinder.Eval(Container,"DataItem.Note") ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Event.Classification"), DataBinder.Eval(Container,"DataItem.Classification") ) %>
									<%# strDraw3ColumnRowTitles("", getlabel("Event.ProcessID"), DataBinder.Eval(Container,"DataItem.Process.ProcessID") ) %>
								</ItemTemplate>
								<FooterTemplate>
									<%# strFooterTable() %>
								</FooterTemplate>
							</asp:repeater>
							<table cellpadding="0" cellspacing="0" width="100%" border="0">
								<tr>
									<td>
										<uc1:ascendantCorrespondence id="AscendantCorrespondence" runat="server"></uc1:ascendantCorrespondence>
									</td>
								</tr>
							</table>
							<asp:DataGrid ID="dgAttacheds" cellpadding="4" CellSpacing="1" AllowPaging="False" GridLines="None"
								AutoGenerateColumns="False" DataKeyField="AttachedID" BorderWidth="0" BackColor="#ffffff"
								Width="100%" Runat="server">
								<HeaderStyle CssClass="headerStyle"></HeaderStyle>
								<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
								<Columns>
									<asp:BoundColumn DataField="FileName" HeaderText="Nome" ReadOnly="True"></asp:BoundColumn>
									<asp:BoundColumn DataField="ContentLength" HeaderText="Tamanho" HeaderStyle-Width="150"></asp:BoundColumn>
									<asp:TemplateColumn>
										<ItemTemplate>
											<asp:ImageButton Runat="server" ID="imbOpenAttached" CausesValidation="False" CommandName="OpenAttached"
												ImageUrl="../Images/detalhe1.gif" />
										</ItemTemplate>
									</asp:TemplateColumn>
								</Columns>
							</asp:DataGrid>
						</ItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:datagrid>
		</td>
	</tr>
</table>
