<%@ Control Language="vb" AutoEventWireup="false" Codebehind="reservationRequest.ascx.vb" Inherits="CRAVBackOffice.ReservationRequestDetails" TargetSchema="http://schemas.microsoft.com/intellisense/ie5" %>
<%@ Import Namespace ="CRAVDataBaseAccess.mShowItems" %>
<table width="100%" cellpadding="0" cellspacing="0" border="0">
	<tr>
		<td class="txtMediumB07"><%= Getlabel("resReq.title") %></td>
	</tr>
	<tr>
		<td class="vertical_spacer2"></td>
	</tr>
	<tr>
		<td>
			<asp:Repeater id="repTitles" Runat="server">
				<HeaderTemplate>
					<%# strHeaderTable() %>
				</HeaderTemplate>
				<ItemTemplate>
					<!-- INFORMAO DO UTILIZADOR -->
					<%# strDraw3ColumnRowTitles("", GetLabel("resReq.User.FullName"), DataBinder.Eval(Container,"DataItem.UserInfo.FullName") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("resReq.User.UserID"), DataBinder.Eval(Container,"DataItem.UserInfo.UserID") ) %>
					<!-- INFORMAO DO PEDIDO -->
					<%# strSeparator(1) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("Event.EventID"), DataBinder.Eval(Container,"DataItem.EntryExitID") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("Event.EventDate"), DataBinder.Eval(Container,"DataItem.EventDate") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("resReq.ReserveDate"), DataBinder.Eval(Container,"DataItem.ReserveDate") + " (" + DataBinder.Eval(Container,"DataItem.PartDayDesignation") + ")" ) %>
					<!-- INFORMAO DO DIGITARQ -->
					<%# strSeparator(1) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.Reference"), DataBinder.Eval(Container,"DataItem.DigitarqInfo.Reference") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.UnitTitleF"), DataBinder.Eval(Container,"DataItem.DigitarqInfo.UnitTitleF") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.UnitTitleSF"), DataBinder.Eval(Container,"DataItem.DigitarqInfo.UnitTitleSF") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.UnitTitleSC"), DataBinder.Eval(Container,"DataItem.DigitarqInfo.UnitTitleSC") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.UnitTitleSSC"), DataBinder.Eval(Container,"DataItem.DigitarqInfo.UnitTitleSSC") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.UnitTitleSSSC"), DataBinder.Eval(Container,"DataItem.DigitarqInfo.UnitTitleSSSC") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.UnitTitleSR"), DataBinder.Eval(Container,"DataItem.DigitarqInfo.UnitTitleSR") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.UnitTitleSSR"), DataBinder.Eval(Container,"DataItem.DigitarqInfo.UnitTitleSSR") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.UnitTitleUI"), DataBinder.Eval(Container,"DataItem.DigitarqInfo.UnitTitleUI") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.UnitTitleDC"), DataBinder.Eval(Container,"DataItem.DigitarqInfo.UnitTitleDC") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.UnitTitleD"), DataBinder.Eval(Container,"DataItem.DigitarqInfo.UnitTitleD") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.Dates"), GetDates(DataBinder.Eval(Container,"DataItem.DigitarqInfo")) ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.PhysLoc"), DataBinder.Eval(Container,"DataItem.DigitarqInfo.PhysLoc") ) %>
					<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.AltFormAvail"), DataBinder.Eval(Container,"DataItem.DigitarqInfo.AltFormAvail") ) %>
					<asp:Repeater ID="repDigitalObjectLoc" Runat="server">
						<HeaderTemplate>
							<%# strHeaderDigitalObjectsLoc %>
						</HeaderTemplate>
						<ItemTemplate>
							<%# strDraw3ColumnRowTitles("", GetLabel("DigitarqInfo.DigitalObject"), GetDaoGrp(DataBinder.Eval(Container,"DataItem.DigitalObjectName"),DataBinder.Eval(Container,"DataItem.FileName"),DataBinder.Eval(Container,"DataItem.ArchiveID"),DataBinder.Eval(Container,"DataItem.TopographicalQuota")) ) %>
						</ItemTemplate>
						<FooterTemplate>
							<%# strFooterDigitalObjectsLoc %>
						</FooterTemplate>
					</asp:Repeater>
				</ItemTemplate>
				<FooterTemplate>
					<%# strFooterTable() %>
				</FooterTemplate>
			</asp:Repeater>
		</td>
	</tr>
	<tr>
		<td class="vertical_spacer2"></td>
	</tr>
</table>
