Imports CRAVDataBaseAccess
Imports DigitArq.Utility

Public Class ValidateRequestDetails
    Inherits BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents txbUserID As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbUserFullName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbEventID As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbEventDate As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbReferenceDigitarq As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbRequestSubType As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbRequestSubTypeAux As System.Web.UI.WebControls.TextBox

    Protected WithEvents ddlKindActionPrc As System.Web.UI.WebControls.DropDownList
    Protected WithEvents txbAddress As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbRegion As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbFiliationFather As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbFiliationMather As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbSpouse As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbSeatNumber As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbSeatYear As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbPageNumberPrc As System.Web.UI.WebControls.TextBox


    Protected WithEvents pnlPrc As System.Web.UI.WebControls.Panel
    Protected WithEvents ddlKindActionNot As System.Web.UI.WebControls.DropDownList
    Protected WithEvents txbNotary As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbCartoryNumber As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbLocality As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbParticipantsAction As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbPageNumberNot As System.Web.UI.WebControls.TextBox


    Protected WithEvents pnlNot As System.Web.UI.WebControls.Panel
    Protected WithEvents txbFonds As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbNamesOther As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbTerms As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbDocType As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbLocalities As System.Web.UI.WebControls.TextBox


    Protected WithEvents pnlOther As System.Web.UI.WebControls.Panel
    Protected WithEvents ckblActionReq As System.Web.UI.WebControls.CheckBoxList
    Protected WithEvents ddlTypeReproduction As System.Web.UI.WebControls.DropDownList
    Protected WithEvents rblCert As System.Web.UI.WebControls.RadioButtonList
    Protected WithEvents ddlTypeCertificate As System.Web.UI.WebControls.DropDownList
    Protected WithEvents txbDestination As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbRedutionsCosts As System.Web.UI.WebControls.TextBox
    Protected WithEvents pnlCert As System.Web.UI.WebControls.Panel
    Protected WithEvents txbNumberCopies As System.Web.UI.WebControls.TextBox
    Protected WithEvents pnlRep As System.Web.UI.WebControls.Panel
    Protected WithEvents txbNoteToNext As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbInitialYear As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbInitialMonth As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbInitialDay As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbFinalYear As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbFinalMonth As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbFinalDay As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbAdditionalInformation As System.Web.UI.WebControls.TextBox
    Protected WithEvents cvAdditionalInformation As System.Web.UI.WebControls.CustomValidator
    Protected WithEvents txbNotification As System.Web.UI.WebControls.TextBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private objI As New SQLDataBase
    Private objRepReq As ReproductionRequest

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        If Not Me.Page.IsPostBack Then
            Me.rblCert.Items(0).Text = GetLabel("repReq.certificate.False")
            Me.rblCert.Items(1).Text = GetLabel("repReq.certificate.True")

            Me.ckblActionReq.Items(0).Text = GetLabel("repReq.Search")
            Me.ckblActionReq.Items(1).Text = GetLabel("repReq.Reproduction")

            objRepReq = objI.loadReproductionRequest(Me.Request.QueryString("eid"))

            loadRequestToForm(objRepReq)
        End If
    End Sub

    Private Sub loadRequestToForm(ByVal objRepReq As ReproductionRequest)

        '============ USER INFO ============
        Me.txbUserID.Text = objRepReq.UserInfo.UserID
        Me.txbUserFullName.Text = objRepReq.UserInfo.FullName

        '============ REQUEST INFO ============
        Me.txbEventID.Text = objRepReq.SourceEventID
        Me.txbEventDate.Text = objRepReq.EventDate
        Me.txbReferenceDigitarq.Text = objRepReq.ReferenceDigitarq
        Me.txbNoteToNext.Text = objRepReq.NoteToNext
        Me.txbRequestSubType.Text = objRepReq.RequestSubTypeDesignation
        Me.txbRequestSubTypeAux.Text = objRepReq.RequestSubTypeCode

        Select Case objRepReq.RequestSubTypeCode
            Case ReproductionRequest.eRequestSubType.parochial
                Me.pnlPrc.Visible = True

                objI.loadDdl(Me.ddlKindActionPrc, "KindActionPrcCode", "KindActionPrc", "KindActionPrc")
                If objRepReq.KindActionPrcCode <> "" Then
                    Me.ddlKindActionPrc.SelectedValue = objRepReq.KindActionPrcCode
                End If
                Me.txbAddress.Text = objRepReq.Address
                Me.txbRegion.Text = objRepReq.Region
                Me.txbName.Text = objRepReq.Name
                Me.txbFiliationFather.Text = objRepReq.FiliationFather
                Me.txbFiliationMather.Text = objRepReq.FiliationMather
                Me.txbSpouse.Text = objRepReq.Spouse
                Me.txbSeatNumber.Text = objRepReq.SeatNumber
                Me.txbSeatYear.Text = objRepReq.SeatYear
                Me.txbPageNumberPrc.Text = objRepReq.PageNumberPrc

            Case ReproductionRequest.eRequestSubType.notarial
                Me.pnlNot.Visible = True

                objI.loadDdl(Me.ddlKindActionNot, "KindActionNotCode", "KindActionNot", "KindActionNot")
                If objRepReq.KindActionPrcCode <> "" Then
                    Me.ddlKindActionNot.SelectedValue = objRepReq.KindActionNotCode
                End If
                Me.txbNotary.Text = objRepReq.Notary
                Me.txbCartoryNumber.Text = objRepReq.CartoryNumber
                Me.txbLocality.Text = objRepReq.Locality
                Me.txbParticipantsAction.Text = objRepReq.ParticipantsAction
                Me.txbPageNumberNot.Text = objRepReq.PageNumberNot

            Case ReproductionRequest.eRequestSubType.other
                Me.pnlOther.Visible = True

                Me.txbFonds.Text = objRepReq.Fonds
                Me.txbNamesOther.Text = objRepReq.NamesOther
                Me.txbTerms.Text = objRepReq.TermsWords
                Me.txbDocType.Text = objRepReq.Document
                Me.txbLocalities.Text = objRepReq.Localities

        End Select
        Me.txbAdditionalInformation.Text = objRepReq.AdditionalInformation
        Me.txbInitialYear.Text = DBToYYYY(objRepReq.InitialDate)
        Me.txbInitialMonth.Text = DBToMM(objRepReq.InitialDate)
        Me.txbInitialDay.Text = DBToDD(objRepReq.InitialDate)
        Me.txbFinalYear.Text = DBToYYYY(objRepReq.FinalDate)
        Me.txbFinalMonth.Text = DBToMM(objRepReq.FinalDate)
        Me.txbFinalDay.Text = DBToDD(objRepReq.FinalDate)

        Me.ckblActionReq.Items(0).Selected = Me.objRepReq.SearchValue
        Me.ckblActionReq.Items(1).Selected = Me.objRepReq.ReproductionValue
        objI.loadDdl(Me.ddlTypeReproduction, "TypeReproductionCode", "TypeReproduction", "TypesReproduction")
        If Me.objRepReq.ReproductionValue Then
            Me.ddlTypeReproduction.SelectedValue = objRepReq.TypeReproductionCode
        End If
        Me.rblCert.SelectedValue = BoolToDB(objRepReq.CertificateValue)
        If objRepReq.CertificateValue Then
            Me.pnlCert.Visible = True
            objI.loadDdl(Me.ddlTypeCertificate, "TypeCertificateCode", "TypeCertificate", "TypesCertificate")
            Me.ddlTypeCertificate.SelectedValue = objRepReq.TypeCertificateCode
            Me.txbDestination.Text = objRepReq.Destination
            Me.txbRedutionsCosts.Text = objRepReq.RedutionsCosts
        End If
        Me.txbNumberCopies.Text = objRepReq.NumberCopies

        Me.txbNoteToNext.Text = objRepReq.NoteToNext
        Me.txbNotification.Text = objRepReq.Notification
    End Sub

End Class
