<%@ Control Language="vb" AutoEventWireup="false" Codebehind="buildListServices.ascx.vb" Inherits="CRAVBackOffice.buildListServices" TargetSchema="http://schemas.microsoft.com/intellisense/ie5" %>
<table id="tblMain" cellSpacing="0" cellPadding="0" width="100%" align="center" border="0">
	<tr>
		<td>
			<table cellSpacing="1" cellPadding="2" width="100%" border="0">
				<tr valign="top">
					<td class="txtCenter" width="180"><%=getlabel("BO.buildListServices.lblCategory")%></td>
					<td class="txtCenter" width="180"><%=getlabel("BO.buildListServices.lblService")%></td>
					<td></td>
					<td class="txtCenter" width="80"><%=getlabel("BO.buildListServices.lblUnitPrice")%></td>
					<td class="txtCenter" width="80"><%=getlabel("BO.buildListServices.lblQuantity")%></td>
					<td></td>
					<td class="txtCenter"></td>
				</tr>
				<tr valign="baseline">
					<td align="center"><asp:dropdownlist id="ddlCategories" AutoPostBack="True" CssClass="ddl100" Runat="server"></asp:dropdownlist></td>
					<td align="center"><asp:dropdownlist id="ddlServices" AutoPostBack="True" CssClass="ddl100" Runat="server"></asp:dropdownlist></td>
					<td class="txtAlert"><asp:RequiredFieldValidator id="rfvServices" Runat="server" ControlToValidate="ddlServices" InitialValue="0">!</asp:RequiredFieldValidator></td>
					<td align="center"><asp:Label id="lblUnitPrice" Runat="server"></asp:Label></td>
					<td align="center"><asp:textbox id="txbQuantity" CssClass="txbSmallCenter" Runat="server" MaxLength="4"></asp:textbox></td>
					<td class="txtAlert"><asp:RequiredFieldValidator ControlToValidate="txbQuantity" Runat="server" id="rfvQuantity">!</asp:RequiredFieldValidator></td>
					<td align="right"><asp:linkbutton id="lnkbInsert" CssClass="Button_1" Runat="server" CausesValidation="true" Height="20px"></asp:linkbutton></td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="line"></td>
	</tr>
	<tr>
		<td class="vertical_spacer2"></td>
	</tr>
	<tr>
		<td>
			<asp:datagrid id="dgTasks" Runat="server" Width="100%" BorderWidth="0" DataKeyField="ServiceID"
				AutoGenerateColumns="False" GridLines="None" AllowPaging="False" CellSpacing="1" cellpadding="4">
				<Columns>
					<asp:buttoncolumn buttontype="LinkButton" commandname="Delete" text="<img src='Images/delete.png' alt='Remover Item' border='0'>" 
 HeaderStyle-Width="20">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
					</asp:buttoncolumn>
					<asp:BoundColumn DataField="Category" ReadOnly="True" HeaderStyle-Width="200">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textLeft"></ItemStyle>
					</asp:BoundColumn>
					<asp:BoundColumn DataField="Service" ReadOnly="True" HeaderStyle-Width="200">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textLeft"></ItemStyle>
					</asp:BoundColumn>
					<asp:TemplateColumn HeaderStyle-Width="100">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textRight"></ItemStyle>
						<ItemTemplate>
							<span>
								<%# string.format("{0:0.00}", DataBinder.Eval(Container.DataItem,"UnitPrice")) %>
							</span>
						</ItemTemplate>
					</asp:TemplateColumn>
					<asp:BoundColumn DataField="Quantity" ReadOnly="True" HeaderStyle-Width="80">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
					</asp:BoundColumn>
					<asp:TemplateColumn HeaderStyle-Width="100">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textRight"></ItemStyle>
						<ItemTemplate>
							<span>
								<%# string.format("{0:0.00}", DataBinder.Eval(Container.DataItem,"UnitPrice")*DataBinder.Eval(Container.DataItem,"Quantity")) %>
							</span>
						</ItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:datagrid></td>
	</tr>
	<tr>
		<td>
			<asp:panel id="pnlTotal" Runat="server" Visible="False">
      <TABLE cellSpacing=0 cellPadding=0 width="100%" border=0>
        <TR>
          <TD class=line colSpan=2></TD></TR>
        <TR height=20>
          <TD align=right width=600><%=getlabel("BO.buildListServices.lblTotal")%></TD>
          <TD align=right width=100>
<asp:Label id=lblTotalValue Runat="server" Font-Bold="True"></asp:Label></TD></TR>
        <TR>
          <TD class=line 
  colSpan=2></TD></TR></TABLE>
			</asp:panel>
		</td>
	</tr>
</table>
