Imports System


Public MustInherit Class SQLInterface
    Inherits System.Web.UI.Page

#Region "Digitarq Info"

    MustOverride Function loadDigitarqInfo(ByVal intID As Int64) As DigitarqInfo

    MustOverride Function getCompleteUnitIDFromID(ByVal intID As Int64) As String

    MustOverride Function getIDFromCompleteUnitID(ByVal strReference As String) As Int64

    MustOverride Function getOtherLevel(ByVal strCompleteUnitID As String) As String

#End Region

#Region "Employee"

    'MustOverride Sub validateEmployee(ByVal strUserName As String, ByVal strPassword As String)

    'MustOverride Sub storeEmployee(ByVal objEmployee As Employee)

    ''MustOverride Function validateUpdateEmployee(ByVal strUserName As String) As Boolean

    'MustOverride Function validateStoreEmployee(ByVal strUserName As String) As Boolean

    'MustOverride Function loadEmployee(ByVal strUserName As String) As Employee

    'MustOverride Function loadEmployee(ByVal intEmployeeID As Integer) As Employee

    'MustOverride Sub loadEmployees(ByVal ddl As DropDownList)

    'MustOverride Sub loadEmployees(ByVal dg As DataGrid, ByVal intListType As Integer)

    'MustOverride Sub updateEmployee(ByVal intEmployeeID As Integer, ByVal intProfileID As Integer, ByVal bolActive As Boolean)

    'MustOverride Sub updateEmployee(ByVal intEmployeeID As Integer, ByVal objEmployee As Employee)

    'MustOverride Sub deleteEmployee(ByVal intEmployeeID As Integer)

    'MustOverride Function countEmployees() As Integer

#End Region

#Region "User"

    MustOverride Function validateUser(ByVal strUserName As String, ByVal strPassword As String) As User

    MustOverride Function validateUserByID(ByVal intUserID As Integer, ByVal strPassword As String) As User

    MustOverride Sub updateUser(ByVal objUser As User)

    MustOverride Sub updateUserPassword(ByVal intUserID As Integer, ByVal strPassword As String)

    MustOverride Function storeUser(ByVal objUser As User) As Integer

    MustOverride Function validateStoreUser(ByVal strUserName As String) As Boolean

    MustOverride Function loadUser(ByVal strUserName As String) As User

#End Region

#Region "Profiles"

    MustOverride Sub storeProfile(ByVal strProfileName As String)

    MustOverride Function loadProfiles(ByVal rdbl As RadioButtonList)

    MustOverride Function loadProfiles(ByVal ddl As DropDownList)

    MustOverride Function loadDsProfiles() As DataSet

    MustOverride Function loadDdlProfiles() As DropDownList

    MustOverride Sub deleteProfile(ByVal strProfileID As Integer)

    MustOverride Sub updateProfile(ByVal strProfileID As Integer, ByVal strProfileName As String)

#End Region

#Region "Profile functions"

    'MustOverride Function getProfileFunctions(ByVal intProfile As Integer, ByVal intParentID As Integer) As Hashtable

    'MustOverride Function getProfileSubFunctions(ByVal intProfile As Integer, ByVal intFunctionID As Integer) As Hashtable

    'MustOverride Function getProfileSubSubFunctions(ByVal intProfile As Integer, ByVal intSubFunctionID As Integer) As Hashtable

    'MustOverride Function getAllProfileFunctions(ByVal intProfile As Integer, ByVal intParentID As Integer) As Hashtable

    'MustOverride Function getAllProfileSubFunctions(ByVal intFunctionID As Integer) As Hashtable

    'MustOverride Function getAllProfileSubSubFunctions(ByVal intFunctionID As Integer) As Hashtable

    'MustOverride Function isFunctionOfProfile(ByVal intFunctionID As Integer, ByVal intProfileID As Integer) As Boolean

    'MustOverride Sub updateProfileFunctions(ByVal intPtofileID As Integer, ByVal alstFunctionsID As ArrayList)

#End Region

#Region "Utils"

    MustOverride Sub loadDdl(ByVal ddl As DropDownList, ByVal strDataValueField As String, _
    ByVal strDataTextField As String, ByVal strTable As String, Optional ByVal strStratItem As String = "Selecionar")

#End Region

#Region "Correspondence"

    MustOverride Function storeCorrespondence(ByVal objCI As Correspondence) As Int64()

    MustOverride Function updateCorrespondence(ByVal objCI As Correspondence) As Int64

    MustOverride Sub loadCorrespondenceOutIn(ByVal dg As DataGrid, ByVal intCorrespondenceOutID As Integer)

    MustOverride Function loadCorrespondenceRelated(ByVal intCorrespondenceID As Integer) As DataSet

    'MustOverride Function searchCorrespondence(ByVal intColumnNumber As Integer, ByVal strTerm As String, ByVal intEventType As Integer) As DataSet

    MustOverride Function loadFullCorrespondence(ByVal intCorrespondenceID As Int64) As Correspondence

    MustOverride Function loadCorrespondence(ByVal intCorrespondenceID As Int64) As Correspondence

    MustOverride Function loadAttached(ByVal AttachedID As Integer) As Attached

    MustOverride Sub deleteAttached(ByVal intAttachedID As Integer)

#End Region

#Region "TypesEntryExit"

    MustOverride Sub loadTypesEntryExit(ByVal ddl As DropDownList)

#End Region

#Region "RelationshipInOut"

    MustOverride Sub insertRelationship(ByVal intCorrespondenceID As Integer, ByVal intParentID As Integer)

    MustOverride Sub storeRelationshipInOut(ByVal intInID As Integer, ByVal alstOut As ArrayList)

    MustOverride Sub storeRelationshipOutIn(ByVal intOutID As Integer, ByVal alstIn As ArrayList)

    MustOverride Sub loadRelationshipInOut(ByVal dg As DataGrid, ByVal intCorrespondenceInID As Integer)

    MustOverride Sub loadRelationshipOutIn(ByVal dg As DataGrid, ByVal intCorrespondenceOutID As Integer)

#End Region

#Region "RequestTypes"

    MustOverride Sub loadRequestTypes(ByVal ddl As DropDownList, Optional ByVal SelectedValue As String = "0")

#End Region

#Region "Requests"

    'MustOverride Sub storeRequest(ByVal objConReq As Request)

    MustOverride Function storeConsultationRequest(ByVal objConReq As ConsultationRequest) As Int64()

    MustOverride Function storeReservationRequest(ByVal objResReq As ReservationRequest) As Int64()

    MustOverride Function storeReproductionRequest(ByVal objRepReq As ReproductionRequest) As Int64()

    MustOverride Sub updateConsultationRequest(ByVal objConReq As ConsultationRequest)

    MustOverride Sub updateReservationRequest(ByVal objResReq As ReservationRequest)

    MustOverride Sub updateReproductionRequest(ByVal objRepReq As ReproductionRequest)

    MustOverride Sub updateEvent(ByVal objEvent As Event_)

    MustOverride Sub updateEvent(ByVal eid As Int64, ByVal status As Event_.eStatus, ByVal strEmployeeID As String)

    MustOverride Sub changeStatus(ByVal eid As Int64, ByVal status As Event_.eStatus)

    MustOverride Sub storeNextEvent(ByVal objEvent As Event_, ByVal alNextUserGroups As ArrayList)

    MustOverride Function loadEvent(ByVal intEventID As Int64) As Event_

    MustOverride Function loadRequests(ByVal strRequestTypeCode As String, ByVal intProfileID As Integer) As EventCollection

    MustOverride Function loadRequestsPendentsByProfile(ByVal eEventType As Event_.eEventType, ByVal intProfileID As Integer) As DataSet

    MustOverride Function loadUserRequests(ByVal strRequestTypeCode As String, ByVal intUserID As Integer) As DataSet

    MustOverride Function loadRequests(ByVal strRequestTypeCode As String) As EventCollection

    MustOverride Sub loadRequests(ByVal dg As DataGrid, ByVal strRequestTypeCode As String)

    MustOverride Function loadConsultationRequest(ByVal intRequestID As Int64) As ConsultationRequest

    MustOverride Function loadReservationRequest(ByVal intRequestID As Int64) As ReservationRequest

    MustOverride Function loadReproductionRequest(ByVal intRequestID As Int64) As ReproductionRequest

    MustOverride Function IsAvailable(ByVal strReference As String, ByVal strDate As String, ByVal strPartDay As String) As Boolean

#End Region

#Region "Processes"

    MustOverride Function storeProcess(ByVal objProcess As Process) As Integer()

    MustOverride Function loadProcess(ByVal intProcessID As Integer) As Process

    MustOverride Function updateProcess(ByVal objProcess As Process) As Boolean

    MustOverride Sub deleteProcess(ByVal intProcessID As Integer)

    MustOverride Function loadProcessEvents(ByVal intProcessID As Integer) As DataSet

#End Region

#Region "Emoluments"

    MustOverride Function storeEmolument(ByVal objEmolument As Emolument) As Integer

    MustOverride Function loadEmolument(ByVal intEmolumentID As Integer) As Emolument

    MustOverride Sub deleteEmolument(ByVal intEmolumentID As Int64)

    MustOverride Function getTotalCostEmoluments() As Double

#End Region

#Region "Services"

    MustOverride Sub storeService(ByVal objService As Service)

    MustOverride Function loadServices(ByVal ddl As DropDownList, ByVal intCategoryID As Integer)

    MustOverride Function loadServices(ByVal dg As DataGrid, ByVal intCategoryID As Integer)

    MustOverride Function loadServices(ByVal intCategoryID As Integer) As DataTable

    MustOverride Sub deleteService(ByVal intServiceID As Integer)

    MustOverride Sub updateService(ByVal objService As Service)

#End Region

#Region "Categories"

    MustOverride Sub storeCategory(ByVal strCategoryName As String)

    MustOverride Sub loadCategories(ByVal ddl As DropDownList)

    MustOverride Function loadCategories() As DataSet

    MustOverride Sub updateCategory(ByVal intCategoryID As Integer, ByVal strCategoryname As String)

    MustOverride Sub deleteCategory(ByVal intCategoryID As Integer)

    MustOverride Function countCategories() As Integer

    'MustOverride Function countCats() As Integer

#End Region

#Region "Budgets"

    MustOverride Sub storeTask(ByVal objTask As Task)

    MustOverride Sub updateTask(ByVal objTask As Task)

    MustOverride Function loadTask(ByVal intBudgetID As Int64) As Task

#End Region

#Region "Messages"

    MustOverride Function loadMessages(ByVal ddl As DropDownList, ByVal intCategoryID As Integer)

#End Region

#Region "Notes"

    MustOverride Sub storeNote(ByVal objNote As Note)

    MustOverride Function loadNotes(ByVal intUserID As Integer) As NoteCollection

    MustOverride Sub updateNote(ByVal objNote As Note)

    MustOverride Sub deleteNote(ByVal intCategoryID As Integer)

#End Region

#Region "Messages"

    MustOverride Sub storeMessage(ByVal objMessage As Message)

    MustOverride Function loadMessages() As MessageCollection

    MustOverride Sub updateMessage(ByVal objMessage As Message)

    MustOverride Sub deleteMessage(ByVal intMessageID As Integer)

#End Region

End Class







