Public Class Attached

#Region "Internal Properties (private)"

    Private myAttachedID As Integer
    Private myFileName As String
    Private myAttached As Byte()
    Private myContentType As String
    Private myContentLength As Integer
    Private myRegisterID As Int64

#End Region


#Region "Gets and Sets of Public Properties"

    Public Property AttachedID() As Integer
        Get
            Return myAttachedID
        End Get
        Set(ByVal Value As Integer)
            myAttachedID = Value
        End Set
    End Property

    Public Property Attached() As Byte()
        Get
            Return myAttached
        End Get
        Set(ByVal Value As Byte())
            myAttached = Value
        End Set
    End Property

    Public Property FileName() As String
        Get
            Return myFileName
        End Get
        Set(ByVal Value As String)
            myFileName = Value
        End Set
    End Property

    Public Property ContentType() As String
        Get
            Return myContentType
        End Get
        Set(ByVal Value As String)
            myContentType = Value
        End Set
    End Property

    Public Property ContentLength() As Integer
        Get
            Return myContentLength
        End Get
        Set(ByVal Value As Integer)
            myContentLength = Value
        End Set
    End Property

    Public Property RegisterID() As Int64
        Get
            Return myRegisterID
        End Get
        Set(ByVal Value As Int64)
            myRegisterID = Value
        End Set
    End Property

#End Region

End Class

Public Class AttachedCollection
    Inherits CollectionBase

    Default Public Property Item(ByVal index As Integer) As Attached
        Get
            Return CType(List(index), Attached)
        End Get
        Set(ByVal Value As Attached)
            List(index) = Value
        End Set
    End Property

    Public Function Add(ByVal value As Attached) As Integer
        Return List.Add(value)
    End Function

    Public Function IndexOf(ByVal value As Attached) As Integer
        Return List.IndexOf(value)
    End Function

    Public Sub Insert(ByVal index As Integer, ByVal value As Attached)
        List.Insert(index, value)
    End Sub

    Public Sub Remove(ByVal value As Attached)
        List.Remove(value)
    End Sub

    Public Function Contains(ByVal value As Attached) As Boolean
        Return List.Contains(value)
    End Function

End Class