Public Class Service

    Private myServiceID As Integer
    Private myService As String
    Private myUnitPrice As Double
    Private myCategoryID As Integer


#Region "Constructors"

    Public Sub New()
    End Sub

    Public Sub New(ByVal intServiceID As Integer)
        myServiceID = intServiceID
    End Sub

#End Region


#Region "Properties"

    Property ServiceID() As Integer
        Get
            Return myServiceID
        End Get
        Set(ByVal Value As Integer)
            myServiceID = Value
        End Set
    End Property

    Property Service() As String
        Get
            Return myService
        End Get
        Set(ByVal Value As String)
            myService = Value
        End Set
    End Property

    Property UnitPrice() As Double
        Get
            Return myUnitPrice
        End Get
        Set(ByVal Value As Double)
            myUnitPrice = Value
        End Set
    End Property

    Property CategoryID() As Integer
        Get
            Return myCategoryID
        End Get
        Set(ByVal Value As Integer)
            myCategoryID = Value
        End Set
    End Property

#End Region

End Class


Public Class ServiceCollection
    Inherits CollectionBase

    Default Public Property Item(ByVal index As Integer) As Service
        Get
            Return CType(List(index), Service)
        End Get
        Set(ByVal Value As Service)
            List(index) = Value
        End Set
    End Property

    Public Function Add(ByVal value As Service) As Integer
        Return List.Add(value)
    End Function

    Public Function IndexOf(ByVal value As Service) As Integer
        Return List.IndexOf(value)
    End Function

    Public Sub Insert(ByVal index As Integer, ByVal value As Service)
        List.Insert(index, value)
    End Sub

    Public Sub Remove(ByVal value As Service)
        List.Remove(value)
    End Sub

    Public Function Contains(ByVal value As Service) As Boolean
        Return List.Contains(value)
    End Function

End Class


