Imports System.Globalization
Imports CRAVDataBaseAccess


Public Class buildListServices
    Inherits CRAVDataBaseAccess.BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents tblBudgets As System.Web.UI.WebControls.Table
    Protected WithEvents lnkbDelete As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkbSubmit As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lblRowID As System.Web.UI.WebControls.Label
    Protected WithEvents lblUnitPrice As System.Web.UI.WebControls.Label
    Protected WithEvents txbQuantity As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblCost As System.Web.UI.WebControls.Label
    Protected WithEvents lblTotal As System.Web.UI.WebControls.Label
    Protected WithEvents lblTotalValue As System.Web.UI.WebControls.Label
    Protected WithEvents pnlTotal As System.Web.UI.WebControls.Panel
    Protected WithEvents reQuantity As System.Web.UI.WebControls.RegularExpressionValidator
    Protected WithEvents RequiredFieldValidator1 As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents lnkbInsert As System.Web.UI.WebControls.LinkButton
    Protected WithEvents ddlCategories As System.Web.UI.WebControls.DropDownList
    Protected WithEvents ddlServices As System.Web.UI.WebControls.DropDownList
    Protected WithEvents rfvQuantity As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents dgTasks As System.Web.UI.WebControls.DataGrid

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private objI As New SQLDataBase
    Private myServices As DataTable

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        If Not Me.Page.IsPostBack Then
            DataGridSetup(Services)
        End If
    End Sub

    Private Sub DataGridSetup(ByVal services As DataTable)
        Me.dgTasks.Columns(0).HeaderText = GetLabel("Services.Category")
        Me.dgTasks.Columns(1).HeaderText = GetLabel("Services.Service")
        Me.dgTasks.Columns(2).HeaderText = GetLabel("Services.UnitPrice")
        Me.dgTasks.Columns(3).HeaderText = GetLabel("Services.Quantity")
        Me.dgTasks.Columns(4).HeaderText = GetLabel("Services.Cost")

        Me.dgTasks.DataSource = services
        Me.dgTasks.DataBind()
        Me.lblTotalValue.Text = CStr(Format(GetItemTotal(services), ",##"))
    End Sub

    Private Function GetItemTotal(ByVal dt As DataTable) As Decimal
        Dim intCounter As Integer
        Dim decTotal As Decimal
        Dim objDR As DataRow

        For intCounter = 0 To dt.Rows.Count - 1
            objDR = dt.Rows(intCounter)
            decTotal += (objDR("UnitPrice") * objDR("Quantity"))
        Next

        Return decTotal
    End Function

    '============= PROPERTIES =========================================
    Property Services() As DataTable
        Get
            Return myServices
        End Get
        Set(ByVal Value As DataTable)
            myServices = Value
        End Set
    End Property

End Class
