Imports CRAVDataBaseAccess

Public Class uc_reproductionStep3
    Inherits BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents ddlTypeReproduction As System.Web.UI.WebControls.DropDownList
    Protected WithEvents ddlTypeCertificate As System.Web.UI.WebControls.DropDownList
    Protected WithEvents txtDestination As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtRedutionsCosts As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtNumberCopies As System.Web.UI.WebControls.TextBox
    Protected WithEvents btnCancel As System.Web.UI.WebControls.ImageButton
    Protected WithEvents pnlCert As System.Web.UI.WebControls.Panel
    Protected WithEvents summary As System.Web.UI.WebControls.ValidationSummary
    Protected WithEvents reNumberCopies As System.Web.UI.WebControls.RegularExpressionValidator
    Protected WithEvents rfvNumberCopies As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents rfvTypeCertificate As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents rfvDestination As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents hlnkBack As System.Web.UI.WebControls.HyperLink
    Protected WithEvents lblHeader As System.Web.UI.WebControls.Label
    Protected WithEvents lblTypeReproduction As System.Web.UI.WebControls.Label
    Protected WithEvents lblOtherTypeReproduction As System.Web.UI.WebControls.Label
    Protected WithEvents lblCertificate As System.Web.UI.WebControls.Label
    Protected WithEvents lblTypeCertificate As System.Web.UI.WebControls.Label
    Protected WithEvents lblDestination As System.Web.UI.WebControls.Label
    Protected WithEvents lblRedutionsCosts As System.Web.UI.WebControls.Label
    Protected WithEvents lblNumberCopies As System.Web.UI.WebControls.Label
    Protected WithEvents rblCert As System.Web.UI.WebControls.RadioButtonList
    Protected WithEvents rfvTypeReproduction As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents hlnkCancel As System.Web.UI.WebControls.HyperLink
    Protected WithEvents DigitarqInfo1 As DigitarqInfoUC
    Protected WithEvents bttnNext As System.Web.UI.WebControls.Button

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private objPath As New Path
    Private objI As New SQLDataBase
    'Private strInitialPageUrl As String = ConfigurationSettings.AppSettings("InitialPageUrl")

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here

        If Not IsPostBack Then
            Me.rfvTypeReproduction.ErrorMessage = GetLabel("FO.repReq3.rfvTypeReproduction")
            Me.rfvTypeCertificate.ErrorMessage = GetLabel("FO.repReq3.rfvTypeCertificate")
            Me.rfvDestination.ErrorMessage = GetLabel("FO.repReq3.rfvDestination")
            Me.reNumberCopies.ErrorMessage = GetLabel("FO.repReq3.reNumberCopies")
            Me.rfvNumberCopies.ErrorMessage = GetLabel("FO.repReq3.rfvNumberCopies")

            Me.hlnkBack.Text = GetLabel("lnkbBack")
            Me.hlnkBack.ToolTip = GetLabel("lnkbBack")
            Me.hlnkCancel.Text = GetLabel("lnkbCancel")
            Me.hlnkCancel.ToolTip = GetLabel("lnkbCancel")
            Me.bttnNext.Text = GetLabel("lnkbNext")
            Me.bttnNext.ToolTip = GetLabel("lnkbNext")

            Me.hlnkBack.NavigateUrl = "javascript:history.back();"
            Me.hlnkCancel.NavigateUrl = GetConfig("InitialPageUrl")

            If Me.Request.QueryString("from") = "pesquisa" Then
                Dim id As Int64 = Me.Request.QueryString("regid")
                Dim strReference As String = objI.getCompleteUnitIDFromID(id)

                objPath.From = Path.eFrom.Search
                objPath.OtherLevel = Path.eOtherLevel.DorDC
                objPath.RequestType = objPath.getRequestType(strReference)

                Path = objPath

                Dim objRepReq As New ReproductionRequest
                ReproductionRequest = objRepReq
                ReproductionRequest.RequestSubTypeCode = ReproductionRequest.eRequestSubType.none
                ReproductionRequest.DigitarqInfo = objI.loadDigitarqInfo(id)

                Me.DigitarqInfo1.Visible = True
                Me.DigitarqInfo1.loadDigitarqInfo(ReproductionRequest.DigitarqInfo)
            ElseIf Not ReproductionRequest.DigitarqInfo Is Nothing Then
                Me.DigitarqInfo1.Visible = True
                Me.DigitarqInfo1.loadDigitarqInfo(ReproductionRequest.DigitarqInfo)
            End If

            Me.rblCert.Items(0).Text = GetLabel("FO.repReq3.rblCert0")
            Me.rblCert.Items(1).Text = GetLabel("FO.repReq3.rblCert1")

            objI.loadDdl(Me.ddlTypeCertificate, "TypeCertificateCode", "TypeCertificate", "TypesCertificate")
            objI.loadDdl(Me.ddlTypeReproduction, "TypeReproductionCode", "TypeReproduction", "TypesReproduction")
        End If

    End Sub

    Private Sub rblCert_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rblCert.SelectedIndexChanged
        If Me.rblCert.SelectedValue = "1" Then
            Me.pnlCert.Visible = True
        ElseIf Me.rblCert.SelectedValue = "0" Then
            Me.pnlCert.Visible = False
        End If
    End Sub

    Private Sub bttnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnNext.Click
        If Me.Page.IsValid Then
            loadInfo()
            Me.Response.Redirect("defaultIn.aspx?page=repReq&step=4")
        End If
    End Sub

    Private Sub loadInfo()
        objPath = Path

        ReproductionRequest.ReproductionValue = True

        ReproductionRequest.TypeReproductionCode = Me.ddlTypeReproduction.SelectedValue
        ReproductionRequest.TypeReproduction = Me.ddlTypeReproduction.SelectedItem.Text

        ReproductionRequest.CertificateValue = Me.rblCert.SelectedValue()
        ReproductionRequest.CertificateText = Me.rblCert.SelectedItem.Text
        If Me.rblCert.SelectedValue = "1" Then
            ReproductionRequest.TypeCertificateCode = Me.ddlTypeCertificate.SelectedValue
            ReproductionRequest.TypeCertificate = Me.ddlTypeCertificate.SelectedItem.Text
            ReproductionRequest.Destination = Me.txtDestination.Text
            ReproductionRequest.RedutionsCosts = Me.txtRedutionsCosts.Text
        End If
        ReproductionRequest.NumberCopies = Me.txtNumberCopies.Text

    End Sub

End Class
