Imports System.Globalization
Imports CRAVDataBaseAccess
Imports DigitArq.Utility

Public Class paymentUC
    Inherits BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lnkbPay As System.Web.UI.WebControls.LinkButton
    Protected WithEvents dgTasks As System.Web.UI.WebControls.DataGrid
    Protected WithEvents lblTotalValue As System.Web.UI.WebControls.Label
    Protected WithEvents rblFormsPayment As System.Web.UI.WebControls.RadioButtonList
    Protected WithEvents lblEntity As System.Web.UI.WebControls.Label
    Protected WithEvents lblReference As System.Web.UI.WebControls.Label
    Protected WithEvents pnlMultibanco As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlPostal As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlTransference As System.Web.UI.WebControls.Panel
    Protected WithEvents lblDestEntity As System.Web.UI.WebControls.Label
    Protected WithEvents lblBank As System.Web.UI.WebControls.Label
    Protected WithEvents lblSWIFTCode As System.Web.UI.WebControls.Label
    Protected WithEvents lblIBAN As System.Web.UI.WebControls.Label
    Protected WithEvents lblAcountNumber As System.Web.UI.WebControls.Label
    Protected WithEvents lblTransferenceDestEntity As System.Web.UI.WebControls.Label
    Protected WithEvents lnkbPrint As System.Web.UI.WebControls.HyperLink
    Protected WithEvents hlnkPrint As System.Web.UI.WebControls.HyperLink
    Protected WithEvents txbNotification As System.Web.UI.WebControls.TextBox
    Protected WithEvents bttnClose As System.Web.UI.WebControls.Button
    Protected WithEvents bttnReply As System.Web.UI.WebControls.Button
    Protected WithEvents bttnAcceptBudget As System.Web.UI.WebControls.Button
    Protected WithEvents pnlPayment As System.Web.UI.WebControls.Panel
    Protected WithEvents bttnChooseThisFormPayment As System.Web.UI.WebControls.Button
    Protected WithEvents lblAmount2 As System.Web.UI.WebControls.Label
    Protected WithEvents lblAmount0 As System.Web.UI.WebControls.Label
    Protected WithEvents lblAmount3 As System.Web.UI.WebControls.Label
    Protected WithEvents bttnCreditCardPayment As System.Web.UI.WebControls.Button
    Protected WithEvents Label1 As System.Web.UI.WebControls.Label
    Protected WithEvents Label2 As System.Web.UI.WebControls.Label
    Protected WithEvents Label3 As System.Web.UI.WebControls.Label
    Protected WithEvents pnlCreditCard As System.Web.UI.WebControls.Panel
    Protected WithEvents bttnOpenCreditCardPayment As System.Web.UI.WebControls.Button

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private objIGPU As New DigitArq.Data.Entities.MGUP.SQLDataBase
    Private objI As New SQLDataBase
    Private myServices As DataTable


    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        If Not Me.Page.IsPostBack Then
            Me.hlnkPrint.Text = GetLabel("lnkbPrint")
            Me.hlnkPrint.ToolTip = GetLabel("lnkbPrint")
            Me.hlnkPrint.NavigateUrl = "javascript:PrintThisPage();"
            Me.bttnChooseThisFormPayment.Text = GetLabel("lnkbChooseThisFormPayment")
            Me.bttnChooseThisFormPayment.ToolTip = GetLabel("lnkbChooseThisFormPayment")
            Me.bttnChooseThisFormPayment.BackColor = Color.FromArgb(184, 226, 117)
            Me.bttnAcceptBudget.Text = GetLabel("lnkbAcceptBudget")
            Me.bttnAcceptBudget.ToolTip = GetLabel("lnkbAcceptBudget")
            Me.bttnClose.Text = GetLabel("lnkbExit")
            Me.bttnClose.ToolTip = GetLabel("lnkbExit")
            Me.bttnReply.Text = GetLabel("lnkbReply")
            Me.bttnReply.ToolTip = GetLabel("lnkbReply")
            Me.bttnOpenCreditCardPayment.Text = GetLabel("lnkbOpenCreditCardPayment")
            Me.bttnOpenCreditCardPayment.ToolTip = GetLabel("lnkbOpenCreditCardPayment")

            Dim eid As Int64 = Request.QueryString("eid")
            Dim seid As Int64 = Request.QueryString("seid")

            Dim pendent As Boolean = StrToBool(Request.QueryString("pendent"))
            Dim task As Task
            If pendent Then
                task = objI.loadTask(seid)
                If Dif(task.EventDate.Substring(0, 10)) Then
                    Me.bttnChooseThisFormPayment.Enabled = False
                    Me.bttnReply.Enabled = False
                Else
                    Me.bttnChooseThisFormPayment.Enabled = True
                    Me.bttnReply.Enabled = True
                End If
            Else
                task = objI.loadTask(eid)
                Me.bttnChooseThisFormPayment.Enabled = False
                Me.bttnReply.Enabled = False
            End If

            LoadPaymentForms()

            Me.txbNotification.Text = task.Notification

            ListServices = objI.loadTask(seid).ListServices
            DataGridSetup(ListServices)
        End If
    End Sub

    Private Sub LoadPaymentForms()
        Dim p1 As New ListItem(GetLabel("payment." & Event_.ePayment.ATM), Event_.ePayment.ATM)
        Dim p2 As New ListItem(GetLabel("payment." & Event_.ePayment.Postal), Event_.ePayment.Postal)
        Dim p3 As New ListItem(GetLabel("payment." & Event_.ePayment.Transfer), Event_.ePayment.Transfer)
        Dim p4 As New ListItem(GetLabel("payment." & Event_.ePayment.CreditCard), Event_.ePayment.CreditCard)
        Me.rblFormsPayment.Items.Add(p1)
        Me.rblFormsPayment.Items.Add(p2)
        Me.rblFormsPayment.Items.Add(p3)
        Me.rblFormsPayment.Items.Add(p4)
    End Sub

    Private Sub bttnChooseThisFormPayment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnChooseThisFormPayment.Click
        Dim objTask As Task = objI.loadTask(Me.Request.QueryString("eid"))
        objTask.ListServices = ListServices
        objTask.Notification = Me.txbNotification.Text
        objTask.Type = Task.eType.budget
        objTask.PaymentID = Me.rblFormsPayment.SelectedValue
        objTask.Status = Event_.eStatus.Submited
        objI.updateTask(objTask)

        Dim hash As New Hashtable
        hash.Add("checkPayment", "")
        objTask.getNextEvents(hash, Event_.eEventType.reproductionRequest)

        For Each objEvent As Event_ In objTask.NextEvents
            objI.storeNextEvent(objEvent, objEvent.UserGroups)
        Next
        objTask = Nothing
        ListServices = Nothing

        Select Case Me.rblFormsPayment.SelectedValue
            Case Event_.ePayment.CreditCard
                'Dim userID As String = HttpContext.Current.User.Identity.Name
                'Dim amount As String = Me.lblTotalValue.Text
                'Dim request As String = Me.Request.QueryString("request")
                'Dim process As String = Me.Request.QueryString("process")
                'Me.Page.RegisterStartupScript("OpenPageToPay", "<script>NewWindow('OtherWindows/creditcardPayment.aspx?userID=" & userID & "&request=" & request & "&process=" & process & "&amount=" & amount & "','mywin','600','600','yes','center');</script>")
                'Me.pnlPayment.Visible = False
                Me.bttnChooseThisFormPayment.Enabled = False
                Me.bttnReply.Enabled = False
                Me.bttnOpenCreditCardPayment.Enabled = True
            Case Else
                Response.Redirect(TruncateUrl(Me.Request.Url.ToString))
        End Select
    End Sub

    Private Sub DataGridSetup(ByVal services As DataTable)
        Me.dgTasks.Columns(0).HeaderText = GetLabel("Services.Category")
        Me.dgTasks.Columns(1).HeaderText = GetLabel("Services.Service")
        Me.dgTasks.Columns(2).HeaderText = GetLabel("Services.UnitPrice") & " (&euro;)"
        Me.dgTasks.Columns(3).HeaderText = GetLabel("Services.Quantity")
        Me.dgTasks.Columns(4).HeaderText = GetLabel("Services.Cost") & " (&euro;)"

        Me.dgTasks.DataSource = services
        Me.dgTasks.DataBind()
        Me.lblTotalValue.Text = String.Format("{0:0.00}", GetItemTotal(services))
        'Me.lblTotalValue.Text = CStr(Math.Round(GetItemTotal(services), 2))
        'Me.lblTotalValue.Text = Format(GetItemTotal(services), "0,00")
    End Sub

    Private Function GetItemTotal(ByVal dt As DataTable) As Decimal
        Dim intCounter As Integer
        Dim decTotal As Decimal
        Dim objDR As DataRow

        For intCounter = 0 To dt.Rows.Count - 1
            objDR = dt.Rows(intCounter)
            decTotal += (objDR("UnitPrice") * objDR("Quantity"))
        Next

        Return decTotal
    End Function

    '============= PROPERTIES =========================================
    Property Services() As DataTable
        Get
            Return myServices
        End Get
        Set(ByVal Value As DataTable)
            myServices = Value
        End Set
    End Property

    Private Sub rblFormsPayment_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rblFormsPayment.SelectedIndexChanged
        Select Case Me.rblFormsPayment.SelectedValue
            Case Event_.ePayment.ATM
                Me.hlnkPrint.Visible = True
                Me.bttnChooseThisFormPayment.Visible = True
                Me.pnlMultibanco.Visible = True
                Me.pnlCreditCard.Visible = False
                Me.pnlPostal.Visible = False
                Me.pnlTransference.Visible = False
                Me.lblEntity.Text = GetConfig("Entity.Code")
                Me.lblAmount0.Text = Me.lblTotalValue.Text + " " + GetLabel("FO.payment.lblEuro")
                Dim PadAmount As String = Me.lblTotalValue.Text.Replace(",", "").Replace(".", "").PadLeft(8, "0")
                Dim PadRequest As String = Me.Request.QueryString("request").PadLeft(7, "0")
                Dim CheckDigit As String = calcCheckDigitPol(Me.lblEntity.Text + PadRequest + PadAmount, 22)
                Me.lblReference.Text = PadRequest + CheckDigit

            Case Event_.ePayment.CreditCard
                Me.hlnkPrint.Visible = False
                Me.bttnChooseThisFormPayment.Visible = True
                Me.pnlMultibanco.Visible = False
                Me.pnlCreditCard.Visible = True
                Me.pnlPostal.Visible = False
                Me.pnlTransference.Visible = False
                If Me.bttnChooseThisFormPayment.Enabled Then
                    Me.bttnOpenCreditCardPayment.Enabled = False
                Else
                    Me.bttnOpenCreditCardPayment.Enabled = True
                End If

            Case Event_.ePayment.Postal
                Me.hlnkPrint.Visible = True
                Me.bttnChooseThisFormPayment.Visible = True
                Me.pnlMultibanco.Visible = False
                Me.pnlCreditCard.Visible = False
                Me.pnlTransference.Visible = False
                Me.pnlPostal.Visible = True
                Me.lblDestEntity.Text = GetConfig("Entity.Name") + "<br>" + GetConfig("Entity.Address") + "<br>" + GetConfig("Entity.PostalCode")
                Me.lblAmount2.Text = Me.lblTotalValue.Text + " " + GetLabel("FO.payment.lblEuro")

            Case Event_.ePayment.Transfer
                Me.hlnkPrint.Visible = True
                Me.bttnChooseThisFormPayment.Visible = True
                Me.pnlMultibanco.Visible = False
                Me.pnlCreditCard.Visible = False
                Me.pnlPostal.Visible = False
                Me.pnlTransference.Visible = True
                Me.lblTransferenceDestEntity.Text = GetConfig("Entity.Name") + "<br>" + GetConfig("Entity.Address") + "<br>" + GetConfig("Entity.PostalCode")
                Me.lblBank.Text = GetConfig("Bank.Name") + "<br>" + GetConfig("Bank.Agency") + "<br>" + GetConfig("Bank.Address") + "<br>" + GetConfig("Bank.PostalCode")
                Me.lblSWIFTCode.Text = GetConfig("SWIFTCode")
                Me.lblIBAN.Text = GetConfig("IBAN")
                Me.lblAcountNumber.Text = GetConfig("AcountNumber")
                Me.lblAmount3.Text = Me.lblTotalValue.Text + " " + GetLabel("FO.payment.lblEuro")
        End Select
    End Sub

    Private Function calcCheckDigitPol(ByVal value As String, ByVal len As Integer) As String
        Dim i As Integer
        Dim Wi As Integer
        Dim Ai As String
        Dim P As Integer = 0
        value = value.PadRight(len, "0")
        For i = len To 1 Step -1
            Wi = (10 ^ (i - 1)) Mod 97
            Ai = value.Chars(len - i)
            P += Wi * Ai
        Next
        Dim cd As Integer = 98 - (P Mod 97)
        Return CStr(cd).PadLeft(2, "0")
    End Function

    Private Sub bttnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnClose.Click
        Me.Response.Redirect(Me.Request.Url.ToString + "&op=" + CStr(Event_.eSubmitStatus.ExitWithoutSave))
    End Sub

    Private Sub bttnReply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnReply.Click
        If Me.bttnReply.Text = GetLabel("lnkbReply") Then
            Me.txbNotification.Text = vbNewLine + vbNewLine + vbNewLine + "------------" + vbNewLine + Me.txbNotification.Text
            Me.bttnReply.Text = GetLabel("lnkbSend")
            Me.bttnReply.ToolTip = GetLabel("lnkbSend")
            Me.bttnReply.BackColor = Color.FromArgb(184, 226, 117)
        ElseIf Me.bttnReply.Text = GetLabel("lnkbSend") Then
            Dim objTask As Task = objI.loadTask(Me.Request.QueryString("eid"))
            objTask.ListServices = ListServices
            objTask.Notification = GetNotificationHeader(GetLabel("FO.lblFrom"), objTask.UserInfo.FullName, _
                                  GetLabel("FO.lblDate"), DateToStr(Date.Now), _
                                  Me.txbNotification.Text)
            objTask.Type = Task.eType.budget
            objTask.Status = Event_.eStatus.Submited
            objI.updateTask(objTask)

            Dim hash As New Hashtable
            hash.Add("validateBudget", "")
            objTask.getNextEvents(hash, Event_.eEventType.reproductionRequest)

            For Each objEvent As Event_ In objTask.NextEvents
                objI.storeNextEvent(objEvent, objEvent.UserGroups)
            Next
            objTask = Nothing
            ListServices = Nothing
            Response.Redirect(TruncateUrl(Me.Request.Url.ToString))
        End If
    End Sub

    Private Sub bttnAcceptBudget_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnAcceptBudget.Click
        Me.pnlPayment.Visible = True
    End Sub

    Private Sub bttnOpenCreditCardPayment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnOpenCreditCardPayment.Click
        Dim userID As String = HttpContext.Current.User.Identity.Name

        Dim amount As String = Me.lblTotalValue.Text.ToString.Substring(0, Me.lblTotalValue.Text.Replace(",", ".").LastIndexOf("."))
        Dim amountDec As String = Me.lblTotalValue.Text.ToString.Substring(Me.lblTotalValue.Text.Replace(",", ".").LastIndexOf(".") + 1, Me.lblTotalValue.Text.Length - Me.lblTotalValue.Text.Replace(",", ".").LastIndexOf(".") - 1)

        Dim request As String = Me.Request.QueryString("request")
        Dim process As String = Me.Request.QueryString("process")
        Me.Page.RegisterStartupScript("OpenPageToPay", "<script>NewWindow('OtherWindows/creditCardPayment.aspx?userID=" & userID & "&request=" & request & "&process=" & process & "&amount=" & amount & "&amountDec=" & amountDec & "','mywin','600','600','yes','center');</script>")
        Me.pnlPayment.Visible = False
        'Me.bttnChooseThisFormPayment.Enabled = False
        'Me.bttnReply.Enabled = False
    End Sub

End Class
