<%@ Control Language="vb" AutoEventWireup="false" Codebehind="reproductionBudget.ascx.vb" Inherits="CRAVBackOffice.reproductionBudgetUC" TargetSchema="http://schemas.microsoft.com/intellisense/ie5" %>
<table width="100%" cellpadding="0" cellspacing="0" border="0">
	<tr>
		<td>
			<asp:datagrid id="dgBudgets" Runat="server" Width="100%" BorderWidth="0" DataKeyField="ServiceID"
				AutoGenerateColumns="False" GridLines="None" AllowPaging="False" CellSpacing="1" cellpadding="4">
				<Columns>
					<asp:BoundColumn DataField="Category" ReadOnly="True" HeaderText='Categoria' HeaderStyle-Width="150">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
					</asp:BoundColumn>
					<asp:BoundColumn DataField="Service" ReadOnly="True" HeaderText='Servio' HeaderStyle-Width="150">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
					</asp:BoundColumn>
					<asp:TemplateColumn HeaderText='Preo unitrio' HeaderStyle-Width="70">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
						<ItemTemplate>
							<%# FormatCurrency(DataBinder.Eval(Container.DataItem,"UnitPrice"),2) %>
						</ItemTemplate>
					</asp:TemplateColumn>
					<asp:BoundColumn DataField="Quantity" ReadOnly="True" HeaderText='Quantidade' HeaderStyle-Width="70">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
					</asp:BoundColumn>
					<asp:TemplateColumn HeaderText='Custo' HeaderStyle-Width="100">
						<HeaderStyle CssClass="headerStyle"></HeaderStyle>
						<ItemStyle CssClass="itemStyle_textCenter"></ItemStyle>
						<ItemTemplate>
							<%# FormatCurrency(DataBinder.Eval(Container.DataItem,"UnitPrice")*DataBinder.Eval(Container.DataItem,"Quantity"),2) %>
						</ItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:datagrid>
		</td>
	</tr>
	<tr>
		<td class="vertical_spacer2"></td>
	</tr>
	<tr>
		<td class="Right"><asp:button id="bttnClose" Runat="server" CssClass="Button" Visible="False"></asp:button></td>
	</tr>
	<tr>
		<td class="vertical_spacer2"></td>
	</tr>
</table>
