Namespace MDA
    Public Class DOFile
        Inherits MGOD.DOFile


        Private myProperties As Hashtable


        Public Sub New(ByVal FileName As String, _
                       ByVal OriginalURL As String, _
                       ByVal Format As String, _
                       ByVal Length As Integer)


            Me.HasDissemination = False
            Me.DisseminationURL = Nothing
            Me.ThumbnailURL = Nothing

            Me.Format = Format
            Me.Length = IntToStr(Length)
            Me.MD5 = ""
            Me.Name = FileName
            Me.OriginalURL = OriginalURL

            myProperties = New Hashtable
        End Sub


        Public Sub Add(ByVal PropertyName As String, ByVal PropertyValue As String)
            If Not myProperties.ContainsKey(PropertyName) Then myProperties.Add(PropertyName, PropertyValue)
        End Sub

        ReadOnly Property Properties() As Hashtable
            Get
                Return myProperties
            End Get
        End Property


    End Class


End Namespace
