Imports DigitArq.Data.Entities.MDNP
Imports DigitArq.Definitions.MDNP


Public Class ODDisplay
    Inherits BaseClassP

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents rotateR As System.Web.UI.WebControls.Panel
    Protected WithEvents rotateL As System.Web.UI.WebControls.Panel
    Protected WithEvents hihHeight As System.Web.UI.HtmlControls.HtmlInputHidden
    Protected WithEvents tvDOImages As Microsoft.Web.UI.WebControls.TreeView
    Protected WithEvents lblColor As System.Web.UI.WebControls.Label
    Protected WithEvents lblResolution As System.Web.UI.WebControls.Label
    Protected WithEvents lblDepth As System.Web.UI.WebControls.Label
    Protected WithEvents lblWidth As System.Web.UI.WebControls.Label
    Protected WithEvents lblHeight As System.Web.UI.WebControls.Label
    Protected WithEvents lblSize As System.Web.UI.WebControls.Label
    Protected WithEvents hihUrl As System.Web.UI.HtmlControls.HtmlInputHidden
    Protected WithEvents imgDO As System.Web.UI.WebControls.Image
    Protected WithEvents hidNodeID As System.Web.UI.HtmlControls.HtmlInputHidden
    Protected WithEvents pnlMetadata As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlRotation As System.Web.UI.WebControls.Panel
    Protected WithEvents ibtPrevious As System.Web.UI.WebControls.ImageButton
    Protected WithEvents ibtNext As System.Web.UI.WebControls.ImageButton
    Protected WithEvents Hidden2 As System.Web.UI.HtmlControls.HtmlInputHidden
    Protected WithEvents imgPrevious As System.Web.UI.WebControls.ImageButton
    Protected WithEvents imgCurrent As System.Web.UI.WebControls.Image
    Protected WithEvents imgNext As System.Web.UI.WebControls.ImageButton
    Protected WithEvents rotateRight As System.Web.UI.WebControls.ImageButton
    Protected WithEvents rotateLeft As System.Web.UI.WebControls.ImageButton
    Protected WithEvents lblBitDepth As System.Web.UI.WebControls.Label
    Protected WithEvents print As System.Web.UI.WebControls.ImageButton
    Protected WithEvents download As System.Web.UI.WebControls.ImageButton
    Protected WithEvents pnlViewer As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlHelp As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlButtons As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlPreviewImage As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlVideoPlayer As System.Web.UI.WebControls.Panel
    Protected WithEvents pnlPDFViewer As System.Web.UI.WebControls.Panel
    Protected WithEvents frm As System.Web.UI.HtmlControls.HtmlGenericControl
    Protected WithEvents ifPDFViewer As System.Web.UI.HtmlControls.HtmlGenericControl

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    '*************************************************************************************
    ' Subroutine: Page_Load 
    ' Purpose: Loads the Metadata page, that shows the image and its metadata. This page could 
    '   be in html extension but we are in the ASP.NET world. 
    '   This page is build by frames, it was an ADPRT option (choice).
    '*************************************************************************************
    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private CurrentNode, NextNode, PreviousNode As Microsoft.Web.UI.WebControls.TreeNode


    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If Not IsPostBack Then
            If Me.Request.QueryString("page") = "Help" Then
                Me.pnlViewer.Visible = False
                Me.pnlHelp.Visible = True
            Else
                Me.pnlViewer.Visible = True
                Me.pnlHelp.Visible = False
                Dim DigitalObjectID As String = Me.Request.QueryString("DigitalObjectID")
                LoadTree(DigitalObjectID)
                ShowFile()
            End If
        End If
    End Sub

    Private Sub ShowFile()
        Try
            Dim FileID As String = Me.Request.QueryString("FileID")
            Dim DOFile As New DOImage(FileID.TrimStart("_"), DOImage.Capacities.Description)
            Select Case DOFile.Format
                Case "PDF"
                    Me.pnlMetadata.Visible = False
                    Me.pnlButtons.Visible = False
                    Me.pnlVideoPlayer.Visible = False
                    Me.pnlPDFViewer.Visible = True
                    LoadFile(FileID)
                    ShowPreviewImages()

                Case "DOC"
                    Me.pnlMetadata.Visible = False
                    Me.pnlButtons.Visible = False
                    Me.pnlVideoPlayer.Visible = False
                    Me.pnlPDFViewer.Visible = True
                    LoadFile(FileID)
                    ShowPreviewImages()

                Case "FLV"
                    Me.pnlMetadata.Visible = False
                    Me.pnlButtons.Visible = False
                    Me.pnlVideoPlayer.Visible = True
                    Me.pnlPDFViewer.Visible = False
                    LoadFile(FileID)
                    ShowPlayer()
                    ShowPreviewImages()

                Case "MP3"
                    Me.pnlMetadata.Visible = False
                    Me.pnlButtons.Visible = False
                    Me.pnlVideoPlayer.Visible = True
                    Me.pnlPDFViewer.Visible = False
                    LoadFile(FileID)
                    ShowPlayer()
                    ShowPreviewImages()

                Case "JPG", "JPEG", "PNG", "TIF", "TIFF", "GIF"
                    Me.pnlMetadata.Visible = True
                    Me.pnlButtons.Visible = True
                    Me.pnlVideoPlayer.Visible = False
                    Me.pnlPDFViewer.Visible = False
                    LoadFile(FileID)
                    LoadMetadata(FileID)
                    ShowPreviewImages()
            End Select
        Catch ex As Exception

        End Try
    End Sub

#Region "Load file"

    Private Sub LoadFile(Optional ByVal FileID As String = "")
        If Not FileID.Equals("") Then
            CurrentNode = Nothing
            PreviousNode = Nothing
            NextNode = Nothing
            FindNodeIndex(Me.tvDOImages.Nodes, FileID)
        Else
            Dim DigitalObject As New DigitalObject
            FileID = DigitalObject.GetFirstImage(Me.Request.QueryString("DigitalObjectID"))
        End If

        If Me.Request.QueryString("move") = "previous" Then
            CurrentNode = PreviousNode
            PreviousNode = Nothing
            NextNode = Nothing
            FindNodeIndex(Me.tvDOImages.Nodes, CurrentNode.ID)
        ElseIf Me.Request.QueryString("move") = "next" Then
            CurrentNode = NextNode
            PreviousNode = Nothing
            NextNode = Nothing
            FindNodeIndex(Me.tvDOImages.Nodes, CurrentNode.ID)
        End If
        SelectTreeNode(CurrentNode.GetNodeIndex)
    End Sub

    Private Sub ShowPreviewImages()

        If CurrentNode.Type.Trim = CStr(ImageIndex.FILE_WITH_DISSEMINATION) Or CurrentNode.Type.Trim = CStr(ImageIndex.FILE_WITHOUT_DISSEMINATION) Then
            imgDO.ImageUrl = GetImageURL(CurrentNode.ID, 0, True)
            imgCurrent.ImageUrl = GetImageURL(CurrentNode.ID, 1, True)
            Me.imgCurrent.Visible = True
            imgCurrent.Width = New Unit(100)
        End If

        If Not PreviousNode Is Nothing Then
            Me.ibtPrevious.Visible = False
            If PreviousNode.Type.Trim = CStr(ImageIndex.FILE_WITH_DISSEMINATION) Or PreviousNode.Type.Trim = CStr(ImageIndex.FILE_WITHOUT_DISSEMINATION) Then
                Me.ibtPrevious.Visible = True
                Me.imgPrevious.Visible = True
                Me.imgPrevious.Width = New Unit(100)
                Me.imgPrevious.ImageUrl = GetImageURL(PreviousNode.ID, 1)
            End If
        End If
        If Not NextNode Is Nothing Then
            Me.ibtNext.Visible = False
            If NextNode.Type.Trim = CStr(ImageIndex.FILE_WITH_DISSEMINATION) Or NextNode.Type.Trim = CStr(ImageIndex.FILE_WITHOUT_DISSEMINATION) Then
                Me.ibtNext.Visible = True
                Me.imgNext.Visible = True
                Me.imgNext.ImageUrl = GetImageURL(NextNode.ID, 1)
                Me.imgNext.Width = New Unit(100)
            End If
        End If
    End Sub

    Private Sub FindNodeIndex(ByRef TreeNodeCollection As Microsoft.Web.UI.WebControls.TreeNodeCollection, ByVal ID As String, Optional ByRef Found As Boolean = False)
        Dim i As System.Collections.IEnumerator = TreeNodeCollection.GetEnumerator
        Dim Index As String
        While i.MoveNext
            PreviousNode = CurrentNode
            CurrentNode = i.Current
            If CurrentNode.ID = ID Then
                If CurrentNode.Nodes.Count > 0 Then
                    NextNode = CurrentNode.Nodes.Item(0)
                ElseIf i.MoveNext Then
                    NextNode = i.Current
                End If
                Found = True
                Return
            End If
            If CurrentNode.Nodes.Count > 0 Then
                FindNodeIndex(CurrentNode.Nodes, ID, Found)
                If Found Then Return
            End If
        End While
    End Sub

    Private Sub SelectTreeNode(ByVal Index As String)
        Dim obj As Object = Split(Index, ".")
        Dim i As Integer
        For i = 0 To UBound(obj)
            If i > 0 Then obj(i) = obj(i - 1) + "." + obj(i)
            Me.tvDOImages.GetNodeFromIndex(obj(i)).Expanded = True
            Me.tvDOImages.ToolTip = Me.tvDOImages.GetNodeFromIndex(obj(i)).Text
        Next
        Me.tvDOImages.SelectedNodeIndex = Index
    End Sub

    Private Function GetImageURL(ByVal FileID As String, ByVal ImageType As Integer, Optional ByVal Rotate As Boolean = False) As String
        Me.imgDO.Visible = True
        Dim strImageUrl As String
        If Rotate Then
            strImageUrl = String.Format("./ShowFile.aspx?FileID={0}&Type={1}&Rotate={2}", FileID.TrimStart("_"), ImageType, Me.Request.QueryString("rotate"))
        Else
            strImageUrl = String.Format("./ShowFile.aspx?FileID={0}&Type={1}", FileID.TrimStart("_"), ImageType)
        End If
        Return strImageUrl
    End Function

#End Region

#Region "Load and format tree"

    Private Sub LoadTree(ByVal DigitalObjectID As Int64)

        Dim XMLStructure As New System.Xml.XmlDocument
        Dim DigitalObject As New DigitalObject(DigitalObjectID)

        Dim strStructure As String = String.Format("<?xml version=""1.0"" encoding=""ISO-8859-1"" ?>{0}", DigitalObject.DOStructure)

        XMLStructure.LoadXml(strStructure)
        Me.tvDOImages.TreeNodeSrc = XMLStructure.OuterXml
        Me.tvDOImages.DataBind()

        FormatTree(Me.tvDOImages.Nodes, 0)

        'set styles
        Me.tvDOImages.DefaultStyle = Microsoft.Web.UI.WebControls.CssCollection.FromString("font-family:arial;color:#555555;font-size:11px;")
        Me.tvDOImages.HoverStyle = Microsoft.Web.UI.WebControls.CssCollection.FromString("text-decoration:underline;background-color=#ffffff;color:#555555")
        Me.tvDOImages.SelectedStyle = Microsoft.Web.UI.WebControls.CssCollection.FromString("color:#ff0000;background-color=#ffffff;font-weight:bold;")
    End Sub

    Private Sub FormatTree(ByRef TreeNodeCollection As Microsoft.Web.UI.WebControls.TreeNodeCollection, ByVal count As Integer)
        Dim i As System.Collections.IEnumerator = TreeNodeCollection.GetEnumerator
        Dim index As String
        Dim previousIndex As String
        Dim CurNode As Microsoft.Web.UI.WebControls.TreeNode
        While i.MoveNext
            CurNode = i.Current

            If CurNode.Type = CStr(ImageIndex.FILE_WITH_DISSEMINATION) Or CurNode.Type = CStr(ImageIndex.FILE_WITHOUT_DISSEMINATION) Then
                CurNode.Text = "<span onmouseover=""showFriendInfo('friend_1','" & GetImageURL(CStr(CurNode.ID).TrimStart("_"), 1) & "')"" onmouseout=""hideFriendInfo('friend_1')"" title=""" & CurNode.Text & """>" & CurNode.Text & "</span>"
                CurNode.NavigateUrl = String.Format("ODdisplay.aspx?DigitalObjectID={0}&FileID={1}", Me.Request.QueryString("DigitalObjectID"), CurNode.ID)
                CurNode.ImageUrl = "Images/image.png"
            Else
                count += 1
                CurNode.ID = "DirID" & count
                CurNode.NavigateUrl = String.Format("ODdisplay.aspx?DigitalObjectID={0}&FileID={1}", Me.Request.QueryString("DigitalObjectID"), CurNode.ID)
            End If
            If CurNode.Nodes.Count > 0 Then
                FormatTree(CurNode.Nodes, count)
            End If
        End While
    End Sub

#End Region

#Region "Load file metadata"

    Private Sub LoadMetadata(ByVal FileID As String)
        Me.pnlMetadata.Visible = True
        Dim DOimage As New DOImage(FileID.TrimStart("_"), DOimage.Capacities.Description)
        lblColor.Text = DOimage.ColorSpace
        lblResolution.Text = DOimage.Resolution
        lblBitDepth.Text = DOimage.BitsPerPixel
        lblWidth.Text = DOimage.Width
        lblHeight.Text = DOimage.Height
        lblSize.Text = CStr(Math.Round(CInt(DOimage.Length) / 1024)) + " KB"
        hihHeight.Value = DOimage.Height
    End Sub

#End Region

#Region "Show player"

    Protected Function ShowPlayer() As String
        Dim DOFile As New DOImage(Me.Request.QueryString("FileID").TrimStart("_"), DOImage.Capacities.Description)
        Dim URL As String = DOFile.DisseminationURL.Substring(OBJECTVAULT_STORAGE.Length)
        Dim Provider As String
        If DOFile.Format.Equals("FLV") Then Provider = "video" Else Provider = "sound"

        Dim sb As New System.Text.StringBuilder
        sb.Append("<script type='text/javascript'>")
        sb.Append("var so = new SWFObject('Player/player.swf','mpl','300','240','9');")
        sb.Append("so.addParam('allowscriptaccess','always');")
        sb.Append("so.addParam('wmode','transparent');")
        sb.Append("so.addParam('allowfullscreen','true');")
        sb.Append("so.addVariable('file', '" & String.Format("{0}?GET={1}", OBJECT_VAULT_SERVER_ADDRESS, URL) & "');")
        sb.Append("so.addVariable('autostart', 'true');")
        sb.Append("so.addVariable('provider','" & Provider & "');")
        sb.Append("so.write('jwplayer');")
        sb.Append("</script>")

        Return sb.ToString
    End Function

#End Region
    
#Region "Events"

    Private Sub ibtPrevious_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ibtPrevious.Click
        Response.Redirect(String.Format("ODDisplay.aspx?move=previous&DigitalObjectID={0}&FileID={1}", Me.Request.QueryString("DigitalObjectID"), Me.tvDOImages.GetNodeFromIndex(Me.tvDOImages.SelectedNodeIndex).ID))
    End Sub

    Private Sub ibtNext_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ibtNext.Click
        Response.Redirect(String.Format("ODDisplay.aspx?move=next&DigitalObjectID={0}&FileID={1}", Me.Request.QueryString("DigitalObjectID"), Me.tvDOImages.GetNodeFromIndex(Me.tvDOImages.SelectedNodeIndex).ID))
    End Sub

    Private Sub imgPrevious_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles imgPrevious.Click
        Response.Redirect(String.Format("ODDisplay.aspx?move=previous&DigitalObjectID={0}&FileID={1}", Me.Request.QueryString("DigitalObjectID"), Me.tvDOImages.GetNodeFromIndex(Me.tvDOImages.SelectedNodeIndex).ID))
    End Sub

    Private Sub imgNext_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles imgNext.Click
        Response.Redirect(String.Format("ODDisplay.aspx?move=next&DigitalObjectID={0}&FileID={1}", Me.Request.QueryString("DigitalObjectID"), Me.tvDOImages.GetNodeFromIndex(Me.tvDOImages.SelectedNodeIndex).ID))
    End Sub

    Private Sub rotateRight_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles rotateRight.Click
        Dim rotate As Integer
        If Me.Request.QueryString("rotate") = "" Then
            rotate = 1
        Else
            rotate = Me.Request.QueryString("rotate")
            rotate = rotate + 1
            If rotate > 3 Then
                rotate = 0
            End If
        End If
        Response.Redirect(String.Format("ODDisplay.aspx?DigitalObjectID={0}&FileID={1}&Rotate={2}", Me.Request.QueryString("DigitalObjectID"), Me.tvDOImages.GetNodeFromIndex(Me.tvDOImages.SelectedNodeIndex).ID, CStr(rotate)))
    End Sub

    Private Sub rotateLeft_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles rotateLeft.Click
        Dim rotate As Integer
        If Me.Request.QueryString("rotate") = "" Then
            rotate = 3
        Else
            rotate = Me.Request.QueryString("rotate")
            rotate = rotate - 1
            If rotate < 0 Then
                rotate = 3
            End If
        End If
        Response.Redirect(String.Format("ODDisplay.aspx?DigitalObjectID={0}&FileID={1}&Rotate={2}", Me.Request.QueryString("DigitalObjectID"), Me.tvDOImages.GetNodeFromIndex(Me.tvDOImages.SelectedNodeIndex).ID, CStr(rotate)))
    End Sub

    Private Sub download_Click(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles download.Click
        Dim DOFile As New DOImage(Me.Request.QueryString("FileID").TrimStart("_"), DOImage.Capacities.Image)
        If DOFile.Data Is Nothing Then Return
        Response.Clear()
        Response.AddHeader("Content-Disposition", "attachment; filename=" & DOFile.Name)
        Response.ContentType = String.Format("image/{0}", DOFile.Format)
        Response.BinaryWrite(DOFile.Data)
        Response.Flush()
        Response.Close()
        HttpContext.Current.ApplicationInstance.CompleteRequest()
    End Sub

#End Region

    Private _defaultnode As String

    Public Property DefaultNode() As String
        Get
            Return Me._defaultnode
        End Get
        Set(ByVal Value As String)
            Me._defaultnode = Value
        End Set
    End Property

End Class
