
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.IO
Imports System.Data.SqlClient
Imports CrystalDecisions.CrystalReports.Engine
Imports CrystalDecisions.Shared
Imports System.Threading
Imports System.Text.Encoding
Imports System.Configuration
Imports DigitArq.Data.Entities
Imports DigitArq.Data.Entities.MGOD
Imports DigitArq.UserControls.ProgressDialog
Imports DigitArq.UserControls.ImageButton
Imports DigitArq.Data.Vault.Client
Imports DigitArq.Data.Vault.Utility
Imports DigitArq.Core.Logging
Imports DigitArq.Utility
Imports DigitArq.Definitions.MGOD


Public Class ProjectsForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents miReportDigProjects As System.Windows.Forms.MenuItem
    Friend WithEvents miDOOperators As System.Windows.Forms.MenuItem
    Friend WithEvents BackPanel As System.Windows.Forms.Panel
    Friend WithEvents TabControl As System.Windows.Forms.TabControl
    Friend WithEvents ProjectsTabPage As System.Windows.Forms.TabPage
    Friend WithEvents ProjectsPanel As System.Windows.Forms.Panel
    Friend WithEvents lvwProjects As System.Windows.Forms.ListView
    Friend WithEvents NewProjectButton As System.Windows.Forms.Button
    Friend WithEvents DeleteProjectButton As System.Windows.Forms.Button
    Friend WithEvents OpenProjectButton As System.Windows.Forms.Button
    Friend WithEvents EditProjectButton As System.Windows.Forms.Button
    Friend WithEvents CloseButton As System.Windows.Forms.Button
    Friend WithEvents ButtonsImageList As System.Windows.Forms.ImageList
    Friend WithEvents MainMenu As System.Windows.Forms.MainMenu
    Friend WithEvents ProjectsImageList As System.Windows.Forms.ImageList
    Friend WithEvents ToolTip As System.Windows.Forms.ToolTip
    Friend WithEvents WarningPanel As System.Windows.Forms.Panel
    Friend WithEvents WarningLabel As System.Windows.Forms.Label
    Friend WithEvents miReports As System.Windows.Forms.MenuItem
    Friend WithEvents ProjectsFooterGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents chProjectName As System.Windows.Forms.ColumnHeader
    Friend WithEvents chUsername As System.Windows.Forms.ColumnHeader
    Friend WithEvents chCreationDateTime As System.Windows.Forms.ColumnHeader
    Friend WithEvents chLastUpdateDateTime As System.Windows.Forms.ColumnHeader
    Friend WithEvents chQuantityOfDigitalObjects As System.Windows.Forms.ColumnHeader
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents miGeneDisseminations As System.Windows.Forms.MenuItem
    Friend WithEvents chQuantityOfFiles As System.Windows.Forms.ColumnHeader
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem6 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem10 As System.Windows.Forms.MenuItem
    Friend WithEvents miNewProject As System.Windows.Forms.MenuItem
    Friend WithEvents miEditProject As System.Windows.Forms.MenuItem
    Friend WithEvents miRemoveProject As System.Windows.Forms.MenuItem
    Friend WithEvents miExportAllFiles As System.Windows.Forms.MenuItem
    Friend WithEvents miExportDisseminations As System.Windows.Forms.MenuItem
    Friend WithEvents miExportOriginals As System.Windows.Forms.MenuItem
    Friend WithEvents miExit As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem3 As System.Windows.Forms.MenuItem
    Friend WithEvents miOpenProject As System.Windows.Forms.MenuItem
    Friend WithEvents FolderBrowserDialog As System.Windows.Forms.FolderBrowserDialog
    Friend WithEvents MenuItem4 As System.Windows.Forms.MenuItem
    Friend WithEvents txtSearch As System.Windows.Forms.TextBox
    Friend WithEvents SearchTimer As System.Windows.Forms.Timer
    Friend WithEvents ckbNumberOfItems As System.Windows.Forms.CheckBox
    Friend WithEvents MenuItem9 As System.Windows.Forms.MenuItem
    Friend WithEvents miOrderBy As System.Windows.Forms.MenuItem
    Friend WithEvents miOrderByCreationDateTime As System.Windows.Forms.MenuItem
    Friend WithEvents miOrderByLastUpdateDateTime As System.Windows.Forms.MenuItem
    Friend WithEvents miOrderByName As System.Windows.Forms.MenuItem
    Friend WithEvents ShowItemsTimer As System.Windows.Forms.Timer
    Friend WithEvents txbNumberOfItems As System.Windows.Forms.NumericUpDown
    Friend WithEvents SearchProjectsButton As ImageButton
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(ProjectsForm))
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Me.ButtonsImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.MainMenu = New System.Windows.Forms.MainMenu
        Me.MenuItem2 = New System.Windows.Forms.MenuItem
        Me.miOpenProject = New System.Windows.Forms.MenuItem
        Me.miNewProject = New System.Windows.Forms.MenuItem
        Me.miEditProject = New System.Windows.Forms.MenuItem
        Me.miRemoveProject = New System.Windows.Forms.MenuItem
        Me.MenuItem3 = New System.Windows.Forms.MenuItem
        Me.MenuItem6 = New System.Windows.Forms.MenuItem
        Me.miExportAllFiles = New System.Windows.Forms.MenuItem
        Me.MenuItem4 = New System.Windows.Forms.MenuItem
        Me.miExportOriginals = New System.Windows.Forms.MenuItem
        Me.miExportDisseminations = New System.Windows.Forms.MenuItem
        Me.MenuItem10 = New System.Windows.Forms.MenuItem
        Me.miOrderBy = New System.Windows.Forms.MenuItem
        Me.miOrderByName = New System.Windows.Forms.MenuItem
        Me.miOrderByCreationDateTime = New System.Windows.Forms.MenuItem
        Me.miOrderByLastUpdateDateTime = New System.Windows.Forms.MenuItem
        Me.MenuItem9 = New System.Windows.Forms.MenuItem
        Me.miExit = New System.Windows.Forms.MenuItem
        Me.miReports = New System.Windows.Forms.MenuItem
        Me.miReportDigProjects = New System.Windows.Forms.MenuItem
        Me.miDOOperators = New System.Windows.Forms.MenuItem
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.miGeneDisseminations = New System.Windows.Forms.MenuItem
        Me.ProjectsImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.ToolTip = New System.Windows.Forms.ToolTip(Me.components)
        Me.NewProjectButton = New System.Windows.Forms.Button
        Me.DeleteProjectButton = New System.Windows.Forms.Button
        Me.OpenProjectButton = New System.Windows.Forms.Button
        Me.EditProjectButton = New System.Windows.Forms.Button
        Me.CloseButton = New System.Windows.Forms.Button
        Me.BackPanel = New System.Windows.Forms.Panel
        Me.TabControl = New System.Windows.Forms.TabControl
        Me.ProjectsTabPage = New System.Windows.Forms.TabPage
        Me.ProjectsPanel = New System.Windows.Forms.Panel
        Me.lvwProjects = New System.Windows.Forms.ListView
        Me.chProjectName = New System.Windows.Forms.ColumnHeader
        Me.chQuantityOfDigitalObjects = New System.Windows.Forms.ColumnHeader
        Me.chQuantityOfFiles = New System.Windows.Forms.ColumnHeader
        Me.chUsername = New System.Windows.Forms.ColumnHeader
        Me.chCreationDateTime = New System.Windows.Forms.ColumnHeader
        Me.chLastUpdateDateTime = New System.Windows.Forms.ColumnHeader
        Me.WarningPanel = New System.Windows.Forms.Panel
        Me.txbNumberOfItems = New System.Windows.Forms.NumericUpDown
        Me.ckbNumberOfItems = New System.Windows.Forms.CheckBox
        Me.WarningLabel = New System.Windows.Forms.Label
        Me.ProjectsFooterGroupBox = New System.Windows.Forms.GroupBox
        Me.SearchProjectsButton = New DigitArq.UserControls.ImageButton.ImageButton
        Me.txtSearch = New System.Windows.Forms.TextBox
        Me.FolderBrowserDialog = New System.Windows.Forms.FolderBrowserDialog
        Me.SearchTimer = New System.Windows.Forms.Timer(Me.components)
        Me.ShowItemsTimer = New System.Windows.Forms.Timer(Me.components)
        Me.BackPanel.SuspendLayout()
        Me.TabControl.SuspendLayout()
        Me.ProjectsTabPage.SuspendLayout()
        Me.ProjectsPanel.SuspendLayout()
        Me.WarningPanel.SuspendLayout()
        CType(Me.txbNumberOfItems, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.ProjectsFooterGroupBox.SuspendLayout()
        Me.SuspendLayout()
        '
        'ButtonsImageList
        '
        Me.ButtonsImageList.ImageSize = New System.Drawing.Size(18, 18)
        Me.ButtonsImageList.ImageStream = CType(resources.GetObject("ButtonsImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ButtonsImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'MainMenu
        '
        Me.MainMenu.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem2, Me.miReports, Me.MenuItem1})
        '
        'MenuItem2
        '
        Me.MenuItem2.Index = 0
        Me.MenuItem2.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miOpenProject, Me.miNewProject, Me.miEditProject, Me.miRemoveProject, Me.MenuItem3, Me.MenuItem6, Me.MenuItem10, Me.miOrderBy, Me.MenuItem9, Me.miExit})
        Me.MenuItem2.Text = "&Perfis"
        '
        'miOpenProject
        '
        Me.miOpenProject.Index = 0
        Me.miOpenProject.Text = "&Abrir..."
        '
        'miNewProject
        '
        Me.miNewProject.Index = 1
        Me.miNewProject.Text = "&Novo..."
        '
        'miEditProject
        '
        Me.miEditProject.Index = 2
        Me.miEditProject.Text = "&Editar..."
        '
        'miRemoveProject
        '
        Me.miRemoveProject.Index = 3
        Me.miRemoveProject.Text = "&Remover"
        '
        'MenuItem3
        '
        Me.MenuItem3.Index = 4
        Me.MenuItem3.Text = "-"
        '
        'MenuItem6
        '
        Me.MenuItem6.Index = 5
        Me.MenuItem6.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miExportAllFiles, Me.MenuItem4, Me.miExportOriginals, Me.miExportDisseminations})
        Me.MenuItem6.Text = "&Exportar"
        '
        'miExportAllFiles
        '
        Me.miExportAllFiles.Index = 0
        Me.miExportAllFiles.Text = "&Todos ficheiros"
        '
        'MenuItem4
        '
        Me.MenuItem4.Index = 1
        Me.MenuItem4.Text = "-"
        '
        'miExportOriginals
        '
        Me.miExportOriginals.Index = 2
        Me.miExportOriginals.Text = "&Originais"
        '
        'miExportDisseminations
        '
        Me.miExportDisseminations.Index = 3
        Me.miExportDisseminations.Text = "&Derivadas"
        '
        'MenuItem10
        '
        Me.MenuItem10.Index = 6
        Me.MenuItem10.Text = "-"
        '
        'miOrderBy
        '
        Me.miOrderBy.Index = 7
        Me.miOrderBy.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miOrderByName, Me.miOrderByCreationDateTime, Me.miOrderByLastUpdateDateTime})
        Me.miOrderBy.Text = "Ordenar por"
        '
        'miOrderByName
        '
        Me.miOrderByName.Index = 0
        Me.miOrderByName.Text = "Nome perfil"
        '
        'miOrderByCreationDateTime
        '
        Me.miOrderByCreationDateTime.Checked = True
        Me.miOrderByCreationDateTime.Index = 1
        Me.miOrderByCreationDateTime.Text = "Data criao"
        '
        'miOrderByLastUpdateDateTime
        '
        Me.miOrderByLastUpdateDateTime.Index = 2
        Me.miOrderByLastUpdateDateTime.Text = "ltima actualizao"
        '
        'MenuItem9
        '
        Me.MenuItem9.Index = 8
        Me.MenuItem9.Text = "-"
        '
        'miExit
        '
        Me.miExit.Index = 9
        Me.miExit.Text = "&Sair"
        '
        'miReports
        '
        Me.miReports.Index = 1
        Me.miReports.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miReportDigProjects, Me.miDOOperators})
        Me.miReports.Text = "&Relatrios"
        '
        'miReportDigProjects
        '
        Me.miReportDigProjects.Index = 0
        Me.miReportDigProjects.Text = "&Perfis de incorporao digital..."
        '
        'miDOOperators
        '
        Me.miDOOperators.Index = 1
        Me.miDOOperators.Text = "&Objectos digitais por operador..."
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 2
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miGeneDisseminations})
        Me.MenuItem1.Text = "&Ferramentas"
        '
        'miGeneDisseminations
        '
        Me.miGeneDisseminations.Index = 0
        Me.miGeneDisseminations.Text = "&Gerao de derivadas a partir dos originais"
        '
        'ProjectsImageList
        '
        Me.ProjectsImageList.ImageSize = New System.Drawing.Size(16, 16)
        Me.ProjectsImageList.ImageStream = CType(resources.GetObject("ProjectsImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ProjectsImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'NewProjectButton
        '
        Me.NewProjectButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.NewProjectButton.BackColor = System.Drawing.Color.White
        Me.NewProjectButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.NewProjectButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.NewProjectButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.NewProjectButton.ImageIndex = 0
        Me.NewProjectButton.ImageList = Me.ButtonsImageList
        Me.NewProjectButton.Location = New System.Drawing.Point(8, 13)
        Me.NewProjectButton.Name = "NewProjectButton"
        Me.NewProjectButton.Size = New System.Drawing.Size(76, 25)
        Me.NewProjectButton.TabIndex = 79
        Me.NewProjectButton.Text = "Novo"
        Me.NewProjectButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.ToolTip.SetToolTip(Me.NewProjectButton, "Novo projecto")
        '
        'DeleteProjectButton
        '
        Me.DeleteProjectButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.DeleteProjectButton.BackColor = System.Drawing.Color.White
        Me.DeleteProjectButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.DeleteProjectButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.DeleteProjectButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.DeleteProjectButton.ImageIndex = 1
        Me.DeleteProjectButton.ImageList = Me.ButtonsImageList
        Me.DeleteProjectButton.Location = New System.Drawing.Point(91, 13)
        Me.DeleteProjectButton.Name = "DeleteProjectButton"
        Me.DeleteProjectButton.Size = New System.Drawing.Size(76, 25)
        Me.DeleteProjectButton.TabIndex = 83
        Me.DeleteProjectButton.Text = "Remover"
        Me.DeleteProjectButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.ToolTip.SetToolTip(Me.DeleteProjectButton, "Eliminar projecto")
        '
        'OpenProjectButton
        '
        Me.OpenProjectButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.OpenProjectButton.BackColor = System.Drawing.Color.FromArgb(CType(230, Byte), CType(255, Byte), CType(230, Byte))
        Me.OpenProjectButton.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.OpenProjectButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.OpenProjectButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.OpenProjectButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.OpenProjectButton.ImageIndex = 6
        Me.OpenProjectButton.ImageList = Me.ButtonsImageList
        Me.OpenProjectButton.Location = New System.Drawing.Point(414, 13)
        Me.OpenProjectButton.Name = "OpenProjectButton"
        Me.OpenProjectButton.Size = New System.Drawing.Size(76, 25)
        Me.OpenProjectButton.TabIndex = 80
        Me.OpenProjectButton.Text = "Abrir"
        Me.OpenProjectButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.ToolTip.SetToolTip(Me.OpenProjectButton, "Ver Objectos Digitais")
        '
        'EditProjectButton
        '
        Me.EditProjectButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.EditProjectButton.BackColor = System.Drawing.Color.White
        Me.EditProjectButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.EditProjectButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.EditProjectButton.ForeColor = System.Drawing.Color.Black
        Me.EditProjectButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.EditProjectButton.ImageIndex = 3
        Me.EditProjectButton.ImageList = Me.ButtonsImageList
        Me.EditProjectButton.Location = New System.Drawing.Point(497, 13)
        Me.EditProjectButton.Name = "EditProjectButton"
        Me.EditProjectButton.Size = New System.Drawing.Size(76, 25)
        Me.EditProjectButton.TabIndex = 81
        Me.EditProjectButton.Text = CType(configurationAppSettings.GetValue("btnEdit.Text", GetType(System.String)), String)
        Me.EditProjectButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.ToolTip.SetToolTip(Me.EditProjectButton, "Editar")
        '
        'CloseButton
        '
        Me.CloseButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.CloseButton.BackColor = System.Drawing.Color.White
        Me.CloseButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.CloseButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.CloseButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.CloseButton.ImageIndex = 5
        Me.CloseButton.ImageList = Me.ButtonsImageList
        Me.CloseButton.Location = New System.Drawing.Point(580, 13)
        Me.CloseButton.Name = "CloseButton"
        Me.CloseButton.Size = New System.Drawing.Size(76, 25)
        Me.CloseButton.TabIndex = 82
        Me.CloseButton.Text = CType(configurationAppSettings.GetValue("btnCancel.Text", GetType(System.String)), String)
        Me.CloseButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.ToolTip.SetToolTip(Me.CloseButton, "Fechar")
        '
        'BackPanel
        '
        Me.BackPanel.Controls.Add(Me.TabControl)
        Me.BackPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.BackPanel.Location = New System.Drawing.Point(0, 0)
        Me.BackPanel.Name = "BackPanel"
        Me.BackPanel.Size = New System.Drawing.Size(674, 291)
        Me.BackPanel.TabIndex = 80
        '
        'TabControl
        '
        Me.TabControl.Controls.Add(Me.ProjectsTabPage)
        Me.TabControl.Dock = System.Windows.Forms.DockStyle.Fill
        Me.TabControl.Location = New System.Drawing.Point(0, 0)
        Me.TabControl.Name = "TabControl"
        Me.TabControl.SelectedIndex = 0
        Me.TabControl.Size = New System.Drawing.Size(674, 291)
        Me.TabControl.TabIndex = 0
        '
        'ProjectsTabPage
        '
        Me.ProjectsTabPage.Controls.Add(Me.ProjectsPanel)
        Me.ProjectsTabPage.Controls.Add(Me.ProjectsFooterGroupBox)
        Me.ProjectsTabPage.Location = New System.Drawing.Point(4, 22)
        Me.ProjectsTabPage.Name = "ProjectsTabPage"
        Me.ProjectsTabPage.Size = New System.Drawing.Size(666, 265)
        Me.ProjectsTabPage.TabIndex = 1
        Me.ProjectsTabPage.Text = "Perfis"
        '
        'ProjectsPanel
        '
        Me.ProjectsPanel.Controls.Add(Me.lvwProjects)
        Me.ProjectsPanel.Controls.Add(Me.WarningPanel)
        Me.ProjectsPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.ProjectsPanel.Location = New System.Drawing.Point(0, 0)
        Me.ProjectsPanel.Name = "ProjectsPanel"
        Me.ProjectsPanel.Size = New System.Drawing.Size(666, 221)
        Me.ProjectsPanel.TabIndex = 109
        '
        'lvwProjects
        '
        Me.lvwProjects.AllowColumnReorder = True
        Me.lvwProjects.BackColor = System.Drawing.Color.White
        Me.lvwProjects.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lvwProjects.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chProjectName, Me.chQuantityOfDigitalObjects, Me.chQuantityOfFiles, Me.chUsername, Me.chCreationDateTime, Me.chLastUpdateDateTime})
        Me.lvwProjects.Dock = System.Windows.Forms.DockStyle.Fill
        Me.lvwProjects.FullRowSelect = True
        Me.lvwProjects.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
        Me.lvwProjects.HideSelection = False
        Me.lvwProjects.Location = New System.Drawing.Point(0, 0)
        Me.lvwProjects.Name = "lvwProjects"
        Me.lvwProjects.Size = New System.Drawing.Size(666, 191)
        Me.lvwProjects.SmallImageList = Me.ProjectsImageList
        Me.lvwProjects.StateImageList = Me.ProjectsImageList
        Me.lvwProjects.TabIndex = 109
        Me.lvwProjects.View = System.Windows.Forms.View.Details
        '
        'chProjectName
        '
        Me.chProjectName.Text = "Perfil incorporao"
        Me.chProjectName.Width = 130
        '
        'chQuantityOfDigitalObjects
        '
        Me.chQuantityOfDigitalObjects.Text = "Objectos digitais"
        Me.chQuantityOfDigitalObjects.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.chQuantityOfDigitalObjects.Width = 90
        '
        'chQuantityOfFiles
        '
        Me.chQuantityOfFiles.Text = "Documentos"
        Me.chQuantityOfFiles.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.chQuantityOfFiles.Width = 90
        '
        'chUsername
        '
        Me.chUsername.Text = "Utilizador"
        Me.chUsername.Width = 120
        '
        'chCreationDateTime
        '
        Me.chCreationDateTime.Text = "Data criao"
        Me.chCreationDateTime.Width = 105
        '
        'chLastUpdateDateTime
        '
        Me.chLastUpdateDateTime.Text = "ltima actualizao"
        Me.chLastUpdateDateTime.Width = 105
        '
        'WarningPanel
        '
        Me.WarningPanel.BackColor = System.Drawing.SystemColors.Control
        Me.WarningPanel.Controls.Add(Me.txbNumberOfItems)
        Me.WarningPanel.Controls.Add(Me.ckbNumberOfItems)
        Me.WarningPanel.Controls.Add(Me.WarningLabel)
        Me.WarningPanel.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.WarningPanel.Location = New System.Drawing.Point(0, 191)
        Me.WarningPanel.Name = "WarningPanel"
        Me.WarningPanel.Size = New System.Drawing.Size(666, 30)
        Me.WarningPanel.TabIndex = 0
        '
        'txbNumberOfItems
        '
        Me.txbNumberOfItems.Location = New System.Drawing.Point(620, 5)
        Me.txbNumberOfItems.Maximum = New Decimal(New Integer() {1000, 0, 0, 0})
        Me.txbNumberOfItems.Name = "txbNumberOfItems"
        Me.txbNumberOfItems.Size = New System.Drawing.Size(44, 20)
        Me.txbNumberOfItems.TabIndex = 114
        Me.txbNumberOfItems.Value = New Decimal(New Integer() {10, 0, 0, 0})
        '
        'ckbNumberOfItems
        '
        Me.ckbNumberOfItems.Checked = True
        Me.ckbNumberOfItems.CheckState = System.Windows.Forms.CheckState.Checked
        Me.ckbNumberOfItems.Location = New System.Drawing.Point(484, 4)
        Me.ckbNumberOfItems.Name = "ckbNumberOfItems"
        Me.ckbNumberOfItems.Size = New System.Drawing.Size(148, 24)
        Me.ckbNumberOfItems.TabIndex = 113
        Me.ckbNumberOfItems.Text = "Listar apenas os ltimos"
        '
        'WarningLabel
        '
        Me.WarningLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.WarningLabel.Image = CType(resources.GetObject("WarningLabel.Image"), System.Drawing.Image)
        Me.WarningLabel.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.WarningLabel.Location = New System.Drawing.Point(8, 5)
        Me.WarningLabel.Name = "WarningLabel"
        Me.WarningLabel.Size = New System.Drawing.Size(317, 20)
        Me.WarningLabel.TabIndex = 112
        Me.WarningLabel.Text = "Perfis com objectos digitais que precisam de reviso."
        Me.WarningLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        Me.WarningLabel.Visible = False
        '
        'ProjectsFooterGroupBox
        '
        Me.ProjectsFooterGroupBox.BackColor = System.Drawing.Color.WhiteSmoke
        Me.ProjectsFooterGroupBox.Controls.Add(Me.SearchProjectsButton)
        Me.ProjectsFooterGroupBox.Controls.Add(Me.txtSearch)
        Me.ProjectsFooterGroupBox.Controls.Add(Me.NewProjectButton)
        Me.ProjectsFooterGroupBox.Controls.Add(Me.DeleteProjectButton)
        Me.ProjectsFooterGroupBox.Controls.Add(Me.OpenProjectButton)
        Me.ProjectsFooterGroupBox.Controls.Add(Me.EditProjectButton)
        Me.ProjectsFooterGroupBox.Controls.Add(Me.CloseButton)
        Me.ProjectsFooterGroupBox.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.ProjectsFooterGroupBox.Location = New System.Drawing.Point(0, 221)
        Me.ProjectsFooterGroupBox.Name = "ProjectsFooterGroupBox"
        Me.ProjectsFooterGroupBox.Size = New System.Drawing.Size(666, 44)
        Me.ProjectsFooterGroupBox.TabIndex = 108
        Me.ProjectsFooterGroupBox.TabStop = False
        '
        'SearchProjectsButton
        '
        Me.SearchProjectsButton.BorderColor = System.Drawing.Color.WhiteSmoke
        Me.SearchProjectsButton.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.SearchProjectsButton.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.SearchProjectsButton.ButtonImage = CType(resources.GetObject("SearchProjectsButton.ButtonImage"), System.Drawing.Image)
        Me.SearchProjectsButton.ButtonImageAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.SearchProjectsButton.ButtonShowShadow = True
        Me.SearchProjectsButton.ButtonText = ""
        Me.SearchProjectsButton.ButtonTextAlignment = System.Drawing.ContentAlignment.MiddleCenter
        Me.SearchProjectsButton.ButtonTransparentColor = System.Drawing.Color.Empty
        Me.SearchProjectsButton.HighlightBackgroundColor = System.Drawing.Color.FromArgb(CType(252, Byte), CType(252, Byte), CType(252, Byte))
        Me.SearchProjectsButton.Location = New System.Drawing.Point(356, 14)
        Me.SearchProjectsButton.Name = "SearchProjectsButton"
        Me.SearchProjectsButton.Size = New System.Drawing.Size(24, 24)
        Me.SearchProjectsButton.TabIndex = 86
        Me.SearchProjectsButton.ToolTip = ""
        '
        'txtSearch
        '
        Me.txtSearch.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtSearch.Location = New System.Drawing.Point(174, 17)
        Me.txtSearch.Name = "txtSearch"
        Me.txtSearch.Size = New System.Drawing.Size(176, 20)
        Me.txtSearch.TabIndex = 85
        Me.txtSearch.Text = ""
        '
        'SearchTimer
        '
        Me.SearchTimer.Interval = 2000
        '
        'ShowItemsTimer
        '
        Me.ShowItemsTimer.Interval = 1000
        '
        'ProjectsForm
        '
        Me.AcceptButton = Me.OpenProjectButton
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.White
        Me.ClientSize = New System.Drawing.Size(674, 291)
        Me.Controls.Add(Me.BackPanel)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.KeyPreview = True
        Me.MaximizeBox = False
        Me.Menu = Me.MainMenu
        Me.Name = "ProjectsForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = CType(configurationAppSettings.GetValue("ProjectsForm.Text", GetType(System.String)), String)
        Me.BackPanel.ResumeLayout(False)
        Me.TabControl.ResumeLayout(False)
        Me.ProjectsTabPage.ResumeLayout(False)
        Me.ProjectsPanel.ResumeLayout(False)
        Me.WarningPanel.ResumeLayout(False)
        CType(Me.txbNumberOfItems, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ProjectsFooterGroupBox.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Private properties"

    Private myProjectID As Int64
    Private myProjectName As String
    Private myComboboxConfigArrayList As New ArrayList
    Private SqlCommands As New SqlCommands(USER_LOGON)
    Private myCreatedNewProject As Boolean = False
    Private myProgressDialog As ProgressDialog
    Private SelectedIndex As Integer = 0

    Private Enum Export
        ALL
        DISSEMINATIONS
        ORIGINALS
    End Enum

    Private myExport As Export
    Private myProfileOpened As Boolean = False
    Private myDeleteOriginals As Boolean = False
    Private myOrderBy As String = PROJECTID_FIELD
    Private myLoaded As Boolean = False

#End Region

#Region "Constants"

    Const PROJECTID_FIELD As String = "ProjectID"
    Const PROJECTNAME_FIELD As String = "Name"
    Const CREATIONDATETIME_FIELD As String = "CreationDateTime"
    Const LASTUPDATEDATETIME_FIELD As String = "LastUpdateDateTime"

#End Region

#Region "Form event handlers"

    Private Sub ChooseProject_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        myLoaded = False
        LoadConfiguration()
        LoadData()
    End Sub

    Private Sub ProjectsForm_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        Dim myProgramState As New ProgramState
        myProgramState.NumberOfProjectsChecked = Me.ckbNumberOfItems.Checked
        myProgramState.LastNumberOfProjectsShowed = Me.txbNumberOfItems.Value
        myProgramState.Save()
    End Sub

    Private Sub LoadConfiguration()
        Try
            Dim myProgramState As New ProgramState
            Me.ckbNumberOfItems.Checked = myProgramState.NumberOfProjectsChecked
            Me.txbNumberOfItems.Value = myProgramState.LastNumberOfProjectsShowed
        Catch ex As Exception
        End Try
    End Sub

#End Region

#Region "Properties"

    Public Property ProjectID() As Int64
        Get
            Return myProjectID
        End Get
        Set(ByVal Value As Int64)
            myProjectID = Value
        End Set
    End Property

    Public Property ProjectName() As String
        Get
            Return myProjectName
        End Get
        Set(ByVal Value As String)
            myProjectName = Value
        End Set
    End Property

    Private Property CreatedNewProject() As Boolean
        Get
            Return myCreatedNewProject
        End Get
        Set(ByVal Value As Boolean)
            myCreatedNewProject = Value
        End Set
    End Property

    Property ProfileOpened() As Boolean
        Get
            Return myProfileOpened
        End Get
        Set(ByVal Value As Boolean)
            myProfileOpened = Value
        End Set
    End Property

    Property DeleteOriginals() As Boolean
        Get
            Return myDeleteOriginals
        End Get
        Set(ByVal Value As Boolean)
            myDeleteOriginals = Value
        End Set
    End Property

    Property OrderBy() As String
        Get
            Return myOrderBy
        End Get
        Set(ByVal Value As String)
            myOrderBY = Value
        End Set
    End Property

#End Region

#Region "Menus"

#Region "miProjects"

    Private Sub miOpenProject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miOpenProject.Click
        OpenProject()
    End Sub

    Private Sub miNewProject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miNewProject.Click
        NewProject()
    End Sub

    Private Sub miEditProject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miEditProject.Click
        EditProject()
    End Sub

    Private Sub miRemoveProject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miRemoveProject.Click
        RemoveProjects()
    End Sub

    Private Sub miExportAllFiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miExportAllFiles.Click
        myExport = Export.ALL
        For Each ListViewItem As ListViewItem In Me.lvwProjects.SelectedItems
            If Me.FolderBrowserDialog.ShowDialog() = DialogResult.OK Then
                Me.ProjectID = ListViewItem.Tag
                Me.ProjectName = ListViewItem.Text
                myProgressDialog = New ProgressDialog(True, 1)
                myProgressDialog.Run(New ThreadStart(AddressOf ExportProjectFiles), String.Format(InfoMessage("Files.ExportAllFiles.Title"), Me.ProjectName), 0, ListViewItem.SubItems(2).Text)
            End If
        Next
    End Sub

    Private Sub miExportDisseminations_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miExportDisseminations.Click
        myExport = Export.DISSEMINATIONS
        For Each ListViewItem As ListViewItem In Me.lvwProjects.SelectedItems
            If Me.FolderBrowserDialog.ShowDialog() = DialogResult.OK Then
                Me.ProjectID = ListViewItem.Tag
                Me.ProjectName = ListViewItem.Text
                myProgressDialog = New ProgressDialog(True, 1)
                myProgressDialog.Run(New ThreadStart(AddressOf ExportProjectFiles), String.Format(InfoMessage("Files.ExportDisseminations.Title"), Me.ProjectName), 0, ListViewItem.SubItems(2).Text)
            End If
        Next
    End Sub

    Private Sub miExportOriginals_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miExportOriginals.Click
        myExport = Export.ORIGINALS
        For Each ListViewItem As ListViewItem In Me.lvwProjects.SelectedItems
            If Me.FolderBrowserDialog.ShowDialog() = DialogResult.OK Then
                Me.ProjectID = ListViewItem.Tag
                Me.ProjectName = ListViewItem.Text
                myProgressDialog = New ProgressDialog(True, 1)
                myProgressDialog.Run(New ThreadStart(AddressOf ExportProjectFiles), String.Format(InfoMessage("Files.ExportOriginals.Title"), Me.ProjectName), 0, ListViewItem.SubItems(2).Text)
            End If
        Next
    End Sub

    Private Sub miExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miExit.Click
        CloseProjects()
    End Sub

#End Region

#Region "miEdit"

    'Private Sub EditPD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    Dim formDP As New DigitalizationProfilesForm
    '    formDP.ShowDialog(Me)
    'End Sub

    'Private Sub EditPT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    Dim formTP As New TechnologicalPlataformForm
    '    formTP.ShowDialog(Me)
    'End Sub

    'Private Sub EditLT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    Dim formLP As New LampTypeForm
    '    formLP.ShowDialog(Me)
    'End Sub

    'Private Sub EditIR_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    Dim form As New RevisionIntervalForm
    '    form.ShowDialog(Me)
    'End Sub

    'Private Sub EditMeteringModes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    Dim form As New MeteringModesForm
    '    form.ShowDialog(Me)
    'End Sub

    'Private Sub EditAutoFocus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    Dim form As New AutoFocusForm
    '    form.ShowDialog(Me)
    'End Sub

#End Region

#Region "miReports"


    'Private Sub miReportDigitalizationProfiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    Dim RepDSBuilder As New ReportDataSetBuilder
    '    Dim ReportDataSet As DigitalizationProfilesData = RepDSBuilder.GenerateDPReportData

    '    Dim Report As New DigitalizationProfilesReport
    '    Report.SetDataSource(ReportDataSet)
    '    Dim viewReport As New ReportPreviewForm(Report)
    '    viewReport.Show()
    'End Sub

    'Private Sub miReportPreservationGD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    Dim RepDSBuilder As New ReportDataSetBuilder
    '    Dim ReportDataSet As ReformattingNormsData = RepDSBuilder.GenerateReformattingNormsReportData

    '    Dim Report As New ReformattingNormsReport
    '    Report.SetDataSource(ReportDataSet)
    '    Dim viewReport As New ReportPreviewForm(Report)
    '    viewReport.Show()
    'End Sub

    'Private Sub miReportReformattingMethods_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    Dim RepDSBuilder As New ReportDataSetBuilder
    '    Dim ReportDataSet As ReformattingMethodsData = RepDSBuilder.GenerateReformattingMethodsReportData

    '    Dim Report As New ReformattingMethodsReport
    '    Report.SetDataSource(ReportDataSet)
    '    Dim viewReport As New ReportPreviewForm(Report)
    '    viewReport.Show()
    'End Sub

    Private Sub miReportDigProjects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miReportDigProjects.Click
        'myProgressDialog = New ProgressDialog.ProgressDialog(False)
        'myProgressDialog.ShowTimeToEnd = True
        'myProgressDialog.Text = "A gerar relatrio..."
        ''myProgressDialog.MinimumValue = 0
        ''myProgressDialog.MaximumValue = myDOFileCollection.Count
        'myProgressDialog.ShowDialog()

        'Dim Thread As Thread = New Thread(New ThreadStart(AddressOf GenerateDigitalizationProjectsReport))
        'Thread.Start()

        'While Thread.IsAlive
        '    System.Windows.Forms.Application.DoEvents()
        'End While

        'myProgressDialog.Hide()
        'myProgressDialog.Close()
        'myProgressDialog.Dispose()
        GenerateDigitalizationProjectsReport()
    End Sub

    Private Sub GenerateDigitalizationProjectsReport()
        Dim RepDSBuilder As New ReportDataSetBuilder
        Dim ReportDataSet As ProjectsData = RepDSBuilder.GenerateDigitalizationProjectsReportData(Me.lvwProjects.SelectedItems)

        Dim Report As New ProjectsReport
        Report.SetDataSource(ReportDataSet)
        Dim viewReport As New ReportPreviewForm(Report)
        viewReport.Show()
    End Sub



    Private Sub miDOOperators_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miDOOperators.Click
        Dim RepDSBuilder As New ReportDataSetBuilder
        Dim ReportDataSet As DOOperatorsData = RepDSBuilder.GenerateDOOperatorsReportData(Me.lvwProjects.SelectedItems)

        Dim Report As New OperatorsReport
        Report.SetDataSource(ReportDataSet)
        Dim viewReport As New ReportPreviewForm(Report)
        viewReport.Show()
    End Sub

#End Region

#Region "miTools"

    Private Sub miGeneDisseminations_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miGeneDisseminations.Click
        For Each ListViewItem As ListViewItem In Me.lvwProjects.SelectedItems
            Me.ProjectID = ListViewItem.Tag
            Me.ProjectName = ListViewItem.Text
            myProgressDialog = New ProgressDialog(False, 1)
            myProgressDialog.Run(New ThreadStart(AddressOf GeneDisseminations), InfoMessage("GeneDisseminations.ProgressTitle"), 0, ListViewItem.SubItems(2).Text)
        Next
    End Sub

#End Region

#Region "miHelp"

    Private Sub About_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim form As New AboutForm
        form.ShowDialog(Me)
    End Sub

#End Region


#End Region

#Region "Create Projects Listview"

    Private Sub CreateLvwProjects()
        Me.lvwProjects.View = View.Details
        Me.lvwProjects.LabelEdit = False
        Me.lvwProjects.FullRowSelect = True
        Me.lvwProjects.MultiSelect = False

        ' Create columns for the items and subitems.
        Me.lvwProjects.Columns.Add("Designao", 200, HorizontalAlignment.Left)
        Me.lvwProjects.Columns.Add("", 30, HorizontalAlignment.Right)
        Me.lvwProjects.Columns.Add("Responsvel", 120, HorizontalAlignment.Left)
        Me.lvwProjects.Columns.Add("Data criao", 100, HorizontalAlignment.Left)
        Me.lvwProjects.Columns.Add("ltima alterao", 100, HorizontalAlignment.Left)
    End Sub

#End Region

#Region "Load data"

    Public Sub LoadData(Optional ByVal ProjectCollection As ProjectCollection = Nothing)
        Me.Cursor = Cursors.WaitCursor
        Dim ProjectsToCheck As ArrayList = SqlCommands.SelectProjectsToCheck

        If ProjectCollection Is Nothing Then
            Dim TopValue As Integer
            Dim Order As String
            If Me.ckbNumberOfItems.Checked AndAlso IsInteger(Me.txbNumberOfItems.Value) Then
                TopValue = Me.txbNumberOfItems.Value
                Order = "DESC"
            Else
                TopValue = 0
                Order = "ASC"
            End If
            ProjectCollection = SqlCommands.SelectProjects(TopValue, OrderBy, Order)
        End If
        Me.lvwProjects.Items.Clear()
        For Each Project As Project In ProjectCollection
            Dim lvi As ListViewItem = New ListViewItem(Project.Name)
            lvi.SubItems.Add(Project.DigitalObjectsCount)
            lvi.SubItems.Add(SqlCommands.SelectCountProjectFiles(Project.ProjectID))
            lvi.SubItems.Add(Project.Username)
            lvi.SubItems.Add(Project.CreationDateTime)
            lvi.SubItems.Add(Project.LastUpdateDateTime)

            lvi.Tag = Project.ProjectID
            Me.lvwProjects.Items.Add(lvi)
            If ProjectsToCheck.Contains(Project.ProjectID) Then
                lvi.ImageIndex = 0
                Me.WarningLabel.Visible = True
            End If
        Next
        If Me.lvwProjects.Items.Count > 0 Then
            Me.EditProjectButton.Enabled = True
            Me.DeleteProjectButton.Enabled = True
            Me.OpenProjectButton.Enabled = True
            Me.lvwProjects.Items(Me.SelectedIndex).Selected = True
        Else
            Me.EditProjectButton.Enabled = False
            Me.DeleteProjectButton.Enabled = False
            Me.OpenProjectButton.Enabled = False
        End If
        SetFormTitle()
        Format()
        myLoaded = True
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub SetFormTitle()
        If Me.lvwProjects.Items.Count = 0 Then Return
        Me.Text = String.Format("{0} [{1}]", ConfigurationSettings.AppSettings("ProjectsForm.Text"), Me.lvwProjects.Items.Count)
    End Sub

    Private Sub Format()
        Dim UserProfile As String = (New MGUP.SQLDataBase).getProfile(DigitArq.Definitions.MGOD.USER_LOGON, ConfigurationSettings.AppSettings("Application.Code")).Profile
        Dim AdminProfile As String = ConfigurationSettings.AppSettings("Profile.Administrator")
        Dim RevisorProfile As String = ConfigurationSettings.AppSettings("Profile.Revisor")

        Me.miExportAllFiles.Enabled = UserProfile = AdminProfile
        Me.miExportOriginals.Enabled = UserProfile = AdminProfile
    End Sub

    Private Sub ckbNumberOfItems_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckbNumberOfItems.CheckedChanged
        Me.txbNumberOfItems.Enabled = Me.ckbNumberOfItems.Checked
        If myLoaded Then LoadData()
    End Sub

    Private Sub miOrderByName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miOrderByName.Click
        If Not Me.miOrderByName.Checked Then
            Me.miOrderByName.Checked = True
            Me.miOrderByCreationDateTime.Checked = False
            Me.miOrderByLastUpdateDateTime.Checked = False
            Me.OrderBy = PROJECTNAME_FIELD
            LoadData()
        End If
    End Sub

    Private Sub miOrderByCreationDateTime_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miOrderByCreationDateTime.Click
        If Not Me.miOrderByCreationDateTime.Checked Then
            Me.miOrderByCreationDateTime.Checked = True
            Me.miOrderByName.Checked = False
            Me.miOrderByLastUpdateDateTime.Checked = False
            Me.OrderBy = CREATIONDATETIME_FIELD
            LoadData()
        End If
    End Sub

    Private Sub miOrderByLastUpdateDateTime_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miOrderByLastUpdateDateTime.Click
        If Not Me.miOrderByLastUpdateDateTime.Checked Then
            Me.miOrderByLastUpdateDateTime.Checked = True
            Me.miOrderByName.Checked = False
            Me.miOrderByCreationDateTime.Checked = False
            Me.OrderBy = LASTUPDATEDATETIME_FIELD
            LoadData()
        End If
    End Sub

    Private Sub txbNumberOfItems_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txbNumberOfItems.ValueChanged
        ShowItemsTimer.Enabled = True
        ShowItemsTimer.Start()
    End Sub

    Private Sub txbNumberOfItems_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txbNumberOfItems.TextChanged
        ShowItemsTimer.Enabled = True
        ShowItemsTimer.Start()
        Dim value As Integer = Me.txbNumberOfItems.Value
    End Sub

    Private Sub ShowItemsTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowItemsTimer.Tick
        If Me.lvwProjects.Items.Count <> Me.txbNumberOfItems.Value Then LoadData()
        ShowItemsTimer.Enabled = False
        ShowItemsTimer.Stop()
    End Sub

#End Region

#Region "ListView event handlers"

    Private Sub lvwProjects_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvwProjects.SelectedIndexChanged
        If Me.lvwProjects.SelectedItems.Count > 0 Then
            Me.ProjectID = Me.lvwProjects.SelectedItems(0).Tag
            Me.ProjectName = Me.lvwProjects.SelectedItems(0).Text
        End If
    End Sub

    Private Sub lvwProjects_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvwProjects.DoubleClick
        Me.DialogResult = DialogResult.OK
        OpenProject()
    End Sub

#End Region

#Region "Buttons event handlers"

    Private Sub NewProjectButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewProjectButton.Click
        NewProject()
    End Sub

    Private Sub DeleteProjectButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteProjectButton.Click
        RemoveProjects()
    End Sub

    Private Sub SearchProjectsButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SearchProjectsButton.Click
        SearchProjects()
    End Sub

    Private Sub OpenProjectButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenProjectButton.Click
        OpenProject()
    End Sub

    Private Sub EditProjectButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EditProjectButton.Click
        EditProject()
    End Sub

    Private Sub CloseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CloseButton.Click
        CloseProjects()
    End Sub

    Private Sub OpenProject()
        If Me.lvwProjects.SelectedItems.Count > 0 Then
            Me.Close()
        End If
    End Sub

    Private Sub NewProject()
        Me.Cursor = Cursors.WaitCursor
        Me.Enabled = False

        Dim NewProjectForm As New NewProjectForm
        If NewProjectForm.ShowDialog() = DialogResult.OK Then
            LoadData()
        End If

        Me.Cursor = Cursors.Default
        Me.Enabled = True
    End Sub

    Private Sub EditProject()
        Me.Cursor = Cursors.WaitCursor
        Me.Enabled = False

        Me.SelectedIndex = Me.lvwProjects.SelectedItems(0).Index
        Dim Project As Project = SqlCommands.SelectProject(Me.ProjectID)
        Dim NewProjectForm As New NewProjectForm(Project)
        If NewProjectForm.ShowDialog() = DialogResult.OK Then
            LoadData()
        End If

        Me.Cursor = Cursors.Default
        Me.Enabled = True
    End Sub

    Private Sub RemoveProjects()
        If MessageBox.Show(InfoMessage("Projects.DeleteSelectedProjects.Confirm"), _
                                InfoMessage("Projects.Delete.ConfirmTitle"), MessageBoxButtons.YesNo, _
                                MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2) = DialogResult.No Then
            Exit Sub
        End If
        For Each ListViewItem As ListViewItem In Me.lvwProjects.SelectedItems
            Me.ProjectID = ListViewItem.Tag
            Me.ProjectName = ListViewItem.Text
            If MessageBox.Show(String.Format(InfoMessage("Projects.DeleteProject.Confirm"), Me.ProjectName), InfoMessage("Projects.Delete.ConfirmTitle"), MessageBoxButtons.YesNo, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2) = DialogResult.Yes Then
                Dim UserProfile As String = (New MGUP.SQLDataBase).getProfile(USER_LOGON, ConfigurationSettings.AppSettings("Application.Code")).Profile
                Dim AdminProfile As String = ConfigurationSettings.AppSettings("Profile.Administrator")
                If UserProfile = AdminProfile Then
                    Dim MsgBoxResult As MsgBoxResult = MsgBox("Deseja eliminar, alm das derivadas, todos os documentos originais associados ao objecto digital?", MsgBoxStyle.Exclamation Or MsgBoxStyle.YesNoCancel Or MsgBoxStyle.DefaultButton2)
                    Select Case MsgBoxResult
                        Case MsgBoxResult.Cancel
                            Return
                        Case MsgBoxResult.Yes
                            DeleteOriginals = True
                        Case MsgBoxResult.No
                            DeleteOriginals = False
                    End Select
                Else
                    DeleteOriginals = False
                End If
                myProgressDialog = New ProgressDialog(False)
                myProgressDialog.Run(New ThreadStart(AddressOf DeleteProject), InfoMessage("Delete.ProgressTitle"), 0, ListViewItem.SubItems(2).Text)
            End If
            LoadData()
        Next
    End Sub

    Private Sub CloseProjects()
        Dim Project As Project = SqlCommands.SelectProject(Me.ProjectID)
        If Me.ProfileOpened Then
            Me.Close()
        Else
            If MsgBox(InfoMessage("Projects.Close"), MsgBoxStyle.YesNo Or MsgBoxStyle.Question Or MsgBoxStyle.DefaultButton2) = MsgBoxResult.Yes Then
                Application.Exit()
            End If
        End If
    End Sub

    Private Sub SearchProjects()
        Me.Cursor = Cursors.WaitCursor
        Me.Enabled = False

        Dim FindDOForm As New FindProjectForm
        FindDOForm.ShowDialog(Me)

        Me.Cursor = Cursors.Default
        Me.Enabled = True
    End Sub

    Private Sub txtSearch_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSearch.TextChanged
        SearchTimer.Enabled = True
        SearchTimer.Start()
    End Sub

    Private Sub SearchTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SearchTimer.Tick
        Dim StrCommand As String
        Dim ProjectCollection As ProjectCollection
        Dim prequery As String = "SELECT P.Name, P.ProjectID, P.Description, P.CreationDateTime, " & _
                        "P.LastUpdateDateTime, P.Username, Count(DO.DigitalObjectID) AS DOCount FROM Projects P " & _
                        "LEFT JOIN DigitalObjects DO ON DO.ProjectID=P.ProjectID "

        Dim posquery As String = "GROUP BY P.Name, P.ProjectID, P.Description, P.CreationDateTime, P.LastUpdateDateTime, P.Username " & _
                        "ORDER BY P.ProjectID DESC"

        StrCommand = String.Format("WHERE P.UserName LIKE '%{0}%' " & _
                               "OR P.Name LIKE '%{1}%'", _
                               Me.txtSearch.Text, Me.txtSearch.Text)
        strCommand = prequery + strCommand + posquery

        ProjectCollection = SqlCommands.SelectProjects(StrCommand)
        LoadData(ProjectCollection)

        SearchTimer.Enabled = False
        SearchTimer.Stop()
    End Sub

#End Region

#Region "DELETE Project"

    Private Sub DeleteProject()
        myProgressDialog.Message = String.Format(InfoMessage("Delete.Project"), Me.ProjectName)
        Dim DigitalObjectCollection As DigitalObjectCollection = SqlCommands.SelectDigitalObjects(ProjectID)
        For Each DigitalObject As DigitalObject In DigitalObjectCollection
            DeleteDigitalObject(DigitalObject, DeleteOriginals)
        Next
        SqlCommands.DeleteProject(Me.ProjectID)
        Logger.Append(USER_LOGON, Logger.RemoveNode, String.Format(LogMessage("Log.DeleteProject"), Me.ProjectName))
        myProgressDialog.Increment()
    End Sub

    Private Sub DeleteDigitalObject(ByVal DigitalObject As DigitalObject, Optional ByVal DeleteOriginals As Boolean = False)
        myProgressDialog.Message = String.Format(InfoMessage("Delete.DigitalObject"), DigitalObject.Name)
        Dim DOFileCollection As DOFileCollection = SqlCommands.SelectFiles(DigitalObject.DigitalObjectID)
        For Each DOFile As DOFile In DOFileCollection
            DeleteDOFile(DOFile, DeleteOriginals)
        Next
        SqlCommands.DeleteDigitalObject(DigitalObject.DigitalObjectID)
        Logger.Append(USER_LOGON, Logger.RemoveNode, String.Format(LogMessage("Log.DeleteDigitalObject"), DigitalObject.Name))
        myProgressDialog.Increment()
    End Sub

    Private Function DeleteDOFile(ByVal DOFile As DOFile, Optional ByVal DeleteOriginals As Boolean = False) As Boolean
        myProgressDialog.Message = String.Format(InfoMessage("Delete.File"), DOFile.Name)
        If DeleteOriginals Then DeleteOriginal(DOFile)
        DeleteDissemination(DOFile)
        DeleteThumbnail(DOFile)
        SqlCommands.DeleteFile(DOFile.ID)
        Logger.Append(USER_LOGON, Logger.RemoveNode, String.Format(LogMessage("Log.DeleteFile"), DOFile.Name))
        myProgressDialog.Increment()
    End Function

    Private Function DeleteOriginal(ByVal DOfile As DOFile) As Boolean
        If DOfile.OriginalURL.StartsWith(FILE_STORAGE) Then
            Try
                Dim FileName As String = DOfile.OriginalURL.Substring(FILE_STORAGE.Length)
                If File.Exists(FileName) Then
                    File.Delete(FileName)
                End If
            Catch ex As Exception
            End Try
        ElseIf DOfile.OriginalURL.StartsWith(OBJECTVAULT_STORAGE) Then
            Try
                Dim ID As String = DOfile.OriginalURL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Return Vault.Delete(ID)
            Catch ex As Exception
            End Try
        ElseIf DOfile.OriginalURL.StartsWith(SQLSERVER_STORAGE) Then
            Try
                Dim ID As String = DOfile.OriginalURL.Substring(SQLSERVER_STORAGE.Length)
                Return SqlCommands.DeleteBLOB(ID)
            Catch ex As Exception
            End Try
        End If
    End Function

    Private Function DeleteDissemination(ByVal DOfile As DOFile) As Boolean
        If DOfile.DisseminationURL.StartsWith(OBJECTVAULT_STORAGE) Then
            Try
                Dim ID As String = DOfile.DisseminationURL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Vault.Delete(ID)
            Catch ex As Exception
            End Try
        ElseIf DOfile.DisseminationURL.StartsWith(SQLSERVER_STORAGE) Then
            Try
                Dim ID As String = DOfile.DisseminationURL.Substring(SQLSERVER_STORAGE.Length)
                SqlCommands.DeleteBLOB(ID)
            Catch ex As Exception
            End Try
        End If
    End Function

    Private Function DeleteThumbnail(ByVal DOfile As DOFile) As Boolean
        If DOfile.ThumbnailURL.StartsWith(OBJECTVAULT_STORAGE) Then
            Try
                Dim ID As String = DOfile.ThumbnailURL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Return Vault.Delete(ID)
            Catch ex As Exception
            End Try
        ElseIf DOfile.ThumbnailURL.StartsWith(SQLSERVER_STORAGE) Then
            Try
                Dim ID As String = DOfile.ThumbnailURL.Substring(SQLSERVER_STORAGE.Length)
                Return SqlCommands.DeleteBLOB(ID)
            Catch ex As Exception
            End Try
        End If
    End Function

#End Region

#Region "Export project files"

    Private Sub ExportProjectFiles()
        Dim DigitalObjectCollection As DigitalObjectCollection = SqlCommands.SelectDigitalObjects(ProjectID)
        For Each DigitalObject As DigitalObject In DigitalObjectCollection
            ExportDigitalObjectFiles(DigitalObject, Me.FolderBrowserDialog.SelectedPath)
        Next
    End Sub

    Private Sub ExportDigitalObjectFiles(ByVal DigitalObject As DigitalObject, ByVal DirectoryName As String)
        Dim DirectoryInfo As DirectoryInfo = Directory.CreateDirectory(String.Format("{0}{1}{2}", Me.FolderBrowserDialog.SelectedPath, Path.DirectorySeparatorChar, DigitalObject.Name))
        DirectoryName = DirectoryInfo.FullName
        Dim DOFileCollection As DOFileCollection = SqlCommands.SelectFiles(DigitalObject.DigitalObjectID)
        For Each DOFile As DOFile In DOFileCollection
            If myProgressDialog.Cancel Then Return
            ExportFile(DOFile, DirectoryName)
        Next
    End Sub

    Private Sub ExportFile(ByVal DOFile As DOFile, ByVal DirectoryName As String)
        Select Case myExport
            Case Export.ALL
                ExportOriginal(DOFile, DirectoryName)
                ExportDissemination(DOFile, DirectoryName)
                ExportThumbnail(DOFile, DirectoryName)
            Case Export.DISSEMINATIONS
                ExportDissemination(DOFile, DirectoryName)
                ExportThumbnail(DOFile, DirectoryName)
            Case Export.ORIGINALS
                ExportOriginal(DOFile, DirectoryName)
        End Select
        myProgressDialog.Increment()
    End Sub

    Private Sub ExportOriginal(ByVal DOFile As DOFile, ByVal DirectoryName As String)
        Try
            myProgressDialog.Message = String.Format(InfoMessage("Files.ExportOriginal"), DOFile.Name)
            Dim DirectoryInfo As DirectoryInfo = Directory.CreateDirectory(String.Format("{0}{1}{2}", DirectoryName, Path.DirectorySeparatorChar, "Originais"))
            DirectoryName = DirectoryInfo.FullName
            Dim DestFileName As String = String.Format("{0}{1}{2}", DirectoryName, Path.DirectorySeparatorChar, DOFile.Name)
            If DOFile.OriginalURL.StartsWith(FILE_STORAGE) Then
                Dim SourceFileName As String = DOFile.OriginalURL.Substring(FILE_STORAGE.Length)
                file.Copy(SourceFileName, DestFileName)

            ElseIf DOFile.OriginalURL.StartsWith(SQLSERVER_STORAGE) Then
                Dim ID As String = DOFile.OriginalURL.Substring(SQLSERVER_STORAGE.Length)
                Dim File As Byte() = SqlCommands.SelectBLOB(ID)
                FileProcessing.WriteBinaryFile(DestFileName, File)

            ElseIf DOFile.OriginalURL.StartsWith(OBJECTVAULT_STORAGE) Then
                Dim ID As String = DOFile.OriginalURL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Dim File As Byte() = vault.Retrieve(ID)
                FileProcessing.WriteBinaryFile(DestFileName, File)

            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub ExportDissemination(ByVal DOFile As DOFile, ByVal DirectoryName As String)
        Try
            myProgressDialog.Message = String.Format(InfoMessage("Files.ExportDissemination"), DOFile.Name)
            Dim DirectoryInfo As DirectoryInfo = Directory.CreateDirectory(String.Format("{0}{1}{2}", DirectoryName, Path.DirectorySeparatorChar, InfoMessage("Files.Disseminations")))
            DirectoryName = DirectoryInfo.FullName
            Dim DestFileName As String
            If FileProcessing.CanGeneDissemination(DOFile.Format) Then
                DestFileName = String.Format("{0}{1}{2}.{3}", DirectoryName, Path.DirectorySeparatorChar, Path.GetFileNameWithoutExtension(DOFile.Name), "JPG")
            Else
                DestFileName = String.Format("{0}{1}{2}", DirectoryName, Path.DirectorySeparatorChar, DOFile.Name)
            End If
            If DOFile.DisseminationURL.StartsWith(FILE_STORAGE) Then
                Dim DisseminationFileName As String = DOFile.DisseminationURL.Substring(FILE_STORAGE.Length)
                File.Copy(DisseminationFileName, DestFileName)

            ElseIf DOFile.DisseminationURL.StartsWith(SQLSERVER_STORAGE) Then
                Dim ID As String = DOFile.DisseminationURL.Substring(SQLSERVER_STORAGE.Length)
                Dim File As Byte() = SqlCommands.SelectBLOB(ID)
                FileProcessing.WriteBinaryFile(DestFileName, File)

            ElseIf DOFile.DisseminationURL.StartsWith(OBJECTVAULT_STORAGE) Then
                Dim vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Dim ID As String = DOFile.DisseminationURL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim File As Byte() = vault.Retrieve(ID)
                FileProcessing.WriteBinaryFile(DestFileName, File)

            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub ExportThumbnail(ByVal DOFile As DOFile, ByVal DirectoryName As String)
        Try
            myProgressDialog.Message = String.Format(InfoMessage("Files.ExportThumbnail"), DOFile.Name)
            Dim DirectoryInfo As DirectoryInfo = Directory.CreateDirectory(String.Format("{0}{1}{2}", DirectoryName, Path.DirectorySeparatorChar, InfoMessage("Files.Thumbnails")))
            DirectoryName = DirectoryInfo.FullName
            Dim DestFileName As String
            If FileProcessing.CanGeneDissemination(DOFile.Format) Then
                DestFileName = String.Format("{0}{1}{2}.{3}", DirectoryName, Path.DirectorySeparatorChar, Path.GetFileNameWithoutExtension(DOFile.Name), "JPG")
            Else
                DestFileName = String.Format("{0}{1}{2}", DirectoryName, Path.DirectorySeparatorChar, DOFile.Name)
            End If
            If DOFile.ThumbnailURL.StartsWith(FILE_STORAGE) Then
                Dim FileName As String = DOFile.ThumbnailURL.Substring(FILE_STORAGE.Length)
                File.Copy(FileName, DestFileName)

            ElseIf DOFile.ThumbnailURL.StartsWith(SQLSERVER_STORAGE) Then
                Dim ID As String = DOFile.ThumbnailURL.Substring(SQLSERVER_STORAGE.Length)
                Dim File As Byte() = SqlCommands.SelectBLOB(ID)
                FileProcessing.WriteBinaryFile(DestFileName, File)

            ElseIf DOFile.ThumbnailURL.StartsWith(OBJECTVAULT_STORAGE) Then
                Dim vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Dim ID As String = DOFile.ThumbnailURL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim File As Byte() = vault.Retrieve(ID)
                FileProcessing.WriteBinaryFile(DestFileName, File)

            End If
        Catch ex As Exception
        End Try
    End Sub

#End Region

#Region "Gene disseminations"

    Private Sub GeneDisseminations()
        Dim DOFileCollection As DOFileCollection = SqlCommands.SelectProjectFiles(Me.ProjectID)
        For Each DOFile As DOFile In DOFileCollection
            Try
                DeleteDissemination(DOFile)
                DeleteThumbnail(DOFile)

                Dim OriginalFile As Byte() = GetFileFromURL(DOFile.OriginalURL)
                Dim OriginalStream As Stream = New ByteArrayStream(OriginalFile)

                If Not OriginalStream Is Nothing Then
                    DOFile = StoreDisseminationFile(DOFile, OriginalStream)
                    DOFile = StoreThumbnailFile(DOFile, OriginalStream)
                    SqlCommands.UpdateDOFile(DOFile)
                End If
            Catch ex As Exception
                MsgBoxException(ex)
            End Try
            myProgressDialog.Increment()
        Next
    End Sub

    Private Function StoreDisseminationFile(ByVal DOFile As DOFile, ByVal OriginalStream As Stream) As DOFile
        Dim ProgramState As New ProgramState

        myProgressDialog.Message = String.Format(InfoMessage("Files.InsertDissemination"), DOFile.Name)
        Select Case ProgramState.DisseminationStorage
            Case ProgramState.StorageForm.Database
                If FileProcessing.CanGeneDissemination(DOFile.Format) Then
                    Dim OutputStream As New MemoryStream

                    FileProcessing.GenerateDisseminationImage(OriginalStream, OutputStream, ProgramState.DisseminationQuality, ProgramState.DisseminationDim, GetDimensionValue(ProgramState.DisseminationDim))
                    Dim ID As Int64 = SqlCommands.InsertBLOB(DOFile.ID, OutputStream.ToArray)
                    OutputStream.Close()
                    DOFile.DisseminationURL = SQLSERVER_STORAGE & CStr(ID)
                    DOFile.HasDissemination = True
                    Return DOFile
                Else
                    DOFile.DisseminationURL = DOFile.OriginalURL
                    Return DOFile
                End If

            Case ProgramState.StorageForm.ObjectVault
                If FileProcessing.CanGeneDissemination(DOFile.Format) Then
                    Try
                        Dim OutputStream As New MemoryStream
                        FileProcessing.GenerateDisseminationImage(OriginalStream, OutputStream, ProgramState.DisseminationQuality, ProgramState.DisseminationDim, GetDimensionValue(ProgramState.DisseminationDim))

                        Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                        Dim CustomMetadata As New Hashtable
                        CustomMetadata.Add("Date", Now.ToShortDateString)
                        Dim Result As Byte() = Vault.Store(OutputStream, DOFile.Name, CustomMetadata)
                        OutputStream.Close()
                        Dim ObjectID As String = ASCII.GetString(Result)

                        DOFile.DisseminationURL = OBJECTVAULT_STORAGE & ObjectID
                        DOFile.HasDissemination = True
                        Return DOFile
                    Catch ex As Exception
                        MsgBoxException(ex)
                    End Try
                Else
                    DOFile.DisseminationURL = DOFile.OriginalURL
                    Return DOFile
                End If
        End Select
    End Function

    Private Function StoreThumbnailFile(ByVal DOFile As DOFile, ByVal OriginalStream As Stream) As DOFile
        Dim FileProcessing As New FileProcessing
        Dim ProgramState As New ProgramState

        myProgressDialog.Message = String.Format(InfoMessage("Files.InsertThumbnail"), DOFile.Name)
        Select Case ProgramState.DisseminationStorage
            Case ProgramState.StorageForm.Database
                If FileProcessing.CanGeneDissemination(DOFile.Format) Then
                    Dim OutputStream As New MemoryStream

                    FileProcessing.GenerateThumbnailImage(OriginalStream, OutputStream, THUMBNAIL_WIDTH)
                    Dim ID As Int64 = SqlCommands.InsertBLOB(DOFile.ID, OutputStream.ToArray)
                    OutputStream.Close()

                    DOFile.ThumbnailURL = SQLSERVER_STORAGE & CStr(ID)
                    Return DOFile
                Else
                    DOFile.ThumbnailURL = DOFile.OriginalURL
                    Return DOFile
                End If

            Case ProgramState.StorageForm.ObjectVault
                If FileProcessing.CanGeneDissemination(DOFile.Format) Then
                    Try
                        Dim OutputStream As New MemoryStream
                        FileProcessing.GenerateThumbnailImage(OriginalStream, OutputStream, THUMBNAIL_WIDTH)

                        Dim Vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                        Dim CustomMetadata As New Hashtable
                        CustomMetadata.Add("Date", Now.ToShortDateString)
                        Dim Result As Byte() = Vault.Store(OutputStream, DOFile.Name, CustomMetadata)
                        OutputStream.Close()
                        Dim ObjectID As String = ASCII.GetString(Result)

                        DOFile.ThumbnailURL = OBJECTVAULT_STORAGE & ObjectID
                        Return DOFile
                    Catch ex As Exception
                        MsgBoxException(ex)
                    End Try
                Else
                    DOFile.ThumbnailURL = DOFile.OriginalURL
                    Return DOFile
                End If
        End Select
    End Function

    Private Function GetFileFromURL(ByVal URL As String) As Byte()
        Try
            If URL.StartsWith(SQLSERVER_STORAGE) Then
                Dim ID As Int64 = URL.Substring(SQLSERVER_STORAGE.Length)
                Return SqlCommands.SelectBLOB(ID)

            ElseIf URL.StartsWith(FILE_STORAGE) Then
                Dim FilePath As String = URL.Substring(FILE_STORAGE.Length)
                Return FileProcessing.ReadBinaryFile(FilePath)

            ElseIf URL.StartsWith(OBJECTVAULT_STORAGE) Then
                Dim ID As String = URL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                Return vault.Retrieve(ID)
            End If
        Catch ex As Exception
            MessageBox.Show(String.Format(InfoMessage("GeneDisseminations.OriginalFileNotAvailable"), URL), _
                            InfoMessage("GeneDisseminations.OriginalFileNotAvailable.Title"), MessageBoxButtons.OK, _
                            MessageBoxIcon.Warning)
        End Try
    End Function

    Private Function GetDimensionValue(ByVal Dimension As ProgramState.DisseminationDimension) As Integer
        Dim myProgramState As New ProgramState
        Select Case Dimension
            Case ProgramState.DisseminationDimension.Width
                Return myProgramState.DisseminationWidth
            Case ProgramState.DisseminationDimension.Height
                Return myProgramState.DisseminationHeight
            Case ProgramState.DisseminationDimension.Resolution
                Return myProgramState.DisseminationResolution
        End Select
    End Function

#End Region

#Region "Verify the connection"

    'Private Function TryConnection() As Boolean
    '    Try
    '        Dim cn As New SqlConnection
    '        cn.ConnectionString = Constants.ConnectionString
    '        cn.Open()
    '        Return True
    '    Catch ex As Exception
    '        Return False
    '    End Try
    'End Function

#End Region

End Class
