
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports DigitArq.Data.Entities.MGOD
Imports DigitArq.Core.Logging
Imports DigitArq.Utility
Imports DigitArq.Definitions.MGOD

Public Class TechnologicalPlataformForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()
        'This call is required by the Windows Form Designer.
        InitializeComponent()
        'Add any initialization after the InitializeComponent() call
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents txtDeviceSource As ColorTextBox
    Friend WithEvents txtOperatingSystem As ColorTextBox
    Public WithEvents lbxModels As System.Windows.Forms.ListBox
    Friend WithEvents gbxTechnologicalPlatform As System.Windows.Forms.GroupBox
    Friend WithEvents btnNew As System.Windows.Forms.Button
    Friend WithEvents gbxInfo As System.Windows.Forms.GroupBox
    Friend WithEvents btnDelete As System.Windows.Forms.Button
    Friend WithEvents txtIlluminance As MGOD.ColorTextBox
    Friend WithEvents txtFontType As MGOD.ColorTextBox
    Friend WithEvents txtManufacturer As MGOD.ColorTextBox
    Friend WithEvents txtSoftware As MGOD.ColorTextBox
    Friend WithEvents txtSoftwareVersion As MGOD.ColorTextBox
    Friend WithEvents txtOperatingSystemVersion As MGOD.ColorTextBox
    Friend WithEvents lblFontType As System.Windows.Forms.Label
    Friend WithEvents lblIlluminance As System.Windows.Forms.Label
    Friend WithEvents lblManufacturer As System.Windows.Forms.Label
    Friend WithEvents lblSoftwareVersion As System.Windows.Forms.Label
    Friend WithEvents lblSoftware As System.Windows.Forms.Label
    Friend WithEvents lblDeviceSource As System.Windows.Forms.Label
    Friend WithEvents lblOperatingSystemVersion As System.Windows.Forms.Label
    Friend WithEvents lblOperatingSystem As System.Windows.Forms.Label
    Friend WithEvents ButtonImageList As System.Windows.Forms.ImageList
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
    Friend WithEvents btnClose As System.Windows.Forms.Button
    Friend WithEvents btnSave As System.Windows.Forms.Button
    Friend WithEvents lblProcessingActions As System.Windows.Forms.Label
    Friend WithEvents txtProcessingActions As MGOD.ColorTextBox
    Friend WithEvents lblProcessingSoftwareName As System.Windows.Forms.Label
    Friend WithEvents txtProcessingSoftwareName As MGOD.ColorTextBox
    Friend WithEvents lblProcessingSoftwareVersion As System.Windows.Forms.Label
    Friend WithEvents txtProcessingSoftwareVersion As MGOD.ColorTextBox
    Friend WithEvents lblProcessingOSName As System.Windows.Forms.Label
    Friend WithEvents txtProcessingOSName As MGOD.ColorTextBox
    Friend WithEvents lblProcessingOSVersion As System.Windows.Forms.Label
    Friend WithEvents txtProcessingOSVersion As MGOD.ColorTextBox
    Friend WithEvents lblColorManager As System.Windows.Forms.Label
    Friend WithEvents txtColorManager As MGOD.ColorTextBox
    Friend WithEvents lblDesignation As System.Windows.Forms.Label
    Friend WithEvents txtDesignation As MGOD.ColorTextBox
    Friend WithEvents lblModelName As System.Windows.Forms.Label
    Friend WithEvents txtModelName As MGOD.ColorTextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(TechnologicalPlataformForm))
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Me.gbxInfo = New System.Windows.Forms.GroupBox
        Me.lblModelName = New System.Windows.Forms.Label
        Me.txtModelName = New MGOD.ColorTextBox
        Me.lblFontType = New System.Windows.Forms.Label
        Me.lblIlluminance = New System.Windows.Forms.Label
        Me.lblDesignation = New System.Windows.Forms.Label
        Me.lblManufacturer = New System.Windows.Forms.Label
        Me.lblSoftwareVersion = New System.Windows.Forms.Label
        Me.lblSoftware = New System.Windows.Forms.Label
        Me.lblDeviceSource = New System.Windows.Forms.Label
        Me.lblOperatingSystemVersion = New System.Windows.Forms.Label
        Me.lblOperatingSystem = New System.Windows.Forms.Label
        Me.txtDesignation = New MGOD.ColorTextBox
        Me.txtDeviceSource = New MGOD.ColorTextBox
        Me.txtManufacturer = New MGOD.ColorTextBox
        Me.txtSoftware = New MGOD.ColorTextBox
        Me.txtSoftwareVersion = New MGOD.ColorTextBox
        Me.txtOperatingSystem = New MGOD.ColorTextBox
        Me.txtOperatingSystemVersion = New MGOD.ColorTextBox
        Me.txtIlluminance = New MGOD.ColorTextBox
        Me.txtFontType = New MGOD.ColorTextBox
        Me.ButtonImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.btnNew = New System.Windows.Forms.Button
        Me.gbxTechnologicalPlatform = New System.Windows.Forms.GroupBox
        Me.btnDelete = New System.Windows.Forms.Button
        Me.lbxModels = New System.Windows.Forms.ListBox
        Me.GroupBox1 = New System.Windows.Forms.GroupBox
        Me.lblColorManager = New System.Windows.Forms.Label
        Me.txtColorManager = New MGOD.ColorTextBox
        Me.lblProcessingOSVersion = New System.Windows.Forms.Label
        Me.txtProcessingOSVersion = New MGOD.ColorTextBox
        Me.lblProcessingOSName = New System.Windows.Forms.Label
        Me.txtProcessingOSName = New MGOD.ColorTextBox
        Me.lblProcessingSoftwareVersion = New System.Windows.Forms.Label
        Me.txtProcessingSoftwareVersion = New MGOD.ColorTextBox
        Me.lblProcessingSoftwareName = New System.Windows.Forms.Label
        Me.txtProcessingSoftwareName = New MGOD.ColorTextBox
        Me.lblProcessingActions = New System.Windows.Forms.Label
        Me.txtProcessingActions = New MGOD.ColorTextBox
        Me.GroupBox2 = New System.Windows.Forms.GroupBox
        Me.btnClose = New System.Windows.Forms.Button
        Me.btnSave = New System.Windows.Forms.Button
        Me.gbxInfo.SuspendLayout()
        Me.gbxTechnologicalPlatform.SuspendLayout()
        Me.GroupBox1.SuspendLayout()
        Me.GroupBox2.SuspendLayout()
        Me.SuspendLayout()
        '
        'gbxInfo
        '
        Me.gbxInfo.BackColor = System.Drawing.Color.WhiteSmoke
        Me.gbxInfo.Controls.Add(Me.lblModelName)
        Me.gbxInfo.Controls.Add(Me.txtModelName)
        Me.gbxInfo.Controls.Add(Me.lblFontType)
        Me.gbxInfo.Controls.Add(Me.lblIlluminance)
        Me.gbxInfo.Controls.Add(Me.lblDesignation)
        Me.gbxInfo.Controls.Add(Me.lblManufacturer)
        Me.gbxInfo.Controls.Add(Me.lblSoftwareVersion)
        Me.gbxInfo.Controls.Add(Me.lblSoftware)
        Me.gbxInfo.Controls.Add(Me.lblDeviceSource)
        Me.gbxInfo.Controls.Add(Me.lblOperatingSystemVersion)
        Me.gbxInfo.Controls.Add(Me.lblOperatingSystem)
        Me.gbxInfo.Controls.Add(Me.txtDesignation)
        Me.gbxInfo.Controls.Add(Me.txtDeviceSource)
        Me.gbxInfo.Controls.Add(Me.txtManufacturer)
        Me.gbxInfo.Controls.Add(Me.txtSoftware)
        Me.gbxInfo.Controls.Add(Me.txtSoftwareVersion)
        Me.gbxInfo.Controls.Add(Me.txtOperatingSystem)
        Me.gbxInfo.Controls.Add(Me.txtOperatingSystemVersion)
        Me.gbxInfo.Controls.Add(Me.txtIlluminance)
        Me.gbxInfo.Controls.Add(Me.txtFontType)
        Me.gbxInfo.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.gbxInfo.Location = New System.Drawing.Point(240, 16)
        Me.gbxInfo.Name = "gbxInfo"
        Me.gbxInfo.Size = New System.Drawing.Size(432, 296)
        Me.gbxInfo.TabIndex = 19
        Me.gbxInfo.TabStop = False
        Me.gbxInfo.Text = "Plataforma de captura"
        '
        'lblModelName
        '
        Me.lblModelName.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblModelName.Location = New System.Drawing.Point(8, 51)
        Me.lblModelName.Name = "lblModelName"
        Me.lblModelName.Size = New System.Drawing.Size(140, 19)
        Me.lblModelName.TabIndex = 83
        Me.lblModelName.Text = "Modelo dispositivo captura"
        Me.lblModelName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtModelName
        '
        Me.txtModelName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtModelName.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtModelName.Location = New System.Drawing.Point(152, 51)
        Me.txtModelName.MaxLength = 100
        Me.txtModelName.Name = "txtModelName"
        Me.txtModelName.Size = New System.Drawing.Size(264, 20)
        Me.txtModelName.TabIndex = 2
        Me.txtModelName.Text = ""
        '
        'lblFontType
        '
        Me.lblFontType.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblFontType.Location = New System.Drawing.Point(8, 267)
        Me.lblFontType.Name = "lblFontType"
        Me.lblFontType.Size = New System.Drawing.Size(140, 19)
        Me.lblFontType.TabIndex = 81
        Me.lblFontType.Text = "Tipo de fonte"
        Me.lblFontType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblIlluminance
        '
        Me.lblIlluminance.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblIlluminance.Location = New System.Drawing.Point(8, 240)
        Me.lblIlluminance.Name = "lblIlluminance"
        Me.lblIlluminance.Size = New System.Drawing.Size(140, 19)
        Me.lblIlluminance.TabIndex = 79
        Me.lblIlluminance.Text = "Iluminao cena"
        Me.lblIlluminance.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblDesignation
        '
        Me.lblDesignation.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblDesignation.ForeColor = System.Drawing.Color.Red
        Me.lblDesignation.Location = New System.Drawing.Point(8, 24)
        Me.lblDesignation.Name = "lblDesignation"
        Me.lblDesignation.Size = New System.Drawing.Size(140, 19)
        Me.lblDesignation.TabIndex = 74
        Me.lblDesignation.Text = "Designao"
        Me.lblDesignation.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblManufacturer
        '
        Me.lblManufacturer.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblManufacturer.Location = New System.Drawing.Point(8, 105)
        Me.lblManufacturer.Name = "lblManufacturer"
        Me.lblManufacturer.Size = New System.Drawing.Size(140, 19)
        Me.lblManufacturer.TabIndex = 60
        Me.lblManufacturer.Text = "Fabricante"
        Me.lblManufacturer.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblSoftwareVersion
        '
        Me.lblSoftwareVersion.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblSoftwareVersion.Location = New System.Drawing.Point(8, 159)
        Me.lblSoftwareVersion.Name = "lblSoftwareVersion"
        Me.lblSoftwareVersion.Size = New System.Drawing.Size(140, 19)
        Me.lblSoftwareVersion.TabIndex = 66
        Me.lblSoftwareVersion.Text = "Verso software captura"
        Me.lblSoftwareVersion.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblSoftware
        '
        Me.lblSoftware.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblSoftware.Location = New System.Drawing.Point(8, 132)
        Me.lblSoftware.Name = "lblSoftware"
        Me.lblSoftware.Size = New System.Drawing.Size(140, 19)
        Me.lblSoftware.TabIndex = 64
        Me.lblSoftware.Text = "Software captura"
        Me.lblSoftware.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblDeviceSource
        '
        Me.lblDeviceSource.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblDeviceSource.Location = New System.Drawing.Point(8, 78)
        Me.lblDeviceSource.Name = "lblDeviceSource"
        Me.lblDeviceSource.Size = New System.Drawing.Size(140, 19)
        Me.lblDeviceSource.TabIndex = 58
        Me.lblDeviceSource.Text = "Dispositivo captura"
        Me.lblDeviceSource.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblOperatingSystemVersion
        '
        Me.lblOperatingSystemVersion.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblOperatingSystemVersion.Location = New System.Drawing.Point(8, 213)
        Me.lblOperatingSystemVersion.Name = "lblOperatingSystemVersion"
        Me.lblOperatingSystemVersion.Size = New System.Drawing.Size(140, 19)
        Me.lblOperatingSystemVersion.TabIndex = 60
        Me.lblOperatingSystemVersion.Text = "Verso sistema operativo"
        Me.lblOperatingSystemVersion.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblOperatingSystem
        '
        Me.lblOperatingSystem.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblOperatingSystem.Location = New System.Drawing.Point(8, 186)
        Me.lblOperatingSystem.Name = "lblOperatingSystem"
        Me.lblOperatingSystem.Size = New System.Drawing.Size(140, 19)
        Me.lblOperatingSystem.TabIndex = 59
        Me.lblOperatingSystem.Text = "Sistema operativo"
        Me.lblOperatingSystem.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtDesignation
        '
        Me.txtDesignation.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtDesignation.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtDesignation.Location = New System.Drawing.Point(152, 24)
        Me.txtDesignation.MaxLength = 100
        Me.txtDesignation.Name = "txtDesignation"
        Me.txtDesignation.Size = New System.Drawing.Size(264, 20)
        Me.txtDesignation.TabIndex = 1
        Me.txtDesignation.Text = ""
        '
        'txtDeviceSource
        '
        Me.txtDeviceSource.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtDeviceSource.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtDeviceSource.Location = New System.Drawing.Point(152, 78)
        Me.txtDeviceSource.MaxLength = 100
        Me.txtDeviceSource.Name = "txtDeviceSource"
        Me.txtDeviceSource.Size = New System.Drawing.Size(264, 20)
        Me.txtDeviceSource.TabIndex = 3
        Me.txtDeviceSource.Text = ""
        '
        'txtManufacturer
        '
        Me.txtManufacturer.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtManufacturer.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtManufacturer.Location = New System.Drawing.Point(152, 105)
        Me.txtManufacturer.MaxLength = 100
        Me.txtManufacturer.Name = "txtManufacturer"
        Me.txtManufacturer.Size = New System.Drawing.Size(264, 20)
        Me.txtManufacturer.TabIndex = 4
        Me.txtManufacturer.Text = ""
        '
        'txtSoftware
        '
        Me.txtSoftware.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtSoftware.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtSoftware.Location = New System.Drawing.Point(152, 132)
        Me.txtSoftware.MaxLength = 100
        Me.txtSoftware.Name = "txtSoftware"
        Me.txtSoftware.Size = New System.Drawing.Size(264, 20)
        Me.txtSoftware.TabIndex = 5
        Me.txtSoftware.Text = ""
        '
        'txtSoftwareVersion
        '
        Me.txtSoftwareVersion.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtSoftwareVersion.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtSoftwareVersion.Location = New System.Drawing.Point(152, 159)
        Me.txtSoftwareVersion.MaxLength = 100
        Me.txtSoftwareVersion.Name = "txtSoftwareVersion"
        Me.txtSoftwareVersion.Size = New System.Drawing.Size(264, 20)
        Me.txtSoftwareVersion.TabIndex = 6
        Me.txtSoftwareVersion.Text = ""
        '
        'txtOperatingSystem
        '
        Me.txtOperatingSystem.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtOperatingSystem.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtOperatingSystem.Location = New System.Drawing.Point(152, 186)
        Me.txtOperatingSystem.MaxLength = 100
        Me.txtOperatingSystem.Name = "txtOperatingSystem"
        Me.txtOperatingSystem.Size = New System.Drawing.Size(264, 20)
        Me.txtOperatingSystem.TabIndex = 7
        Me.txtOperatingSystem.Text = ""
        '
        'txtOperatingSystemVersion
        '
        Me.txtOperatingSystemVersion.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtOperatingSystemVersion.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtOperatingSystemVersion.Location = New System.Drawing.Point(152, 213)
        Me.txtOperatingSystemVersion.MaxLength = 100
        Me.txtOperatingSystemVersion.Name = "txtOperatingSystemVersion"
        Me.txtOperatingSystemVersion.Size = New System.Drawing.Size(264, 20)
        Me.txtOperatingSystemVersion.TabIndex = 8
        Me.txtOperatingSystemVersion.Text = ""
        '
        'txtIlluminance
        '
        Me.txtIlluminance.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtIlluminance.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtIlluminance.Location = New System.Drawing.Point(152, 240)
        Me.txtIlluminance.MaxLength = 100
        Me.txtIlluminance.Name = "txtIlluminance"
        Me.txtIlluminance.Size = New System.Drawing.Size(264, 20)
        Me.txtIlluminance.TabIndex = 9
        Me.txtIlluminance.Text = ""
        '
        'txtFontType
        '
        Me.txtFontType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtFontType.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtFontType.Location = New System.Drawing.Point(152, 267)
        Me.txtFontType.MaxLength = 100
        Me.txtFontType.Name = "txtFontType"
        Me.txtFontType.Size = New System.Drawing.Size(264, 20)
        Me.txtFontType.TabIndex = 10
        Me.txtFontType.Text = ""
        '
        'ButtonImageList
        '
        Me.ButtonImageList.ImageSize = New System.Drawing.Size(18, 18)
        Me.ButtonImageList.ImageStream = CType(resources.GetObject("ButtonImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ButtonImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'btnNew
        '
        Me.btnNew.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnNew.BackColor = System.Drawing.Color.White
        Me.btnNew.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnNew.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnNew.ImageIndex = 0
        Me.btnNew.ImageList = Me.ButtonImageList
        Me.btnNew.Location = New System.Drawing.Point(8, 24)
        Me.btnNew.Name = "btnNew"
        Me.btnNew.Size = New System.Drawing.Size(206, 25)
        Me.btnNew.TabIndex = 19
        Me.btnNew.Text = "Novo"
        '
        'gbxTechnologicalPlatform
        '
        Me.gbxTechnologicalPlatform.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.gbxTechnologicalPlatform.BackColor = System.Drawing.Color.WhiteSmoke
        Me.gbxTechnologicalPlatform.Controls.Add(Me.btnDelete)
        Me.gbxTechnologicalPlatform.Controls.Add(Me.lbxModels)
        Me.gbxTechnologicalPlatform.Controls.Add(Me.btnNew)
        Me.gbxTechnologicalPlatform.Location = New System.Drawing.Point(7, 16)
        Me.gbxTechnologicalPlatform.Name = "gbxTechnologicalPlatform"
        Me.gbxTechnologicalPlatform.Size = New System.Drawing.Size(224, 546)
        Me.gbxTechnologicalPlatform.TabIndex = 28
        Me.gbxTechnologicalPlatform.TabStop = False
        Me.gbxTechnologicalPlatform.Text = "Plataformas tecnolgicas"
        '
        'btnDelete
        '
        Me.btnDelete.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnDelete.BackColor = System.Drawing.Color.White
        Me.btnDelete.Enabled = False
        Me.btnDelete.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnDelete.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnDelete.ImageIndex = 1
        Me.btnDelete.ImageList = Me.ButtonImageList
        Me.btnDelete.Location = New System.Drawing.Point(7, 514)
        Me.btnDelete.Name = "btnDelete"
        Me.btnDelete.Size = New System.Drawing.Size(206, 25)
        Me.btnDelete.TabIndex = 20
        Me.btnDelete.Text = CType(configurationAppSettings.GetValue("btnDelete.Text", GetType(System.String)), String)
        '
        'lbxModels
        '
        Me.lbxModels.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lbxModels.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lbxModels.HorizontalScrollbar = True
        Me.lbxModels.Location = New System.Drawing.Point(7, 57)
        Me.lbxModels.Name = "lbxModels"
        Me.lbxModels.Size = New System.Drawing.Size(206, 444)
        Me.lbxModels.TabIndex = 13
        '
        'GroupBox1
        '
        Me.GroupBox1.BackColor = System.Drawing.Color.WhiteSmoke
        Me.GroupBox1.Controls.Add(Me.lblColorManager)
        Me.GroupBox1.Controls.Add(Me.txtColorManager)
        Me.GroupBox1.Controls.Add(Me.lblProcessingOSVersion)
        Me.GroupBox1.Controls.Add(Me.txtProcessingOSVersion)
        Me.GroupBox1.Controls.Add(Me.lblProcessingOSName)
        Me.GroupBox1.Controls.Add(Me.txtProcessingOSName)
        Me.GroupBox1.Controls.Add(Me.lblProcessingSoftwareVersion)
        Me.GroupBox1.Controls.Add(Me.txtProcessingSoftwareVersion)
        Me.GroupBox1.Controls.Add(Me.lblProcessingSoftwareName)
        Me.GroupBox1.Controls.Add(Me.txtProcessingSoftwareName)
        Me.GroupBox1.Controls.Add(Me.lblProcessingActions)
        Me.GroupBox1.Controls.Add(Me.txtProcessingActions)
        Me.GroupBox1.Location = New System.Drawing.Point(240, 312)
        Me.GroupBox1.Name = "GroupBox1"
        Me.GroupBox1.Size = New System.Drawing.Size(432, 208)
        Me.GroupBox1.TabIndex = 29
        Me.GroupBox1.TabStop = False
        Me.GroupBox1.Text = "Tratamento digital"
        '
        'lblColorManager
        '
        Me.lblColorManager.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblColorManager.ForeColor = System.Drawing.Color.Black
        Me.lblColorManager.Location = New System.Drawing.Point(8, 179)
        Me.lblColorManager.Name = "lblColorManager"
        Me.lblColorManager.Size = New System.Drawing.Size(140, 19)
        Me.lblColorManager.TabIndex = 86
        Me.lblColorManager.Text = "Gesto cor"
        Me.lblColorManager.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtColorManager
        '
        Me.txtColorManager.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtColorManager.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtColorManager.Location = New System.Drawing.Point(152, 179)
        Me.txtColorManager.MaxLength = 200
        Me.txtColorManager.Name = "txtColorManager"
        Me.txtColorManager.Size = New System.Drawing.Size(264, 20)
        Me.txtColorManager.TabIndex = 16
        Me.txtColorManager.Text = ""
        '
        'lblProcessingOSVersion
        '
        Me.lblProcessingOSVersion.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblProcessingOSVersion.ForeColor = System.Drawing.Color.Black
        Me.lblProcessingOSVersion.Location = New System.Drawing.Point(8, 152)
        Me.lblProcessingOSVersion.Name = "lblProcessingOSVersion"
        Me.lblProcessingOSVersion.Size = New System.Drawing.Size(140, 19)
        Me.lblProcessingOSVersion.TabIndex = 84
        Me.lblProcessingOSVersion.Text = "Verso sistema operativo"
        Me.lblProcessingOSVersion.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtProcessingOSVersion
        '
        Me.txtProcessingOSVersion.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtProcessingOSVersion.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtProcessingOSVersion.Location = New System.Drawing.Point(152, 152)
        Me.txtProcessingOSVersion.MaxLength = 100
        Me.txtProcessingOSVersion.Name = "txtProcessingOSVersion"
        Me.txtProcessingOSVersion.Size = New System.Drawing.Size(264, 20)
        Me.txtProcessingOSVersion.TabIndex = 15
        Me.txtProcessingOSVersion.Text = ""
        '
        'lblProcessingOSName
        '
        Me.lblProcessingOSName.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblProcessingOSName.ForeColor = System.Drawing.Color.Black
        Me.lblProcessingOSName.Location = New System.Drawing.Point(8, 125)
        Me.lblProcessingOSName.Name = "lblProcessingOSName"
        Me.lblProcessingOSName.Size = New System.Drawing.Size(140, 19)
        Me.lblProcessingOSName.TabIndex = 82
        Me.lblProcessingOSName.Text = "Sistema operativo"
        Me.lblProcessingOSName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtProcessingOSName
        '
        Me.txtProcessingOSName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtProcessingOSName.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtProcessingOSName.Location = New System.Drawing.Point(152, 125)
        Me.txtProcessingOSName.MaxLength = 100
        Me.txtProcessingOSName.Name = "txtProcessingOSName"
        Me.txtProcessingOSName.Size = New System.Drawing.Size(264, 20)
        Me.txtProcessingOSName.TabIndex = 14
        Me.txtProcessingOSName.Text = ""
        '
        'lblProcessingSoftwareVersion
        '
        Me.lblProcessingSoftwareVersion.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblProcessingSoftwareVersion.ForeColor = System.Drawing.Color.Black
        Me.lblProcessingSoftwareVersion.Location = New System.Drawing.Point(8, 98)
        Me.lblProcessingSoftwareVersion.Name = "lblProcessingSoftwareVersion"
        Me.lblProcessingSoftwareVersion.Size = New System.Drawing.Size(143, 19)
        Me.lblProcessingSoftwareVersion.TabIndex = 80
        Me.lblProcessingSoftwareVersion.Text = "Verso software tratamento"
        Me.lblProcessingSoftwareVersion.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtProcessingSoftwareVersion
        '
        Me.txtProcessingSoftwareVersion.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtProcessingSoftwareVersion.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtProcessingSoftwareVersion.Location = New System.Drawing.Point(152, 98)
        Me.txtProcessingSoftwareVersion.MaxLength = 100
        Me.txtProcessingSoftwareVersion.Name = "txtProcessingSoftwareVersion"
        Me.txtProcessingSoftwareVersion.Size = New System.Drawing.Size(264, 20)
        Me.txtProcessingSoftwareVersion.TabIndex = 13
        Me.txtProcessingSoftwareVersion.Text = ""
        '
        'lblProcessingSoftwareName
        '
        Me.lblProcessingSoftwareName.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblProcessingSoftwareName.ForeColor = System.Drawing.Color.Black
        Me.lblProcessingSoftwareName.Location = New System.Drawing.Point(8, 71)
        Me.lblProcessingSoftwareName.Name = "lblProcessingSoftwareName"
        Me.lblProcessingSoftwareName.Size = New System.Drawing.Size(140, 19)
        Me.lblProcessingSoftwareName.TabIndex = 78
        Me.lblProcessingSoftwareName.Text = "Software tratamento"
        Me.lblProcessingSoftwareName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtProcessingSoftwareName
        '
        Me.txtProcessingSoftwareName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtProcessingSoftwareName.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtProcessingSoftwareName.Location = New System.Drawing.Point(152, 71)
        Me.txtProcessingSoftwareName.MaxLength = 100
        Me.txtProcessingSoftwareName.Name = "txtProcessingSoftwareName"
        Me.txtProcessingSoftwareName.Size = New System.Drawing.Size(264, 20)
        Me.txtProcessingSoftwareName.TabIndex = 12
        Me.txtProcessingSoftwareName.Text = ""
        '
        'lblProcessingActions
        '
        Me.lblProcessingActions.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblProcessingActions.ForeColor = System.Drawing.Color.Black
        Me.lblProcessingActions.Location = New System.Drawing.Point(8, 24)
        Me.lblProcessingActions.Name = "lblProcessingActions"
        Me.lblProcessingActions.Size = New System.Drawing.Size(140, 19)
        Me.lblProcessingActions.TabIndex = 76
        Me.lblProcessingActions.Text = "Tratamento aplicado"
        Me.lblProcessingActions.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'txtProcessingActions
        '
        Me.txtProcessingActions.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtProcessingActions.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtProcessingActions.Location = New System.Drawing.Point(152, 24)
        Me.txtProcessingActions.MaxLength = 1000
        Me.txtProcessingActions.Multiline = True
        Me.txtProcessingActions.Name = "txtProcessingActions"
        Me.txtProcessingActions.Size = New System.Drawing.Size(264, 40)
        Me.txtProcessingActions.TabIndex = 11
        Me.txtProcessingActions.Text = ""
        '
        'GroupBox2
        '
        Me.GroupBox2.BackColor = System.Drawing.Color.WhiteSmoke
        Me.GroupBox2.Controls.Add(Me.btnClose)
        Me.GroupBox2.Controls.Add(Me.btnSave)
        Me.GroupBox2.Location = New System.Drawing.Point(240, 520)
        Me.GroupBox2.Name = "GroupBox2"
        Me.GroupBox2.Size = New System.Drawing.Size(432, 42)
        Me.GroupBox2.TabIndex = 30
        Me.GroupBox2.TabStop = False
        '
        'btnClose
        '
        Me.btnClose.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnClose.BackColor = System.Drawing.Color.White
        Me.btnClose.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnClose.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnClose.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnClose.ImageIndex = 5
        Me.btnClose.ImageList = Me.ButtonImageList
        Me.btnClose.Location = New System.Drawing.Point(336, 11)
        Me.btnClose.Name = "btnClose"
        Me.btnClose.Size = New System.Drawing.Size(88, 25)
        Me.btnClose.TabIndex = 18
        Me.btnClose.Text = "Fechar"
        Me.btnClose.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnSave
        '
        Me.btnSave.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnSave.BackColor = System.Drawing.Color.White
        Me.btnSave.Enabled = False
        Me.btnSave.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnSave.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnSave.ImageIndex = 2
        Me.btnSave.ImageList = Me.ButtonImageList
        Me.btnSave.Location = New System.Drawing.Point(240, 11)
        Me.btnSave.Name = "btnSave"
        Me.btnSave.Size = New System.Drawing.Size(88, 25)
        Me.btnSave.TabIndex = 17
        Me.btnSave.Text = "Guardar"
        Me.btnSave.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'TechnologicalPlataformForm
        '
        Me.AcceptButton = Me.btnSave
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.White
        Me.CancelButton = Me.btnClose
        Me.ClientSize = New System.Drawing.Size(682, 575)
        Me.Controls.Add(Me.GroupBox2)
        Me.Controls.Add(Me.GroupBox1)
        Me.Controls.Add(Me.gbxTechnologicalPlatform)
        Me.Controls.Add(Me.gbxInfo)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.KeyPreview = True
        Me.MaximizeBox = False
        Me.Name = "TechnologicalPlataformForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.Text = "Plataforma tecnolgica"
        Me.gbxInfo.ResumeLayout(False)
        Me.gbxTechnologicalPlatform.ResumeLayout(False)
        Me.GroupBox1.ResumeLayout(False)
        Me.GroupBox2.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Private properties"

    Const NEW_MODEL_NAME As String = "Novo"
    Private myID As Integer
    Private SqlCommands As New SqlCommands(USER_LOGON)

#End Region

#Region "Properties"

    Private ReadOnly Property TechnologicalPlatform() As TechnologicalPlatform
        Get
            Dim TechPlatform As New TechnologicalPlatform
            TechPlatform.ID = Me.ID
            TechPlatform.Designation = Me.Designation
            TechPlatform.Name = Me.ModelName
            TechPlatform.DeviceSource = Me.DeviceSource
            TechPlatform.Manufacturer = Me.Manufacturer
            TechPlatform.Software = Me.Software
            TechPlatform.SoftwareVersion = Me.SoftwareVersion
            TechPlatform.OperatingSystem = Me.OperatingSystem
            TechPlatform.OperatingSystemVersion = Me.OperatingSystemVersion
            TechPlatform.Illuminance = Me.Illuminance
            TechPlatform.FontType = Me.FontType
            TechPlatform.ProcessingActions = Me.ProcessingActions
            TechPlatform.ProcessingSoftwareName = Me.ProcessingSoftwareName
            TechPlatform.ProcessingSoftwareVersion = Me.ProcessingSoftwareVersion
            TechPlatform.ProcessingOSName = Me.ProcessingOSName
            TechPlatform.ProcessingOSVersion = Me.ProcessingOSVersion
            TechPlatform.ColorManager = Me.ColorManager

            Return TechPlatform
        End Get
    End Property

    Private Property ID() As Integer
        Get
            Return myID
        End Get
        Set(ByVal Value As Integer)
            myID = Value
        End Set
    End Property

    Private Property Designation() As String
        Get
            Return Me.txtDesignation.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtDesignation.Text = Value
        End Set
    End Property

    Private Property ModelName() As String
        Get
            Return Me.txtModelName.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtModelName.Text = Value
        End Set
    End Property

    Private Property DeviceSource() As String
        Get
            Return Me.txtDeviceSource.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtDeviceSource.Text = Value
        End Set
    End Property

    Private Property Manufacturer() As String
        Get
            Return Me.txtManufacturer.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtManufacturer.Text = Value
        End Set
    End Property

    Private Property Software() As String
        Get
            Return Me.txtSoftware.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtSoftware.Text = Value
        End Set
    End Property

    Private Property SoftwareVersion() As String
        Get
            Return Me.txtSoftwareVersion.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtSoftwareVersion.Text = Value
        End Set
    End Property

    Private Property OperatingSystem() As String
        Get
            Return Me.txtOperatingSystem.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtOperatingSystem.Text = Value
        End Set
    End Property

    Private Property OperatingSystemVersion() As String
        Get
            Return Me.txtOperatingSystemVersion.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtOperatingSystemVersion.Text = Value
        End Set
    End Property

    Private Property Illuminance() As String
        Get
            Return Me.txtIlluminance.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtIlluminance.Text = Value
        End Set
    End Property

    Private Property FontType() As String
        Get
            Return Me.txtFontType.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtFontType.Text = Value
        End Set
    End Property

    Private Property ProcessingActions() As String
        Get
            Return Me.txtProcessingActions.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtProcessingActions.Text = Value
        End Set
    End Property

    Private Property ProcessingSoftwareName() As String
        Get
            Return Me.txtProcessingSoftwareName.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtProcessingSoftwareName.Text = Value
        End Set
    End Property

    Private Property ProcessingSoftwareVersion() As String
        Get
            Return Me.txtProcessingSoftwareVersion.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtProcessingSoftwareVersion.Text = Value
        End Set
    End Property

    Private Property ProcessingOSName() As String
        Get
            Return Me.txtProcessingOSName.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtProcessingOSName.Text = Value
        End Set
    End Property

    Private Property ProcessingOSVersion() As String
        Get
            Return Me.txtProcessingOSVersion.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtProcessingOSVersion.Text = Value
        End Set
    End Property

    Private Property ColorManager() As String
        Get
            Return Me.txtColorManager.Text.Replace("'", "''")
        End Get
        Set(ByVal Value As String)
            Me.txtColorManager.Text = Value
        End Set
    End Property

#End Region

#Region "Form event handlers"

    Private Sub TechnologicalPlataform_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If USER_LOGON.Equals("admin") Then
            Me.btnDelete.Enabled = True
        End If
        LoadData()
    End Sub

    Private Sub TechnologicalPlataformForm_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        If Me.btnSave.Enabled Then
            If MsgBox(InfoMessage("MainForm.AskBeforeSave"), MsgBoxStyle.YesNo Or MsgBoxStyle.Question Or MsgBoxStyle.DefaultButton1) = MsgBoxResult.Yes Then
                Save()
            End If
        End If
        Me.Close()
    End Sub

#End Region

#Region "ListBox event handlers"

    Private Sub lbxModels_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbxModels.SelectedIndexChanged
        If Me.btnSave.Enabled Then
            If MsgBox(InfoMessage("MainForm.AskBeforeSave"), MsgBoxStyle.YesNo Or MsgBoxStyle.Question Or MsgBoxStyle.DefaultButton1) = MsgBoxResult.Yes Then
                Save()
            End If
        End If
        Me.ID = Me.lbxModels.SelectedValue
        LoadTechnologicalPlatform(Me.ID)
    End Sub

#End Region

#Region "Buttons event handlers"

    Private Sub btnNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNew.Click
        Clear()
        Me.Designation = NEW_MODEL_NAME
        Me.txtDesignation.Focus()
        Me.txtDesignation.SelectAll()
        SqlCommands.InsertTechnologicalPlatform(Me.TechnologicalPlatform)
        Logger.Append(USER_LOGON, Logger.AppendNode, String.Format(LogMessage("Log.InsertTechnologicalPlatform"), Me.Designation))
        Me.btnSave.Enabled = False
        LoadData()
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        Save()
    End Sub

    Private Sub Save()
        Dim index As Integer = Me.lbxModels.SelectedIndex
        If SqlCommands.UpdateTechnologicalPlatform(Me.TechnologicalPlatform) Then
            Logger.Append(USER_LOGON, Logger.EditNode, String.Format(LogMessage("Log.UpdateTechnologicalPlatform"), Me.Designation))
            Me.btnSave.Enabled = False
            LoadData()
        End If
        Me.lbxModels.SelectedIndex = index
    End Sub

    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        If MsgBox(String.Format(InfoMessage("TechnologicalPlatform.Delete"), Me.Designation), MessageBoxButtons.YesNo Or MessageBoxIcon.Warning Or MessageBoxDefaultButton.Button2) = MsgBoxResult.Yes Then
            If SqlCommands.DeleteTechnologicalPlatform(Me.ID) Then
                Logger.Append(USER_LOGON, Logger.RemoveNode, String.Format(LogMessage("Log.DeleteTechnologicalPlatform"), Me.Designation))
                LoadData()
            Else
                MsgBox(ErrorMessage("Delete.RelatedProjectRecord"), MsgBoxStyle.Exclamation)
            End If
        End If
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

#End Region

#Region "Textboxs event handlers"

    Private Sub txtDesignation_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtDesignation.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtModelName_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtModelName.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtDeviceSource_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtDeviceSource.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtManufacturer_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtManufacturer.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtOperatingSystem_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtOperatingSystem.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtOperatingSystemVersion_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtOperatingSystemVersion.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtIlluminance_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtIlluminance.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtFontType_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtFontType.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtSoftware_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtSoftware.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtSoftwareVersion_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtSoftwareVersion.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtProcessingActions_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtProcessingActions.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtProcessingSoftwareName_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtProcessingSoftwareName.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtProcessingSoftwareVersion_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtProcessingSoftwareVersion.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtProcessingOSName_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtProcessingOSName.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtProcessingOSVersion_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtProcessingOSVersion.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

    Private Sub txtColorManager_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtColorManager.TextChanged
        Me.btnSave.Enabled = Me.Designation.Length > 0
    End Sub

#End Region

#Region "Load data"

    Private Sub LoadData()
        Dim ArrayList As New ArrayList
        Dim TechnologicalPlatforms As TechnologicalPlatformCollection = SqlCommands.SelectTechnologicalPlatforms
        
        ArrayList.AddRange(TechnologicalPlatforms)

        With Me.lbxModels
            .DisplayMember = "Designation"
            .ValueMember = "ID"
            .DataSource = ArrayList
        End With

        If Me.lbxModels.Items.Count > 0 Then
            Me.btnDelete.Enabled = True
        Else
            Me.btnDelete.Enabled = False
            Clear()
        End If

        Me.btnSave.Enabled = False
    End Sub

    Private Sub LoadTechnologicalPlatform(ByVal ID As Integer)
        Dim TechnologicalPlatform As TechnologicalPlatform = SqlCommands.SelectTechnologicalPlatform(ID)

        Me.Designation = TechnologicalPlatform.Designation
        Me.ModelName = TechnologicalPlatform.Name
        Me.DeviceSource = TechnologicalPlatform.DeviceSource
        Me.Manufacturer = TechnologicalPlatform.Manufacturer
        Me.Software = TechnologicalPlatform.Software
        Me.SoftwareVersion = TechnologicalPlatform.SoftwareVersion
        Me.OperatingSystem = TechnologicalPlatform.OperatingSystem
        Me.OperatingSystemVersion = TechnologicalPlatform.OperatingSystemVersion
        Me.Illuminance = TechnologicalPlatform.Illuminance
        Me.FontType = TechnologicalPlatform.FontType
        Me.ProcessingActions = TechnologicalPlatform.ProcessingActions
        Me.ProcessingSoftwareName = TechnologicalPlatform.ProcessingSoftwareName
        Me.ProcessingSoftwareVersion = TechnologicalPlatform.ProcessingSoftwareVersion
        Me.ProcessingOSName = TechnologicalPlatform.ProcessingOSName
        Me.ProcessingOSVersion = TechnologicalPlatform.ProcessingOSVersion
        Me.ColorManager = TechnologicalPlatform.ColorManager

        Me.btnSave.Enabled = False
    End Sub

#End Region

#Region "Auxiliary functions"

    Private Sub Clear()
        Me.Designation = ""
        Me.ModelName = ""
        Me.DeviceSource = ""
        Me.Manufacturer = ""
        Me.Software = ""
        Me.SoftwareVersion = ""
        Me.OperatingSystem = ""
        Me.OperatingSystemVersion = ""
        Me.Illuminance = ""
        Me.FontType = ""
        Me.ProcessingActions = ""
        Me.ProcessingSoftwareName = ""
        Me.ProcessingSoftwareVersion = ""
        Me.ProcessingOSName = ""
        Me.ProcessingOSVersion = ""
        Me.ColorManager = ""
    End Sub

#End Region

#Region "Others"

    'Private Sub TecnologicalPlataform_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
    '    If e.KeyCode = Keys.Escape Then
    '        If btnCancel.Enabled Then
    '            DisableEdition()
    '        Else
    '            Me.Close()
    '        End If
    '    ElseIf e.KeyCode = Keys.Enter Then
    '        If btnCancel.Enabled Then
    '            Save()
    '        End If
    '    End If
    'End Sub

#End Region

End Class
