
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports DigitArq.Data.Entities.MGUP

Public Class ApplicationsMenu1
    Inherits BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents pnlEditFunction As System.Web.UI.WebControls.Panel
    Protected WithEvents txbFunctionCode As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbParentCode As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbFunctionName As System.Web.UI.WebControls.TextBox
    Protected WithEvents lnkbNewFunction As System.Web.UI.WebControls.LinkButton
    Protected WithEvents txbNewFunctionCode As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbNewParentCode As System.Web.UI.WebControls.TextBox
    Protected WithEvents txbNewFunctionName As System.Web.UI.WebControls.TextBox
    Protected WithEvents pnlNewFunction As System.Web.UI.WebControls.Panel
    Protected WithEvents lnkbSave As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkbDeleteFunction As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lnkbSaveNewFunction As System.Web.UI.WebControls.LinkButton
    Protected WithEvents ltlAplFunctions As System.Web.UI.WebControls.Literal
    Protected WithEvents rblApplications As System.Web.UI.WebControls.RadioButtonList

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private objI As New SQLDataBase

    '======== FunctionCode: gpu-2.1.1 ======== 
    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        If Not Me.Page.IsPostBack Then
            If objI.accessFunction(HttpContext.Current.User.Identity.Name, Me.Request.QueryString("select")) Then
                Me.lnkbNewFunction.Text = GetLabel("lnkbNewFunction")
                Me.lnkbDeleteFunction.Text = GetLabel("lnkbDeleteFunction")
                Me.lnkbSaveNewFunction.Text = GetLabel("lnkbSave")

                Dim qs_aid As String = Me.Request.QueryString("aid")
                Dim qs_fid As String = Me.Request.QueryString("fid")

                LoadApplications()
                If Not Me.Request.QueryString("aid") Is Nothing Then
                    Me.rblApplications.SelectedValue = qs_aid
                Else
                    Me.rblApplications.SelectedValue = Me.rblApplications.Items(0).Value
                End If

                If Me.Request.QueryString("level") = "last" Then
                    Me.lnkbNewFunction.Visible = False
                Else
                    Me.lnkbNewFunction.Visible = True
                End If

                loadApplicationFunctions(qs_fid)

                If Not objI.hasFunctionsChildren(qs_fid) Then
                    Me.lnkbDeleteFunction.Attributes.Add("onClick", "return confirm('" & GetLabel("ApplicationsMenu1.confirm1") & "');")

                Else
                    Me.lnkbDeleteFunction.Attributes.Add("onClick", "return confirm('" & GetLabel("ApplicationsMenu1.confirm2") & "');")

                End If
            Else
                Response.Redirect("defaultIn.aspx?page=gpu-0&lbl=accessDenied")
            End If
        End If
    End Sub


    Private Sub LoadApplications()
        Me.rblApplications.DataSource = objI.loadApplications
        Me.rblApplications.DataValueField = "ApplicationCode"
        Me.rblApplications.DataTextField = "ApplicationName"
        Me.rblApplications.DataBind()
        Me.rblApplications.SelectedValue = Me.rblApplications.Items(0).Value
    End Sub


    Private Sub rblApplications_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rblApplications.SelectedIndexChanged
        loadApplicationFunctions(Me.Request.QueryString("fid"))
    End Sub

    Private Sub lnkbNewFunction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbNewFunction.Click
        Me.pnlNewFunction.Visible = True
        loadApplicationFunctions(Me.Request.QueryString("fid"))
    End Sub

    Private Sub lnkbDeleteFunction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbDeleteFunction.Click
        Dim strApplicationCode As String = Me.Request.QueryString("aid")
        If Not Me.Request.QueryString("fid") Is Nothing Then
            Dim strFunctionCode = Me.Request.QueryString("fid")
            objI.deleteFunction(strFunctionCode, strApplicationCode)
            loadApplicationFunctions()
        Else
            Response.Write("<script language=javascript>window.alert('Seleccione um nodo da rvore!');</script>")
        End If
    End Sub

    Private Sub lnkbSaveNewFunction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbSaveNewFunction.Click
        Dim objFunction As New _Function

        Dim qs_fid As String = Me.Request.QueryString("fid")

        If Not Me.Request.QueryString("fid") Is Nothing Then
            objFunction.FunctionCode = Me.txbNewFunctionCode.Text
            objFunction.ParentCode = qs_fid
            objFunction.FunctionName = Me.txbNewFunctionName.Text
            objFunction.ApplicationCode = Me.rblApplications.SelectedValue

            objI.storeFunction(objFunction)

            loadApplicationFunctions(qs_fid)
        Else
            Response.Write("<script language=javascript>window.alert('Seleccione um nodo da rvore!');</script>")
        End If

    End Sub

    Private Sub loadApplicationFunctions(Optional ByVal functionCodeSelected As String = "null")
        Me.ltlAplFunctions.Text = strApplicationFunctions(Me.rblApplications.SelectedValue, functionCodeSelected)
    End Sub

End Class


