
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports DigitArq.Data.Entities.MGUP

Public Class employeesMenu1
    Inherits BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents ddlListType As System.Web.UI.WebControls.DropDownList
    Protected WithEvents dgProfiles As System.Web.UI.WebControls.DataGrid
    Protected WithEvents ddlApplication As System.Web.UI.WebControls.DropDownList

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private objI As New SQLDataBase
    Private flag As Boolean = False


    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        If Not Me.Page.IsPostBack Then
            If objI.accessFunction(HttpContext.Current.User.Identity.Name, Me.Request.QueryString("select")) Then
                LoadApplications()
                Me.ddlApplication.SelectedValue = Request.QueryString("apl")
                BindData(Me.ddlListType.SelectedValue, Me.ddlApplication.SelectedValue)

                Me.ddlListType.Items(0).Text = GetLabel("employeesMenu1.ddlListType0")
                Me.ddlListType.Items(1).Text = GetLabel("employeesMenu1.ddlListType1")
                Me.ddlListType.Items(2).Text = GetLabel("employeesMenu1.ddlListType2")
            Else
                Response.Redirect("defaultIn.aspx?page=gpu-0&lbl=accessDenied")
            End If
        End If
    End Sub

    Public Sub BindData(ByVal ListType As String, ByVal ApplicationCode As String)
        Dim c0 As HyperLinkColumn = Me.dgProfiles.Columns(0)
        c0.Text = String.Format("<img src='Images/editUser.png' alt='{0}' border='0'", GetLabel("alt.PersonalData"))

        Dim c1 As EditCommandColumn = Me.dgProfiles.Columns(1)
        c1.EditText = String.Format("<img src='Images/edit.png' alt='{0}' border='0'", GetLabel("alt.Edit"))
        c1.UpdateText = String.Format("<img src='Images/save.png' alt='{0}' border='0'>", GetLabel("alt.Update"))
        c1.CancelText = String.Format("<img src='Images/cancel.png' alt='{0}' border='0'", GetLabel("alt.Cancel"))

        Me.dgProfiles.Columns(2).HeaderText = GetLabel("employeesMenu1.dgProfiles.column2HeaderText")
        Me.dgProfiles.Columns(3).HeaderText = GetLabel("employeesMenu1.dgProfiles.column3HeaderText")
        Me.dgProfiles.Columns(4).HeaderText = GetLabel("employeesMenu1.dgProfiles.column4HeaderText")
        Me.dgProfiles.Columns(5).HeaderText = GetLabel("employeesMenu1.dgProfiles.column5HeaderText")

        Dim DataSet As DataSet = objI.loadEmployees(ListType, ApplicationCode)
        Me.dgProfiles.DataSource = DataSet
        Me.dgProfiles.DataBind()
    End Sub

    Sub dgProfiles_Paged(ByVal sender As Object, ByVal e As DataGridPageChangedEventArgs)
        Me.dgProfiles.CurrentPageIndex = e.NewPageIndex
        BindData(Me.ddlListType.SelectedValue, Me.ddlApplication.SelectedValue)
    End Sub

    Private Sub ddlListType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ddlListType.SelectedIndexChanged
        BindData(Me.ddlListType.SelectedValue, Me.ddlApplication.SelectedValue)
    End Sub

    Private Sub dgProfiles_CancelCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles dgProfiles.CancelCommand
        Me.dgProfiles.EditItemIndex = -1
        BindData(Me.ddlListType.SelectedValue, Me.ddlApplication.SelectedValue)
    End Sub

    Private Sub dgProfiles_PageIndexChanged(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridPageChangedEventArgs) Handles dgProfiles.PageIndexChanged
        Me.dgProfiles.CurrentPageIndex = e.NewPageIndex
        BindData(Me.ddlListType.SelectedValue, Me.ddlApplication.SelectedValue)
    End Sub

    Private Sub dgProfiles_EditCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles dgProfiles.EditCommand
        Me.dgProfiles.EditItemIndex = e.Item.ItemIndex
        BindData(Me.ddlListType.SelectedValue, Me.ddlApplication.SelectedValue)
    End Sub


    Private Sub dgProfiles_UpdateCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles dgProfiles.UpdateCommand
        Dim strUserName As String = dgProfiles.DataKeys(e.Item.ItemIndex)
        Dim ddlProfiles As DropDownList = CType(e.Item.FindControl("ddlProfile"), DropDownList)
        Dim ckbActiveE As CheckBox = CType(e.Item.FindControl("ckbActiveE"), CheckBox)
        Dim intProfileID As Integer = ddlProfiles.SelectedValue
        Dim bolActive As Boolean = ckbActiveE.Checked
        objI.updateEmployee(strUserName, intProfileID, Me.ddlApplication.SelectedValue, bolActive)

        dgProfiles.EditItemIndex = -1
        BindData(Me.ddlListType.SelectedValue, Me.ddlApplication.SelectedValue)
    End Sub

    Private Sub dgProfiles_ItemDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles dgProfiles.ItemDataBound

        If e.Item.ItemType = ListItemType.EditItem Then 
            Dim strApplicationCode As String = Me.ddlApplication.SelectedValue
            Dim ddlProfiles As DropDownList = CType(e.Item.FindControl("ddlProfile"), DropDownList)
            Dim DataSet As DataSet = objI.loadProfiles(strApplicationCode)
            ddlProfiles.DataValueField = "ProfileID"
            ddlProfiles.DataTextField = "Profile"
            ddlProfiles.DataSource = DataSet
            ddlProfiles.DataBind()
        End If
    End Sub

    Private Sub ddlApplication_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ddlApplication.SelectedIndexChanged
        BindData(Me.ddlListType.SelectedValue, Me.ddlApplication.SelectedValue)
    End Sub

    Private Sub LoadApplications()
        Me.ddlApplication.DataSource = objI.loadApplications
        Me.ddlApplication.DataValueField = "ApplicationCode"
        Me.ddlApplication.DataTextField = "ApplicationName"
        Me.ddlApplication.DataBind()
    End Sub

End Class
