
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports DigitArq.Data.Entities.MGUP
Imports System.Data.SqlClient
Imports System.Web.Security

Public Class uc_login1
    Inherits BaseClassUC

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected WithEvents txtPassword As System.Web.UI.WebControls.TextBox
    Protected WithEvents lkbAux As System.Web.UI.WebControls.LinkButton
    Protected WithEvents lblError As System.Web.UI.WebControls.Label
    Protected WithEvents lnkbSubmit As System.Web.UI.WebControls.LinkButton
    Protected WithEvents rfvTxtPassword As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents hlnkRegister As System.Web.UI.WebControls.HyperLink
    Protected WithEvents btnSearch As System.Web.UI.WebControls.Button
    Protected WithEvents ddlUserName As System.Web.UI.WebControls.DropDownList

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private objIGPU As New SQLDataBase

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        If Not Me.Page.IsPostBack Then
            Dim ds As DataSet = objIGPU.loadEmployees(ConfigurationSettings.AppSettings("Application.Code"))
            Me.ddlUserName.DataSource = ds
            Me.ddlUserName.DataValueField = "UserName"
            Me.ddlUserName.DataTextField = "Username"
            Me.ddlUserName.DataBind()

            Me.lnkbSubmit.Text = GetLabel("lnkbLogin")
        End If
    End Sub


    Private Sub lnkbSubmit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkbSubmit.Click

        Dim strUsername As String = Me.ddlUserName.SelectedValue
        Dim strPassword As String = Me.txtPassword.Text

        Dim GPUApplicationCode As String = ConfigurationSettings.AppSettings("Application.Code")

        Dim objI As New SQLDataBase

        Dim eReturn As SQLInterface.eReturn = objI.validateEmployee(GPUApplicationCode, strUsername, strPassword)

        Select Case eReturn
            Case eReturn.Sucess
                Dim objEmployee As Employee = objI.loadEmployee(strUsername)

                Dim authTicket As New FormsAuthenticationTicket(objEmployee.UserName, False, 15)
                Dim encryptTicket = FormsAuthentication.Encrypt(authTicket)
                Dim authCookie As HttpCookie = New HttpCookie(FormsAuthentication.FormsCookieName, encryptTicket)
                Response.Cookies.Add(authCookie)

                Session.Add("Employee", objEmployee)

                If Me.Request.QueryString("page") = "" Or Me.Request.QueryString("page") = "logout" Then
                    Response.Redirect("defaultIn.aspx")
                Else
                    FormsAuthentication.RedirectFromLoginPage(objEmployee.UserName, False)
                End If

            Case eReturn.ErrorUsernamePass
                Me.lblError.Visible = True
                Me.lblError.Text = GetLabel("login.errorUsernamePass")

            Case eReturn.ErrorNotProfile
                Me.lblError.Visible = True
                Me.lblError.Text = GetLabel("login.errorNotProfile")

            Case eReturn.ErrorNotActive
                Me.lblError.Visible = True
                Me.lblError.Text = GetLabel("login.errorNotActive")

            Case eReturn.ApplicationAccessDenied
                Me.lblError.Visible = True
                Me.lblError.Text = GetLabel("login.errorApplicationAccessDenied")

        End Select

    End Sub

    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        lnkbSubmit_Click(sender, e)
    End Sub
End Class
