
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region

Imports System.Data.SqlClient
Imports System.Threading
Imports System.IO
Imports DigitArq.Data.Entities.MGOD
Imports DigitArq.UserControls.ListDataGrid
Imports DigitArq.UserControls.ImageButton
Imports DigitArq.UserControls.Viewer
Imports DigitArq.UserControls.ProgressDialog
Imports DigitArq.UserControls.DigitalObjectsTree
Imports DigitArq.Data.Vault.Client
Imports DigitArq.Definitions.MPOD
Imports DigitArq.Definitions.EAD
Imports DigitArq.Utility


Public Class AssociationForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()
        'This call is required by the Windows Form Designer.
        InitializeComponent()
        'Add any initialization after the InitializeComponent() call
        AddHandler DigitalObjectAssociationsDataGrig.DeleteProperty, AddressOf RemoveDigitalObjectAssociation
        AddHandler FileAssociationsDataGrig.DeleteProperty, AddressOf RemoveFileAssociation
        AddHandler ComponentAssociationsDataGrig.DeleteProperty, AddressOf RemoveComponentAssociation
        AddHandler DigitalObjectAssociationsDataGrig.TextBoxClick, AddressOf DigitalObjectAssociation_DoubleClick
        AddHandler FileAssociationsDataGrig.TextBoxClick, AddressOf FileAssociation_DoubleClick
        AddHandler ComponentAssociationsDataGrig.TextBoxClick, AddressOf ComponentAssociation_DoubleClick

    End Sub

    Public Sub New(ByVal Username As String, ByVal ProjectID As Int64, ByVal DigitalObjectID As Int64)
        MyBase.New()
        USER_LOGON = Username
        myProjectID = ProjectID
        myDigitalObjectID = DigitalObjectID
        myGoFromMGOD = True

        'This call is required by the Windows Form Designer.
        InitializeComponent()
        'Add any initialization after the InitializeComponent() call
        AddHandler DigitalObjectAssociationsDataGrig.DeleteProperty, AddressOf RemoveDigitalObjectAssociation
        AddHandler FileAssociationsDataGrig.DeleteProperty, AddressOf RemoveFileAssociation
        AddHandler ComponentAssociationsDataGrig.DeleteProperty, AddressOf RemoveComponentAssociation
        AddHandler DigitalObjectAssociationsDataGrig.TextBoxClick, AddressOf DigitalObjectAssociation_DoubleClick
        AddHandler FileAssociationsDataGrig.TextBoxClick, AddressOf FileAssociation_DoubleClick
        AddHandler ComponentAssociationsDataGrig.TextBoxClick, AddressOf ComponentAssociation_DoubleClick

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents miCheckChild As System.Windows.Forms.MenuItem
    Friend WithEvents miUIDigitalization As System.Windows.Forms.MenuItem
    Friend WithEvents miDigitarqOD As System.Windows.Forms.MenuItem
    Friend WithEvents miClose As System.Windows.Forms.MenuItem
    Friend WithEvents miProjects As System.Windows.Forms.MenuItem
    Friend WithEvents miOpenProjects As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem5 As System.Windows.Forms.MenuItem
    Friend WithEvents miView As System.Windows.Forms.MenuItem
    Friend WithEvents miReports As System.Windows.Forms.MenuItem
    Friend WithEvents miHelp As System.Windows.Forms.MenuItem
    Friend WithEvents miAssociationDODesc As System.Windows.Forms.MenuItem
    Friend WithEvents miAboutMPOD As System.Windows.Forms.MenuItem
    Friend WithEvents FooterPanel As System.Windows.Forms.Panel
    Friend WithEvents StatusBar As System.Windows.Forms.StatusBar
    Friend WithEvents MainMenu As System.Windows.Forms.MainMenu
    Friend WithEvents lblStatus As System.Windows.Forms.Label
    Friend WithEvents TreeNodeImageList As System.Windows.Forms.ImageList
    Friend WithEvents cmComponents As System.Windows.Forms.ContextMenu
    Friend WithEvents BackPanel As System.Windows.Forms.Panel
    Friend WithEvents RightPanel As System.Windows.Forms.Panel
    Friend WithEvents DigitalObjectsTabControl As System.Windows.Forms.TabControl
    Friend WithEvents tpDigitalObjects As System.Windows.Forms.TabPage
    Friend WithEvents HeaderDigitalObjectsPanel As System.Windows.Forms.Panel
    Friend WithEvents lblDigitalObjectsChecked As System.Windows.Forms.Label
    Friend WithEvents FooterDigitalObjectsPanel As System.Windows.Forms.Panel
    Friend WithEvents btnBackDigitalObjects As ImageButton
    Friend WithEvents btnCheckAllDigitalObjects As ImageButton
    Friend WithEvents tpFiles As System.Windows.Forms.TabPage
    Friend WithEvents Splitter2 As System.Windows.Forms.Splitter
    Friend WithEvents FooterDigitalObjectComponentsPanel As System.Windows.Forms.Panel
    Friend WithEvents btnBackFiles As ImageButton
    Friend WithEvents btnCheckAllFiles As ImageButton
    Friend WithEvents MidlePanel As System.Windows.Forms.Panel
    Friend WithEvents btnAssociate As ImageButton
    Friend WithEvents Splitter3 As System.Windows.Forms.Splitter
    Friend WithEvents LeftPanel As System.Windows.Forms.Panel
    Friend WithEvents FondsTabControl As System.Windows.Forms.TabControl
    Friend WithEvents tpFonds As System.Windows.Forms.TabPage
    Friend WithEvents FondsPanel As System.Windows.Forms.Panel
    Friend WithEvents lvwFonds As System.Windows.Forms.ListView
    Friend WithEvents HeaderFondsPanel As System.Windows.Forms.Panel
    Friend WithEvents txtSearch As System.Windows.Forms.TextBox
    Friend WithEvents FooterFondsPanel As System.Windows.Forms.Panel
    Friend WithEvents ImageButton2 As ImageButton
    Friend WithEvents ImageButton3 As ImageButton
    Friend WithEvents ImageButton4 As ImageButton
    Friend WithEvents tpFondsComponents As System.Windows.Forms.TabPage
    Friend WithEvents HeaderFondsComponentsPanel As System.Windows.Forms.Panel
    Friend WithEvents lblComponentsChecked As System.Windows.Forms.Label
    Friend WithEvents FooterFondsComponentsPanel As System.Windows.Forms.Panel
    Friend WithEvents btnCheckAllComponents As ImageButton
    Friend WithEvents btnExpandAllComponents As ImageButton
    Friend WithEvents btnBackComponents As ImageButton
    Friend WithEvents chFonds As System.Windows.Forms.ColumnHeader
    Friend WithEvents DigitalObjectsBackPanel As System.Windows.Forms.Panel
    Friend WithEvents Splitter4 As System.Windows.Forms.Splitter
    Friend WithEvents DigitalObjectsPanel As System.Windows.Forms.Panel
    Friend WithEvents lvwDigitalObjects As System.Windows.Forms.ListView
    Friend WithEvents chDigitalObjectName As System.Windows.Forms.ColumnHeader
    Friend WithEvents chDigitalObjectOriginalName As System.Windows.Forms.ColumnHeader
    Friend WithEvents DOFilesBackPanel As System.Windows.Forms.Panel
    Friend WithEvents FondsComponentsBackPanel As System.Windows.Forms.Panel
    Friend WithEvents ComponentAssociationsPanel As System.Windows.Forms.Panel
    Friend WithEvents Splitter6 As System.Windows.Forms.Splitter
    Friend WithEvents FondsComponentsPanel As System.Windows.Forms.Panel
    Friend WithEvents tvwSelectedFond As System.Windows.Forms.TreeView
    Friend WithEvents Splitter5 As System.Windows.Forms.Splitter
    Friend WithEvents DOFilesPanel As System.Windows.Forms.Panel
    Friend WithEvents ViewerPanel As System.Windows.Forms.Panel
    Friend WithEvents ImageViewer As ImageViewer
    Friend WithEvents Splitter7 As System.Windows.Forms.Splitter
    Friend WithEvents DigitalObjectsComponentsPanel As System.Windows.Forms.Panel
    Friend WithEvents tvwDO As System.Windows.Forms.TreeView
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents lblFilesChecked As System.Windows.Forms.Label
    Friend WithEvents DigitalObjectAssociationsDataGrig As ListDataGrid
    Friend WithEvents FileAssociationsDataGrig As ListDataGrid
    Friend WithEvents ComponentAssociationsDataGrig As ListDataGrid
    Friend WithEvents DigitalObjectAssociationsPanel As System.Windows.Forms.Panel
    Friend WithEvents FileAssociationsPanel As System.Windows.Forms.Panel
    Friend WithEvents miViewComponentAssociationsPanel As System.Windows.Forms.MenuItem
    Friend WithEvents miViewDigitalObjectAssociationsPanel As System.Windows.Forms.MenuItem
    Friend WithEvents miViewFileAssociationsPanel As System.Windows.Forms.MenuItem
    Friend WithEvents miViewFonds As System.Windows.Forms.MenuItem
    Friend WithEvents miViewComponents As System.Windows.Forms.MenuItem
    Friend WithEvents miViewDigitalObjects As System.Windows.Forms.MenuItem
    Friend WithEvents miViewFiles As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem6 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents miAutoAssociation As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem3 As System.Windows.Forms.MenuItem
    Friend WithEvents miViewAllDigitalObjects As System.Windows.Forms.MenuItem
    Friend WithEvents miViewAssociatedDigitalObjects As System.Windows.Forms.MenuItem
    Friend WithEvents miViewNotAssociatedDigitalObjects As System.Windows.Forms.MenuItem
    Friend WithEvents OtherLevelIcons As System.Windows.Forms.ImageList
    Friend WithEvents MenuItem4 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem7 As System.Windows.Forms.MenuItem
    Friend WithEvents miOrderByName As System.Windows.Forms.MenuItem
    Friend WithEvents miOrderBydate As System.Windows.Forms.MenuItem

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(AssociationForm))
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader
        Me.cmComponents = New System.Windows.Forms.ContextMenu
        Me.miCheckChild = New System.Windows.Forms.MenuItem
        Me.MainMenu = New System.Windows.Forms.MainMenu
        Me.miProjects = New System.Windows.Forms.MenuItem
        Me.miOpenProjects = New System.Windows.Forms.MenuItem
        Me.MenuItem5 = New System.Windows.Forms.MenuItem
        Me.miClose = New System.Windows.Forms.MenuItem
        Me.miView = New System.Windows.Forms.MenuItem
        Me.miViewFonds = New System.Windows.Forms.MenuItem
        Me.miViewComponents = New System.Windows.Forms.MenuItem
        Me.miViewDigitalObjects = New System.Windows.Forms.MenuItem
        Me.miViewFiles = New System.Windows.Forms.MenuItem
        Me.MenuItem6 = New System.Windows.Forms.MenuItem
        Me.MenuItem3 = New System.Windows.Forms.MenuItem
        Me.miViewAllDigitalObjects = New System.Windows.Forms.MenuItem
        Me.miViewAssociatedDigitalObjects = New System.Windows.Forms.MenuItem
        Me.miViewNotAssociatedDigitalObjects = New System.Windows.Forms.MenuItem
        Me.MenuItem2 = New System.Windows.Forms.MenuItem
        Me.miAssociationDODesc = New System.Windows.Forms.MenuItem
        Me.miViewComponentAssociationsPanel = New System.Windows.Forms.MenuItem
        Me.miViewDigitalObjectAssociationsPanel = New System.Windows.Forms.MenuItem
        Me.miViewFileAssociationsPanel = New System.Windows.Forms.MenuItem
        Me.miReports = New System.Windows.Forms.MenuItem
        Me.miUIDigitalization = New System.Windows.Forms.MenuItem
        Me.miDigitarqOD = New System.Windows.Forms.MenuItem
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.miAutoAssociation = New System.Windows.Forms.MenuItem
        Me.miHelp = New System.Windows.Forms.MenuItem
        Me.miAboutMPOD = New System.Windows.Forms.MenuItem
        Me.btnBackDigitalObjects = New DigitArq.UserControls.ImageButton.ImageButton
        Me.btnCheckAllDigitalObjects = New DigitArq.UserControls.ImageButton.ImageButton
        Me.btnBackFiles = New DigitArq.UserControls.ImageButton.ImageButton
        Me.btnCheckAllFiles = New DigitArq.UserControls.ImageButton.ImageButton
        Me.btnAssociate = New DigitArq.UserControls.ImageButton.ImageButton
        Me.btnCheckAllComponents = New DigitArq.UserControls.ImageButton.ImageButton
        Me.btnExpandAllComponents = New DigitArq.UserControls.ImageButton.ImageButton
        Me.btnBackComponents = New DigitArq.UserControls.ImageButton.ImageButton
        Me.FooterPanel = New System.Windows.Forms.Panel
        Me.lblStatus = New System.Windows.Forms.Label
        Me.StatusBar = New System.Windows.Forms.StatusBar
        Me.TreeNodeImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.BackPanel = New System.Windows.Forms.Panel
        Me.RightPanel = New System.Windows.Forms.Panel
        Me.DigitalObjectsTabControl = New System.Windows.Forms.TabControl
        Me.tpDigitalObjects = New System.Windows.Forms.TabPage
        Me.DigitalObjectsBackPanel = New System.Windows.Forms.Panel
        Me.DigitalObjectsPanel = New System.Windows.Forms.Panel
        Me.lvwDigitalObjects = New System.Windows.Forms.ListView
        Me.chDigitalObjectName = New System.Windows.Forms.ColumnHeader
        Me.chDigitalObjectOriginalName = New System.Windows.Forms.ColumnHeader
        Me.Splitter4 = New System.Windows.Forms.Splitter
        Me.DigitalObjectAssociationsPanel = New System.Windows.Forms.Panel
        Me.DigitalObjectAssociationsDataGrig = New DigitArq.UserControls.ListDataGrid.ListDataGrid
        Me.HeaderDigitalObjectsPanel = New System.Windows.Forms.Panel
        Me.lblDigitalObjectsChecked = New System.Windows.Forms.Label
        Me.FooterDigitalObjectsPanel = New System.Windows.Forms.Panel
        Me.tpFiles = New System.Windows.Forms.TabPage
        Me.DOFilesBackPanel = New System.Windows.Forms.Panel
        Me.DOFilesPanel = New System.Windows.Forms.Panel
        Me.ViewerPanel = New System.Windows.Forms.Panel
        Me.ImageViewer = New DigitArq.UserControls.Viewer.ImageViewer
        Me.Splitter7 = New System.Windows.Forms.Splitter
        Me.DigitalObjectsComponentsPanel = New System.Windows.Forms.Panel
        Me.tvwDO = New System.Windows.Forms.TreeView
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.lblFilesChecked = New System.Windows.Forms.Label
        Me.Splitter5 = New System.Windows.Forms.Splitter
        Me.FileAssociationsPanel = New System.Windows.Forms.Panel
        Me.FileAssociationsDataGrig = New DigitArq.UserControls.ListDataGrid.ListDataGrid
        Me.Splitter2 = New System.Windows.Forms.Splitter
        Me.FooterDigitalObjectComponentsPanel = New System.Windows.Forms.Panel
        Me.MidlePanel = New System.Windows.Forms.Panel
        Me.Splitter3 = New System.Windows.Forms.Splitter
        Me.LeftPanel = New System.Windows.Forms.Panel
        Me.FondsTabControl = New System.Windows.Forms.TabControl
        Me.tpFonds = New System.Windows.Forms.TabPage
        Me.FondsPanel = New System.Windows.Forms.Panel
        Me.lvwFonds = New System.Windows.Forms.ListView
        Me.chFonds = New System.Windows.Forms.ColumnHeader
        Me.OtherLevelIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.HeaderFondsPanel = New System.Windows.Forms.Panel
        Me.txtSearch = New System.Windows.Forms.TextBox
        Me.FooterFondsPanel = New System.Windows.Forms.Panel
        Me.ImageButton2 = New DigitArq.UserControls.ImageButton.ImageButton
        Me.ImageButton3 = New DigitArq.UserControls.ImageButton.ImageButton
        Me.ImageButton4 = New DigitArq.UserControls.ImageButton.ImageButton
        Me.tpFondsComponents = New System.Windows.Forms.TabPage
        Me.FondsComponentsBackPanel = New System.Windows.Forms.Panel
        Me.FondsComponentsPanel = New System.Windows.Forms.Panel
        Me.tvwSelectedFond = New System.Windows.Forms.TreeView
        Me.Splitter6 = New System.Windows.Forms.Splitter
        Me.ComponentAssociationsPanel = New System.Windows.Forms.Panel
        Me.ComponentAssociationsDataGrig = New DigitArq.UserControls.ListDataGrid.ListDataGrid
        Me.HeaderFondsComponentsPanel = New System.Windows.Forms.Panel
        Me.lblComponentsChecked = New System.Windows.Forms.Label
        Me.FooterFondsComponentsPanel = New System.Windows.Forms.Panel
        Me.MenuItem4 = New System.Windows.Forms.MenuItem
        Me.MenuItem7 = New System.Windows.Forms.MenuItem
        Me.miOrderByName = New System.Windows.Forms.MenuItem
        Me.miOrderBydate = New System.Windows.Forms.MenuItem
        Me.FooterPanel.SuspendLayout()
        Me.BackPanel.SuspendLayout()
        Me.RightPanel.SuspendLayout()
        Me.DigitalObjectsTabControl.SuspendLayout()
        Me.tpDigitalObjects.SuspendLayout()
        Me.DigitalObjectsBackPanel.SuspendLayout()
        Me.DigitalObjectsPanel.SuspendLayout()
        Me.DigitalObjectAssociationsPanel.SuspendLayout()
        Me.HeaderDigitalObjectsPanel.SuspendLayout()
        Me.FooterDigitalObjectsPanel.SuspendLayout()
        Me.tpFiles.SuspendLayout()
        Me.DOFilesBackPanel.SuspendLayout()
        Me.DOFilesPanel.SuspendLayout()
        Me.ViewerPanel.SuspendLayout()
        Me.DigitalObjectsComponentsPanel.SuspendLayout()
        Me.Panel1.SuspendLayout()
        Me.FileAssociationsPanel.SuspendLayout()
        Me.FooterDigitalObjectComponentsPanel.SuspendLayout()
        Me.MidlePanel.SuspendLayout()
        Me.LeftPanel.SuspendLayout()
        Me.FondsTabControl.SuspendLayout()
        Me.tpFonds.SuspendLayout()
        Me.FondsPanel.SuspendLayout()
        Me.HeaderFondsPanel.SuspendLayout()
        Me.FooterFondsPanel.SuspendLayout()
        Me.tpFondsComponents.SuspendLayout()
        Me.FondsComponentsBackPanel.SuspendLayout()
        Me.FondsComponentsPanel.SuspendLayout()
        Me.ComponentAssociationsPanel.SuspendLayout()
        Me.HeaderFondsComponentsPanel.SuspendLayout()
        Me.FooterFondsComponentsPanel.SuspendLayout()
        Me.SuspendLayout()
        '
        'cmComponents
        '
        Me.cmComponents.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miCheckChild})
        '
        'miCheckChild
        '
        Me.miCheckChild.Index = 0
        Me.miCheckChild.Text = "Seleccionar filhos"
        '
        'MainMenu
        '
        Me.MainMenu.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miProjects, Me.miView, Me.miReports, Me.MenuItem1, Me.miHelp})
        '
        'miProjects
        '
        Me.miProjects.Index = 0
        Me.miProjects.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miOpenProjects, Me.MenuItem5, Me.miClose})
        Me.miProjects.Text = "&Perfis"
        '
        'miOpenProjects
        '
        Me.miOpenProjects.Index = 0
        Me.miOpenProjects.Text = "&Abrir..."
        '
        'MenuItem5
        '
        Me.MenuItem5.Index = 1
        Me.MenuItem5.Text = "-"
        '
        'miClose
        '
        Me.miClose.Index = 2
        Me.miClose.Text = "&Sair"
        '
        'miView
        '
        Me.miView.Index = 1
        Me.miView.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miViewFonds, Me.miViewComponents, Me.miViewDigitalObjects, Me.miViewFiles, Me.MenuItem6, Me.MenuItem3, Me.MenuItem2, Me.miAssociationDODesc, Me.MenuItem4, Me.MenuItem7})
        Me.miView.Text = "&Ver"
        '
        'miViewFonds
        '
        Me.miViewFonds.Index = 0
        Me.miViewFonds.Text = "&Lista de fundos"
        '
        'miViewComponents
        '
        Me.miViewComponents.Index = 1
        Me.miViewComponents.Text = "&Estrutura do fundo"
        '
        'miViewDigitalObjects
        '
        Me.miViewDigitalObjects.Index = 2
        Me.miViewDigitalObjects.Text = "Lista de &objectos digitais"
        '
        'miViewFiles
        '
        Me.miViewFiles.Index = 3
        Me.miViewFiles.Text = "Estrutura do o&bjecto digital "
        '
        'MenuItem6
        '
        Me.MenuItem6.Index = 4
        Me.MenuItem6.Text = "-"
        '
        'MenuItem3
        '
        Me.MenuItem3.Index = 5
        Me.MenuItem3.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miViewAllDigitalObjects, Me.miViewAssociatedDigitalObjects, Me.miViewNotAssociatedDigitalObjects})
        Me.MenuItem3.Text = "&Objectos digitais"
        '
        'miViewAllDigitalObjects
        '
        Me.miViewAllDigitalObjects.Checked = True
        Me.miViewAllDigitalObjects.Index = 0
        Me.miViewAllDigitalObjects.Text = "&Todos"
        '
        'miViewAssociatedDigitalObjects
        '
        Me.miViewAssociatedDigitalObjects.Index = 1
        Me.miViewAssociatedDigitalObjects.Text = "&Associados"
        '
        'miViewNotAssociatedDigitalObjects
        '
        Me.miViewNotAssociatedDigitalObjects.Index = 2
        Me.miViewNotAssociatedDigitalObjects.Text = "&No associados"
        '
        'MenuItem2
        '
        Me.MenuItem2.Index = 6
        Me.MenuItem2.Text = "-"
        '
        'miAssociationDODesc
        '
        Me.miAssociationDODesc.Index = 7
        Me.miAssociationDODesc.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miViewComponentAssociationsPanel, Me.miViewDigitalObjectAssociationsPanel, Me.miViewFileAssociationsPanel})
        Me.miAssociationDODesc.Text = "&Painel de associaes"
        '
        'miViewComponentAssociationsPanel
        '
        Me.miViewComponentAssociationsPanel.Checked = True
        Me.miViewComponentAssociationsPanel.Index = 0
        Me.miViewComponentAssociationsPanel.Text = "&Descries"
        '
        'miViewDigitalObjectAssociationsPanel
        '
        Me.miViewDigitalObjectAssociationsPanel.Checked = True
        Me.miViewDigitalObjectAssociationsPanel.Index = 1
        Me.miViewDigitalObjectAssociationsPanel.Text = "&Objectos digitais"
        '
        'miViewFileAssociationsPanel
        '
        Me.miViewFileAssociationsPanel.Checked = True
        Me.miViewFileAssociationsPanel.Index = 2
        Me.miViewFileAssociationsPanel.Text = "&Ficheiros"
        '
        'miReports
        '
        Me.miReports.Index = 2
        Me.miReports.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miUIDigitalization, Me.miDigitarqOD})
        Me.miReports.Text = "&Relatrios"
        '
        'miUIDigitalization
        '
        Me.miUIDigitalization.Index = 0
        Me.miUIDigitalization.Text = "&Percentagem de unidades de instalao digitalizadas..."
        '
        'miDigitarqOD
        '
        Me.miDigitarqOD.Index = 1
        Me.miDigitarqOD.Text = "&Informao de objectos digitais associados..."
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 3
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miAutoAssociation})
        Me.MenuItem1.Text = "&Ferramentas"
        '
        'miAutoAssociation
        '
        Me.miAutoAssociation.Index = 0
        Me.miAutoAssociation.Text = "&Associao automtica..."
        '
        'miHelp
        '
        Me.miHelp.Index = 4
        Me.miHelp.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miAboutMPOD})
        Me.miHelp.Text = "&Ajuda"
        Me.miHelp.Visible = False
        '
        'miAboutMPOD
        '
        Me.miAboutMPOD.Index = 0
        Me.miAboutMPOD.Text = "MPOD"
        '
        'btnBackDigitalObjects
        '
        Me.btnBackDigitalObjects.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.btnBackDigitalObjects.BorderColor = System.Drawing.Color.WhiteSmoke
        Me.btnBackDigitalObjects.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 6.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnBackDigitalObjects.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.btnBackDigitalObjects.ButtonImage = CType(resources.GetObject("btnBackDigitalObjects.ButtonImage"), System.Drawing.Image)
        Me.btnBackDigitalObjects.ButtonImageAlignment = System.Drawing.ContentAlignment.TopCenter
        Me.btnBackDigitalObjects.ButtonShowShadow = True
        Me.btnBackDigitalObjects.ButtonText = "Voltar"
        Me.btnBackDigitalObjects.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.btnBackDigitalObjects.ButtonTransparentColor = System.Drawing.Color.WhiteSmoke
        Me.btnBackDigitalObjects.Enabled = False
        Me.btnBackDigitalObjects.HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
        Me.btnBackDigitalObjects.Location = New System.Drawing.Point(4, 1)
        Me.btnBackDigitalObjects.Name = "btnBackDigitalObjects"
        Me.btnBackDigitalObjects.Size = New System.Drawing.Size(56, 56)
        Me.btnBackDigitalObjects.TabIndex = 114
        Me.btnBackDigitalObjects.ToolTip = "Voltar  lista de objectos digitais"
        '
        'btnCheckAllDigitalObjects
        '
        Me.btnCheckAllDigitalObjects.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnCheckAllDigitalObjects.BorderColor = System.Drawing.Color.WhiteSmoke
        Me.btnCheckAllDigitalObjects.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 6.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnCheckAllDigitalObjects.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.btnCheckAllDigitalObjects.ButtonImage = CType(resources.GetObject("btnCheckAllDigitalObjects.ButtonImage"), System.Drawing.Image)
        Me.btnCheckAllDigitalObjects.ButtonImageAlignment = System.Drawing.ContentAlignment.TopCenter
        Me.btnCheckAllDigitalObjects.ButtonShowShadow = True
        Me.btnCheckAllDigitalObjects.ButtonText = "Seleccionar"
        Me.btnCheckAllDigitalObjects.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.btnCheckAllDigitalObjects.ButtonTransparentColor = System.Drawing.Color.WhiteSmoke
        Me.btnCheckAllDigitalObjects.Font = New System.Drawing.Font("Microsoft Sans Serif", 6.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnCheckAllDigitalObjects.HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
        Me.btnCheckAllDigitalObjects.Location = New System.Drawing.Point(483, 1)
        Me.btnCheckAllDigitalObjects.Name = "btnCheckAllDigitalObjects"
        Me.btnCheckAllDigitalObjects.Size = New System.Drawing.Size(68, 56)
        Me.btnCheckAllDigitalObjects.TabIndex = 112
        Me.btnCheckAllDigitalObjects.ToolTip = "Seleccionar tudo"
        '
        'btnBackFiles
        '
        Me.btnBackFiles.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.btnBackFiles.BorderColor = System.Drawing.Color.WhiteSmoke
        Me.btnBackFiles.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 6.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnBackFiles.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.btnBackFiles.ButtonImage = CType(resources.GetObject("btnBackFiles.ButtonImage"), System.Drawing.Image)
        Me.btnBackFiles.ButtonImageAlignment = System.Drawing.ContentAlignment.TopCenter
        Me.btnBackFiles.ButtonShowShadow = True
        Me.btnBackFiles.ButtonText = "Voltar"
        Me.btnBackFiles.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.btnBackFiles.ButtonTransparentColor = System.Drawing.Color.WhiteSmoke
        Me.btnBackFiles.HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
        Me.btnBackFiles.Location = New System.Drawing.Point(8, 1)
        Me.btnBackFiles.Name = "btnBackFiles"
        Me.btnBackFiles.Size = New System.Drawing.Size(56, 56)
        Me.btnBackFiles.TabIndex = 110
        Me.btnBackFiles.ToolTip = "Voltar  lista de objectos digitais"
        '
        'btnCheckAllFiles
        '
        Me.btnCheckAllFiles.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnCheckAllFiles.BorderColor = System.Drawing.Color.WhiteSmoke
        Me.btnCheckAllFiles.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 6.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnCheckAllFiles.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.btnCheckAllFiles.ButtonImage = CType(resources.GetObject("btnCheckAllFiles.ButtonImage"), System.Drawing.Image)
        Me.btnCheckAllFiles.ButtonImageAlignment = System.Drawing.ContentAlignment.TopCenter
        Me.btnCheckAllFiles.ButtonShowShadow = True
        Me.btnCheckAllFiles.ButtonText = "Seleccionar"
        Me.btnCheckAllFiles.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.btnCheckAllFiles.ButtonTransparentColor = System.Drawing.Color.WhiteSmoke
        Me.btnCheckAllFiles.Font = New System.Drawing.Font("Microsoft Sans Serif", 6.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnCheckAllFiles.HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
        Me.btnCheckAllFiles.Location = New System.Drawing.Point(482, 1)
        Me.btnCheckAllFiles.Name = "btnCheckAllFiles"
        Me.btnCheckAllFiles.Size = New System.Drawing.Size(68, 56)
        Me.btnCheckAllFiles.TabIndex = 108
        Me.btnCheckAllFiles.ToolTip = "Seleccionar tudo"
        '
        'btnAssociate
        '
        Me.btnAssociate.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnAssociate.BorderColor = System.Drawing.SystemColors.Control
        Me.btnAssociate.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 6.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnAssociate.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.btnAssociate.ButtonImage = CType(resources.GetObject("btnAssociate.ButtonImage"), System.Drawing.Image)
        Me.btnAssociate.ButtonImageAlignment = System.Drawing.ContentAlignment.TopCenter
        Me.btnAssociate.ButtonShowShadow = True
        Me.btnAssociate.ButtonText = "Associar"
        Me.btnAssociate.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.btnAssociate.ButtonTransparentColor = System.Drawing.SystemColors.Control
        Me.btnAssociate.Enabled = False
        Me.btnAssociate.HighlightBackgroundColor = System.Drawing.SystemColors.Control
        Me.btnAssociate.Location = New System.Drawing.Point(-1, 184)
        Me.btnAssociate.Name = "btnAssociate"
        Me.btnAssociate.Size = New System.Drawing.Size(57, 56)
        Me.btnAssociate.TabIndex = 110
        Me.btnAssociate.ToolTip = "Efectuar associao"
        '
        'btnCheckAllComponents
        '
        Me.btnCheckAllComponents.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnCheckAllComponents.BorderColor = System.Drawing.Color.WhiteSmoke
        Me.btnCheckAllComponents.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 6.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnCheckAllComponents.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.btnCheckAllComponents.ButtonImage = CType(resources.GetObject("btnCheckAllComponents.ButtonImage"), System.Drawing.Image)
        Me.btnCheckAllComponents.ButtonImageAlignment = System.Drawing.ContentAlignment.TopCenter
        Me.btnCheckAllComponents.ButtonShowShadow = True
        Me.btnCheckAllComponents.ButtonText = "Seleccionar"
        Me.btnCheckAllComponents.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.btnCheckAllComponents.ButtonTransparentColor = System.Drawing.Color.WhiteSmoke
        Me.btnCheckAllComponents.HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
        Me.btnCheckAllComponents.Location = New System.Drawing.Point(221, 1)
        Me.btnCheckAllComponents.Name = "btnCheckAllComponents"
        Me.btnCheckAllComponents.Size = New System.Drawing.Size(68, 56)
        Me.btnCheckAllComponents.TabIndex = 102
        Me.btnCheckAllComponents.ToolTip = "Seleccionar tudo"
        '
        'btnExpandAllComponents
        '
        Me.btnExpandAllComponents.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnExpandAllComponents.BorderColor = System.Drawing.Color.WhiteSmoke
        Me.btnExpandAllComponents.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 6.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnExpandAllComponents.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.btnExpandAllComponents.ButtonImage = CType(resources.GetObject("btnExpandAllComponents.ButtonImage"), System.Drawing.Image)
        Me.btnExpandAllComponents.ButtonImageAlignment = System.Drawing.ContentAlignment.TopCenter
        Me.btnExpandAllComponents.ButtonShowShadow = True
        Me.btnExpandAllComponents.ButtonText = "Expandir"
        Me.btnExpandAllComponents.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.btnExpandAllComponents.ButtonTransparentColor = System.Drawing.Color.WhiteSmoke
        Me.btnExpandAllComponents.HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
        Me.btnExpandAllComponents.Location = New System.Drawing.Point(161, 1)
        Me.btnExpandAllComponents.Name = "btnExpandAllComponents"
        Me.btnExpandAllComponents.Size = New System.Drawing.Size(57, 56)
        Me.btnExpandAllComponents.TabIndex = 101
        Me.btnExpandAllComponents.ToolTip = "Expandir tudo"
        '
        'btnBackComponents
        '
        Me.btnBackComponents.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.btnBackComponents.BorderColor = System.Drawing.Color.WhiteSmoke
        Me.btnBackComponents.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 6.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnBackComponents.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.btnBackComponents.ButtonImage = CType(resources.GetObject("btnBackComponents.ButtonImage"), System.Drawing.Image)
        Me.btnBackComponents.ButtonImageAlignment = System.Drawing.ContentAlignment.TopCenter
        Me.btnBackComponents.ButtonShowShadow = True
        Me.btnBackComponents.ButtonText = "Voltar"
        Me.btnBackComponents.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.btnBackComponents.ButtonTransparentColor = System.Drawing.Color.WhiteSmoke
        Me.btnBackComponents.HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
        Me.btnBackComponents.Location = New System.Drawing.Point(4, 1)
        Me.btnBackComponents.Name = "btnBackComponents"
        Me.btnBackComponents.Size = New System.Drawing.Size(57, 56)
        Me.btnBackComponents.TabIndex = 100
        Me.btnBackComponents.ToolTip = "Voltar  lista de fundos"
        '
        'FooterPanel
        '
        Me.FooterPanel.Controls.Add(Me.lblStatus)
        Me.FooterPanel.Controls.Add(Me.StatusBar)
        Me.FooterPanel.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.FooterPanel.Location = New System.Drawing.Point(0, 625)
        Me.FooterPanel.Name = "FooterPanel"
        Me.FooterPanel.Size = New System.Drawing.Size(920, 40)
        Me.FooterPanel.TabIndex = 102
        '
        'lblStatus
        '
        Me.lblStatus.BackColor = System.Drawing.SystemColors.Control
        Me.lblStatus.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblStatus.Location = New System.Drawing.Point(8, 10)
        Me.lblStatus.Name = "lblStatus"
        Me.lblStatus.Size = New System.Drawing.Size(728, 23)
        Me.lblStatus.TabIndex = 1
        Me.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'StatusBar
        '
        Me.StatusBar.Dock = System.Windows.Forms.DockStyle.Fill
        Me.StatusBar.Location = New System.Drawing.Point(0, 0)
        Me.StatusBar.Name = "StatusBar"
        Me.StatusBar.Size = New System.Drawing.Size(920, 40)
        Me.StatusBar.TabIndex = 0
        '
        'TreeNodeImageList
        '
        Me.TreeNodeImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth24Bit
        Me.TreeNodeImageList.ImageSize = New System.Drawing.Size(16, 16)
        Me.TreeNodeImageList.ImageStream = CType(resources.GetObject("TreeNodeImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.TreeNodeImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'BackPanel
        '
        Me.BackPanel.Controls.Add(Me.RightPanel)
        Me.BackPanel.Controls.Add(Me.Splitter3)
        Me.BackPanel.Controls.Add(Me.LeftPanel)
        Me.BackPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.BackPanel.Location = New System.Drawing.Point(0, 0)
        Me.BackPanel.Name = "BackPanel"
        Me.BackPanel.Size = New System.Drawing.Size(920, 625)
        Me.BackPanel.TabIndex = 105
        '
        'RightPanel
        '
        Me.RightPanel.Controls.Add(Me.DigitalObjectsTabControl)
        Me.RightPanel.Controls.Add(Me.MidlePanel)
        Me.RightPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.RightPanel.Location = New System.Drawing.Point(303, 0)
        Me.RightPanel.Name = "RightPanel"
        Me.RightPanel.Size = New System.Drawing.Size(617, 625)
        Me.RightPanel.TabIndex = 115
        '
        'DigitalObjectsTabControl
        '
        Me.DigitalObjectsTabControl.Controls.Add(Me.tpDigitalObjects)
        Me.DigitalObjectsTabControl.Controls.Add(Me.tpFiles)
        Me.DigitalObjectsTabControl.Dock = System.Windows.Forms.DockStyle.Fill
        Me.DigitalObjectsTabControl.Location = New System.Drawing.Point(56, 0)
        Me.DigitalObjectsTabControl.Name = "DigitalObjectsTabControl"
        Me.DigitalObjectsTabControl.SelectedIndex = 0
        Me.DigitalObjectsTabControl.Size = New System.Drawing.Size(561, 625)
        Me.DigitalObjectsTabControl.TabIndex = 103
        '
        'tpDigitalObjects
        '
        Me.tpDigitalObjects.Controls.Add(Me.DigitalObjectsBackPanel)
        Me.tpDigitalObjects.Controls.Add(Me.HeaderDigitalObjectsPanel)
        Me.tpDigitalObjects.Controls.Add(Me.FooterDigitalObjectsPanel)
        Me.tpDigitalObjects.Location = New System.Drawing.Point(4, 22)
        Me.tpDigitalObjects.Name = "tpDigitalObjects"
        Me.tpDigitalObjects.Size = New System.Drawing.Size(553, 599)
        Me.tpDigitalObjects.TabIndex = 3
        Me.tpDigitalObjects.Text = "Objectos digitais"
        '
        'DigitalObjectsBackPanel
        '
        Me.DigitalObjectsBackPanel.Controls.Add(Me.DigitalObjectsPanel)
        Me.DigitalObjectsBackPanel.Controls.Add(Me.Splitter4)
        Me.DigitalObjectsBackPanel.Controls.Add(Me.DigitalObjectAssociationsPanel)
        Me.DigitalObjectsBackPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.DigitalObjectsBackPanel.Location = New System.Drawing.Point(0, 44)
        Me.DigitalObjectsBackPanel.Name = "DigitalObjectsBackPanel"
        Me.DigitalObjectsBackPanel.Size = New System.Drawing.Size(553, 495)
        Me.DigitalObjectsBackPanel.TabIndex = 3
        '
        'DigitalObjectsPanel
        '
        Me.DigitalObjectsPanel.Controls.Add(Me.lvwDigitalObjects)
        Me.DigitalObjectsPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.DigitalObjectsPanel.Location = New System.Drawing.Point(0, 0)
        Me.DigitalObjectsPanel.Name = "DigitalObjectsPanel"
        Me.DigitalObjectsPanel.Size = New System.Drawing.Size(553, 422)
        Me.DigitalObjectsPanel.TabIndex = 101
        '
        'lvwDigitalObjects
        '
        Me.lvwDigitalObjects.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lvwDigitalObjects.CheckBoxes = True
        Me.lvwDigitalObjects.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chDigitalObjectName, Me.chDigitalObjectOriginalName})
        Me.lvwDigitalObjects.Dock = System.Windows.Forms.DockStyle.Fill
        Me.lvwDigitalObjects.FullRowSelect = True
        Me.lvwDigitalObjects.GridLines = True
        Me.lvwDigitalObjects.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
        Me.lvwDigitalObjects.HideSelection = False
        Me.lvwDigitalObjects.Location = New System.Drawing.Point(0, 0)
        Me.lvwDigitalObjects.MultiSelect = False
        Me.lvwDigitalObjects.Name = "lvwDigitalObjects"
        Me.lvwDigitalObjects.Size = New System.Drawing.Size(553, 422)
        Me.lvwDigitalObjects.SmallImageList = Me.TreeNodeImageList
        Me.lvwDigitalObjects.TabIndex = 99
        Me.lvwDigitalObjects.View = System.Windows.Forms.View.Details
        '
        'chDigitalObjectName
        '
        Me.chDigitalObjectName.Text = "Nome do objecto digital"
        Me.chDigitalObjectName.Width = 186
        '
        'chDigitalObjectOriginalName
        '
        Me.chDigitalObjectOriginalName.Text = "Nome original do objecto digital"
        Me.chDigitalObjectOriginalName.Width = 306
        '
        'Splitter4
        '
        Me.Splitter4.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.Splitter4.Location = New System.Drawing.Point(0, 422)
        Me.Splitter4.Name = "Splitter4"
        Me.Splitter4.Size = New System.Drawing.Size(553, 3)
        Me.Splitter4.TabIndex = 100
        Me.Splitter4.TabStop = False
        '
        'DigitalObjectAssociationsPanel
        '
        Me.DigitalObjectAssociationsPanel.Controls.Add(Me.DigitalObjectAssociationsDataGrig)
        Me.DigitalObjectAssociationsPanel.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.DigitalObjectAssociationsPanel.Location = New System.Drawing.Point(0, 425)
        Me.DigitalObjectAssociationsPanel.Name = "DigitalObjectAssociationsPanel"
        Me.DigitalObjectAssociationsPanel.Size = New System.Drawing.Size(553, 70)
        Me.DigitalObjectAssociationsPanel.TabIndex = 99
        '
        'DigitalObjectAssociationsDataGrig
        '
        Me.DigitalObjectAssociationsDataGrig.AddPropertyButtonImage = CType(resources.GetObject("DigitalObjectAssociationsDataGrig.AddPropertyButtonImage"), System.Drawing.Image)
        Me.DigitalObjectAssociationsDataGrig.AllowAddNewProperty = False
        Me.DigitalObjectAssociationsDataGrig.BackColor = System.Drawing.Color.White
        Me.DigitalObjectAssociationsDataGrig.BgColor = System.Drawing.Color.White
        Me.DigitalObjectAssociationsDataGrig.Border = System.Windows.Forms.BorderStyle.None
        Me.DigitalObjectAssociationsDataGrig.Dock = System.Windows.Forms.DockStyle.Fill
        Me.DigitalObjectAssociationsDataGrig.FooterColor = System.Drawing.SystemColors.ActiveBorder
        Me.DigitalObjectAssociationsDataGrig.HeaderText = "Descries associadas"
        Me.DigitalObjectAssociationsDataGrig.Location = New System.Drawing.Point(0, 0)
        Me.DigitalObjectAssociationsDataGrig.Name = "DigitalObjectAssociationsDataGrig"
        Me.DigitalObjectAssociationsDataGrig.Size = New System.Drawing.Size(553, 70)
        Me.DigitalObjectAssociationsDataGrig.TabIndex = 0
        Me.DigitalObjectAssociationsDataGrig.TextBoxBgColor = System.Drawing.Color.White
        Me.DigitalObjectAssociationsDataGrig.TextBoxBorder = System.Windows.Forms.BorderStyle.None
        Me.DigitalObjectAssociationsDataGrig.TextBoxClickType = DigitArq.UserControls.ListDataGrid.ListDataGrid.ClickType.SingleClick
        Me.DigitalObjectAssociationsDataGrig.TextBoxFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Underline, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.DigitalObjectAssociationsDataGrig.TextBoxForeColor = System.Drawing.Color.Blue
        '
        'HeaderDigitalObjectsPanel
        '
        Me.HeaderDigitalObjectsPanel.Controls.Add(Me.lblDigitalObjectsChecked)
        Me.HeaderDigitalObjectsPanel.Dock = System.Windows.Forms.DockStyle.Top
        Me.HeaderDigitalObjectsPanel.Location = New System.Drawing.Point(0, 0)
        Me.HeaderDigitalObjectsPanel.Name = "HeaderDigitalObjectsPanel"
        Me.HeaderDigitalObjectsPanel.Size = New System.Drawing.Size(553, 44)
        Me.HeaderDigitalObjectsPanel.TabIndex = 2
        '
        'lblDigitalObjectsChecked
        '
        Me.lblDigitalObjectsChecked.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblDigitalObjectsChecked.ForeColor = System.Drawing.Color.IndianRed
        Me.lblDigitalObjectsChecked.Location = New System.Drawing.Point(12, 10)
        Me.lblDigitalObjectsChecked.Name = "lblDigitalObjectsChecked"
        Me.lblDigitalObjectsChecked.Size = New System.Drawing.Size(396, 24)
        Me.lblDigitalObjectsChecked.TabIndex = 1
        Me.lblDigitalObjectsChecked.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'FooterDigitalObjectsPanel
        '
        Me.FooterDigitalObjectsPanel.BackColor = System.Drawing.Color.WhiteSmoke
        Me.FooterDigitalObjectsPanel.Controls.Add(Me.btnBackDigitalObjects)
        Me.FooterDigitalObjectsPanel.Controls.Add(Me.btnCheckAllDigitalObjects)
        Me.FooterDigitalObjectsPanel.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.FooterDigitalObjectsPanel.Location = New System.Drawing.Point(0, 539)
        Me.FooterDigitalObjectsPanel.Name = "FooterDigitalObjectsPanel"
        Me.FooterDigitalObjectsPanel.Size = New System.Drawing.Size(553, 60)
        Me.FooterDigitalObjectsPanel.TabIndex = 0
        '
        'tpFiles
        '
        Me.tpFiles.Controls.Add(Me.DOFilesBackPanel)
        Me.tpFiles.Controls.Add(Me.Splitter2)
        Me.tpFiles.Controls.Add(Me.FooterDigitalObjectComponentsPanel)
        Me.tpFiles.Location = New System.Drawing.Point(4, 22)
        Me.tpFiles.Name = "tpFiles"
        Me.tpFiles.Size = New System.Drawing.Size(553, 599)
        Me.tpFiles.TabIndex = 1
        Me.tpFiles.Text = "Estrutura"
        Me.tpFiles.Visible = False
        '
        'DOFilesBackPanel
        '
        Me.DOFilesBackPanel.Controls.Add(Me.DOFilesPanel)
        Me.DOFilesBackPanel.Controls.Add(Me.Splitter5)
        Me.DOFilesBackPanel.Controls.Add(Me.FileAssociationsPanel)
        Me.DOFilesBackPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.DOFilesBackPanel.Location = New System.Drawing.Point(3, 0)
        Me.DOFilesBackPanel.Name = "DOFilesBackPanel"
        Me.DOFilesBackPanel.Size = New System.Drawing.Size(550, 539)
        Me.DOFilesBackPanel.TabIndex = 4
        '
        'DOFilesPanel
        '
        Me.DOFilesPanel.Controls.Add(Me.ViewerPanel)
        Me.DOFilesPanel.Controls.Add(Me.Splitter7)
        Me.DOFilesPanel.Controls.Add(Me.DigitalObjectsComponentsPanel)
        Me.DOFilesPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.DOFilesPanel.Location = New System.Drawing.Point(0, 0)
        Me.DOFilesPanel.Name = "DOFilesPanel"
        Me.DOFilesPanel.Size = New System.Drawing.Size(550, 466)
        Me.DOFilesPanel.TabIndex = 2
        '
        'ViewerPanel
        '
        Me.ViewerPanel.Controls.Add(Me.ImageViewer)
        Me.ViewerPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.ViewerPanel.Location = New System.Drawing.Point(203, 0)
        Me.ViewerPanel.Name = "ViewerPanel"
        Me.ViewerPanel.Size = New System.Drawing.Size(347, 466)
        Me.ViewerPanel.TabIndex = 5
        '
        'ImageViewer
        '
        Me.ImageViewer.Dock = System.Windows.Forms.DockStyle.Fill
        Me.ImageViewer.Filename = Nothing
        Me.ImageViewer.Image = Nothing
        Me.ImageViewer.Location = New System.Drawing.Point(0, 0)
        Me.ImageViewer.Name = "ImageViewer"
        Me.ImageViewer.SaveImageButtonVisible = False
        Me.ImageViewer.Size = New System.Drawing.Size(347, 466)
        Me.ImageViewer.TabIndex = 0
        '
        'Splitter7
        '
        Me.Splitter7.Location = New System.Drawing.Point(200, 0)
        Me.Splitter7.Name = "Splitter7"
        Me.Splitter7.Size = New System.Drawing.Size(3, 466)
        Me.Splitter7.TabIndex = 4
        Me.Splitter7.TabStop = False
        '
        'DigitalObjectsComponentsPanel
        '
        Me.DigitalObjectsComponentsPanel.Controls.Add(Me.tvwDO)
        Me.DigitalObjectsComponentsPanel.Controls.Add(Me.Panel1)
        Me.DigitalObjectsComponentsPanel.Dock = System.Windows.Forms.DockStyle.Left
        Me.DigitalObjectsComponentsPanel.Location = New System.Drawing.Point(0, 0)
        Me.DigitalObjectsComponentsPanel.Name = "DigitalObjectsComponentsPanel"
        Me.DigitalObjectsComponentsPanel.Size = New System.Drawing.Size(200, 466)
        Me.DigitalObjectsComponentsPanel.TabIndex = 3
        '
        'tvwDO
        '
        Me.tvwDO.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.tvwDO.CheckBoxes = True
        Me.tvwDO.Dock = System.Windows.Forms.DockStyle.Fill
        Me.tvwDO.ImageList = Me.TreeNodeImageList
        Me.tvwDO.Location = New System.Drawing.Point(0, 44)
        Me.tvwDO.Name = "tvwDO"
        Me.tvwDO.Size = New System.Drawing.Size(200, 422)
        Me.tvwDO.TabIndex = 96
        '
        'Panel1
        '
        Me.Panel1.Controls.Add(Me.lblFilesChecked)
        Me.Panel1.Dock = System.Windows.Forms.DockStyle.Top
        Me.Panel1.Location = New System.Drawing.Point(0, 0)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(200, 44)
        Me.Panel1.TabIndex = 0
        '
        'lblFilesChecked
        '
        Me.lblFilesChecked.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblFilesChecked.ForeColor = System.Drawing.Color.IndianRed
        Me.lblFilesChecked.Location = New System.Drawing.Point(12, 10)
        Me.lblFilesChecked.Name = "lblFilesChecked"
        Me.lblFilesChecked.Size = New System.Drawing.Size(176, 24)
        Me.lblFilesChecked.TabIndex = 1
        Me.lblFilesChecked.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Splitter5
        '
        Me.Splitter5.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.Splitter5.Location = New System.Drawing.Point(0, 466)
        Me.Splitter5.Name = "Splitter5"
        Me.Splitter5.Size = New System.Drawing.Size(550, 3)
        Me.Splitter5.TabIndex = 1
        Me.Splitter5.TabStop = False
        '
        'FileAssociationsPanel
        '
        Me.FileAssociationsPanel.Controls.Add(Me.FileAssociationsDataGrig)
        Me.FileAssociationsPanel.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.FileAssociationsPanel.Location = New System.Drawing.Point(0, 469)
        Me.FileAssociationsPanel.Name = "FileAssociationsPanel"
        Me.FileAssociationsPanel.Size = New System.Drawing.Size(550, 70)
        Me.FileAssociationsPanel.TabIndex = 0
        '
        'FileAssociationsDataGrig
        '
        Me.FileAssociationsDataGrig.AddPropertyButtonImage = CType(resources.GetObject("FileAssociationsDataGrig.AddPropertyButtonImage"), System.Drawing.Image)
        Me.FileAssociationsDataGrig.AllowAddNewProperty = False
        Me.FileAssociationsDataGrig.BgColor = System.Drawing.Color.White
        Me.FileAssociationsDataGrig.Border = System.Windows.Forms.BorderStyle.None
        Me.FileAssociationsDataGrig.Dock = System.Windows.Forms.DockStyle.Fill
        Me.FileAssociationsDataGrig.FooterColor = System.Drawing.SystemColors.ActiveBorder
        Me.FileAssociationsDataGrig.HeaderText = "Descries associadas"
        Me.FileAssociationsDataGrig.Location = New System.Drawing.Point(0, 0)
        Me.FileAssociationsDataGrig.Name = "FileAssociationsDataGrig"
        Me.FileAssociationsDataGrig.Size = New System.Drawing.Size(550, 70)
        Me.FileAssociationsDataGrig.TabIndex = 0
        Me.FileAssociationsDataGrig.TextBoxBgColor = System.Drawing.Color.White
        Me.FileAssociationsDataGrig.TextBoxBorder = System.Windows.Forms.BorderStyle.None
        Me.FileAssociationsDataGrig.TextBoxClickType = DigitArq.UserControls.ListDataGrid.ListDataGrid.ClickType.SingleClick
        Me.FileAssociationsDataGrig.TextBoxFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Underline, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.FileAssociationsDataGrig.TextBoxForeColor = System.Drawing.Color.Blue
        '
        'Splitter2
        '
        Me.Splitter2.Location = New System.Drawing.Point(0, 0)
        Me.Splitter2.MinSize = 200
        Me.Splitter2.Name = "Splitter2"
        Me.Splitter2.Size = New System.Drawing.Size(3, 539)
        Me.Splitter2.TabIndex = 3
        Me.Splitter2.TabStop = False
        '
        'FooterDigitalObjectComponentsPanel
        '
        Me.FooterDigitalObjectComponentsPanel.BackColor = System.Drawing.Color.WhiteSmoke
        Me.FooterDigitalObjectComponentsPanel.Controls.Add(Me.btnBackFiles)
        Me.FooterDigitalObjectComponentsPanel.Controls.Add(Me.btnCheckAllFiles)
        Me.FooterDigitalObjectComponentsPanel.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.FooterDigitalObjectComponentsPanel.Location = New System.Drawing.Point(0, 539)
        Me.FooterDigitalObjectComponentsPanel.Name = "FooterDigitalObjectComponentsPanel"
        Me.FooterDigitalObjectComponentsPanel.Size = New System.Drawing.Size(553, 60)
        Me.FooterDigitalObjectComponentsPanel.TabIndex = 1
        '
        'MidlePanel
        '
        Me.MidlePanel.BackColor = System.Drawing.SystemColors.Control
        Me.MidlePanel.Controls.Add(Me.btnAssociate)
        Me.MidlePanel.Dock = System.Windows.Forms.DockStyle.Left
        Me.MidlePanel.Location = New System.Drawing.Point(0, 0)
        Me.MidlePanel.Name = "MidlePanel"
        Me.MidlePanel.Size = New System.Drawing.Size(56, 625)
        Me.MidlePanel.TabIndex = 0
        '
        'Splitter3
        '
        Me.Splitter3.BackColor = System.Drawing.SystemColors.Control
        Me.Splitter3.Location = New System.Drawing.Point(300, 0)
        Me.Splitter3.Name = "Splitter3"
        Me.Splitter3.Size = New System.Drawing.Size(3, 625)
        Me.Splitter3.TabIndex = 114
        Me.Splitter3.TabStop = False
        '
        'LeftPanel
        '
        Me.LeftPanel.Controls.Add(Me.FondsTabControl)
        Me.LeftPanel.Dock = System.Windows.Forms.DockStyle.Left
        Me.LeftPanel.Location = New System.Drawing.Point(0, 0)
        Me.LeftPanel.Name = "LeftPanel"
        Me.LeftPanel.Size = New System.Drawing.Size(300, 625)
        Me.LeftPanel.TabIndex = 113
        '
        'FondsTabControl
        '
        Me.FondsTabControl.Controls.Add(Me.tpFonds)
        Me.FondsTabControl.Controls.Add(Me.tpFondsComponents)
        Me.FondsTabControl.Dock = System.Windows.Forms.DockStyle.Fill
        Me.FondsTabControl.Location = New System.Drawing.Point(0, 0)
        Me.FondsTabControl.Name = "FondsTabControl"
        Me.FondsTabControl.SelectedIndex = 0
        Me.FondsTabControl.Size = New System.Drawing.Size(300, 625)
        Me.FondsTabControl.TabIndex = 101
        '
        'tpFonds
        '
        Me.tpFonds.Controls.Add(Me.FondsPanel)
        Me.tpFonds.Controls.Add(Me.HeaderFondsPanel)
        Me.tpFonds.Controls.Add(Me.FooterFondsPanel)
        Me.tpFonds.Location = New System.Drawing.Point(4, 22)
        Me.tpFonds.Name = "tpFonds"
        Me.tpFonds.Size = New System.Drawing.Size(292, 599)
        Me.tpFonds.TabIndex = 0
        Me.tpFonds.Text = "Fundos"
        '
        'FondsPanel
        '
        Me.FondsPanel.Controls.Add(Me.lvwFonds)
        Me.FondsPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.FondsPanel.Location = New System.Drawing.Point(0, 21)
        Me.FondsPanel.Name = "FondsPanel"
        Me.FondsPanel.Size = New System.Drawing.Size(292, 518)
        Me.FondsPanel.TabIndex = 2
        '
        'lvwFonds
        '
        Me.lvwFonds.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lvwFonds.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chFonds})
        Me.lvwFonds.Dock = System.Windows.Forms.DockStyle.Fill
        Me.lvwFonds.FullRowSelect = True
        Me.lvwFonds.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
        Me.lvwFonds.HideSelection = False
        Me.lvwFonds.Location = New System.Drawing.Point(0, 0)
        Me.lvwFonds.Name = "lvwFonds"
        Me.lvwFonds.Size = New System.Drawing.Size(292, 518)
        Me.lvwFonds.SmallImageList = Me.OtherLevelIcons
        Me.lvwFonds.TabIndex = 92
        Me.lvwFonds.View = System.Windows.Forms.View.Details
        '
        'chFonds
        '
        Me.chFonds.Text = "Fundos"
        Me.chFonds.Width = 285
        '
        'OtherLevelIcons
        '
        Me.OtherLevelIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit
        Me.OtherLevelIcons.ImageSize = New System.Drawing.Size(16, 16)
        Me.OtherLevelIcons.ImageStream = CType(resources.GetObject("OtherLevelIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.OtherLevelIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'HeaderFondsPanel
        '
        Me.HeaderFondsPanel.Controls.Add(Me.txtSearch)
        Me.HeaderFondsPanel.Dock = System.Windows.Forms.DockStyle.Top
        Me.HeaderFondsPanel.Location = New System.Drawing.Point(0, 0)
        Me.HeaderFondsPanel.Name = "HeaderFondsPanel"
        Me.HeaderFondsPanel.Size = New System.Drawing.Size(292, 21)
        Me.HeaderFondsPanel.TabIndex = 1
        '
        'txtSearch
        '
        Me.txtSearch.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtSearch.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper
        Me.txtSearch.Dock = System.Windows.Forms.DockStyle.Fill
        Me.txtSearch.Location = New System.Drawing.Point(0, 0)
        Me.txtSearch.Name = "txtSearch"
        Me.txtSearch.Size = New System.Drawing.Size(292, 20)
        Me.txtSearch.TabIndex = 91
        Me.txtSearch.Text = ""
        '
        'FooterFondsPanel
        '
        Me.FooterFondsPanel.BackColor = System.Drawing.Color.WhiteSmoke
        Me.FooterFondsPanel.Controls.Add(Me.ImageButton2)
        Me.FooterFondsPanel.Controls.Add(Me.ImageButton3)
        Me.FooterFondsPanel.Controls.Add(Me.ImageButton4)
        Me.FooterFondsPanel.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.FooterFondsPanel.Enabled = False
        Me.FooterFondsPanel.Location = New System.Drawing.Point(0, 539)
        Me.FooterFondsPanel.Name = "FooterFondsPanel"
        Me.FooterFondsPanel.Size = New System.Drawing.Size(292, 60)
        Me.FooterFondsPanel.TabIndex = 0
        '
        'ImageButton2
        '
        Me.ImageButton2.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.ImageButton2.BorderColor = System.Drawing.Color.WhiteSmoke
        Me.ImageButton2.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 6.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ImageButton2.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.ImageButton2.ButtonImage = CType(resources.GetObject("ImageButton2.ButtonImage"), System.Drawing.Image)
        Me.ImageButton2.ButtonImageAlignment = System.Drawing.ContentAlignment.TopCenter
        Me.ImageButton2.ButtonShowShadow = True
        Me.ImageButton2.ButtonText = "Seleccionar"
        Me.ImageButton2.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.ImageButton2.ButtonTransparentColor = System.Drawing.Color.WhiteSmoke
        Me.ImageButton2.Enabled = False
        Me.ImageButton2.HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
        Me.ImageButton2.Location = New System.Drawing.Point(221, 1)
        Me.ImageButton2.Name = "ImageButton2"
        Me.ImageButton2.Size = New System.Drawing.Size(68, 56)
        Me.ImageButton2.TabIndex = 108
        Me.ImageButton2.ToolTip = ""
        '
        'ImageButton3
        '
        Me.ImageButton3.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.ImageButton3.BorderColor = System.Drawing.Color.WhiteSmoke
        Me.ImageButton3.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 6.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ImageButton3.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.ImageButton3.ButtonImage = CType(resources.GetObject("ImageButton3.ButtonImage"), System.Drawing.Image)
        Me.ImageButton3.ButtonImageAlignment = System.Drawing.ContentAlignment.TopCenter
        Me.ImageButton3.ButtonShowShadow = True
        Me.ImageButton3.ButtonText = "Expandir"
        Me.ImageButton3.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.ImageButton3.ButtonTransparentColor = System.Drawing.Color.WhiteSmoke
        Me.ImageButton3.Enabled = False
        Me.ImageButton3.HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
        Me.ImageButton3.Location = New System.Drawing.Point(161, 1)
        Me.ImageButton3.Name = "ImageButton3"
        Me.ImageButton3.Size = New System.Drawing.Size(57, 56)
        Me.ImageButton3.TabIndex = 107
        Me.ImageButton3.ToolTip = ""
        '
        'ImageButton4
        '
        Me.ImageButton4.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.ImageButton4.BorderColor = System.Drawing.Color.WhiteSmoke
        Me.ImageButton4.ButtonFont = New System.Drawing.Font("Microsoft Sans Serif", 6.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ImageButton4.ButtonForeColor = System.Drawing.SystemColors.ControlText
        Me.ImageButton4.ButtonImage = CType(resources.GetObject("ImageButton4.ButtonImage"), System.Drawing.Image)
        Me.ImageButton4.ButtonImageAlignment = System.Drawing.ContentAlignment.TopCenter
        Me.ImageButton4.ButtonShowShadow = True
        Me.ImageButton4.ButtonText = "Voltar"
        Me.ImageButton4.ButtonTextAlignment = System.Drawing.ContentAlignment.BottomCenter
        Me.ImageButton4.ButtonTransparentColor = System.Drawing.Color.WhiteSmoke
        Me.ImageButton4.Enabled = False
        Me.ImageButton4.HighlightBackgroundColor = System.Drawing.Color.WhiteSmoke
        Me.ImageButton4.Location = New System.Drawing.Point(4, 1)
        Me.ImageButton4.Name = "ImageButton4"
        Me.ImageButton4.Size = New System.Drawing.Size(57, 56)
        Me.ImageButton4.TabIndex = 106
        Me.ImageButton4.ToolTip = ""
        '
        'tpFondsComponents
        '
        Me.tpFondsComponents.Controls.Add(Me.FondsComponentsBackPanel)
        Me.tpFondsComponents.Controls.Add(Me.HeaderFondsComponentsPanel)
        Me.tpFondsComponents.Controls.Add(Me.FooterFondsComponentsPanel)
        Me.tpFondsComponents.Location = New System.Drawing.Point(4, 22)
        Me.tpFondsComponents.Name = "tpFondsComponents"
        Me.tpFondsComponents.Size = New System.Drawing.Size(292, 599)
        Me.tpFondsComponents.TabIndex = 1
        Me.tpFondsComponents.Text = "Estrutura"
        Me.tpFondsComponents.Visible = False
        '
        'FondsComponentsBackPanel
        '
        Me.FondsComponentsBackPanel.Controls.Add(Me.FondsComponentsPanel)
        Me.FondsComponentsBackPanel.Controls.Add(Me.Splitter6)
        Me.FondsComponentsBackPanel.Controls.Add(Me.ComponentAssociationsPanel)
        Me.FondsComponentsBackPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.FondsComponentsBackPanel.Location = New System.Drawing.Point(0, 44)
        Me.FondsComponentsBackPanel.Name = "FondsComponentsBackPanel"
        Me.FondsComponentsBackPanel.Size = New System.Drawing.Size(292, 495)
        Me.FondsComponentsBackPanel.TabIndex = 3
        '
        'FondsComponentsPanel
        '
        Me.FondsComponentsPanel.Controls.Add(Me.tvwSelectedFond)
        Me.FondsComponentsPanel.Dock = System.Windows.Forms.DockStyle.Fill
        Me.FondsComponentsPanel.Location = New System.Drawing.Point(0, 0)
        Me.FondsComponentsPanel.Name = "FondsComponentsPanel"
        Me.FondsComponentsPanel.Size = New System.Drawing.Size(292, 422)
        Me.FondsComponentsPanel.TabIndex = 5
        '
        'tvwSelectedFond
        '
        Me.tvwSelectedFond.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.tvwSelectedFond.CheckBoxes = True
        Me.tvwSelectedFond.ContextMenu = Me.cmComponents
        Me.tvwSelectedFond.Dock = System.Windows.Forms.DockStyle.Fill
        Me.tvwSelectedFond.ImageIndex = 1
        Me.tvwSelectedFond.ImageList = Me.OtherLevelIcons
        Me.tvwSelectedFond.Location = New System.Drawing.Point(0, 0)
        Me.tvwSelectedFond.Name = "tvwSelectedFond"
        Me.tvwSelectedFond.SelectedImageIndex = 1
        Me.tvwSelectedFond.Size = New System.Drawing.Size(292, 422)
        Me.tvwSelectedFond.TabIndex = 22
        '
        'Splitter6
        '
        Me.Splitter6.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.Splitter6.Location = New System.Drawing.Point(0, 422)
        Me.Splitter6.Name = "Splitter6"
        Me.Splitter6.Size = New System.Drawing.Size(292, 3)
        Me.Splitter6.TabIndex = 1
        Me.Splitter6.TabStop = False
        '
        'ComponentAssociationsPanel
        '
        Me.ComponentAssociationsPanel.Controls.Add(Me.ComponentAssociationsDataGrig)
        Me.ComponentAssociationsPanel.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.ComponentAssociationsPanel.Location = New System.Drawing.Point(0, 425)
        Me.ComponentAssociationsPanel.Name = "ComponentAssociationsPanel"
        Me.ComponentAssociationsPanel.Size = New System.Drawing.Size(292, 70)
        Me.ComponentAssociationsPanel.TabIndex = 0
        '
        'ComponentAssociationsDataGrig
        '
        Me.ComponentAssociationsDataGrig.AddPropertyButtonImage = CType(resources.GetObject("ComponentAssociationsDataGrig.AddPropertyButtonImage"), System.Drawing.Image)
        Me.ComponentAssociationsDataGrig.AllowAddNewProperty = False
        Me.ComponentAssociationsDataGrig.BgColor = System.Drawing.Color.White
        Me.ComponentAssociationsDataGrig.Border = System.Windows.Forms.BorderStyle.None
        Me.ComponentAssociationsDataGrig.Dock = System.Windows.Forms.DockStyle.Fill
        Me.ComponentAssociationsDataGrig.FooterColor = System.Drawing.SystemColors.ActiveBorder
        Me.ComponentAssociationsDataGrig.HeaderText = "Objectos digitais associados"
        Me.ComponentAssociationsDataGrig.Location = New System.Drawing.Point(0, 0)
        Me.ComponentAssociationsDataGrig.Name = "ComponentAssociationsDataGrig"
        Me.ComponentAssociationsDataGrig.Size = New System.Drawing.Size(292, 70)
        Me.ComponentAssociationsDataGrig.TabIndex = 0
        Me.ComponentAssociationsDataGrig.TextBoxBgColor = System.Drawing.Color.White
        Me.ComponentAssociationsDataGrig.TextBoxBorder = System.Windows.Forms.BorderStyle.None
        Me.ComponentAssociationsDataGrig.TextBoxClickType = DigitArq.UserControls.ListDataGrid.ListDataGrid.ClickType.SingleClick
        Me.ComponentAssociationsDataGrig.TextBoxFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Underline, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ComponentAssociationsDataGrig.TextBoxForeColor = System.Drawing.Color.Blue
        '
        'HeaderFondsComponentsPanel
        '
        Me.HeaderFondsComponentsPanel.Controls.Add(Me.lblComponentsChecked)
        Me.HeaderFondsComponentsPanel.Dock = System.Windows.Forms.DockStyle.Top
        Me.HeaderFondsComponentsPanel.Location = New System.Drawing.Point(0, 0)
        Me.HeaderFondsComponentsPanel.Name = "HeaderFondsComponentsPanel"
        Me.HeaderFondsComponentsPanel.Size = New System.Drawing.Size(292, 44)
        Me.HeaderFondsComponentsPanel.TabIndex = 2
        '
        'lblComponentsChecked
        '
        Me.lblComponentsChecked.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblComponentsChecked.ForeColor = System.Drawing.Color.IndianRed
        Me.lblComponentsChecked.Location = New System.Drawing.Point(12, 12)
        Me.lblComponentsChecked.Name = "lblComponentsChecked"
        Me.lblComponentsChecked.Size = New System.Drawing.Size(268, 24)
        Me.lblComponentsChecked.TabIndex = 0
        Me.lblComponentsChecked.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'FooterFondsComponentsPanel
        '
        Me.FooterFondsComponentsPanel.BackColor = System.Drawing.Color.WhiteSmoke
        Me.FooterFondsComponentsPanel.Controls.Add(Me.btnCheckAllComponents)
        Me.FooterFondsComponentsPanel.Controls.Add(Me.btnExpandAllComponents)
        Me.FooterFondsComponentsPanel.Controls.Add(Me.btnBackComponents)
        Me.FooterFondsComponentsPanel.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.FooterFondsComponentsPanel.Location = New System.Drawing.Point(0, 539)
        Me.FooterFondsComponentsPanel.Name = "FooterFondsComponentsPanel"
        Me.FooterFondsComponentsPanel.Size = New System.Drawing.Size(292, 60)
        Me.FooterFondsComponentsPanel.TabIndex = 1
        '
        'MenuItem4
        '
        Me.MenuItem4.Index = 8
        Me.MenuItem4.Text = "-"
        '
        'MenuItem7
        '
        Me.MenuItem7.Index = 9
        Me.MenuItem7.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miOrderByName, Me.miOrderBydate})
        Me.MenuItem7.Text = "Ordenar objectos digitais por"
        '
        'miOrderByName
        '
        Me.miOrderByName.Checked = True
        Me.miOrderByName.Index = 0
        Me.miOrderByName.Text = "Nome"
        '
        'miOrderBydate
        '
        Me.miOrderBydate.Index = 1
        Me.miOrderBydate.Text = "Data de criao"
        '
        'AssociationForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.White
        Me.ClientSize = New System.Drawing.Size(920, 665)
        Me.Controls.Add(Me.BackPanel)
        Me.Controls.Add(Me.FooterPanel)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.KeyPreview = True
        Me.Menu = Me.MainMenu
        Me.Name = "AssociationForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = CType(configurationAppSettings.GetValue("Application.Version", GetType(System.String)), String)
        Me.WindowState = System.Windows.Forms.FormWindowState.Maximized
        Me.FooterPanel.ResumeLayout(False)
        Me.BackPanel.ResumeLayout(False)
        Me.RightPanel.ResumeLayout(False)
        Me.DigitalObjectsTabControl.ResumeLayout(False)
        Me.tpDigitalObjects.ResumeLayout(False)
        Me.DigitalObjectsBackPanel.ResumeLayout(False)
        Me.DigitalObjectsPanel.ResumeLayout(False)
        Me.DigitalObjectAssociationsPanel.ResumeLayout(False)
        Me.HeaderDigitalObjectsPanel.ResumeLayout(False)
        Me.FooterDigitalObjectsPanel.ResumeLayout(False)
        Me.tpFiles.ResumeLayout(False)
        Me.DOFilesBackPanel.ResumeLayout(False)
        Me.DOFilesPanel.ResumeLayout(False)
        Me.ViewerPanel.ResumeLayout(False)
        Me.DigitalObjectsComponentsPanel.ResumeLayout(False)
        Me.Panel1.ResumeLayout(False)
        Me.FileAssociationsPanel.ResumeLayout(False)
        Me.FooterDigitalObjectComponentsPanel.ResumeLayout(False)
        Me.MidlePanel.ResumeLayout(False)
        Me.LeftPanel.ResumeLayout(False)
        Me.FondsTabControl.ResumeLayout(False)
        Me.tpFonds.ResumeLayout(False)
        Me.FondsPanel.ResumeLayout(False)
        Me.HeaderFondsPanel.ResumeLayout(False)
        Me.FooterFondsPanel.ResumeLayout(False)
        Me.tpFondsComponents.ResumeLayout(False)
        Me.FondsComponentsBackPanel.ResumeLayout(False)
        Me.FondsComponentsPanel.ResumeLayout(False)
        Me.ComponentAssociationsPanel.ResumeLayout(False)
        Me.HeaderFondsComponentsPanel.ResumeLayout(False)
        Me.FooterFondsComponentsPanel.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Private properties"

    Private myProgressDialog As ProgressDialog
    Private Database As New SqlCommands(USER_LOGON)
    Private DigitalObjectsTree As DigitalObjectsTree

    Private myProjectID As Int64
    Private myProjectName As String
    Private myDigitalObjectID As Int64 = 0
    Private mySelectedDigitalObjectID As Int64
    Private mySelectedFileID As Int64
    Private mySelectedFondID As Int64
    Private myGoFromMGOD As Boolean = False

    Private tnSearched As New ListViewItem
    Private Stoped As Boolean = False

    Private CountDOChecked As Integer
    Private CountFilesChecked As Integer
    Private CountComponentsChecked As Integer

    Private FilesCount As Integer
    Private DigitalObjectsCount As Integer
    Private ComponentsCount As Integer

    Private myImageViewer As ImageViewer
    Private myPDFViewer As PDFViewer
    Private myWordViewer As WordViewer

    Public Enum ViewDigitalObjects
        All
        Associated
        NotAssociated
    End Enum

    Private myView As View

    Private myDaoGrpCollection As DaoGrpCollection

    Dim myAssociationsPreviewForm As AssociationsPreviewForm
    Private myOrderBy As String = DIGITAL_OBJECT_NAME

#End Region

#Region "Properties"

    Property SelectedFondID() As Int64
        Get
            Return mySelectedFondID
        End Get
        Set(ByVal Value As Int64)
            mySelectedFondID = Value
        End Set
    End Property

    Property SelectedDigitalObjectID() As Int64
        Get
            Return mySelectedDigitalObjectID
        End Get
        Set(ByVal Value As Int64)
            mySelectedDigitalObjectID = Value
        End Set
    End Property

    Property SelectedFileID() As Int64
        Get
            Return mySelectedFileID
        End Get
        Set(ByVal Value As Int64)
            mySelectedFileID = Value
        End Set
    End Property

    Property OrderBy() As String
        Get
            Return myOrderBy
        End Get
        Set(ByVal Value As String)
            myOrderBY = Value
        End Set
    End Property

#End Region

#Region "Constants"

    Const EXPAND As Integer = 1
    Const COLLAPSE As Integer = 0
    Const CHECK As Integer = 1
    Const UNCHECK As Integer = 0

    Const CHECK_ALL As String = "Seleccionar"
    Const UNCHECK_ALL As String = "Desseleccionar"
    Const EXPAND_ALL As String = "Expandir"
    Const COLLAPSE_ALL As String = "Colapsar"
    Const DUMMY_FILEID As Integer = -1

    Const SelectImagePath As String = "\..\Images\select.png"

    Const DIGITAL_OBJECT_NAME = "Name"
    Const DIGITAL_OBJECT_ID = "DigitalObjectID"

#End Region

#Region "Load"

    Private Sub AssociationForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Text = GetFormTitle("[" & USER_LOGON & "]")

        If Not myGoFromMGOD Then
            Dim ProjectsForm As New ProjectsForm
            ProjectsForm.ShowDialog()
            myProjectID = ProjectsForm.ProjectID
            myProjectName = ProjectsForm.ProjectName
        End If
        myProgressDialog = New ProgressDialog(False)
        myProgressDialog.Run(New ThreadStart(AddressOf LoadFonds), InfoMessage("ProgressDialog.Load.Title"), 0, 10)
        myProgressDialog = New ProgressDialog(False)
        myProgressDialog.Run(New ThreadStart(AddressOf LoadDigitalObjectsAndCheck), InfoMessage("ProgressDialog.Load.Title"), 0, 10)
        ViewFonds()
        ViewDigitalObjectsList()
    End Sub

    Private Sub LoadDigitalObjectsAndCheck()
        myProgressDialog.Message = InfoMessage("ProgressDialog.Load.SelectDigitalObjects")
        LoadDigitalObjects(myDigitalObjectID)
    End Sub

    Private Sub LoadDigitalObjects(Optional ByVal DigitalObjectID As Int64 = 0, Optional ByVal View As ViewDigitalObjects = ViewDigitalObjects.All)
        Dim index As Integer = 0
        Dim DigitalObjectCollection As DigitalObjectCollection = Database.SelectDigitalObjects(myProjectID, Me.OrderBy)

        Me.lvwDigitalObjects.BringToFront()
        Me.lvwDigitalObjects.Items.Clear()

        For Each DigitalObject As DigitalObject In DigitalObjectCollection
            myProgressDialog.Message = String.Format("{0}...", DigitalObject.Name)
            Dim lvi As ListViewItem = New ListViewItem(DigitalObject.Name)
            lvi.SubItems.Add(DigitalObject.OriginalName)
            lvi.Tag = DigitalObject.DigitalObjectID
            If DigitalObject.Active Then
                lvi.ImageIndex = 0
            Else
                lvi.ImageIndex = 1
            End If
            If DigitalObject.Associated Then
                lvi.ForeColor = Color.Blue
            Else
                lvi.ForeColor = Color.Black
            End If
            Select Case View
                Case ViewDigitalObjects.All
                    Me.lvwDigitalObjects.Items.Add(lvi)
                Case ViewDigitalObjects.Associated
                    If DigitalObject.Associated Then Me.lvwDigitalObjects.Items.Add(lvi)
                Case ViewDigitalObjects.NotAssociated
                    If Not DigitalObject.Associated Then Me.lvwDigitalObjects.Items.Add(lvi)
            End Select
            lvi.Selected = DigitalObject.DigitalObjectID = DigitalObjectID
            myProgressDialog.Increment()
        Next
        DigitalObjectsCount = Me.lvwDigitalObjects.Items.Count
        ResizeLvwDigitalObjects()
        Me.CountDOChecked = 0
        WriteDigitalObjectsCount()
    End Sub

    Private Sub LoadFonds()
        myProgressDialog.Message = InfoMessage("ProgressDialog.Load.SelectFonds")
        Dim Fonds As ComponentCollection = Database.SelectAllFonds()

        Me.lvwFonds.View = View.Details
        Me.lvwFonds.LabelEdit = False
        Me.lvwFonds.FullRowSelect = True

        Me.lvwFonds.Items.Clear()
        For Each Fond As Components In Fonds
            myProgressDialog.Message = String.Format("{0}...", Fond.UnitID)
            Dim lvi As ListViewItem = New ListViewItem(String.Format("{0} {1}", Fond.UnitID, Fond.UnitTitle))
            lvi.Tag = Fond.ID
            lvi.ImageIndex = GetOtherLevelIndex(Fond.OtherLevel)
            Me.lvwFonds.Items.Add(lvi)
            myProgressDialog.Increment()
        Next
        WriteFondsCount()
    End Sub

#End Region

#Region "Form"

    Private Sub Association_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        If e.KeyCode = Keys.Escape Then
            Me.Close()
        End If
    End Sub

    Private Sub txtSearch_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtSearch.KeyDown
        If e.KeyCode <> Keys.Enter Then Exit Sub

        Dim Item As ListViewItem
        Dim ItemToSelect As ListViewItem = Nothing
        For Each Item In Me.lvwFonds.Items
            If Item.Text.ToUpper.IndexOf(Me.txtSearch.Text.ToUpper) >= 0 Then
                ItemToSelect = Item
                Exit For
            End If
        Next

        If Not ItemToSelect Is Nothing Then
            lvwFonds.Focus()
            lvwFonds.MultiSelect = False
            ItemToSelect.Selected = True
            ItemToSelect.Focused = True
            ItemToSelect.EnsureVisible()
            lvwFonds.MultiSelect = True
        End If
    End Sub

    Private Sub AssociationForm_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        ResizeLvwDigitalObjects()
    End Sub

    Private Sub ResizeLvwDigitalObjects()
        Me.lvwDigitalObjects.Columns(1).Width = Me.lvwDigitalObjects.Width - Me.lvwDigitalObjects.Columns(0).Width - 20
    End Sub

#End Region

#Region "Menus"

#Region "miProjects"

    Private Sub miOpenProjects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miOpenProjects.Click
        myGoFromMGOD = False
        Dim ProjectsForm As New ProjectsForm
        ProjectsForm.ShowDialog()
        myProjectID = ProjectsForm.ProjectID
        myProjectName = ProjectsForm.ProjectName
        LoadDigitalObjects()
    End Sub

    Private Sub miClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miClose.Click
        Me.Close()
    End Sub

#End Region

#Region "miView"

    Private Sub miViewAllDigitalObjects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewAllDigitalObjects.Click
        If Me.miViewAllDigitalObjects.Checked Then
            Me.miViewAllDigitalObjects.Checked = False
        Else
            Me.miViewAllDigitalObjects.Checked = True
            Me.miViewAssociatedDigitalObjects.Checked = False
            Me.miViewNotAssociatedDigitalObjects.Checked = False
            LoadDigitalObjects(0, ViewDigitalObjects.All)
        End If
    End Sub

    Private Sub miViewAssociatedDigitalObjects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewAssociatedDigitalObjects.Click
        If Me.miViewAssociatedDigitalObjects.Checked Then
            Me.miViewAssociatedDigitalObjects.Checked = False
        Else
            Me.miViewAllDigitalObjects.Checked = False
            Me.miViewAssociatedDigitalObjects.Checked = True
            Me.miViewNotAssociatedDigitalObjects.Checked = False
            LoadDigitalObjects(0, ViewDigitalObjects.Associated)
        End If
    End Sub

    Private Sub miViewNotAssociatedDigitalObjects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewNotAssociatedDigitalObjects.Click
        If Me.miViewNotAssociatedDigitalObjects.Checked Then
            Me.miViewNotAssociatedDigitalObjects.Checked = True
        Else
            Me.miViewAllDigitalObjects.Checked = False
            Me.miViewAssociatedDigitalObjects.Checked = False
            Me.miViewNotAssociatedDigitalObjects.Checked = True
            LoadDigitalObjects(0, ViewDigitalObjects.NotAssociated)
        End If
    End Sub

    Private Sub miViewComponentAssociationsPanel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewComponentAssociationsPanel.Click
        If Me.miViewComponentAssociationsPanel.Checked Then
            Me.ComponentAssociationsPanel.Hide()
            Me.miViewComponentAssociationsPanel.Checked = False
        Else
            Me.ComponentAssociationsPanel.Show()
            Me.miViewComponentAssociationsPanel.Checked = True
        End If
    End Sub

    Private Sub miViewDigitalObjectAssociationsPanel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewDigitalObjectAssociationsPanel.Click
        If Me.miViewDigitalObjectAssociationsPanel.Checked Then
            Me.DigitalObjectAssociationsPanel.Hide()
            Me.miViewDigitalObjectAssociationsPanel.Checked = False
        Else
            Me.DigitalObjectAssociationsPanel.Show()
            Me.miViewDigitalObjectAssociationsPanel.Checked = True
        End If
    End Sub

    Private Sub miViewFileAssociationsPanel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewFileAssociationsPanel.Click
        If Me.miViewFileAssociationsPanel.Checked Then
            Me.FileAssociationsPanel.Hide()
            Me.miViewFileAssociationsPanel.Checked = False
        Else
            Me.FileAssociationsPanel.Show()
            Me.miViewFileAssociationsPanel.Checked = True
        End If
    End Sub

    Private Sub miViewFonds_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewFonds.Click
        ViewFonds()
    End Sub

    Private Sub miViewComponents_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewComponents.Click
        If Me.lvwFonds.SelectedItems.Count = 0 Then Return
        LoadTvwSelectedFond(Me.lvwFonds.SelectedItems(0).Tag)
    End Sub

    Private Sub miViewDigitalObjects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewDigitalObjects.Click
        ViewDigitalObjectsList()
    End Sub

    Private Sub miViewFiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miViewFiles.Click
        If Me.lvwDigitalObjects.SelectedItems.Count = 0 Then Return
        LoadTvwFiles(Me.lvwDigitalObjects.SelectedItems(0).Tag)
    End Sub

    Private Sub miOrderByName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miOrderByName.Click
        'If Not Me.miOrderByName.Checked Then
        Me.miOrderByName.Checked = True
        Me.miOrderBydate.Checked = False
        Me.OrderBy = DIGITAL_OBJECT_NAME
        LoadDigitalObjects(myProjectID)
        'End If
    End Sub

    Private Sub miOrderBydate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miOrderBydate.Click
        'If Not Me.miOrderByDate.Checked Then
        Me.miOrderBydate.Checked = True
        Me.miOrderByName.Checked = False
        Me.OrderBy = DIGITAL_OBJECT_ID
        LoadDigitalObjects(myProjectID)
        'End If
    End Sub

#End Region

#Region "miReports"

    Private Sub miUIDigitalization_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miUIDigitalization.Click
        If Me.lvwFonds.SelectedItems.Count = 0 Then
            MsgBox(InfoMessage("Reports.SelectFonds"), MsgBoxStyle.Information)
        Else
            Dim RepDSBuilder As New ReportDataSetBuilder
            Dim ReportDataSet As UIDigitalizationData = RepDSBuilder.GenerateUIDigitalizationReportData(Me.lvwFonds.SelectedItems)

            Dim Report As New UIDigitalizationReport
            Report.SetDataSource(ReportDataSet)
            Dim viewReport As New ReportPreviewForm(Report)
            viewReport.Show()
        End If
    End Sub

    Private Sub miDigitarqOD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miDigitarqOD.Click
        If Me.lvwFonds.SelectedItems.Count = 0 Then
            MsgBox(InfoMessage("Reports.SelectFonds"), MsgBoxStyle.Information)
        Else
            Dim RepDSBuilder As New ReportDataSetBuilder
            Dim ReportDataSet As DigitarqODData = RepDSBuilder.GenerateDigitarqDOReportData(Me.lvwFonds.SelectedItems(0).Tag)

            Dim Report As New DigitarqDOReport
            Report.SetDataSource(ReportDataSet)
            Dim viewReport As New ReportPreviewForm(Report)
            viewReport.Show()
        End If
    End Sub

#End Region

#Region "miTools"

    Private Sub miAutoAssociation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miAutoAssociation.Click
        If SelectedFondID = 0 Then
            If MsgBox(InfoMessage("AssociationPreview.AlertMessage"), MsgBoxStyle.Question Or MsgBoxStyle.YesNo) = MsgBoxResult.No Then Return
        End If
        'myDaoGrpCollection = New DaoGrpCollection

        If Me.DigitalObjectsTabControl.SelectedTab Is Me.tpDigitalObjects Then
            FindDigitalObjectAssociations()
        End If
    End Sub

    Private Sub FindDigitalObjectAssociations()
        myAssociationsPreviewForm = New AssociationsPreviewForm
        myAssociationsPreviewForm.ShowDialog(Me)

        Dim Thread As Thread = New Thread(New ThreadStart(AddressOf PreviewDigitalObjectAssociations))
        Thread.Start()

        While Thread.IsAlive
            System.Windows.Forms.Application.DoEvents()
        End While
    End Sub

    Private Sub PreviewDigitalObjectAssociations()
        Dim Count As Integer = 0
        For Each lvi As ListViewItem In Me.lvwDigitalObjects.Items
            If myAssociationsPreviewForm.Cancel Then Exit For
            Count += 1
            Dim Component As Components = Database.FindComponentID(lvi.Text, SelectedFondID)
            If Not Component Is Nothing Then
                Dim DaoGrp As New DaoGrp(Component.ID, lvi.Tag, -1)
                DaoGrp.CompleteUnitID = Component.CompleteUnitID
                DaoGrp.OtherLevel = Component.OtherLevel
                DaoGrp.DigitalObjectName = lvi.Text
                myAssociationsPreviewForm.AddNewSingleValue(DaoGrp.CompleteUnitID, DaoGrp.DigitalObjectName, DaoGrp)
                myAssociationsPreviewForm.Message = String.Format(InfoMessage("AssociationPreview.InfoMessage"), Count, Me.lvwDigitalObjects.Items.Count)
            End If
        Next
        myAssociationsPreviewForm.ButtonAssociateEnabled = True
    End Sub

    'Private Sub PreviewDigitalObjectAssociations()
    '    Dim Count As Integer = 0
    '    For Each lvi As ListViewItem In Me.lvwDigitalObjects.Items
    '        Count += 1
    '        Dim Component As MGOD.Components = Database.FindComponentID(lvi.Text, SelectedFondID)
    '        If Not Component Is Nothing Then
    '            Dim DaoGrp As New DaoGrp(Component.ID, lvi.Tag, -1)
    '            DaoGrp.CompleteUnitID = Component.CompleteUnitID
    '            DaoGrp.DigitalObjectName = lvi.Text
    '            myAssociationsPreviewForm.AddNewSingleValue(DaoGrp.CompleteUnitID, DaoGrp.DigitalObjectName, DaoGrp)
    '            myAssociationsPreviewForm.Message = String.Format(InfoMessage("AssociationPreview.InfoMessage"), Count, Me.lvwDigitalObjects.Items.Count)
    '        End If
    '    Next
    '    myAssociationsPreviewForm.ButtonAssociateEnabled = True
    'End Sub

#End Region

#End Region

#Region "Association"

#Region "Perform association"

    Private Sub btnAssociate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAssociate.Click
        Dim ComponentsChecked As New ArrayList
        Dim DigitalObjectsChecked As New ArrayList
        Dim DaoGrpCollection As DaoGrpCollection
        GetTreeNodesChecked(Me.tvwSelectedFond.Nodes(0), ComponentsChecked)

        If Me.DigitalObjectsTabControl.SelectedTab Is Me.tpDigitalObjects Then
            For Each lvi As ListViewItem In Me.lvwDigitalObjects.CheckedItems
                DigitalObjectsChecked.Add(lvi.Tag)
            Next
            DaoGrpCollection = GetDaoGrpCollection(ComponentsChecked, DigitalObjectsChecked, DaoGrp.AssociationType.DigitalObject)
            Associate(DaoGrpCollection)
        ElseIf Me.DigitalObjectsTabControl.SelectedTab Is Me.tpFiles Then
            GetTreeNodesChecked(Me.tvwDO.Nodes(0), DigitalObjectsChecked)
            DaoGrpCollection = GetDaoGrpCollection(ComponentsChecked, DigitalObjectsChecked, DaoGrp.AssociationType.DOFile)
            Associate(DaoGrpCollection)
        End If
    End Sub

    Private Function GetDaoGrpCollection(ByVal ComponentsChecked As ArrayList, ByVal DigitalObjectsChecked As ArrayList, ByVal Type As DaoGrp.AssociationType) As DaoGrpCollection
        Dim DigitalObjectID, ComponentID, FileID As Int64
        Dim DaoGrpCollection As New DaoGrpCollection

        Select Case Type
            Case DaoGrp.AssociationType.DigitalObject
                FileID = DUMMY_FILEID
            Case DaoGrp.AssociationType.DOFile
                DigitalObjectID = Me.tvwDO.Nodes(0).Tag
        End Select
        If (ComponentsChecked.Count = DigitalObjectsChecked.Count) Then
            For i As Integer = 0 To ComponentsChecked.Count - 1
                ComponentID = CType(ComponentsChecked(i), Int64)
                Select Case Type
                    Case DaoGrp.AssociationType.DigitalObject
                        DigitalObjectID = CType(DigitalObjectsChecked(i), Int64)
                    Case DaoGrp.AssociationType.DOFile
                        FileID = CType(DigitalObjectsChecked(i), Int64)
                End Select
                DaoGrpCollection.Add(New DaoGrp(ComponentID, DigitalObjectID, FileID))
            Next
        ElseIf ComponentsChecked.Count > 1 And DigitalObjectsChecked.Count = 1 Then
            Select Case Type
                Case DaoGrp.AssociationType.DigitalObject
                    DigitalObjectID = CType(DigitalObjectsChecked(0), Int64)
                Case DaoGrp.AssociationType.DOFile
                    FileID = CType(DigitalObjectsChecked(0), Int64)
            End Select
            For i As Integer = 0 To ComponentsChecked.Count - 1
                ComponentID = CType(ComponentsChecked(i), Int64)
                DaoGrpCollection.Add(New DaoGrp(ComponentID, DigitalObjectID, FileID))
            Next
        ElseIf CountComponentsChecked = 1 And CountDOChecked > 1 Then
            ComponentID = CType(ComponentsChecked(0), Int64)
            For i As Integer = 0 To DigitalObjectsChecked.Count - 1
                Select Case Type
                    Case SqlCommands.AssociationType.DigitalObject
                        DigitalObjectID = CType(DigitalObjectsChecked(i), Int64)
                    Case SqlCommands.AssociationType.File
                        FileID = CType(DigitalObjectsChecked(i), Int64)
                End Select
                DaoGrpCollection.Add(New DaoGrp(ComponentID, DigitalObjectID, FileID))
            Next
        End If
        Return DaoGrpCollection
    End Function

    Public Sub Associate(ByVal DaoGrpCollection As DaoGrpCollection)
        If DaoGrpCollection Is Nothing Then Return
        Dim DigitalObjectsChecked, ComponentsChecked As ArrayList
        Dim Count As Integer = 0
        Try
            Me.Cursor = Cursors.WaitCursor

            For Each DaoGrp As DaoGrp In DaoGrpCollection
                If Database.InsertDaoGrp(DaoGrp.ComponentID, DaoGrp.DigitalObjectID, DaoGrp.FileID, DaoGrp.Type) Then
                    Count += 1
                Else
                    'MsgBox(InfoMessage("AssociationAlreadyExists"), MsgBoxStyle.Exclamation)
                End If
            Next

            If Me.DigitalObjectsTabControl.SelectedTab Is Me.tpDigitalObjects Then
                DigitalObjectsChecked = New ArrayList
                ComponentsChecked = New ArrayList
                For Each DaoGrp As DaoGrp In DaoGrpCollection
                    ComponentsChecked.Add(daogrp.ComponentID)
                    DigitalObjectsChecked.Add(daogrp.DigitalObjectID)
                Next
                UpdateLvw(Me.lvwDigitalObjects, DigitalObjectsChecked)
                If Me.lvwDigitalObjects.SelectedItems.Count > 0 Then LoadDigitalObjectAssociations(Me.lvwDigitalObjects.SelectedItems(0).Tag)
            ElseIf Me.DigitalObjectsTabControl.SelectedTab Is Me.tpFiles Then
                DigitalObjectsChecked = New ArrayList
                ComponentsChecked = New ArrayList
                For Each DaoGrp As DaoGrp In DaoGrpCollection
                    ComponentsChecked.Add(daogrp.ComponentID)
                    DigitalObjectsChecked.Add(daogrp.FileID)
                Next
                UpdateTvw(Me.tvwDO.Nodes(0), DigitalObjectsChecked)
                If Not Me.tvwDO.SelectedNode Is Nothing Then LoadFileAssociations(Me.tvwDO.Tag, Me.tvwDO.SelectedNode.Tag)
            End If
            If Me.FondsTabControl.SelectedTab Is Me.tpFondsComponents Then UpdateTvw(Me.tvwSelectedFond.Nodes(0), ComponentsChecked)
            If Not Me.tvwSelectedFond.SelectedNode Is Nothing Then LoadComponentAssociations(Me.tvwSelectedFond.SelectedNode.Tag)
            Me.lblStatus.Text = String.Format(InfoMessage("AssociationResult"), Count)
            Me.lblStatus.ForeColor = Color.Green

            Me.Cursor = Cursors.Default
        Catch ex As Exception
            MsgBoxException(ex)
        End Try
    End Sub

    Private Sub UpdateTvw(ByVal ParentTreeNode As TreeNode, ByVal ArrayList As ArrayList)
        If ArrayList.Contains(ParentTreeNode.Tag) Then
            ParentTreeNode.ForeColor = Color.Blue
            ParentTreeNode.Checked = False
        End If
        For Each tn As TreeNode In ParentTreeNode.Nodes
            If tn.GetNodeCount(False) > 0 Then
                Call UpdateTvw(tn, ArrayList)
            ElseIf ArrayList.Contains(tn.Tag) Then
                tn.ForeColor = Color.Blue
                tn.Checked = False
            End If
        Next
    End Sub

    Private Sub UpdateLvw(ByVal ListView As ListView, ByVal ArrayList As ArrayList)
        For Each lvi As ListViewItem In ListView.Items
            If ArrayList.Contains(lvi.Tag) Then
                lvi.ForeColor = Color.Blue
                lvi.Checked = False
            End If
        Next
    End Sub

    Public Sub GetTreeNodesChecked(ByVal ParentTreeNode As TreeNode, ByVal ArrayList As ArrayList)
        If ParentTreeNode.Checked Then ArrayList.Add(ParentTreeNode.Tag)
        For Each tn As TreeNode In ParentTreeNode.Nodes
            If tn.GetNodeCount(False) > 0 Then
                Call GetTreeNodesChecked(tn, ArrayList)
            ElseIf tn.Checked Then
                ArrayList.Add(tn.Tag)
            End If
        Next
    End Sub

#End Region

#Region "Load associations"

    Private Sub LoadDigitalObjectAssociations(ByVal DigitalObjectID As Int64)
        If Not Me.miViewDigitalObjectAssociationsPanel.Checked Then Return
        Dim DaoGrpCollection As DaoGrpCollection = Database.SelectDigitalObjectAssociations(DigitalObjectID)
        Me.DigitalObjectAssociationsDataGrig.Clear()
        Dim Max As Integer = GetMaxLength(DaoGrpCollection, "CompleteUnitID")
        For Each DaoGrp As DaoGrp In DaoGrpCollection
            Dim Value As String = String.Format("{0} - {1}", DaoGrp.CompleteUnitID.PadRight(Max), DaoGrp.UnitTitle)
            Me.DigitalObjectAssociationsDataGrig.AddNewSingleValueProperty(DigitalObjectID, Value, DaoGrp, True)
        Next
    End Sub

    Private Sub LoadFileAssociations(ByVal DigitalObjectID As Int64, ByVal FileID As Int64)
        If Not Me.miViewFileAssociationsPanel.Checked Then Return
        Dim DaoGrpCollection As DaoGrpCollection = Database.SelectDigitalObjectAssociations(DigitalObjectID, FileID)
        Me.FileAssociationsDataGrig.Clear()
        Dim Max As Integer = GetMaxLength(DaoGrpCollection, "CompleteUnitID")
        For Each DaoGrp As DaoGrp In DaoGrpCollection
            Dim Value As String = String.Format("{0} - {1}", DaoGrp.CompleteUnitID.PadRight(Max), DaoGrp.UnitTitle)
            Me.FileAssociationsDataGrig.AddNewSingleValueProperty(DigitalObjectID, Value, DaoGrp, True)
        Next
    End Sub

    Private Sub LoadComponentAssociations(ByVal ComponentID As Int64)
        If Not Me.miViewComponentAssociationsPanel.Checked Then Return
        Dim DaoGrpCollection As DaoGrpCollection = Database.SelectComponentAssociations(ComponentID)
        Me.ComponentAssociationsDataGrig.Clear()
        Dim ProjectNameMaxLength = GetMaxLength(DaoGrpCollection, "ProjectName")
        Dim DigitalObjectNameMaxLength = GetMaxLength(DaoGrpCollection, "DigitalObjectName")
        For Each DaoGrp As DaoGrp In DaoGrpCollection
            Dim Value As String = String.Format("{0} - {1} - {2}", DaoGrp.ProjectName.PadRight(ProjectNameMaxLength), DaoGrp.DigitalObjectName.PadRight(DigitalObjectNameMaxLength), DaoGrp.FileName)
            Me.ComponentAssociationsDataGrig.AddNewSingleValueProperty(ComponentID, Value.Trim.TrimEnd("-").Trim, DaoGrp, True)
        Next
    End Sub

    Private Function GetMaxLength(ByVal DaoGrpCollection As DaoGrpCollection, ByVal Field As String) As Integer
        Dim Max As Integer = 0
        For Each DaoGrp As DaoGrp In DaoGrpCollection
            Select Case Field
                Case "CompleteUnitID"
                    If DaoGrp.CompleteUnitID.Length > Max Then Max = DaoGrp.CompleteUnitID.Length
                Case "ProjectName"
                    If DaoGrp.ProjectName.Length > Max Then Max = DaoGrp.ProjectName.Length
                Case "DigitalObjectName"
                    If DaoGrp.ProjectName.Length > Max Then Max = DaoGrp.ProjectName.Length
            End Select
        Next
        Return Max
    End Function

#End Region

#Region "Remove associations"

    Private Sub RemoveDigitalObjectAssociation(ByVal Index As Integer)
        If MsgBox("Deseja remover esta associao?", MsgBoxStyle.YesNo Or MsgBoxStyle.DefaultButton2 Or MsgBoxStyle.Exclamation) = MsgBoxResult.Yes Then
            Me.Cursor = Cursors.WaitCursor
            Dim DaoGrp As DaoGrp = Me.DigitalObjectAssociationsDataGrig.PropertyCollection.Item(Index).Tag
            Database.DeleteAssociation(DaoGrp.ComponentID, DaoGrp.DigitalObjectID, DaoGrp.FileID)
            If Me.DigitalObjectAssociationsDataGrig.Count = 1 Then
                Me.lvwDigitalObjects.SelectedItems(0).ForeColor = Color.Black
            End If
            Me.Cursor = Cursors.Default
        End If
    End Sub

    Private Sub RemoveFileAssociation(ByVal Index As Integer)
        If MsgBox("Deseja remover esta associao?", MsgBoxStyle.YesNo Or MsgBoxStyle.DefaultButton2 Or MsgBoxStyle.Exclamation) = MsgBoxResult.Yes Then
            Me.Cursor = Cursors.WaitCursor
            Dim DaoGrp As DaoGrp = Me.FileAssociationsDataGrig.PropertyCollection.Item(Index).Tag
            Database.DeleteAssociation(DaoGrp.ComponentID, DaoGrp.DigitalObjectID, DaoGrp.FileID)
            If Me.FileAssociationsDataGrig.Count = 1 Then
                If Not Me.tvwDO.SelectedNode Is Nothing Then Me.tvwDO.SelectedNode.ForeColor = Color.Black
            End If
            Me.Cursor = Cursors.Default
        End If
    End Sub

    Private Sub RemoveComponentAssociation(ByVal Index As Integer)
        If MsgBox("Deseja remover esta associao?", MsgBoxStyle.YesNo Or MsgBoxStyle.DefaultButton2 Or MsgBoxStyle.Exclamation) = MsgBoxResult.Yes Then
            Me.Cursor = Cursors.WaitCursor
            Dim DaoGrp As DaoGrp = Me.ComponentAssociationsDataGrig.PropertyCollection.Item(Index).Tag
            Database.DeleteAssociation(DaoGrp.ComponentID, DaoGrp.DigitalObjectID, DaoGrp.FileID)
            If Me.ComponentAssociationsDataGrig.Count = 1 Then
                If Not Me.tvwSelectedFond.SelectedNode Is Nothing Then Me.tvwSelectedFond.SelectedNode.ForeColor = Color.Black
            End If
            Me.Cursor = Cursors.Default
        End If
    End Sub

#End Region

#Region "Go to related record"

    Private Sub DigitalObjectAssociation_DoubleClick(ByVal Index As Integer)
        Me.Cursor = Cursors.WaitCursor
        Dim DaoGrp As DaoGrp = Me.DigitalObjectAssociationsDataGrig.PropertyCollection.Item(Index).Tag
        LoadTvwSelectedFond(DaoGrp.ParentFondsID, DaoGrp.ComponentID)
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub FileAssociation_DoubleClick(ByVal Index As Integer)
        Me.Cursor = Cursors.WaitCursor
        Dim DaoGrp As DaoGrp = Me.FileAssociationsDataGrig.PropertyCollection.Item(Index).Tag
        LoadTvwSelectedFond(DaoGrp.ParentFondsID, DaoGrp.ComponentID)
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub ComponentAssociation_DoubleClick(ByVal Index As Integer)
        Me.Cursor = Cursors.WaitCursor
        Dim DaoGrp As DaoGrp = Me.ComponentAssociationsDataGrig.PropertyCollection.Item(Index).Tag
        If DaoGrp.FileID = DUMMY_FILEID Then
            ViewDigitalObjectsList()
            For Each lvi As ListViewItem In Me.lvwDigitalObjects.Items
                If lvi.Tag = DaoGrp.DigitalObjectID Then
                    lvi.Selected = True
                    Exit For
                End If
            Next
        Else
            LoadTvwFiles(DaoGrp.DigitalObjectID)
            Dim TreeNode As TreeNode = DigitalObjectsTree.FindTreeNode(Me.tvwDO.Nodes(0), DaoGrp.FileID)
            If TreeNode Is Nothing Then Return
            Me.tvwDO.SelectedNode = TreeNode
        End If
        Me.Cursor = Cursors.Default
    End Sub

#End Region

#End Region

#Region "Fonds event handlers"

    Private Sub lvwFonds_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvwFonds.DoubleClick
        If Me.lvwFonds.SelectedItems.Count = 0 Then Return
        SelectedFondID = Me.lvwFonds.SelectedItems(0).Tag
        LoadTvwSelectedFond(SelectedFondID)
    End Sub

    Private Sub LoadTvwSelectedFond(ByVal FondsID As Int64, Optional ByVal ComponentID As Int64 = 0)
        tvwSelectedFond.Nodes.Clear()
        LoadFondsTree(FondsID, ComponentID)
        If ComponentID = 0 Then
            Me.tvwSelectedFond.Nodes(0).EnsureVisible()
            Me.tvwSelectedFond.Nodes(0).Expand()
        End If
        ViewComponents()
        WriteComponentsCount(FondsID)
    End Sub

    Private Sub WriteFondsCount()
        Me.tpFonds.Text = String.Format(InfoMessage("Association.FondsCount"), Me.lvwFonds.Items.Count)
    End Sub

#End Region

#Region "Fonds components event handlers"

    Private Sub tvwSelectedFond_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles tvwSelectedFond.AfterSelect
        If e.Node Is Nothing Then Return
        LoadComponentAssociations(e.Node.Tag)
        If Me.ComponentAssociationsDataGrig.Count > 0 Then
            e.Node.ForeColor = Color.Blue
        Else
            e.Node.ForeColor = Color.Black
        End If
    End Sub

    Private Sub tvwSelectedFond_AfterCheck(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles tvwSelectedFond.AfterCheck
        If e.Node.Checked Then
            CountComponentsChecked += 1
        Else
            CountComponentsChecked -= 1
        End If
        If CountComponentsChecked = ComponentsCount Then
            DrawCheckButton(Me.btnCheckAllComponents, False)

        ElseIf CountComponentsChecked <= ComponentsCount Then
            DrawCheckButton(Me.btnCheckAllComponents, True)

        End If
        WriteComponentsChecked()
        WriteAssociationType()
    End Sub

    Private Sub tvwSelectedFond_AfterCollapse(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles tvwSelectedFond.AfterCollapse
        If e.Node Is tvwSelectedFond.Nodes(0) And Me.btnExpandAllComponents.Tag = EXPAND Then
            DrawExpandButton(Me.btnExpandAllComponents, True)
        End If
    End Sub

    Private Sub tvwSelectedFond_AfterExpand(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles tvwSelectedFond.AfterExpand
        If e.Node Is tvwSelectedFond.Nodes(0) And Me.btnExpandAllComponents.Tag = COLLAPSE Then
            DrawExpandButton(Me.btnExpandAllComponents, False)
        End If
        If e.Node.Nodes(0).Text.Equals("__DUMMY__") Then GetChildren(e.Node)
    End Sub

    Private Sub tvwSelectedFond_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles tvwSelectedFond.MouseUp
        If e.Button = MouseButtons.Right Then
            Dim TreeNode As TreeNode = Me.tvwSelectedFond.GetNodeAt(e.X, e.Y)
            If Not TreeNode Is Nothing Then
                Me.tvwSelectedFond.SelectedNode = TreeNode
                If TreeNode.GetNodeCount(False) > 0 Then
                    FormatContextMenu(TreeNode)
                    'cmComponents.Show(Me, New Point(e.X, e.Y))
                End If
            End If
        End If
    End Sub

    Private Sub FormatContextMenu(ByVal TreeNode As TreeNode)
        Dim check As Boolean = True
        Me.miCheckChild.Text = InfoMessage("MenuItem.CheckChilds.Check")
        For Each tn As TreeNode In TreeNode.Nodes
            If tn.Checked = False Then
                Me.miCheckChild.Text = InfoMessage("MenuItem.CheckChilds.Uncheck")
                Exit For
            End If
        Next
        For Each tn As TreeNode In Me.tvwSelectedFond.SelectedNode.Nodes
            If tn.Checked = True Then
                check = False
                Exit For
            End If
        Next
        For Each tn As TreeNode In Me.tvwSelectedFond.SelectedNode.Nodes
            If check <> tn.Checked Then
                tn.Checked = check
            End If
        Next
    End Sub

    Private Function WriteComponentsChecked() As Integer
        Me.lblComponentsChecked.Text = String.Format(InfoMessage("Association.lblItemsChecked"), CStr(CountComponentsChecked))
    End Function

    Private Sub btnBackComponents_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBackComponents.Click
        ViewFonds()
    End Sub

    Private Sub btnExpandAllComponents_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExpandAllComponents.Click
        If Me.btnExpandAllComponents.Tag = EXPAND Then
            Me.tvwSelectedFond.CollapseAll()
            DrawExpandButton(Me.btnExpandAllComponents, True)
            Me.btnExpandAllComponents.ToolTip = InfoMessage("Association.ttExpandAll")
        ElseIf Me.btnExpandAllComponents.Tag = COLLAPSE Then
            myProgressDialog = New ProgressDialog(True)
            myProgressDialog.Run(New ThreadStart(AddressOf ExpandAllComponents), InfoMessage("ProgressDialog.ExpandAll.Title"), 0, ComponentsCount)
            DrawExpandButton(Me.btnExpandAllComponents, False)
            Me.btnExpandAllComponents.ToolTip = InfoMessage("Association.ttCollapseAll")
        End If
    End Sub

    Private Sub ExpandAllComponents()
        ExpandAll(Me.tvwSelectedFond.Nodes(0))
    End Sub

    Private Sub btnCheckAllComponents_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheckAllComponents.Click
        If tvwSelectedFond.GetNodeCount(False) > 0 Then
            If Me.btnCheckAllComponents.Tag = CHECK Then
                myProgressDialog = New ProgressDialog(True)
                myProgressDialog.Run(New ThreadStart(AddressOf UnCheckAllComponents), InfoMessage("ProgressDialog.UnselectAll.Title"), 0, ComponentsCount)
                CountComponentsChecked = 0
                Me.btnCheckAllComponents.ToolTip = InfoMessage("Association.ttCheckAll")
            ElseIf Me.btnCheckAllComponents.Tag = UNCHECK Then
                myProgressDialog = New ProgressDialog(True)
                myProgressDialog.Run(New ThreadStart(AddressOf CheckAllComponents), InfoMessage("ProgressDialog.SelectAll.Title"), 0, ComponentsCount)
                CountComponentsChecked = ComponentsCount
                Me.btnCheckAllComponents.ToolTip = InfoMessage("Association.ttUnCheckAll")
            End If
        End If
        WriteComponentsChecked()
    End Sub

    Private Sub CheckAllComponents()
        CheckTreeNodes(Me.tvwSelectedFond.Nodes(0), True)
    End Sub

    Private Sub UnCheckAllComponents()
        CheckTreeNodes(Me.tvwSelectedFond.Nodes(0), False)
    End Sub

    Private Sub WriteComponentsCount(ByVal FondsID As Int64)
        ComponentsCount = Database.SelectComponentsCount(FondsID)
        Me.tpFondsComponents.Text = String.Format(InfoMessage("Association.ComponentsCount"), ComponentsCount)
    End Sub

#End Region

#Region "Digital objects event handlers"

    Private Sub lvwDigitalObjects_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvwDigitalObjects.SelectedIndexChanged
        If Me.lvwDigitalObjects.SelectedItems.Count = 0 Then Return
        Dim ListViewItem As ListViewItem = Me.lvwDigitalObjects.SelectedItems(0)
        LoadDigitalObjectAssociations(ListViewItem.Tag)
        If Me.DigitalObjectAssociationsDataGrig.Count > 0 Then
            ListViewItem.ForeColor = Color.Blue
        Else
            ListViewItem.ForeColor = Color.Black
        End If
    End Sub

    Private Sub lvwDigitalObjects_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvwDigitalObjects.DoubleClick
        If Me.lvwDigitalObjects.SelectedItems.Count = 0 Then Return
        LoadTvwFiles(Me.lvwDigitalObjects.SelectedItems(0).Tag)
    End Sub

    Private Sub lvwDigitalObjects_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lvwDigitalObjects.MouseUp
        If e.Button = MouseButtons.Right Or e.Button = MouseButtons.Left Then
            Dim lvi As ListViewItem = Me.lvwDigitalObjects.GetItemAt(e.X, e.Y)
            If Not lvi Is Nothing Then
                Me.lvwDigitalObjects.Items(lvi.Index).Selected = True
            End If
        End If
    End Sub

    Private Sub lvwDigitalObjects_ItemCheck(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ItemCheckEventArgs) Handles lvwDigitalObjects.ItemCheck

        If e.CurrentValue = CheckState.Checked Then
            CountDOChecked = CountDOChecked - 1
        ElseIf e.CurrentValue = CheckState.Unchecked Then
            CountDOChecked = CountDOChecked + 1
        End If
        WriteDigitalObjectsChecked()
        WriteAssociationType()

        If CountDOChecked = DigitalObjectsCount Then
            DrawCheckButton(Me.btnCheckAllDigitalObjects, False)

        ElseIf CountDOChecked <= DigitalObjectsCount Then
            DrawCheckButton(Me.btnCheckAllDigitalObjects, True)
        End If
    End Sub

    Private Sub WriteAssociationType()

        If CountComponentsChecked = 0 And CountDOChecked = 0 Then
            Me.lblStatus.Text = ""
            Me.btnAssociate.Enabled = False
        ElseIf CountComponentsChecked = CountDOChecked Then
            Me.lblStatus.Text = String.Format(InfoMessage("AssociationType1"), CStr(CountDOChecked))
            Me.lblStatus.ForeColor = Color.Blue
            Me.btnAssociate.Enabled = True
        ElseIf CountComponentsChecked = 1 And CountDOChecked > 1 Then
            Me.lblStatus.Text = String.Format(InfoMessage("AssociationType2"), CStr(CountDOChecked))
            Me.lblStatus.ForeColor = Color.Blue
            Me.btnAssociate.Enabled = True
        ElseIf CountComponentsChecked > 1 And CountDOChecked = 1 Then
            Me.lblStatus.Text = String.Format(InfoMessage("AssociationType3"), CStr(CountComponentsChecked))
            Me.lblStatus.ForeColor = Color.Blue
            Me.btnAssociate.Enabled = True
        Else
            Me.lblStatus.Text = InfoMessage("AssociationType4")
            Me.lblStatus.ForeColor = Color.Red
            Me.btnAssociate.Enabled = False
        End If
    End Sub

    Private Sub btnCheckAllDigitalObjects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheckAllDigitalObjects.Click
        If Me.btnCheckAllDigitalObjects.Tag = CHECK Then
            myProgressDialog = New ProgressDialog(False, 1)
            myProgressDialog.Run(New ThreadStart(AddressOf UnCheckAllDigitalObjects), InfoMessage("ProgressDialog.UnselectAll.Title"), 0, DigitalObjectsCount)
            CountDOChecked = 0
            Me.btnCheckAllDigitalObjects.ToolTip = InfoMessage("Association.ttCheckAll")
        ElseIf Me.btnCheckAllDigitalObjects.Tag = UNCHECK Then
            myProgressDialog = New ProgressDialog(False, 1)
            myProgressDialog.Run(New ThreadStart(AddressOf CheckAllDigitalObjects), InfoMessage("ProgressDialog.SelectAll.Title"), 0, DigitalObjectsCount)
            Me.btnCheckAllDigitalObjects.ToolTip = InfoMessage("Association.ttUnCheckAll")
        End If
    End Sub

    Private Sub WriteDigitalObjectsCount()
        Me.tpDigitalObjects.Text = String.Format(InfoMessage("Association.DigitalObjectsCount"), DigitalObjectsCount)
    End Sub

    Private Sub WriteDigitalObjectsChecked()
        Me.lblDigitalObjectsChecked.Text = String.Format(InfoMessage("Association.lblItemsChecked"), CStr(CountDOChecked))
    End Sub

#End Region

#Region "Files event handlers"

    Private Sub LoadTvwFiles(ByVal DigitalObjectID As Int64)
        ViewFiles()
        Me.tvwDO.Nodes.Clear()

        Dim DigitalObject As DigitalObject = Database.SelectDigitalObject(DigitalObjectID)
        DigitalObjectsTree = New DigitalObjectsTree(Me.tvwDO, DigitalObject)

        Me.tvwDO.Tag = DigitalObjectID
        Me.tvwDO.Nodes(0).EnsureVisible()
        Me.tvwDO.Nodes(0).Expand()

        FilesCount = ColorAndCountNodes(Me.tvwDO.Nodes(0))
        CountDOChecked = 0
        WriteFilesChecked()
        WriteFilesCount()
        WriteAssociationType()
    End Sub

    Private Function ColorAndCountNodes(ByVal ParentTreeNode As TreeNode) As Integer
        Dim FilesCount As Integer = 0
        For Each tn As TreeNode In ParentTreeNode.Nodes
            If tn.GetNodeCount(False) > 0 Then
                FilesCount += ColorAndCountNodes(tn)
            Else
                FilesCount += 1
                If Database.FileIsAssociated(tn.Tag) Then tn.ForeColor = Color.Blue
            End If
        Next
        Return FilesCount
    End Function

    Private Sub tvwDO_BeforeExpand(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles tvwDO.BeforeExpand
        If (e.Node.Nodes.Item(0).Text = "__DUMMY__") Then
            Cursor.Current = Cursors.WaitCursor
            e.Node.Nodes.RemoveAt(0) 'remove dummy
        End If
        If e.Node.Parent Is Nothing AndAlso Not e.Node.IsExpanded Then
            Dim DOStructure As String = Database.GetDOStructure(e.Node.Tag)
            DigitalObjectsTree.LoadTreeViewFromXML(DOStructure, e.Node)
        End If
    End Sub

    Private Sub tvwDO_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles tvwDO.AfterSelect
        e.Node.SelectedImageIndex = e.Node.ImageIndex
        If Not e.Node.ImageIndex = ImageIndex.FILE_WITH_DISSEMINATION And _
            Not e.Node.ImageIndex = ImageIndex.FILE_WITHOUT_DISSEMINATION Then Return
        Try
            Dim FileID As Int64 = Me.tvwDO.SelectedNode.Tag
            LoadViewer(FileID)
            LoadFileAssociations(Me.tvwDO.Tag, FileID)
            If Me.FileAssociationsDataGrig.Count > 0 Then
                e.Node.ForeColor = Color.Blue
            Else
                e.Node.ForeColor = Color.Black
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub tvwDO_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles tvwDO.MouseUp
        If e.Button = MouseButtons.Right Or e.Button = MouseButtons.Left Then
            Dim TreeNode As TreeNode = Me.tvwDO.GetNodeAt(e.X, e.Y)
            If Not TreeNode Is Nothing Then
                Me.tvwDO.SelectedNode = TreeNode
            End If
        End If
    End Sub

    Private Sub LoadViewer(ByVal FileID As Int64)
        Dim BLOB As Byte()
        Dim DOFile As DOFile = Database.SelectDOFile(FileID)
        If DOFile Is Nothing Then Return
        Dim URL As String = DOFile.DisseminationURL
        Dim Format As String = DOFile.Format
        Try
            If URL.Equals("") Then
                BLOB = ReadBinaryFile(AppDomain.CurrentDomain.BaseDirectory & IMAGE_NOT_AVAILABLE_PATH)
                myImageViewer = New ImageViewer(BLOB, Format)
                Me.ViewerPanel.Controls.Clear()
                myImageViewer.Dock = DockStyle.Fill
                Me.ViewerPanel.Controls.Add(myImageViewer)
                myImageViewer.Display()
                Return

            ElseIf URL.StartsWith(SQLSERVER_STORAGE) Then
                Dim ID As Int64 = URL.Substring(SQLSERVER_STORAGE.Length)
                BLOB = Database.SelectBLOB(ID)

            ElseIf URL.StartsWith(FILE_STORAGE) Then
                Dim Filename As String = URL.Substring(FILE_STORAGE.Length)
                BLOB = ReadBinaryFile(Filename)

            ElseIf File.Exists(URL) Then
                BLOB = ReadBinaryFile(URL)

            ElseIf URL.StartsWith(OBJECTVAULT_STORAGE) Then
                Dim ID As String = URL.Substring(OBJECTVAULT_STORAGE.Length)
                Dim vault As New ObjectVaultClient(OBJECT_VAULT_SERVER_ADDRESS)
                BLOB = vault.Retrieve(ID)
            Else
                Return
            End If
            If Not myImageViewer Is Nothing Then
                myImageViewer.Close()
            End If
            If Not myPDFViewer Is Nothing Then
                myPDFViewer.Close()
            End If
            If Not myWordViewer Is Nothing Then
                myWordViewer.Close()
            End If
            myImageViewer = New ImageViewer(BLOB, Format)
            myPDFViewer = New PDFViewer(BLOB, Format)
            myWordViewer = New WordViewer(BLOB, Format)
            If myImageViewer.CanDisplay() Then
                Me.ViewerPanel.Controls.Clear()
                myImageViewer.Dock = DockStyle.Fill
                Me.ViewerPanel.Controls.Add(myImageViewer)
                myImageViewer.Display()
            ElseIf myPDFViewer.CanDisplay() Then
                Me.ViewerPanel.Controls.Clear()
                myPDFViewer.Dock = DockStyle.Fill
                Me.ViewerPanel.Controls.Add(myPDFViewer)
                myPDFViewer.Display()
            ElseIf myWordViewer.CanDisplay() Then
                Me.ViewerPanel.Controls.Clear()
                myWordViewer.Dock = DockStyle.Fill
                Me.ViewerPanel.Controls.Add(myWordViewer)
                myWordViewer.Display()
            End If

        Catch ex As Exception
            BLOB = ReadBinaryFile(AppDomain.CurrentDomain.BaseDirectory & IMAGE_NOT_AVAILABLE_PATH)
            myImageViewer = New ImageViewer(BLOB, Format)
            Me.ViewerPanel.Controls.Clear()
            myImageViewer.Dock = DockStyle.Fill
            Me.ViewerPanel.Controls.Add(myImageViewer)
            myImageViewer.Display()
        End Try
    End Sub

    Private Sub tvwDO_AfterCheck(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles tvwDO.AfterCheck
        If e.Node.Checked Then
            CountDOChecked = CountDOChecked + 1
        ElseIf Not e.Node.Checked Then
            CountDOChecked = CountDOChecked - 1
        End If
        WriteFilesChecked()
        WriteAssociationType()

        If CountDOChecked = FilesCount Then
            DrawCheckButton(btnCheckAllFiles, False)

        ElseIf CountDOChecked <= Me.tvwDO.GetNodeCount(True) Then
            DrawCheckButton(btnCheckAllFiles, True)

        End If
    End Sub

    Private Sub tvwDO_BeforeCheck(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles tvwDO.BeforeCheck
        If Not e.Node.ImageIndex = ImageIndex.FILE_WITH_DISSEMINATION And _
            Not e.Node.ImageIndex = ImageIndex.FILE_WITHOUT_DISSEMINATION Then
            e.Cancel = True
        End If
    End Sub

    Private Sub btnBackFiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBackFiles.Click
        ViewDigitalObjectsList()
        For i As Integer = 0 To DigitalObjectsCount - 1
            Me.lvwDigitalObjects.Items(i).Checked = False
        Next
        CountDOChecked = 0
        WriteDigitalObjectsChecked()
    End Sub

    Private Sub btnCheckAllFiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheckAllFiles.Click
        If Me.tvwDO.GetNodeCount(False) > 0 Then
            If Me.btnCheckAllFiles.Tag = CHECK Then
                myProgressDialog = New ProgressDialog(False)
                myProgressDialog.Run(New ThreadStart(AddressOf UnCheckAllFiles), InfoMessage("ProgressDialog.UnselectAll.Title"), 0, FilesCount)
                CountFilesChecked = 0
                Me.btnCheckAllFiles.ToolTip = InfoMessage("Association.ttCheckAll")
            ElseIf Me.btnCheckAllFiles.Tag = UNCHECK Then
                myProgressDialog = New ProgressDialog(False)
                myProgressDialog.Run(New ThreadStart(AddressOf CheckAllFiles), InfoMessage("ProgressDialog.SelectAll.Title"), 0, FilesCount)
                CountFilesChecked = FilesCount
                Me.btnCheckAllFiles.ToolTip = InfoMessage("Association.ttUncheckAll")
            End If
        End If
    End Sub

    Private Sub CheckAllDigitalObjects()
        For i As Integer = 0 To DigitalObjectsCount - 1
            myProgressDialog.Message = String.Format("{0}...", Me.lvwDigitalObjects.Items(i))
            Me.lvwDigitalObjects.Items(i).Checked = True
            myProgressDialog.Increment()
        Next
    End Sub

    Private Sub UnCheckAllDigitalObjects()
        For i As Integer = 0 To DigitalObjectsCount - 1
            myProgressDialog.Message = String.Format("{0}...", Me.lvwDigitalObjects.Items(i))
            Me.lvwDigitalObjects.Items(i).Checked = False
            myProgressDialog.Increment()
        Next
    End Sub

    Private Sub CheckAllFiles()
        CheckTreeNodes(Me.tvwDO.Nodes(0), True)
    End Sub

    Private Sub UnCheckAllFiles()
        CheckTreeNodes(Me.tvwDO.Nodes(0), False)
    End Sub

    Private Sub WriteFilesCount()
        Me.tpFiles.Text = String.Format(InfoMessage("Association.FilesCount"), CStr(FilesCount))
    End Sub

    Private Sub WriteFilesChecked()
        Me.lblFilesChecked.Text = String.Format(InfoMessage("Association.lblItemsChecked"), CStr(CountDOChecked))
    End Sub

#End Region

#Region "Some auxiliary functions"

    Private Sub ViewFonds()
        Me.FondsTabControl.TabPages.Remove(Me.tpFondsComponents)
        If Not Me.FondsTabControl.TabPages.Contains(Me.tpFonds) Then
            Me.FondsTabControl.TabPages.Add(Me.tpFonds)
        End If
        Me.miViewFonds.Enabled = False
        Me.miViewComponents.Enabled = True
    End Sub

    Private Sub ViewComponents()
        Me.FondsTabControl.TabPages.Remove(Me.tpFonds)
        If Not Me.FondsTabControl.TabPages.Contains(Me.tpFondsComponents) Then
            Me.FondsTabControl.TabPages.Add(Me.tpFondsComponents)
        End If
        DrawExpandButton(Me.btnExpandAllComponents, True)
        DrawCheckButton(Me.btnCheckAllComponents, True)

        Me.CountComponentsChecked = 0
        WriteComponentsChecked()
        Me.miViewFonds.Enabled = True
        Me.miViewComponents.Enabled = False
    End Sub

    Private Sub ViewDigitalObjectsList()
        Me.DigitalObjectsTabControl.TabPages.Remove(Me.tpFiles)
        If Not Me.DigitalObjectsTabControl.TabPages.Contains(Me.tpDigitalObjects) Then
            Me.DigitalObjectsTabControl.TabPages.Add(Me.tpDigitalObjects)
        End If
        Me.miAutoAssociation.Enabled = True
        Me.miViewDigitalObjects.Enabled = False
        Me.miViewFiles.Enabled = True
    End Sub

    Private Sub ViewFiles()
        Me.DigitalObjectsTabControl.TabPages.Remove(Me.tpDigitalObjects)
        If Not Me.DigitalObjectsTabControl.TabPages.Contains(Me.tpFiles) Then
            Me.DigitalObjectsTabControl.TabPages.Add(Me.tpFiles)
        End If
        Me.miAutoAssociation.Enabled = False
        Me.miViewDigitalObjects.Enabled = True
        Me.miViewFiles.Enabled = False
    End Sub

    Private Sub DrawCheckButton(ByVal Button As ImageButton, ByVal boolCheck As Boolean)
        If boolCheck Then
            Button.ButtonImage = Image.FromFile(Application.StartupPath + "\..\Images\select.png")
            Button.Tag = UNCHECK
            Button.ButtonText = CHECK_ALL
        Else
            Button.ButtonImage = Image.FromFile(Application.StartupPath + "\..\Images\unselect.png")
            Button.Tag = CHECK
            Button.ButtonText = UNCHECK_ALL
        End If
    End Sub

    Private Sub DrawExpandButton(ByVal Button As ImageButton, ByVal boolExpand As Boolean)
        If boolExpand Then
            Button.ButtonImage = Image.FromFile(Application.StartupPath + "\..\Images\p.png")
            Button.Tag = COLLAPSE
            Button.ButtonText = EXPAND_ALL
        Else
            Button.ButtonImage = Image.FromFile(Application.StartupPath + "\..\Images\m.png")
            Button.Tag = EXPAND
            Button.ButtonText = COLLAPSE_ALL
        End If
    End Sub

    Private Sub CheckTreeNodes(ByVal ParentTreeNode As TreeNode, ByVal Check As Boolean)
        Try
            myProgressDialog.Message = String.Format("{0}...", ParentTreeNode.Text)
            If ParentTreeNode.Checked = Not Check Then ParentTreeNode.Checked = Check
            For Each tn As TreeNode In ParentTreeNode.Nodes
                If myProgressDialog.Cancel Then Exit For
                tn.Expand()
                If tn.GetNodeCount(False) > 0 Then
                    CheckTreeNodes(tn, Check)
                Else
                    myProgressDialog.Message = String.Format("{0}...", tn.Text)
                    If tn.Checked = Not Check Then
                        tn.Checked = Check
                    End If
                End If
                myProgressDialog.Increment()
            Next
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub ExpandAll(ByVal ParentTreeNode As TreeNode)
        Try
            myProgressDialog.Message = String.Format("{0}...", ParentTreeNode.Text)
            ParentTreeNode.Expand()
            For Each tn As TreeNode In ParentTreeNode.Nodes
                If myProgressDialog.Cancel Then Exit For
                If tn.GetNodeCount(False) > 0 Then
                    myProgressDialog.Message = String.Format("{0}...", ParentTreeNode.Text)
                    ExpandAll(tn)
                End If
                myProgressDialog.Increment()
            Next
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub

#End Region

#Region "Menu items event handlers"

    'Private Sub miCheckChild_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miCheckChild.Click
    '    Dim check As Boolean = True
    '    For Each tn As TreeNode In Me.tvwSelectedFond.SelectedNode.Nodes
    '        If tn.Checked = True Then
    '            check = False
    '            Exit For
    '        End If
    '    Next
    '    For Each tn As TreeNode In Me.tvwSelectedFond.SelectedNode.Nodes
    '        If check <> tn.Checked Then
    '            tn.Checked = check
    '        End If
    '    Next
    'End Sub

    'Private Sub miViewAssociations_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miComponentAssociations.Click
    '    GetComponentAssociations()
    'End Sub

    'Private Sub miDigitalObjectAssociations_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miDigitalObjectAssociations.Click
    '    GetDigitalObjectAssociations()
    'End Sub

    Private Sub miViewDOStructure_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If Me.lvwDigitalObjects.SelectedItems.Count > 0 Then
            LoadTvwFiles(Me.lvwDigitalObjects.SelectedItems(0).Tag)
        End If
    End Sub

    'Private Sub miFileAssociations_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miFileAssociations.Click
    '    GetFileAssociations()
    'End Sub

    Private Sub miBackDigitalObjectsList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ViewDigitalObjectsList()
    End Sub

#End Region


#Region "Populate fonds components tree"

    Public Function LoadFondsTree(ByVal FondID As Int64, Optional ByVal ComponentID As Int64 = 0) As Integer
        Dim Component As Components = Database.SqlCommandSelectDigitArqToTree(FondID)
        If Component Is Nothing Then Exit Function
        Try
            Dim tnNew As TreeNode = Me.tvwSelectedFond.Nodes.Add(Component.ID)
            With tnNew
                .Tag = Component.ID
                .Text = String.Format("{0} {1}", Component.UnitID, Component.UnitTitle)
                .ImageIndex = Getotherlevelindex(Component.OtherLevel)
                .SelectedImageIndex = .ImageIndex
                If Component.Associated Then .ForeColor = Color.Blue
                If Component.ID = ComponentID Then Me.tvwSelectedFond.SelectedNode = tnNew
            End With
            GetChildren(tnNew, False, ComponentID)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation, "Populate DigitArqTreeView")
        End Try
    End Function

    Public Function GetChildren(ByVal tnParent As TreeNode, Optional ByRef Found As Boolean = False, Optional ByVal ComponentID As Int64 = 0) As TreeNode
        tnParent.Nodes.Clear()
        Dim tnNew As TreeNode
        Dim ComponentCollection As ComponentCollection = Database.Children(tnParent.Tag)

        For Each Component As Components In ComponentCollection
            tnNew = tnParent.Nodes.Add(Component.ID)
            With tnNew
                .Tag = Component.ID
                .Text = String.Format("{0} {1}", Component.UnitID, Component.UnitTitle)
                .ImageIndex = GetOtherLevelIndex(Component.OtherLevel)
                .SelectedImageIndex = .ImageIndex
                If Component.Associated Then .ForeColor = Color.Blue
                If Component.ID = ComponentID Then
                    Me.tvwSelectedFond.SelectedNode = tnNew
                    tnNew.EnsureVisible()
                    Found = True
                End If
            End With
            If Component.HasChildren Then
                If ComponentID <> 0 And Not Found Then
                    GetChildren(tnNew, Found, ComponentID)
                    tnNew.Expand()
                Else
                    tnNew.Nodes.Add("__DUMMY__")
                End If
            End If
        Next
    End Function

#End Region

End Class
