Imports System.Configuration


Public Module Config

    Public Function Constant(ByVal key As String) As String
        Try
            Dim message As String = CStr(CType(ConfigurationSettings.GetConfig("constants"), Hashtable).Item(key))
            Return message
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function


    Public Function ErrorMessage(ByVal key As String) As String
        Try
            Dim message As String = CStr(CType(ConfigurationSettings.GetConfig("errMessages"), Hashtable).Item(key))
            Return message
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function


    Public Function InfoMessage(ByVal key As String) As String
        Try
            Dim message As String = CStr(CType(ConfigurationSettings.GetConfig("infoMessages"), Hashtable).Item(key))
            Return message
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function


    Public Function LogMessage(ByVal key As String) As String
        Try
            Dim message As String = CStr(CType(ConfigurationSettings.GetConfig("logMessages"), Hashtable).Item(key))
            Return message
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function


    Public Function ContextMenuLabel(ByVal key As String) As String
        Try
            Dim message As String = CStr(CType(ConfigurationSettings.GetConfig("contextMenu"), Hashtable).Item(key))
            Return message
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function


    Public Function VisualFieldLabel(ByVal key As String) As String
        Try
            Dim message As String = CStr(CType(ConfigurationSettings.GetConfig("visualFieldsLabelSettings"), Hashtable).Item(key))
            Return message
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function


    Public Function IncorporationSetting(ByVal key As String) As String
        Try
            Dim message As String = CStr(CType(ConfigurationSettings.GetConfig("incorporationSettings"), Hashtable).Item(key))
            Return message
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function


    Public Function GetConfig(ByVal strKey As String) As String
        Try
            Return ConfigurationSettings.AppSettings(strKey)
        Catch ex As Exception
            Return "Cannot Load Configuration File!"
        End Try
    End Function

End Module
