Public Module DataCleansing

    Public Function CleanRawSearchCondition(ByVal SearchCondition As String) As String

        SearchCondition = SearchCondition.Trim()

        While (Not SearchCondition.Equals(SearchCondition.Replace("  ", " ")))
            SearchCondition = SearchCondition.Replace("  ", " ")
        End While

        SearchCondition = SearchCondition.Replace("'", "")
        SearchCondition = SearchCondition.Replace("""", "")
        SearchCondition = SearchCondition.Replace("':", " ")
        SearchCondition = SearchCondition.Replace("',", " ")
        SearchCondition = SearchCondition.Replace("';", " ")
        SearchCondition = SearchCondition.Replace("'.", " ")

        Return SearchCondition
    End Function


    Public Function PrepareContainsSearchCondition(ByVal SearchCondition As String, Optional ByVal JoinOperator As String = " AND ") As String
        SearchCondition = CleanRawSearchCondition(SearchCondition)
        Dim Words As String() = SearchCondition.Split(CChar(" "))
        Dim WordsCollection As New Collection

        For Each w As String In Words
            w = w.Trim
            If w.Length >= 1 Then WordsCollection.Add(w)
        Next

        Return JoinCollection(WordsCollection, JoinOperator)
    End Function

End Module
