
#Region "License Agreement"

'* DigitArq
'* Copyright 2007-2015
'* Arquivo Distrital do Porto. Todos os direitos
'* reservados.
'*  
'* Este software foi desenvolvido pelo Arquivo
'* Distrital do Porto (http://www.adporto.org)
'* sob a administrao da Direco-Geral de
'* Arquivos (http://www.dgarq.gov.pt) e debaixo da
'* coordenao tcnica da Universidade do Minho
'* (http://www.uminho.pt).
'* O desenvolvimento deste produto foi parcialmente
'* financiado pelo Programa Operacional para a
'* Cultura (POC) promovido pelo Governo Portugus.
'* ---------------------------------------------------
'*
'* A redistribuio e utilizao deste produto sob a
'* forma de cdigo-fonte ou programa compilado, com ou
'* sem modificaes,  permitida desde que o seguinte
'* conjunto de condies seja cumprido:
'* 
'*     * Redistribuies do cdigo-fonte deste produto
'*	  devero ser acompanhadas do texto que compe
'*	  esta licena, incluindo o texto inicial de
'*	  atribuio de autoria, esta lista de condies
'*	  e o seguinte termo de responsabilidade.
'*     * Redistribuies deste produto sob a forma de
'*	  programa compilado devero ser acompanhadas do
'*	  texto que compe esta licena, incluindo o
'*	  texto inicial de atribuio de autoria, esta
'*	  lista de condies e o seguinte termo de
'*	  responsabilidade na documentao e outros
'*	  materiais que acompanhem a distribuio.
'*     * Os nomes da Direco-Geral de Arquivos, do
'*	  Arquivo Distrital do Porto, da Universidade do
'*	  Minho e das pessoas individuais que colaboraram
'*	  no desenvolvimento deste produto no devero
'*	  ser utilizados na promoo de produtos
'*	  derivados deste sem que seja obtido
'*	  consentimento prvio, por escrito, por parte
'*	  dos visados.
'*     * A utilizao da designao DigitArq, seus
'*	  logtipos e nomesinstitucionais associados 
'*	  apenas permitida em distribuies que sejam
'*	  cpias exactas da verso oficial deste produto
'*	  provada e/ou distribuida pela Direco-Geral de
'*	  Arquivos.
'*     * O desenvolvimento de obras derivadas deste
'*	  produto  permitido desde que a designao
'*	  DigitArq, seus logtipos e parceiros
'*	  institucionais no sejam utilizados em todo e
'*	  qualquer tipo de distribuio e/ou promoo da
'*	  obra derivada.
'* 
'* ESTE SOFTWARE  DISTRIBUIDO PELA DIRECO-GERAL DE
'* ARQUIVOS SEM QUALQUER PRESUNO DE QUALIDADE OU
'* GARANTIA ASSOCIADA, INCLUINDO, MAS NO LIMITADO A,
'* GARANTIAS ASSOCIADAS A COMRCIO DE PRODUTOS OU
'* AFIRMAO DE ADEQUABILIDADE A DETERMINADO FIM OU
'* OBJECTIVO. EM QUALQUER CIRCUNSTNCIA DEVER A
'* DIRECO-GERAL DE ARQUIVOS SER CONSIDERADA
'* RESPONSVEL POR QUALQUER DANO QUE POSSA SER PROVOCADO
'* DA UTILIZAO DIRECTA, INDIRECTA, ACIDENTAL, ESPECIAL 
'* OU DEMONSTRATIVA DESTE PRODUTO (INCLUINDO, MAS NO
'* LIMITADO A, PERDAS DE DADOS, LUCROS, FALNCIA,
'* INDEVIDA PRESTAO DE SERVIOS, NEGLIGNCIA, ETC).
'* ---------------------------------------------------
'*
'* Para mais informao sobre este produto ou a sua
'* licena,  favor consultar o endereo electrnico
'* http://www.digitarq.pt

#End Region


Public Class CheckButton
    Inherits System.Windows.Forms.Label

    Private myCheckedState As Boolean


    Public Sub New()
        MyBase.New()

        Checked = False
        AutoSize = True

        TabStop = True
        Cursor = Cursors.Hand
    End Sub


    Public Property Checked() As Boolean
        Get
            Return myCheckedState
        End Get
        Set(ByVal Value As Boolean)
            myCheckedState = Value
        End Set
    End Property


    Private Shadows Sub OnClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Click
        Checked = Not Checked
        Refresh()
    End Sub



    Protected Overrides Sub OnPaint(ByVal e As PaintEventArgs)
        If Checked Then
            e.Graphics.DrawLine(Pens.DarkGray, 0, 0, Width - 1, 0)
            e.Graphics.DrawLine(Pens.DarkGray, 0, 0, 0, Height - 1)

            e.Graphics.DrawLine(Pens.WhiteSmoke, 0, Height - 1, Width - 1, Height - 1)
            e.Graphics.DrawLine(Pens.WhiteSmoke, Width - 1, 0, Width - 1, Height - 1)
            e.Graphics.DrawString(Text, Font, Brushes.Green, 1, 1)
        Else
            e.Graphics.DrawLine(Pens.WhiteSmoke, 0, 0, Width - 1, 0)
            e.Graphics.DrawLine(Pens.WhiteSmoke, 0, 0, 0, Height - 1)

            e.Graphics.DrawLine(Pens.DarkGray, 0, Height - 1, Width - 1, Height - 1)
            e.Graphics.DrawLine(Pens.DarkGray, Width - 1, 0, Width - 1, Height - 1)
            e.Graphics.DrawString(Text, Font, Brushes.DarkRed, 0, 0)
        End If

    End Sub





End Class

